(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common'), require('ngx-bootstrap/carousel'), require('@wm/components/base'), require('@swipey')) :
    typeof define === 'function' && define.amd ? define('@wm/components/advanced/carousel', ['exports', '@angular/core', '@angular/common', 'ngx-bootstrap/carousel', '@wm/components/base', '@swipey'], factory) :
    (global = global || self, factory((global.wm = global.wm || {}, global.wm.components = global.wm.components || {}, global.wm.components.advanced = global.wm.components.advanced || {}, global.wm.components.advanced.carousel = {}), global.ng.core, global.ng.common, global['ngx-bootstrap'].carousel, global.wm.components.base, global.swipey));
}(this, (function (exports, core, common, carousel, base, _swipey) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __rest(s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); }
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    function __createBinding(o, m, k, k2) {
        if (k2 === undefined) k2 = k;
        o[k2] = m[k];
    }

    function __exportStar(m, exports) {
        for (var p in m) if (p !== "default" && !exports.hasOwnProperty(p)) exports[p] = m[p];
    }

    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m) return m.call(o);
        if (o && typeof o.length === "number") return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }

    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    }

    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    };

    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }

    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
    }

    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }

    function __asyncValues(o) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
    }

    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
        return cooked;
    };

    function __importStar(mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
        result.default = mod;
        return result;
    }

    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }

    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }

    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    var registerProps = function () {
        base.register('wm-carousel', new Map([
            ['animation', __assign({ value: 'auto' }, base.PROP_STRING)],
            ['animationinterval', __assign({ value: 3 }, base.PROP_NUMBER)],
            ['controls', __assign({ value: 'both' }, base.PROP_STRING)],
            ['dataset', base.PROP_ANY],
            ['name', base.PROP_STRING],
            ['nodatamessage', __assign({ value: 'No Data Found' }, base.PROP_STRING)],
            ['show', base.PROP_BOOLEAN]
        ]));
    };

    var CarouselAnimator = /** @class */ (function (_super) {
        __extends(CarouselAnimator, _super);
        function CarouselAnimator(carousel, interval, ngZone) {
            var _this = _super.call(this) || this;
            _this.carousel = carousel;
            _this.interval = interval;
            _this.ngZone = ngZone;
            _this._activeIndex = 0;
            _this._animationPaused = false;
            _this._pauseCaroselTill = 0;
            _this._oldIndex = 0;
            var self = _this;
            _this._$el = $(_this.carousel.getNativeElement()).find('>.carousel');
            _this.init(_this._$el.find('>.carousel-inner'));
            _this._items = _this._$el.find('>.carousel-inner >.carousel-item');
            _this._indicators = _this._$el.find('>.carousel-indicators');
            _this._indicators.find('li').each(function (i) {
                $(this).on('click', function () {
                    self._activeIndex = i;
                    self.setActiveItem();
                    // WMS-17583: Triggering onChange event
                    self.carousel.onChangeCB(self._activeIndex, self._oldIndex);
                    self._oldIndex = self._activeIndex;
                });
            });
            _this._$el.find('>.left.carousel-control').on('click', function () {
                _this._pauseCaroselTill = Date.now() + _this.interval;
                _this.goToUpper();
            });
            _this._$el.find('>.right.carousel-control').on('click', function () {
                _this._pauseCaroselTill = Date.now() + _this.interval;
                _this.goToLower();
            });
            _this.setActiveItem();
            if (_this.interval) {
                _this.start();
            }
            return _this;
        }
        CarouselAnimator.prototype.bounds = function () {
            this._width = this._items.width();
            this._swiping = true;
            return {
                'lower': -this._width,
                'center': 0,
                'upper': this._width
            };
        };
        CarouselAnimator.prototype.context = function () {
            return {
                'w': this._width
            };
        };
        CarouselAnimator.prototype.animation = function () {
            return [{
                    'target': this.getTarget.bind(this),
                    'css': {
                        'transform': 'translate3d(${{ (($D + $d) / w) * 100 + \'%\'}}, 0, 0)',
                        '-webkit-transform': 'translate3d(${{ (($D + $d) / w) * 100 + \'%\'}}, 0, 0)'
                    }
                }];
        };
        CarouselAnimator.prototype.onUpper = function () {
            this.resetTransition();
            this._activeIndex -= 1;
            this.setActiveItem();
            this._swiping = false;
        };
        CarouselAnimator.prototype.onLower = function () {
            this.resetTransition();
            this._activeIndex += 1;
            this.setActiveItem();
            this._swiping = false;
        };
        CarouselAnimator.prototype.onAnimation = function () {
            var newIndex = (this._items.length + this._activeIndex) % this._items.length;
            this.carousel.onChangeCB(newIndex, this._oldIndex);
            this._oldIndex = newIndex;
        };
        CarouselAnimator.prototype.start = function () {
            var _this = this;
            this.ngZone.runOutsideAngular(function () {
                _this._intervalId = setInterval(function () {
                    if (!_this._swiping && _this._pauseCaroselTill < Date.now()) {
                        _this.goToLower(600);
                    }
                }, _this.interval);
            });
        };
        CarouselAnimator.prototype.pause = function () {
            this._animationPaused = true;
            if (!this._intervalId) {
                this.start();
            }
        };
        CarouselAnimator.prototype.resume = function () {
            this._animationPaused = false;
        };
        CarouselAnimator.prototype.stop = function () {
            if (this._intervalId) {
                clearInterval(this._intervalId);
                this._intervalId = 0;
            }
        };
        CarouselAnimator.prototype.threshold = function () {
            return 5;
        };
        // Returns multiple elements as single jQuery element.
        CarouselAnimator.prototype.getTarget = function () {
            var noOfItems = this._items.length, activeItem = this._items.eq((noOfItems + this._activeIndex) % noOfItems), leftItem = this._items.eq((noOfItems + this._activeIndex - 1) % noOfItems), rightItem = this._items.eq((noOfItems + this._activeIndex + 1) % noOfItems);
            return activeItem.add(rightItem).add(leftItem);
        };
        CarouselAnimator.prototype.resetTransition = function () {
            this.getTarget().css({
                '-webkit-transition': 'none',
                '-webkit-transform': '',
                'transition': 'none',
                'transform': ''
            });
        };
        // Sets active item, leftItem, rightItem by removing / adding respective classes.
        CarouselAnimator.prototype.setActiveItem = function () {
            var items = this._items, left = this._activeIndex - 1, right = this._activeIndex + 1;
            // if there is only one carousel-item then there won't be any right or left-item.
            if (items.length === 1) {
                items.eq(0).removeClass('left-item right-item');
                return;
            }
            this._indicators.find('>.active').removeClass('active');
            this._indicators.find('> li').eq((items.length + this._activeIndex) % items.length).addClass('active');
            items.filter('.active').removeClass('active');
            items.addClass('left-item');
            items.eq((items.length + left) % items.length).addClass('left-item').removeClass('right-item');
            items.eq((items.length + this._activeIndex) % items.length).removeClass('left-item right-item').addClass('active');
            items.eq((items.length + right) % items.length).addClass('right-item').removeClass('left-item');
        };
        return CarouselAnimator;
    }(_swipey.SwipeAnimation));

    var WIDGET_CONFIG = {
        widgetType: 'wm-carousel'
    };
    var navigationClassMap = {
        indicators: 'hide-navs',
        navs: 'hide-indicators',
        none: 'hide-both'
    };
    var CarouselDirective = /** @class */ (function (_super) {
        __extends(CarouselDirective, _super);
        function CarouselDirective(component, inj, ngZone) {
            var _this = _super.call(this, inj, WIDGET_CONFIG) || this;
            _this.component = component;
            _this.ngZone = ngZone;
            base.styler(_this.nativeElement, _this);
            return _this;
        }
        CarouselDirective.prototype.onDataChange = function (newVal) {
            this.fieldDefs = base.createArrayFrom(newVal);
        };
        CarouselDirective.prototype.stopAnimation = function () {
            if (this.animator) {
                this.animator.stop();
            }
        };
        CarouselDirective.prototype.startAnimation = function () {
            if (this.animator) {
                this.animator.interval = this.animationinterval * 1000;
                this.animator.start();
            }
        };
        CarouselDirective.prototype.onSlidesRender = function (slides) {
            var _this = this;
            // if dynamic carousel, initialize the 'currentslide' property as the first object
            if (this.fieldDefs && this.fieldDefs.length) {
                this.currentslide = this.fieldDefs[0];
            }
            setTimeout(function () {
                if (slides.length) {
                    _this.animator = new CarouselAnimator(_this, _this.interval, _this.ngZone);
                }
            }, 50);
        };
        CarouselDirective.prototype.setupHandlers = function () {
            var _this = this;
            this.slides.changes.subscribe(function (slides) {
                _this.stopAnimation();
                _this.onSlidesRender(slides);
            });
            this.slides.setDirty();
        };
        CarouselDirective.prototype.onChangeCB = function (newIndex, oldIndex) {
            // assign current and previous slides on widget. In case of static carousel, fieldDefs will be undefined, hence the check
            this.currentslide = this.fieldDefs && this.fieldDefs[newIndex];
            this.previousslide = this.fieldDefs && this.fieldDefs[oldIndex];
            this.invokeEventCallback('change', { newIndex: newIndex, oldIndex: oldIndex });
        };
        CarouselDirective.prototype.ngAfterContentInit = function () {
            this.setupHandlers();
        };
        CarouselDirective.prototype.ngOnDestroy = function () {
            this.stopAnimation();
            _super.prototype.ngOnDestroy.call(this);
        };
        // Calculating animation interval if animation is enabled
        CarouselDirective.prototype.setanimationinterval = function () {
            this.interval = this.animation === 'auto' ? this.animationinterval * 1000 : 0;
        };
        CarouselDirective.prototype.ngOnInit = function () {
            _super.prototype.ngOnInit.call(this);
            this.setanimationinterval();
            // TODO transition is pending
        };
        // on property change handler
        CarouselDirective.prototype.onPropertyChange = function (key, nv, ov) {
            if (key === 'dataset') {
                this.onDataChange(nv);
            }
            else if (key === 'controls') {
                // For showing controls
                this.navigationClass = navigationClassMap[this.controls];
            }
            else if (key === 'animation' || key === 'animationinterval') {
                if (key === 'animationinterval') {
                    this.setanimationinterval();
                }
                this.animation === 'none' ? this.stopAnimation() : this.startAnimation();
            }
            else {
                _super.prototype.onPropertyChange.call(this, key, nv, ov);
            }
        };
        CarouselDirective.initializeProps = registerProps();
        CarouselDirective.ctorParameters = function () { return [
            { type: carousel.CarouselComponent },
            { type: core.Injector },
            { type: core.NgZone }
        ]; };
        __decorate([
            core.ContentChildren(carousel.SlideComponent),
            __metadata("design:type", core.QueryList)
        ], CarouselDirective.prototype, "slides", void 0);
        CarouselDirective = __decorate([
            core.Directive({
                selector: '[wmCarousel]',
                exportAs: 'wmCarousel'
            }),
            __metadata("design:paramtypes", [carousel.CarouselComponent, core.Injector, core.NgZone])
        ], CarouselDirective);
        return CarouselDirective;
    }(base.StylableComponent));

    var registerProps$1 = function () {
        base.register('wm-carousel-template', new Map([
            ['show', base.PROP_BOOLEAN]
        ]));
    };

    var DEFAULT_CLS = 'app-carousel-item';
    var WIDGET_CONFIG$1 = {
        widgetType: 'wm-carousel-template',
        hostClass: DEFAULT_CLS
    };
    var CarouselTemplateDirective = /** @class */ (function (_super) {
        __extends(CarouselTemplateDirective, _super);
        function CarouselTemplateDirective(inj) {
            var _this = _super.call(this, inj, WIDGET_CONFIG$1) || this;
            base.styler(_this.nativeElement, _this);
            return _this;
        }
        CarouselTemplateDirective.initializeProps = registerProps$1();
        CarouselTemplateDirective.ctorParameters = function () { return [
            { type: core.Injector }
        ]; };
        CarouselTemplateDirective = __decorate([
            core.Directive({
                selector: '[wmCarouselTemplate]'
            }),
            __metadata("design:paramtypes", [core.Injector])
        ], CarouselTemplateDirective);
        return CarouselTemplateDirective;
    }(base.StylableComponent));

    var components = [
        CarouselDirective,
        CarouselTemplateDirective
    ];
    var CarouselModule = /** @class */ (function () {
        function CarouselModule() {
        }
        CarouselModule = __decorate([
            core.NgModule({
                imports: [
                    common.CommonModule,
                    carousel.CarouselModule,
                    base.WmComponentsModule
                ],
                declarations: __spread(components),
                exports: __spread(components),
                entryComponents: []
            })
        ], CarouselModule);
        return CarouselModule;
    }());

    exports.CarouselModule = CarouselModule;
    exports.ɵa = CarouselDirective;
    exports.ɵb = registerProps;
    exports.ɵc = CarouselTemplateDirective;
    exports.ɵd = registerProps$1;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=index.umd.js.map
