import { AfterViewInit, Injector, OnDestroy } from '@angular/core';
import { App } from '@wm/core';
import { StylableComponent } from '@wm/components/base';
export declare const disableContextMenu: ($event: Event) => void;
export declare class AnchorComponent extends StylableComponent implements AfterViewInit, OnDestroy {
    private app;
    static initializeProps: void;
    private hasNavigationToCurrentPageExpr;
    private hasGoToPageExpr;
    encodeurl: any;
    hyperlink: any;
    iconheight: string;
    iconwidth: string;
    iconurl: string;
    iconclass: string;
    caption: any;
    badgevalue: string;
    target: string;
    shortcutkey: string;
    iconposition: string;
    private _eventNotifier;
    constructor(inj: Injector, app: App);
    protected processEventAttr(eventName: string, expr: string, meta?: string): void;
    onActive(callback: (data: any) => void): void;
    protected handleEvent(node: HTMLElement, eventName: string, eventCallback: Function, locals: any, meta?: string): void;
    onPropertyChange(key: string, nv: any, ov?: any): void;
    init(): void;
    ngAfterViewInit(): void;
    ngOnAttach(): void;
    ngOnDestroy(): void;
}
