(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common'), require('ng-circle-progress'), require('@wm/components/base'), require('@wm/core')) :
    typeof define === 'function' && define.amd ? define('@wm/components/basic/progress', ['exports', '@angular/core', '@angular/common', 'ng-circle-progress', '@wm/components/base', '@wm/core'], factory) :
    (global = global || self, factory((global.wm = global.wm || {}, global.wm.components = global.wm.components || {}, global.wm.components.basic = global.wm.components.basic || {}, global.wm.components.basic.progress = {}), global.ng.core, global.ng.common, global.ngCircleProgress, global.wm.components.base, global.wm.core));
}(this, (function (exports, core, common, ngCircleProgress, base, core$1) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __rest(s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); }
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    function __createBinding(o, m, k, k2) {
        if (k2 === undefined) k2 = k;
        o[k2] = m[k];
    }

    function __exportStar(m, exports) {
        for (var p in m) if (p !== "default" && !exports.hasOwnProperty(p)) exports[p] = m[p];
    }

    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m) return m.call(o);
        if (o && typeof o.length === "number") return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }

    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    }

    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    };

    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }

    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
    }

    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }

    function __asyncValues(o) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
    }

    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
        return cooked;
    };

    function __importStar(mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
        result.default = mod;
        return result;
    }

    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }

    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }

    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    var registerProps = function () {
        base.register('wm-progress-bar', new Map([
            ['captionplacement', __assign({ value: 'hidden' }, base.PROP_STRING)],
            ['class', base.PROP_STRING],
            ['dataset', base.PROP_ANY],
            ['datavalue', base.PROP_STRING],
            ['displayformat', base.PROP_STRING],
            ['hint', base.PROP_STRING],
            ['maxvalue', __assign({ value: 100 }, base.PROP_NUMBER)],
            ['minvalue', __assign({ value: 0 }, base.PROP_NUMBER)],
            ['name', base.PROP_STRING],
            ['show', __assign({ value: true }, base.PROP_BOOLEAN)],
            ['tabindex', __assign({ value: 0 }, base.PROP_NUMBER)],
            ['type', __assign({ value: 'default' }, base.PROP_STRING)]
        ]));
    };

    // This function returns the maximum number of decimal digits allowed.
    var getDecimalCount = function (val) {
        val = val || '9';
        val = val.replace(/\%$/, '');
        var n = val.lastIndexOf('.');
        return (n === -1) ? 0 : (val.length - n - 1);
    };
    // returns true if the given value contains '%'
    var isPercentageValue = function (val) {
        if (core$1.isString(val)) {
            val = val.trim();
            return val.charAt(val.length - 1) === '%';
        }
        return false;
    };
    var calculatePercent = function (value, min, max) {
        if (min === void 0) { min = 0; }
        if (max === void 0) { max = 0; }
        var percent = ((value - min) / (max - min)) * 100;
        if (_.isNaN(percent)) {
            console.warn('Circle Progress Bar: One of the properties Min, Max or datavalue is not a valid number');
            return 0;
        }
        return Math.abs(percent);
    };

    var DEFAULT_CLS = 'progress app-progress';
    var WIDGET_CONFIG = { widgetType: 'wm-progress-bar', hostClass: DEFAULT_CLS };
    // map of progress-bar type and classes
    var TYPE_CLASS_MAP = {
        'default': '',
        'default-striped': 'progress-bar-striped',
        'success': 'progress-bar-success',
        'success-striped': 'progress-bar-success progress-bar-striped',
        'info': 'progress-bar-info',
        'info-striped': 'progress-bar-info progress-bar-striped',
        'warning': 'progress-bar-warning',
        'warning-striped': 'progress-bar-warning progress-bar-striped',
        'danger': 'progress-bar-danger',
        'danger-striped': 'progress-bar-danger progress-bar-striped'
    };
    var ProgressBarComponent = /** @class */ (function (_super) {
        __extends(ProgressBarComponent, _super);
        function ProgressBarComponent(inj, dataset, boundDataset) {
            var _this = _super.call(this, inj, WIDGET_CONFIG) || this;
            // progress-bar data, ngFor in the template iterates on this
            _this.data = [{
                    cls: TYPE_CLASS_MAP.default,
                    progressBarWidth: '0%',
                    displayValue: '0'
                }];
            // flag which determines whether dataset is provided or not
            _this.hasDataset = !!(dataset || boundDataset);
            base.styler(_this.nativeElement, _this);
            _this._prepareData = _.debounce(function () { return _this.prepareData(); }, 50);
            return _this;
        }
        ProgressBarComponent_1 = ProgressBarComponent;
        // update the proper classes when there is a change in type
        ProgressBarComponent.prototype.onTypeChange = function () {
            if (!this.hasDataset) {
                if (this.data[0]) {
                    this.data[0].cls = TYPE_CLASS_MAP[this.type];
                }
            }
        };
        // returns the formatted display value based on the provided displayformat
        ProgressBarComponent.prototype.getFormattedDisplayVal = function (val) {
            var format = this.displayformat || '9';
            val = parseFloat('' + val);
            val = (val.toFixed(getDecimalCount(format)));
            if (format && format.includes('%')) {
                val = val + "%";
            }
            return val;
        };
        ProgressBarComponent.prototype.prepareData = function () {
            var _this = this;
            // when the dataset is provided, iterate over the dataset to set the proper values in the data
            if (this.dataset && _.isArray(this.dataset) && this.type && this.datavalue) {
                this.data = this.dataset.map(function (datum) {
                    var val = core$1.findValueOf(datum, _this.datavalue).toString();
                    var percentVal = val;
                    if (val && !val.includes('%')) {
                        percentVal = val + "%";
                    }
                    return {
                        cls: TYPE_CLASS_MAP[core$1.findValueOf(datum, _this.type)],
                        progressBarWidth: percentVal,
                        displayValue: _this.getFormattedDisplayVal(val)
                    };
                });
            }
            else {
                // if the dataset is not provided, update the values in the default data
                var width = 0;
                var displayVal = 0;
                if (this.datavalue) {
                    if (isPercentageValue(this.datavalue)) {
                        var val = (this.datavalue || '0%');
                        width = displayVal = val;
                    }
                    else {
                        if (core$1.isDefined(this.datavalue)) {
                            var denominator = (+this.maxvalue - +this.minvalue) || 1;
                            var val = ((+this.datavalue - +this.minvalue) * 100) / denominator + '%';
                            width = displayVal = val;
                        }
                    }
                }
                this.data[0].displayValue = this.getFormattedDisplayVal(displayVal);
                this.data[0].progressBarWidth = width;
                this.data[0].cls = TYPE_CLASS_MAP[this.type];
            }
        };
        ProgressBarComponent.prototype.onPropertyChange = function (key, nv, ov) {
            if (key === 'type') {
                this.onTypeChange();
            }
            else if (key === 'minvalue' || key === 'maxvalue' || key === 'datavalue' || key === 'dataset' || key === 'displayformat') {
                this._prepareData();
            }
            else {
                _super.prototype.onPropertyChange.call(this, key, nv, ov);
            }
        };
        var ProgressBarComponent_1;
        ProgressBarComponent.initializeProps = registerProps();
        ProgressBarComponent.ctorParameters = function () { return [
            { type: core.Injector },
            { type: String, decorators: [{ type: core.Attribute, args: ['dataset',] }] },
            { type: String, decorators: [{ type: core.Attribute, args: ['dataset.bind',] }] }
        ]; };
        ProgressBarComponent = ProgressBarComponent_1 = __decorate([
            core.Component({
                selector: '[wmProgressBar]',
                template: "<div class=\"multi-bar progress-bar {{bar.cls}}\" *ngFor=\"let bar of data\" [style.width]=\"bar.progressBarWidth\" role=\"progressbar\"\n     [attr.aria-valuenow]=\"datavalue\" [attr.aria-valuemin]=\"minvalue\" [attr.aria-valuemax]=\"maxvalue\">\n    <span class=\"app-progress-label\" [attr.data-caption-placement]=\"captionplacement\">{{bar.displayValue}}</span>\n</div>",
                providers: [
                    base.provideAsWidgetRef(ProgressBarComponent_1)
                ]
            }),
            __param(1, core.Attribute('dataset')), __param(2, core.Attribute('dataset.bind')),
            __metadata("design:paramtypes", [core.Injector, String, String])
        ], ProgressBarComponent);
        return ProgressBarComponent;
    }(base.StylableComponent));

    var registerProps$1 = function () {
        base.register('wm-progress-circle', new Map([
            ['captionplacement', __assign({ value: 'inside' }, base.PROP_STRING)],
            ['class', base.PROP_STRING],
            ['dataset', base.PROP_ANY],
            ['datavalue', __assign({ value: '30' }, base.PROP_STRING)],
            ['displayformat', __assign({ value: '9%' }, base.PROP_STRING)],
            ['hint', base.PROP_STRING],
            ['maxvalue', __assign({ value: 100 }, base.PROP_NUMBER)],
            ['minvalue', __assign({ value: 0 }, base.PROP_NUMBER)],
            ['name', base.PROP_STRING],
            ['show', __assign({ value: true }, base.PROP_BOOLEAN)],
            ['subtitle', base.PROP_STRING],
            ['tabindex', __assign({ value: 0 }, base.PROP_NUMBER)],
            ['title', base.PROP_STRING],
            ['type', __assign({ value: 'default' }, base.PROP_STRING)]
        ]));
    };

    var DEFAULT_CLS$1 = 'progress app-progress circle';
    var WIDGET_CONFIG$1 = { widgetType: 'wm-progress-circle', hostClass: DEFAULT_CLS$1 };
    var DEFAULT_OPTIONS = {
        responsive: true,
        innerStrokeWidth: 10,
        outerStrokeWidth: 10,
        unitsFontSize: '15',
        space: -10,
        toFixed: 0,
        maxPercent: 100,
        showSubtitle: false,
        clockwise: true,
        startFromZero: false,
        renderOnClick: false,
        innerStrokeColor: '',
        outerStrokeColor: ''
    };
    // map of progress-bar type and classes
    var TYPE_CLASS_MAP$1 = {
        'default': '',
        'success': 'progress-circle-success',
        'info': 'progress-circle-info',
        'warning': 'progress-circle-warning',
        'danger': 'progress-circle-danger',
    };
    var ProgressCircleComponent = /** @class */ (function (_super) {
        __extends(ProgressCircleComponent, _super);
        function ProgressCircleComponent(inj) {
            var _this = _super.call(this, inj, WIDGET_CONFIG$1) || this;
            base.styler(_this.nativeElement, _this);
            _this.options = _.clone(DEFAULT_OPTIONS);
            _this.redraw = _.debounce(_this._redraw, 100);
            return _this;
        }
        ProgressCircleComponent_1 = ProgressCircleComponent;
        ProgressCircleComponent.prototype._redraw = function () {
            this.circleRef.render();
        };
        ProgressCircleComponent.prototype.ngAfterViewInit = function () {
            _super.prototype.ngAfterViewInit.call(this);
            this.invokeEventCallback('beforerender', { '$event': {} });
            this.options = Object.assign(this.circleRef.options, this.options);
        };
        ProgressCircleComponent.prototype.overrideDefaults = function (options) {
            _.extend(this.options, options);
        };
        ProgressCircleComponent.prototype.updateDisplayValueFormat = function () {
            // show title and subtitle only when captionplacement is 'inside'
            this.options.showTitle = this.options.showSubtitle = (this.captionplacement === 'inside');
            // show units when title value is empty and captionplacement is 'inside'
            this.options.showUnits = !this.title && this.options.showTitle && isPercentageValue(this.displayformat);
            this.options.toFixed = getDecimalCount(this.displayformat);
            if (this.options.showTitle) {
                this.options.title = this.title || 'auto';
                this.options.showSubtitle = !!this.subtitle;
                this.options.subtitle = this.subtitle || '';
            }
            this.redraw();
        };
        ProgressCircleComponent.prototype.onPropertyChange = function (key, nv, ov) {
            switch (key) {
                case 'type':
                    this.$element.removeClass(TYPE_CLASS_MAP$1[ov]);
                    this.$element.addClass(TYPE_CLASS_MAP$1[nv]);
                    break;
                case 'minvalue':
                case 'maxvalue':
                case 'datavalue':
                    if (isPercentageValue(this.datavalue)) {
                        this.percentagevalue = parseFloat(this.datavalue);
                    }
                    else {
                        this.percentagevalue = calculatePercent(parseFloat(this.datavalue), this.minvalue, this.maxvalue);
                    }
                    break;
                case 'displayformat':
                case 'captionplacement':
                case 'title':
                case 'subtitle':
                    this.updateDisplayValueFormat();
                    break;
            }
            _super.prototype.onPropertyChange.call(this, key, nv, ov);
        };
        var ProgressCircleComponent_1;
        ProgressCircleComponent.initializeProps = registerProps$1();
        ProgressCircleComponent.ctorParameters = function () { return [
            { type: core.Injector }
        ]; };
        __decorate([
            core.ViewChild(ngCircleProgress.CircleProgressComponent, { static: true }),
            __metadata("design:type", ngCircleProgress.CircleProgressComponent)
        ], ProgressCircleComponent.prototype, "circleRef", void 0);
        ProgressCircleComponent = ProgressCircleComponent_1 = __decorate([
            core.Component({
                selector: '[wmProgressCircle]',
                template: "<circle-progress [percent]=\"percentagevalue\" [options]=\"options\"></circle-progress>\n",
                providers: [
                    base.provideAsWidgetRef(ProgressCircleComponent_1)
                ]
            }),
            __metadata("design:paramtypes", [core.Injector])
        ], ProgressCircleComponent);
        return ProgressCircleComponent;
    }(base.StylableComponent));

    var components = [
        ProgressBarComponent,
        ProgressCircleComponent
    ];
    var ProgressModule = /** @class */ (function () {
        function ProgressModule() {
        }
        ProgressModule = __decorate([
            core.NgModule({
                imports: [
                    common.CommonModule,
                    ngCircleProgress.NgCircleProgressModule,
                    base.WmComponentsModule
                ],
                declarations: __spread(components),
                exports: __spread(components),
                entryComponents: []
            })
        ], ProgressModule);
        return ProgressModule;
    }());

    exports.ProgressModule = ProgressModule;
    exports.ɵa = ProgressBarComponent;
    exports.ɵb = registerProps;
    exports.ɵc = ProgressCircleComponent;
    exports.ɵd = registerProps$1;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=index.umd.js.map
