(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common'), require('@wm/components/base'), require('@angular/forms'), require('@angular/platform-browser'), require('@wm/core'), require('@wm/components/input')) :
    typeof define === 'function' && define.amd ? define('@wm/components/basic/rich-text-editor', ['exports', '@angular/core', '@angular/common', '@wm/components/base', '@angular/forms', '@angular/platform-browser', '@wm/core', '@wm/components/input'], factory) :
    (global = global || self, factory((global.wm = global.wm || {}, global.wm.components = global.wm.components || {}, global.wm.components.basic = global.wm.components.basic || {}, global.wm.components.basic.richtexteditor = {}), global.ng.core, global.ng.common, global.wm.components.base, global.ng.forms, global.ng.platformBrowser, global.wm.core, global.wm.components.input));
}(this, (function (exports, core, common, base, forms, platformBrowser, core$1, input) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __rest(s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); }
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    function __createBinding(o, m, k, k2) {
        if (k2 === undefined) k2 = k;
        o[k2] = m[k];
    }

    function __exportStar(m, exports) {
        for (var p in m) if (p !== "default" && !exports.hasOwnProperty(p)) exports[p] = m[p];
    }

    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m) return m.call(o);
        if (o && typeof o.length === "number") return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }

    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    }

    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    };

    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }

    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
    }

    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }

    function __asyncValues(o) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
    }

    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
        return cooked;
    };

    function __importStar(mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
        result.default = mod;
        return result;
    }

    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }

    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }

    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    var richTextProps = new Map([
        ['class', base.PROP_STRING],
        ['datavaluesource', base.PROP_ANY],
        ['datavalue', base.PROP_STRING],
        ['height', base.PROP_STRING],
        ['hint', base.PROP_STRING],
        ['name', base.PROP_STRING],
        ['placeholder', base.PROP_STRING],
        ['readonly', base.PROP_BOOLEAN],
        ['show', __assign({ value: true }, base.PROP_BOOLEAN)],
        ['showpreview', __assign({ value: false }, base.PROP_BOOLEAN)],
        ['tabindex', __assign({ value: 0 }, base.PROP_NUMBER)]
    ]);
    var registerProps = function () {
        base.register('wm-richtexteditor', richTextProps);
        base.registerFormWidget(core$1.FormWidgetType.RICHTEXT, new Map(richTextProps));
    };

    var WIDGET_INFO = { widgetType: 'wm-richtexteditor', hostClass: 'app-richtexteditor clearfix' };
    var getChangeEvt = function () {
        var changeEvt;
        // for IE the event constructor doesn't work so use the createEvent proto
        if (typeof (Event) === 'function') {
            changeEvt = new Event('change');
        }
        else {
            changeEvt = document.createEvent('Event');
            changeEvt.initEvent('change', true, true);
        }
        return changeEvt;
    };
    var ɵ0 = getChangeEvt;
    var overrideSummerNote = function () {
        if (!$.summernote.__overidden) {
            // override summernote methods
            var origFn_1 = $.summernote.ui.button.bind($.summernote);
            $.summernote.ui.button = function () {
                var args = [];
                for (var _i = 0; _i < arguments.length; _i++) {
                    args[_i] = arguments[_i];
                }
                var retVal = origFn_1.apply(void 0, __spread(args));
                var origCallback = retVal.callback;
                retVal.callback = function ($node, options) {
                    // add bs3 btn class to the buttons
                    $node.addClass('btn');
                    return origCallback($node, options);
                };
                return retVal;
            };
            $.summernote.__overidden = true;
        }
    };
    var ɵ1 = overrideSummerNote;
    var RichTextEditorComponent = /** @class */ (function (_super) {
        __extends(RichTextEditorComponent, _super);
        function RichTextEditorComponent(inj, domSanitizer, ngZone) {
            var _this = _super.call(this, inj, WIDGET_INFO) || this;
            _this.domSanitizer = domSanitizer;
            _this.ngZone = ngZone;
            _this._operationStack = [];
            _this.isEditorLoaded = false;
            _this.EDITOR_DEFAULT_OPTIONS = {
                toolbar: [
                    // [groupName, [list of button]]
                    ['misc', ['undo', 'redo']],
                    ['style', ['style']],
                    ['fontname', ['fontname']],
                    ['fontsize', ['fontsize']],
                    ['height', ['height']],
                    ['style', ['bold', 'italic', 'underline', 'clear']],
                    ['font', ['strikethrough', 'superscript', 'subscript']],
                    ['color', ['color']],
                    ['insert', ['table', 'picture', 'link', 'video', 'hr']],
                    ['para', ['ul', 'ol', 'paragraph']],
                    ['misc', ['codeview', 'fullscreen', 'help']]
                ],
                callbacks: {
                    onInit: function () {
                        _this.isEditorLoaded = true;
                        if (_this._operationStack.length) {
                            _this._operationStack.forEach(function (operationParam) {
                                var key = Array.from(operationParam.keys())[0], val = operationParam.get(key);
                                _this.performEditorOperation(key, val);
                            });
                            _this._operationStack = [];
                        }
                    },
                    onChange: function (contents, editable) {
                        _this.proxyModel = _this.domSanitizer.sanitize(core.SecurityContext.HTML, contents.toString());
                        _this.invokeOnChange(contents, getChangeEvt(), true);
                        _this.invokeOnTouched();
                    }
                },
                fontNames: ['Arial', 'Arial Black', 'Comic Sans MS', 'Courier New', 'Merriweather'],
                placeholder: 'write here...',
                minHeight: 100,
                disableResizeEditor: true
            };
            base.styler(_this.nativeElement, _this, base.APPLY_STYLES_TYPE.CONTAINER, ['height']);
            overrideSummerNote();
            return _this;
        }
        RichTextEditorComponent_1 = RichTextEditorComponent;
        Object.defineProperty(RichTextEditorComponent.prototype, "htmlcontent", {
            get: function () {
                return this.performEditorOperation('code');
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(RichTextEditorComponent.prototype, "datavalue", {
            get: function () {
                return this.htmlcontent;
            },
            set: function (nv) {
                if (nv !== undefined && nv !== null) {
                    this.$hiddenInputEle.val(nv);
                    this.performEditorOperation('reset');
                    this.performEditorOperation('code', nv);
                }
            },
            enumerable: true,
            configurable: true
        });
        RichTextEditorComponent.prototype.ngOnInit = function () {
            this.$richTextEditor = $(this.nativeElement.querySelector('[richTextEditor]'));
            this.$hiddenInputEle = $(this.nativeElement.querySelector('input.model-holder'));
            _super.prototype.ngOnInit.call(this);
            this.initEditor();
        };
        RichTextEditorComponent.prototype.initEditor = function () {
            var _this = this;
            this.ngZone.runOutsideAngular(function () {
                _this.invokeEventCallback('beforerender', { '$event': {} });
                _this.$richTextEditor.summernote(_this.EDITOR_DEFAULT_OPTIONS);
            });
        };
        RichTextEditorComponent.prototype.overrideDefaults = function (options) {
            _.extend(this.EDITOR_DEFAULT_OPTIONS, options);
        };
        RichTextEditorComponent.prototype.onPropertyChange = function (key, nv, ov) {
            if (key === 'placeholder') {
                this.performEditorOperation('placeholder', nv);
            }
            else if (key === 'disabled' || key === 'readonly') {
                this.performEditorOperation(nv ? 'disable' : 'enable');
            }
            else {
                _super.prototype.onPropertyChange.call(this, key, nv, ov);
            }
        };
        RichTextEditorComponent.prototype.onStyleChange = function (key, nv, ov) {
            if (key === 'height') {
                this.performEditorOperation('height', nv);
            }
        };
        RichTextEditorComponent.prototype.performEditorOperation = function (key, value) {
            if (this.isEditorLoaded) {
                if (key === 'height') {
                    core$1.setCSS(this.nativeElement.querySelector('div.note-editable'), key, value, true);
                }
                else if (key === 'placeholder') {
                    core$1.setAttr(this.nativeElement, key, value);
                    core$1.setHtml(this.nativeElement.querySelector('div.note-placeholder'), value, true);
                }
                else {
                    // if editor content is empty then summernote('code') is returning empty p tags like <p></br></p>. So checking for empty and returning undefined.
                    if (arguments.length === 1 && key === 'code' && this.$richTextEditor.summernote('isEmpty')) {
                        var content = this.$richTextEditor.summernote('code');
                        return content === '' ? content : undefined;
                    }
                    return this.$richTextEditor.summernote(key, value);
                }
            }
            else {
                var op = new Map();
                op.set(key, value);
                this._operationStack.push(op);
                return;
            }
        };
        RichTextEditorComponent.prototype.getCurrentPosition = function () {
            return this.performEditorOperation('createRange');
        };
        RichTextEditorComponent.prototype.undo = function () {
            this.performEditorOperation('undo');
        };
        RichTextEditorComponent.prototype.focus = function () {
            this.performEditorOperation('focus');
        };
        RichTextEditorComponent.prototype.ngOnDestroy = function () {
            this.performEditorOperation('destroy');
            _super.prototype.ngOnDestroy.call(this);
        };
        var RichTextEditorComponent_1;
        RichTextEditorComponent.initializeProps = registerProps();
        RichTextEditorComponent.ctorParameters = function () { return [
            { type: core.Injector },
            { type: platformBrowser.DomSanitizer },
            { type: core.NgZone }
        ]; };
        RichTextEditorComponent = RichTextEditorComponent_1 = __decorate([
            core.Component({
                selector: 'div[wmRichTextEditor]',
                template: "<div richTextEditor></div>\n<div [innerHTML]=\"proxyModel\" class=\"ta-preview\" *ngIf=\"showpreview\"></div>\n<input class=\"model-holder\" [disabled]=\"disabled\" hidden>\n",
                providers: [
                    base.provideAs(RichTextEditorComponent_1, forms.NG_VALUE_ACCESSOR, true),
                    base.provideAsWidgetRef(RichTextEditorComponent_1)
                ]
            }),
            __metadata("design:paramtypes", [core.Injector, platformBrowser.DomSanitizer, core.NgZone])
        ], RichTextEditorComponent);
        return RichTextEditorComponent;
    }(input.BaseFormCustomComponent));

    var components = [
        RichTextEditorComponent
    ];
    var RichTextEditorModule = /** @class */ (function () {
        function RichTextEditorModule() {
        }
        RichTextEditorModule = __decorate([
            core.NgModule({
                imports: [
                    common.CommonModule,
                    base.WmComponentsModule
                ],
                declarations: __spread(components),
                exports: __spread(components),
                entryComponents: []
            })
        ], RichTextEditorModule);
        return RichTextEditorModule;
    }());

    exports.RichTextEditorModule = RichTextEditorModule;
    exports.ɵa = RichTextEditorComponent;
    exports.ɵb = registerProps;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=index.umd.js.map
