import { AfterViewInit, ElementRef, Injector, OnInit, QueryList } from '@angular/core';
import { TypeaheadContainerComponent, TypeaheadDirective, TypeaheadMatch } from 'ngx-bootstrap/typeahead';
import { DataSetItem } from '@wm/components/base';
import { DatasetAwareFormComponent } from '@wm/components/input';
export declare class SearchComponent extends DatasetAwareFormComponent implements OnInit, AfterViewInit {
    binddatavalue: any;
    binddataset: any;
    static initializeProps: void;
    casesensitive: boolean;
    searchkey: string;
    queryModel: Array<DataSetItem> | string;
    query: string;
    limit: any;
    showsearchicon: boolean;
    minchars: number;
    type: string;
    navsearchbar: any;
    debouncetime: number;
    private typeaheadDataSource;
    private pagesize;
    private page;
    _loadingItems: boolean;
    private dataProvider;
    private result;
    private formattedDataset;
    private isformfield;
    private $typeaheadEvent;
    tabindex: number;
    startIndex: number;
    binddisplaylabel: string;
    typeaheadContainer: TypeaheadContainerComponent;
    containerTarget: string;
    typeahead: TypeaheadDirective;
    ulElement: ElementRef;
    liElements: QueryList<ElementRef>;
    private allowonlyselect;
    private class;
    private lastSelectedIndex;
    private dataoptions;
    dropdownEl: any;
    private _lastQuery;
    private _lastResult;
    private _isOpen;
    private showClosebtn;
    private _unsubscribeDv;
    private _datasource;
    private isScrolled;
    private parentEl;
    private position;
    private elIndex;
    private listenQuery;
    private _domUpdated;
    private searchon;
    matchmode: string;
    get datasource(): any;
    set datasource(nv: any);
    constructor(inj: Injector, binddatavalue: any, binddataset: any);
    private clearSearch;
    clearText(): void;
    private closeSearch;
    private renderMobileAutoComplete;
    private getDataSourceAsObservable;
    protected handleEvent(node: HTMLElement, eventName: string, eventCallback: Function, locals: any): void;
    private highlight;
    private insertAtIndex;
    isMobileAutoComplete(): boolean;
    private loadMoreData;
    private onFocusOut;
    private onInputChange;
    private handleEnterEvent;
    private onSearchSelect;
    private invokeOnBeforeServiceCall;
    private onDropdownOpen;
    private selectNext;
    private setLastActiveMatchAsSelected;
    private triggerSearch;
    private isUpdateOnKeyPress;
    private debounceDefaultQuery;
    private updateByDatavalue;
    private updateByDataSource;
    private updateDatavalueFromQueryModel;
    private updateByDataset;
    private handleFocus;
    getDataSource(query: Array<string> | string, searchOnDataField?: boolean, nextItemIndex?: number): Promise<DataSetItem[]>;
    private getContext;
    getTransformedData(data: any, itemIndex?: number, iscustom?: boolean): DataSetItem[];
    onScroll($scrollEl: Element, evt: Event): void;
    ngOnInit(): void;
    ngAfterViewInit(): void;
    private eventData;
    typeaheadOnSelect(match: TypeaheadMatch, $event: Event): void;
    onPropertyChange(key: string, nv: any, ov: any): void;
}
