(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common'), require('@wm/components/base'), require('@wm/core')) :
    typeof define === 'function' && define.amd ? define('@wm/components/basic/tree', ['exports', '@angular/core', '@angular/common', '@wm/components/base', '@wm/core'], factory) :
    (global = global || self, factory((global.wm = global.wm || {}, global.wm.components = global.wm.components || {}, global.wm.components.basic = global.wm.components.basic || {}, global.wm.components.basic.tree = {}), global.ng.core, global.ng.common, global.wm.components.base, global.wm.core));
}(this, (function (exports, core, common, base, core$1) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __rest(s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); }
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    function __createBinding(o, m, k, k2) {
        if (k2 === undefined) k2 = k;
        o[k2] = m[k];
    }

    function __exportStar(m, exports) {
        for (var p in m) if (p !== "default" && !exports.hasOwnProperty(p)) exports[p] = m[p];
    }

    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m) return m.call(o);
        if (o && typeof o.length === "number") return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }

    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    }

    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    };

    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }

    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
    }

    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }

    function __asyncValues(o) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
    }

    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
        return cooked;
    };

    function __importStar(mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
        result.default = mod;
        return result;
    }

    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }

    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }

    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    var registerProps = function () {
        base.register('wm-tree', new Map([
            ['class', base.PROP_STRING],
            ['dataset', __assign({ value: 'node1, node2, node3' }, base.PROP_ANY)],
            ['datavalue', base.PROP_STRING],
            ['levels', __assign({ value: 0 }, base.PROP_NUMBER)],
            ['name', base.PROP_STRING],
            ['nodeaction', base.PROP_STRING],
            ['nodechildren', base.PROP_STRING],
            ['nodeclick', __assign({ value: 'none' }, base.PROP_STRING)],
            ['nodeicon', base.PROP_STRING],
            ['nodeid', base.PROP_STRING],
            ['nodelabel', base.PROP_STRING],
            ['orderby', base.PROP_STRING],
            ['show', __assign({ value: true }, base.PROP_BOOLEAN)],
            ['tabindex', __assign({ value: 0 }, base.PROP_NUMBER)],
            ['treeicons', base.PROP_STRING]
        ]));
    };

    var defaultTreeIconClass = 'plus-minus';
    var ICON_CLASSES = {
        'folder': {
            'expanded': 'wi-folder-open',
            'collapsed': 'wi-folder'
        },
        'circle-plus-minus': {
            'expanded': 'wi-remove-circle-outline',
            'collapsed': 'wi-add-circle-outline'
        },
        'chevron': {
            'expanded': 'wi-keyboard-arrow-down',
            'collapsed': 'wi-keyboard-arrow-right'
        },
        'menu': {
            'expanded': 'wi-arrow-down',
            'collapsed': 'wi-arrow-right'
        },
        'triangle': {
            'expanded': 'wi-arrow-drop-down-circle',
            'collapsed': 'wi-play-circle-filled'
        },
        'expand-collapse': {
            'expanded': 'wi-expand-less',
            'collapsed': 'wi-expand-more'
        },
        'plus-minus': {
            'expanded': 'wi-minus',
            'collapsed': 'wi-plus'
        }
    };
    var WIDGET_INFO = { widgetType: 'wm-tree', hostClass: 'app-tree' };
    var TreeDirective = /** @class */ (function (_super) {
        __extends(TreeDirective, _super);
        function TreeDirective(inj, binddatavalue, bindnodelabel, bindnodeicon, bindnodechildren, bindnodeid) {
            var _this = _super.call(this, inj, WIDGET_INFO) || this;
            _this.binddatavalue = binddatavalue;
            _this.bindnodelabel = bindnodelabel;
            _this.bindnodeicon = bindnodeicon;
            _this.bindnodechildren = bindnodechildren;
            _this.bindnodeid = bindnodeid;
            base.styler(_this.nativeElement, _this, base.APPLY_STYLES_TYPE.CONTAINER);
            _this.bindEvents();
            return _this;
        }
        TreeDirective_1 = TreeDirective;
        TreeDirective.prototype.onPropertyChange = function (key, nv, ov) {
            switch (key) {
                case 'dataset':
                    this.nodes = this.getNodes(nv);
                    this._selectNode = undefined;
                    this.renderTree();
                    break;
                case 'nodeicon':
                case 'nodelabel':
                case 'nodechildren':
                case 'orderby':
                    this.renderTree();
                    break;
                case 'treeicons':
                    this.changeTreeIcons(nv, ov);
                    break;
                case 'datavalue':
                    this.selectById(nv);
                    break;
                default:
                    _super.prototype.onPropertyChange.call(this, key, nv, ov);
            }
        };
        TreeDirective.prototype.constructNodes = function (nodes, parent, levels, deep, _evalDataValue) {
            var _this = this;
            var $ul = $('<ul></ul>');
            var _iconClses = ICON_CLASSES[this.treeicons || defaultTreeIconClass];
            var _expr = (this.binddatavalue || this.datavalue);
            var _iconCls, _cls;
            _cls = levels > 0 ? ' expanded ' : ' collapsed ';
            _iconCls = _cls + (levels > 0 ? _iconClses.expanded : _iconClses.collapsed);
            deep = deep || 0;
            parent.append($ul);
            nodes.forEach(function (node, idx) {
                var $li = $('<li></li>'), $iconNode = $('<i></i>'), nodeLabel = base.getEvaluatedData(node, { expression: _this.nodelabel, bindExpression: _this.bindnodelabel }, _this.viewParent) || node.label, nodeIcon = base.getEvaluatedData(node, { expression: _this.nodeicon, bindExpression: _this.bindnodeicon }, _this.viewParent) || node.icon, nodeChildren = base.getEvaluatedData(node, { expression: _this.nodechildren, bindExpression: _this.bindnodechildren }, _this.viewParent) || node.children, nodeIdValue = base.getEvaluatedData(node, { expression: _this.nodeid, bindExpression: _this.bindnodeid }, _this.viewParent) || node.children;
                var isNodeMatched = false, expandCollapseIcon;
                $li.data('nodedata', node)
                    .append($iconNode)
                    .append("<span class=\"title\">" + nodeLabel + "</span>")
                    .appendTo($ul);
                // if datavalue(ie, expr) is provided select the tree node accordingly
                // if datavalue === 'FirstNode' -- select the FirstNode at level 0
                // if datavalue === 'LastNode' -- select the LastNode at level 0
                // if datavalue is a bind expression evaluate the expression for each node of the tree till the condition is satisfied.
                // if node identifier is present then verify the datavalue is bound expr or static value and compare with the node model
                if (_this.bindnodeid || _this.nodeid) {
                    isNodeMatched = _this.binddatavalue ? nodeIdValue === _evalDataValue : nodeIdValue === _expr;
                    if (nodeIdValue) {
                        $li.attr('id', nodeIdValue);
                    }
                }
                else if (_this.binddatavalue) { // evaluate the expression only if it is bound (useExpression)
                    isNodeMatched = !!core$1.$parseExpr(_expr)(_this, node);
                }
                // Perform LastNode check only at level 0.(ie, deep = 0);
                if (!_this._selectNode) {
                    if ((_expr === 'FirstNode' && idx === 0)
                        || (!deep && _expr === 'LastNode' && idx === nodes.length - 1)
                        || isNodeMatched) {
                        // save a reference of the node to be selected in `_selectNode`
                        _this._selectNode = $li;
                        _this.datavalue = nodeIdValue;
                    }
                }
                if (nodeIcon) {
                    $iconNode.addClass(nodeIcon);
                }
                if (nodeChildren && nodeChildren.length) { // parent node
                    $li.addClass("parent-node " + _cls);
                    expandCollapseIcon = $("<i class=\"wi " + _iconCls + "\"></i>");
                    if (nodeIcon) {
                        $iconNode.addClass(nodeIcon);
                    }
                    $li.prepend(expandCollapseIcon);
                    _this.constructNodes(nodeChildren, $li, levels - 1, deep + 1, _evalDataValue);
                }
                else {
                    if (!nodeIcon) {
                        $iconNode.addClass('leaf-node');
                    }
                    $li.addClass('leaf-node');
                }
            });
        };
        TreeDirective.prototype.getNodesFromString = function (value) {
            return value.split(',').map(function (item) {
                return {
                    'label': item && item.trim()
                };
            });
        };
        TreeDirective.prototype.getNodes = function (newVal) {
            var nodes;
            if (_.isString(newVal) && !_.isEmpty(newVal)) {
                newVal = newVal.trim();
                if (newVal) {
                    nodes = this.getNodesFromString(newVal);
                }
            }
            else if (_.isArray(newVal)) {
                newVal = base.getOrderedDataset(newVal, this.orderby);
                nodes = newVal;
            }
            else if (_.isObject(newVal)) {
                nodes = [newVal];
            }
            return nodes;
        };
        TreeDirective.prototype.changeTreeIcons = function (nv, ov) {
            var $el = $(this.nativeElement);
            nv = nv || defaultTreeIconClass;
            ov = ov || defaultTreeIconClass;
            $el.find('i.expanded').removeClass(ICON_CLASSES[ov].expanded).addClass(ICON_CLASSES[nv].expanded);
            $el.find('i.collapsed').removeClass(ICON_CLASSES[ov].collapsed).addClass(ICON_CLASSES[nv].collapsed);
        };
        TreeDirective.prototype.toggleExpandCollapseNode = function ($event, $i, $li) {
            var treeIcons = ICON_CLASSES[this.treeicons || defaultTreeIconClass];
            var $liPath = $li.find('> span.title').parents('.app-tree li');
            var path = '';
            // construct the path of the node
            $liPath
                .each(function (i, el) {
                var current = $(el).children('.title').text();
                path = "/" + (current + path);
            });
            var eventParams = {
                '$event': $event,
                "$item": $li.data('nodedata'),
                "$path": path
            };
            if ($i.hasClass('collapsed')) {
                $i.removeClass("collapsed " + treeIcons.collapsed).addClass("expanded " + treeIcons.expanded);
                $li.removeClass('collapsed').addClass('expanded');
                this.invokeEventCallback('expand', eventParams);
            }
            else if ($i.hasClass('expanded')) {
                $i.removeClass("expanded " + treeIcons.expanded).addClass("collapsed " + treeIcons.collapsed);
                $li.removeClass('expanded').addClass('collapsed');
                this.invokeEventCallback('collapse', eventParams);
            }
        };
        TreeDirective.prototype.renderTree = function (forceRender) {
            var _this = this;
            var docFrag, $li, $liPath, data, path = '';
            var levels = +this.nativeElement.getAttribute('levels') || 0, $el = $(this.nativeElement);
            $el.empty();
            if (forceRender) {
                this._selectNode = undefined;
            }
            if (this.nodes && this.nodes.length) {
                docFrag = document.createDocumentFragment();
                this.constructNodes(this.nodes, $(docFrag), levels, 0, this.datavalue);
                $el.append(docFrag);
            }
            if (this._selectNode) {
                $li = this._selectNode;
                $li.addClass('selected');
                data = $li.data('nodedata');
                $liPath = $li.parentsUntil($el, 'li.parent-node.collapsed');
                if (!$liPath.length) {
                    $liPath = $li;
                }
                $liPath
                    .each(function () {
                    var $current = $(_this), $i = $current.children('i.collapsed'), $title = $current.children('.title');
                    _this.toggleExpandCollapseNode(undefined, $i, $current);
                    path = "/" + ($title.text() + path);
                });
                this.selecteditem = core$1.getClonedObject(data) || {};
                this.selecteditem.path = path;
                this.invokeEventCallback('select', { $event: undefined, $item: data, $path: path });
                core$1.$appDigest();
            }
        };
        TreeDirective.prototype.selectNode = function (evt, value) {
            var _this = this;
            var target = evt && $(evt.target), $el = $(this.nativeElement), $li = _.isObject(value) ? value : $el.find("li[id=\"" + value + "\"]").first();
            var data, path = '', $liPath, nodeAction;
            $el.find('.selected').removeClass('selected');
            if (!$li.length) {
                return;
            }
            $li.addClass('selected');
            data = $li.data('nodedata');
            nodeAction = data[this.nodeaction || 'action'];
            // if the selectNode is initiated by click event then use the nativeElement target from event
            $liPath = target ? target.parents('.app-tree li') : $li.find('> span.title').parents('.app-tree li');
            // construct the path of the node
            $liPath
                .each(function (i, el) {
                var current = $(el).children('.title').text();
                path = "/" + (current + path);
            });
            // expand the current node till the viewParent level which is collapsed
            $li.parentsUntil($el, 'li.parent-node.collapsed')
                .each(function (index, el) {
                var $current = $(el), $i = $current.children('i.collapsed');
                _this.toggleExpandCollapseNode(undefined, $i, $current);
            });
            this.selecteditem = core$1.getClonedObject(data) || {};
            this.selecteditem.path = path;
            if (target) {
                if (this.nodeid) {
                    this.datavalue = core$1.$parseExpr(this.nodeid)(this, data);
                }
                else if (this.bindnodeid) {
                    this.datavalue = base.getEvaluatedData(data, { expression: this.nodeid, bindExpression: this.bindnodeid }, this.viewParent);
                }
                else {
                    this.datavalue = core$1.getClonedObject(data) || {};
                }
            }
            if (nodeAction) {
                core$1.$parseEvent(nodeAction)(this);
            }
            this.invokeEventCallback('select', { $event: evt, $item: data, $path: path });
            core$1.$appDigest();
        };
        // click event is added on the host nativeElement
        TreeDirective.prototype.bindEvents = function () {
            var _this = this;
            $(this.nativeElement).on('click', function (evt) {
                var target = $(evt.target), li = target.closest('li'), $i = target.is('i') ? target : target.siblings('i.collapsed,i.expanded');
                evt.stopPropagation();
                if (target.is('span.title')) { // select the node only if it is nodelabel
                    _this.selecteditem = {};
                    _this.selectNode(evt, li);
                }
                if (target.is('i') || (target.is('span.title') && _this.nodeclick === 'expand')) {
                    _this.toggleExpandCollapseNode(evt, $i, li);
                }
            });
        };
        TreeDirective.prototype.selectById = function (value) {
            this.selectNode(undefined, value);
        };
        TreeDirective.prototype.deselectById = function (value) {
            this.selecteditem = {};
            this.selectById();
        };
        TreeDirective.prototype.redraw = function () {
            this.renderTree(true);
        };
        var TreeDirective_1;
        TreeDirective.initializeProps = registerProps();
        TreeDirective.ctorParameters = function () { return [
            { type: core.Injector },
            { type: undefined, decorators: [{ type: core.Attribute, args: ['datavalue.bind',] }] },
            { type: undefined, decorators: [{ type: core.Attribute, args: ['nodelabel.bind',] }] },
            { type: undefined, decorators: [{ type: core.Attribute, args: ['nodeicon.bind',] }] },
            { type: undefined, decorators: [{ type: core.Attribute, args: ['nodechildren.bind',] }] },
            { type: undefined, decorators: [{ type: core.Attribute, args: ['nodeid.bind',] }] }
        ]; };
        TreeDirective = TreeDirective_1 = __decorate([
            core.Directive({
                selector: 'div[wmTree]',
                providers: [
                    base.provideAsWidgetRef(TreeDirective_1)
                ]
            }),
            __param(1, core.Attribute('datavalue.bind')),
            __param(2, core.Attribute('nodelabel.bind')),
            __param(3, core.Attribute('nodeicon.bind')),
            __param(4, core.Attribute('nodechildren.bind')),
            __param(5, core.Attribute('nodeid.bind')),
            __metadata("design:paramtypes", [core.Injector, Object, Object, Object, Object, Object])
        ], TreeDirective);
        return TreeDirective;
    }(base.StylableComponent));

    var components = [
        TreeDirective
    ];
    var TreeModule = /** @class */ (function () {
        function TreeModule() {
        }
        TreeModule = __decorate([
            core.NgModule({
                imports: [
                    common.CommonModule,
                    base.WmComponentsModule
                ],
                declarations: __spread(components),
                exports: __spread(components),
                entryComponents: []
            })
        ], TreeModule);
        return TreeModule;
    }());

    exports.TreeModule = TreeModule;
    exports.ɵa = TreeDirective;
    exports.ɵb = registerProps;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=index.umd.js.map
