(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common'), require('@wm/components/base'), require('@wm/components/basic'), require('@wm/core')) :
    typeof define === 'function' && define.amd ? define('@wm/components/chart', ['exports', '@angular/core', '@angular/common', '@wm/components/base', '@wm/components/basic', '@wm/core'], factory) :
    (global = global || self, factory((global.wm = global.wm || {}, global.wm.components = global.wm.components || {}, global.wm.components.chart = {}), global.ng.core, global.ng.common, global.wm.components.base, global.wm.components.basic, global.wm.core));
}(this, (function (exports, core, common, base, basic, core$1) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __rest(s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); }
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    function __createBinding(o, m, k, k2) {
        if (k2 === undefined) k2 = k;
        o[k2] = m[k];
    }

    function __exportStar(m, exports) {
        for (var p in m) if (p !== "default" && !exports.hasOwnProperty(p)) exports[p] = m[p];
    }

    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m) return m.call(o);
        if (o && typeof o.length === "number") return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }

    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    }

    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    };

    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }

    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
    }

    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }

    function __asyncValues(o) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
    }

    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
        return cooked;
    };

    function __importStar(mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
        result.default = mod;
        return result;
    }

    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }

    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }

    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    var registerProps = function () {
        base.register('wm-chart', new Map([
            ['aggregation', __assign({ value: 'none' }, base.PROP_STRING)],
            ['aggregationcolumn', base.PROP_STRING],
            ['areaviewtype', __assign({ value: 'stack' }, base.PROP_STRING)],
            ['barspacing', __assign({ value: 'medium' }, base.PROP_STRING)],
            ['bubblesize', base.PROP_STRING],
            ['centerlabel', base.PROP_STRING],
            ['class', base.PROP_STRING],
            ['customcolors', base.PROP_ANY],
            ['dataset', base.PROP_ANY],
            ['datasource', base.PROP_STRING],
            ['donutratio', __assign({ value: 'medium' }, base.PROP_STRING)],
            ['formattype', { value: '', PROP_STRING: base.PROP_STRING }],
            ['groupby', base.PROP_STRING],
            ['height', { value: '210px', PROP_STRING: base.PROP_STRING }],
            ['highlightpoints', base.PROP_BOOLEAN],
            ['iconclass', base.PROP_STRING],
            ['interpolation', __assign({ value: 'linear' }, base.PROP_STRING)],
            ['labelthreshold', __assign({ value: 0.01 }, base.PROP_NUMBER)],
            ['labeltype', __assign({ value: 'percent' }, base.PROP_STRING)],
            ['legendtype', __assign({ value: 'furious' }, base.PROP_STRING)],
            ['linethickness', base.PROP_STRING],
            ['loadingdatamsg', __assign({ value: 'Loading...' }, base.PROP_STRING)],
            ['name', base.PROP_STRING],
            ['nodatamessage', __assign({ value: 'No Data Available.' }, base.PROP_STRING)],
            ['offset', base.PROP_STRING],
            ['offsetbottom', __assign({ value: 55 }, base.PROP_NUMBER)],
            ['offsetleft', __assign({ value: 75 }, base.PROP_NUMBER)],
            ['offsetright', __assign({ value: 25 }, base.PROP_NUMBER)],
            ['offsettop', __assign({ value: 25 }, base.PROP_NUMBER)],
            ['orderby', base.PROP_STRING],
            ['reducexticks', __assign({ value: true }, base.PROP_BOOLEAN)],
            ['shape', __assign({ value: 'circle' }, base.PROP_STRING)],
            ['show', __assign({ value: true }, base.PROP_BOOLEAN)],
            ['showlabels', __assign({ value: 'outside' }, base.PROP_STRING)],
            ['showlabelsoutside', __assign({ value: true }, base.PROP_BOOLEAN)],
            ['showlegend', __assign({ value: 'top' }, base.PROP_STRING)],
            ['showvalues', __assign({ value: false }, base.PROP_BOOLEAN)],
            ['showxaxis', __assign({ value: true }, base.PROP_BOOLEAN)],
            ['showxdistance', __assign({ value: false }, base.PROP_BOOLEAN)],
            ['showyaxis', __assign({ value: true }, base.PROP_BOOLEAN)],
            ['showydistance', __assign({ value: false }, base.PROP_BOOLEAN)],
            ['staggerlabels', __assign({ value: false }, base.PROP_BOOLEAN)],
            ['subheading', base.PROP_STRING],
            ['theme', base.PROP_STRING],
            ['title', base.PROP_STRING],
            ['tooltips', __assign({ value: true }, base.PROP_BOOLEAN)],
            ['type', base.PROP_STRING],
            ['viewtype', __assign({ value: 'Grouped' }, base.PROP_STRING)],
            ['xaxisdatakey', base.PROP_STRING],
            ['xaxislabel', base.PROP_STRING],
            ['xaxislabeldistance', __assign({ value: 12 }, base.PROP_NUMBER)],
            ['xdateformat', base.PROP_STRING],
            ['xdomain', __assign({ value: 'Default' }, base.PROP_STRING)],
            ['xnumberformat', base.PROP_STRING],
            ['xunits', base.PROP_STRING],
            ['yaxisdatakey', base.PROP_STRING],
            ['yaxislabel', base.PROP_STRING],
            ['yaxislabeldistance', __assign({ value: 12 }, base.PROP_NUMBER)],
            ['ydomain', __assign({ value: 'Default' }, base.PROP_STRING)],
            ['ynumberformat', base.PROP_STRING],
            ['yunits', base.PROP_STRING]
        ]));
    };

    var chartTypes = ['Column', 'Line', 'Area', 'Cumulative Line', 'Bar', 'Pie', 'Donut', 'Bubble'], allShapes = ['circle', 'square', 'diamond', 'cross', 'triangle-up', 'triangle-down'];
    var dateList = ['01/01/2001', '01/01/2002', '01/01/2003'], themes = {
        'Terrestrial': {
            colors: ['#1f77b4', '#aec7e8', '#ff7f0e', '#ffbb78', '#2ca02c', '#98df8a', '#d62728', '#ff9896', '#9467bd', '#c5b0d5', '#8c564b', '#c49c94', '#e377c2', '#f7b6d2', '#7f7f7f', '#c7c7c7', '#bcbd22', '#dbdb8d', '#17becf', '#9edae5'],
            tooltip: {
                'backgroundColor': '#de7d28',
                'textColor': '#FFFFFF'
            }
        },
        'Annabelle': {
            colors: ['#393b79', '#5254a3', '#6b6ecf', '#9c9ede', '#637939', '#8ca252', '#b5cf6b', '#cedb9c', '#8c6d31', '#bd9e39', '#e7ba52', '#e7cb94', '#843c39', '#ad494a', '#d6616b', '#e7969c', '#7b4173', '#a55194', '#ce6dbd', '#de9ed6'],
            tooltip: {
                'backgroundColor': '#2e306f',
                'textColor': '#FFFFFF'
            }
        },
        'Azure': {
            colors: ['#3182bd', '#6baed6', '#9ecae1', '#c6dbef', '#e6550d', '#fd8d3c', '#fdae6b', '#fdd0a2', '#31a354', '#74c476', '#a1d99b', '#c7e9c0', '#756bb1', '#9e9ac8', '#bcbddc', '#dadaeb', '#636363', '#969696', '#bdbdbd', '#d9d9d9'],
            tooltip: {
                'backgroundColor': '#3182bd',
                'textColor': '#FFFFFF'
            }
        },
        'Retro': {
            colors: ['#0ca7a1', '#ffa615', '#334957', '#acc5c2', '#988f90', '#8accc9', '#515151', '#f27861', '#36c9fd', '#794668', '#0f709d', '#0d2738', '#44be78', '#4a1839', '#6a393f', '#557d8b', '#6c331c', '#1c1c1c', '#861500', '#09562a'],
            tooltip: {
                'backgroundColor': '#80513a',
                'textColor': '#FFFFFF'
            }
        },
        'Mellow': {
            colors: ['#f0dcbf', '#88c877', '#aeb918', '#2e2c23', '#ddddd2', '#dfe956', '#4c963b', '#5d3801', '#e1eec3', '#cd8472', '#fcfab3', '#9a4635', '#9295ad', '#2e3f12', '#565677', '#557d8b', '#4f4d02', '#0c0c1b', '#833324', '#24120e'],
            tooltip: {
                'backgroundColor': '#7c9e73',
                'textColor': '#FFFFFF'
            }
        },
        'Orient': {
            colors: ['#a80000', '#cc6c3c', '#f0e400', '#000084', '#fccc6c', '#009c6c', '#cc309c', '#78cc00', '#fc84e4', '#48e4fc', '#4878d8', '#186c0c', '#606060', '#a8a8a8', '#000000', '#d7d7d7', '#75a06e', '#190d0b', '#888888', '#694b84'],
            tooltip: {
                'backgroundColor': '#c14242',
                'textColor': '#FFFFFF'
            }
        },
        'GrayScale': {
            colors: ['#141414', '#353535', '#5b5b5b', '#848484', '#a8a8a8', '#c3c3c3', '#e0e0e0', '#c8c8c8', '#a5a5a5', '#878787', '#656565', '#4e4e4e', '#303030', '#1c1c1c', '#4f4f4f', '#3b3b3b', '#757575', '#606060', '#868686', '#c1c1c1'],
            tooltip: {
                'backgroundColor': '#575757',
                'textColor': '#FFFFFF'
            }
        },
        'Flyer': {
            colors: ['#3f454c', '#5a646e', '#848778', '#cededf', '#74c4dd', '#0946ed', '#380bb1', '#000ff0', '#f54a23', '#1db262', '#bca3aa', '#ffa500', '#a86b32', '#63a18c', '#56795e', '#934343', '#b75f5f', '#752d2d', '#4e1111', '#920606'],
            tooltip: {
                'backgroundColor': '#47637c',
                'textColor': '#FFFFFF'
            }
        },
        'Luminosity': {
            colors: ['#FFFFFF', '#e4e4e4', '#00bcd4', '#f0dd2f', '#00aabf', '#018376', '#e91e63', '#39e5d4', '#ff6d6d', '#00ff76', '#ff9800', '#969696', '#ff4200', '#e00000', '#95cbe5', '#5331ff', '#fff4a7', '#e7a800', '#0061e4', '#d5e7ff'],
            tooltip: {
                'backgroundColor': '#47637c',
                'textColor': '#FFFFFF'
            }
        }
    }, basicProperties = ['xaxislabel', 'yaxislabel', 'xunits', 'yunits', 'xnumberformat', 'xdateformat', 'ynumberformat',
        'showvalues', 'showlabels', 'viewtype', 'areaviewtype', 'staggerlabels', 'reducexticks', 'offsettop', 'offsetbottom', 'offsetright', 'offsetleft',
        'barspacing', 'xaxislabeldistance', 'yaxislabeldistance', 'theme', 'labeltype', 'donutratio', 'showlabelsoutside', 'showxdistance', 'showydistance', 'shape', 'nodatamessage', 'captions', 'showxaxis', 'showyaxis',
        'centerlabel', 'customcolors', 'showlegend', 'legendtype', 'xdomain', 'ydomain', 'tooltips', 'linethickness', 'highlightpoints', 'interpolation', 'labelthreshold'], barSpacingMap = {
        'small': 0.3,
        'medium': 0.5,
        'large': 0.8
    }, donutRatioMap = {
        'small': 0.3,
        'medium': 0.6,
        'large': 0.7
    }, barSpacingMapInvert = _.invert(barSpacingMap), donutRatioMapInvert = _.invert(donutRatioMap), tickformats = {
        'Thousand': {
            'prefix': 'K',
            'divider': 1000
        },
        'Million': {
            'prefix': 'M',
            'divider': 1000000
        },
        'Billion': {
            'prefix': 'B',
            'divider': 1000000000
        }
    }, chartId = '#preview-chart', dataTypeJSON = ['Column', 'Line', 'Pie', 'Bar', 'Donut', 'Bubble'], // Charts that supports the data to be JSON;
    lineTypeCharts = ['Line', 'Area', 'Cumulative Line'], // Charts that does not supports the string type of data in the xaxis in the nvd3;
    dataTypeArray = ['Cumulative Line', 'Area'], // Charts that supports the data to be Array
    SAMPLE_DATA = {
        'group1': 'Europe',
        'group2': 'Asia',
        'group3': 'America',
        'group4': 'Australia'
    };
    // returns true if chart type is pie
    var isPieChart = function (type) { return type === 'Pie'; };
    // returns true if chart type is line
    var isLineChart = function (type) { return type === 'Line'; };
    // returns true if chart type is bar
    var isBarChart = function (type) { return type === 'Bar'; };
    // returns true if chart type is donut
    var isDonutChart = function (type) { return type === 'Donut'; };
    // returns true if chart type is bubble
    var isBubbleChart = function (type) { return type === 'Bubble'; };
    // returns true if chart type is column
    var isColumnChart = function (type) { return type === 'Column'; };
    // returns true if chart type is area
    var isAreaChart = function (type) { return type === 'Area'; };
    // returns true if chart type is area
    var isPieType = function (type) { return isPieChart(type) || isDonutChart(type); };
    // The format of chart data is array of json objects in case of the following types of chart
    var isChartDataJSON = function (type) { return _.includes(dataTypeJSON, type) || !_.includes(chartTypes, type); };
    // The format of chart data is array of objects in case of the following types of chart
    var isChartDataArray = function (type) { return _.includes(dataTypeArray, type); };
    // returns true is the chart type is 'line', 'area' or 'cumulative line' else false
    var isLineTypeChart = function (type) { return _.includes(lineTypeCharts, type); };
    // X/Y Domain properties are supported only for Column and Area charts
    var isAxisDomainSupported = function (type) { return isColumnChart(type) || isAreaChart(type); };
    // Returns bar spacing value
    var getBarSpacingValue = function (value, prop) {
        if (prop === 'value') {
            return barSpacingMap[value];
        }
        if (prop === 'key') {
            return barSpacingMapInvert[value];
        }
    };
    // Returns radius value
    var getRadiusValue = function (value, prop) {
        if (prop === 'value') {
            return donutRatioMap[value];
        }
        if (prop === 'key') {
            return donutRatioMapInvert[value];
        }
    };
    // Returns labels config
    var getLabelValues = function (showlabels, showlabelsoutside, prop) {
        var labelsConfig = {};
        switch (showlabels) {
            case 'hide':
                labelsConfig.showlabels = false;
                break;
            case 'inside':
                labelsConfig.showlabels = true;
                labelsConfig.showlabelsoutside = false;
                break;
            case 'outside':
                labelsConfig.showlabels = true;
                labelsConfig.showlabelsoutside = true;
                break;
        }
        return labelsConfig;
    };
    // Construct the sample data
    var constructSampleData = function (dataType, yaxisLength, shape) {
        var first_series = [], second_series = [], third_series = [], first_series_array = [], second_series_array = [], third_series_array = [], first_series_bubble = [], second_series_bubble = [], third_series_bubble = [], data = [];
        switch (dataType) {
            case 'jsonFormat':
                first_series = [
                    { 'x': '01/01/2001', 'y': 4000000 },
                    { 'x': '01/01/2002', 'y': 1000000 },
                    { 'x': '01/01/2003', 'y': 5000000 }
                ];
                second_series = [
                    { 'x': '01/01/2001', 'y': 3000000 },
                    { 'x': '01/01/2002', 'y': 4000000 },
                    { 'x': '01/01/2003', 'y': 7000000 }
                ];
                third_series = [
                    { 'x': '01/01/2001', 'y': 2000000 },
                    { 'x': '01/01/2002', 'y': 8000000 },
                    { 'x': '01/01/2003', 'y': 6000000 }
                ];
                data[0] = {
                    values: first_series,
                    key: SAMPLE_DATA.group1
                };
                if (yaxisLength >= 2) {
                    data[1] = {
                        values: second_series,
                        key: SAMPLE_DATA.group2
                    };
                }
                if (yaxisLength >= 3) {
                    data[2] = {
                        values: third_series,
                        key: SAMPLE_DATA.group3
                    };
                }
                break;
            case 'lineChartFormat':
                first_series = [
                    { 'x': 1, 'y': 4000000 },
                    { 'x': 2, 'y': 1000000 },
                    { 'x': 3, 'y': 5000000 }
                ];
                second_series = [
                    { 'x': 1, 'y': 3000000 },
                    { 'x': 2, 'y': 4000000 },
                    { 'x': 3, 'y': 7000000 }
                ];
                third_series = [
                    { 'x': 1, 'y': 2000000 },
                    { 'x': 2, 'y': 8000000 },
                    { 'x': 3, 'y': 6000000 }
                ];
                data[0] = {
                    values: first_series,
                    key: SAMPLE_DATA.group1
                };
                if (yaxisLength >= 2) {
                    data[1] = {
                        values: second_series,
                        key: SAMPLE_DATA.group2
                    };
                }
                if (yaxisLength >= 3) {
                    data[2] = {
                        values: third_series,
                        key: SAMPLE_DATA.group3
                    };
                }
                break;
            case 'arrayFormat':
                first_series_array = [
                    [1, 4000000],
                    [2, 1000000],
                    [3, 5000000]
                ];
                second_series_array = [
                    [1, 3000000],
                    [2, 4000000],
                    [3, 7000000]
                ];
                third_series_array = [
                    [1, 2000000],
                    [2, 8000000],
                    [3, 6000000]
                ];
                data[0] = {
                    values: first_series_array,
                    key: SAMPLE_DATA.group1
                };
                if (yaxisLength >= 2) {
                    data[1] = {
                        values: second_series_array,
                        key: SAMPLE_DATA.group2
                    };
                }
                if (yaxisLength >= 3) {
                    data[2] = {
                        values: third_series_array,
                        key: SAMPLE_DATA.group3
                    };
                }
                break;
            case 'bubbleFormat':
                shape = shape === 'random' ? allShapes[Math.floor(Math.random() * allShapes.length)] : shape;
                first_series_bubble = [
                    { 'x': 80.66, 'y': 33739900, 'size': 78, 'shape': shape },
                    { 'x': 79.84, 'y': 81902300, 'size': 90, 'shape': shape },
                    { 'x': 78.6, 'y': 5523100, 'size': 45, 'shape': shape }
                ];
                second_series_bubble = [
                    { 'x': 72.73, 'y': 79716200, 'size': 98, 'shape': shape },
                    { 'x': 80.05, 'y': 61801600, 'size': 20, 'shape': shape },
                    { 'x': 72.49, 'y': 73137200, 'size': 34, 'shape': shape }
                ];
                third_series_bubble = [
                    { 'x': 68.09, 'y': 33739900, 'size': 45, 'shape': shape },
                    { 'x': 81.55, 'y': 7485600, 'size': 78, 'shape': shape },
                    { 'x': 68.60, 'y': 141850000, 'size': 56, 'shape': shape }
                ];
                data[0] = {
                    values: first_series_bubble,
                    key: SAMPLE_DATA.group1
                };
                if (yaxisLength >= 2) {
                    data[1] = {
                        values: second_series_bubble,
                        key: SAMPLE_DATA.group2
                    };
                }
                if (yaxisLength >= 3) {
                    data[2] = {
                        values: third_series_bubble,
                        key: SAMPLE_DATA.group3
                    };
                }
                break;
            case 'pieChartFormat':
                data = [
                    { 'x': SAMPLE_DATA.group1, 'y': 1000000 },
                    { 'x': SAMPLE_DATA.group2, 'y': 2000000 },
                    { 'x': SAMPLE_DATA.group3, 'y': 3000000 },
                    { 'x': SAMPLE_DATA.group4, 'y': 4000000 }
                ];
                break;
        }
        return data;
    };
    var getDataType = function (widgetContext) {
        var type = widgetContext.type;
        if (isLineChart(type)) {
            return 'lineChartFormat';
        }
        if (isPieType(type)) {
            return 'pieChartFormat';
        }
        if (isBubbleChart(type)) {
            return 'bubbleFormat';
        }
        return isChartDataJSON(type) ? 'jsonFormat' : 'arrayFormat';
    };
    // Sample data to populate when no data is bound
    var getSampleData = function (widgetContext) { return constructSampleData(getDataType(widgetContext), _.split(widgetContext.yaxisdatakey, ',').length, widgetContext.shape); };
    // Check whether X/Y Domain was set to Min and is supported for the present chart
    var isAxisDomainValid = function (widgetContext, axis) {
        if (widgetContext[axis + 'domain'] === 'Min' && (isAxisDomainSupported(widgetContext.type))) {
            return true;
        }
        return false;
    };
    // Check whether min and max values are finite or not
    var areMinMaxValuesValid = function (values) {
        if (_.isFinite(values.min) && _.isFinite(values.max)) {
            return true;
        }
        return false;
    };
    var getYScaleMinValue = function (value) {
        var _min = Math.floor(value);
        /* If the number has a) decimal part returning floor value - 0.1
         b) no decimal part returning floor value - 1 */
        return Math.abs(value) - _min > 0 ? value - 0.1 : _min - 1;
    };
    // Chooses the data points of line/cumulative line/area chart and highlights them
    var highlightPoints = function (id, highlightpoints) {
        var chartSvg = id ? d3.select('#wmChart' + id + ' svg') : d3.select(chartId + ' svg');
        if (highlightpoints) {
            chartSvg.selectAll('.nv-point').style({ 'stroke-width': '6px', 'fill-opacity': '.95', 'stroke-opacity': '.95' });
        }
        else {
            chartSvg.selectAll('.nv-point').style({ 'stroke-width': '0px', 'fill-opacity': '0' });
        }
    };
    // Chooses the line of line/cumulative line and increases the thickness of it
    var setLineThickness = function (id, thickness) {
        var chartSvg = id ? d3.select('#wmChart' + id + ' svg') : d3.select(chartId + ' svg');
        thickness = thickness || 1.5;
        chartSvg.selectAll('.nv-line').style({ 'stroke-width': thickness });
    };
    // Constructing a common key value map for preview and canvas mode
    var initProperties = function (widgetContext, propertyValueMap) {
        if (!propertyValueMap || core$1.isEmptyObject(propertyValueMap)) {
            propertyValueMap = {};
        }
        _.forEach(basicProperties, function (prop) {
            if (_.isUndefined(propertyValueMap[prop])) {
                propertyValueMap[prop] = widgetContext[prop];
            }
        });
        return propertyValueMap;
    };
    var getNumberValue = function (value, callback) {
        return isNaN(parseInt(value, 10)) ? callback(value, 'value') : value;
    };
    // Formats the given value according to date format
    var getDateFormatedData = function (dateFormat, d) {
        dateFormat = dateFormat || '%x';
        /**
         * if date value is string "20-05-2019" then new Date(value) return 20May2019 with current time in India,
         * whereas this will return 19May2019 with time lagging for few hours.
         * This is because it returns UTC time i.e. Coordinated Universal Time (UTC).
         * To create date in local time use moment
         */
        return d3.time.format(dateFormat)(new Date(moment(moment(d).format()).valueOf()));
    };
    // Formats the given value according to number format
    var getNumberFormatedData = function (numberFormat, d) {
        var formattedData, divider, prefix;
        formattedData = d3.format(numberFormat)(d);
        // formatting the data based on number format selected
        if (numberFormat) {
            // Getting the respective divider[1000,1000000,1000000000] based on the number format choosen
            divider = (tickformats[numberFormat] && tickformats[numberFormat].divider) || 0;
            prefix = tickformats[numberFormat] && tickformats[numberFormat].prefix;
            if (prefix && divider !== 0) {
                formattedData = d3.format('.2f')(d / divider) + prefix;
            }
        }
        else {
            // Auto formatting the data when no formating option is chosen
            formattedData = d >= 1000 ? d3.format('.1s')(d) : d;
        }
        return formattedData;
    };
    // Set the visibility property of the chart x,y axis due to a bug in the nvd3
    var toggleAxisShow = function (property, value) {
        var $xAxis = d3.select(chartId + ' g.nv-axis.nv-x'), $yAxis = d3.select(chartId + ' g.nv-axis.nv-y');
        if (property === 'showxaxis') {
            $xAxis.style('visibility', value ? 'visible' : 'hidden');
        }
        else {
            $yAxis.style('visibility', value ? 'visible' : 'hidden');
        }
    };
    var modifyLegendPosition = function (widgetContext, position, id) {
        var showLegend = isShowLegend(widgetContext.showlegend), chart_Id = id ? '#wmChart' + id : chartId, legendWrap = d3.select(chart_Id + ' .nv-legendWrap'), legendPadding = 5;
        // Return when showlegend is false
        if (!showLegend || !legendWrap[0][0]) {
            return;
        }
        if (position === 'bottom') {
            var legendWrapHeight_1 = legendWrap[0][0].getBoundingClientRect().height, wrap = d3.select(chart_Id + ' .nv-wrap'), wrapTransform = (wrap && wrap.attr('transform')) ? wrap.attr('transform').replace(/, /g, ',') : '', coordinates = /translate\(\s*([^\s,)]+)[ ,]([^\s,)]+)/.exec(wrapTransform), getChartHeight = function () {
                var chartHeight = $(chart_Id + ' svg>.nvd3.nv-wrap')[0].getBoundingClientRect().height;
                if (chartHeight === 0) { // fix for IE
                    chartHeight = ($(chart_Id + ' svg')[0].getBoundingClientRect().height - (legendWrapHeight_1 + 15));
                }
                return chartHeight;
            };
            legendWrap.attr('transform', 'translate(0 , ' + (getChartHeight() - legendWrapHeight_1 - legendPadding) + ')');
            if (coordinates) {
                wrap.attr('transform', 'translate(' + coordinates[1] + ',' + legendPadding + ')');
            }
        }
    };
    // Returns value if legend need to shown or not
    var isShowLegend = function (value) {
        // Old projects will have either true or false
        if (value === 'false' || value === false) {
            return false;
        }
        if (value === 'true' || value === true) {
            return true;
        }
        // New projects will have either 'Hide Legend', 'Show Top', 'Show Bottom'
        return value === 'hide' ? false : true;
    };
    /**
     * Customise the tooltip for donut & pie charts and also for charts having only one value attached to yaxis
     * @param key
     * @param label
     */
    var customiseTooltip = function (chart, propertyValueMap, widgetContext, label) {
        chart.tooltip.contentGenerator(function (key) {
            var xValue = key.data.x, yValue;
            yValue = getNumberFormatedData(propertyValueMap.ynumberformat, key.data.y);
            if (isPieType(widgetContext.type)) {
                label = key.data.x;
                xValue = '';
            }
            return '<table>' +
                '<tbody>' +
                '<tr class="value"><b>' + xValue +
                '</b></tr>' +
                '<tr>' +
                '<td class="legend-color-guide"><div style="background-color:' + key.color + ';"></div></td>' +
                '<td class="key">' + label + '</td>' +
                '<td class="value">' + yValue + '</td>' +
                '</tr>' +
                '</tbody>' +
                '</table>';
        });
    };
    // intializes the chart obejct
    var initChart = function (widgetContext, xDomainValues, yDomainValues, propertyValueMap, isPreview) {
        propertyValueMap = initProperties(widgetContext, propertyValueMap);
        var chart, colors = [], xaxislabel, yaxislabel, labelConfig, radius, barSpacing, showLegend, xAxisValue, hasMultipleYValues;
        var xValue = {}, yValue = {};
        switch (widgetContext.type) {
            case 'Column':
                barSpacing = getNumberValue(propertyValueMap.barspacing, getBarSpacingValue) || barSpacingMap.medium;
                chart = nv.models.multiBarChart()
                    .x(function (d) { return d.x; })
                    .y(function (d) { return d.y; })
                    .reduceXTicks(propertyValueMap.reducexticks)
                    .rotateLabels(0)
                    .showControls(false)
                    .stacked(propertyValueMap.viewtype === 'Stacked' ? true : false)
                    .groupSpacing(barSpacing);
                break;
            case 'Cumulative Line':
                chart = nv.models.cumulativeLineChart()
                    .x(function (d) { return d[0]; })
                    .y(function (d) { return d[1]; })
                    .showControls(false)
                    .useInteractiveGuideline(propertyValueMap.tooltips)
                    .interpolate(propertyValueMap.interpolation);
                break;
            case 'Line':
                chart = nv.models.lineChart()
                    .useInteractiveGuideline(propertyValueMap.tooltips)
                    .interpolate(propertyValueMap.interpolation);
                break;
            case 'Area':
                chart = nv.models.stackedAreaChart()
                    .x(function (d) { return d[0]; })
                    .y(function (d) { return d[1]; })
                    .clipEdge(true)
                    .showControls(false)
                    .style(propertyValueMap.areaviewtype)
                    .useInteractiveGuideline(propertyValueMap.tooltips)
                    .interpolate(propertyValueMap.interpolation);
                break;
            case 'Bar':
                barSpacing = getNumberValue(propertyValueMap.barspacing, getBarSpacingValue) || barSpacingMap.medium;
                chart = nv.models.multiBarHorizontalChart()
                    .x(function (d) { return d.x; })
                    .y(function (d) { return d.y; })
                    .showControls(false)
                    .stacked(propertyValueMap.viewtype === 'Stacked' ? true : false)
                    .showValues(propertyValueMap.showvalues)
                    .groupSpacing(barSpacing);
                break;
            case 'Pie':
            case 'Donut':
                labelConfig = getLabelValues(propertyValueMap.showlabels, propertyValueMap.showlabelsoutside, 'value');
                radius = getNumberValue(propertyValueMap.donutratio, getRadiusValue) || donutRatioMap.medium;
                chart = nv.models.pieChart()
                    .x(function (d) { return d.x; })
                    .y(function (d) { return d.y; })
                    .showLabels(labelConfig.showlabels)
                    .labelType(propertyValueMap.labeltype)
                    .valueFormat(d3.format('%'))
                    .title(propertyValueMap.centerlabel)
                    .labelThreshold(propertyValueMap.labelthreshold || 0.01)
                    .labelsOutside(labelConfig.showlabelsoutside);
                if (isDonutChart(widgetContext.type)) {
                    chart.donut(true)
                        .donutRatio(radius);
                }
                if (propertyValueMap.labeltype === 'key-value') {
                    chart.labelType(function (d) { return d.data.x + ' ' + d.data.y; });
                }
                break;
            case 'Bubble':
                chart = nv.models.scatterChart()
                    .x(function (d) { return d.x; })
                    .y(function (d) { return d.y; })
                    .showDistX(propertyValueMap.showxdistance)
                    .showDistY(propertyValueMap.showydistance);
                break;
        }
        if (xDomainValues) {
            xValue.min = xDomainValues.min.x || xDomainValues.min[0];
            xValue.max = xDomainValues.max.x || xDomainValues.max[0];
            // If the values on the x axis are string then min max values gives Infinity
            if (areMinMaxValuesValid(xValue)) {
                // Reducing the min value to 0.1 so the min value is not missed out
                xValue.min = getYScaleMinValue(xValue.min);
                chart.xDomain([xValue.min, xValue.max]);
            }
        }
        if (yDomainValues) {
            // Reducing the min value to 1 so the min value is not missed out
            yValue.min = yDomainValues.min.y || yDomainValues.min[1];
            yValue.max = yDomainValues.max.y || yDomainValues.max[1];
            // If the values on the y axis are string or invalid then min max values gives Infinity
            if (areMinMaxValuesValid(yValue)) {
                // Reducing the min value to 1 so the min value is not missed out
                yValue.min = getYScaleMinValue(yValue.min);
                chart.yDomain([yValue.min, yValue.max]);
            }
        }
        // Setting the legend type choosen by user or default it will be furious
        chart.legend.vers((propertyValueMap.legendtype && propertyValueMap.legendtype.toLowerCase()) || 'furious');
        if (!_.includes(chartTypes, widgetContext.type)) {
            chart = nv.models.multiBarChart()
                .x(function (d) { return d.x; })
                .y(function (d) { return d.y; });
        }
        if (isPieType(widgetContext.type)) {
            // In case of pie/donut chart formatting the values of it
            if (propertyValueMap.labeltype === 'percent') {
                chart.valueFormat(d3.format('%'));
            }
            else {
                chart.valueFormat(function (d) { return getNumberFormatedData(propertyValueMap.ynumberformat, d); });
            }
            // Customizing the tooltips in case of the pie and donut when labelType is value
            customiseTooltip(chart, propertyValueMap, widgetContext);
        }
        else {
            chart.showXAxis(propertyValueMap.showxaxis)
                .showYAxis(propertyValueMap.showyaxis);
            // Setting the labels if they are specified explicitly or taking the axiskeys chosen
            xaxislabel = propertyValueMap.xaxislabel || core$1.prettifyLabels(widgetContext.xaxisdatakey) || 'x caption';
            yaxislabel = propertyValueMap.yaxislabel || core$1.prettifyLabels(widgetContext.yaxisdatakey) || 'y caption';
            // Checking if y axis has multiple values
            if (widgetContext.yaxisdatakey && widgetContext.yaxisdatakey.split(',').length > 1) {
                hasMultipleYValues = true;
            }
            // Customizing the tooltip to show yaxislabel, only if the y axis contains one value
            if (!hasMultipleYValues && !isBubbleChart(widgetContext.type)) {
                customiseTooltip(chart, propertyValueMap, widgetContext, yaxislabel);
            }
            // Adding the units to the captions if they are specified
            xaxislabel += propertyValueMap.xunits ? '(' + propertyValueMap.xunits + ')' : '';
            yaxislabel += propertyValueMap.yunits ? '(' + propertyValueMap.yunits + ')' : '';
            chart.xAxis
                .axisLabel(xaxislabel)
                .axisLabelDistance(propertyValueMap.xaxislabeldistance)
                .staggerLabels(propertyValueMap.staggerlabels);
            // If date format set format based date format
            if (propertyValueMap.xdateformat || (isPreview && !isBubbleChart(widgetContext.type))) {
                if (isLineTypeChart(widgetContext.type)) {
                    chart.xAxis.tickFormat(function (d) {
                        // get the actual value
                        xAxisValue = isPreview ? dateList[d - 1] : widgetContext.xDataKeyArr[d];
                        return getDateFormatedData(propertyValueMap.xdateformat, xAxisValue);
                    });
                }
                else {
                    chart.xAxis.tickFormat(function (d) { return getDateFormatedData(propertyValueMap.xdateformat, d); });
                }
            }
            else if (propertyValueMap.xnumberformat) {
                chart.xAxis.tickFormat(function (d) { return getNumberFormatedData(propertyValueMap.xnumberformat, d); });
            }
            else {
                if (isLineTypeChart(widgetContext.type)) {
                    // get the actual value
                    chart.xAxis.tickFormat(function (d) { return widgetContext.xDataKeyArr[d]; });
                }
            }
            chart.yAxis
                .axisLabel(yaxislabel)
                .axisLabelDistance(propertyValueMap.yaxislabeldistance)
                .staggerLabels(propertyValueMap.staggerlabels)
                .tickFormat(function (d) { return getNumberFormatedData(propertyValueMap.ynumberformat, d); });
            if (isBarChart(widgetContext.type)) {
                chart.valueFormat(function (d) { return getNumberFormatedData(propertyValueMap.ynumberformat, d); });
            }
        }
        // Support for custom colors if user gives direct string of colors in text box
        if (_.isString(propertyValueMap.customcolors) && propertyValueMap.customcolors) {
            colors = _.split(propertyValueMap.customcolors, ',');
        }
        if (_.isArray(propertyValueMap.customcolors)) {
            colors = propertyValueMap.customcolors;
        }
        showLegend = isShowLegend(propertyValueMap.showlegend);
        chart.showLegend(showLegend)
            .margin({ top: propertyValueMap.offsettop, right: propertyValueMap.offsetright, bottom: propertyValueMap.offsetbottom, left: propertyValueMap.offsetleft })
            .color(colors.length ? colors : themes[propertyValueMap.theme].colors);
        chart.tooltip.enabled(propertyValueMap.tooltips);
        widgetContext.message = propertyValueMap.nodatamessage || 'No data found';
        // setting the no data message
        chart.noData(widgetContext.message);
        if (isLineTypeChart(widgetContext.type) && widgetContext.highlightpoints) {
            chart.dispatch.on('stateChange', function () {
                setTimeout(function () { return postPlotChartProcess(widgetContext); }, 100);
            });
        }
        if (widgetContext.showlegend && (widgetContext.type === 'Donut' || widgetContext.type === 'Pie')) {
            if (widgetContext.showlegend === 'right') {
                chart.legendPosition('right');
            }
        }
        return chart;
    };
    var postPlotChartProcess = function (widgetContext, isPreview) {
        var id = isPreview ? null : widgetContext.$id;
        // If user sets to highlight the data points and increase the thickness of the line
        if (isLineTypeChart(widgetContext.type)) {
            setLineThickness(id, widgetContext.linethickness);
            highlightPoints(id, widgetContext.highlightpoints);
        }
        // Modifying the legend position only when legend is shown
        if (widgetContext.showlegend) {
            modifyLegendPosition(widgetContext, widgetContext.showlegend, id);
        }
    };
    var getDateList = function () { return dateList; };

    var WIDGET_CONFIG = { widgetType: 'wm-chart', hostClass: 'app-chart' };
    var options = {
        'Bubble': ['bubblesize', 'shape']
    }, NONE = 'none', advanceDataProps = ['aggregation', 'aggregationcolumn', 'groupby', 'orderby'], 
    // XPaths to get actual data of data points in charts
    chartDataPointXpath = {
        'Column': 'rect.nv-bar',
        'Bar': 'g.nv-bar',
        'Area': '.nv-stackedarea .nv-point',
        'Cumulative Line': '.nv-cumulativeLine .nv-scatterWrap path.nv-point',
        'Line': '.nv-lineChart .nv-scatterWrap path.nv-point',
        'Pie': '.nv-pieChart .nv-slice path',
        'Donut': '.nv-pieChart .nv-slice path',
        'Bubble': '.nv-scatterChart .nv-point-paths path'
    }, 
    // all properties of the chart
    allOptions = ['bubblesize', 'shape'], styleProps = {
        'fontunit': 'font-size',
        'fontsize': 'font-size',
        'color': 'fill',
        'fontfamily': 'font-family',
        'fontweight': 'font-weight',
        'fontstyle': 'font-style',
        'textdecoration': 'text-decoration'
    }, 
    // Getting the relevant aggregation function based on the selected option
    aggregationFnMap = {
        'average': 'AVG',
        'count': 'COUNT',
        'maximum': 'MAX',
        'minimum': 'MIN',
        'sum': 'SUM'
    };
    var getBooleanValue = function (val) {
        if (val === true || val === 'true') {
            return true;
        }
        if (val === false || val === 'false') {
            return false;
        }
        return val;
    };
    var ɵ0 = getBooleanValue;
    // returns orderby columns and their orders in two separate arrays
    var getLodashOrderByFormat = function (orderby) {
        var columns;
        var orderByColumns = [], orders = [];
        _.forEach(_.split(orderby, ','), function (col) {
            columns = _.split(col, ':');
            orderByColumns.push(columns[0]);
            orders.push(columns[1]);
        });
        return {
            'columns': orderByColumns,
            'orders': orders
        };
    };
    var ɵ1 = getLodashOrderByFormat;
    // Replacing the '.' by the '$' because '.' is not supported in the alias names
    var getValidAliasName = function (aliasName) { return aliasName ? aliasName.replace(/\./g, '$') : null; };
    var ɵ2 = getValidAliasName;
    // Applying the font related styles for the chart
    var setTextStyle = function (properties, id) {
        var charttext = d3.select('#wmChart' + id + ' svg').selectAll('text');
        charttext.style(properties);
    };
    var ɵ3 = setTextStyle;
    var angle = function (d) {
        var a = (d.startAngle + d.endAngle) * 90 / Math.PI - 90;
        return a > 90 ? a - 180 : a;
    };
    var ɵ4 = angle;
    var ChartComponent = /** @class */ (function (_super) {
        __extends(ChartComponent, _super);
        function ChartComponent(inj, app) {
            var _this = _super.call(this, inj, WIDGET_CONFIG) || this;
            _this.app = app;
            _this.iconclass = '';
            _this.nonPrimaryColumns = [];
            _this.xDataKeyArr = [];
            _this.chartData = [];
            _this._processedData = [];
            _this._subsciptions = [];
            _this._plotChartProxy = _.debounce(_this.plotChartProxy.bind(_this), 100);
            _this.redraw = _this._plotChartProxy.bind(_this);
            base.styler(_this.nativeElement, _this, base.APPLY_STYLES_TYPE.CONTAINER, ['fontsize', 'fontunit', 'color', 'fontfamily', 'fontweight', 'fontstyle', 'textdecoration']);
            // generate unique id for the component
            _this.$id = _this.widgetId || Math.random();
            // remove title attribute as the element on hover shows you the hint through-out the element
            core$1.removeAttr(_this.nativeElement, 'title');
            _this.chartReady = false;
            _this.binddataset = _this.nativeElement.getAttribute('dataset.bind');
            // Show loading status based on the variable life cycle
            _this._subsciptions.push(_this.app.subscribe('toggle-variable-state', _this.handleLoading.bind(_this)));
            // Will hide tolltip of a chart in mobile when the user scrolls.
            _this._subsciptions.push(_this.app.subscribe('iscroll-start', function () { d3.selectAll('.nvtooltip').style('opacity', 0); }));
            return _this;
        }
        ChartComponent_1 = ChartComponent;
        ChartComponent.prototype.isGroupByEnabled = function () {
            return !!(this.groupby && this.groupby !== NONE);
        };
        // Check if x and y axis that are chosen are valid to plot chart
        ChartComponent.prototype.isValidAxis = function () {
            // Check if x axis and y axis are chosen and are not equal
            return this.binddataset ? (this.xaxisdatakey && this.yaxisdatakey) : true;
        };
        // Check if aggregation is chosen
        ChartComponent.prototype.isAggregationEnabled = function () {
            return !!((this.isGroupByEnabled() && this.aggregation !== NONE && this.aggregationcolumn));
        };
        // Check if either groupby, aggregation or orderby is chosen
        ChartComponent.prototype.isDataFilteringEnabled = function () {
            /*Query need to be triggered if any of the following cases satisfy
            * 1. Group By and aggregation both chosen
            * 2. Only Order By is chosen
            * */
            return this.isAggregationEnabled() || (!this.isVisuallyGrouped && this.orderby);
        };
        /*Charts like Line,Area,Cumulative Line does not support any other datatype
            other than integer unlike the column and bar.It is a nvd3 issue. Inorder to
            support that this is a fix*/
        ChartComponent.prototype.getxAxisVal = function (dataObj, xKey, index) {
            var value = _.get(dataObj, xKey);
            // If x axis is other than number type then add indexes
            if (isLineTypeChart(this.type) && !core$1.isNumberType(this.xAxisDataType)) {
                // Verification to get the unique data keys
                this.xDataKeyArr.push(value);
                return index;
            }
            return value;
        };
        // Getting the min and max values among all the x values
        ChartComponent.prototype.getXMinMaxValues = function (datum) {
            if (!datum) {
                return;
            }
            var xValues = {};
            /*
             compute the min x value
             eg: When data has objects
                input: [{x:1, y:2}, {x:2, y:3}, {x:3, y:4}]
                min x: 1
             eg: When data has arrays
                input: [[10, 20], [20, 30], [30, 40]];
                min x: 10
            */
            xValues.min = _.minBy(datum.values, function (dataObject) { return dataObject.x || dataObject[0]; });
            /*
             compute the max x value
             eg: When data has objects
                input: [{x:1, y:2}, {x:2, y:3}, {x:3, y:4}]
                max x: 3
             eg: When data has arrays
                input: [[10, 20], [20, 30], [30, 40]];
                max x: 30
             */
            xValues.max = _.maxBy(datum.values, function (dataObject) { return dataObject.x || dataObject[0]; });
            return xValues;
        };
        // Getting the min and max values among all the y values
        ChartComponent.prototype.getYMinMaxValues = function (datum) {
            var yValues = {}, minValues = [], maxValues = [];
            if (!datum) {
                return;
            }
            /*
             Getting the min and max y values among all the series of data
             compute the min y value
             eg: When data has objects
                input: [[{x:1, y:2}, {x:2, y:3}, {x:3, y:4}], [{x:2, y:3}, {x:3, y:4}, {x:4, y:5}]]
                min y values : '2'(among first set) & '3'(among second set)
                max y values : '4'(among first set) & '5'(among second set)

             eg: When data has arrays
                input: [[[10, 20], [20, 30], [30, 40]], [[20, 30], [30, 40], [40, 50]]]
                min y values : '20'(among first set) & '30'(among second set)
                max y values : '40'(among first set) & '50'(among second set)
             */
            _.forEach(datum, function (data) {
                minValues.push(_.minBy(data.values, function (dataObject) { return dataObject.y || dataObject[1]; }));
                maxValues.push(_.maxBy(data.values, function (dataObject) { return dataObject.y || dataObject[1]; }));
            });
            // Gets the least and highest values among all the min and max values of respective series of data
            yValues.min = _.minBy(minValues, function (dataObject) { return dataObject.y || dataObject[1]; });
            yValues.max = _.maxBy(maxValues, function (dataObject) { return dataObject.y || dataObject[1]; });
            return yValues;
        };
        // If the x-axis values are undefined, we return empty array else we return the values
        ChartComponent.prototype.getValidData = function (values) {
            return (values.length === 1 && values[0] === undefined) ? [] : values;
        };
        // Returns the single data point based on the type of the data chart accepts
        ChartComponent.prototype.valueFinder = function (dataObj, xKey, yKey, index, shape) {
            var xVal = this.getxAxisVal(dataObj, xKey, index), value = _.get(dataObj, yKey), yVal = parseFloat(value) || value, size = parseFloat(dataObj[this.bubblesize]) || 2;
            var dataPoint = {};
            if (isChartDataJSON(this.type)) {
                dataPoint.x = xVal;
                dataPoint.y = yVal;
                // only Bubble chart has the third dimension
                if (isBubbleChart(this.type)) {
                    dataPoint.size = size;
                    dataPoint.shape = shape || 'circle';
                }
            }
            else if (isChartDataArray(this.type)) {
                dataPoint = [xVal, yVal];
            }
            // Adding actual unwrapped data to chart data to use at the time of selected data point of chart event
            dataPoint._dataObj = dataObj;
            return dataPoint;
        };
        // Setting appropriate error messages
        ChartComponent.prototype.setErrMsg = function (message) {
            if (this.showNoDataMsg) {
                this.showContentLoadError = true;
                this.invalidConfig = true;
                // TODO: Set the locale from the message
                this.errMsg = ''; // $rootScope.locale[message];
            }
        };
        ChartComponent.prototype.processChartData = function () {
            var _this = this;
            this.sampleData = getSampleData(this);
            // scope variables used to keep the actual key values for x-axis
            this.xDataKeyArr = [];
            // Plotting the chart with sample data when the chart dataset is not bound
            if (!this.binddataset) {
                this.xDataKeyArr = getDateList();
                return this.sampleData;
            }
            if (!this.chartData || !this.chartData.length) {
                return [];
            }
            var datum = [], yAxisKey, shapes = [], values = [];
            var xAxisKey = this.xaxisdatakey, yAxisKeys = this.yaxisdatakey ? this.yaxisdatakey.split(',') : [], dataSet = this.chartData;
            if (_.isArray(dataSet)) {
                if (isPieType(this.type)) {
                    yAxisKey = yAxisKeys[0];
                    datum = _.map(dataSet, function (dataObj, index) {
                        if (!core$1.isEmptyObject(dataSet[index])) {
                            return _this.valueFinder(dataSet[index], xAxisKey, yAxisKey);
                        }
                    });
                    datum = this.getValidData(datum);
                }
                else {
                    if (isBubbleChart(this.type)) {
                        shapes = this.shape === 'random' ? allShapes : this.shape;
                    }
                    yAxisKeys.forEach(function (yAxisKey, series) {
                        values = _.map(dataSet, function (dataObj, index) {
                            if (!core$1.isEmptyObject(dataSet[index])) {
                                return _this.valueFinder(dataSet[index], xAxisKey, yAxisKey, index, (_.isArray(shapes) && shapes[series]) || _this.shape);
                            }
                        });
                        values = _this.getValidData(values);
                        datum.push({
                            values: values,
                            key: core$1.prettifyLabels(yAxisKey)
                        });
                    });
                }
            }
            return datum;
        };
        ChartComponent.prototype.setChartData = function (data) {
            if (data) {
                this._processedData = data;
            }
        };
        ChartComponent.prototype.getChartData = function () {
            return this._processedData;
        };
        // constructing the grouped data based on the selection of orderby, x & y axis
        ChartComponent.prototype.getVisuallyGroupedData = function (queryResponse, groupingColumn) {
            var _this = this;
            var groupData = {}, groupValues = [], orderByDetails, maxLength;
            var chartData = [], _isAreaChart = isAreaChart(this.type), yAxisKey = _.first(_.split(this.yaxisdatakey, ','));
            this.xDataKeyArr = [];
            queryResponse = _.orderBy(queryResponse, _.split(this.groupby, ','));
            if (this.orderby) {
                orderByDetails = getLodashOrderByFormat(this.orderby);
                queryResponse = _.orderBy(queryResponse, orderByDetails.columns, orderByDetails.orders);
            }
            queryResponse = _.groupBy(queryResponse, groupingColumn);
            // In case of area chart all the series data should be of same length
            if (_isAreaChart) {
                maxLength = _.max(_.map(queryResponse, function (obj) { return obj.length; }));
            }
            _.forEach(queryResponse, function (values, groupKey) {
                groupValues = isAreaChart ? _.fill(new Array(maxLength), [0, 0]) : [];
                _.forEachRight(values, function (value, index) {
                    groupValues[index] = _this.valueFinder(value, _this.xaxisdatakey, yAxisKey, index);
                });
                groupData = {
                    key: groupKey,
                    values: groupValues
                };
                chartData.push(groupData);
            });
            return chartData;
        };
        /*Decides whether the data should be visually grouped or not
                Visually grouped when a different column is choosen in the group by other than x and y axis and aggregation is not chosen*/
        ChartComponent.prototype.getGroupingDetails = function () {
            var _this = this;
            if (this.isGroupByEnabled() && !this.isAggregationEnabled()) {
                var isVisuallyGrouped_1 = false, visualGroupingColumn_1, groupingExpression = void 0, columns_1 = [], groupingColumnIndex_1;
                var groupbyColumns_1 = this.groupby && this.groupby !== NONE ? this.groupby.split(',') : [], yAxisKeys_1 = this.yaxisdatakey ? this.yaxisdatakey.split(',') : [];
                if (groupbyColumns_1.length > 1) {
                    /*Getting the group by column which is not selected either in x or y axis*/
                    groupbyColumns_1.every(function (column, index) {
                        if (_this.xaxisdatakey !== column && $.inArray(column, yAxisKeys_1) === -1) {
                            isVisuallyGrouped_1 = true;
                            visualGroupingColumn_1 = column;
                            groupingColumnIndex_1 = index;
                            groupbyColumns_1.splice(groupingColumnIndex_1, 1);
                            return false;
                        }
                        return true;
                    });
                    // Constructing the groupby expression
                    if (visualGroupingColumn_1) {
                        columns_1.push(visualGroupingColumn_1);
                    }
                    if (groupbyColumns_1.length) {
                        columns_1 = _.concat(columns_1, groupbyColumns_1);
                    }
                }
                // If x and y axis are not included in aggregation need to be included in groupby
                if (this.xaxisdatakey !== this.aggregationcolumn) {
                    columns_1.push(this.xaxisdatakey);
                }
                _.forEach(yAxisKeys_1, function (key) {
                    if (key !== _this.aggregationcolumn) {
                        columns_1.push(key);
                    }
                });
                groupingExpression = columns_1.join(',');
                // set isVisuallyGrouped flag in scope for later use
                this.isVisuallyGrouped = isVisuallyGrouped_1;
                return {
                    expression: groupingExpression,
                    isVisuallyGrouped: isVisuallyGrouped_1,
                    visualGroupingColumn: visualGroupingColumn_1
                };
            }
            return {
                expression: '',
                isVisuallyGrouped: false,
                visualGroupingColumn: ''
            };
        };
        // Function to get the aggregated data after applying the aggregation & group by or order by operations.
        ChartComponent.prototype.getAggregatedData = function (callback) {
            var _this = this;
            var variable = this.datasource, yAxisKeys = this.yaxisdatakey ? this.yaxisdatakey.split(',') : [], data = {};
            var sortExpr, columns = [], colAlias, orderByColumns, groupByFields = [];
            if (!variable) {
                return;
            }
            if (this.isGroupByEnabled()) {
                groupByFields = _.split(this.groupby, ',');
            }
            if (this.orderby) {
                sortExpr = _.replace(this.orderby, /:/g, ' ');
                columns = _.uniq(_.concat(columns, groupByFields, [this.aggregationcolumn]));
                orderByColumns = getLodashOrderByFormat(this.orderby).columns;
                // If the orderby column is chosen either in groupby or orderby then replace . with $ for that column
                _.forEach(_.intersection(columns, orderByColumns), function (col) {
                    colAlias = getValidAliasName(col);
                    sortExpr = _.replace(sortExpr, col, colAlias);
                });
            }
            if (this.isAggregationEnabled()) {
                // Send the group by in the aggregations api only if aggregation is also chosen
                data.groupByFields = groupByFields;
                data.aggregations = [
                    {
                        'field': this.aggregationcolumn,
                        'type': aggregationFnMap[this.aggregation],
                        'alias': getValidAliasName(this.aggregationcolumn)
                    }
                ];
            }
            // Execute the query.
            variable.execute('getAggregatedData', {
                'aggregations': data,
                'sort': sortExpr
            }).then(function (response) {
                // Transform the result into a format supported by the chart.
                var chartData = [], aggregationAlias = getValidAliasName(_this.aggregationcolumn), xAxisAliasKey = getValidAliasName(_this.xaxisdatakey), yAxisAliasKeys = [];
                yAxisKeys.forEach(function (yAxisKey) { return yAxisAliasKeys.push(getValidAliasName(yAxisKey)); });
                _.forEach(response.body.content, function (responseContent) {
                    var obj = {};
                    // Set the response in the chartData based on 'aggregationColumn', 'xAxisDataKey' & 'yAxisDataKey'.
                    if (_this.isAggregationEnabled()) {
                        obj[_this.aggregationcolumn] = responseContent[aggregationAlias];
                        obj[_this.aggregationcolumn] = _.get(responseContent, aggregationAlias) || _.get(responseContent, _this.aggregationcolumn);
                    }
                    obj[_this.xaxisdatakey] = _.get(responseContent, xAxisAliasKey) || _.get(responseContent, _this.xaxisdatakey);
                    yAxisKeys.forEach(function (yAxisKey, index) {
                        obj[yAxisKey] = responseContent[yAxisAliasKeys[index]];
                        obj[yAxisKey] = _.get(responseContent, yAxisAliasKeys[index]) || _.get(responseContent, yAxisKey);
                    });
                    chartData.push(obj);
                });
                _this.chartData = chartData;
                core$1.triggerFn(callback);
            }, function () {
                _this.chartData = [];
                _this.setErrMsg('MESSAGE_ERROR_FETCH_DATA');
                core$1.triggerFn(callback);
            });
        };
        // This function sets maximum width for the labels that can be displayed.This will helpful when they are overlapping
        ChartComponent.prototype.setLabelsMaxWidth = function () {
            var xTicks, tickWidth, maxLength, xDist, yDist, totalHeight, maxNoLabels, nthElement, labelsAvailableWidth, barWrapper, yAxisWrapper, svgWrapper;
            var fontsize = parseInt(this.fontsize, 10) || 12, isBarchart = isBarChart(this.type);
            // getting the x ticks in the chart
            xTicks = $('#wmChart' + this.$id + ' svg').find('g.nv-x').find('g.tick').find('text');
            // getting the distance between the two visible ticks associated with visible text
            xTicks.each(function () {
                var xTick = $(this);
                var xTransform, tickDist;
                if (xTick.text() && xTick.css('opacity') === '1') {
                    xTransform = xTick.parent().attr('transform').split(',');
                    xDist = parseFloat(xTransform[0].substr(10));
                    yDist = parseFloat(xTransform[1] || '0');
                    if (!isBarchart && xDist > 0) {
                        tickDist = xDist;
                    }
                    else if (yDist > 0) {
                        tickDist = yDist;
                    }
                    if (tickWidth) {
                        tickWidth = tickDist - tickWidth;
                        return false;
                    }
                    tickWidth = tickDist;
                    return true;
                }
            });
            // In case of bar chart getting the available space for the labels to be displayed
            if (isBarchart) {
                barWrapper = $('#wmChart' + this.$id + ' svg>g.nv-wrap>g>g.nv-barsWrap')[0];
                yAxisWrapper = $('#wmChart' + this.$id + ' svg>g.nv-wrap>g>g.nv-y')[0];
                svgWrapper = $('#wmChart' + this.$id + ' svg')[0];
                // getting the total height of the chart
                totalHeight = barWrapper ? barWrapper.getBoundingClientRect().height : 0;
                // getting the labels available space
                labelsAvailableWidth = yAxisWrapper ? svgWrapper.getBoundingClientRect().width - yAxisWrapper.getBoundingClientRect().width : svgWrapper.getBoundingClientRect().width;
                // Setting the max length for the label
                maxLength = Math.round(labelsAvailableWidth / fontsize);
                // if available space for each label is less than the font-size
                // then limiting the labels to be displayed
                if (tickWidth < fontsize) {
                    // calculate the maximum no of labels to be fitted
                    maxNoLabels = totalHeight / fontsize;
                    // showing only the nth element
                    nthElement = Math.ceil(this.chartData.length / maxNoLabels);
                    // showing up only some labels
                    d3.select('#wmChart' + this.$id + ' svg').select('g.nv-x').selectAll('g.tick').select('text').each(function (text, i) {
                        // hiding every non nth element
                        if (i % nthElement !== 0) {
                            d3.select(this).attr('opacity', 0);
                        }
                    });
                }
            }
            else {
                // Setting the max length for the label
                maxLength = Math.round(tickWidth / fontsize);
            }
            // maxLength should always be a positive number
            maxLength = Math.abs(maxLength);
            // Validating if every label exceeds the max length and if so limiting the length and adding ellipsis
            xTicks.each(function () {
                if (this.textContent.length > maxLength) {
                    this.textContent = this.textContent.substr(0, maxLength) + '...';
                }
            });
        };
        // Returns the columns of that can be choosen in the x and y axis
        ChartComponent.prototype.getDefaultColumns = function () {
            var type, stringColumn, i, temp;
            var defaultColumns = [], columns = this.datasource.execute(core$1.DataSource.Operation.GET_PROPERTIES_MAP) || [];
            for (i = 0; i < columns.length && defaultColumns.length <= 2; i += 1) {
                type = columns[i].type;
                if (!columns[i].isRelated && (core$1.isNumberType(type))) {
                    defaultColumns.push(columns[i].fieldName);
                }
                else if (type === 'string' && !stringColumn) {
                    stringColumn = columns[i].fieldName;
                }
            }
            // Other than bubble chart x: string type y: number type
            // Bubble chart x: number type y: number type
            if (stringColumn && defaultColumns.length > 0 && !isBubbleChart(this.type)) {
                temp = defaultColumns[0];
                defaultColumns[0] = stringColumn;
                defaultColumns[1] = temp;
            }
            return defaultColumns;
        };
        // Call user defined javascript function when user links it to click event of the widget.
        ChartComponent.prototype.attachClickEvent = function () {
            var _this = this;
            var dataObj;
            d3.select('#wmChart' + this.$id + ' svg').selectAll(chartDataPointXpath[this.type]).style('pointer-events', 'all')
                .on('click', function (data, index) {
                switch (_this.type) {
                    case 'Column':
                    case 'Bar':
                        dataObj = data._dataObj;
                        break;
                    case 'Pie':
                    case 'Donut':
                        dataObj = data.data._dataObj;
                        break;
                    case 'Area':
                    case 'Cumulative Line':
                    case 'Line':
                        dataObj = data[0]._dataObj;
                        break;
                    case 'Bubble':
                        dataObj = data.data.point[4]._dataObj;
                        break;
                }
                _this.selecteditem = dataObj;
                _this.invokeEventCallback('select', { $event: d3.event, selectedChartItem: data, selectedItem: _this.selecteditem });
            });
        };
        /*  Returns Y Scale min value
               Ex: Input   : 8.97
                   Output  : 8.87

                   Input   : 8
                   Output  : 7
           */
        ChartComponent.prototype.postPlotProcess = function (chart) {
            var _this = this;
            var chartSvg, pieLabels, pieGroups, angleArray;
            var styleObj = {};
            var element = this.$element;
            postPlotChartProcess(this);
            if (!isPieType(this.type)) {
                this.setLabelsMaxWidth();
            }
            else if (!this.showlabelsoutside) {
                /** Nvd3 has a issue in rotating text. So we will use this as a temp fix.
                 * If the issue is resolved there, we can remove this.*/
                /* If it is a donut chart, then rotate the text and position them*/
                chartSvg = d3.select('#wmChart' + this.$id + ' svg');
                pieLabels = chartSvg.select('.nv-pieLabels').selectAll('.nv-label');
                pieGroups = chartSvg.select('.nv-pie').selectAll('.nv-slice');
                angleArray = [];
                if (pieGroups && pieGroups.length) {
                    pieGroups.each(function () {
                        d3.select(this).attr('transform', function (d) {
                            angleArray.push(angle(d));
                        });
                    });
                    pieLabels.each(function (d, i) {
                        var group = d3.select(this);
                        $(group[0][0]).find('text').attr('transform', 'rotate(' + angleArray[i] + ')');
                    });
                }
            }
            // prepare text style props object and set
            _.forEach(styleProps, function (value, key) {
                if (key === 'fontsize' || key === 'fontunit') {
                    styleObj[value] = _this.fontsize + _this.fontunit;
                }
                else {
                    styleObj[value] = _this[key];
                }
            });
            setTextStyle(styleObj, this.$id);
            /*
             * allow window-resize functionality, for only-run mode as
             * updating chart is being handled by watchers of height & width in studio-mode
             * */
            core$1.triggerFn(this._resizeFn && this._resizeFn.clear);
            this._resizeFn = nv.utils.windowResize(function () {
                if (element[0].getBoundingClientRect().height) {
                    chart.update();
                    postPlotChartProcess(_this);
                    if (!isPieType(_this.type)) {
                        _this.setLabelsMaxWidth();
                    }
                }
                else {
                    // TODO: get parents of accordion type
                    /*let parent = element.closest('.app-accordion-panel, .tab-pane').isolateScope();
                    if (parent) {
                        parent.initialized = false;
                    }*/
                }
            });
        };
        // prepares and configures the chart properties
        ChartComponent.prototype.configureChart = function () {
            // Copy the data only in case of pie chart with default data
            // Reason : when multiple pie charts are bound to same data, first chart theme will be applied to all charts
            var xDomainValues;
            var yDomainValues;
            var chart;
            var beforeRenderVal;
            var yformatOptions = {};
            if (this._processedData.length > 0) {
                if (isAxisDomainValid(this, 'x')) {
                    xDomainValues = this.binddataset ? this.getXMinMaxValues(this._processedData[0]) : { 'min': { 'x': 1 }, 'max': { 'x': 5 } };
                }
                if (isAxisDomainValid(this, 'y')) {
                    yDomainValues = this.binddataset ? this.getYMinMaxValues(this._processedData) : { 'min': { 'y': 1 }, 'max': { 'y': 5 } };
                }
            }
            if (isPieType(this.type) && (!this.binddataset || !this.scopedataset)) {
                this._processedData = core$1.getClonedObject(this.scopedataset || this._processedData);
            }
            // get the chart object
            chart = initChart(this, xDomainValues, yDomainValues, null, !this.binddataset);
            if (_.isArray(this._processedData)) {
                // WMS-19499:  To remove chart X-axis old ticks when chart data loaded dynamically.
                var oldgTicks = $('#wmChart' + this.$id + ' svg').find('g.nv-x').find('g.tick');
                if (oldgTicks && oldgTicks.length) {
                    oldgTicks.remove();
                }
                beforeRenderVal = this.invokeEventCallback('beforerender', { 'chartInstance': chart });
                if (beforeRenderVal) {
                    chart = beforeRenderVal;
                }
                this.chart = chart;
                // changing the default no data message
                d3.select('#wmChart' + this.$id + ' svg')
                    .datum(this._processedData)
                    .call(this.chart);
                this.postPlotProcess(chart);
                return chart;
            }
        };
        // Plotting the chart with set of the properties set to it
        ChartComponent.prototype.plotChart = function () {
            var _this = this;
            var element = this.$element;
            // call user-transformed function
            this.chartData = (this.invokeEventCallback('transform')) || this.chartData;
            // Getting the order by data only in run mode. The order by applies for all the charts other than pie and donut charts
            if (this.isVisuallyGrouped && !isPieType(this.type)) {
                this._processedData = this.chartData;
            }
            else {
                this._processedData = this.processChartData();
            }
            // checking the parent container before plotting the chart
            if (!element[0].getBoundingClientRect().height) {
                return;
            }
            if (this.clearCanvas) {
                // empty svg to add-new chart
                element.find('svg').replaceWith('<svg></svg>');
                this.clearCanvas = false;
            }
            // In case of invalid axis show no data available message
            if (!this.isValidAxis()) {
                this._processedData = [];
            }
            nv.addGraph(function () { return _this.configureChart(); }, function () {
                /*Bubble chart has an time out delay of 300ms in their implementation due to which we
                * won't be getting required data points on attaching events
                * hence delaying it 600ms*/
                setTimeout(function () {
                    _this.attachClickEvent();
                }, 600);
            });
            this.isLoadInProgress = false;
        };
        Object.defineProperty(ChartComponent.prototype, "isLiveVariable", {
            // TODO: Need way to figure out if the datasource is a live source
            get: function () {
                // setting the flag for the live variable in the scope for the checks
                var variableObj = this.datasource;
                return variableObj && variableObj.category === 'wm.LiveVariable';
            },
            enumerable: true,
            configurable: true
        });
        ChartComponent.prototype.plotChartProxy = function () {
            var _this = this;
            this.showContentLoadError = false;
            this.invalidConfig = false;
            // Checking if x and y axis are chosen
            this.isLoadInProgress = true;
            var groupingDetails = this.getGroupingDetails();
            // If aggregation/group by/order by properties have been set, then get the aggregated data and plot the result in the chart.
            // TODO: datasource for live variable detection
            if (this.binddataset && this.isLiveVariable && (this.filterFields || this.isDataFilteringEnabled())) {
                this.getAggregatedData(function () { return _this.plotChart(); });
            }
            else { // Else, simply plot the chart.
                // In case of live variable resetting the aggregated data to the normal dataset when the aggregation has been removed
                if (this.dataset && this.isLiveVariable) {
                    this.chartData = this.dataset;
                    if (this.isGroupByEnabled() && groupingDetails.isVisuallyGrouped) {
                        this.chartData = this.getVisuallyGroupedData(this.chartData, groupingDetails.visualGroupingColumn);
                    }
                }
                this.plotChart();
            }
        };
        // sets the default x and y axis options
        ChartComponent.prototype.setDefaultAxisOptions = function () {
            var defaultColumns = this.getDefaultColumns();
            // If we get the valid default columns then assign them as the x and y axis
            // In case of service variable we may not get the valid columns because we cannot know the datatypes
            this.xaxisdatakey = defaultColumns[0] || null;
            this.yaxisdatakey = defaultColumns[1] || null;
        };
        ChartComponent.prototype.getCutomizedOptions = function (prop, fields) {
            var groupByColumns = _.split(this.groupby, ','), aggColumns = _.split(this.aggregationcolumn, ',');
            if (!this.binddataset) {
                return fields;
            }
            if (!this.axisoptions) {
                this.axisoptions = fields;
            }
            var newOptions;
            switch (prop) {
                case 'xaxisdatakey':
                    // If group by enabled, columns chosen in groupby will be populated in x axis options
                    if (this.isGroupByEnabled()) {
                        newOptions = groupByColumns;
                    }
                    break;
                case 'yaxisdatakey':
                    // If aggregation by enabled, columns chosen in aggregation will be populated in y axis options
                    if (this.isAggregationEnabled()) {
                        newOptions = aggColumns;
                    }
                    else if (this.isLiveVariable) {
                        // In case of live variable populating only numeric columns
                        newOptions = this.numericColumns;
                    }
                    break;
                case 'groupby':
                    // Filtering only non primary key columns
                    if (this.isLiveVariable && this.nonPrimaryColumns && this.nonPrimaryColumns.length) {
                        newOptions = this.nonPrimaryColumns;
                    }
                    break;
                case 'aggregationcolumn':
                    // Set the 'aggregationColumn' to show all keys in case of aggregation function is count or to numeric keys in all other cases.
                    if (this.isLiveVariable && this.isAggregationEnabled() && this.aggregation !== 'count') {
                        newOptions = this.numericColumns;
                    }
                    break;
                case 'orderby':
                    // Set the 'aggregationColumn' to show all keys in case of aggregation function is count or to numeric keys in all other cases.
                    if (this.isLiveVariable && this.isAggregationEnabled()) {
                        newOptions = _.uniq(_.concat(groupByColumns, aggColumns));
                    }
                    break;
                case 'bubblesize':
                    if (this.numericColumns && this.numericColumns.length) {
                        newOptions = this.numericColumns;
                    }
                    break;
            }
            return newOptions || fields || this.axisoptions;
        };
        // Function that iterates through all the columns and then fetching the numeric and non primary columns among them
        ChartComponent.prototype.setNumericandNonPrimaryColumns = function () {
            var _this = this;
            var columns, type;
            var propertiesMap = this.datasource.execute(core$1.DataSource.Operation.GET_PROPERTIES_MAP);
            this.numericColumns = [];
            this.nonPrimaryColumns = [];
            // Fetching all the columns
            if (this.dataset && !_.isEmpty(propertiesMap)) {
                columns = []; // TODO: fetchPropertiesMapColumns(propertiesMap);
            }
            if (columns) {
                // Iterating through all the columns and fetching the numeric and non primary key columns
                _.forEach(Object.keys(columns), function (key) {
                    type = columns[key].type;
                    if (core$1.isNumberType(type)) {
                        _this.numericColumns.push(key);
                    }
                    // Hiding only table's primary key
                    if (columns[key].isRelatedPk === 'true' || !columns[key].isPrimaryKey) {
                        _this.nonPrimaryColumns.push(key);
                    }
                });
                this.numericColumns = this.numericColumns.sort();
                this.nonPrimaryColumns = this.nonPrimaryColumns.sort();
            }
        };
        // plot the chart
        ChartComponent.prototype.handleDataSet = function (newVal) {
            this.errMsg = '';
            // Resetting the flag to false when the binding was removed
            if (!newVal && !this.binddataset) {
                this.isVisuallyGrouped = false;
                this.axisoptions = null;
            }
            // liveVariables contain data in 'data' property' of the variable
            this.chartData = this.isLiveVariable ? newVal || '' : (newVal && newVal.dataValue === '' && _.keys(newVal).length === 1) ? '' : newVal;
            // if the data returned is an object make it an array of object
            if (!_.isArray(this.chartData) && _.isObject(this.chartData)) {
                this.chartData = [this.chartData];
            }
            if (newVal && newVal.filterFields) {
                this.filterFields = newVal.filterFields;
            }
            // plotchart for only valid data and only after bound variable returns data
            if (this.chartData) {
                this._plotChartProxy();
            }
        };
        ChartComponent.prototype.onPropertyChange = function (key, newVal, oldVal) {
            _super.prototype.onPropertyChange.call(this, key, newVal, oldVal);
            switch (key) {
                case 'dataset':
                    this.handleDataSet(newVal);
                    break;
                case 'type':
                    // Based on the change in type deciding the default margins
                    if (isPieType(this.type)) {
                        this.offsettop = 20;
                        this.offsetright = 0;
                        this.offsetbottom = 0;
                        this.offsetleft = 0;
                    }
                    else if (oldVal === 'Pie' || oldVal === 'Donut') {
                        this.offsettop = 25;
                        this.offsetright = 25;
                        this.offsetbottom = 55;
                        this.offsetleft = 75;
                    }
                    if (oldVal !== newVal) {
                        this.clearCanvas = true;
                    }
                    // In studio mode, configure properties dependent on chart type
                    this._plotChartProxy();
                    break;
                default:
                    // In RunMode, the plotchart method will not be called for all property change
                    this._plotChartProxy();
                    break;
            }
            if (_.includes(advanceDataProps, key)) {
                this._plotChartProxy();
            }
        };
        ChartComponent.prototype.handleLoading = function (data) {
            var dataSource = this.datasource;
            if (dataSource && dataSource.execute(core$1.DataSource.Operation.IS_API_AWARE) && core$1.isDataSourceEqual(data.variable, dataSource)) {
                this.variableInflight = data.active;
                this.isLoadInProgress = data.active;
            }
        };
        ChartComponent.prototype.onStyleChange = function (key, newVal, oldVal) {
            var styleObj = {};
            _super.prototype.onStyleChange.call(this, key, newVal, oldVal);
            switch (key) {
                case 'fontsize':
                case 'fontunit':
                case 'color':
                case 'fontfamily':
                case 'fontweight':
                case 'fontstyle':
                case 'textdecoration':
                    styleObj[styleProps[key]] = (key === 'fontsize' || key === 'fontunit') ? this.fontsize + this.fontunit : newVal;
                    setTextStyle(styleObj, this.$id);
                    break;
            }
        };
        ChartComponent.prototype.ngAfterViewInit = function () {
            _super.prototype.ngAfterViewInit.call(this);
            // For old projects
            if (!_.includes(['outside', 'inside', 'hide'], this.showlabels)) {
                this.showlabels = getBooleanValue(this.showlabels);
                this.showlabelsoutside = getBooleanValue(this.showlabelsoutside);
                this.showlabels = this.showlabels ? (this.showlabelsoutside ? 'outside' : 'inside') : 'hide';
            }
            if (!this.theme) {
                // Default theme for pie/donut is Azure and for other it is Terrestrial
                this.theme = isPieType(this.type) ? 'Azure' : 'Terrestrial';
            }
            this.nativeElement.setAttribute('id', 'wmChart' + this.$id);
            // When there is not value binding, then plot the chart with sample data
            if (!this.binddataset && !this.nativeElement.getAttribute('scopedataset')) {
                this._plotChartProxy();
            }
        };
        ChartComponent.prototype.ngOnDestroy = function () {
            // destroy all subscriptions to prevent memory leak.
            this._subsciptions.forEach(function (subscription) {
                subscription();
            });
            _super.prototype.ngOnDestroy.call(this);
        };
        var ChartComponent_1;
        ChartComponent.initializeProps = registerProps();
        ChartComponent.ctorParameters = function () { return [
            { type: core.Injector },
            { type: core$1.App }
        ]; };
        __decorate([
            core.HostBinding('class.panel'),
            __metadata("design:type", Object)
        ], ChartComponent.prototype, "title", void 0);
        ChartComponent = ChartComponent_1 = __decorate([
            core.Component({
                selector: 'div[wmChart]',
                template: "<div class=\"panel-heading\" *ngIf=\"title\">\n    <h3 class=\"panel-title\">\n        <div class=\"pull-left\"><i class=\"app-icon panel-icon {{iconclass}}\" [class.ng-hide]=\"!iconclass\"></i></div>\n        <div class=\"heading\" [innerHTML]=\"title | trustAs: 'html'\"></div>\n        <div class=\"description\" *ngIf=\"subheading\" [innerHTML]=\"subheading | trustAs: 'html'\"></div>\n    </h3>\n</div>\n<div class=\"app-chart-inner\" [ngClass]=\"{'loading':isLoadInProgress, 'panel-body': title}\">\n    <svg></svg>\n    <div class=\"wm-content-info readonly-wrapper\" *ngIf=\"showContentLoadError && showNoDataMsg\">\n        <p class=\"wm-message\" [title]=\"hintMsg\" [ngClass]=\"{'error': invalidConfig}\" [innerText]=\"errMsg\"></p>\n    </div>\n    <div wmSpinner show.bind=\"isLoadInProgress\" caption.bind=\"loadingdatamsg\"></div>\n</div>",
                providers: [
                    base.provideAsWidgetRef(ChartComponent_1)
                ],
                encapsulation: core.ViewEncapsulation.None,
                styles: [".nvd3 .nv-axis line,.nvd3 .nv-axis path{fill:none;shape-rendering:crispEdges}.nv-brush .extent,.nvd3 .background path,.nvd3 .nv-axis line,.nvd3 .nv-axis path{shape-rendering:crispEdges}.nv-distx,.nv-disty,.nv-noninteractive,.nvd3 .nv-axis,.nvd3.nv-pie .nv-label,.nvd3.nv-sparklineplus g.nv-hoverValue{pointer-events:none}.nvd3 .nv-axis{opacity:1}.nvd3 .nv-axis.nv-disabled,.nvd3 .nv-controlsWrap .nv-legend .nv-check-box .nv-check{opacity:0}.nvd3 .nv-axis path{stroke:#000;stroke-opacity:.75}.nvd3 .nv-axis path.domain{stroke-opacity:.75}.nvd3 .nv-axis.nv-x path.domain{stroke-opacity:0}.nvd3 .nv-axis line{stroke:#e5e5e5}.nvd3 .nv-axis .zero line,.nvd3 .nv-axis line.zero{stroke-opacity:.75}.nvd3 .nv-axis .nv-axisMaxMin text{font-weight:700}.nvd3 .x .nv-axis .nv-axisMaxMin text,.nvd3 .x2 .nv-axis .nv-axisMaxMin text,.nvd3 .x3 .nv-axis .nv-axisMaxMin text{text-anchor:middle}.nvd3 .nv-bars rect{fill-opacity:.75;transition:fill-opacity 250ms linear}.nvd3 .nv-bars rect.hover{fill-opacity:1}.nvd3 .nv-bars .hover rect{fill:#add8e6}.nvd3 .nv-bars text{fill:transparent}.nvd3 .nv-bars .hover text{fill:#000}.nvd3 .nv-discretebar .nv-groups rect,.nvd3 .nv-multibar .nv-groups rect,.nvd3 .nv-multibarHorizontal .nv-groups rect{stroke-opacity:0;transition:fill-opacity 250ms linear}.with-transitions .nv-candlestickBar .nv-ticks .nv-tick,.with-transitions .nvd3 .nv-groups .nv-point{transition:stroke-width 250ms linear,stroke-opacity 250ms linear}.nvd3 .nv-candlestickBar .nv-ticks rect:hover,.nvd3 .nv-discretebar .nv-groups rect:hover,.nvd3 .nv-multibar .nv-groups rect:hover,.nvd3 .nv-multibarHorizontal .nv-groups rect:hover{fill-opacity:1}.nvd3 .nv-discretebar .nv-groups text,.nvd3 .nv-multibarHorizontal .nv-groups text{font-weight:700;fill:#000;stroke:transparent}.nvd3 .nv-boxplot circle{fill-opacity:.5}.nvd3 .nv-boxplot circle:hover,.nvd3 .nv-boxplot rect:hover{fill-opacity:1}.nvd3 line.nv-boxplot-median{stroke:#000}.nv-boxplot-tick:hover{stroke-width:2.5px}.nvd3.nv-bullet{font:10px sans-serif}.nvd3.nv-bullet .nv-measure{fill-opacity:.8}.nvd3.nv-bullet .nv-measure:hover{fill-opacity:1}.nvd3.nv-bullet .nv-marker{stroke:#000;stroke-width:2px}.nvd3.nv-bullet .nv-markerTriangle{stroke:#000;fill:#fff;stroke-width:1.5px}.nvd3.nv-bullet .nv-markerLine{stroke:#000;stroke-width:1.5px}.nvd3.nv-bullet .nv-tick line{stroke:#666;stroke-width:.5px}.nvd3.nv-bullet .nv-range.nv-s0{fill:#eee}.nvd3.nv-bullet .nv-range.nv-s1{fill:#ddd}.nvd3.nv-bullet .nv-range.nv-s2{fill:#ccc}.nvd3.nv-bullet .nv-title{font-size:14px;font-weight:700}.nvd3.nv-bullet .nv-subtitle{fill:#999}.nvd3.nv-bullet .nv-range{fill:#bababa;fill-opacity:.4}.nvd3.nv-bullet .nv-range:hover{fill-opacity:.7}.nvd3.nv-candlestickBar .nv-ticks .nv-tick{stroke-width:1px}.nvd3.nv-candlestickBar .nv-ticks .nv-tick.hover{stroke-width:2px}.nvd3.nv-candlestickBar .nv-ticks .nv-tick.positive rect{stroke:#2ca02c;fill:#2ca02c}.nvd3.nv-candlestickBar .nv-ticks .nv-tick.negative rect{stroke:#d62728;fill:#d62728}.nvd3.nv-candlestickBar .nv-ticks line{stroke:#333}.nv-force-node{stroke:#fff;stroke-width:1.5px}.nv-force-link{stroke:#999;stroke-opacity:.6}.nv-force-node text{stroke-width:0}.nvd3 .nv-check-box .nv-box{fill-opacity:0;stroke-width:2}.nvd3 .nv-check-box .nv-check{fill-opacity:0;stroke-width:4}.nvd3 .nv-series.nv-disabled .nv-check-box .nv-check{fill-opacity:0;stroke-opacity:0}.nvd3.nv-linePlusBar .nv-bar rect{fill-opacity:.75}.nvd3.nv-linePlusBar .nv-bar rect:hover{fill-opacity:1}.nvd3 .nv-groups path.nv-line{fill:none}.nvd3 .nv-groups path.nv-area{stroke:none}.nvd3.nv-line .nvd3.nv-scatter .nv-groups .nv-point{fill-opacity:0;stroke-opacity:0}.nvd3.nv-scatter.nv-single-point .nv-groups .nv-point{fill-opacity:.5!important;stroke-opacity:.5!important}.nvd3 .nv-groups .nv-point.hover,.nvd3.nv-scatter .nv-groups .nv-point.hover{stroke-width:7px;fill-opacity:.95!important;stroke-opacity:.95!important}.nvd3 .nv-point-paths path{stroke:#aaa;stroke-opacity:0;fill:#eee;fill-opacity:0}.nvd3 .nv-indexLine{cursor:ew-resize}svg.nvd3-svg{-webkit-user-select:none;-ms-user-select:none;-moz-user-select:none;user-select:none;display:block;width:100%;height:100%}.nvtooltip.with-3d-shadow,.with-3d-shadow .nvtooltip{box-shadow:0 5px 10px rgba(0,0,0,.2);border-radius:5px}.nvd3 text{font:400 12px Arial,sans-serif}.nvd3 .title{font:700 14px Arial,sans-serif}.nvd3 .nv-background{fill:#fff;fill-opacity:0}.nvd3.nv-noData{font-size:18px;font-weight:700}.nv-brush .extent{fill-opacity:.125}.nv-brush .resize path{fill:#eee;stroke:#666}.nvd3 .nv-legend .nv-series{cursor:pointer}.nvd3 .nv-legend .nv-disabled circle{fill-opacity:0}.nvd3 .nv-brush .extent{fill-opacity:0!important}.nvd3 .nv-brushBackground rect{stroke:#000;stroke-width:.4;fill:#fff;fill-opacity:.7}@media print{.nvd3 text{stroke-width:0;fill-opacity:1}}.nvd3.nv-ohlcBar .nv-ticks .nv-tick{stroke-width:1px}.nvd3.nv-ohlcBar .nv-ticks .nv-tick.hover{stroke-width:2px}.nvd3.nv-ohlcBar .nv-ticks .nv-tick.positive{stroke:#2ca02c}.nvd3.nv-ohlcBar .nv-ticks .nv-tick.negative{stroke:#d62728}.nvd3 .background path{fill:none;stroke:#eee;stroke-opacity:.4}.nvd3 .foreground path{fill:none;stroke-opacity:.7}.nvd3 .nv-parallelCoordinates-brush .extent{fill:#fff;fill-opacity:.6;stroke:gray;shape-rendering:crispEdges}.nvd3 .nv-parallelCoordinates .hover{fill-opacity:1;stroke-width:3px}.nvd3 .missingValuesline line{fill:none;stroke:#000;stroke-width:1;stroke-opacity:1;stroke-dasharray:5,5}.nvd3.nv-pie .nv-pie-title{font-size:24px;fill:rgba(19,196,249,.59)}.nvd3.nv-pie .nv-slice text{stroke:#000;stroke-width:0}.nvd3.nv-pie path{transition:fill-opacity 250ms linear,stroke-width 250ms linear,stroke-opacity 250ms linear;stroke:#fff;stroke-width:1px;stroke-opacity:1;fill-opacity:.7}.nvd3.nv-pie .hover path{fill-opacity:1}.nvd3.nv-pie .nv-label rect{fill-opacity:0;stroke-opacity:0}.nvd3 .nv-groups .nv-point.hover{stroke-width:20px;stroke-opacity:.5}.nvd3 .nv-scatter .nv-point.hover{fill-opacity:1}.nvd3.nv-sparkline path{fill:none}.nvd3.nv-sparklineplus .nv-hoverValue line{stroke:#333;stroke-width:1.5px}.nvd3.nv-sparklineplus,.nvd3.nv-sparklineplus g{pointer-events:all}.nvd3 .nv-interactiveGuideLine,.nvtooltip{pointer-events:none}.nvd3 .nv-hoverArea{fill-opacity:0;stroke-opacity:0}.nvd3.nv-sparklineplus .nv-xValue,.nvd3.nv-sparklineplus .nv-yValue{stroke-width:0;font-size:.9em;font-weight:400}.nvd3.nv-sparklineplus .nv-yValue{stroke:#f66}.nvd3.nv-sparklineplus .nv-maxValue{stroke:#2ca02c;fill:#2ca02c}.nvd3.nv-sparklineplus .nv-minValue{stroke:#d62728;fill:#d62728}.nvd3.nv-sparklineplus .nv-currentValue{font-weight:700;font-size:1.1em}.nvtooltip h3,.nvtooltip table td.key{font-weight:400}.nvd3.nv-stackedarea path.nv-area{fill-opacity:.7;stroke-opacity:0;transition:fill-opacity 250ms linear,stroke-opacity 250ms linear}.nvd3.nv-stackedarea path.nv-area.hover{fill-opacity:.9}.nvd3.nv-stackedarea .nv-groups .nv-point{stroke-opacity:0;fill-opacity:0}.nvtooltip{position:absolute;color:#000;padding:1px;z-index:10000;display:block;font-family:Arial,sans-serif;font-size:13px;text-align:left;white-space:nowrap;-webkit-user-select:none;-ms-user-select:none;-moz-user-select:none;user-select:none;background:rgba(255,255,255,.8);border:1px solid rgba(0,0,0,.5);border-radius:4px}.nvtooltip h3,.nvtooltip p{margin:0;text-align:center}.nvtooltip.with-transitions,.with-transitions .nvtooltip{transition:opacity 50ms linear .2s}.nvtooltip.x-nvtooltip,.nvtooltip.y-nvtooltip{padding:8px}.nvtooltip h3{padding:4px 14px;line-height:18px;background-color:rgba(247,247,247,.75);color:#000;border-bottom:1px solid #ebebeb;border-radius:5px 5px 0 0}.nvtooltip p{padding:5px 14px}.nvtooltip span{display:inline-block;margin:2px 0}.nvtooltip table{margin:6px;border-spacing:0}.nvtooltip table td{padding:2px 9px 2px 0;vertical-align:middle}.nvtooltip table td.key.total{font-weight:700}.nvtooltip table td.value{text-align:right;font-weight:700}.nvtooltip table td.percent{color:#a9a9a9}.nvtooltip table tr.highlight td{padding:1px 9px 1px 0;border-bottom-style:solid;border-bottom-width:1px;border-top-style:solid;border-top-width:1px}.nvtooltip table td.legend-color-guide div{vertical-align:middle;width:12px;height:12px;border:1px solid #999}.nvtooltip .footer{padding:3px;text-align:center}.nvtooltip-pending-removal{pointer-events:none;display:none}.nvd3 line.nv-guideline{stroke:#ccc}"]
            }),
            __metadata("design:paramtypes", [core.Injector, core$1.App])
        ], ChartComponent);
        return ChartComponent;
    }(base.StylableComponent));

    var components = [
        ChartComponent
    ];
    var ChartModule = /** @class */ (function () {
        function ChartModule() {
        }
        ChartModule = __decorate([
            core.NgModule({
                imports: [
                    basic.BasicModule,
                    common.CommonModule,
                    base.WmComponentsModule
                ],
                declarations: __spread(components),
                exports: __spread(components),
                entryComponents: []
            })
        ], ChartModule);
        return ChartModule;
    }());

    exports.ChartModule = ChartModule;
    exports.ɵa = ChartComponent;
    exports.ɵb = registerProps;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=index.umd.js.map
