import { AfterViewInit, Injector, OnInit } from '@angular/core';
import { StylableComponent } from '@wm/components/base';
import { TabsComponent } from '../tabs.component';
export declare class TabPaneComponent extends StylableComponent implements OnInit, AfterViewInit {
    private tabsRef;
    heading: any;
    title: any;
    static initializeProps: void;
    private _isFirstLoad;
    $lazyLoad: (...args: any[]) => void;
    name: string;
    show: boolean;
    smoothscroll: any;
    private isdynamic;
    isActive: boolean;
    disabled: boolean;
    reDrawableComponents: any;
    constructor(inj: Injector, tabsRef: TabsComponent, heading: any, title: any);
    invokeOnSelectCallback($event?: Event): void;
    select($event?: Event): void;
    deselect(): void;
    remove(): void;
    private redrawChildren;
    private notifyParent;
    private handleSwipeLeft;
    private handleSwipeRight;
    protected handleEvent(node: HTMLElement, eventName: string, callback: Function, locals: any): void;
    onPropertyChange(key: string, nv: any, ov?: any): void;
    ngOnInit(): void;
    ngAfterViewInit(): void;
}
