(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common'), require('ngx-bootstrap/dropdown'), require('@wm/components/base'), require('@wm/components/basic'), require('@wm/components/navigation/menu')) :
    typeof define === 'function' && define.amd ? define('@wm/components/data/card', ['exports', '@angular/core', '@angular/common', 'ngx-bootstrap/dropdown', '@wm/components/base', '@wm/components/basic', '@wm/components/navigation/menu'], factory) :
    (global = global || self, factory((global.wm = global.wm || {}, global.wm.components = global.wm.components || {}, global.wm.components.data = global.wm.components.data || {}, global.wm.components.data.card = {}), global.ng.core, global.ng.common, global['ngx-bootstrap'].dropdown, global.wm.components.base, global.wm.components.basic, global.wm.components.navigation.menu));
}(this, (function (exports, core, common, dropdown, base, basic, menu) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __rest(s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); }
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    function __createBinding(o, m, k, k2) {
        if (k2 === undefined) k2 = k;
        o[k2] = m[k];
    }

    function __exportStar(m, exports) {
        for (var p in m) if (p !== "default" && !exports.hasOwnProperty(p)) exports[p] = m[p];
    }

    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m) return m.call(o);
        if (o && typeof o.length === "number") return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }

    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    }

    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    };

    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }

    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
    }

    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }

    function __asyncValues(o) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
    }

    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
        return cooked;
    };

    function __importStar(mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
        result.default = mod;
        return result;
    }

    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }

    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }

    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    var registerProps = function () {
        base.register('wm-card', new Map([
            ['actions', base.PROP_STRING],
            ['animation', base.PROP_STRING],
            ['class', base.PROP_STRING],
            ['iconclass', base.PROP_STRING],
            ['iconurl', base.PROP_STRING],
            ['imageheight', __assign({ value: '200px' }, base.PROP_STRING)],
            ['itemaction', base.PROP_STRING],
            ['itemchildren', base.PROP_STRING],
            ['itemicon', base.PROP_STRING],
            ['itemlabel', base.PROP_STRING],
            ['itemlink', base.PROP_STRING],
            ['name', base.PROP_STRING],
            ['picturesource', base.PROP_STRING],
            ['picturetitle', __assign({ value: '' }, base.PROP_STRING)],
            ['show', __assign({ value: true }, base.PROP_BOOLEAN)],
            ['subheading', base.PROP_STRING],
            ['title', base.PROP_STRING],
            ['userrole', base.PROP_STRING]
        ]));
    };

    var DEFAULT_CLS = 'app-card card app-panel';
    var WIDGET_CONFIG = {
        widgetType: 'wm-card',
        hostClass: DEFAULT_CLS
    };
    var CardComponent = /** @class */ (function (_super) {
        __extends(CardComponent, _super);
        function CardComponent(inj) {
            var _this = _super.call(this, inj, WIDGET_CONFIG) || this;
            base.styler(_this.nativeElement, _this, base.APPLY_STYLES_TYPE.SHELL);
            return _this;
        }
        CardComponent_1 = CardComponent;
        CardComponent.prototype.ngAfterViewInit = function () {
            _super.prototype.ngAfterViewInit.call(this);
            base.styler(this.cardContainerElRef.nativeElement, this, base.APPLY_STYLES_TYPE.INNER_SHELL);
        };
        CardComponent.prototype.onPropertyChange = function (key, nv, ov) {
            if (key === 'title' || key === 'subheading' || key === 'iconclass' || key === 'iconurl' || key === 'actions') {
                this.showHeader = !!(this.title || this.subheading || this.iconclass || this.iconurl || this.actions);
            }
            else {
                _super.prototype.onPropertyChange.call(this, key, nv, ov);
            }
        };
        var CardComponent_1;
        CardComponent.initializeProps = registerProps();
        CardComponent.ctorParameters = function () { return [
            { type: core.Injector }
        ]; };
        __decorate([
            core.ViewChild('cardContainerWrapper', { static: true }),
            __metadata("design:type", core.ElementRef)
        ], CardComponent.prototype, "cardContainerElRef", void 0);
        CardComponent = CardComponent_1 = __decorate([
            core.Component({
                selector: '[wmCard]',
                template: "<div class=\"app-card-header panel-heading\" *ngIf=\"showHeader\">\n    <div class=\"app-card-avatar\" *ngIf=\"iconclass || iconurl\">\n        <i class=\"app-icon\" [ngClass]=\"iconclass\" *ngIf=\"iconclass && !iconurl\"></i>\n        <img class=\"img-circle\" [src]=\"iconurl\" *ngIf=\"iconurl\" />\n    </div>\n    <div class=\"app-card-header-text\">\n        <h4 class=\"card-heading\" [textContent]=\"title\"></h4>\n        <h5 class=\"card-subheading text-muted\" [textContent]=\"subheading\"></h5>\n    </div>\n    <div class=\"panel-actions\" *ngIf=\"actions\">\n        <!-- TODO(punith) need to bind autoclose-->\n        <div wmMenu dropdown\n             [autoClose]=\"autoclose !== 'disabled'\"\n             class=\"panel-action\"\n             type=\"anchor\"\n             iconclass=\"wi wi-more-vert\"\n             menuposition=\"down,left\"\n             hint=\"Actions\"\n             caption=\"\"\n             dataset.bind=\"actions\">\n        </div>\n    </div>\n</div>\n<div class=\"app-card-image\" *ngIf=\"picturesource\"  [ngStyle]=\"{'max-height':imageheight}\">\n   <img wmPicture class=\"card-image\" picturesource.bind=\"picturesource\" hint.bind=\"picturetitle\" />\n</div>\n<div #cardContainerWrapper>\n    <ng-content select=\"[wmCardContent]\"></ng-content>\n</div>\n<div>\n    <ng-content select=\"[wmCardActions]\"></ng-content>\n</div>\n<div>\n    <ng-content select=\"[wmCardFooter]\"></ng-content>\n</div>\n",
                providers: [
                    base.provideAsWidgetRef(CardComponent_1)
                ]
            }),
            __metadata("design:paramtypes", [core.Injector])
        ], CardComponent);
        return CardComponent;
    }(menu.MenuAdapterComponent));
    // Todo(swathi) - menu

    var registerProps$1 = function () {
        base.register('wm-card-actions', new Map([
            ['class', base.PROP_STRING],
            ['name', base.PROP_STRING],
            ['show', __assign({ value: true }, base.PROP_BOOLEAN)],
        ]));
    };

    var DEFAULT_CLS$1 = 'app-card-actions';
    var WIDGET_CONFIG$1 = {
        widgetType: 'wm-card-actions',
        hostClass: DEFAULT_CLS$1
    };
    var CardActionsDirective = /** @class */ (function (_super) {
        __extends(CardActionsDirective, _super);
        function CardActionsDirective(inj) {
            var _this = _super.call(this, inj, WIDGET_CONFIG$1) || this;
            base.styler(_this.nativeElement, _this, base.APPLY_STYLES_TYPE.CONTAINER);
            return _this;
        }
        CardActionsDirective.initializeProps = registerProps$1();
        CardActionsDirective.ctorParameters = function () { return [
            { type: core.Injector }
        ]; };
        CardActionsDirective = __decorate([
            core.Directive({
                selector: '[wmCardActions]'
            }),
            __metadata("design:paramtypes", [core.Injector])
        ], CardActionsDirective);
        return CardActionsDirective;
    }(base.StylableComponent));

    var registerProps$2 = function () {
        base.register('wm-card-content', new Map([
            ['class', base.PROP_STRING],
            ['content', base.PROP_STRING],
            ['name', base.PROP_STRING],
            ['show', __assign({ value: true }, base.PROP_BOOLEAN)]
        ]));
    };

    var DEFAULT_CLS$2 = 'app-card-content card-body card-block';
    var WIDGET_CONFIG$2 = {
        widgetType: 'wm-card-content',
        hostClass: DEFAULT_CLS$2
    };
    var CardContentComponent = /** @class */ (function (_super) {
        __extends(CardContentComponent, _super);
        function CardContentComponent(inj) {
            return _super.call(this, inj, WIDGET_CONFIG$2) || this;
        }
        CardContentComponent_1 = CardContentComponent;
        CardContentComponent.prototype.ngAfterViewInit = function () {
            _super.prototype.ngAfterViewInit.call(this);
            base.styler(this.cardContentContainerElRef.nativeElement, this, base.APPLY_STYLES_TYPE.CONTAINER);
        };
        var CardContentComponent_1;
        CardContentComponent.initializeProps = registerProps$2();
        CardContentComponent.ctorParameters = function () { return [
            { type: core.Injector }
        ]; };
        __decorate([
            core.ViewChild('cardContentContainer'),
            __metadata("design:type", core.ElementRef)
        ], CardContentComponent.prototype, "cardContentContainerElRef", void 0);
        CardContentComponent = CardContentComponent_1 = __decorate([
            core.Component({
                selector: 'div[wmCardContent]',
                template: "<div partial-container-target #cardContentContainer>\n    <ng-content></ng-content>\n</div>",
                providers: [
                    base.provideAsWidgetRef(CardContentComponent_1)
                ]
            }),
            __metadata("design:paramtypes", [core.Injector])
        ], CardContentComponent);
        return CardContentComponent;
    }(base.StylableComponent));

    var registerProps$3 = function () {
        base.register('wm-card-footer', new Map([
            ['class', base.PROP_STRING],
            ['name', base.PROP_STRING],
            ['show', __assign({ value: true }, base.PROP_BOOLEAN)],
        ]));
    };

    var DEFAULT_CLS$3 = 'app-card-footer text-muted card-footer';
    var WIDGET_CONFIG$3 = {
        widgetType: 'wm-card-footer',
        hostClass: DEFAULT_CLS$3
    };
    var CardFooterDirective = /** @class */ (function (_super) {
        __extends(CardFooterDirective, _super);
        function CardFooterDirective(inj) {
            var _this = _super.call(this, inj, WIDGET_CONFIG$3) || this;
            base.styler(_this.nativeElement, _this, base.APPLY_STYLES_TYPE.CONTAINER);
            return _this;
        }
        CardFooterDirective.initializeProps = registerProps$3();
        CardFooterDirective.ctorParameters = function () { return [
            { type: core.Injector }
        ]; };
        CardFooterDirective = __decorate([
            core.Directive({
                selector: '[wmCardFooter]'
            }),
            __metadata("design:paramtypes", [core.Injector])
        ], CardFooterDirective);
        return CardFooterDirective;
    }(base.StylableComponent));

    var components = [
        CardComponent,
        CardActionsDirective,
        CardContentComponent,
        CardFooterDirective
    ];
    var CardModule = /** @class */ (function () {
        function CardModule() {
        }
        CardModule = __decorate([
            core.NgModule({
                imports: [
                    basic.BasicModule,
                    dropdown.BsDropdownModule,
                    common.CommonModule,
                    menu.MenuModule,
                    base.WmComponentsModule
                ],
                declarations: __spread(components),
                exports: __spread(components),
                entryComponents: []
            })
        ], CardModule);
        return CardModule;
    }());

    exports.CardModule = CardModule;
    exports.ɵa = CardComponent;
    exports.ɵb = registerProps;
    exports.ɵc = CardActionsDirective;
    exports.ɵd = registerProps$1;
    exports.ɵe = CardContentComponent;
    exports.ɵf = registerProps$2;
    exports.ɵg = CardFooterDirective;
    exports.ɵh = registerProps$3;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=index.umd.js.map
