(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('ngx-bootstrap/modal'), require('@wm/core'), require('@wm/components/base'), require('@angular/router'), require('@angular/common')) :
    typeof define === 'function' && define.amd ? define('@wm/components/dialogs', ['exports', '@angular/core', 'ngx-bootstrap/modal', '@wm/core', '@wm/components/base', '@angular/router', '@angular/common'], factory) :
    (global = global || self, factory((global.wm = global.wm || {}, global.wm.components = global.wm.components || {}, global.wm.components.dialogs = {}), global.ng.core, global['ngx-bootstrap'].modal, global.wm.core, global.wm.components.base, global.ng.router, global.ng.common));
}(this, (function (exports, core, modal, core$1, base, router, common) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __rest(s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); }
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    function __createBinding(o, m, k, k2) {
        if (k2 === undefined) k2 = k;
        o[k2] = m[k];
    }

    function __exportStar(m, exports) {
        for (var p in m) if (p !== "default" && !exports.hasOwnProperty(p)) exports[p] = m[p];
    }

    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m) return m.call(o);
        if (o && typeof o.length === "number") return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }

    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    }

    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    };

    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }

    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
    }

    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }

    function __asyncValues(o) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
    }

    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
        return cooked;
    };

    function __importStar(mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
        result.default = mod;
        return result;
    }

    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }

    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }

    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    var DEFAULT_CLS = 'app-dialog-body modal-body';
    var DialogBodyDirective = /** @class */ (function () {
        function DialogBodyDirective(elRef, dialogRef, bsModal) {
            var _this = this;
            this.dialogRef = dialogRef;
            core$1.addClass(elRef.nativeElement, DEFAULT_CLS);
            var subscription = bsModal.onShown.subscribe(function () {
                var dialogRoot = $(elRef.nativeElement).closest('.app-dialog')[0];
                var width = _this.dialogRef.width;
                var height = _this.dialogRef.height;
                if (height) {
                    setTimeout(function (e) {
                        core$1.setCSS($(elRef.nativeElement)[0], 'height', height);
                    });
                }
                if (dialogRoot) {
                    if (width) {
                        core$1.setCSS(dialogRoot, 'width', width);
                    }
                    core$1.setAttr(dialogRoot, 'tabindex', _this.dialogRef.tabindex);
                    core$1.setAttr(dialogRoot, 'name', _this.dialogRef.name);
                }
                subscription.unsubscribe();
            });
        }
        DialogBodyDirective.ctorParameters = function () { return [
            { type: core.ElementRef },
            { type: undefined, decorators: [{ type: core.Inject, args: [base.DialogRef,] }] },
            { type: modal.BsModalService }
        ]; };
        __decorate([
            core.HostBinding('style.height'),
            __metadata("design:type", Object)
        ], DialogBodyDirective.prototype, "height", void 0);
        DialogBodyDirective = __decorate([
            core.Directive({
                selector: 'div[wmDialogBody]',
            }),
            __param(1, core.Inject(base.DialogRef)),
            __metadata("design:paramtypes", [core.ElementRef, Object, modal.BsModalService])
        ], DialogBodyDirective);
        return DialogBodyDirective;
    }());

    var registerProps = function () {
        base.register('wm-dialogfooter', new Map([
            ['class', base.PROP_STRING],
            ['name', base.PROP_STRING],
            ['show', __assign({ value: true }, base.PROP_BOOLEAN)]
        ]));
    };

    var WIDGET_INFO = {
        widgetType: 'wm-dialogfooter',
        hostClass: 'app-dialog-footer modal-footer'
    };
    var DialogFooterDirective = /** @class */ (function (_super) {
        __extends(DialogFooterDirective, _super);
        function DialogFooterDirective(inj) {
            return _super.call(this, inj, WIDGET_INFO) || this;
        }
        DialogFooterDirective_1 = DialogFooterDirective;
        var DialogFooterDirective_1;
        DialogFooterDirective.initializeProps = registerProps();
        DialogFooterDirective.ctorParameters = function () { return [
            { type: core.Injector }
        ]; };
        DialogFooterDirective = DialogFooterDirective_1 = __decorate([
            core.Directive({
                selector: 'div[wmDialogFooter]',
                providers: [
                    base.provideAsWidgetRef(DialogFooterDirective_1)
                ]
            }),
            __metadata("design:paramtypes", [core.Injector])
        ], DialogFooterDirective);
        return DialogFooterDirective;
    }(base.BaseComponent));

    var eventsRegistered = false;
    var invokeOpenedCallback = function (ref) {
        if (ref) {
            setTimeout(function () {
                var root = core$1.findRootContainer(ref.$element);
                // if page styles have to be applied to dialog then dialog has to be child of page element.
                if (root) {
                    $('body > modal-container > div').wrap('<' + root + '/>');
                }
                ref.invokeEventCallback('opened', { $event: { type: 'opened' } });
            });
        }
    };
    var ɵ0 = invokeOpenedCallback;
    var invokeClosedCallback = function (ref) {
        if (ref) {
            ref.invokeEventCallback('close');
            ref.dialogRef = undefined;
        }
    };
    var ɵ1 = invokeClosedCallback;
    var BaseDialog = /** @class */ (function (_super) {
        __extends(BaseDialog, _super);
        function BaseDialog(inj, widgetConfig, modalOptions) {
            var _this = _super.call(this, inj, widgetConfig) || this;
            _this.modalOptions = modalOptions;
            _this.dialogService = inj.get(core$1.AbstractDialogService);
            _this.bsModal = inj.get(modal.BsModalService);
            var router$1 = inj.get(router.Router);
            var subscriptions = [
                _this.bsModal.onShown.subscribe(function () {
                    var ref = _this.dialogService.getLastOpenedDialog();
                    if (ref === _this) {
                        // Always get the reference of last pushed dialog in the array for calling onOpen callback
                        invokeOpenedCallback(ref);
                    }
                }),
                _this.bsModal.onHidden.subscribe(function (closeReason) {
                    var ref = closeReason === 'esc' || closeReason === 'backdrop-click' ? _this.dialogService.getLastOpenedDialog() : _this.dialogService.getDialogRefFromClosedDialogs();
                    if (ref === _this) {
                        // remove the dialog reference from opened dialogs and closed dialogs
                        _this.dialogService.removeFromOpenedDialogs(ref);
                        _this.dialogService.removeFromClosedDialogs(ref);
                        invokeClosedCallback(ref);
                        if (ref.closeCallBackFn) {
                            ref.closeCallBackFn();
                        }
                    }
                }),
                router$1.events.subscribe(function (e) {
                    if (e instanceof router.NavigationStart) {
                        _this.close();
                    }
                })
            ];
            _this.registerDestroyListener(function () {
                _this.dialogService.removeFromOpenedDialogs(_this);
                _this.dialogService.removeFromClosedDialogs(_this);
                subscriptions.forEach(function (s) { return s.unsubscribe(); });
            });
            return _this;
        }
        /**
         * Opens the dialog
         * Subscribe to the onShown event emitter of bsModal and trigger on-opened event callback
         */
        BaseDialog.prototype.open = function (initState) {
            // remove the popovers in the page to avoid the overlap with dialog
            // closePopover(this.$element); Commenting this line because it is causing regression(if we have dialog inside popover as partail content, then the dialog close is not working because on closing the popover the partial get destroyed.)
            var _this = this;
            // do not open the dialog again if it is already opened
            var duplicateDialogCheck = function (openedDialog) {
                return openedDialog === _this;
            };
            if (this.dialogService.getOpenedDialogs().some(duplicateDialogCheck)) {
                return;
            }
            this.dialogService.addToOpenedDialogs(this);
            // extend the context with the initState
            Object.assign(this.context, initState);
            this.dialogRef = this.bsModal.show(this.getTemplateRef(), this.modalOptions);
        };
        /**
         * closes the dialog
         * invokes the on-close event callback
         */
        BaseDialog.prototype.close = function () {
            // remove the popovers in the page to avoid the overlap with dialog
            // closePopover(this.$element); Commenting this line because it is causing regression(if we have dialog inside popover as partail content, then the dialog close is not working because on closing the popover the partial get destroyed.)
            if (this.dialogRef) {
                this.dialogService.addToClosedDialogs(this);
                this.dialogRef.hide();
            }
        };
        /**
         * Register the dialog with the dialog service for programmatic access
         */
        BaseDialog.prototype.register = function (scope) {
            // add scope along with name in the dialogRefsCollection Map while registering dialog
            // So that 2 dialogs having same name on different pages won't be overridden.
            this.dialogService.register(this.name, this, scope);
        };
        /**
         * De Register the dialog with the dialog service after dialog destruction
         */
        BaseDialog.prototype.deRegister = function (scope) {
            this.dialogService.deRegister(this.name, scope);
        };
        BaseDialog.prototype.onPropertyChange = function (key, nv, ov) {
            // ignore the class attribute.
            // Prevent the framework from setting the class on the host element.
            if (key === 'class' || key === 'name' || key === 'tabindex') {
                return;
            }
            else if (key === 'animation') {
                this.modalOptions.class = this.modalOptions.class.replace(' animated ' + ov, '');
                if (nv) {
                    this.modalOptions.class = this.modalOptions.class + ' animated ' + nv;
                }
            }
            _super.prototype.onPropertyChange.call(this, key, nv, ov);
        };
        BaseDialog.prototype.ngOnDestroy = function () {
            this.close();
            this.deRegister(this.viewParent);
            _super.prototype.ngOnDestroy.call(this);
        };
        return BaseDialog;
    }(base.BaseComponent));

    var DEFAULT_CLS$1 = 'app-dialog-header modal-header';
    var DEFAULT_ICON_DIMENSIONS = '21px';
    var DialogHeaderComponent = /** @class */ (function () {
        function DialogHeaderComponent(elRef, dialogRef) {
            this.dialogRef = dialogRef;
            this.iconwidth = DEFAULT_ICON_DIMENSIONS;
            this.iconheight = DEFAULT_ICON_DIMENSIONS;
            this.closable = true;
            core$1.addClass(elRef.nativeElement, DEFAULT_CLS$1);
        }
        Object.defineProperty(DialogHeaderComponent.prototype, "isClosable", {
            get: function () {
                return core$1.toBoolean(this.closable);
            },
            enumerable: true,
            configurable: true
        });
        DialogHeaderComponent.prototype.closeDialog = function () {
            this.dialogRef.close();
        };
        DialogHeaderComponent.ctorParameters = function () { return [
            { type: core.ElementRef },
            { type: BaseDialog, decorators: [{ type: core.Inject, args: [base.DialogRef,] }] }
        ]; };
        __decorate([
            core.Input(),
            __metadata("design:type", Object)
        ], DialogHeaderComponent.prototype, "iconwidth", void 0);
        __decorate([
            core.Input(),
            __metadata("design:type", Object)
        ], DialogHeaderComponent.prototype, "iconheight", void 0);
        __decorate([
            core.Input(),
            __metadata("design:type", String)
        ], DialogHeaderComponent.prototype, "iconmargin", void 0);
        __decorate([
            core.Input(),
            __metadata("design:type", String)
        ], DialogHeaderComponent.prototype, "iconclass", void 0);
        __decorate([
            core.Input(),
            __metadata("design:type", String)
        ], DialogHeaderComponent.prototype, "iconurl", void 0);
        __decorate([
            core.Input(),
            __metadata("design:type", Object)
        ], DialogHeaderComponent.prototype, "closable", void 0);
        __decorate([
            core.Input(),
            __metadata("design:type", String)
        ], DialogHeaderComponent.prototype, "heading", void 0);
        __decorate([
            core.Input(),
            __metadata("design:type", String)
        ], DialogHeaderComponent.prototype, "subheading", void 0);
        DialogHeaderComponent = __decorate([
            core.Component({
                selector: 'div[wmDialogHeader]',
                template: "<button *ngIf=\"isClosable\" aria-label=\"Close\" class=\"app-dialog-close close\" (click)=\"closeDialog();\" title=\"Close\">\n    <span aria-hidden=\"true\">&times;</span>\n</button>\n<h4 class=\"app-dialog-title modal-title\">\n    <i [ngClass]=\"iconclass\" [ngStyle]=\"{width: iconwidth, height: iconheight, margin: iconmargin}\"  *ngIf=\"iconclass && !iconurl\"></i>\n    <img data-identifier=\"img\" [src]=\"iconurl | image\" *ngIf=\"iconurl\" [ngStyle]=\"{width:iconwidth, height:iconheight, margin:iconmargin}\"/>\n    <span class=\"dialog-heading\" [textContent]=\"heading\"></span>\n    <span class=\"dialog-sub-heading\" *ngIf=\"subheading\" [title]=\"subheading\" [textContent]=\"subheading\"></span>\n</h4>"
            }),
            __param(1, core.Inject(base.DialogRef)),
            __metadata("design:paramtypes", [core.ElementRef, BaseDialog])
        ], DialogHeaderComponent);
        return DialogHeaderComponent;
    }());

    var components = [
        DialogBodyDirective,
        DialogFooterDirective,
        DialogHeaderComponent
    ];
    var DialogModule = /** @class */ (function () {
        function DialogModule() {
        }
        DialogModule = __decorate([
            core.NgModule({
                imports: [
                    common.CommonModule,
                    modal.ModalModule,
                    base.WmComponentsModule
                ],
                declarations: __spread(components),
                exports: __spread(components),
                entryComponents: []
            })
        ], DialogModule);
        return DialogModule;
    }());

    exports.BaseDialog = BaseDialog;
    exports.DialogBodyDirective = DialogBodyDirective;
    exports.DialogFooterDirective = DialogFooterDirective;
    exports.DialogHeaderComponent = DialogHeaderComponent;
    exports.DialogModule = DialogModule;
    exports.ɵ0 = ɵ0;
    exports.ɵ1 = ɵ1;
    exports.ɵa = registerProps;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=index.umd.js.map
