(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common'), require('@wm/components/base'), require('@wm/components/basic/search'), require('@angular/forms'), require('@wm/core'), require('@wm/components/input')) :
    typeof define === 'function' && define.amd ? define('@wm/components/input/chips', ['exports', '@angular/core', '@angular/common', '@wm/components/base', '@wm/components/basic/search', '@angular/forms', '@wm/core', '@wm/components/input'], factory) :
    (global = global || self, factory((global.wm = global.wm || {}, global.wm.components = global.wm.components || {}, global.wm.components.input = global.wm.components.input || {}, global.wm.components.input.chips = {}), global.ng.core, global.ng.common, global.wm.components.base, global.wm.components.basic.search, global.ng.forms, global.wm.core, global.wm.components.input));
}(this, (function (exports, core, common, base, search, forms, core$1, input) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __rest(s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); }
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    function __createBinding(o, m, k, k2) {
        if (k2 === undefined) k2 = k;
        o[k2] = m[k];
    }

    function __exportStar(m, exports) {
        for (var p in m) if (p !== "default" && !exports.hasOwnProperty(p)) exports[p] = m[p];
    }

    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m) return m.call(o);
        if (o && typeof o.length === "number") return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }

    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    }

    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    };

    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }

    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
    }

    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }

    function __asyncValues(o) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
    }

    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
        return cooked;
    };

    function __importStar(mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
        result.default = mod;
        return result;
    }

    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }

    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }

    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    var chipsProps = new Map([
        ['allowonlyselect', base.PROP_BOOLEAN],
        ['autofocus', base.PROP_BOOLEAN],
        ['chipclass', base.PROP_STRING],
        ['class', base.PROP_STRING],
        ['compareby', base.PROP_STRING],
        ['datafield', base.PROP_STRING],
        ['dataoptions', base.PROP_ANY],
        ['dataset', __assign({ value: 'Option 1, Option 2, Option 3' }, base.PROP_ANY)],
        ['datasource', base.PROP_ANY],
        ['datavalue', base.PROP_ANY],
        ['datavaluesource', base.PROP_ANY],
        ['disabled', base.PROP_BOOLEAN],
        ['displayexpression', base.PROP_STRING],
        ['displayfield', base.PROP_STRING],
        ['displayimagesrc', base.PROP_STRING],
        ['enablereorder', base.PROP_BOOLEAN],
        ['inputposition', __assign({ value: 'last' }, base.PROP_STRING)],
        ['inputwidth', __assign({ value: 'default' }, base.PROP_STRING)],
        ['limit', base.PROP_NUMBER],
        ['loadingdatamsg', __assign({ value: 'Loading items...' }, base.PROP_STRING)],
        ['matchmode', base.PROP_STRING],
        ['maxsize', base.PROP_NUMBER],
        ['minchars', __assign({ value: 1 }, base.PROP_NUMBER)],
        ['name', base.PROP_STRING],
        ['navsearchbar', __assign({ value: false }, base.PROP_BOOLEAN)],
        ['orderby', base.PROP_STRING],
        ['placeholder', __assign({ value: 'Type here..' }, base.PROP_STRING)],
        ['query', base.PROP_STRING],
        ['readonly', base.PROP_BOOLEAN],
        ['searchkey', base.PROP_STRING],
        ['shortcutkey', base.PROP_STRING],
        ['show', __assign({ value: true }, base.PROP_BOOLEAN)],
        ['showsearchicon', base.PROP_BOOLEAN],
        ['tabindex', __assign({ value: 0 }, base.PROP_NUMBER)],
        ['type', __assign({ value: 'search' }, base.PROP_STRING)],
        ['debouncetime', __assign({ value: 250 }, base.PROP_NUMBER)],
    ]);
    var registerProps = function () {
        base.register('wm-chips', chipsProps);
        base.registerFormWidget(core$1.FormWidgetType.CHIPS, new Map(chipsProps));
    };

    var WIDGET_CONFIG = {
        widgetType: 'wm-chips',
        hostClass: 'app-chips nav nav-pills list-inline'
    };
    var ChipsComponent = /** @class */ (function (_super) {
        __extends(ChipsComponent, _super);
        function ChipsComponent(inj, bindDisplayField, bindDisplayExpr, bindDisplayImgSrc, bindDataField, bindDataSet, bindChipclass) {
            var _this = _super.call(this, inj, WIDGET_CONFIG) || this;
            _this.bindDisplayField = bindDisplayField;
            _this.bindDisplayExpr = bindDisplayExpr;
            _this.bindDisplayImgSrc = bindDisplayImgSrc;
            _this.bindDataField = bindDataField;
            _this.bindDataSet = bindDataSet;
            _this.bindChipclass = bindChipclass;
            _this.chipsList = [];
            _this.maxSizeReached = 'Max size reached';
            _this._unsubscribeDv = false;
            base.styler(_this.nativeElement, _this);
            // set the showsearchicon as false by default.
            if (!core$1.isDefined(_this.showsearchicon)) {
                _this.showsearchicon = false;
            }
            _this.multiple = true;
            _this.nextItemIndex = 0; // default chip index
            _this._debounceUpdateQueryModel = core$1.debounce(function (val) {
                _this.updateQueryModel(val).then(function () {
                    if (_this.bindChipclass) {
                        _.forEach(_this.chipsList, function (item, index) {
                            _this.registerChipItemClass(item, index);
                        });
                    }
                });
            }, 150);
            var datasetSubscription = _this.dataset$.subscribe(function () {
                _this.searchComponent.dataset = _this.dataset;
                // clearing the last results when dataset is reassigned
                _this.searchComponent._lastResult = undefined;
                _this.nextItemIndex = _this.datasetItems.length;
                _this._debounceUpdateQueryModel(_this.datavalue || _this.toBeProcessedDatavalue);
            });
            _this.registerDestroyListener(function () { return datasetSubscription.unsubscribe(); });
            var datavalueSubscription = _this.datavalue$.subscribe(function (val) {
                // update queryModel only when parentRef is available.
                if (!_this._unsubscribeDv) {
                    _this.chipsList = [];
                    // if the datafield is ALLFILEDS do not fetch the records
                    // update the query model with the values we have
                    _this._debounceUpdateQueryModel(val);
                }
            });
            _this.registerDestroyListener(function () { return datavalueSubscription.unsubscribe(); });
            return _this;
        }
        ChipsComponent_1 = ChipsComponent;
        Object.defineProperty(ChipsComponent.prototype, "datasource", {
            // getter setter is added to pass the datasource to searchcomponent.
            get: function () {
                return this._datasource;
            },
            set: function (nv) {
                this._datasource = nv;
                this.searchComponent.datasource = nv;
                this._debounceUpdateQueryModel(this.datavalue || this.toBeProcessedDatavalue);
            },
            enumerable: true,
            configurable: true
        });
        ChipsComponent.prototype.ngOnInit = function () {
            var _this = this;
            _super.prototype.ngOnInit.call(this);
            this.searchComponent.multiple = true;
            this.searchComponent.binddisplayimagesrc = this.bindDisplayImgSrc;
            this.searchComponent.displayimagesrc = this.displayimagesrc;
            this.searchComponent.binddisplaylabel = this.bindDisplayExpr;
            this.searchComponent.displaylabel = this.displayfield;
            this.searchComponent.datafield = this.bindDataField || this.datafield;
            this.searchComponent.binddataset = this.bindDataSet;
            this.searchComponent.dataset = this.dataset;
            this.searchComponent.searchkey = this.searchkey;
            this.searchComponent.limit = this.limit;
            this.searchComponent.debouncetime = this.debouncetime;
            this.searchComponent.matchmode = this.matchmode;
            this.getTransformedData = function (val, isCustom) {
                return _this.searchComponent.getTransformedData([val], _this.nextItemIndex++, isCustom);
            };
        };
        ChipsComponent.prototype.ngAfterViewInit = function () {
            _super.prototype.ngAfterViewInit.call(this);
            if (this.enablereorder) {
                this.configureDnD();
            }
        };
        /**
         * This method returns the evaluated class expression.
         * @param $index index of the chip
         * @param item chip object containing the key, value, label
         * @returns {any} evaluated class expression value
         */
        ChipsComponent.prototype.registerChipItemClass = function (item, $index) {
            var _this = this;
            if (this.bindChipclass) {
                var watchName = this.widgetId + "_chipItemClass_" + $index;
                core$1.$unwatch(watchName);
                this.registerDestroyListener(core$1.$watch(this.bindChipclass, this.viewParent, { item: item, $index: $index }, function (nv, ov) {
                    _this.applyItemClass(base.getConditionalClasses(nv, ov), $index);
                }, watchName));
            }
        };
        ChipsComponent.prototype.applyItemClass = function (val, index) {
            var chipItem = this.nativeElement.querySelectorAll('.chip-item').item(index);
            $(chipItem).removeClass(val.toRemove).addClass(val.toAdd);
        };
        ChipsComponent.prototype.removeDuplicates = function () {
            this.chipsList = base.getUniqObjsByDataField(this.chipsList, this.datafield, this.displayfield || this.displaylabel);
        };
        // This method updates the queryModel.
        // default call to get the default data can be done only when defaultQuery is true.
        ChipsComponent.prototype.updateQueryModel = function (data) {
            var _this = this;
            var promises = [];
            if (!data) {
                this.chipsList = [];
                return Promise.resolve();
            }
            // clone the data as the updations on data will change the datavalue.
            var dataValue = _.clone(data);
            var prevChipsList = this.chipsList;
            this.chipsList = [];
            // update the model when model has items more than maxsize
            if (this.maxsize && dataValue.length > this.maxsize) {
                this._modelByValue = dataValue = _.slice(dataValue, 0, this.maxsize);
                data = dataValue;
            }
            var searchQuery = [];
            /**
             * For each value in datavalue,
             * 1. check whether value is in datasetItems, if item is found, addd to the chipsList.
             * 2. else make a default query to the filter and get the record.
             * 3. In step 2, if datavalue is not ALLFIELDS, then make a query. Extract the chipsList from the query response.
             * 4. If there is no response for the value and allowonlyselect is true, remove the value from the datavalue. So that datavalue just contains the valid values.
             * 5. In step 2, if datavalue is ALLFIELDS and value is object, then just prepare the datasetItem from the value.
             * 6. If value is not object and allowonlyselect is false, then create a customModel and replace this value with customModel and prepare datasetItem from this value
             */
            dataValue.forEach(function (val, i) {
                var itemFound = _.find(_this.datasetItems, function (item) {
                    return _.isObject(item.value) ? _.isEqual(item.value, val) : _.toString(item.value) === _.toString(val);
                });
                if (itemFound) {
                    _this.chipsList.push(itemFound);
                }
                else if (_this.datafield !== base.ALLFIELDS) {
                    searchQuery.push(val);
                }
                else if (_this.datafield === base.ALLFIELDS) {
                    var dataObj = void 0, isCustom = false;
                    if (!_.isObject(val)) {
                        dataObj = _this.createCustomDataModel(val);
                        isCustom = true;
                        if (dataObj) {
                            data.splice(i, 1, dataObj);
                        }
                    }
                    else {
                        // if custom chips is already generated, val will be object as {'dataField_val': 'entered_val'}
                        // Hence check this val in previous chipList and assign the iscustom flag
                        var prevChipObj = prevChipsList.find(function (obj) {
                            return _.isEqual(obj.value, val);
                        });
                        if (prevChipObj) {
                            isCustom = prevChipObj.iscustom;
                        }
                    }
                    dataObj = dataObj || val;
                    var transformedData = _this.getTransformedData(dataObj, isCustom);
                    var chipObj = transformedData[0];
                    if (isCustom) {
                        chipObj.iscustom = isCustom;
                    }
                    _this.chipsList.push(chipObj);
                }
            });
            // make default query with all the values and if response for the value is not in datavalue then add a custom chip object.
            if (searchQuery.length) {
                promises.push(this.getDefaultModel(searchQuery, this.nextItemIndex)
                    .then(function (response) {
                    _this.chipsList = _this.chipsList.concat(response || []);
                    dataValue.forEach(function (val, i) {
                        var isExists = _.find(_this.chipsList, function (obj) {
                            return obj.value.toString() === val.toString();
                        });
                        if (!isExists) {
                            if (_this.allowonlyselect) {
                                var index = data.indexOf(val);
                                if (index > -1) {
                                    data.splice(index, 1);
                                }
                                return;
                            }
                            var transformedData = _this.getTransformedData(val, true);
                            var chipObj = transformedData[0];
                            chipObj.iscustom = true;
                            _this.chipsList.push(chipObj);
                        }
                    });
                }));
            }
            // default chip data is adding focus on to the search input. Hence this flag helps not to focus.
            this.resetSearchModel(true);
            return Promise.all(promises).then(function () {
                _this._modelByValue = data;
                _this.removeDuplicates();
                _this.updateMaxSize();
                core$1.$appDigest();
            });
        };
        ChipsComponent.prototype.resetSearchModel = function (defaultQuery) {
            this._unsubscribeDv = true;
            // clear search will empty the query model and gets the data when minchars is 0 (i.e. autocomplete) on focus
            // defaultQuery flag is set when widget is not active. This will only load the autocomplete dropup with minchars as 0 when widget is focused/active
            this.searchComponent.clearSearch(undefined, !this.minchars && !defaultQuery);
            this._unsubscribeDv = false;
        };
        // Triggerred when typeahead option is selected by enter keypress.
        ChipsComponent.prototype.onSelect = function ($event) {
            if (!this.searchComponent.liElements.length) {
                this.addItem($event);
            }
        };
        // Add the newItem to the list
        ChipsComponent.prototype.addItem = function ($event, widget) {
            var searchComponent = widget;
            var allowAdd;
            var chipObj;
            if (searchComponent && core$1.isDefined(searchComponent.datavalue) && searchComponent.queryModel !== '') {
                if (!searchComponent.query || !_.trim(searchComponent.query)) {
                    return;
                }
                chipObj = searchComponent.queryModel;
            }
            else {
                if (this.allowonlyselect) {
                    return;
                }
                var dataObj = void 0;
                if (this.datafield === base.ALLFIELDS) {
                    if (!_.isObject(this.searchComponent.query) && _.trim(this.searchComponent.query)) {
                        dataObj = this.createCustomDataModel(this.searchComponent.query);
                        // return if the custom chip is empty
                        if (!dataObj) {
                            this.resetSearchModel();
                            return;
                        }
                    }
                }
                var data = dataObj || _.trim(this.searchComponent.query);
                if (data) {
                    var transformedData = this.getTransformedData(data, true);
                    chipObj = transformedData[0];
                    chipObj.iscustom = true;
                }
            }
            if (!core$1.isDefined(chipObj) || chipObj === '') {
                return;
            }
            allowAdd = this.invokeEventCallback('beforeadd', { $event: $event, newItem: chipObj });
            if (core$1.isDefined(allowAdd) && !core$1.toBoolean(allowAdd)) {
                return;
            }
            if (this.isDuplicate(chipObj)) {
                this.resetSearchModel();
                return;
            }
            this.registerChipItemClass(chipObj, this.chipsList.length);
            this.chipsList.push(chipObj);
            if (!this.datavalue) {
                this._modelByValue = [chipObj.value];
            }
            else {
                this._modelByValue = __spread(this._modelByValue, [chipObj.value]);
            }
            this._unsubscribeDv = true;
            this.invokeOnTouched();
            this.invokeOnChange(this._modelByValue, $event || {}, true);
            this.invokeEventCallback('add', { $event: $event, $item: chipObj });
            this.updateMaxSize();
            // reset input box when item is added.
            this.resetSearchModel();
            // stop the event to not to call the submit event on enter press.
            if ($event && ($event.key === 'Enter' || $event.keyCode === 13)) {
                this.stopEvent($event);
            }
        };
        // Prepare datavalue object from a string(junk) value when datafield is allFields.
        ChipsComponent.prototype.createCustomDataModel = function (val) {
            var key = this.displayfield || (this.datafield !== base.ALLFIELDS ? this.datafield : undefined);
            if (key) {
                var customObj = {};
                customObj[key] = val;
                return customObj;
            }
        };
        // Check if newItem already exists
        ChipsComponent.prototype.isDuplicate = function (item) {
            if (this.datafield === base.ALLFIELDS) {
                return _.findIndex(this.chipsList, { value: item.value }) > -1;
            }
            return _.findIndex(this.chipsList, { key: item.key }) > -1;
        };
        // Check if max size is reached
        ChipsComponent.prototype.updateMaxSize = function () {
            this.saturate = this.maxsize > 0 && this.chipsList.length === this.maxsize;
        };
        // Makes call to searchComponent to filter the dataSource based on the query.
        ChipsComponent.prototype.getDefaultModel = function (query, index) {
            this.nextItemIndex++;
            return this.searchComponent.getDataSource(query, true, index)
                .then(function (response) {
                return _.filter(query, function (queryVal) {
                    _.find(response, { value: queryVal });
                });
            });
        };
        ChipsComponent.prototype.handleChipClick = function ($event, chip) {
            if (this.readonly) {
                return;
            }
            $event.currentTarget.focus();
            this.invokeEventCallback('chipclick', { $event: $event, $item: chip });
        };
        ChipsComponent.prototype.handleChipFocus = function ($event, chip) {
            if (this.readonly) {
                return;
            }
            chip.active = true;
            this.invokeEventCallback('chipselect', { $event: $event, $item: chip });
        };
        // To avoid form submit on pressing enter key
        ChipsComponent.prototype.stopEvent = function ($event) {
            $event.stopPropagation();
            $event.preventDefault();
        };
        ChipsComponent.prototype.onTextDelete = function ($event) {
            if (core$1.isAppleProduct) {
                this.onInputClear($event);
            }
        };
        ChipsComponent.prototype.onInputClear = function ($event) {
            if (!this.chipsList || !this.chipsList.length || this.searchComponent.query) {
                return;
            }
            this.$element.find('li.chip-item > a.app-chip').last().focus();
            this.stopEvent($event);
        };
        ChipsComponent.prototype.onBackspace = function ($event, $item, $index) {
            if (this.readonly) {
                return;
            }
            this.removeItem($event, $item, $index, true);
        };
        ChipsComponent.prototype.onDelete = function ($event, $item, $index) {
            if (this.readonly) {
                return;
            }
            this.removeItem($event, $item, $index);
        };
        ChipsComponent.prototype.onArrowLeft = function ($item, $index) {
            if (this.readonly) {
                return;
            }
            // On left arrow click when search input query is empty.
            if (!this.searchComponent.query && !core$1.isDefined($index) && !core$1.isDefined($item)) {
                this.$element.find('li.chip-item > a.app-chip').last().focus();
                return;
            }
            if ($index > 0) {
                this.$element.find('li.chip-item > a.app-chip').get($index - 1).focus();
            }
            else {
                this.focusSearchBox();
            }
        };
        ChipsComponent.prototype.onArrowRight = function ($item, $index) {
            if (this.readonly) {
                return;
            }
            // On right arrow click when search input query is empty.
            if (!this.searchComponent.query && !core$1.isDefined($index) && !core$1.isDefined($item)) {
                this.$element.find('li.chip-item > a.app-chip').first().focus();
                return;
            }
            if ($index < (this.chipsList.length - 1)) {
                this.$element.find('li.chip-item > a.app-chip').get($index + 1).focus();
            }
            else {
                this.focusSearchBox();
            }
        };
        // focus search box.
        ChipsComponent.prototype.focusSearchBox = function () {
            this.$element.find('.app-chip-input > input.app-textbox').focus();
        };
        // Remove the item from list
        ChipsComponent.prototype.removeItem = function ($event, item, index, canFocus) {
            var _this = this;
            $event.stopPropagation();
            var indexes = _.isArray(index) ? index : [index];
            var focusIndex = _.max(indexes);
            var items = _.reduce(indexes, function (result, i) {
                result.push(_this.chipsList[i]);
                return result;
            }, []);
            // prevent deletion if the before-remove event callback returns false
            var allowRemove = this.invokeEventCallback('beforeremove', { $event: $event, $item: items.length === 1 ? items[0] : items });
            if (core$1.isDefined(allowRemove) && !core$1.toBoolean(allowRemove)) {
                return;
            }
            var prevDatavalue = _.clone(this.datavalue);
            // focus next chip after deletion.
            // if there are no chips in the list focus search box
            setTimeout(function () {
                var chipsLength = _this.chipsList.length;
                var $chipsList = _this.$element.find('li.chip-item > a.app-chip');
                if (!chipsLength || !canFocus) {
                    _this.focusSearchBox();
                }
                else if ((chipsLength - 1) < focusIndex) {
                    // if focus index is greater than chips length select last chip
                    $chipsList.get(chipsLength - 1).focus();
                }
                else {
                    // manually set the succeeding chip as active if there is a chip next to the current chip.
                    _this.chipsList[focusIndex].active = true;
                    $chipsList.get(focusIndex).focus();
                }
            });
            var pulledItems = _.pullAt(this.chipsList, indexes);
            pulledItems.forEach(function (datasetItem) {
                _this._modelByValue = _.filter(_this._modelByValue, function (val) {
                    return !(_.isObject(val) ? _.isEqual(val, datasetItem.value) : _.toString(val) === _.toString(datasetItem.value));
                });
            });
            this._unsubscribeDv = false;
            this.invokeOnChange(this._modelByValue, $event, true);
            this.invokeEventCallback('change', { $event: $event, newVal: this.datavalue, oldVal: prevDatavalue });
            this.updateMaxSize();
            this.invokeEventCallback('remove', { $event: $event, $item: items.length === 1 ? items[0] : items });
        };
        /**
         * Swaps items in an array if provided with indexes.
         * @param data :- array to be swapped
         * @param newIndex :- new index for the element to be placed
         * @param currentIndex :- the current index of the element.
         */
        ChipsComponent.prototype.swapElementsInArray = function (data, newIndex, currentIndex) {
            var draggedItem = _.pullAt(data, currentIndex)[0];
            data.splice(newIndex, 0, draggedItem);
        };
        /**
         * Cancels the reorder by reseting the elements to the original position.
         */
        ChipsComponent.prototype.resetReorder = function () {
            this.$element.removeData('oldIndex');
        };
        ChipsComponent.prototype.invokeOnBeforeServiceCall = function (inputData) {
            this.invokeEventCallback('beforeservicecall', { inputData: inputData });
        };
        ChipsComponent.prototype.handleEvent = function (node, eventName, eventCallback, locals) {
            if (eventName === 'remove' || eventName === 'beforeremove' || eventName === 'chipselect'
                || eventName === 'chipclick' || eventName === 'add' || eventName === 'reorder' || eventName === 'change') {
                return;
            }
            _super.prototype.handleEvent.call(this, node, eventName, eventCallback, locals);
        };
        // Configures the reordable feature in chips widgets.
        ChipsComponent.prototype.configureDnD = function () {
            var options = {
                items: '> li:not(.app-chip-search)',
                placeholder: 'chip-placeholder'
            };
            base.configureDnD(this.$element, options, this.onReorderStart.bind(this), this.update.bind(this));
        };
        // Triggered on drag start while reordering.
        ChipsComponent.prototype.onReorderStart = function (evt, ui) {
            var helper = ui.helper;
            // increasing the width of the dragged item by 1
            helper.width(helper.width() + 1);
            this.$element.data('oldIndex', ui.item.index() - (this.inputposition === 'first' ? 1 : 0));
        };
        // updates the chipsList and datavalue on reorder.
        ChipsComponent.prototype.update = function ($event, ui) {
            var changedItem, newIndex, oldIndex;
            // Get the index of the item at position before drag and after the reorder.
            newIndex = ui.item.index() - (this.inputposition === 'first' ? 1 : 0);
            oldIndex = this.$element.data('oldIndex');
            newIndex = this.chipsList.length === newIndex ? newIndex - 1 : newIndex;
            changedItem = {
                oldIndex: oldIndex,
                newIndex: newIndex,
                item: this.chipsList[oldIndex]
            };
            if (newIndex === oldIndex) {
                this.resetReorder();
                return;
            }
            changedItem.item = this.chipsList[oldIndex];
            var allowReorder = this.invokeEventCallback('beforereorder', { $event: $event, $data: this.chipsList, $changedItem: changedItem });
            if (core$1.isDefined(allowReorder) && core$1.toBoolean(allowReorder) === false) {
                this.resetReorder();
                return;
            }
            // modify the chipsList and datavalue after the reorder.
            this.swapElementsInArray(this.chipsList, newIndex, oldIndex);
            this.swapElementsInArray(this._modelByValue, newIndex, oldIndex);
            changedItem.item = this.chipsList[newIndex];
            this.chipsList = __spread(this.chipsList);
            this.resetReorder();
            this.invokeEventCallback('reorder', { $event: $event, $data: this.chipsList, $changedItem: changedItem });
        };
        ChipsComponent.prototype.onPropertyChange = function (key, nv, ov) {
            var _this = this;
            if (key === 'tabindex') {
                return;
            }
            if (key === 'dataoptions') {
                this.searchComponent.dataoptions = nv;
            }
            if (key === 'datafield') {
                this.searchComponent.datafield = this.datafield;
            }
            if (key === 'displayfield') {
                this.searchComponent.displaylabel = this.displayfield;
            }
            if (key === 'displayexpression') {
                this.searchComponent.binddisplaylabel = this.binddisplayexpression ? this.binddisplayexpression : this.displayexpression;
            }
            if (key === 'displayimagesrc') {
                this.searchComponent.binddisplayimagesrc = this.binddisplayimagesrc ? this.binddisplayimagesrc : this.displayimagesrc;
            }
            if (key === 'limit') {
                this.searchComponent.limit = this.limit;
            }
            if (key === 'matchmode') {
                this.searchComponent.matchmode = this.matchmode;
            }
            if (key === 'enablereorder') {
                if (this.$element.hasClass('ui-sortable')) {
                    this.$element.sortable('option', 'disabled', !nv);
                }
                else if (nv) {
                    this.configureDnD();
                }
            }
            if (key === 'readonly') {
                if (nv) {
                    this.$element.addClass('readonly');
                }
                else {
                    this.$element.removeClass('readonly');
                }
            }
            if (key === 'inputposition') {
                var $inputEl = this.$element.find('li.app-chip-search');
                if (nv === 'first') {
                    this.$element.prepend($inputEl);
                }
                else {
                    this.$element.append($inputEl);
                }
            }
            if (key === 'autofocus' && nv) {
                // setting the autofocus on the input once after dom is updated
                setTimeout(function () {
                    var $chipsList = _this.$element.find('.app-chip-input > input.app-textbox');
                    if ($chipsList && $chipsList.length) {
                        _this.focusSearchBox();
                    }
                });
            }
            _super.prototype.onPropertyChange.call(this, key, nv, ov);
        };
        var ChipsComponent_1;
        ChipsComponent.initializeProps = registerProps();
        ChipsComponent.ctorParameters = function () { return [
            { type: core.Injector },
            { type: undefined, decorators: [{ type: core.Attribute, args: ['displayfield.bind',] }] },
            { type: undefined, decorators: [{ type: core.Attribute, args: ['displayexpression.bind',] }] },
            { type: undefined, decorators: [{ type: core.Attribute, args: ['displayimagesrc.bind',] }] },
            { type: undefined, decorators: [{ type: core.Attribute, args: ['datafield.bind',] }] },
            { type: undefined, decorators: [{ type: core.Attribute, args: ['dataset.bind',] }] },
            { type: undefined, decorators: [{ type: core.Attribute, args: ['chipclass.bind',] }] }
        ]; };
        __decorate([
            core.ViewChild(search.SearchComponent, /* TODO: add static flag */ { static: true }),
            __metadata("design:type", search.SearchComponent)
        ], ChipsComponent.prototype, "searchComponent", void 0);
        ChipsComponent = ChipsComponent_1 = __decorate([
            core.Component({
                selector: '[wmChips]',
                template: "<li class=\"chip-item {{chipclass && !bindChipclass ? chipclass : ''}}\" role=\"option\" *ngFor=\"let item of chipsList; let $index = index;\"\n    [ngClass]=\"{'active': item.active, 'disabled': disabled}\">\n    <a class=\"app-chip\" href=\"javascript:void(0);\" tabindex=\"-1\"\n       (click)=\"handleChipClick($event, item)\"\n       (keydown.delete)=\"onDelete($event, item, $index)\"\n       (keydown.backspace)=\"onBackspace($event, item, $index)\"\n       (keydown.arrowleft)=\"onArrowLeft(item, $index)\"\n       (keydown.arrowright)=\"onArrowRight(item, $index)\"\n       (focus)=\"handleChipFocus($event, item)\"\n       (blur)=\"readonly ? 0 : item.active = false\"\n       [ngClass]=\"{'chip-duplicate bg-danger': item.isDuplicate, 'chip-picture': item.imgSrc}\">\n        <img data-identifier=\"img\" alt=\"Chip Image\" class=\"button-image-icon\" [src]=\"item.imgSrc\" *ngIf=\"item.imgSrc\"/>\n        <span class=\"app-chip-title\" [textContent]=\"item.label\" [title]=\"item.label\"></span>\n        <button type=\"button\" tabindex=\"-1\" arial-label=\"Clear Button\" class=\"btn btn-transparent\" (click)=\"removeItem($event, item, $index);\" *ngIf=\"!readonly\">\n            <i class=\"app-icon wi wi-close\"></i>\n        </button>\n    </a>\n</li>\n<li class=\"app-chip-search\" [ngClass]=\"{'full-width': inputwidth === 'full'}\">\n    <div #search wmSearch class=\"app-chip-input\"\n         name=\"app-chip-search\"\n         submit.event=\"addItem($event, widget)\"\n         beforeservicecall.event=\"invokeOnBeforeServiceCall(inputData)\"\n         disabled.bind=\"disabled || readonly || saturate\"\n         datafield.bind=\"datafield\"\n         allowonlyselect.bind=\"allowonlyselect\"\n         searchkey.bind=\"searchkey\"\n         orderby.bind=\"orderby\"\n         placeholder.bind=\"saturate ? maxSizeReached : placeholder\"\n         showsearchicon.bind=\"showsearchicon\"\n         tabindex.bind=\"tabindex\"\n         minchars.bind=\"minchars\"\n         debouncetime.bind=\"debouncetime\"\n         matchmode.bind=\"matchmode\"\n         (keydown.enter)=\"onSelect($event)\"\n         (keydown.delete)=\"onTextDelete($event)\"\n         (keydown.backspace)=\"onInputClear($event)\"\n         (keydown.arrowleft)=\"onArrowLeft()\"\n         (keydown.arrowright)=\"onArrowRight()\">\n    </div>\n</li>\n",
                providers: [
                    base.provideAs(ChipsComponent_1, forms.NG_VALUE_ACCESSOR, true),
                    base.provideAsWidgetRef(ChipsComponent_1)
                ]
            }),
            __param(1, core.Attribute('displayfield.bind')),
            __param(2, core.Attribute('displayexpression.bind')),
            __param(3, core.Attribute('displayimagesrc.bind')),
            __param(4, core.Attribute('datafield.bind')),
            __param(5, core.Attribute('dataset.bind')),
            __param(6, core.Attribute('chipclass.bind')),
            __metadata("design:paramtypes", [core.Injector, Object, Object, Object, Object, Object, Object])
        ], ChipsComponent);
        return ChipsComponent;
    }(input.DatasetAwareFormComponent));

    var components = [
        ChipsComponent
    ];
    var ChipsModule = /** @class */ (function () {
        function ChipsModule() {
        }
        ChipsModule = __decorate([
            core.NgModule({
                imports: [
                    common.CommonModule,
                    search.SearchModule,
                    base.WmComponentsModule
                ],
                declarations: __spread(components),
                exports: __spread(components),
                entryComponents: []
            })
        ], ChipsModule);
        return ChipsModule;
    }());

    exports.ChipsModule = ChipsModule;
    exports.ɵa = ChipsComponent;
    exports.ɵb = registerProps;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=index.umd.js.map
