import { ElementRef, Injector } from '@angular/core';
import { NgModel } from '@angular/forms';
import { ColorPickerDirective } from 'ngx-color-picker';
import { BaseFormCustomComponent } from '@wm/components/input';
export declare class ColorPickerComponent extends BaseFormCustomComponent {
    static initializeProps: void;
    required: boolean;
    readonly: boolean;
    disabled: boolean;
    name: string;
    placeholder: any;
    tabindex: any;
    shortcutkey: string;
    outsideclick: boolean;
    autoclose: string;
    ngModel: NgModel;
    inputEl: ElementRef;
    cpDirective: ColorPickerDirective;
    constructor(inj: Injector);
    colorPickerToggleChange(isOpen: boolean): void;
    colorPickerOpen(value: string): void;
    open(): void;
    close(): void;
    protected handleEvent(node: HTMLElement, eventName: string, callback: Function, locals: any): void;
    handleChange(newVal: boolean): void;
    protected onPropertyChange(key: string, nv: any, ov: any): void;
}
