(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common'), require('@angular/forms'), require('angular-imask'), require('@wm/components/base'), require('@wm/core'), require('rxjs')) :
    typeof define === 'function' && define.amd ? define('@wm/components/input', ['exports', '@angular/core', '@angular/common', '@angular/forms', 'angular-imask', '@wm/components/base', '@wm/core', 'rxjs'], factory) :
    (global = global || self, factory((global.wm = global.wm || {}, global.wm.components = global.wm.components || {}, global.wm.components.input = {}), global.ng.core, global.ng.common, global.ng.forms, global['angular-imask'], global.wm.components.base, global.wm.core, global.rxjs));
}(this, (function (exports, core, common, forms, angularImask, base, core$1, rxjs) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __rest(s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); }
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    function __createBinding(o, m, k, k2) {
        if (k2 === undefined) k2 = k;
        o[k2] = m[k];
    }

    function __exportStar(m, exports) {
        for (var p in m) if (p !== "default" && !exports.hasOwnProperty(p)) exports[p] = m[p];
    }

    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m) return m.call(o);
        if (o && typeof o.length === "number") return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }

    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    }

    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    };

    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }

    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
    }

    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }

    function __asyncValues(o) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
    }

    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
        return cooked;
    };

    function __importStar(mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
        result.default = mod;
        return result;
    }

    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }

    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }

    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    var registerProps = function () {
        base.register('wm-button', new Map([
            ['animation', base.PROP_STRING],
            ['badgevalue', base.PROP_STRING],
            ['caption', base.PROP_STRING],
            ['class', base.PROP_STRING],
            ['conditionalclass', base.PROP_ANY],
            ['conditionalstyle', base.PROP_ANY],
            ['disabled', base.PROP_BOOLEAN],
            ['hint', base.PROP_STRING],
            ['iconclass', base.PROP_STRING],
            ['iconheight', base.PROP_STRING],
            ['iconmargin', base.PROP_STRING],
            ['iconposition', base.PROP_STRING],
            ['iconurl', base.PROP_STRING],
            ['iconwidth', base.PROP_STRING],
            ['name', base.PROP_STRING],
            ['shortcutkey', base.PROP_STRING],
            ['show', __assign({ value: true }, base.PROP_BOOLEAN)],
            ['tabindex', __assign({ value: 0 }, base.PROP_NUMBER)],
            ['type', base.PROP_STRING]
        ]));
    };

    var DEFAULT_CLS = 'btn app-button';
    var WIDGET_CONFIG = {
        widgetType: 'wm-button',
        hostClass: DEFAULT_CLS,
        displayType: base.DISPLAY_TYPE.INLINE_BLOCK
    };
    var ButtonComponent = /** @class */ (function (_super) {
        __extends(ButtonComponent, _super);
        function ButtonComponent(inj) {
            var _this = _super.call(this, inj, WIDGET_CONFIG) || this;
            base.styler(_this.nativeElement, _this);
            return _this;
        }
        ButtonComponent_1 = ButtonComponent;
        var ButtonComponent_1;
        ButtonComponent.initializeProps = registerProps();
        ButtonComponent.ctorParameters = function () { return [
            { type: core.Injector }
        ]; };
        __decorate([
            core.HostBinding('type'),
            __metadata("design:type", String)
        ], ButtonComponent.prototype, "type", void 0);
        __decorate([
            core.HostBinding('tabIndex'),
            __metadata("design:type", Number)
        ], ButtonComponent.prototype, "tabindex", void 0);
        __decorate([
            core.HostBinding('disabled'),
            __metadata("design:type", Boolean)
        ], ButtonComponent.prototype, "disabled", void 0);
        __decorate([
            core.HostBinding('attr.accesskey'),
            __metadata("design:type", String)
        ], ButtonComponent.prototype, "shortcutkey", void 0);
        __decorate([
            core.HostBinding('attr.icon-position'),
            __metadata("design:type", String)
        ], ButtonComponent.prototype, "iconposition", void 0);
        ButtonComponent = ButtonComponent_1 = __decorate([
            core.Component({
                selector: 'button[wmButton]',
                template: "<img data-identifier=\"img\" alt=\"button image\" class=\"button-image-icon\" [src]=\"iconurl | image\" *ngIf=\"iconurl\" [ngStyle]=\"{width:iconwidth, height:iconheight, margin:iconmargin}\"/>\n<i class=\"app-icon {{iconclass}}\" aria-hidden=\"true\" [ngStyle]=\"{width:iconwidth, height:iconheight, margin:iconmargin, fontSize:iconwidth}\" *ngIf=\"iconclass\"></i>\n<span class=\"sr-only\" *ngIf=\"iconclass\">{{caption | trustAs:'html'}} {{appLocale.LABEL_ICON}}</span>\n<span class=\"btn-caption\" [innerHTML]=\"caption | trustAs:'html'\"></span>\n<ng-content select=\".caret\"></ng-content>\n<span *ngIf=\"badgevalue\" class=\"badge pull-right\" [textContent]=\"badgevalue\"></span>",
                providers: [
                    base.provideAsWidgetRef(ButtonComponent_1)
                ]
            }),
            __metadata("design:paramtypes", [core.Injector])
        ], ButtonComponent);
        return ButtonComponent;
    }(base.StylableComponent));

    var registerProps$1 = function () {
        base.register('wm-buttongroup', new Map([
            ['class', base.PROP_STRING],
            ['name', base.PROP_STRING],
            ['show', __assign({ value: true }, base.PROP_BOOLEAN)],
            ['vertical', base.PROP_BOOLEAN]
        ]));
    };

    var DEFAULT_CLS$1 = 'btn-group app-button-group';
    var WIDGET_CONFIG$1 = {
        widgetType: 'wm-buttongroup',
        hostClass: DEFAULT_CLS$1
    };
    var ButtonGroupDirective = /** @class */ (function (_super) {
        __extends(ButtonGroupDirective, _super);
        function ButtonGroupDirective(inj) {
            var _this = _super.call(this, inj, WIDGET_CONFIG$1) || this;
            base.styler(_this.nativeElement, _this, base.APPLY_STYLES_TYPE.CONTAINER);
            return _this;
        }
        ButtonGroupDirective_1 = ButtonGroupDirective;
        ButtonGroupDirective.prototype.handleClick = function (event) {
            var $target = $(event.target).closest('.app-button');
            this.$element.find('.app-button').removeClass('selected');
            $target.addClass('selected');
        };
        var ButtonGroupDirective_1;
        ButtonGroupDirective.initializeProps = registerProps$1();
        ButtonGroupDirective.ctorParameters = function () { return [
            { type: core.Injector }
        ]; };
        __decorate([
            core.HostBinding('class.btn-group-vertical'),
            __metadata("design:type", Boolean)
        ], ButtonGroupDirective.prototype, "vertical", void 0);
        __decorate([
            core.HostListener('click', ['$event']),
            __metadata("design:type", Function),
            __metadata("design:paramtypes", [Object]),
            __metadata("design:returntype", void 0)
        ], ButtonGroupDirective.prototype, "handleClick", null);
        ButtonGroupDirective = ButtonGroupDirective_1 = __decorate([
            core.Directive({
                selector: '[wmButtonGroup]',
                providers: [
                    base.provideAsWidgetRef(ButtonGroupDirective_1)
                ]
            }),
            __metadata("design:paramtypes", [core.Injector])
        ], ButtonGroupDirective);
        return ButtonGroupDirective;
    }(base.StylableComponent));

    var BaseFormComponent = /** @class */ (function (_super) {
        __extends(BaseFormComponent, _super);
        function BaseFormComponent(inj, config, initPromise) {
            var _this = _super.call(this, inj, config, initPromise) || this;
            _this.inj = inj;
            _this.binddatavalue = _this.$element.attr('datavalue.bind');
            return _this;
        }
        /**
         * Responsible for updating the variable bound to the widget's datavalue property.
         * @param value
         */
        BaseFormComponent.prototype.updateBoundVariable = function (value) {
            var binddatavalue = this.binddatavalue;
            // return if the variable bound is not static.
            if (this.datavaluesource && this.datavaluesource.execute(core$1.DataSource.Operation.IS_API_AWARE)) {
                return;
            }
            else if (this.datavaluesource && !this.datavaluesource.twoWayBinding) {
                return;
            }
            // return if widget is bound.
            if (!binddatavalue || binddatavalue.startsWith('Widgets.') || binddatavalue.startsWith('itemRef.currentItemWidgets')) {
                return;
            }
            binddatavalue = binddatavalue.replace(/\[\$i\]/g, '[0]');
            // In case of list widget context will be the listItem.
            if (_.has(this.context, binddatavalue.split('.')[0])) {
                _.set(this.context, binddatavalue, value);
            }
            else {
                _.set(this.viewParent, binddatavalue, value);
            }
        };
        BaseFormComponent.prototype.invokeOnChange = function (value, $event) {
            // invoke the event callback
            if ($event) {
                if (this.datavalue !== this.prevDatavalue) {
                    this.updateBoundVariable(value);
                    this.invokeEventCallback('change', {
                        $event: $event,
                        newVal: value,
                        oldVal: this.prevDatavalue
                    });
                }
            }
            // update the previous value
            this.prevDatavalue = value;
        };
        BaseFormComponent.prototype.updatePrevDatavalue = function (val) {
            this.prevDatavalue = val;
        };
        BaseFormComponent.prototype.ngAfterViewInit = function () {
            _super.prototype.ngAfterViewInit.call(this);
            // [WMS-18892]- stopping event propagation [for ArrowLeft, ArrowUp, ArrowRight, ArrowDown actions]  when form widgets or form is inside list widget
            var parentElemList = $(this.nativeElement).parents();
            if (parentElemList.closest('[wmList]').length) {
                this.$element.keydown(function ($event) {
                    if ($event.keyCode === 37 || $event.keyCode === 38 || $event.keyCode === 39 || $event.keyCode === 40) {
                        $event.stopPropagation();
                    }
                });
            }
        };
        return BaseFormComponent;
    }(base.StylableComponent));

    /*
     * WMS-18269
     * custom 'required' validator for components,
     * as the bound values are resolved at runtime
     * Called on 'required' property change
     *
     * Note: Component needs NG_VALIDATOR provider for this to work
     */
    function isValidValue(val) {
        switch (typeof val) {
            case 'object': return (!!val && (!!val.length || !!Object.keys(val).length));
            case 'number': return (!!val || val === 0);
            default: return !!val;
        }
    }
    function validateRequiredBind(required) {
        return function (control) {
            return required
                ? (isValidValue(control.value)
                    ? null
                    : { required: true })
                : null;
        };
    }
    var BaseFormCustomComponent = /** @class */ (function (_super) {
        __extends(BaseFormCustomComponent, _super);
        function BaseFormCustomComponent() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this._onChange = function () { };
            _this._onTouched = function () { };
            return _this;
        }
        BaseFormCustomComponent.prototype.ngOnInit = function () {
            _super.prototype.ngOnInit.call(this);
            this._formControl = this.inj.get(forms.FormControlName, null);
        };
        BaseFormCustomComponent.prototype.registerOnChange = function (fn) {
            this._onChange = fn;
        };
        BaseFormCustomComponent.prototype.registerOnTouched = function (fn) {
            this._onTouched = fn;
        };
        BaseFormCustomComponent.prototype.writeValue = function (value) {
            if (this.isDestroyed) {
                return;
            }
            if (this._formControl) {
                this.datavalue = value;
                this.onPropertyChange('datavalue', value);
                this.updatePrevDatavalue(value);
            }
            /*
             * WMS:18246
             * Call onChange on default value, so that the Component Model is updated
             * Do only When the Model Value is different from datavalue
             */
            (value !== this.datavalue) && this._onChange(this.datavalue);
        };
        BaseFormCustomComponent.prototype.invokeOnChange = function (value, $event, valid) {
            // let the angular know about the change
            this._onChange(value);
            if (valid) {
                _super.prototype.invokeOnChange.call(this, value, $event);
            }
        };
        BaseFormCustomComponent.prototype.invokeOnTouched = function ($event) {
            this._onTouched();
            if ($event) {
                this.invokeEventCallback('blur', { $event: $event });
            }
        };
        BaseFormCustomComponent.prototype.invokeOnFocus = function ($event) {
            this.invokeEventCallback('focus', { $event: $event });
        };
        /* WMS-18269 */
        BaseFormCustomComponent.prototype.validate = function (control) {
            return this['show'] ? validateRequiredBind(this['required'])(control) : null;
        };
        return BaseFormCustomComponent;
    }(BaseFormComponent));

    var checkboxProps = new Map([
        ['caption', base.PROP_STRING],
        ['class', base.PROP_STRING],
        ['conditionalclass', base.PROP_ANY],
        ['conditionalstyle', base.PROP_ANY],
        ['checkedvalue', __assign({ value: true }, base.PROP_STRING)],
        ['datavaluesource', base.PROP_ANY],
        ['datavalue', base.PROP_STRING],
        ['disabled', base.PROP_BOOLEAN],
        ['hint', base.PROP_STRING],
        ['name', base.PROP_STRING],
        ['readonly', base.PROP_BOOLEAN],
        ['required', base.PROP_BOOLEAN],
        ['shortcutkey', base.PROP_STRING],
        ['show', __assign({ value: true }, base.PROP_BOOLEAN)],
        ['tabindex', __assign({ value: 0 }, base.PROP_NUMBER)],
        ['uncheckedvalue', __assign({ value: false }, base.PROP_STRING)]
    ]);
    var registerProps$2 = function () {
        base.register('wm-checkbox', checkboxProps);
        base.registerFormWidget(core$1.FormWidgetType.CHECKBOX, checkboxProps);
        base.registerFormWidget(core$1.FormWidgetType.TOGGLE, checkboxProps);
    };

    var DEFAULT_CLS$2 = 'app-checkbox checkbox';
    var WIDGET_CONFIG$2 = {
        widgetType: 'wm-checkbox',
        hostClass: DEFAULT_CLS$2
    };
    /*
     * try to convert the chekedvalue and unchecked values to boolean/number
     */
    var unStringify = function (val, defaultVal) {
        if (val === null) {
            return defaultVal;
        }
        if (val === true || val === 'true') {
            return true;
        }
        if (val === false || val === 'false') {
            return false;
        }
        var number = parseInt(val, 10);
        if (!isNaN(number)) {
            return number;
        }
        return val;
    };
    var ɵ0 = unStringify;
    var CheckboxComponent = /** @class */ (function (_super) {
        __extends(CheckboxComponent, _super);
        function CheckboxComponent(inj, checkedVal, uncheckedVal, type) {
            var _this = _super.call(this, inj, WIDGET_CONFIG$2) || this;
            _this._caption = '&nbsp';
            _this._checkedvalue = unStringify(checkedVal, true);
            _this._uncheckedvalue = unStringify(uncheckedVal, false);
            // if the type of the checkbox is toggle update the related classes on the host node
            core$1.toggleClass(_this.nativeElement, 'app-toggle', type === 'toggle');
            return _this;
        }
        CheckboxComponent_1 = CheckboxComponent;
        Object.defineProperty(CheckboxComponent.prototype, "datavalue", {
            // if the checkbox is checked, return checkedvalue else return uncheckedvalue
            get: function () {
                return core$1.isDefined(this.proxyModel) ? (this.proxyModel ? this._checkedvalue : this._uncheckedvalue) : undefined;
            },
            // when the datavalue is set, update the checked state
            set: function (v) {
                this.proxyModel = (core$1.isDefined(v) && v !== '') ? v === this._checkedvalue : undefined;
                this.updatePrevDatavalue(this.datavalue);
            },
            enumerable: true,
            configurable: true
        });
        CheckboxComponent.prototype.onPropertyChange = function (key, nv, ov) {
            if (key === 'tabindex') {
                return;
            }
            if (key === 'required') {
                this._onChange(this.datavalue);
                return;
            }
            if (key === 'caption') {
                if (!core$1.isDefined(nv) || nv === '') {
                    this._caption = '&nbsp;';
                }
                else {
                    this._caption = nv;
                }
            }
            else if (key === 'checkedvalue') {
                this._checkedvalue = unStringify(nv, true);
            }
            else if (key === 'uncheckedvalue') {
                this._uncheckedvalue = unStringify(nv, false);
            }
            else if (key === 'datavalue') {
                this.datavalue = unStringify(nv);
                this._onChange(this.datavalue);
            }
            else {
                _super.prototype.onPropertyChange.call(this, key, nv, ov);
            }
        };
        // change and blur events are handled from template
        CheckboxComponent.prototype.handleEvent = function (node, eventName, callback, locals) {
            if (eventName !== 'change' && eventName !== 'blur') {
                // applying tap (Hammer event) on the label as the event handler is not getting triggered on the input.
                var $el = eventName === 'tap' ? this.nativeElement.querySelector('label') : this.checkboxEl.nativeElement;
                _super.prototype.handleEvent.call(this, $el, eventName, callback, locals);
            }
        };
        CheckboxComponent.prototype.handleChange = function (newVal) {
            this.invokeOnChange(this.datavalue, { type: 'change' }, this.ngModel.valid);
        };
        CheckboxComponent.prototype.ngAfterViewInit = function () {
            _super.prototype.ngAfterViewInit.call(this);
            base.styler(this.nativeElement.querySelector('label'), this);
        };
        var CheckboxComponent_1;
        CheckboxComponent.initializeProps = registerProps$2();
        CheckboxComponent.ctorParameters = function () { return [
            { type: core.Injector },
            { type: undefined, decorators: [{ type: core.Attribute, args: ['checkedvalue',] }] },
            { type: undefined, decorators: [{ type: core.Attribute, args: ['uncheckedvalue',] }] },
            { type: undefined, decorators: [{ type: core.Attribute, args: ['type',] }] }
        ]; };
        __decorate([
            core.ViewChild(forms.NgModel),
            __metadata("design:type", forms.NgModel)
        ], CheckboxComponent.prototype, "ngModel", void 0);
        __decorate([
            core.ViewChild('checkbox', { static: true, read: core.ElementRef }),
            __metadata("design:type", core.ElementRef)
        ], CheckboxComponent.prototype, "checkboxEl", void 0);
        CheckboxComponent = CheckboxComponent_1 = __decorate([
            core.Component({
                selector: '[wmCheckbox]',
                template: "<label [ngClass]=\"{'unchecked': !proxyModel, 'disabled': (disabled || readonly), 'required': (required && _caption)}\" role=\"button\">\n    <input type=\"checkbox\" aria-describedby=\"checkbox\"\n           #checkbox\n           [attr.name]=\"name\"\n           focus-target\n           [(ngModel)]=\"proxyModel\"\n           [readonly]=\"readonly\"\n           [required]=\"required\"\n           [disabled]=\"disabled || readonly\"\n           [attr.accesskey]=\"shortcutkey\"\n           [tabindex]=\"tabindex\"\n           (blur)=\"invokeOnTouched($event)\"\n           (ngModelChange)=\"handleChange($event)\">\n    <span class=\"caption\" [innerHtml]=\"_caption\"></span>\n    <img alt=\"Checkbox Image\" src=\"data:image/gif;base64,R0lGODlhAQABAAAAACH5BAEKAAEALAAAAAABAAEAAAICTAEAOw==\" class=\"switch\"/>\n</label>\n<input type=\"hidden\" class=\"ng-hide model-holder\" [disabled]=\"disabled\" [value]=\"proxyModel\">\n",
                providers: [
                    base.provideAs(CheckboxComponent_1, forms.NG_VALUE_ACCESSOR, true),
                    base.provideAs(CheckboxComponent_1, forms.NG_VALIDATORS, true),
                    base.provideAsWidgetRef(CheckboxComponent_1)
                ]
            }),
            __param(1, core.Attribute('checkedvalue')),
            __param(2, core.Attribute('uncheckedvalue')),
            __param(3, core.Attribute('type')),
            __metadata("design:paramtypes", [core.Injector, Object, Object, Object])
        ], CheckboxComponent);
        return CheckboxComponent;
    }(BaseFormCustomComponent));

    var DatasetAwareFormComponent = /** @class */ (function (_super) {
        __extends(DatasetAwareFormComponent, _super);
        function DatasetAwareFormComponent(inj, WIDGET_CONFIG) {
            var _this = _super.call(this, inj, WIDGET_CONFIG) || this;
            _this.datasetItems = [];
            _this.acceptsArray = false; // set to true if proxyModel on widget accepts array type.
            _this.dataset$ = new rxjs.Subject();
            _this.datavalue$ = new rxjs.Subject();
            _this.allowempty = true;
            _this._debounceDatavalueUpdation = _.debounce(function (values) {
                // if no item is found in datasetItems, wait untill the dataset updates by preserving the datavalue in toBeProcessedDatavalue.
                if (!core$1.isDefined(_this._modelByKey) || (_.isArray(_this._modelByKey) && !_this._modelByKey.length)) {
                    _this.toBeProcessedDatavalue = values;
                    _this._modelByValue = '';
                }
                else if (core$1.isDefined(_this.toBeProcessedDatavalue)) {
                    // obtain the first array value when multiple is set to false.
                    // set the modelByValue only when undefined.
                    if (!core$1.isDefined(_this._modelByValue)) {
                        _this._modelByValue = (!_this.multiple && _.isArray(_this.toBeProcessedDatavalue)) ? _this.toBeProcessedDatavalue[0] : _this.toBeProcessedDatavalue;
                    }
                    _this.toBeProcessedDatavalue = undefined;
                }
                _this.initDisplayValues();
            }, 150);
            _this.binddisplayexpression = _this.nativeElement.getAttribute('displayexpression.bind');
            _this.binddisplayimagesrc = _this.nativeElement.getAttribute('displayimagesrc.bind');
            _this.binddisplaylabel = _this.nativeElement.getAttribute('displaylabel.bind');
            _this._debouncedInitDatasetItems = core$1.debounce(function () {
                _this.initDatasetItems();
                core$1.$appDigest();
            }, 150);
            return _this;
        }
        Object.defineProperty(DatasetAwareFormComponent.prototype, "modelByKey", {
            get: function () {
                return this._modelByKey;
            },
            // triggers on ngModel change. This function extracts the datavalue value.
            set: function (val) {
                this.selectByKey(val);
                // invoke on datavalue change.
                this.invokeOnChange(this._modelByValue);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DatasetAwareFormComponent.prototype, "datavalue", {
            get: function () {
                return this._modelByValue;
            },
            // triggers on setting the datavalue. This function extracts the model value.
            set: function (val) {
                if (this.multiple) {
                    val = base.extractDataAsArray(val);
                }
                this._modelByValue = val;
                this.selectByValue(val);
                // changes on the datavalue can be subscribed using listenToDatavalue
                this.datavalue$.next(val);
                // invoke on datavalue change.
                this.invokeOnChange(val, undefined, true);
            },
            enumerable: true,
            configurable: true
        });
        /**
         * This function sets the _datavalue value from the model and sets the selected flag when item is found.
         * Here model is the value obtained from ngModel.
         * @param keys represent the model.
         */
        DatasetAwareFormComponent.prototype.selectByKey = function (keys) {
            var _this = this;
            this.resetDatasetItems();
            if (!this.datasetItems.length) {
                return;
            }
            if (this.multiple && !_.isArray(keys)) {
                keys = [keys];
            }
            // Set the _modelByKey to the modified keys.
            this._modelByKey = keys;
            if (this.multiple) {
                this._modelByValue = [];
                keys.forEach(function (key) {
                    var itemByKey = _.find(_this.datasetItems, function (item) {
                        // not triple equal, as the instance type can be different.
                        // only value comparison should be done.
                        return _.toString(item.key) === _.toString(key);
                    });
                    if (itemByKey) {
                        itemByKey.selected = true;
                        _this._modelByValue = __spread(_this._modelByValue, [itemByKey.value]);
                    }
                });
            }
            else {
                this._modelByValue = '';
                var itemByKey = _.find(this.datasetItems, function (item) {
                    // not triple equal, as the instance type can be different.
                    // only value comparison should be done.
                    return _.toString(item.key) === _.toString(keys);
                });
                if (itemByKey) {
                    itemByKey.selected = true;
                    this._modelByValue = itemByKey.value;
                }
            }
            this.initDisplayValues();
        };
        /**
         * This function sets the _model value from the datavalue (selectedvalues) and sets the selected flag when item is found.
         * datavalue is the default value or a value representing the displayField (for suppose: object in case of ALLFIELDS).
         * If acceptsArray is true, the model always accepts an array.
         * For example, select always accepts model as array whether multiple select is true or false.
         * @param values represent the datavalue.
         */
        DatasetAwareFormComponent.prototype.selectByValue = function (values) {
            var _this = this;
            this.resetDatasetItems();
            // if datavalue is not defined or empty then set the model as undefined.
            if (!core$1.isDefined(values) || values === '' || _.isNull(values) || (values instanceof Array && !values.length)) {
                this._modelByKey = undefined;
                // do not return when allowempty is set to true.
                if (!this.allowempty || !core$1.isDefined(values)) {
                    return;
                }
            }
            if (this.acceptsArray && !_.isArray(values)) {
                values = this.allowempty ? [values] : base.extractDataAsArray(values);
            }
            // preserve the datavalue if datasetItems are empty.
            if (!this.datasetItems.length && core$1.isDefined(values)) {
                this.toBeProcessedDatavalue = values;
                return;
            }
            var filterField = this.datafield === base.ALLFIELDS ? 'dataObject' : 'key';
            if (_.isArray(values)) {
                this._modelByKey = [];
                values.forEach(function (val) {
                    var itemByValue = _.find(_this.datasetItems, function (item) {
                        if (filterField === 'dataObject') {
                            if (_this.compareby && _this.compareby.length) {
                                return core$1.isEqualWithFields(item[filterField], val, _this.compareby);
                            }
                        }
                        return (_.isObject(item.value) ? _.isEqual(item.value, val) : (_.toString(item.value)).toLowerCase() === (_.toString(val)).toLowerCase());
                    });
                    if (itemByValue) {
                        itemByValue.selected = true;
                        _this._modelByKey.push(itemByValue.key);
                    }
                });
            }
            else {
                this._modelByKey = undefined;
                var itemByValue = _.find(this.datasetItems, function (item) {
                    if (filterField === 'dataObject') {
                        if (_this.compareby && _this.compareby.length) {
                            return core$1.isEqualWithFields(item[filterField], values, _this.compareby);
                        }
                    }
                    return (_.isObject(item.value) ? _.isEqual(item.value, values) : (_.toString(item.value)).toLowerCase() === (_.toString(values)).toLowerCase());
                });
                if (itemByValue) {
                    itemByValue.selected = true;
                    this._modelByKey = itemByValue.key;
                }
            }
            // delaying the datavalue update as the widgets in liveform are having datavalue as undefined and not the default provided value
            // because datavalue is updated later when new dataset is available.
            this._debounceDatavalueUpdation(values);
        };
        // Updates the displayValue property.
        DatasetAwareFormComponent.prototype.initDisplayValues = function () {
            var displayValues = [];
            this.datasetItems.forEach(function (item) {
                if (item.selected) {
                    displayValues.push(item.label);
                }
            });
            this.displayValue = this.multiple ? displayValues : displayValues[0] || '';
        };
        // This function parses the dataset and extracts the displayOptions from parsed dataset.
        DatasetAwareFormComponent.prototype.initDatasetItems = function () {
            if (!this.dataset || _.isEmpty(this.dataset)) {
                this.datasetItems = [];
                // notify the dataset listeners
                this.dataset$.next(this.datasetItems);
                return;
            }
            // convert any dataset to the object format.
            var orderedDataset = base.getOrderedDataset(base.convertDataToObject(this.dataset), this.orderby);
            if (this.usekeys) {
                this.datasetItems = base.transformDataWithKeys(orderedDataset);
            }
            else {
                var displayOptions = base.transformFormData(this.viewParent, orderedDataset, this.datafield, {
                    displayField: this.displayfield || this.displaylabel,
                    displayExpr: this.displayexpression,
                    bindDisplayExpr: this.binddisplayexpression || this.binddisplaylabel,
                    bindDisplayImgSrc: this.binddisplayimagesrc,
                    displayImgSrc: this.displayimagesrc
                });
                // get the unique objects out of the extracted data. Notify change in datasetItems using [...datasetItems] notation
                this.datasetItems = __spread(base.getUniqObjsByDataField(displayOptions, this.datafield, this.displayfield || this.displaylabel, core$1.toBoolean(this.allowempty)));
            }
            this.postDatasetItemsInit();
        };
        // Once the datasetItems are ready, set the proxyModel by using datavalue.
        DatasetAwareFormComponent.prototype.postDatasetItemsInit = function () {
            if (this.datasetItems.length && !this._defaultQueryInvoked) {
                // use the latest of toBeProcessedDatavalue, datavalue
                var _datavalue = _.isEmpty(this.toBeProcessedDatavalue) ? this.datavalue : this.toBeProcessedDatavalue;
                this.selectByValue(_datavalue);
            }
            // notify the dataset listeners
            this.dataset$.next(this.datasetItems);
        };
        // Reset the selected flag on datasetItems to false.
        DatasetAwareFormComponent.prototype.resetDatasetItems = function () {
            this.datasetItems.forEach(function (item) { return item.selected = false; });
        };
        DatasetAwareFormComponent.prototype.setTemplate = function (partialName) {
            this.content = partialName;
        };
        DatasetAwareFormComponent.prototype.onPropertyChange = function (key, nv, ov) {
            _super.prototype.onPropertyChange.call(this, key, nv, ov);
            switch (key) {
                case 'dataset':
                case 'datafield':
                case 'displayfield':
                case 'displaylabel':
                case 'displayexpression':
                case 'orderby':
                case 'usekeys':
                    this._debouncedInitDatasetItems();
                    break;
                case 'required':
                case 'datavalue':
                    this._onChange(this.datavalue);
                    break;
            }
        };
        return DatasetAwareFormComponent;
    }(BaseFormCustomComponent));

    var checkboxsetProps = new Map([
        ['class', base.PROP_STRING],
        ['collapsible', base.PROP_BOOLEAN],
        ['compareby', base.PROP_STRING],
        ['datafield', base.PROP_STRING],
        ['dataset', __assign({ value: 'Option 1, Option 2, Option 3' }, base.PROP_ANY)],
        ['datavaluesource', base.PROP_ANY],
        ['datavalue', base.PROP_STRING],
        ['dateformat', base.PROP_STRING],
        ['disabled', base.PROP_BOOLEAN],
        ['displayexpression', base.PROP_STRING],
        ['displayfield', base.PROP_STRING],
        ['displayValue', base.PROP_STRING],
        ['groupby', base.PROP_STRING],
        ['itemclass', __assign({ value: '' }, base.PROP_STRING)],
        ['itemsperrow', __assign({ value: 'xs-1 sm-1 md-1 lg-1' }, base.PROP_STRING)],
        ['listclass', __assign({ value: '' }, base.PROP_STRING)],
        ['match', base.PROP_STRING],
        ['name', base.PROP_STRING],
        ['orderby', base.PROP_STRING],
        ['readonly', base.PROP_BOOLEAN],
        ['required', base.PROP_BOOLEAN],
        ['show', __assign({ value: true }, base.PROP_BOOLEAN)],
        ['showcount', base.PROP_BOOLEAN],
        ['showindevice', __assign({ displayType: 'inline-block', value: 'all' }, base.PROP_STRING)],
        ['tabindex', __assign({ value: 0 }, base.PROP_NUMBER)],
        ['usekeys', base.PROP_BOOLEAN]
    ]);
    var registerProps$3 = function () {
        base.register('wm-checkboxset', checkboxsetProps);
        base.registerFormWidget(core$1.FormWidgetType.CHECKBOXSET, new Map(checkboxsetProps));
    };

    var DEFAULT_CLS$3 = 'app-checkboxset list-group inline';
    var WIDGET_CONFIG$3 = { widgetType: 'wm-checkboxset', hostClass: DEFAULT_CLS$3 };
    var CheckboxsetComponent = /** @class */ (function (_super) {
        __extends(CheckboxsetComponent, _super);
        function CheckboxsetComponent(inj, groupby, appDefaults, datePipe) {
            var _this = _super.call(this, inj, WIDGET_CONFIG$3) || this;
            _this.groupby = groupby;
            _this.appDefaults = appDefaults;
            _this.datePipe = datePipe;
            _this.layout = '';
            base.styler(_this.nativeElement, _this);
            _this.multiple = true;
            _this.handleHeaderClick = core$1.noop;
            return _this;
        }
        CheckboxsetComponent_1 = CheckboxsetComponent;
        CheckboxsetComponent.prototype.onCheckboxLabelClick = function ($event, key) {
            if (!$($event.target).is('input')) {
                return;
            }
            // construct the _model from the checked elements.
            var inputElements = this.nativeElement.querySelectorAll('input:checked');
            var keys = [];
            _.forEach(inputElements, function ($el) {
                keys.push($el.value);
            });
            this.modelByKey = keys;
            this.invokeOnTouched();
            // invoke on datavalue change.
            this.invokeOnChange(this.datavalue, $event || {}, true);
        };
        // change and blur events are added from the template
        CheckboxsetComponent.prototype.handleEvent = function (node, eventName, callback, locals) {
            if (eventName === 'click') {
                this.eventManager.addEventListener(node, eventName, function (e) {
                    if (!$(e.target).is('input')) {
                        return;
                    }
                    locals.$event = e;
                    return callback();
                });
            }
            else if (!_.includes(['change'], eventName)) {
                _super.prototype.handleEvent.call(this, node, eventName, callback, locals);
            }
        };
        CheckboxsetComponent.prototype.getGroupedData = function () {
            return this.datasetItems.length ? base.groupData(this, base.convertDataToObject(this.datasetItems), this.groupby, this.match, this.orderby, this.dateformat, this.datePipe, 'dataObject', this.appDefaults) : [];
        };
        CheckboxsetComponent.prototype.datasetSubscription = function () {
            var _this = this;
            var datasetSubscription = this.dataset$.subscribe(function () {
                _this.groupedData = _this.getGroupedData();
            });
            this.registerDestroyListener(function () { return datasetSubscription.unsubscribe(); });
        };
        CheckboxsetComponent.prototype.onPropertyChange = function (key, nv, ov) {
            if (key === 'tabindex') {
                return;
            }
            if (key === 'required') {
                this._onChange(this.datavalue);
                return;
            }
            if (key === 'itemsperrow') {
                core$1.setListClass(this);
            }
            else if (key === 'groupby' || key === 'match') {
                this.datasetSubscription();
                // If groupby is set, get the groupedData from the datasetItems.
                this.groupedData = this.getGroupedData();
            }
            else {
                _super.prototype.onPropertyChange.call(this, key, nv, ov);
            }
        };
        CheckboxsetComponent.prototype.ngOnInit = function () {
            _super.prototype.ngOnInit.call(this);
            if (this.groupby) {
                this.datasetSubscription();
                // If groupby is set, get the groupedData from the datasetItems.
                this.groupedData = this.getGroupedData();
            }
            // adding the handler for header click and toggle headers.
            if (this.groupby && this.collapsible) {
                this.handleHeaderClick = base.handleHeaderClick;
                this.toggleAllHeaders = base.toggleAllHeaders.bind(undefined, this);
            }
        };
        var CheckboxsetComponent_1;
        CheckboxsetComponent.initializeProps = registerProps$3();
        CheckboxsetComponent.ctorParameters = function () { return [
            { type: core.Injector },
            { type: String, decorators: [{ type: core.Attribute, args: ['groupby',] }] },
            { type: core$1.AppDefaults },
            { type: base.ToDatePipe }
        ]; };
        CheckboxsetComponent = CheckboxsetComponent_1 = __decorate([
            core.Component({
                selector: '[wmCheckboxset]',
                exportAs: 'wmCheckboxset',
                template: "<ng-template [ngIf]=\"!groupby\" [ngIfElse]=\"groupedListTemplate\">\n    <li [ngClass]=\"['checkbox', 'app-checkbox', itemclass, itemsPerRowClass]\"\n        [class.active]=\"item.selected\"\n        *ngFor=\"let item of datasetItems; let i = index\"\n        [wmItemTemplate]=\"content\" [userComponentParams]=\"item\" partialContainer\n        (click)=\"onCheckboxLabelClick($event, item.key)\">\n        <!-- Default item template -->\n        <label *ngIf=\"!content\" class=\"app-checkboxset-label\" [ngClass]=\"{'disabled':disabled || readonly}\" [title]=\"item.label\">\n            <input [name]=\"'checkboxset_' + widgetId\" type=\"checkbox\" aria-label=\"checkbox group\"\n                   [tabindex]=\"tabindex\"\n                   [disabled]=\"disabled || readonly\" [attr.data-attr-index]=\"i\"\n                   [value]=\"item.key\" [tabindex]=\"tabindex\" [checked]=\"item.selected\"/>\n            <span class=\"caption\" [textContent]=\"item.label\"></span>\n        </label>\n        <!-- Custom partial template -->\n        <label *ngIf=\"content\" class=\"app-checkboxset-label\" [ngClass]=\"{'disabled':disabled || readonly}\" >\n            <input [name]=\"'checkboxset_' + widgetId\" type=\"checkbox\" aria-label=\"checkbox group\"\n                   [tabindex]=\"tabindex\"\n                   [disabled]=\"disabled || readonly\" [attr.data-attr-index]=\"i\"\n                   [value]=\"item.key\" [tabindex]=\"tabindex\" [checked]=\"item.selected\"/>\n            <span class=\"caption customTemplate\" partial-container-target></span>\n        </label>\n    </li>\n</ng-template>\n<input [disabled]=\"disabled || readonly\" hidden class=\"model-holder\">\n<div *ngIf=\"readonly || disabled\" class=\"readonly-wrapper\"></div>\n\n<!-- This template will be displayed when groupby is specified. -->\n<ng-template #groupedListTemplate>\n    <li *ngFor=\"let groupObj of groupedData\" class=\"app-list-item-group\">\n        <ul class=\"item-group\">\n            <li class=\"list-group-header\" (click)=\"handleHeaderClick($event)\" [title]=\"groupObj.key\" [ngClass]=\"{'collapsible-content': collapsible}\">\n                <h4 class=\"group-title\">{{groupObj.key}}\n                    <div class=\"header-action\">\n                        <i class=\"app-icon wi action wi-chevron-up\" *ngIf=\"collapsible\" title=\"{{appLocale.LABEL_COLLAPSE}}/{{appLocale.LABEL_EXPAND}}\"></i>\n                        <span *ngIf=\"showcount\" class=\"label label-default\" [textContent]=\"groupObj.data.length\"></span>\n                    </div>\n                </h4>\n            </li>\n            <li *ngFor=\"let item of groupObj.data; let i = index;\"\n                [ngClass]=\"['checkbox', 'app-checkbox', 'group-list-item', itemclass, itemsPerRowClass]\"\n                [class.active]=\"item.selected\"\n                [wmItemTemplate]=\"content\" [userComponentParams]=\"item\" partialContainer\n                (click)=\"onCheckboxLabelClick($event, item)\">\n                <!-- Default item template -->\n                <label *ngIf=\"!content\" class=\"app-checkboxset-label\" [ngClass]=\"{'disabled':disabled || readonly}\" [title]=\"item.label\">\n                    <input [name]=\"'checkboxset_' + widgetId\" type=\"checkbox\" aria-label=\"checkbox group\"\n                           [tabindex]=\"tabindex\"\n                           [disabled]=\"disabled || readonly\" [attr.data-attr-index]=\"i\"\n                           [value]=\"item.key\" [tabindex]=\"tabindex\" [checked]=\"item.selected\"/>\n                    <span class=\"caption\" [textContent]=\"item.label\"></span>\n                </label>\n                <!-- Custom partial template -->\n                <label *ngIf=\"content\" class=\"app-checkboxset-label\" [ngClass]=\"{'disabled':disabled || readonly}\" >\n                    <input [name]=\"'checkboxset_' + widgetId\" type=\"checkbox\" aria-label=\"checkbox group\"\n                           [tabindex]=\"tabindex\"\n                           [disabled]=\"disabled || readonly\" [attr.data-attr-index]=\"i\"\n                           [value]=\"item.key\" [tabindex]=\"tabindex\" [checked]=\"item.selected\"/>\n                    <span class=\"caption\" partial-container-target></span>\n                </label>\n            </li>\n        </ul>\n    </li>\n</ng-template>\n",
                providers: [
                    base.provideAs(CheckboxsetComponent_1, forms.NG_VALUE_ACCESSOR, true),
                    base.provideAs(CheckboxsetComponent_1, forms.NG_VALIDATORS, true),
                    base.provideAsWidgetRef(CheckboxsetComponent_1)
                ]
            }),
            __param(1, core.Attribute('groupby')),
            __metadata("design:paramtypes", [core.Injector, String, core$1.AppDefaults,
                base.ToDatePipe])
        ], CheckboxsetComponent);
        return CheckboxsetComponent;
    }(DatasetAwareFormComponent));

    var registerProps$4 = function () {
        base.register('wm-form-group', new Map([
            ['captionposition', base.PROP_STRING],
            ['name', base.PROP_STRING],
            ['required', base.PROP_BOOLEAN],
            ['show', __assign({ value: true }, base.PROP_BOOLEAN)]
        ]));
    };

    var DEFAULT_CLS$4 = 'form-group app-composite-widget clearfix';
    var WIDGET_CONFIG$4 = {
        widgetType: 'wm-form-group',
        hostClass: DEFAULT_CLS$4
    };
    var CAPTION_POSITION = {
        left: 'caption-left',
        right: 'caption-right',
        top: 'caption-top'
    };
    var CompositeDirective = /** @class */ (function (_super) {
        __extends(CompositeDirective, _super);
        function CompositeDirective(inj) {
            var _this = _super.call(this, inj, WIDGET_CONFIG$4) || this;
            base.styler(_this.nativeElement, _this, base.APPLY_STYLES_TYPE.CONTAINER);
            return _this;
        }
        CompositeDirective_1 = CompositeDirective;
        /**
         * this is onPropertyChange handler for the form-group component
         * @param key
         * @param nv
         * @param ov
         */
        CompositeDirective.prototype.onPropertyChange = function (key, nv, ov) {
            if (key === 'captionposition') {
                core$1.switchClass(this.nativeElement, CAPTION_POSITION[nv], CAPTION_POSITION[ov]);
            }
            else if (key === 'required') {
                this.required = nv;
                this.assignRequiredToSubComponents();
            }
            else {
                _super.prototype.onPropertyChange.call(this, key, nv, ov);
            }
        };
        /**
         * this method assigns the required on the component/directive based on the required attribute of the form-group
         */
        CompositeDirective.prototype.assignRequiredToSubComponents = function () {
            var _this = this;
            if (this.required && this.componentRefs) {
                setTimeout(function () {
                    _this.componentRefs.forEach(function (componentRef) { return componentRef.widget.required = true; });
                }, 50);
            }
        };
        CompositeDirective.prototype.ngAfterViewInit = function () {
            _super.prototype.ngAfterViewInit.call(this);
            core$1.addForIdAttributes(this.nativeElement);
            this.assignRequiredToSubComponents();
        };
        var CompositeDirective_1;
        CompositeDirective.initializeProps = registerProps$4();
        CompositeDirective.ctorParameters = function () { return [
            { type: core.Injector }
        ]; };
        __decorate([
            core.ContentChildren(base.WidgetRef, { descendants: true }),
            __metadata("design:type", Object)
        ], CompositeDirective.prototype, "componentRefs", void 0);
        CompositeDirective = CompositeDirective_1 = __decorate([
            core.Directive({
                selector: 'div[wmComposite]',
                providers: [
                    base.provideAsWidgetRef(CompositeDirective_1)
                ]
            }),
            __metadata("design:paramtypes", [core.Injector])
        ], CompositeDirective);
        return CompositeDirective;
    }(base.StylableComponent));

    var numberProps = new Map([
        ['autofocus', base.PROP_BOOLEAN],
        ['class', base.PROP_STRING],
        ['datavaluesource', base.PROP_ANY],
        ['datavalue', base.PROP_STRING],
        ['disabled', base.PROP_BOOLEAN],
        ['hint', base.PROP_STRING],
        ['localefilter', base.PROP_STRING],
        ['minvalue', base.PROP_NUMBER],
        ['maxvalue', base.PROP_NUMBER],
        ['name', base.PROP_STRING],
        ['numberfilter', base.PROP_STRING],
        ['placeholder', __assign({ value: 'Enter number' }, base.PROP_STRING)],
        ['readonly', base.PROP_BOOLEAN],
        ['regexp', base.PROP_STRING],
        ['required', base.PROP_BOOLEAN],
        ['shortcutkey', base.PROP_STRING],
        ['show', __assign({ value: true }, base.PROP_BOOLEAN)],
        ['step', __assign({ value: 1 }, base.PROP_NUMBER)],
        ['tabindex', __assign({ value: 0 }, base.PROP_NUMBER)],
        ['trailingzero', __assign({ value: false }, base.PROP_BOOLEAN)],
        ['updateon', base.PROP_STRING]
    ]);
    var registerProps$5 = function () {
        base.register('wm-number', numberProps);
        base.registerFormWidget(core$1.FormWidgetType.NUMBER, new Map(numberProps));
    };

    var BaseInput = /** @class */ (function (_super) {
        __extends(BaseInput, _super);
        function BaseInput(inj, config) {
            var _this = _super.call(this, inj, config) || this;
            // possible values for ngModelOptions are 'blur' and 'change'
            // default is 'blur'
            _this.ngModelOptions = {
                updateOn: ''
            };
            var updateOn = _this.nativeElement.getAttribute('updateon') || 'blur';
            updateOn = updateOn === 'default' ? 'change' : updateOn;
            _this.ngModelOptions.updateOn = updateOn;
            return _this;
        }
        BaseInput.prototype.onPropertyChange = function (key, nv, ov) {
            // set the class on the input element
            if (key === 'tabindex') {
                return;
            }
            if (key === 'required') {
                /* WMS-18269 | Update Angular about the required attr value change */
                this._onChange(this.datavalue);
            }
            if (key === 'class') {
                if (this.inputEl.nativeElement) {
                    core$1.switchClass(this.inputEl.nativeElement, nv, ov);
                }
            }
            else if (key === 'datavalue') {
                // update the oldDataValue when the datavalue is modified programmatically
                this.updatePrevDatavalue(nv);
                this._onChange(this.datavalue);
            }
            else {
                _super.prototype.onPropertyChange.call(this, key, nv, ov);
            }
        };
        // invoke the change callback
        BaseInput.prototype.handleChange = function (newValue) {
            if (this.autotrim && this.datavalue && _.isString(this.datavalue)) {
                this.datavalue = this.datavalue.trim();
            }
            this.invokeOnChange(this.datavalue, { type: 'change' }, this.ngModel.valid);
        };
        // Change event is registered from the template, Prevent the framework from registering one more event
        BaseInput.prototype.handleEvent = function (node, eventName, eventCallback, locals) {
            if (eventName !== 'change' && eventName !== 'blur') {
                _super.prototype.handleEvent.call(this, this.inputEl.nativeElement, eventName, eventCallback, locals);
            }
        };
        // invoke the blur callback
        BaseInput.prototype.handleBlur = function ($event) {
            this.invokeOnTouched($event);
        };
        // Update the model on enter key press
        BaseInput.prototype.flushViewChanges = function (val) {
            this.ngModel.update.next(val);
            core$1.$appDigest();
        };
        BaseInput.prototype.ngAfterViewInit = function () {
            _super.prototype.ngAfterViewInit.call(this);
            // add the class on the input element
            if (this.class) {
                core$1.addClass(this.inputEl.nativeElement, this.class);
            }
            base.styler(this.inputEl.nativeElement, this);
        };
        return BaseInput;
    }(BaseFormCustomComponent));

    var NumberLocale = /** @class */ (function (_super) {
        __extends(NumberLocale, _super);
        function NumberLocale(inj, config, i18nService, trailingZeroDecimalPipe) {
            var _this = _super.call(this, inj, config) || this;
            _this.trailingZeroDecimalPipe = trailingZeroDecimalPipe;
            _this.isDefaultQuery = true;
            _this.decimalValue = '';
            _this.selectedLocale = i18nService.getSelectedLocale();
            _this.DECIMAL = common.getLocaleNumberSymbol(_this.localefilter || _this.selectedLocale, common.NumberSymbol.Decimal);
            _this.GROUP = common.getLocaleNumberSymbol(_this.localefilter || _this.selectedLocale, common.NumberSymbol.Group);
            _this.numberfilter = '1.0-16';
            _this.resetValidations();
            return _this;
        }
        Object.defineProperty(NumberLocale.prototype, "datavalue", {
            // returns the actual model value of the widget.
            get: function () {
                return this.proxyModel;
            },
            // Setter for the datavalue.
            set: function (value) {
                // set text value to null if data value is empty.
                if (_.includes([null, undefined, ''], value)) {
                    var input = this.inputEl.nativeElement;
                    this.displayValue = input.value = this.proxyModel = null;
                    this.resetValidations();
                    this._onChange();
                    return;
                }
                // if the widget has default value and if we change the locale, the value should be in selected locale format.
                if (this.isDefaultQuery) {
                    var isLocalizedNumber = _.isString(value) && _.includes(value, this.DECIMAL);
                    var parts = isLocalizedNumber ? value.split(this.DECIMAL) : _.isString(value) && value.split('.');
                    this.decimalValue = parts[1] || '';
                    value = isLocalizedNumber ? value : this.transformNumber(value);
                }
                // get a valid number form the text.
                var model = this.parseNumber(value.toString());
                // if the number is valid or if number is not in range update the model value.
                if (this.isValid(model)) {
                    this.proxyModel = model;
                    // update the display value in the text box.
                    this.updateDisplayText();
                    this.handleChange(model);
                }
                else {
                    this.displayValue = value.toString();
                    this.proxyModel = null;
                    this.handleChange(null);
                }
            },
            enumerable: true,
            configurable: true
        });
        // resets all the flags related to the widget's validation.
        NumberLocale.prototype.resetValidations = function () {
            this.isInvalidNumber = false;
            this.numberNotInRange = false;
        };
        /**
         * Adds validations for the number before updating the widget model. like validating min and max value for the widget.
         * @param {number} val number to be validated
         * @returns {number}
         */
        NumberLocale.prototype.isValid = function (val) {
            // id number is infinite then consider it as invalid value
            if (_.isNaN(val) || !_.isFinite(val) || (!Number.isInteger(this.step) &&
                this.countDecimals(val) > this.countDecimals(this.step))) {
                this.isInvalidNumber = true;
                return false;
            }
            if (val !== this.getValueInRange(val)) {
                this.numberNotInRange = true;
                return true;
            }
            this.resetValidations();
            return true;
        };
        /**
         * returns a valid number by validating the minimum and maximum values.
         * @param {number} value
         * @returns {number}
         */
        NumberLocale.prototype.getValueInRange = function (value) {
            if (!_.isNaN(this.minvalue) && value < this.minvalue) {
                this.validateType = 'minvalue';
                return this.minvalue;
            }
            if (!_.isNaN(this.maxvalue) && value > this.maxvalue) {
                this.validateType = 'maxvalue';
                return this.maxvalue;
            }
            return value;
        };
        /**
         * convert number to localized number using angular decimal pipe. eg 10,00,000 or 1,000,000
         * @param number
         * @returns {string}
         */
        NumberLocale.prototype.transformNumber = function (number) {
            return this.trailingZeroDecimalPipe.transform(number, this.selectedLocale, this.numberfilter, this.localefilter, this.trailingzero, this.decimalValue);
        };
        /**
         * resets the cursor position in the text box.
         * @param {number} value cursor position index form left to right.
         */
        NumberLocale.prototype.resetCursorPosition = function (value) {
            var input = this.inputEl.nativeElement;
            // position of the cursor should be given form right to left.
            var position = input.value.length - value;
            position = position < 0 ? 0 : position;
            // set the cursor position in the text box.
            input.setSelectionRange(position, position);
        };
        /**
         * Method parses the Localized number(string) to a valid number.
         * if the string dose not result to a valid number then returns NaN.
         * @param {string} val Localized number.
         * @returns {number}
         */
        NumberLocale.prototype.parseNumber = function (val) {
            // splits string into two parts. decimal and number.
            var parts = val.split(this.DECIMAL);
            if (!parts.length) {
                return null;
            }
            if (parts.length > 2) {
                return NaN;
            }
            // If number have decimal point and not have a decimal value then return.
            if (parts[1] === '') {
                return NaN;
            }
            // replaces all group separators form the number.
            var number = Number(parts[0].split(this.GROUP).join(''));
            var decimal = Number("0." + (parts[1] || 0));
            if (Number.isNaN(number) || Number.isNaN(decimal)) {
                return NaN;
            }
            // if the number is negative then calculate the number as number - decimal
            // Ex: number = -123 and decimal = 0.45 then number - decimal = -123-045 = -123.45
            return number >= 0 ? number + decimal : number - decimal;
        };
        // updates the widgets text value.
        NumberLocale.prototype.updateDisplayText = function () {
            var input = this.inputEl.nativeElement;
            var position = input.selectionStart;
            var preValue = input.value;
            if (!this.isDefaultQuery) {
                var parts = preValue.split(this.DECIMAL);
                this.decimalValue = parts[1] || '';
            }
            this.displayValue = input.value = this.transformNumber(this.proxyModel);
            // in safari browser, setSelectionRange will focus the input by default, which may invoke the focus event on widget.
            // Hence preventing the setSelectionRange when default value is set i.e. widget is not focused.
            if (this.updateon === 'default' && !this.isDefaultQuery) {
                this.resetCursorPosition(preValue.length - position);
            }
        };
        /**
         * returns the number of decimal places a number have.
         * @param value: number
         * @returns {number}
         */
        NumberLocale.prototype.countDecimals = function (value) {
            if ((value % 1) !== 0) {
                var decimalValue = value.toString().split('.')[1];
                return decimalValue && decimalValue.length;
            }
            return 0;
        };
        /**
         * handles the arrow press event. Increases or decreases the number. triggered fom the template
         * @param $event keyboard event.
         * @param key identifier to increase or decrease the number.
         */
        NumberLocale.prototype.onArrowPress = function ($event, key) {
            $event.preventDefault();
            if (this.readonly || this.step === 0) {
                return;
            }
            var proxyModel = this.proxyModel;
            var value;
            // if the number is not in range and when arrow buttons are pressed need to get appropriate number value.
            if (this.numberNotInRange) {
                var inputValue = this.parseNumber(this.inputEl.nativeElement.value);
                // take the textbox value as current model if the value is valid.
                if (!_.isNaN(inputValue)) {
                    value = this.getValueInRange(inputValue);
                    proxyModel = inputValue;
                    this.resetValidations();
                }
            }
            else {
                if (_.isUndefined(proxyModel) || _.isNull(proxyModel)) {
                    proxyModel = value = this.getValueInRange((this.minvalue || 0));
                    this.resetValidations();
                }
                else {
                    value = this.getValueInRange(proxyModel + (key === 'UP' ? this.step : -this.step));
                }
            }
            if ((key === 'UP' && proxyModel <= value) || (key === 'DOWN' && proxyModel >= value)) {
                var decimalRoundValue = Math.max(this.countDecimals(proxyModel), this.countDecimals(this.step));
                // update the modelProxy.
                this.proxyModel = _.round(value, decimalRoundValue);
                this.updateDisplayText();
                this.handleChange(this.proxyModel);
            }
        };
        /**
         * method is called from the from widget. to check whether the value entered is valid or not.
         * @returns {object}
         */
        NumberLocale.prototype.validate = function (c) {
            if (this.isInvalidNumber) {
                this.validateType = '';
                return {
                    invalidNumber: {
                        valid: false
                    },
                };
            }
            if (this.numberNotInRange) {
                return {
                    numberNotInRange: {
                        valid: false
                    },
                };
            }
            this.validateType = '';
            /* WMS-18269 | Extending the existing validation for 'required' */
            if (this['show'] && this['required']) {
                return (!!c.value || c.value === 0) ? null : { required: true };
            }
            return null;
        };
        NumberLocale.prototype.validateInputEntry = function ($event) {
            this.isDefaultQuery = false;
            // allow actions if control key is pressed or if backspace is pressed. (for Mozilla).
            if ($event.ctrlKey || _.includes(['Backspace', 'ArrowRight', 'ArrowLeft', 'Tab', 'Enter'], $event.key)) {
                return;
            }
            var validity = new RegExp("^[\\d\\s-,.e+" + this.GROUP + this.DECIMAL + "]$", 'i');
            var inputValue = $event.target.value;
            // validates if user entered an invalid character.
            if (!validity.test($event.key)) {
                return false;
            }
            // a decimal value can be entered only once in the input.
            if (_.includes(inputValue, this.DECIMAL) && $event.key === this.DECIMAL) {
                return false;
            }
            // 'e' can be entered only once in the input.
            if (_.intersection(_.toArray(inputValue), ['e', 'E']).length && _.includes('eE', $event.key)) {
                return false;
            }
            if ((_.includes(inputValue, '+') || _.includes(inputValue, '-')) && ($event.key === '+' || $event.key === '-')) {
                return false;
            }
        };
        NumberLocale.prototype.onEnter = function ($event) {
            this.datavalue = $event.target.value;
        };
        NumberLocale.prototype.onPropertyChange = function (key, nv, ov) {
            if (key === 'minvalue' || key === 'maxvalue') {
                this.isValid(nv);
            }
            else {
                _super.prototype.onPropertyChange.call(this, key, nv, ov);
            }
        };
        return NumberLocale;
    }(BaseInput));

    var WIDGET_CONFIG$5 = {
        widgetType: 'wm-number',
        hostClass: 'app-input-wrapper'
    };
    var NumberComponent = /** @class */ (function (_super) {
        __extends(NumberComponent, _super);
        function NumberComponent(inj, i18nService, trailingZeroDecimalPipe) {
            return _super.call(this, inj, WIDGET_CONFIG$5, i18nService, trailingZeroDecimalPipe) || this;
        }
        NumberComponent_1 = NumberComponent;
        var NumberComponent_1;
        NumberComponent.initializeProps = registerProps$5();
        NumberComponent.ctorParameters = function () { return [
            { type: core.Injector },
            { type: core$1.AbstractI18nService },
            { type: base.TrailingZeroDecimalPipe }
        ]; };
        __decorate([
            core.ViewChild('input', { static: true }),
            __metadata("design:type", core.ElementRef)
        ], NumberComponent.prototype, "inputEl", void 0);
        __decorate([
            core.ViewChild(forms.NgModel, { static: true }),
            __metadata("design:type", forms.NgModel)
        ], NumberComponent.prototype, "ngModel", void 0);
        NumberComponent = NumberComponent_1 = __decorate([
            core.Component({
                selector: '[wmNumber]',
                template: "<input class=\"form-control app-textbox app-number-input\"\n       inputmode=\"numeric\"\n       focus-target\n       [attr.name]=\"name\"\n       role=\"input\"\n       type=\"text\"\n       [ngModel]=\"displayValue\"\n       [readonly]=\"readonly\"\n       [disabled]=\"disabled\"\n       [pattern]=\"regexp\"\n       [attr.tabindex]=\"tabindex\"\n       [attr.placeholder]=\"placeholder\"\n       [attr.accesskey]=\"shortcutkey\"\n       [autofocus]=\"autofocus\"\n       (ngModelChange)=\"datavalue=$event\"\n       (blur)=\"handleBlur($event)\"\n       [ngModelOptions]=\"ngModelOptions\"\n       [required]=\"required\"\n       (keypress)=\"validateInputEntry($event)\"\n       (keydown.enter)=\"onEnter($event)\"\n       (keydown.ArrowUp)=\"onArrowPress($event, 'UP')\"\n       (keydown.ArrowDown)=\"onArrowPress($event, 'DOWN')\"\n       #input>",
                providers: [
                    base.provideAs(NumberComponent_1, forms.NG_VALUE_ACCESSOR, true),
                    base.provideAs(NumberComponent_1, forms.NG_VALIDATORS, true),
                    base.provideAsWidgetRef(NumberComponent_1)
                ]
            }),
            __metadata("design:paramtypes", [core.Injector, core$1.AbstractI18nService, base.TrailingZeroDecimalPipe])
        ], NumberComponent);
        return NumberComponent;
    }(NumberLocale));

    var radiosetProps = new Map([
        ['class', base.PROP_STRING],
        ['compareby', base.PROP_STRING],
        ['datafield', base.PROP_STRING],
        ['dataset', __assign({ value: 'Option 1, Option 2, Option 3' }, base.PROP_ANY)],
        ['datavaluesource', base.PROP_ANY],
        ['datavalue', base.PROP_ANY],
        ['disabled', base.PROP_BOOLEAN],
        ['displayexpression', base.PROP_STRING],
        ['displayfield', base.PROP_STRING],
        ['displayValue', base.PROP_STRING],
        ['itemclass', __assign({ value: '' }, base.PROP_STRING)],
        ['itemsperrow', __assign({ value: 'xs-1 sm-1 md-1 lg-1' }, base.PROP_STRING)],
        ['listclass', __assign({ value: '' }, base.PROP_STRING)],
        ['name', base.PROP_STRING],
        ['orderby', base.PROP_STRING],
        ['readonly', base.PROP_BOOLEAN],
        ['required', base.PROP_BOOLEAN],
        ['show', __assign({ value: true }, base.PROP_BOOLEAN)],
        ['showindevice', __assign({ displayType: 'inline-block', value: 'all' }, base.PROP_STRING)],
        ['tabindex', __assign({ value: 0 }, base.PROP_NUMBER)],
        ['usekeys', base.PROP_BOOLEAN]
    ]);
    var registerProps$6 = function () {
        base.register('wm-radioset', radiosetProps);
        base.registerFormWidget(core$1.FormWidgetType.RADIOSET, new Map(radiosetProps));
    };

    var DEFAULT_CLS$5 = 'app-radioset list-group inline';
    var WIDGET_CONFIG$6 = { widgetType: 'wm-radioset', hostClass: DEFAULT_CLS$5 };
    var RadiosetComponent = /** @class */ (function (_super) {
        __extends(RadiosetComponent, _super);
        function RadiosetComponent(inj) {
            var _this = _super.call(this, inj, WIDGET_CONFIG$6) || this;
            _this.layout = '';
            base.styler(_this.nativeElement, _this);
            _this.multiple = false;
            return _this;
        }
        RadiosetComponent_1 = RadiosetComponent;
        /**
         * On click of the option, update the datavalue
         */
        RadiosetComponent.prototype.onRadioLabelClick = function ($event, key) {
            if (!$($event.target).is('input')) {
                return;
            }
            this.modelByKey = key;
            this.invokeOnTouched();
            // invoke on datavalue change.
            this.invokeOnChange(this.datavalue, $event || {}, true);
        };
        // change and blur events are added from the template
        RadiosetComponent.prototype.handleEvent = function (node, eventName, callback, locals) {
            if (eventName === 'click') {
                this.eventManager.addEventListener(node, eventName, function (e) {
                    if (!$(e.target).is('input')) {
                        return;
                    }
                    locals.$event = e;
                    return callback();
                });
            }
            else if (!_.includes(['change'], eventName)) {
                _super.prototype.handleEvent.call(this, node, eventName, callback, locals);
            }
        };
        RadiosetComponent.prototype.onPropertyChange = function (key, nv, ov) {
            if (key === 'tabindex') {
                return;
            }
            if (key === 'itemsperrow') {
                core$1.setListClass(this);
            }
            else {
                _super.prototype.onPropertyChange.call(this, key, nv, ov);
            }
        };
        var RadiosetComponent_1;
        RadiosetComponent.initializeProps = registerProps$6();
        RadiosetComponent.ctorParameters = function () { return [
            { type: core.Injector }
        ]; };
        RadiosetComponent = RadiosetComponent_1 = __decorate([
            core.Component({
                selector: '[wmRadioset]',
                exportAs: 'wmRadioset',
                template: "<li [ngClass]=\"['radio', 'app-radio', itemclass, itemsPerRowClass]\"\n    [class.active]=\"item.selected\"\n    *ngFor=\"let item of datasetItems;let i = index\"\n    [wmItemTemplate]=\"content\" [userComponentParams]=\"item\" partialContainer\n    (click)=\"onRadioLabelClick($event, item.key)\">\n    <!-- Default item template -->\n    <label *ngIf=\"!content\" class=\"app-radioset-label\"\n           [ngClass]=\"{'disabled':disabled || readonly}\"\n           [title]=\"item.label\">\n        <input [name]=\"'radioset_' + widgetId\" type=\"radio\" [attr.aria-checked]=\"item.selected\" [attr.data-attr-index]=\"i\"\n               [value]=\"item.key\" [disabled]=\"disabled || readonly\" [tabindex]=\"tabindex\" [checked]=\"item.selected\"/>\n        <span class=\"caption\" [textContent]=\"item.label\"></span>\n    </label>\n    <!-- Custom partial template -->\n    <label *ngIf=\"content\" class=\"app-radioset-label\"\n           [ngClass]=\"{'disabled':disabled || readonly}\"\n           [title]=\"item.label\">\n        <input [name]=\"'radioset_' + widgetId\" type=\"radio\" [attr.aria-checked]=\"item.selected\" [attr.data-attr-index]=\"i\"\n               [value]=\"item.key\" [disabled]=\"disabled || readonly\" [tabindex]=\"tabindex\" [checked]=\"item.selected\"/>\n        <span class=\"caption customTemplate\" partial-container-target></span>\n    </label>\n</li>\n\n<input [disabled]=\"disabled || readonly\" hidden class=\"model-holder\">\n<div *ngIf=\"readonly || disabled\" aria-readonly=\"true\" class=\"readonly-wrapper\"></div>\n",
                providers: [
                    base.provideAs(RadiosetComponent_1, forms.NG_VALUE_ACCESSOR, true),
                    base.provideAs(RadiosetComponent_1, forms.NG_VALIDATORS, true),
                    base.provideAsWidgetRef(RadiosetComponent_1)
                ]
            }),
            __metadata("design:paramtypes", [core.Injector])
        ], RadiosetComponent);
        return RadiosetComponent;
    }(DatasetAwareFormComponent));

    var selectProps = new Map([
        ['autofocus', base.PROP_BOOLEAN],
        ['class', __assign({ value: '' }, base.PROP_STRING)],
        ['compareby', base.PROP_STRING],
        ['datafield', base.PROP_STRING],
        ['dataset', base.PROP_ANY],
        ['datavaluesource', base.PROP_ANY],
        ['datavalue', base.PROP_STRING],
        ['disabled', base.PROP_BOOLEAN],
        ['displayexpression', base.PROP_STRING],
        ['displayfield', base.PROP_STRING],
        ['displayValue', base.PROP_STRING],
        ['hint', base.PROP_STRING],
        ['multiple', __assign({ value: false }, base.PROP_BOOLEAN)],
        ['name', base.PROP_STRING],
        ['orderby', base.PROP_STRING],
        ['placeholder', base.PROP_STRING],
        ['readonly', base.PROP_BOOLEAN],
        ['required', base.PROP_BOOLEAN],
        ['shortcutkey', base.PROP_STRING],
        ['show', __assign({ value: true }, base.PROP_BOOLEAN)],
        ['tabindex', __assign({ value: 0 }, base.PROP_NUMBER)],
        ['usekeys', base.PROP_BOOLEAN]
    ]);
    var registerProps$7 = function () {
        base.register('wm-select', selectProps);
        base.registerFormWidget(core$1.FormWidgetType.SELECT, new Map(selectProps));
        base.registerFormWidget(core$1.FormWidgetType.TYPEAHEAD, new Map(selectProps));
    };

    var WIDGET_CONFIG$7 = { widgetType: 'wm-select', hostClass: 'app-select-wrapper' };
    var SelectComponent = /** @class */ (function (_super) {
        __extends(SelectComponent, _super);
        function SelectComponent(inj) {
            var _this = _super.call(this, inj, WIDGET_CONFIG$7) || this;
            _this.acceptsArray = true;
            return _this;
        }
        SelectComponent_1 = SelectComponent;
        Object.defineProperty(SelectComponent.prototype, "datasource", {
            set: function (ds) {
                if (ds && ds.execute && ds.execute(core$1.DataSource.Operation.IS_BOUND_TO_LOCALE)) {
                    this.datavalue = ds.execute(core$1.DataSource.Operation.GET_DEFAULT_LOCALE);
                }
            },
            enumerable: true,
            configurable: true
        });
        SelectComponent.prototype.ngAfterViewInit = function () {
            _super.prototype.ngAfterViewInit.call(this);
            base.styler(this.selectEl.nativeElement, this);
        };
        // Change event is registered from the template, Prevent the framework from registering one more event
        SelectComponent.prototype.handleEvent = function (node, eventName, eventCallback, locals) {
            if (!_.includes(['blur', 'change'], eventName)) {
                _super.prototype.handleEvent.call(this, this.selectEl.nativeElement, eventName, eventCallback, locals);
            }
        };
        SelectComponent.prototype.onSelectValueChange = function ($event) {
            if (this.readonly) {
                if (this.placeholder) {
                    this.selectEl.nativeElement.value = this.placeholder;
                }
                else {
                    this.selectEl.nativeElement.value = '';
                }
                this.datavalue = this.prevDatavalue;
                return;
            }
            this.invokeOnTouched();
            // invoke on datavalue change.
            this.invokeOnChange(this.datavalue, $event || {}, true);
        };
        SelectComponent.prototype.onPropertyChange = function (key, nv, ov) {
            if (key === 'required') {
                this._onChange(this.datavalue);
                return;
            }
            if (key === 'class' || key === 'tabindex') {
                return;
            }
            else if (key === 'readonly') {
                (nv === true) ? core$1.setAttr(this.selectEl.nativeElement, 'readonly', 'readonly') : core$1.removeAttr(this.selectEl.nativeElement, 'readonly');
            }
            _super.prototype.onPropertyChange.call(this, key, nv, ov);
        };
        var SelectComponent_1;
        SelectComponent.initializeProps = registerProps$7();
        SelectComponent.ctorParameters = function () { return [
            { type: core.Injector }
        ]; };
        __decorate([
            core.ViewChild('select', { static: true, read: core.ElementRef }),
            __metadata("design:type", core.ElementRef)
        ], SelectComponent.prototype, "selectEl", void 0);
        SelectComponent = SelectComponent_1 = __decorate([
            core.Component({
                selector: 'wm-select',
                template: "<select role=\"input\" aria-haspopup=\"true\" aria-expanded=\"false\" #select\n        focus-target\n        [ngClass]=\"['app-select form-control', class]\"\n        [disabled]=\"disabled\"\n        [required]=\"required\"\n        [tabindex]=\"tabindex\"\n        [(ngModel)]=\"modelByKey\"\n        [multiple]=\"multiple\"\n        (change)=\"onSelectValueChange($event)\"\n        (blur)=\"invokeOnTouched($event)\"\n        [attr.name]=\"name\"\n        [autofocus]=\"autofocus\"\n>\n  <option selected value=\"undefined\" [textContent]=\"placeholder\" [hidden]=\"!placeholder\" ></option>\n  <option\n          *ngFor=\"let item of datasetItems\"\n          [value]=\"item.key\" [selected]=\"item.selected\" [textContent]=\"item.label\"></option>\n</select>\n",
                providers: [
                    base.provideAs(SelectComponent_1, forms.NG_VALUE_ACCESSOR, true),
                    base.provideAs(SelectComponent_1, forms.NG_VALIDATORS, true),
                    base.provideAsWidgetRef(SelectComponent_1)
                ]
            }),
            __metadata("design:paramtypes", [core.Injector])
        ], SelectComponent);
        return SelectComponent;
    }(DatasetAwareFormComponent));

    var switchProps = new Map([
        ['class', base.PROP_STRING],
        ['compareby', base.PROP_STRING],
        ['datafield', base.PROP_STRING],
        ['dataset', __assign({ value: 'yes, no, maybe' }, base.PROP_ANY)],
        ['datavaluesource', base.PROP_ANY],
        ['datavalue', base.PROP_STRING],
        ['disabled', base.PROP_BOOLEAN],
        ['displayexpression', base.PROP_STRING],
        ['displayfield', base.PROP_STRING],
        ['hint', base.PROP_STRING],
        ['iconclass', base.PROP_STRING],
        ['name', base.PROP_STRING],
        ['orderby', base.PROP_STRING],
        ['required', base.PROP_BOOLEAN],
        ['show', __assign({ value: true }, base.PROP_BOOLEAN)],
        ['tabindex', __assign({ value: 0 }, base.PROP_NUMBER)]
    ]);
    var registerProps$8 = function () {
        base.register('wm-switch', switchProps);
        base.registerFormWidget(core$1.FormWidgetType.SWITCH, new Map(switchProps));
        base.registerFormWidget(core$1.FormWidgetType.TOGGLE, new Map(switchProps));
    };

    var DEFAULT_CLS$6 = 'app-switch';
    var WIDGET_CONFIG$8 = { widgetType: 'wm-switch', hostClass: DEFAULT_CLS$6 };
    var SwitchComponent = /** @class */ (function (_super) {
        __extends(SwitchComponent, _super);
        function SwitchComponent(inj) {
            var _this = _super.call(this, inj, WIDGET_CONFIG$8) || this;
            _this.options = [];
            _this._debounceSetSelectedValue = core$1.debounce(function (val) {
                _this.setSelectedValue();
                _this.updateHighlighter(val);
                // only for default value trigger app digest to apply the selectedItem
                if (val) {
                    core$1.$appDigest();
                }
            }, 200);
            var datasetSubscription = _this.dataset$.subscribe(function () { return _this.updateSwitchOptions(); });
            _this.registerDestroyListener(function () { return datasetSubscription.unsubscribe(); });
            var datavalueSubscription = _this.datavalue$.subscribe(function () {
                _this._debounceSetSelectedValue(true);
            });
            _this.registerDestroyListener(function () { return datavalueSubscription.unsubscribe(); });
            return _this;
        }
        SwitchComponent_1 = SwitchComponent;
        SwitchComponent.prototype.ngAfterViewInit = function () {
            _super.prototype.ngAfterViewInit.call(this);
            base.styler(this.nativeElement, this);
        };
        SwitchComponent.prototype.onStyleChange = function (key, nv, ov) {
            if (key === 'height') {
                core$1.setCSS(this.nativeElement, 'overflow', nv ? 'auto' : '');
            }
            else {
                _super.prototype.onStyleChange.call(this, key, nv, ov);
            }
        };
        // This function sets the selectedItem by either using compareby fields or selected flag on datasetItems.
        SwitchComponent.prototype.setSelectedValue = function () {
            if (core$1.isDefined(this.datavalue) || core$1.isDefined(this.toBeProcessedDatavalue)) {
                this.selectedItem = _.find(this.datasetItems, { selected: true });
                return;
            }
            // If no value is provided, set first value as default if options are available else set -1 ie no selection
            this.selectOptAtIndex(0);
        };
        // set the css for switch overlay element.
        // set the selected index from the datasetItems and highlight the datavalue on switch.
        SwitchComponent.prototype.updateSwitchOptions = function () {
            if (this.datasetItems.length) {
                this.btnwidth = (100 / this.datasetItems.length);
                core$1.setCSS(this.nativeElement.querySelector('.app-switch-overlay'), 'width', this.btnwidth + '%');
            }
            this._debounceSetSelectedValue(true);
        };
        // This function animates the highlighted span on to the selected value.
        SwitchComponent.prototype.updateHighlighter = function (skipAnimation) {
            var handler = $(this.nativeElement).find('span.app-switch-overlay');
            this.setSelectedValue();
            var left, index = this.selectedItem ? _.findIndex(this.datasetItems, { key: this.selectedItem.key }) : -1;
            if (index === undefined || index === null) {
                index = -1;
            }
            left = index * this.btnwidth;
            if (skipAnimation) {
                handler.css('left', left + '%');
            }
            else {
                handler.animate({
                    left: left + '%'
                }, 300);
            }
        };
        SwitchComponent.prototype.selectOptAtIndex = function ($index) {
            if (!this.datasetItems.length) {
                return;
            }
            var opt = this.datasetItems[$index];
            this._modelByValue = opt.value;
        };
        // Triggered on selected the option from the switch.
        // set the index and highlight the default value. Invoke onchange event handler.
        SwitchComponent.prototype.selectOpt = function ($event, $index, option) {
            $event.preventDefault();
            if (this.disabled) {
                return;
            }
            this.modelByKey = option.key;
            this.invokeOnTouched();
            if (this.selectedItem && $index === _.findIndex(this.datasetItems, { key: this.selectedItem.key })) {
                if (this.datasetItems.length === 2) {
                    $index = $index === 1 ? 0 : 1;
                }
                else {
                    return;
                }
            }
            this.selectedItem = this.datasetItems[$index];
            this.updateHighlighter();
            // invoke on datavalue change.
            this.invokeOnChange(this.datavalue, $event || {}, true);
            core$1.$appDigest();
        };
        SwitchComponent.prototype.onPropertyChange = function (key, nv, ov) {
            if (key === 'disabled' && !core$1.toBoolean(nv)) {
                this.nativeElement.removeAttribute(key);
            }
            else {
                _super.prototype.onPropertyChange.call(this, key, nv, ov);
            }
        };
        var SwitchComponent_1;
        SwitchComponent.initializeProps = registerProps$8();
        SwitchComponent.ctorParameters = function () { return [
            { type: core.Injector }
        ]; };
        SwitchComponent = SwitchComponent_1 = __decorate([
            core.Component({
                selector: '[wmSwitch]',
                template: "<div role=\"group\" aria-label=\"button switch\" class=\"btn-group btn-group-justified\">\n    <a *ngFor=\"let opt of datasetItems; let $index = index;\"\n       [title]=\"opt.label\" focus-target\n       href=\"javascript:void(0);\"\n       class=\"btn btn-default\"\n       [name]=\"'wm-switch-' + opt.key\"\n       [ngClass]=\"{'selected': opt.selected, 'disabled': disabled}\"\n       (click)=\"selectOpt($event, $index, opt)\"\n    >\n        <i *ngIf=\"opt.dataObject && opt.dataObject[iconclass]\" aria-hidden=\"true\" [ngClass]=\"['app-icon', opt.dataObject[iconclass] || opt['icon']]\"></i>\n        <span class=\"caption\" [textContent]=\"opt[displayfield] || opt.label\"></span>\n    </a>\n</div>\n<span [title]=\"selectedItem ? selectedItem.label : modelByKey\"\n      class=\"btn btn-primary app-switch-overlay switch-handle\">\n    <i *ngIf=\"iconclass\"\n       class=\"app-icon {{(selectedItem && selectedItem.dataObject) && selectedItem.dataObject[iconclass]}}\"></i>\n    {{selectedItem ? selectedItem.label : modelByKey}}\n</span>\n<input [name]=\"name\" class=\"model-holder ng-hide\" [disabled]=\"disabled\" [value]=\"modelByKey\" [required]=\"required\">\n",
                providers: [
                    base.provideAs(SwitchComponent_1, forms.NG_VALUE_ACCESSOR, true),
                    base.provideAsWidgetRef(SwitchComponent_1)
                ]
            }),
            __metadata("design:paramtypes", [core.Injector])
        ], SwitchComponent);
        return SwitchComponent;
    }(DatasetAwareFormComponent));

    var inputCalendarTypeProps = new Map([
        ['autocomplete', __assign({ value: true }, base.PROP_BOOLEAN)],
        ['autotrim', __assign({ value: true }, base.PROP_BOOLEAN)],
        ['autofocus', base.PROP_BOOLEAN],
        ['class', base.PROP_STRING],
        ['datasource', base.PROP_ANY],
        ['datavalue', base.PROP_STRING],
        ['disabled', base.PROP_BOOLEAN],
        ['hint', base.PROP_STRING],
        ['maxvalue', base.PROP_NUMBER],
        ['minvalue', base.PROP_NUMBER],
        ['name', base.PROP_STRING],
        ['placeholder', __assign({ value: 'Enter text' }, base.PROP_STRING)],
        ['readonly', base.PROP_BOOLEAN],
        ['required', base.PROP_BOOLEAN],
        ['shortcutkey', base.PROP_STRING],
        ['show', __assign({ value: true }, base.PROP_BOOLEAN)],
        ['step', base.PROP_NUMBER],
        ['tabindex', __assign({ value: 0 }, base.PROP_NUMBER)],
        ['type', base.PROP_STRING],
        ['updateon', base.PROP_STRING]
    ]);
    var registerProps$9 = function () {
        base.register('wm-input-calendar', inputCalendarTypeProps);
    };

    var WIDGET_CONFIG$9 = {
        widgetType: 'wm-input-calendar',
        hostClass: 'app-input-wrapper'
    };
    var InputCalendarComponent = /** @class */ (function (_super) {
        __extends(InputCalendarComponent, _super);
        function InputCalendarComponent(inj) {
            return _super.call(this, inj, WIDGET_CONFIG$9) || this;
        }
        InputCalendarComponent_1 = InputCalendarComponent;
        var InputCalendarComponent_1;
        InputCalendarComponent.initializeProps = registerProps$9();
        InputCalendarComponent.ctorParameters = function () { return [
            { type: core.Injector }
        ]; };
        __decorate([
            core.ViewChild('input', { static: true }),
            __metadata("design:type", core.ElementRef)
        ], InputCalendarComponent.prototype, "inputEl", void 0);
        __decorate([
            core.ViewChild(forms.NgModel),
            __metadata("design:type", forms.NgModel)
        ], InputCalendarComponent.prototype, "ngModel", void 0);
        InputCalendarComponent = InputCalendarComponent_1 = __decorate([
            core.Component({
                selector: 'wm-input[type="date"], wm-input[type="datetime-local"], wm-input[type="month"], wm-input[type="time"], wm-input[type="week"]',
                template: "<input class=\"form-control app-textbox\"\n       focus-target\n       role=\"input\"\n       [type]=\"type\"\n       [attr.name]=\"name\"\n       [(ngModel)]=\"datavalue\"\n       [readonly]=\"readonly\"\n       [required]=\"required\"\n       [disabled]=\"disabled\"\n       [min]=\"minvalue\"\n       [max]=\"maxvalue\"\n       [step]=\"step\"\n       [attr.tabindex]=\"tabindex\"\n       [attr.placeholder]=\"placeholder\"\n       [attr.accesskey]=\"shortcutkey\"\n       [autofocus]=\"autofocus\"\n       (blur)=\"handleBlur($event)\"\n       (ngModelChange)=\"handleChange($event)\"\n       [autocomplete]=\"autocomplete ? 'on' : 'off'\"\n       #input>\n",
                providers: [
                    base.provideAs(InputCalendarComponent_1, forms.NG_VALUE_ACCESSOR, true),
                    base.provideAs(InputCalendarComponent_1, forms.NG_VALIDATORS, true),
                    base.provideAsWidgetRef(InputCalendarComponent_1)
                ]
            }),
            __metadata("design:paramtypes", [core.Injector])
        ], InputCalendarComponent);
        return InputCalendarComponent;
    }(BaseInput));

    var inputColorTypeProps = new Map([
        ['autocomplete', __assign({ value: true }, base.PROP_BOOLEAN)],
        ['autofocus', base.PROP_BOOLEAN],
        ['autotrim', __assign({ value: true }, base.PROP_BOOLEAN)],
        ['class', base.PROP_STRING],
        ['datavaluesource', base.PROP_ANY],
        ['datavalue', base.PROP_STRING],
        ['disabled', base.PROP_BOOLEAN],
        ['hint', base.PROP_STRING],
        ['name', base.PROP_STRING],
        ['placeholder', __assign({ value: 'Enter text' }, base.PROP_STRING)],
        ['readonly', base.PROP_BOOLEAN],
        ['required', base.PROP_BOOLEAN],
        ['shortcutkey', base.PROP_STRING],
        ['show', __assign({ value: true }, base.PROP_BOOLEAN)],
        ['tabindex', __assign({ value: 0 }, base.PROP_NUMBER)],
        ['type', base.PROP_STRING],
        ['updateon', base.PROP_STRING]
    ]);
    var registerProps$a = function () {
        base.register('wm-input-color', inputColorTypeProps);
    };

    var WIDGET_CONFIG$a = {
        widgetType: 'wm-input-color',
        hostClass: 'app-input-wrapper'
    };
    var InputColorComponent = /** @class */ (function (_super) {
        __extends(InputColorComponent, _super);
        function InputColorComponent(inj) {
            return _super.call(this, inj, WIDGET_CONFIG$a) || this;
        }
        InputColorComponent_1 = InputColorComponent;
        var InputColorComponent_1;
        InputColorComponent.initializeProps = registerProps$a();
        InputColorComponent.ctorParameters = function () { return [
            { type: core.Injector }
        ]; };
        __decorate([
            core.ViewChild('input', { static: true }),
            __metadata("design:type", core.ElementRef)
        ], InputColorComponent.prototype, "inputEl", void 0);
        __decorate([
            core.ViewChild(forms.NgModel),
            __metadata("design:type", forms.NgModel)
        ], InputColorComponent.prototype, "ngModel", void 0);
        InputColorComponent = InputColorComponent_1 = __decorate([
            core.Component({
                selector: 'wm-input[type="color"]',
                template: "<input class=\"form-control app-textbox\"\n       focus-target\n       type=\"color\"\n       role=\"input\"\n       [attr.name]=\"name\"\n       [(ngModel)]=\"datavalue\"\n       [readonly]=\"readonly\"\n       [required]=\"required\"\n       [disabled]=\"disabled\"\n       [maxlength]=\"maxchars\"\n       [attr.tabindex]=\"tabindex\"\n       [attr.placeholder]=\"placeholder\"\n       [attr.accesskey]=\"shortcutkey\"\n       [autofocus]=\"autofocus\"\n       (blur)=\"handleBlur($event)\"\n       (ngModelChange)=\"handleChange($event)\"\n       #input>",
                providers: [
                    base.provideAs(InputColorComponent_1, forms.NG_VALUE_ACCESSOR, true),
                    base.provideAs(InputColorComponent_1, forms.NG_VALIDATORS, true),
                    base.provideAsWidgetRef(InputColorComponent_1)
                ]
            }),
            __metadata("design:paramtypes", [core.Injector])
        ], InputColorComponent);
        return InputColorComponent;
    }(BaseInput));

    var inputEmailTypeProps = new Map([
        ['autocomplete', __assign({ value: true }, base.PROP_BOOLEAN)],
        ['autofocus', base.PROP_BOOLEAN],
        ['autotrim', __assign({ value: true }, base.PROP_BOOLEAN)],
        ['class', base.PROP_STRING],
        ['datavaluesource', base.PROP_ANY],
        ['datavalue', base.PROP_STRING],
        ['disabled', base.PROP_BOOLEAN],
        ['hint', base.PROP_STRING],
        ['maxchars', base.PROP_NUMBER],
        ['name', base.PROP_STRING],
        ['placeholder', __assign({ value: 'Enter text' }, base.PROP_STRING)],
        ['readonly', base.PROP_BOOLEAN],
        ['regexp', base.PROP_STRING],
        ['required', base.PROP_BOOLEAN],
        ['shortcutkey', base.PROP_STRING],
        ['show', __assign({ value: true }, base.PROP_BOOLEAN)],
        ['tabindex', __assign({ value: 0 }, base.PROP_NUMBER)],
        ['type', base.PROP_STRING],
        ['updateon', base.PROP_STRING]
    ]);
    var registerProps$b = function () {
        base.register('wm-input-email', inputEmailTypeProps);
    };

    var WIDGET_CONFIG$b = {
        widgetType: 'wm-input-email',
        hostClass: 'app-input-wrapper'
    };
    var InputEmailComponent = /** @class */ (function (_super) {
        __extends(InputEmailComponent, _super);
        function InputEmailComponent(inj) {
            return _super.call(this, inj, WIDGET_CONFIG$b) || this;
        }
        InputEmailComponent_1 = InputEmailComponent;
        var InputEmailComponent_1;
        InputEmailComponent.initializeProps = registerProps$b();
        InputEmailComponent.ctorParameters = function () { return [
            { type: core.Injector }
        ]; };
        __decorate([
            core.ViewChild('input', { static: true }),
            __metadata("design:type", core.ElementRef)
        ], InputEmailComponent.prototype, "inputEl", void 0);
        __decorate([
            core.ViewChild(forms.NgModel),
            __metadata("design:type", forms.NgModel)
        ], InputEmailComponent.prototype, "ngModel", void 0);
        InputEmailComponent = InputEmailComponent_1 = __decorate([
            core.Component({
                selector: 'wm-input[type="email"]',
                template: "<input class=\"form-control app-textbox\"\n       focus-target\n       role=\"input\"\n       type=\"email\"\n       [attr.name]=\"name\"\n       [(ngModel)]=\"datavalue\"\n       [ngModelOptions]=\"ngModelOptions\"\n       [readonly]=\"readonly\"\n       [required]=\"required\"\n       [disabled]=\"disabled\"\n       [maxlength]=\"maxchars\"\n       [pattern]=\"regexp\"\n       [attr.tabindex]=\"tabindex\"\n       [attr.placeholder]=\"placeholder\"\n       [attr.accesskey]=\"shortcutkey\"\n       [autofocus]=\"autofocus\"\n       (blur)=\"handleBlur($event)\"\n       (ngModelChange)=\"handleChange($event)\"\n       [autocomplete]=\"autocomplete ? 'on' : 'off'\"\n       (keyup.enter)=\"flushViewChanges(input.value)\"\n       email\n       #input>",
                providers: [
                    base.provideAs(InputEmailComponent_1, forms.NG_VALUE_ACCESSOR, true),
                    base.provideAs(InputEmailComponent_1, forms.NG_VALIDATORS, true),
                    base.provideAsWidgetRef(InputEmailComponent_1)
                ]
            }),
            __metadata("design:paramtypes", [core.Injector])
        ], InputEmailComponent);
        return InputEmailComponent;
    }(BaseInput));

    var inputNumberTypeProps = new Map([
        ['autocomplete', __assign({ value: true }, base.PROP_BOOLEAN)],
        ['autofocus', base.PROP_BOOLEAN],
        ['autotrim', __assign({ value: true }, base.PROP_BOOLEAN)],
        ['class', base.PROP_STRING],
        ['datavaluesource', base.PROP_ANY],
        ['datavalue', base.PROP_STRING],
        ['disabled', base.PROP_BOOLEAN],
        ['hint', base.PROP_STRING],
        ['maxchars', base.PROP_NUMBER],
        ['maxvalue', base.PROP_NUMBER],
        ['minvalue', base.PROP_NUMBER],
        ['name', base.PROP_STRING],
        ['placeholder', __assign({ value: 'Enter text' }, base.PROP_STRING)],
        ['readonly', base.PROP_BOOLEAN],
        ['regexp', base.PROP_STRING],
        ['required', base.PROP_BOOLEAN],
        ['shortcutkey', base.PROP_STRING],
        ['show', __assign({ value: true }, base.PROP_BOOLEAN)],
        ['step', base.PROP_NUMBER],
        ['tabindex', __assign({ value: 0 }, base.PROP_NUMBER)],
        ['type', base.PROP_STRING],
        ['updateon', base.PROP_STRING]
    ]);
    var registerProps$c = function () {
        base.register('wm-input-number', inputNumberTypeProps);
    };

    var WIDGET_CONFIG$c = {
        widgetType: 'wm-input-number',
        hostClass: 'app-input-wrapper'
    };
    var InputNumberComponent = /** @class */ (function (_super) {
        __extends(InputNumberComponent, _super);
        function InputNumberComponent(inj) {
            return _super.call(this, inj, WIDGET_CONFIG$c) || this;
        }
        InputNumberComponent_1 = InputNumberComponent;
        InputNumberComponent.prototype.onArrowPress = function ($event) {
            if (this.step === 0) {
                $event.preventDefault();
            }
        };
        InputNumberComponent.prototype.validateInputEntry = function ($event) {
            if ($event.key === 'e' && $event.target.value.indexOf($event.key) !== -1) {
                return false;
            }
        };
        var InputNumberComponent_1;
        InputNumberComponent.initializeProps = registerProps$c();
        InputNumberComponent.ctorParameters = function () { return [
            { type: core.Injector }
        ]; };
        __decorate([
            core.ViewChild('input', { static: true }),
            __metadata("design:type", core.ElementRef)
        ], InputNumberComponent.prototype, "inputEl", void 0);
        __decorate([
            core.ViewChild(forms.NgModel),
            __metadata("design:type", forms.NgModel)
        ], InputNumberComponent.prototype, "ngModel", void 0);
        InputNumberComponent = InputNumberComponent_1 = __decorate([
            core.Component({
                selector: 'wm-input[type="number"]',
                template: "<input class=\"form-control app-textbox\"\n       [ngClass]=\"{'step-hidden': step === 0}\"\n       focus-target\n       role=\"input\"\n       type=\"number\"\n       [attr.name]=\"name\"\n       [(ngModel)]=\"datavalue\"\n       [ngModelOptions]=\"ngModelOptions\"\n       [readonly]=\"readonly\"\n       [required]=\"required\"\n       [disabled]=\"disabled\"\n       [maxlength]=\"maxchars\"\n       [min]=\"minvalue\"\n       [max]=\"maxvalue\"\n       [step]=\"step\"\n       [attr.tabindex]=\"tabindex\"\n       [attr.placeholder]=\"placeholder\"\n       [attr.accesskey]=\"shortcutkey\"\n       [autofocus]=\"autofocus\"\n       (blur)=\"handleBlur($event)\"\n       (ngModelChange)=\"handleChange($event)\"\n       [autocomplete]=\"autocomplete ? 'on' : 'off'\"\n       (keyup.enter)=\"flushViewChanges(input.value)\"\n       (keydown.ArrowUp)=\"onArrowPress($event)\"\n       (keydown.ArrowDown)=\"onArrowPress($event)\"\n       (keypress)=\"validateInputEntry($event)\"\n       #input>",
                providers: [
                    base.provideAs(InputNumberComponent_1, forms.NG_VALUE_ACCESSOR, true),
                    base.provideAs(InputNumberComponent_1, forms.NG_VALIDATORS, true),
                    base.provideAsWidgetRef(InputNumberComponent_1)
                ]
            }),
            __metadata("design:paramtypes", [core.Injector])
        ], InputNumberComponent);
        return InputNumberComponent;
    }(BaseInput));

    var inputTextTypeProps = new Map([
        ['autocomplete', __assign({ value: true }, base.PROP_BOOLEAN)],
        ['autofocus', base.PROP_BOOLEAN],
        ['autotrim', __assign({ value: true }, base.PROP_BOOLEAN)],
        ['class', base.PROP_STRING],
        ['datavaluesource', base.PROP_ANY],
        ['datavalue', base.PROP_STRING],
        ['disabled', base.PROP_BOOLEAN],
        ['displayformat', base.PROP_STRING],
        ['hint', base.PROP_STRING],
        ['maxchars', base.PROP_NUMBER],
        ['name', base.PROP_STRING],
        ['placeholder', __assign({ value: 'Enter text' }, base.PROP_STRING)],
        ['readonly', base.PROP_BOOLEAN],
        ['regexp', base.PROP_STRING],
        ['required', base.PROP_BOOLEAN],
        ['shortcutkey', base.PROP_STRING],
        ['show', __assign({ value: true }, base.PROP_BOOLEAN)],
        ['tabindex', __assign({ value: 0 }, base.PROP_NUMBER)],
        ['type', __assign({ value: 'text' }, base.PROP_STRING)],
        ['updateon', base.PROP_STRING]
    ]);
    var registerProps$d = function () {
        base.register('wm-input-text', inputTextTypeProps);
        base.registerFormWidget(core$1.FormWidgetType.PASSWORD, new Map(inputTextTypeProps));
        var formTextProps = new Map(inputTextTypeProps);
        var mergeTextProps = function (typeProps) {
            typeProps.forEach(function (v, k) { return formTextProps.set(k, v); });
        };
        mergeTextProps(inputCalendarTypeProps);
        mergeTextProps(inputColorTypeProps);
        mergeTextProps(inputEmailTypeProps);
        mergeTextProps(inputNumberTypeProps);
        base.registerFormWidget(core$1.FormWidgetType.TEXT, new Map(formTextProps));
    };

    var WIDGET_CONFIG$d = {
        widgetType: 'wm-input-text',
        hostClass: 'app-input-wrapper'
    };
    var InputTextComponent = /** @class */ (function (_super) {
        __extends(InputTextComponent, _super);
        function InputTextComponent(inj) {
            return _super.call(this, inj, WIDGET_CONFIG$d) || this;
        }
        InputTextComponent_1 = InputTextComponent;
        /* Define the property change handler. This function will be triggered when there is a change in the widget property */
        InputTextComponent.prototype.onPropertyChange = function (key, nv, ov) {
            /*Monitoring changes for styles or properties and accordingly handling respective changes.*/
            switch (key) {
                case 'displayformat':
                    this.maskVal = this.displayformat;
                    break;
                default:
                    _super.prototype.onPropertyChange.call(this, key, nv, ov);
            }
        };
        Object.defineProperty(InputTextComponent.prototype, "mask", {
            get: function () {
                if (this.displayformat) {
                    return {
                        mask: this.maskVal,
                        lazy: false,
                        definitions: {
                            '9': /\d/,
                            'A': /[a-zA-Z]/,
                            'a': /[a-z]/,
                            '*': /\w/
                        }
                    };
                }
                else {
                    return false;
                }
            },
            enumerable: true,
            configurable: true
        });
        var InputTextComponent_1;
        InputTextComponent.initializeProps = registerProps$d();
        InputTextComponent.ctorParameters = function () { return [
            { type: core.Injector }
        ]; };
        __decorate([
            core.ViewChild('input', { static: true }),
            __metadata("design:type", core.ElementRef)
        ], InputTextComponent.prototype, "inputEl", void 0);
        __decorate([
            core.ViewChild(forms.NgModel),
            __metadata("design:type", forms.NgModel)
        ], InputTextComponent.prototype, "ngModel", void 0);
        InputTextComponent = InputTextComponent_1 = __decorate([
            core.Component({
                selector: 'wm-input[type="text"], wm-input:not([type]), wm-input[type="password"], wm-input[type="search"], wm-input[type="tel"], wm-input[type="url"]',
                template: "<input class=\"form-control app-textbox\"\n       focus-target\n       role=\"input\"\n       [type]=\"type\"\n       [attr.name]=\"name\"\n       [(ngModel)]=\"datavalue\"\n       [imask]=\"mask\"\n       [unmask]=\"true\"\n       [ngModelOptions]=\"ngModelOptions\"\n       [readonly]=\"readonly\"\n       [required]=\"required\"\n       [disabled]=\"disabled\"\n       [maxlength]=\"maxchars\"\n       [pattern]=\"regexp\"\n       [attr.tabindex]=\"tabindex\"\n       [attr.placeholder]=\"placeholder\"\n       [attr.accesskey]=\"shortcutkey\"\n       [autofocus]=\"autofocus\"\n       (ngModelChange)=\"handleChange($event)\"\n       (blur)=\"handleBlur($event)\"\n       [autocomplete]=\"autocomplete ? 'on' : 'off'\"\n       (keyup.enter)=\"flushViewChanges(input.value)\"\n       #input>\n",
                providers: [
                    base.provideAs(InputTextComponent_1, forms.NG_VALUE_ACCESSOR, true),
                    base.provideAs(InputTextComponent_1, forms.NG_VALIDATORS, true),
                    base.provideAsWidgetRef(InputTextComponent_1)
                ]
            }),
            __metadata("design:paramtypes", [core.Injector])
        ], InputTextComponent);
        return InputTextComponent;
    }(BaseInput));

    var textareaProps = new Map([
        ['autofocus', base.PROP_BOOLEAN],
        ['autotrim', __assign({ value: true }, base.PROP_BOOLEAN)],
        ['class', base.PROP_STRING],
        ['datavaluesource', base.PROP_ANY],
        ['datavalue', base.PROP_STRING],
        ['disabled', base.PROP_BOOLEAN],
        ['hint', base.PROP_STRING],
        ['maxchars', base.PROP_NUMBER],
        ['name', base.PROP_STRING],
        ['placeholder', __assign({ value: 'Place your text' }, base.PROP_STRING)],
        ['readonly', base.PROP_BOOLEAN],
        ['required', base.PROP_BOOLEAN],
        ['shortcutkey', base.PROP_STRING],
        ['show', __assign({ value: true }, base.PROP_BOOLEAN)],
        ['tabindex', __assign({ value: 0 }, base.PROP_NUMBER)],
        ['updateon', base.PROP_STRING]
    ]);
    var registerProps$e = function () {
        base.register('wm-textarea', textareaProps);
        base.registerFormWidget(core$1.FormWidgetType.TEXTAREA, new Map(textareaProps));
    };

    var WIDGET_CONFIG$e = {
        widgetType: 'wm-textarea',
        hostClass: 'app-input-wrapper'
    };
    var TextareaComponent = /** @class */ (function (_super) {
        __extends(TextareaComponent, _super);
        function TextareaComponent(inj) {
            return _super.call(this, inj, WIDGET_CONFIG$e) || this;
        }
        TextareaComponent_1 = TextareaComponent;
        var TextareaComponent_1;
        TextareaComponent.initializeProps = registerProps$e();
        TextareaComponent.ctorParameters = function () { return [
            { type: core.Injector }
        ]; };
        __decorate([
            core.ViewChild('textarea', { static: true }),
            __metadata("design:type", core.ElementRef)
        ], TextareaComponent.prototype, "inputEl", void 0);
        __decorate([
            core.ViewChild(forms.NgModel),
            __metadata("design:type", forms.NgModel)
        ], TextareaComponent.prototype, "ngModel", void 0);
        TextareaComponent = TextareaComponent_1 = __decorate([
            core.Component({
                selector: 'wm-textarea',
                template: "<textarea class=\"form-control app-textarea\"\n          focus-target\n          role=\"input\"\n          [attr.name]=\"name\"\n          [(ngModel)]=\"datavalue\"\n          [ngModelOptions]=\"ngModelOptions\"\n          [readonly]=\"readonly\"\n          [required]=\"required\"\n          [disabled]=\"disabled\"\n          [maxlength]=\"maxchars\"\n          [attr.tabindex]=\"tabindex\"\n          [attr.placeholder]=\"placeholder\"\n          [attr.accesskey]=\"shortcutkey\"\n          [autofocus]=\"autofocus\"\n          (blur)=\"handleBlur($event)\"\n          (ngModelChange)=\"handleChange($event)\"\n          #textarea\n></textarea>",
                providers: [
                    base.provideAs(TextareaComponent_1, forms.NG_VALUE_ACCESSOR, true),
                    base.provideAs(TextareaComponent_1, forms.NG_VALIDATORS, true),
                    base.provideAsWidgetRef(TextareaComponent_1)
                ]
            }),
            __metadata("design:paramtypes", [core.Injector])
        ], TextareaComponent);
        return TextareaComponent;
    }(BaseInput));

    var components = [
        ButtonComponent,
        ButtonGroupDirective,
        CheckboxComponent,
        CheckboxsetComponent,
        CompositeDirective,
        NumberComponent,
        RadiosetComponent,
        SelectComponent,
        SwitchComponent,
        InputCalendarComponent,
        InputColorComponent,
        InputEmailComponent,
        InputNumberComponent,
        InputTextComponent,
        TextareaComponent
    ];
    var InputModule = /** @class */ (function () {
        function InputModule() {
        }
        InputModule = __decorate([
            core.NgModule({
                imports: [
                    common.CommonModule,
                    forms.FormsModule,
                    base.WmComponentsModule,
                    angularImask.IMaskModule
                ],
                declarations: __spread(components),
                exports: __spread(components),
                entryComponents: []
            })
        ], InputModule);
        return InputModule;
    }());

    exports.BaseFormComponent = BaseFormComponent;
    exports.BaseFormCustomComponent = BaseFormCustomComponent;
    exports.ButtonComponent = ButtonComponent;
    exports.DatasetAwareFormComponent = DatasetAwareFormComponent;
    exports.InputModule = InputModule;
    exports.NumberLocale = NumberLocale;
    exports.ɵa = registerProps;
    exports.ɵb = ButtonGroupDirective;
    exports.ɵba = InputTextComponent;
    exports.ɵbb = registerProps$d;
    exports.ɵbc = TextareaComponent;
    exports.ɵbd = registerProps$e;
    exports.ɵc = registerProps$1;
    exports.ɵd = CheckboxComponent;
    exports.ɵe = registerProps$2;
    exports.ɵf = CheckboxsetComponent;
    exports.ɵg = registerProps$3;
    exports.ɵh = CompositeDirective;
    exports.ɵi = registerProps$4;
    exports.ɵj = NumberComponent;
    exports.ɵk = BaseInput;
    exports.ɵl = registerProps$5;
    exports.ɵm = RadiosetComponent;
    exports.ɵn = registerProps$6;
    exports.ɵo = SelectComponent;
    exports.ɵp = registerProps$7;
    exports.ɵq = SwitchComponent;
    exports.ɵr = registerProps$8;
    exports.ɵs = InputCalendarComponent;
    exports.ɵt = registerProps$9;
    exports.ɵu = InputColorComponent;
    exports.ɵv = registerProps$a;
    exports.ɵw = InputEmailComponent;
    exports.ɵx = registerProps$b;
    exports.ɵy = InputNumberComponent;
    exports.ɵz = registerProps$c;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=index.umd.js.map
