import { ChangeDetectorRef, Injector } from '@angular/core';
import { AppDefaults } from '@wm/core';
import { BaseDateTimeComponent } from './../base-date-time.component';
export declare class DateComponent extends BaseDateTimeComponent {
    private cdRef;
    private appDefaults;
    static initializeProps: void;
    bsDataValue: any;
    showdropdownon: string;
    private dateContainerCls;
    isOpen: boolean;
    private isEnterPressedOnDateInput;
    private keyEventPlugin;
    private deregisterEventListener;
    get timestamp(): any;
    get dateInputFormat(): string;
    get displayValue(): any;
    get nativeDisplayValue(): any;
    get datavalue(): any;
    set datavalue(newVal: any);
    protected bsDatePickerDirective: any;
    constructor(inj: Injector, cdRef: ChangeDetectorRef, appDefaults: AppDefaults, evtMngrPlugins: any);
    /**
     * This is an internal method triggered when the date input changes
     */
    onDisplayDateChange($event: any, isNativePicker?: any): void;
    private setDataValue;
    onDatePickerOpen(): void;
    onInputBlur($event: any): void;
    hideDatepickerDropdown(): void;
    protected handleEvent(node: HTMLElement, eventName: string, callback: Function, locals: any): void;
    /**
     * This is an internal method used to toggle the dropdown of the date widget
     */
    toggleDpDropdown($event: any): void;
    private addBodyClickListener;
    /**
     * This is an internal method triggered when pressing key on the date input
     */
    onDisplayKeydown(event: any): void;
    /**
     * This is an internal method triggered when the date selection changes
     */
    onDateChange(newVal: any): void;
}
