(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common'), require('@angular/forms'), require('@wm/components/base'), require('@wm/core'), require('@wm/components/input')) :
    typeof define === 'function' && define.amd ? define('@wm/components/input/rating', ['exports', '@angular/core', '@angular/common', '@angular/forms', '@wm/components/base', '@wm/core', '@wm/components/input'], factory) :
    (global = global || self, factory((global.wm = global.wm || {}, global.wm.components = global.wm.components || {}, global.wm.components.input = global.wm.components.input || {}, global.wm.components.input.rating = {}), global.ng.core, global.ng.common, global.ng.forms, global.wm.components.base, global.wm.core, global.wm.components.input));
}(this, (function (exports, core, common, forms, base, core$1, input) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __rest(s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); }
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    function __createBinding(o, m, k, k2) {
        if (k2 === undefined) k2 = k;
        o[k2] = m[k];
    }

    function __exportStar(m, exports) {
        for (var p in m) if (p !== "default" && !exports.hasOwnProperty(p)) exports[p] = m[p];
    }

    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m) return m.call(o);
        if (o && typeof o.length === "number") return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }

    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    }

    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    };

    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }

    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
    }

    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }

    function __asyncValues(o) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
    }

    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
        return cooked;
    };

    function __importStar(mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
        result.default = mod;
        return result;
    }

    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }

    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }

    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    var ratingProps = new Map([
        ['caption', base.PROP_STRING],
        ['class', base.PROP_STRING],
        ['datafield', base.PROP_STRING],
        ['dataset', base.PROP_ANY],
        ['datavaluesource', base.PROP_ANY],
        ['datavalue', base.PROP_STRING],
        ['displayexpression', base.PROP_STRING],
        ['displayfield', base.PROP_STRING],
        ['hint', base.PROP_STRING],
        ['iconcolor', base.PROP_STRING],
        ['iconsize', base.PROP_STRING],
        ['maxvalue', __assign({ value: 5 }, base.PROP_NUMBER)],
        ['name', base.PROP_STRING],
        ['orderby', base.PROP_STRING],
        ['readonly', base.PROP_BOOLEAN],
        ['show', __assign({ value: true }, base.PROP_BOOLEAN)],
        ['showcaptions', __assign({ value: true }, base.PROP_BOOLEAN)],
        ['tabindex', __assign({ value: 0 }, base.PROP_NUMBER)],
        ['usekeys', base.PROP_BOOLEAN]
    ]);
    var registerProps = function () {
        base.register('wm-rating', ratingProps);
        base.registerFormWidget(core$1.FormWidgetType.RATING, new Map(ratingProps));
    };

    var DEFAULT_CLS = 'app-ratings';
    var WIDGET_CONFIG = { widgetType: 'wm-rating', hostClass: DEFAULT_CLS };
    var MAX_RATING = 10;
    var DEFAULT_RATING = 5;
    var RatingComponent = /** @class */ (function (_super) {
        __extends(RatingComponent, _super);
        function RatingComponent(inj) {
            var _this = _super.call(this, inj, WIDGET_CONFIG) || this;
            _this._id = core$1.generateGUId();
            base.styler(_this.nativeElement, _this);
            // prepare the rating options on dataset ready.
            var datasetSubscription = _this.dataset$.subscribe(function () {
                _this.prepareRatingDataset();
            });
            _this.registerDestroyListener(function () { return datasetSubscription.unsubscribe(); });
            // listen to changes in datavalue.
            var datavalueSubscription = _this.datavalue$.subscribe(function () { return _this.onDatavalueChange(_this.datavalue); });
            _this.registerDestroyListener(function () { return datavalueSubscription.unsubscribe(); });
            return _this;
        }
        RatingComponent_1 = RatingComponent;
        Object.defineProperty(RatingComponent.prototype, "selectedRatingValue", {
            get: function () {
                return this._selectedRatingValue;
            },
            set: function (val) {
                this._selectedRatingValue = val;
                this.calculateRatingsWidth();
            },
            enumerable: true,
            configurable: true
        });
        // Change event is registered from the template, Prevent the framework from registering one more event
        RatingComponent.prototype.handleEvent = function (node, eventName, eventCallback, locals) {
            if (eventName !== 'change' && eventName !== 'blur') {
                _super.prototype.handleEvent.call(this, this.ratingEl.nativeElement, eventName, eventCallback, locals);
            }
        };
        // This function returns the rating widget dataset containing the index, value and label
        RatingComponent.prototype.prepareRatingDataset = function () {
            if (!this.datasetItems.length) {
                this.ratingItems = [];
                this.caption = '';
            }
            var ratingItems = [];
            var data = this.datasetItems;
            var maxvalue = parseInt(this.maxvalue || this.datasetItems.length, 10);
            var maxValue = (maxvalue > MAX_RATING ? MAX_RATING : maxvalue) || DEFAULT_RATING;
            /**
             * 1. If datasetItems.length is more than maxValue (i.e. 10 ratings) then just extract maxValue of items from datasetItems.
             * 2. If datasetItems are not available then prepare ratings value depending on maxvalue. eg: 1,2,3 .. upto maxvalue
             * 3. If maxvalue / i value is more than datasetItems length, prepare default rating items for i values more than datasetItems.length
             */
            if (data.length && data.length > maxValue) {
                data = _.slice(data, 0, maxValue);
            }
            for (var i = maxValue; i > 0; i--) {
                if (!data.length) {
                    ratingItems.push({ key: i, value: i, index: i, label: i });
                }
                else {
                    if (i > data.length) {
                        ratingItems.push({ key: i, value: i, index: i, label: i });
                    }
                    else {
                        data = base.getOrderedDataset(data, 'index:desc');
                        ratingItems = ratingItems.concat(data);
                        break;
                    }
                }
            }
            this.ratingItems = ratingItems;
            if (!data.length) { // constructs default datasetItems when there is no dataset binding.
                this.datasetItems = ratingItems;
            }
            this.onDatavalueChange(this.datavalue);
        };
        RatingComponent.prototype.onRatingClick = function ($event, rate) {
            this.modelByKey = rate.key;
            this.selectedRatingValue = rate.index;
            // support if the caption is binded in the old projects for backward compatibility
            if (!this.showcaptions) {
                this.caption = rate.label;
            }
            this.invokeOnTouched();
            // invoke on datavalue change.
            this.invokeOnChange(this.datavalue, $event || {}, true);
        };
        // Update the selected flag on datasetItems and assign the ratingValue.
        /**
         * On datavalue change, update the caption, selectedRatingValue.
         * 1. if datasetItems contain the selected item (check the selected flag on item), find the index of selected item.
         * 2. if not, just check if the datavalue is provided as the index on the item.
         *
         * @param dataVal datavalue
         */
        RatingComponent.prototype.onDatavalueChange = function (dataVal) {
            if (!_.isEmpty(this.datasetItems)) {
                var selectedItem = _.find(this.datasetItems, { 'selected': true });
                if (!selectedItem && !_.isUndefined(dataVal)) {
                    selectedItem = _.find(this.datasetItems, function (item) {
                        return _.toString(item.index) === dataVal;
                    });
                    if (selectedItem) {
                        selectedItem.selected = true;
                    }
                }
                if (!selectedItem) {
                    // reset the  model if there is no item found.
                    this.modelByKey = undefined;
                    this.caption = '';
                }
                this.selectedRatingValue = selectedItem ? selectedItem.index : 0;
                if (selectedItem) {
                    this.caption = selectedItem.label;
                }
            }
            else {
                this.selectedRatingValue = 0;
            }
            if (this.readonly) {
                // when dataset is not given but datavalue is provided which is integer
                if (!this.selectedRatingValue && !isNaN(dataVal)) {
                    this.selectedRatingValue = (parseFloat(dataVal) <= this.maxvalue) ? dataVal : this.maxvalue;
                }
                this.ratingsWidth = this.calculateRatingsWidth(dataVal);
            }
        };
        RatingComponent.prototype.calculateRatingsWidth = function (dataVal) {
            var selectedRating = parseFloat(this.selectedRatingValue), starWidth = 0.925, maxValue = parseInt(this.maxvalue || this.datasetItems.length, 10) || DEFAULT_RATING;
            core$1.setCSS(this.nativeElement.querySelector('.ratings-container'), 'width', (starWidth * maxValue) + 'em');
            dataVal = dataVal || this.datavalue;
            if (dataVal === undefined || dataVal === '' || dataVal === null) {
                this.caption = '';
                return 0;
            }
            if (selectedRating <= maxValue && selectedRating >= 0) {
                return selectedRating * starWidth + 'em';
            }
            if (selectedRating > maxValue) {
                return maxValue * starWidth + 'em';
            }
        };
        RatingComponent.prototype.onPropertyChange = function (key, nv, ov) {
            if (key === 'readonly') {
                if (nv) {
                    this.ratingsWidth = this.calculateRatingsWidth();
                }
            }
            else if (key === 'maxvalue') {
                /** Storing the datavalue in temp variable and assiging back to datavalue
                 * after default datalist is prepared to trigger Dataset Aware class select cycle
                 * as the datavalue property change is triggering first rather than maxvalue
                 * in the rating widget is used inside a datatable
                 */
                var tempDataValue = this.datavalue;
                this.prepareRatingDataset();
                // reset all the items.
                this.resetDatasetItems();
                if (!_.isUndefined(tempDataValue)) {
                    this.datavalue = tempDataValue;
                }
            }
            else {
                _super.prototype.onPropertyChange.call(this, key, nv, ov);
            }
        };
        /* Detect touch enabled devices & update hover styles*/
        RatingComponent.prototype.onTouchStart = function ($event) {
            this.touchEnabled = true;
            this.onTouchStart = core$1.noop;
        };
        RatingComponent.prototype.onMouseleave = function () {
            this.caption = this.displayValue;
        };
        RatingComponent.prototype.onMouseOver = function ($event, rate) {
            this.caption = rate.label;
            !this.touchEnabled && !$event.target.classList.contains('rating-label-hover') && $event.target.classList.add('rating-label-hover');
        };
        var RatingComponent_1;
        RatingComponent.initializeProps = registerProps();
        RatingComponent.ctorParameters = function () { return [
            { type: core.Injector }
        ]; };
        __decorate([
            core.ViewChild('ratingInput', /* TODO: add static flag */ { read: core.ElementRef }),
            __metadata("design:type", core.ElementRef)
        ], RatingComponent.prototype, "ratingEl", void 0);
        RatingComponent = RatingComponent_1 = __decorate([
            core.Component({
                selector: '[wmRating]',
                template: "<div [(ngModel)]=\"modelByKey\" (focus)=\"onFocus($event)\" ngDefaultControl role=\"radiogroup\" class=\"ratings-wrapper\">\n    <div *ngIf=\"!readonly\" class=\"rating-style\">\n        <label *ngFor=\"let rate of ratingItems;\"\n               [ngClass]=\"{active : rate.index <= selectedRatingValue}\"\n               [ngStyle]=\"{'font-size' :iconsize, color: rate.index <= selectedRatingValue && iconcolor}\"\n               [title]=\"rate.label || rate.index\"\n               (touchstart)=\"onTouchStart($event)\"\n               (mouseleave)=\"onMouseleave($event, rate)\"\n               (mouseover)=\"onMouseOver($event, rate)\"\n               [for]=\"_id + '-' + rate.index\">\n            <input #ratingInput type=\"radio\" aria-label=\"rating radio buttons\" aria-checked=\"false\" aria-multiselectable=\"true\"\n                   [id]=\"_id + '-' + rate.index\" (click)=\"onRatingClick($event, rate)\" name=\"ratings-id\" [value]=\"rate.key || rate.index\"/>\n        </label>\n    </div>\n    <div [class.hidden]=\"!readonly\" [ngStyle]=\"{'font-size' :iconsize}\" class=\"ratings-container disabled\" >\n        <div class=\"ratings active\" [ngStyle]=\"{width: ratingsWidth, color: iconcolor}\"></div>\n    </div>\n    <label *ngIf=\"showcaptions\" class=\"caption\" [textContent]=\"caption\"></label>\n</div>\n",
                providers: [
                    base.provideAs(RatingComponent_1, forms.NG_VALUE_ACCESSOR, true),
                    base.provideAsWidgetRef(RatingComponent_1)
                ]
            }),
            __metadata("design:paramtypes", [core.Injector])
        ], RatingComponent);
        return RatingComponent;
    }(input.DatasetAwareFormComponent));

    var components = [
        RatingComponent
    ];
    var RatingModule = /** @class */ (function () {
        function RatingModule() {
        }
        RatingModule = __decorate([
            core.NgModule({
                imports: [
                    common.CommonModule,
                    forms.FormsModule,
                    base.WmComponentsModule
                ],
                declarations: __spread(components),
                exports: __spread(components),
                entryComponents: []
            })
        ], RatingModule);
        return RatingModule;
    }());

    exports.RatingModule = RatingModule;
    exports.ɵa = RatingComponent;
    exports.ɵb = registerProps;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=index.umd.js.map
