(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common'), require('ngx-bootstrap/dropdown'), require('@wm/components/base'), require('@wm/components/basic'), require('@wm/components/input'), require('@angular/router'), require('@wm/core')) :
    typeof define === 'function' && define.amd ? define('@wm/components/navigation/menu', ['exports', '@angular/core', '@angular/common', 'ngx-bootstrap/dropdown', '@wm/components/base', '@wm/components/basic', '@wm/components/input', '@angular/router', '@wm/core'], factory) :
    (global = global || self, factory((global.wm = global.wm || {}, global.wm.components = global.wm.components || {}, global.wm.components.navigation = global.wm.components.navigation || {}, global.wm.components.navigation.menu = {}), global.ng.core, global.ng.common, global['ngx-bootstrap'].dropdown, global.wm.components.base, global.wm.components.basic, global.wm.components.input, global.ng.router, global.wm.core));
}(this, (function (exports, core, common, dropdown, base, basic, input, router, core$1) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __rest(s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); }
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    function __createBinding(o, m, k, k2) {
        if (k2 === undefined) k2 = k;
        o[k2] = m[k];
    }

    function __exportStar(m, exports) {
        for (var p in m) if (p !== "default" && !exports.hasOwnProperty(p)) exports[p] = m[p];
    }

    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m) return m.call(o);
        if (o && typeof o.length === "number") return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }

    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    }

    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    };

    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }

    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
    }

    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }

    function __asyncValues(o) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
    }

    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
        return cooked;
    };

    function __importStar(mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
        result.default = mod;
        return result;
    }

    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }

    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }

    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    var registerProps = function () {
        base.register('wm-nav', new Map([
            ['autoclose', __assign({ value: 'always' }, base.PROP_STRING)],
            ['autoopen', __assign({ value: 'never' }, base.PROP_STRING)],
            ['class', base.PROP_STRING],
            ['dataset', base.PROP_ANY],
            ['iconposition', __assign({ value: 'left' }, base.PROP_STRING)],
            ['isactive', base.PROP_STRING],
            ['itemlabel', base.PROP_STRING],
            ['itemlink', base.PROP_STRING],
            ['itemicon', base.PROP_STRING],
            ['itemclass', base.PROP_STRING],
            ['itemchildren', base.PROP_STRING],
            ['itemaction', base.PROP_STRING],
            ['itembadge', base.PROP_STRING],
            ['itemtarget', base.PROP_STRING],
            ['layout', base.PROP_STRING],
            ['name', base.PROP_STRING],
            ['orderby', base.PROP_STRING],
            ['show', __assign({ value: true }, base.PROP_BOOLEAN)],
            ['type', base.PROP_STRING],
            ['userrole', base.PROP_STRING]
        ]));
    };

    var DEFAULT_CLS = 'nav app-nav';
    var WIDGET_CONFIG = { widgetType: 'wm-nav', hostClass: DEFAULT_CLS };
    var NavClassMap = {
        pills: 'nav-pills',
        tabs: 'nav-tabs',
        navbar: 'navbar-nav'
    };
    var NavComponent = /** @class */ (function (_super) {
        __extends(NavComponent, _super);
        function NavComponent(inj, cdRef, route, userDefinedExecutionContext, app, selectEventCB) {
            var _this = _super.call(this, inj, WIDGET_CONFIG) || this;
            _this.cdRef = cdRef;
            _this.route = route;
            _this.userDefinedExecutionContext = userDefinedExecutionContext;
            _this.app = app;
            base.styler(_this.nativeElement, _this, base.APPLY_STYLES_TYPE.CONTAINER);
            _this.disableMenuContext = !!selectEventCB;
            _this.pageScope = _this.viewParent;
            // For selecting the item on load
            var datasetSubscription = _this.nodes$.subscribe(function () {
                if (!_.isEmpty(_this.nodes)) {
                    var itemFound_1 = false;
                    var getItem_1 = function (nodes, isMenuWidget) {
                        _.forEach(nodes, function (item) {
                            if (itemFound_1) {
                                return;
                            }
                            if (item.isactive) {
                                itemFound_1 = true;
                                _this.selecteditem = isMenuWidget ? _.omit(item, ['children', 'value']) : item.value;
                                _this.invokeEventCallback('select', { $event: {}, $item: item.value });
                                // Trigger the action associated with active item
                                core$1.triggerItemAction(_this, item);
                                // _selected is used to add active class for nav item. If we have children inside nav widget then it is not required.
                                if (!isMenuWidget) {
                                    item._selected = true;
                                }
                                return false;
                            }
                            if (!_.isEmpty(item.children)) {
                                getItem_1(item.children, 'menu');
                            }
                        });
                    };
                    getItem_1(_this.nodes);
                }
            });
            _this.registerDestroyListener(function () { return datasetSubscription.unsubscribe(); });
            return _this;
        }
        NavComponent_1 = NavComponent;
        Object.defineProperty(NavComponent.prototype, "activePageName", {
            get: function () {
                return this.app.activePageName;
            },
            enumerable: true,
            configurable: true
        });
        NavComponent.prototype.setNavType = function (type) {
            core$1.addClass(this.nativeElement, NavClassMap[type]);
        };
        NavComponent.prototype.setNavLayout = function (layout) {
            core$1.addClass(this.nativeElement, "nav-" + layout);
        };
        NavComponent.prototype.onNavSelect = function ($event, item, liRef) {
            $event.preventDefault();
            var selectedItem = _.find(this.nodes, '_selected');
            if (selectedItem) {
                delete selectedItem._selected;
            }
            if (this.activeNavLINode) {
                core$1.removeClass(this.activeNavLINode, 'active');
            }
            this.activeNavLINode = liRef;
            core$1.addClass(liRef, 'active');
            this.selecteditem = item.value;
            this.invokeEventCallback('select', { $event: $event, $item: item.value });
            // Trigger the action associated with active item
            core$1.triggerItemAction(this, item);
        };
        NavComponent.prototype.ngOnInit = function () {
            _super.prototype.ngOnInit.call(this);
            this.setNavType(this.type);
            this.setNavLayout(this.layout);
        };
        /**
         * invoked from the menu widget when a menu item is selected.
         * @param $event
         * @param widget
         * @param $item
         */
        NavComponent.prototype.onMenuItemSelect = function ($event, widget, $item) {
            this.selecteditem = _.omit($item, ['children', 'value']);
            this.invokeEventCallback('select', { $event: $event, $item: this.selecteditem });
        };
        var NavComponent_1;
        NavComponent.initializeProps = registerProps();
        NavComponent.ctorParameters = function () { return [
            { type: core.Injector },
            { type: core.ChangeDetectorRef },
            { type: router.Router },
            { type: core$1.UserDefinedExecutionContext },
            { type: core$1.App },
            { type: undefined, decorators: [{ type: core.Attribute, args: ['select.event',] }] }
        ]; };
        NavComponent = NavComponent_1 = __decorate([
            core.Component({
                selector: '[wmNav]',
                template: "<ng-template #menuRef let-item=\"item\" let-index=\"index\">\n    <div wmMenu dropdown\n         type=\"anchor\"\n         autoclose.bind=\"autoclose\"\n         iconclass.bind=\"item.icon\"\n         autoopen.bind=\"autoopen\"\n         caption.bind=\"item.label\"\n         dataset.bind=\"item.children\"\n         iconposition.bind=\"iconposition\"\n         select.event=\"onMenuItemSelect($event, widget, $item)\"></div>\n</ng-template>\n\n<ng-template #anchorRef let-item=\"item\" let-index=\"index\" let-liRef=\"liRef\">\n    <a wmAnchor\n       [disableMenuContext]=\"disableMenuContext || !!item.action\"\n       [wmNavigationControl]=\"item.link\"\n       caption.bind=\"item.label\"\n       iconclass.bind=\"item.icon\"\n       badgevalue.bind=\"item.badge\"\n       iconposition.bind=\"iconposition\"\n       click.event=\"onNavSelect($event, item, liRef)\"></a>\n</ng-template>\n\n<li class=\"app-nav-item {{item.class}}\" *ngFor=\"let item of nodes; let index = index;\" #liRef [ngClass]=\"{active: item._selected || (!isactive && item.link === '#/' + activePageName)}\">\n    <ng-container [ngTemplateOutlet]=\"anchorRef\" [ngTemplateOutletContext]=\"{item: item, index:index, liRef: liRef}\" *ngIf=\"!item.children.length\"></ng-container>\n    <ng-container [ngTemplateOutlet]=\"menuRef\" [ngTemplateOutletContext]=\"{item: item, index:index}\"  *ngIf=\"item.children.length\"></ng-container>\n</li>\n\n<ng-content *ngIf=\"!nodes.length\" select=\"[wmNavItem]\"></ng-content>\n",
                providers: [
                    base.provideAsWidgetRef(NavComponent_1)
                ]
            }),
            __param(5, core.Attribute('select.event')),
            __metadata("design:paramtypes", [core.Injector,
                core.ChangeDetectorRef,
                router.Router,
                core$1.UserDefinedExecutionContext,
                core$1.App, Object])
        ], NavComponent);
        return NavComponent;
    }(base.DatasetAwareNavComponent));

    var registerProps$1 = function () {
        base.register('wm-menu', new Map([
            ['accessroles', __assign({ value: 'Everyone' }, base.PROP_STRING)],
            ['animateitems', base.PROP_STRING],
            ['autoclose', __assign({ value: 'always' }, base.PROP_STRING)],
            ['autoopen', __assign({ value: 'never' }, base.PROP_STRING)],
            ['caption', base.PROP_STRING],
            ['class', base.PROP_STRING],
            ['dataset', __assign({ value: 'Menu Item 1, Menu Item 2, Menu Item 3' }, base.PROP_ANY)],
            ['hint', __assign({ value: '' }, base.PROP_STRING)],
            ['isactive', base.PROP_STRING],
            ['iconclass', base.PROP_STRING],
            ['iconposition', __assign({ value: 'left' }, base.PROP_STRING)],
            ['itemaction', base.PROP_STRING],
            ['itemchildren', base.PROP_STRING],
            ['itemclass', base.PROP_STRING],
            ['itemicon', base.PROP_STRING],
            ['itemlabel', base.PROP_STRING],
            ['itemlink', base.PROP_STRING],
            ['itemtarget', base.PROP_STRING],
            ['linktarget', __assign({ value: '_self' }, base.PROP_STRING)],
            ['menuclass', base.PROP_STRING],
            ['menulayout', base.PROP_STRING],
            ['menuposition', base.PROP_STRING],
            ['name', base.PROP_STRING],
            ['orderby', base.PROP_STRING],
            ['shortcutkey', base.PROP_STRING],
            ['show', __assign({ value: true }, base.PROP_BOOLEAN)],
            ['tabindex', __assign({ value: 0 }, base.PROP_NUMBER)],
            ['type', __assign({ value: 'menu' }, base.PROP_STRING)],
            ['userrole', base.PROP_STRING]
        ]));
    };

    var KEYBOARD_MOVEMENTS = {
        MOVE_UP: 'UP-ARROW',
        MOVE_LEFT: 'LEFT-ARROW',
        MOVE_RIGHT: 'RIGHT-ARROW',
        MOVE_DOWN: 'DOWN-ARROW',
        ON_ENTER: 'ENTER',
        ON_TAB: 'TAB',
        ON_SHIFT_TAB: 'SHIFT-TAB',
        ON_ESCAPE: 'ESC'
    };
    var MENU_POSITION = {
        UP_LEFT: 'up,left',
        UP_RIGHT: 'up,right',
        DOWN_LEFT: 'down,left',
        DOWN_RIGHT: 'down,right',
        INLINE: 'inline'
    };
    var POSITION = {
        DOWN_RIGHT: 'down,right',
        DOWN_LEFT: 'down,left',
        UP_RIGHT: 'up,right',
        UP_LEFT: 'up,left',
        INLINE: 'inline'
    };
    var CARET_CLS = {
        UP: 'fa-caret-up',
        DOWN: 'fa-caret-down'
    };
    var PULL_CLS = {
        LEFT: 'pull-left',
        RIGHT: 'pull-right'
    };
    var AUTO_OPEN = {
        NEVER: 'never',
        ACTIVE_PAGE: 'activepage',
        ALWAYS: 'always'
    };
    var WIDGET_CONFIG$1 = { widgetType: 'wm-menu', hostClass: 'dropdown app-menu' };
    var MenuComponent = /** @class */ (function (_super) {
        __extends(MenuComponent, _super);
        function MenuComponent(inj, route, userDefinedExecutionContext, bsDropdown, parentNav, selectEventCB) {
            var _this = _super.call(this, inj, WIDGET_CONFIG$1) || this;
            _this.route = route;
            _this.userDefinedExecutionContext = userDefinedExecutionContext;
            _this.bsDropdown = bsDropdown;
            _this.parentNav = parentNav;
            _this.selectEventCB = selectEventCB;
            _this.menuCaret = 'fa-caret-down';
            _this._selectFirstItem = false;
            if (parentNav) {
                _this.disableMenuContext = !!parentNav.disableMenuContext;
            }
            else {
                _this.disableMenuContext = !!selectEventCB;
            }
            // For selecting the item on load
            var datasetSubscription = _this.nodes$.subscribe(function () {
                if (!_.isEmpty(_this.nodes)) {
                    // If menu widget is inside nav widget then dont check for item isactive property because these will be handled form nav widget.
                    if (_this.parentNav) {
                        return;
                    }
                    var itemFound_1 = false;
                    var getItem_1 = function (nodes) {
                        _.forEach(nodes, function (item) {
                            if (itemFound_1) {
                                return;
                            }
                            if (item.isactive) {
                                itemFound_1 = true;
                                _this.onMenuItemSelect({ $event: {}, $item: item });
                                // Trigger the action associated with active item
                                core$1.triggerItemAction(_this, item);
                                return false;
                            }
                            if (!_.isEmpty(item.children)) {
                                getItem_1(item.children);
                            }
                        });
                    };
                    getItem_1(_this.nodes);
                }
            });
            _this.registerDestroyListener(function () { return datasetSubscription.unsubscribe(); });
            return _this;
        }
        MenuComponent_1 = MenuComponent;
        MenuComponent.prototype.onShow = function () {
            var _this = this;
            if (this._selectFirstItem) {
                setTimeout(function () {
                    _this.$element.find('> ul[wmmenudropdown] li.app-menu-item').first().find('> a').focus();
                });
            }
            core$1.$appDigest();
        };
        MenuComponent.prototype.onHide = function () {
            this.$element.find('>.dropdown-toggle').focus();
            this.$element.find('li').removeClass('open');
            this._selectFirstItem = false;
            core$1.$appDigest();
        };
        MenuComponent.prototype.onKeyDown = function ($event, eventAction) {
            var KEY_MOVEMENTS = _.clone(KEYBOARD_MOVEMENTS);
            if (this.menuposition === MENU_POSITION.UP_RIGHT) {
                KEY_MOVEMENTS.MOVE_UP = 'DOWN-ARROW';
                KEY_MOVEMENTS.MOVE_DOWN = 'UP-ARROW';
            }
            else if (this.menuposition === MENU_POSITION.UP_LEFT) {
                KEY_MOVEMENTS.MOVE_UP = 'DOWN-ARROW';
                KEY_MOVEMENTS.MOVE_DOWN = 'UP-ARROW';
                KEY_MOVEMENTS.MOVE_LEFT = 'RIGHT-ARROW';
                KEY_MOVEMENTS.MOVE_RIGHT = 'LEFT-ARROW';
            }
            else if (this.menuposition === MENU_POSITION.DOWN_LEFT) {
                KEY_MOVEMENTS.MOVE_LEFT = 'RIGHT-ARROW';
                KEY_MOVEMENTS.MOVE_RIGHT = 'LEFT-ARROW';
            }
            if (_.includes([KEY_MOVEMENTS.MOVE_DOWN, KEY_MOVEMENTS.MOVE_RIGHT], eventAction)) {
                if (!this.bsDropdown.isOpen) {
                    this._selectFirstItem = true;
                    this.bsDropdown.show();
                }
                else {
                    this.$element.find('> ul[wmmenudropdown] li.app-menu-item').first().find('> a').focus();
                }
            }
            else if (eventAction === KEY_MOVEMENTS.ON_ENTER) {
                this.bsDropdown.toggle(true);
            }
            else if (_.includes([KEY_MOVEMENTS.MOVE_UP, KEY_MOVEMENTS.MOVE_LEFT], eventAction)) {
                this.bsDropdown.hide();
            }
            $event.preventDefault();
        };
        /**
         * returns true if the menu has link to the current page.
         * @param nodes
         */
        MenuComponent.prototype.hasLinkToCurrentPage = function (nodes) {
            var _this = this;
            return nodes.some(function (node) {
                if (base.isActiveNavItem(node.link, _this.route.url)) {
                    return true;
                }
                if (node.children) {
                    return _this.hasLinkToCurrentPage(node.children);
                }
            });
        };
        MenuComponent.prototype.resetNodes = function () {
            _super.prototype.resetNodes.call(this);
            // open the menu if any of its menu items has link to current page and if autoopen value is 'active page'
            if ((this.autoopen === AUTO_OPEN.ACTIVE_PAGE && this.hasLinkToCurrentPage(this.nodes)) || this.autoopen === AUTO_OPEN.ALWAYS) {
                this.bsDropdown.show();
            }
        };
        MenuComponent.prototype.ngOnInit = function () {
            _super.prototype.ngOnInit.call(this);
            this.setMenuPosition();
        };
        MenuComponent.prototype.onPropertyChange = function (key, nv, ov) {
            if (key === 'tabindex') {
                return;
            }
            if (key === 'autoclose') {
                this.bsDropdown.autoClose = nv !== base.AUTOCLOSE_TYPE.DISABLED;
            }
            else {
                _super.prototype.onPropertyChange.call(this, key, nv, ov);
            }
        };
        MenuComponent.prototype.setMenuPosition = function () {
            switch (this.menuposition) {
                case POSITION.DOWN_RIGHT:
                    core$1.removeClass(this.nativeElement, 'dropup');
                    this.menualign = PULL_CLS.LEFT;
                    this.menuCaret = CARET_CLS.DOWN;
                    break;
                case POSITION.DOWN_LEFT:
                    core$1.removeClass(this.nativeElement, 'dropup');
                    this.menualign = PULL_CLS.RIGHT;
                    this.menuCaret = CARET_CLS.DOWN;
                    break;
                case POSITION.UP_LEFT:
                    core$1.addClass(this.nativeElement, 'dropup');
                    this.menualign = PULL_CLS.RIGHT;
                    this.menuCaret = CARET_CLS.UP;
                    break;
                case POSITION.UP_RIGHT:
                    core$1.addClass(this.nativeElement, 'dropup');
                    this.menualign = PULL_CLS.LEFT;
                    this.menuCaret = CARET_CLS.UP;
                    break;
                case POSITION.INLINE:
                    this.menualign = 'dropinline-menu';
                    break;
            }
        };
        MenuComponent.prototype.onMenuItemSelect = function (args) {
            var $event = args.$event;
            var $item = args.$item.value;
            this.invokeEventCallback('select', { $event: $event, $item: $item });
        };
        MenuComponent.prototype.ngAfterViewInit = function () {
            _super.prototype.ngAfterViewInit.call(this);
            base.styler(this.nativeElement.querySelector('.dropdown-toggle'), this);
        };
        var MenuComponent_1;
        MenuComponent.initializeProps = registerProps$1();
        MenuComponent.ctorParameters = function () { return [
            { type: core.Injector },
            { type: router.Router },
            { type: core$1.UserDefinedExecutionContext },
            { type: dropdown.BsDropdownDirective, decorators: [{ type: core.Self }, { type: core.Optional }] },
            { type: NavComponent, decorators: [{ type: core.Optional }] },
            { type: String, decorators: [{ type: core.Attribute, args: ['select.event',] }] }
        ]; };
        __decorate([
            core.HostListener('onShown'),
            __metadata("design:type", Function),
            __metadata("design:paramtypes", []),
            __metadata("design:returntype", void 0)
        ], MenuComponent.prototype, "onShow", null);
        __decorate([
            core.HostListener('onHidden'),
            __metadata("design:type", Function),
            __metadata("design:paramtypes", []),
            __metadata("design:returntype", void 0)
        ], MenuComponent.prototype, "onHide", null);
        __decorate([
            core.HostListener('keydown.arrowup', ['$event', '"UP-ARROW"']),
            core.HostListener('keydown.arrowdown', ['$event', '"DOWN-ARROW"']),
            core.HostListener('keydown.arrowright', ['$event', '"RIGHT-ARROW"']),
            core.HostListener('keydown.arrowleft', ['$event', '"LEFT-ARROW"']),
            core.HostListener('keydown.enter', ['$event', '"ENTER"']),
            __metadata("design:type", Function),
            __metadata("design:paramtypes", [Object, Object]),
            __metadata("design:returntype", void 0)
        ], MenuComponent.prototype, "onKeyDown", null);
        MenuComponent = MenuComponent_1 = __decorate([
            core.Component({
                selector: '[wmMenu]',
                template: "<ng-template #menuTemplate>\n    <button wmButton\n            dropdownToggle\n            aria-haspopup=\"true\"\n            aria-expanded=\"false\"\n\n            class=\"btn app-button dropdown-toggle {{menuclass}}\"\n            hint.bind=\"hint\"\n            shortcutkey.bind=\"shortcutkey\"\n            tabindex.bind=\"tabindex\"\n            caption.bind=\"caption\"\n            iconclass.bind=\"iconclass\"\n            iconposition.bind=\"iconposition\">\n        <span class=\"pull-right caret fa {{menuCaret}}\"></span>\n    </button>\n</ng-template>\n\n<ng-template #innerTemplate>\n    <i class=\"app-icon {{iconclass}}\"></i>\n    <span class=\"caption\" [textContent]=\"caption\"></span>\n    <span class=\"pull-right caret fa {{menuCaret}}\"></span>\n</ng-template>\n\n<ng-container *ngIf=\"type === 'anchor'; else menuTemplate\">\n    <a wmAnchor\n       dropdownToggle\n\n       href=\"javascript:void(0);\"\n       role=\"button\"\n       aria-haspopup=\"true\"\n       aria-expanded=\"false\"\n\n       hint.bind=\"hint\"\n       class=\"dropdown-toggle {{menuclass}}\"\n       shortcutkey.bind=\"shortcutkey\"\n       tabindex.bind=\"tabindex\"\n       caption.bind=\"caption\"\n       iconclass.bind=\"iconclass\"\n       iconposition.bind=\"iconposition\"\n    >\n        <span class=\"pull-right caret fa {{menuCaret}}\"></span>\n    </a>\n</ng-container>\n\n<ul wmMenuDropdown [items]=\"nodes\" [ngClass]=\"menulayout\" class=\"icon-position-{{iconposition}}\" *dropdownMenu aria-labelledby=\"dropdownmenu\"></ul>\n",
                providers: [
                    base.provideAsWidgetRef(MenuComponent_1)
                ]
            }),
            __param(3, core.Self()), __param(3, core.Optional()),
            __param(4, core.Optional()),
            __param(5, core.Attribute('select.event')),
            __metadata("design:paramtypes", [core.Injector,
                router.Router,
                core$1.UserDefinedExecutionContext,
                dropdown.BsDropdownDirective,
                NavComponent, String])
        ], MenuComponent);
        return MenuComponent;
    }(base.DatasetAwareNavComponent));

    var animationClasses = {
        scale: {
            'name': 'wmScaleInLeft',
            'down,right': 'wmScaleInLeft',
            'down,left': 'wmScaleInRight',
            'up,right': 'wmScaleInTopLeft',
            'up,left': 'wmScaleInTopRight'
        },
        fade: {
            'name': 'fadeIn',
            'down,right': 'fadeIn',
            'down,left': 'fadeIn',
            'up,right': 'fadeIn',
            'up,left': 'fadeIn'
        },
        slide: {
            'name': 'wmSlideInDown',
            'down,right': 'wmSlideInDown',
            'down,left': 'wmSlideInDown',
            'up,right': 'wmSlideInUp',
            'up,left': 'wmSlideInUp'
        }
    };
    var DEFAULT_CLS$1 = 'dropdown-menu';
    var MenuDropdownComponent = /** @class */ (function () {
        function MenuDropdownComponent(elRef, menuRef) {
            this.menuRef = menuRef;
            this.nativeElement = elRef.nativeElement;
            core$1.addClass(this.nativeElement, DEFAULT_CLS$1);
        }
        MenuDropdownComponent.prototype.ngAfterViewInit = function () {
            var animateItems = this.menuRef.animateitems;
            var animationClass = '';
            if (animateItems) {
                animationClass = "animated " + (animationClasses[animateItems][this.menuRef.menuposition] || animationClasses[animateItems].name);
            }
            core$1.addClass(this.nativeElement, "dropdown-menu " + this.menuRef.menualign + " " + animationClass, true);
        };
        MenuDropdownComponent.ctorParameters = function () { return [
            { type: core.ElementRef },
            { type: MenuComponent }
        ]; };
        __decorate([
            core.Input(),
            __metadata("design:type", Object)
        ], MenuDropdownComponent.prototype, "items", void 0);
        MenuDropdownComponent = __decorate([
            core.Component({
                selector: 'ul[wmMenuDropdown]',
                template: "<li wmMenuDropdownItem *ngFor=\"let item of items\"\n    [item]=\"item\"\n    [ngClass]=\"{disabled: item.disabled, 'dropdown-submenu': item.children.length > 0}\"\n    class=\"{{item.class}}\">\n</li>"
            }),
            __metadata("design:paramtypes", [core.ElementRef, MenuComponent])
        ], MenuDropdownComponent);
        return MenuDropdownComponent;
    }());

    var menuAlignClass = {
        'pull-right': 'fa-caret-left',
        'dropinline-menu': 'fa-caret-down',
        'pull-left': 'fa-caret-right'
    };
    var MENU_LAYOUT_TYPE = {
        HORIZONTAL: 'horizontal',
        VERTICAL: 'vertical'
    };
    var MenuDropdownItemComponent = /** @class */ (function () {
        function MenuDropdownItemComponent(menuRef, userDefinedExecutionContext, parentNav, elRef) {
            var _this = this;
            this.menuRef = menuRef;
            this.userDefinedExecutionContext = userDefinedExecutionContext;
            this.parentNav = parentNav;
            this.onSelect = function ($event, item) {
                if (_this.nativeElement !== $($event.target).closest('.app-menu-item').get(0)) {
                    return;
                }
                // prevent event event propagation if auto close is outside click.
                if (_this.menuRef.autoclose === 'outsideClick') {
                    $event.stopPropagation();
                }
                $event.preventDefault();
                var args = { $event: $event, $item: item };
                _this.menuRef.onMenuItemSelect(args);
                var selectedItem = _.clone(item);
                selectedItem.target = selectedItem.target || _this.menuRef.linktarget;
                // Trigger the action associated with active item
                core$1.triggerItemAction(_this, selectedItem);
            };
            this.nativeElement = elRef.nativeElement;
            core$1.addClass(this.nativeElement, 'app-menu-item');
            this.menualign = menuAlignClass[this.menuRef.menualign] || menuAlignClass['pull-left'];
        }
        MenuDropdownItemComponent.prototype.ngOnInit = function () {
            // add active class to the item only if it is in nav component.
            if (this.parentNav) {
                if (base.isActiveNavItem(this.item.link, this.menuRef.route.url)) {
                    // add active class to the li, if the menu item's link is same as the current page name.
                    core$1.addClass(this.nativeElement, 'active');
                }
            }
        };
        MenuDropdownItemComponent.prototype.getInitialKeyMovements = function () {
            var KEY_MOVEMENTS = _.clone(KEYBOARD_MOVEMENTS);
            if (this.menuRef.menulayout === MENU_LAYOUT_TYPE.HORIZONTAL) {
                KEY_MOVEMENTS.MOVE_UP = 'LEFT-ARROW';
                KEY_MOVEMENTS.MOVE_LEFT = 'UP-ARROW';
                KEY_MOVEMENTS.MOVE_RIGHT = 'DOWN-ARROW';
                KEY_MOVEMENTS.MOVE_DOWN = 'RIGHT-ARROW';
            }
            else {
                if (this.menuRef.menuposition === MENU_POSITION.DOWN_LEFT || this.menuRef.menuposition === MENU_POSITION.UP_LEFT) {
                    KEY_MOVEMENTS.MOVE_LEFT = 'RIGHT-ARROW';
                    KEY_MOVEMENTS.MOVE_RIGHT = 'LEFT-ARROW';
                }
                else if (this.menuRef.menuposition === 'inline') {
                    KEY_MOVEMENTS.MOVE_UP = 'LEFT-ARROW';
                    KEY_MOVEMENTS.MOVE_LEFT = 'UP-ARROW';
                    KEY_MOVEMENTS.MOVE_RIGHT = 'DOWN-ARROW';
                    KEY_MOVEMENTS.MOVE_DOWN = 'RIGHT-ARROW';
                }
            }
            return KEY_MOVEMENTS;
        };
        MenuDropdownItemComponent.prototype.onKeyDown = function ($event, eventAction) {
            var $li = $(this.nativeElement);
            var $ul = $(this.nativeElement).closest('ul.dropdown-menu');
            var $parentUl = this.menuRef.$element.find('> ul.dropdown-menu');
            var ARROW_KEYS = ['LEFT-ARROW', 'RIGHT-ARROW', 'UP-ARROW', 'DOWN-ARROW'];
            var KEY_MOVEMENTS = this.getInitialKeyMovements();
            if (_.includes(ARROW_KEYS, eventAction)) {
                // preventing from page scroll when up/down arrow is pressed, in case of menu is opened.
                $event.preventDefault();
            }
            if ((eventAction === KEY_MOVEMENTS.ON_TAB && $parentUl.children().last()[0] === this.nativeElement)
                || (eventAction === KEY_MOVEMENTS.ON_SHIFT_TAB && $parentUl.children().first()[0] === this.nativeElement)
                || eventAction === KEY_MOVEMENTS.ON_ESCAPE) {
                /*closing all the children elements when
                * 1. Tab is clicked on the last $element
                * 2. Shift Tab is clicked on the first $element
                * 3. When Escape key is clicked*/
                $event.preventDefault();
                this.menuRef.bsDropdown.hide();
            }
            else if ((eventAction === KEY_MOVEMENTS.ON_ENTER && !this.item.link) || eventAction === KEY_MOVEMENTS.MOVE_RIGHT) {
                // when there is no link for the menu, on enter open the inner child elements and focus the first $element
                $event.stopPropagation();
                if (this.item.children.length) {
                    $li.toggleClass('open');
                    $li.find('li').first().find('> a').focus();
                }
                else {
                    $li.find('> a').focus();
                }
            }
            else if (eventAction === KEY_MOVEMENTS.MOVE_LEFT
                || (eventAction === KEY_MOVEMENTS.ON_TAB && $ul.children().last()[0] === this.nativeElement)
                || (eventAction === KEY_MOVEMENTS.ON_SHIFT_TAB && $ul.children().first()[0] === this.nativeElement)) {
                if ($parentUl[0] !== $ul[0]) {
                    var $parentItem = $ul.parent();
                    $parentItem.toggleClass('open').find('li.open').removeClass('open');
                    $parentItem.find('> a').focus();
                    $event.preventDefault();
                    $event.stopPropagation();
                }
            }
            else if (eventAction === KEY_MOVEMENTS.MOVE_UP) {
                if ($parentUl[0] !== $ul[0] || $parentUl.find('> li').first()[0] !== this.nativeElement) {
                    $event.stopPropagation();
                    $li.prev().find('> a').focus();
                }
            }
            else if (eventAction === KEY_MOVEMENTS.MOVE_DOWN) {
                $event.stopPropagation();
                if ($parentUl.find('> li').last()[0] === this.nativeElement
                    && (this.menuRef.menulayout !== MENU_LAYOUT_TYPE.HORIZONTAL
                        && this.menuRef.menuposition === MENU_POSITION.UP_RIGHT
                        || this.menuRef.menuposition === MENU_POSITION.UP_LEFT)) {
                    this.menuRef.bsDropdown.hide();
                }
                else {
                    $li.next().find('> a').focus();
                }
            }
            else if (eventAction === KEY_MOVEMENTS.ON_ENTER) {
                this.onSelect($event, this.item);
            }
            else {
                $event.stopPropagation();
            }
        };
        MenuDropdownItemComponent.ctorParameters = function () { return [
            { type: MenuComponent },
            { type: core$1.UserDefinedExecutionContext },
            { type: NavComponent, decorators: [{ type: core.Optional }] },
            { type: core.ElementRef }
        ]; };
        __decorate([
            core.Input(),
            __metadata("design:type", Object)
        ], MenuDropdownItemComponent.prototype, "item", void 0);
        __decorate([
            core.HostListener('keydown.tab', ['$event', '"TAB"']),
            core.HostListener('keydown.shift.tab', ['$event', '"SHIFT-TAB"']),
            core.HostListener('keydown.escape', ['$event', '"ESC"']),
            core.HostListener('keydown.enter', ['$event', '"ENTER"']),
            core.HostListener('keydown.arrowup', ['$event', '"UP-ARROW"']),
            core.HostListener('keydown.arrowdown', ['$event', '"DOWN-ARROW"']),
            core.HostListener('keydown.arrowright', ['$event', '"RIGHT-ARROW"']),
            core.HostListener('keydown.arrowleft', ['$event', '"LEFT-ARROW"']),
            __metadata("design:type", Function),
            __metadata("design:paramtypes", [Object, Object]),
            __metadata("design:returntype", void 0)
        ], MenuDropdownItemComponent.prototype, "onKeyDown", null);
        __decorate([
            core.HostListener('click', ['$event', 'item']),
            __metadata("design:type", Object)
        ], MenuDropdownItemComponent.prototype, "onSelect", void 0);
        MenuDropdownItemComponent = __decorate([
            core.Component({
                selector: 'li[wmMenuDropdownItem]',
                template: "<a href=\"javascript:void(0);\" [title]=\"item.label\" [wmNavigationControl]=\"item.link\" [disableMenuContext]=\"menuRef.disableMenuContext || !!item.action\">\n    <span *ngIf=\"item.children.length\" class=\"pull-right fa caret {{menualign}}\"></span>\n    <i class=\"app-icon {{item.icon}}\"></i>\n    <span class=\"anchor-caption\">{{item.label}}</span>\n\n</a>\n<ng-container [ngTemplateOutlet]=\"nestedMenuDropdown\" *ngIf=\"item.children.length\" [ngTemplateOutletContext]=\"{item: item}\"></ng-container>\n\n<ng-template #nestedMenuDropdown let-item=\"item\">\n    <ul wmMenuDropdown [items]=\"item.children\"></ul>\n</ng-template>\n"
            }),
            __param(2, core.Optional()),
            __metadata("design:paramtypes", [MenuComponent,
                core$1.UserDefinedExecutionContext,
                NavComponent,
                core.ElementRef])
        ], MenuDropdownItemComponent);
        return MenuDropdownItemComponent;
    }());

    var registerProps$2 = function () {
        base.register('wm-nav-item', new Map([
            ['class', base.PROP_STRING],
            ['name', base.PROP_STRING],
            ['show', __assign({ value: true }, base.PROP_BOOLEAN)]
        ]));
    };

    var DEFAULT_CLS$2 = 'app-nav-item';
    var WIDGET_CONFIG$2 = { widgetType: 'wm-nav-item', hostClass: DEFAULT_CLS$2 };
    var NavItemDirective = /** @class */ (function (_super) {
        __extends(NavItemDirective, _super);
        function NavItemDirective(inj) {
            var _this = _super.call(this, inj, WIDGET_CONFIG$2) || this;
            base.styler(_this.nativeElement, _this, base.APPLY_STYLES_TYPE.CONTAINER);
            return _this;
        }
        NavItemDirective_1 = NavItemDirective;
        NavItemDirective.prototype.makeActive = function () {
            var parentNode = this.nativeElement.parentNode;
            $(parentNode).find('> li.active').removeClass('active');
            if (this.isAttached) {
                core$1.addClass(this.nativeElement, 'active');
            }
        };
        NavItemDirective.prototype.ngAfterViewInit = function () {
            var _this = this;
            if (this.innerLink) {
                this.innerLink.onActive(function () { return _this.makeActive(); });
            }
        };
        NavItemDirective.prototype.ngOnDetach = function () {
            core$1.removeClass(this.nativeElement, 'active', true);
            _super.prototype.ngOnDetach.call(this);
        };
        var NavItemDirective_1;
        NavItemDirective.initializeProps = registerProps$2();
        NavItemDirective.ctorParameters = function () { return [
            { type: core.Injector }
        ]; };
        __decorate([
            core.ContentChild(basic.AnchorComponent),
            __metadata("design:type", Object)
        ], NavItemDirective.prototype, "innerLink", void 0);
        __decorate([
            core.HostListener('click'),
            core.HostListener('keydown.enter'),
            __metadata("design:type", Function),
            __metadata("design:paramtypes", []),
            __metadata("design:returntype", void 0)
        ], NavItemDirective.prototype, "makeActive", null);
        NavItemDirective = NavItemDirective_1 = __decorate([
            core.Directive({
                selector: '[wmNavItem]',
                providers: [
                    base.provideAsWidgetRef(NavItemDirective_1)
                ]
            }),
            __metadata("design:paramtypes", [core.Injector])
        ], NavItemDirective);
        return NavItemDirective;
    }(base.StylableComponent));

    var disableContextMenu = function ($event) {
        $event.preventDefault();
    };
    var NavigationControlDirective = /** @class */ (function () {
        function NavigationControlDirective(eleRef) {
            this.nativeElement = eleRef.nativeElement;
        }
        Object.defineProperty(NavigationControlDirective.prototype, "wmNavigationControl", {
            set: function (val) {
                this._link = val;
                if (val && !this.disableMenuContext) {
                    core$1.setAttr(this.nativeElement, 'href', val);
                    this.nativeElement.removeEventListener('contextmenu', disableContextMenu);
                }
                else {
                    core$1.setAttr(this.nativeElement, 'href', 'javascript:void(0)');
                    this.nativeElement.addEventListener('contextmenu', disableContextMenu);
                }
            },
            enumerable: true,
            configurable: true
        });
        NavigationControlDirective.ctorParameters = function () { return [
            { type: core.ElementRef }
        ]; };
        __decorate([
            core.Input(),
            __metadata("design:type", Boolean)
        ], NavigationControlDirective.prototype, "disableMenuContext", void 0);
        __decorate([
            core.Input(),
            __metadata("design:type", Object),
            __metadata("design:paramtypes", [Object])
        ], NavigationControlDirective.prototype, "wmNavigationControl", null);
        NavigationControlDirective = __decorate([
            core.Directive({ selector: '[wmNavigationControl]' }),
            __metadata("design:paramtypes", [core.ElementRef])
        ], NavigationControlDirective);
        return NavigationControlDirective;
    }());

    var components = [
        MenuComponent,
        MenuDropdownComponent,
        MenuDropdownItemComponent,
        NavigationControlDirective,
        NavComponent,
        NavItemDirective
    ];
    var MenuModule = /** @class */ (function () {
        function MenuModule() {
        }
        MenuModule = __decorate([
            core.NgModule({
                imports: [
                    basic.BasicModule,
                    dropdown.BsDropdownModule,
                    common.CommonModule,
                    input.InputModule,
                    base.WmComponentsModule
                ],
                declarations: __spread(components),
                exports: __spread(components),
                entryComponents: [
                    MenuComponent,
                    MenuDropdownComponent
                ]
            })
        ], MenuModule);
        return MenuModule;
    }());

    var menuProps = ['itemlabel', 'itemicon', 'itemlink', 'itemaction', 'itemchildren', 'userrole'];
    var MenuAdapterComponent = /** @class */ (function (_super) {
        __extends(MenuAdapterComponent, _super);
        function MenuAdapterComponent(inj, WIDGET_CONFIG) {
            var _this = _super.call(this, inj, WIDGET_CONFIG) || this;
            _this.pageScope = _this.viewParent;
            _this.binditemlabel = _this.nativeElement.getAttribute('itemlabel.bind');
            _this.binditemicon = _this.nativeElement.getAttribute('itemicon.bind');
            _this.binditemaction = _this.nativeElement.getAttribute('itemaction.bind');
            _this.binditemlink = _this.nativeElement.getAttribute('itemlink.bind');
            _this.binduserrole = _this.nativeElement.getAttribute('userrole.bind');
            _this.binditemchildren = _this.nativeElement.getAttribute('itemchildren.bind');
            return _this;
        }
        MenuAdapterComponent.prototype.onPropertyChange = function (key, nv, ov) {
            if (_.includes(menuProps, key) && this.menuRef) {
                this.menuRef.itemlabel = nv;
            }
            else {
                _super.prototype.onPropertyChange.call(this, key, nv, ov);
            }
        };
        MenuAdapterComponent.prototype.ngAfterViewInit = function () {
            var _this = this;
            _super.prototype.ngAfterViewInit.call(this);
            var subscriber = this.menuRefQL.changes.subscribe(function (menuRefQL) {
                if (menuRefQL.first) {
                    _this.menuRef = menuRefQL.first;
                    menuProps.forEach(function (prop) {
                        var bindProp = "bind" + prop;
                        if (_this[bindProp]) {
                            _this.menuRef[bindProp] = _this[bindProp];
                        }
                        _this.menuRef[prop] = _this[prop];
                    });
                    subscriber.unsubscribe();
                }
            });
        };
        MenuAdapterComponent.ctorParameters = function () { return [
            null,
            null
        ]; };
        __decorate([
            core.ViewChildren(MenuComponent),
            __metadata("design:type", core.QueryList)
        ], MenuAdapterComponent.prototype, "menuRefQL", void 0);
        MenuAdapterComponent = __decorate([
            core.Directive(),
            __metadata("design:paramtypes", [Object, Object])
        ], MenuAdapterComponent);
        return MenuAdapterComponent;
    }(base.BaseContainerComponent));

    exports.MenuAdapterComponent = MenuAdapterComponent;
    exports.MenuModule = MenuModule;
    exports.NavComponent = NavComponent;
    exports.NavItemDirective = NavItemDirective;
    exports.ɵa = MenuComponent;
    exports.ɵb = registerProps;
    exports.ɵc = registerProps$1;
    exports.ɵd = MenuDropdownComponent;
    exports.ɵe = MenuDropdownItemComponent;
    exports.ɵf = NavigationControlDirective;
    exports.ɵg = registerProps$2;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=index.umd.js.map
