import { AfterViewInit, ElementRef, Injector, OnInit } from '@angular/core';
import { App } from '@wm/core';
import { StylableComponent } from '@wm/components/base';
export declare class PopoverComponent extends StylableComponent implements OnInit, AfterViewInit {
    private app;
    static initializeProps: void;
    event: string;
    isOpen: boolean;
    private closePopoverTimeout;
    readonly popoverContainerCls: any;
    private keyEventPlugin;
    canPopoverOpen: boolean;
    private Widgets;
    private Variables;
    private Actions;
    interaction: string;
    popoverarrow: boolean;
    popoverwidth: string;
    popoverheight: string;
    contentanimation: string;
    contentsource: string;
    content: string;
    popoverplacement: string;
    outsideclick: boolean;
    autoclose: string;
    class: string;
    title: string;
    tabindex: any;
    name: string;
    adaptiveposition: boolean;
    containerTarget: string;
    private bsPopoverDirective;
    anchorRef: ElementRef;
    popoverTemplate: any;
    partialRef: any;
    constructor(inj: Injector, app: App, evtMngrPlugins: any);
    open(): void;
    close(): void;
    onHidden(): void;
    private setFocusToPopoverLink;
    private adjustPopoverArrowPosition;
    private calculatePopoverPostion;
    onShown(): void;
    triggerPopoverEvents(): void;
    private hidePopover;
    private showPopover;
    onPopoverAnchorKeydown($event: any): void;
    onPropertyChange(key: string, nv: any, ov?: any): void;
    ngOnInit(): void;
    ngAfterViewInit(): void;
}
