import { ChangeDetectorRef, ElementRef, Injector, OnDestroy } from '@angular/core';
import { StylableComponent } from '@wm/components/base';
export declare class PrefabDirective extends StylableComponent implements OnDestroy {
    widgetType: string;
    prefabName: string;
    name: string;
    propsReady: Function;
    constructor(inj: Injector, elRef: ElementRef, cdr: ChangeDetectorRef, prefabName: any);
    onStyleChange(key: string, nv: any, ov: any): void;
    setProps(config: any): void;
    protected handleEvent(): void;
    private prepareProps;
    ngOnDestroy(): void;
}
