import { Element } from '@angular/compiler';
export declare const getFormWidgetTemplate: (widgetType: string, innerTmpl: string, attrs?: Map<string, string>, options?: any) => any;
export declare const getRequiredFormWidget: (widgetType: any) => string;
/**
 * exp: User built bind expression
 *  To check the custom pipe expressions.
 *  If user use the custom pipe expression it will check in the exp. that "custom" string exist or not with (:) syntax.
 *  Eg: custom:
 *      custom    :
 */
export declare const checkIsCustomPipeExpression: (exp: any) => any;
export declare const updateTemplateAttrs: (rootNode: Element | Element[], parentDataSet: string, widgetName: string, instance?: string, referenceName?: string) => void;
export declare const getNgModelAttr: (attrs: any) => "" | "ngModel";
export declare const getRowActionAttrs: (attrs: any) => string;
