(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common'), require('@angular/common/http'), require('@wm/core'), require('rxjs')) :
    typeof define === 'function' && define.amd ? define('@wm/http', ['exports', '@angular/core', '@angular/common', '@angular/common/http', '@wm/core', 'rxjs'], factory) :
    (global = global || self, factory((global.wm = global.wm || {}, global.wm.http = {}), global.ng.core, global.ng.common, global.ng.common.http, global.wm.core, global.rxjs));
}(this, (function (exports, core, common, http, core$1, rxjs) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __rest(s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); }
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    function __createBinding(o, m, k, k2) {
        if (k2 === undefined) k2 = k;
        o[k2] = m[k];
    }

    function __exportStar(m, exports) {
        for (var p in m) if (p !== "default" && !exports.hasOwnProperty(p)) exports[p] = m[p];
    }

    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m) return m.call(o);
        if (o && typeof o.length === "number") return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }

    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    }

    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    };

    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }

    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
    }

    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }

    function __asyncValues(o) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
    }

    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
        return cooked;
    };

    function __importStar(mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
        result.default = mod;
        return result;
    }

    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }

    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }

    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    var HttpServiceImpl = /** @class */ (function (_super) {
        __extends(HttpServiceImpl, _super);
        function HttpServiceImpl(httpClient) {
            var _this = _super.call(this) || this;
            _this.httpClient = httpClient;
            _this.nonBodyTypeMethods = ['GET', 'DELETE', 'HEAD', 'OPTIONS', 'JSONP'];
            _this.sessionTimeoutObservable = new rxjs.Subject();
            _this.sessionTimeoutQueue = [];
            return _this;
        }
        /**
         * This method handles session timeout.
         * @param options
         * @param resolve
         * @param reject
         */
        HttpServiceImpl.prototype.handleSessionTimeout = function (options, subscriber401) {
            this.sessionTimeoutQueue.push({
                requestInfo: options,
                sub401: subscriber401
            });
            this.on401();
        };
        /**
         * Generates a request with provided options
         * @param options, request params/options
         */
        HttpServiceImpl.prototype.generateRequest = function (options) {
            var reqHeaders = new http.HttpHeaders(), reqParams = new http.HttpParams();
            var headers = options.headers;
            var params = options.params;
            var responseType = options.responseType;
            var withCredentials = options.withCredentials;
            // this header is not to be sent with non-proxy calls from service variable
            if (!options.isDirectCall) {
                reqHeaders = reqHeaders.append('X-Requested-With', 'XMLHttpRequest');
            }
            // headers
            if (headers) {
                Object.entries(headers).forEach(function (_a) {
                    var _b = __read(_a, 2), k = _b[0], v = _b[1];
                    return reqHeaders = reqHeaders.append(k, v);
                });
            }
            // params
            if (params) {
                Object.entries(params).forEach(function (_a) {
                    var _b = __read(_a, 2), k = _b[0], v = _b[1];
                    return reqParams = reqParams.append(k, v);
                });
            }
            var third, fourth;
            var reqOptions = {
                headers: reqHeaders,
                params: reqParams,
                responseType: responseType,
                withCredentials: withCredentials
            };
            // Even if method is not expecting request body, if body is passed in request, pass it on.
            if (_.includes(this.nonBodyTypeMethods, options.method && options.method.toUpperCase()) && options.data === undefined) {
                third = reqOptions;
                fourth = null;
            }
            else {
                third = options.data;
                fourth = reqOptions;
            }
            return new http.HttpRequest(options.method, options.url, third, fourth);
        };
        /**
         * This method filters and returns error message from the failed network call response.
         * @param err, error form network call failure
         */
        HttpServiceImpl.prototype.getErrMessage = function (err) {
            var HTTP_STATUS_MSG = {
                404: this.getLocale()['MESSAGE_404_ERROR'] || 'Requested resource not found',
                401: this.getLocale()['MESSAGE_401_ERROR'] || 'Requested resource requires authentication',
                403: this.getLocale()['LABEL_FORBIDDEN_MESSAGE'] || 'The requested resource access/action is forbidden.'
            };
            // check if error message present for responded http status
            var errMsg = HTTP_STATUS_MSG[err.status];
            var errorDetails = err.error;
            errorDetails = core$1.getValidJSON(errorDetails) || errorDetails;
            // WM services have the format of error response as errorDetails.error
            if (errorDetails && errorDetails.errors) {
                errMsg = this.parseErrors(errorDetails.errors) || errMsg || 'Service Call Failed';
            }
            else {
                errMsg = errMsg || 'Service Call Failed';
            }
            return errMsg;
        };
        /**
         * Make a http call and returns an observable that can be cancelled
         * @param options, options using which the call needs to be made
         */
        HttpServiceImpl.prototype.sendCallAsObservable = function (options) {
            var req = this.generateRequest(options);
            return this.httpClient.request(req);
        };
        /**
         * Makes a http call and return a promise
         * @param options, options using which the call needs to be made
         */
        HttpServiceImpl.prototype.send = function (options) {
            var _this = this;
            var req = this.generateRequest(options);
            return new Promise(function (resolve, reject) {
                _this.httpClient.request(req).toPromise().then(function (response) {
                    resolve(response);
                }, function (err) {
                    if (_this.isPlatformSessionTimeout(err)) {
                        err._401Subscriber.asObservable().subscribe(function (response) {
                            resolve(response);
                        }, function (e) {
                            reject(e);
                        });
                    }
                    else {
                        var errMsg = _this.getErrMessage(err);
                        reject({
                            error: errMsg,
                            details: err
                        });
                    }
                });
            });
        };
        HttpServiceImpl.prototype.setLocale = function (locale) {
            this.localeObject = locale;
        };
        HttpServiceImpl.prototype.getLocale = function () {
            return this.localeObject;
        };
        HttpServiceImpl.prototype.parseErrors = function (errors) {
            var _this = this;
            var errMsg = '';
            if (errors && errors.error && errors.error.length) {
                errors.error.forEach(function (errorDetails, i) {
                    errMsg += _this.parseError(errorDetails) + (i > 0 ? '\n' : '');
                });
            }
            return errMsg;
        };
        HttpServiceImpl.prototype.parseError = function (errorObj) {
            var errMsg;
            errMsg = errorObj.message ? core$1.replace(errorObj.message, errorObj.parameters, true) : ((errorObj.parameters && errorObj.parameters[0]) || '');
            return errMsg;
        };
        HttpServiceImpl.prototype.getHeader = function (error, headerKey) {
            return error.headers.get(headerKey);
        };
        HttpServiceImpl.prototype.isPlatformSessionTimeout = function (error) {
            var MSG_SESSION_NOT_FOUND = 'Session Not Found';
            return error.status === 401 && this.getHeader(error, 'x-wm-login-errormessage') === MSG_SESSION_NOT_FOUND;
        };
        HttpServiceImpl.prototype.get = function (url, options) {
            options = options || {};
            options.url = url;
            options.method = 'get';
            return this.send(options).then(function (response) { return response.body; });
        };
        HttpServiceImpl.prototype.post = function (url, data, options) {
            options = options || {};
            options.url = url;
            options.method = 'post';
            options.data = data;
            return this.send(options);
        };
        HttpServiceImpl.prototype.put = function (url, data, options) {
            options = options || {};
            options.url = url;
            options.method = 'put';
            options.data = data;
            return this.send(options);
        };
        HttpServiceImpl.prototype.patch = function (url, data, options) {
            options = options || {};
            options.url = url;
            options.method = 'patch';
            options.data = data;
            return this.send(options);
        };
        HttpServiceImpl.prototype.delete = function (url, options) {
            options = options || {};
            options.url = url;
            options.method = 'delete';
            return this.send(options);
        };
        HttpServiceImpl.prototype.head = function (url, options) {
            options = options || {};
            options.url = url;
            options.method = 'head';
            return this.send(options);
        };
        HttpServiceImpl.prototype.jsonp = function (url, options) {
            options = options || {};
            options.url = url;
            options.method = 'jsonp';
            return this.send(options);
        };
        HttpServiceImpl.prototype.upload = function (url, data, options) {
            var req = new http.HttpRequest('POST', url, data, {
                reportProgress: true // for progress data
            });
            return this.httpClient.request(req);
            // return this.httpClient.post(url, data, {
            //     reportProgress: true
            // });
        };
        /**
         * registers a callback to be trigerred on session timeout
         * @param callback
         */
        HttpServiceImpl.prototype.registerOnSessionTimeout = function (callback) {
            this.sessionTimeoutObservable.asObservable().subscribe(callback);
        };
        /**
         * trigger the registered methods on session timeout
         */
        HttpServiceImpl.prototype.on401 = function () {
            this.sessionTimeoutObservable.next();
        };
        HttpServiceImpl.prototype.pushToSessionFailureQueue = function (callback) {
            this.sessionTimeoutQueue.push({
                callback: callback
            });
        };
        /**
         * Execute queued requests, failed due to session timeout
         */
        HttpServiceImpl.prototype.executeSessionFailureRequests = function () {
            var queue = this.sessionTimeoutQueue;
            var that = this;
            that.sessionTimeoutQueue = [];
            queue.forEach(function (data) {
                if (_.isFunction(data.callback)) {
                    data.callback();
                }
                else {
                    data.requestInfo.headers.headers.delete('x-wm-xsrf-token');
                    that.httpClient.request(data.requestInfo)
                        .subscribe(function (response) {
                        if (response && response.type && data.sub401) {
                            data.sub401.next(response);
                        }
                    }, function (reason) {
                        data.sub401.error(reason);
                    });
                }
            });
        };
        HttpServiceImpl.ctorParameters = function () { return [
            { type: http.HttpClient }
        ]; };
        HttpServiceImpl = __decorate([
            core.Injectable(),
            __metadata("design:paramtypes", [http.HttpClient])
        ], HttpServiceImpl);
        return HttpServiceImpl;
    }(core$1.AbstractHttpService));

    /**
     * This class creates a custom WmHttpRequest.
     */
    var WmHttpRequest = /** @class */ (function () {
        function WmHttpRequest() {
            this.headers = [];
        }
        /**
         * This method converts the given wm HttpRequest to angular HttpRequest
         * @param reqObj, the wm HttpRequest
         */
        WmHttpRequest.prototype.wmToAngularRequest = function (reqObj) {
            var angReq;
            angReq = new http.HttpRequest(reqObj.method, reqObj.url);
            angReq = angReq.clone();
            angReq.body = reqObj.body;
            angReq.method = reqObj.method;
            angReq.responseType = reqObj.responseType;
            angReq.reportProgress = reqObj.reportProgress;
            angReq.urlWithParams = reqObj.url;
            angReq.withCredentials = reqObj.withCredentials;
            reqObj.headers.forEach(function (value, header) {
                angReq.headers = angReq.headers.append(header, value);
            });
            return angReq;
        };
        /**
         * This method converts the given angular HttpRequest to wm HttpRequest
         * @param req, the angular HttpRequest
         */
        WmHttpRequest.prototype.angularToWmRequest = function (req) {
            var wmReq = new WmHttpRequest();
            var headerMap = new Map();
            wmReq.body = req.body;
            wmReq.method = req.method;
            wmReq.responseType = req.responseType;
            wmReq.reportProgress = req.reportProgress;
            wmReq.url = req.urlWithParams;
            wmReq.withCredentials = req.withCredentials;
            req.headers.keys().forEach(function (header) {
                headerMap.set(header, req.headers.headers.get(header.toLowerCase())[0]);
            });
            wmReq.headers = headerMap;
            return wmReq;
        };
        return WmHttpRequest;
    }());

    /**
     * This class creates a custom WmHttpRequest.
     */
    var WmHttpResponse = /** @class */ (function (_super) {
        __extends(WmHttpResponse, _super);
        function WmHttpResponse() {
            return _super.call(this) || this;
        }
        /**
         * This method converts the given wm HttpResponse to angular HttpResponse
         * @param respObj, the wm HttpResponse
         */
        WmHttpResponse.prototype.wmToAngularResponse = function (respObj) {
            var angResp;
            angResp = new http.HttpResponse();
            angResp = angResp.clone();
            angResp.body = respObj.body;
            angResp.error = respObj.error;
            angResp.message = respObj.message;
            angResp.url = respObj.url;
            angResp.ok = respObj.ok;
            angResp.status = respObj.status;
            angResp.statusText = respObj.statusText;
            respObj.headers.forEach(function (value, header) {
                angResp.headers = angResp.headers.append(header, value);
            });
            return angResp;
        };
        /**
         * This method converts the given wm HttpResponse to angular HttpResponse
         * @param respObj, the angular HttpResponse
         */
        WmHttpResponse.prototype.angularToWmResponse = function (respObj) {
            var wmResp;
            var headerMap = new Map();
            wmResp = new WmHttpResponse();
            wmResp.body = respObj.body;
            wmResp.error = respObj.error;
            wmResp.message = respObj.message;
            wmResp.url = respObj.url;
            wmResp.ok = respObj.ok;
            wmResp.status = respObj.status;
            wmResp.statusText = respObj.statusText;
            respObj.headers.keys().forEach(function (header) {
                headerMap.set(header, respObj.headers.headers.get(header.toLowerCase())[0]);
            });
            wmResp.headers = headerMap;
            return wmResp;
        };
        return WmHttpResponse;
    }(WmHttpRequest));

    var HttpServiceModule = /** @class */ (function () {
        function HttpServiceModule() {
        }
        HttpServiceModule.forRoot = function () {
            return {
                ngModule: common.CommonModule,
                providers: [
                    { provide: core$1.AbstractHttpService, useClass: HttpServiceImpl }
                ]
            };
        };
        HttpServiceModule = __decorate([
            core.NgModule({
                imports: [
                    common.CommonModule,
                    http.HttpClientModule
                ],
                declarations: []
            })
        ], HttpServiceModule);
        return HttpServiceModule;
    }());

    exports.HttpServiceImpl = HttpServiceImpl;
    exports.HttpServiceModule = HttpServiceModule;
    exports.WmHttpRequest = WmHttpRequest;
    exports.WmHttpResponse = WmHttpResponse;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=index.umd.js.map
