(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@wm/components/base'), require('@wm/core'), require('@angular/common'), require('@wm/mobile/components/basic'), require('@wm/mobile/components/page/mobile-navbar'), require('@wm/components/page'), require('@wm/components/basic')) :
    typeof define === 'function' && define.amd ? define('@wm/mobile/components/data/media-list', ['exports', '@angular/core', '@wm/components/base', '@wm/core', '@angular/common', '@wm/mobile/components/basic', '@wm/mobile/components/page/mobile-navbar', '@wm/components/page', '@wm/components/basic'], factory) :
    (global = global || self, factory((global.wm = global.wm || {}, global.wm.mobile = global.wm.mobile || {}, global.wm.mobile.components = global.wm.mobile.components || {}, global.wm.mobile.components.data = global.wm.mobile.components.data || {}, global.wm.mobile.components.data.medialist = {}), global.ng.core, global.wm.components.base, global.wm.core, global.ng.common, global.wm.mobile.components.basic, global.wm.mobile.components.page.mobilenavbar, global.wm.components.page, global.wm.components.basic));
}(this, (function (exports, core, base, core$1, common, basic, mobileNavbar, page, basic$1) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __rest(s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); }
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    function __createBinding(o, m, k, k2) {
        if (k2 === undefined) k2 = k;
        o[k2] = m[k];
    }

    function __exportStar(m, exports) {
        for (var p in m) if (p !== "default" && !exports.hasOwnProperty(p)) exports[p] = m[p];
    }

    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m) return m.call(o);
        if (o && typeof o.length === "number") return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }

    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    }

    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    };

    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }

    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
    }

    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }

    function __asyncValues(o) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
    }

    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
        return cooked;
    };

    function __importStar(mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
        result.default = mod;
        return result;
    }

    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }

    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }

    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    var MediaListItemDirective = /** @class */ (function () {
        function MediaListItemDirective() {
        }
        MediaListItemDirective_1 = MediaListItemDirective;
        Object.defineProperty(MediaListItemDirective.prototype, "wmMediaListItem", {
            set: function (val) {
                this.item = val;
            },
            enumerable: true,
            configurable: true
        });
        var MediaListItemDirective_1;
        __decorate([
            core.Input(),
            __metadata("design:type", Object),
            __metadata("design:paramtypes", [Object])
        ], MediaListItemDirective.prototype, "wmMediaListItem", null);
        MediaListItemDirective = MediaListItemDirective_1 = __decorate([
            core.Directive({
                selector: '[wmMediaListItem]',
                providers: [
                    base.provideAsWidgetRef(MediaListItemDirective_1)
                ]
            })
        ], MediaListItemDirective);
        return MediaListItemDirective;
    }());

    var registerProps = function () {
        base.register('wm-media-list', new Map([
            ['class', base.PROP_STRING],
            ['dataset', base.PROP_ANY],
            ['layout', __assign({ value: 'Single-row' }, base.PROP_STRING)],
            ['mediaurl', base.PROP_STRING],
            ['name', base.PROP_STRING],
            ['offline', __assign({ value: true }, base.PROP_BOOLEAN)],
            ['show', __assign({ value: true }, base.PROP_BOOLEAN)],
            ['thumbnailheight', __assign({ value: '100pt' }, base.PROP_STRING)],
            ['thumbnailwidth', __assign({ value: '100pt' }, base.PROP_STRING)],
            ['thumbnailurl', base.PROP_STRING],
        ]));
    };

    var DEFAULT_CLS = 'app-medialist';
    var WIDGET_CONFIG = { widgetType: 'wm-media-list', hostClass: DEFAULT_CLS };
    var Layout;
    (function (Layout) {
        Layout["SINGLE_ROW"] = "Single-row";
        Layout["MULTI_ROW"] = "Multi-row";
    })(Layout || (Layout = {}));
    var MediaListComponent = /** @class */ (function (_super) {
        __extends(MediaListComponent, _super);
        function MediaListComponent(inj) {
            var _this = _super.call(this, inj, WIDGET_CONFIG) || this;
            _this.selectedMediaIndex = -1;
            base.styler(_this.nativeElement, _this, base.APPLY_STYLES_TYPE.SCROLLABLE_CONTAINER);
            return _this;
        }
        MediaListComponent_1 = MediaListComponent;
        MediaListComponent.prototype.appendToBody = function () {
            var _this = this;
            if (!this.$fullScreenEle) {
                setTimeout(function () {
                    _this.$fullScreenEle = _this.$element.find('>.app-media-fullscreen');
                    _this.$fullScreenEle.appendTo('body');
                }, 100);
            }
            return true;
        };
        MediaListComponent.prototype.onPropertyChange = function (key, nv, ov) {
            if (key === 'dataset') {
                this.onDataChange(nv);
            }
            else if (key === 'layout') {
                if (nv === Layout.SINGLE_ROW) {
                    core$1.addClass(this.nativeElement, 'singlerow');
                }
                else {
                    core$1.removeClass(this.nativeElement, 'singlerow');
                }
            }
            else {
                _super.prototype.onPropertyChange.call(this, key, nv, ov);
            }
        };
        MediaListComponent.prototype.exitFullScreen = function () {
            this.selectedMediaIndex = -1;
            this.$fullScreenEle.appendTo(this.$element);
            this.$fullScreenEle = null;
            core$1.$appDigest();
        };
        MediaListComponent.prototype.getPicTitle = function () {
            return this.selectedMediaIndex + 1 + '/' + this.fieldDefs.length;
        };
        MediaListComponent.prototype.showFullScreen = function (i) {
            this.selectedMediaIndex = i;
            core$1.$appDigest();
        };
        MediaListComponent.prototype.showNext = function () {
            if (this.selectedMediaIndex < this.fieldDefs.length - 1) {
                this.selectedMediaIndex++;
                core$1.$appDigest();
            }
        };
        // Returns the field value (src) from the fieldDefs
        MediaListComponent.prototype.getSrc = function (field) {
            if (field) {
                return this.fieldDefs[this.selectedMediaIndex][field];
            }
            return '';
        };
        MediaListComponent.prototype.showPrev = function () {
            if (this.selectedMediaIndex > 0) {
                this.selectedMediaIndex--;
                core$1.$appDigest();
            }
        };
        MediaListComponent.prototype.onDataChange = function (nv) {
            if (nv) {
                if (core$1.isObject(nv) && !core$1.isArray(nv)) {
                    nv = [nv];
                }
                if (!this.binddataset) {
                    if (core$1.isString(nv)) {
                        nv = nv.split(',');
                    }
                }
                if (core$1.isArray(nv)) {
                    this.updateFieldDefs(nv);
                }
            }
            else {
                this.updateFieldDefs([]);
            }
        };
        /** With given data, creates media list items*/
        MediaListComponent.prototype.updateFieldDefs = function (data) {
            var _this = this;
            this.fieldDefs = data;
            data.forEach(function (field) {
                field.mediaUrlVal = core$1.$parseExpr(_this.mediaurl)(field);
                field.thumbnailUrlVal = core$1.$parseExpr(_this.thumbnailurl)(field);
            });
            this.fieldDefs = data;
        };
        /**
         * used to track list items by Index.
         * @param {number} index value of the list item
         * @returns {number} index.
         */
        MediaListComponent.prototype.listTrackByFn = function (index) {
            return index;
        };
        var MediaListComponent_1;
        MediaListComponent.initializeProps = registerProps();
        MediaListComponent.ctorParameters = function () { return [
            { type: core.Injector }
        ]; };
        __decorate([
            core.ContentChild('mediaListTemplate'),
            __metadata("design:type", core.TemplateRef)
        ], MediaListComponent.prototype, "mediaListTemplate", void 0);
        MediaListComponent = MediaListComponent_1 = __decorate([
            core.Component({
                selector: '[wmMediaList]',
                template: "<ul class=\"list-unstyled list-inline app-media-thumbnail\">\n    <li *ngFor=\"let item of fieldDefs; index as index;\" [ngStyle]=\"{width: thumbnailwidth, height: thumbnailheight}\" (click)=\"showFullScreen(index)\">\n        <div class=\"thumbnail\">\n            <ng-container [ngTemplateOutlet]=\"imgTemplate\"\n                          [ngTemplateOutletContext]=\"{src: item.thumbnailUrlVal, class: 'thumbnail-image'}\">\n            </ng-container>\n            <div class=\"thumbnail-details\">\n                <ng-container [ngTemplateOutlet]=\"mediaListTemplate\" [ngTemplateOutletContext]=\"{item:item, index:index}\" [wmMediaListItem]=\"item\">\n                </ng-container>\n            </div>\n        </div>\n    </li>\n</ul>\n<div class=\"app-media-fullscreen\" *ngIf=\"selectedMediaIndex >= 0 && appendToBody()\">\n    <header wmMobileNavbar\n            backbutton=\"true\"\n            backbtnclick.event=\"exitFullScreen()\"\n            showLeftnavbtn=\"false\"\n            backbuttoniconclass.event=\"wi wi-chevron-left\"\n            title.bind=\"getPicTitle()\">\n    </header>\n    <div wmContent>\n        <div wmPageContent>\n            <div class=\"media-content\">\n                <div class=\"image-container\"  (swipeleft)=\"showNext()\" (swiperight)=\"showPrev()\">\n                    <ng-container [ngTemplateOutlet]=\"imgTemplate\"\n                                  [ngTemplateOutletContext]=\"{field: 'mediaUrlVal', class: 'center-block'}\">\n                    </ng-container>\n                    <a class=\"app-media-fullscreen-nav-control left\" [hidden]=\"!(selectedMediaIndex > 0)\" (click)=\"showPrev()\">\n                        <i class=\"wi wi-chevron-left\"></i>\n                    </a>\n                    <a class=\"app-media-fullscreen-nav-control right\" [hidden]=\"!(selectedMediaIndex < fieldDefs.length-1)\" (click)=\"showNext()\">\n                        <i class=\"wi wi-chevron-right\"></i>\n                    </a>\n                </div>\n            </div>\n        </div>\n    </div>\n</div>\n\n<ng-template #imgTemplate let-src=\"src\" let-classname=\"class\" let-field=\"field\">\n    <img wmPicture class=\"{{classname}}\" picturesource.bind=\"src || getSrc(field)\" wmImageCache=\"{{offline}}\" />\n</ng-template>\n",
                providers: [
                    base.provideAsWidgetRef(MediaListComponent_1)
                ]
            }),
            __metadata("design:paramtypes", [core.Injector])
        ], MediaListComponent);
        return MediaListComponent;
    }(base.StylableComponent));

    var components = [
        MediaListItemDirective,
        MediaListComponent
    ];
    var MediaListModule = /** @class */ (function () {
        function MediaListModule() {
        }
        MediaListModule = __decorate([
            core.NgModule({
                imports: [
                    basic$1.BasicModule,
                    common.CommonModule,
                    basic.BasicModule,
                    mobileNavbar.MobileNavbarModule,
                    page.PageModule,
                    base.WmComponentsModule
                ],
                declarations: __spread(components),
                exports: __spread(components),
                entryComponents: []
            })
        ], MediaListModule);
        return MediaListModule;
    }());

    exports.MediaListComponent = MediaListComponent;
    exports.MediaListItemDirective = MediaListItemDirective;
    exports.MediaListModule = MediaListModule;
    exports.ɵa = registerProps;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=index.umd.js.map
