(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@wm/components/base'), require('@wm/components/page'), require('@angular/common')) :
    typeof define === 'function' && define.amd ? define('@wm/mobile/components/page/tab-bar', ['exports', '@angular/core', '@wm/components/base', '@wm/components/page', '@angular/common'], factory) :
    (global = global || self, factory((global.wm = global.wm || {}, global.wm.mobile = global.wm.mobile || {}, global.wm.mobile.components = global.wm.mobile.components || {}, global.wm.mobile.components.page = global.wm.mobile.components.page || {}, global.wm.mobile.components.page.tabbar = {}), global.ng.core, global.wm.components.base, global.wm.components.page, global.ng.common));
}(this, (function (exports, core, base, page, common) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __rest(s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); }
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    function __createBinding(o, m, k, k2) {
        if (k2 === undefined) k2 = k;
        o[k2] = m[k];
    }

    function __exportStar(m, exports) {
        for (var p in m) if (p !== "default" && !exports.hasOwnProperty(p)) exports[p] = m[p];
    }

    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m) return m.call(o);
        if (o && typeof o.length === "number") return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }

    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    }

    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    };

    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }

    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
    }

    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }

    function __asyncValues(o) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
    }

    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
        return cooked;
    };

    function __importStar(mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
        result.default = mod;
        return result;
    }

    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }

    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }

    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    var registerProps = function () {
        base.register('wm-mobile-tabbar', new Map([
            ['class', base.PROP_STRING],
            ['dataset', base.PROP_ANY],
            ['itemicon', base.PROP_STRING],
            ['itemlabel', base.PROP_STRING],
            ['itemlink', base.PROP_STRING],
            ['morebuttoniconclass', __assign({ value: 'wi wi-more-horiz' }, base.PROP_STRING)],
            ['morebuttonlabel', __assign({ value: 'more' }, base.PROP_STRING)],
            ['name', base.PROP_STRING],
            ['show', __assign({ value: true }, base.PROP_BOOLEAN)]
        ]));
    };

    var DEFAULT_CLS = 'app-tabbar app-top-nav';
    var WIDGET_CONFIG = { widgetType: 'wm-mobile-tabbar', hostClass: DEFAULT_CLS };
    var MobileTabbarComponent = /** @class */ (function (_super) {
        __extends(MobileTabbarComponent, _super);
        function MobileTabbarComponent(page, inj, binditemlabel, binditemicon, binditemlink) {
            var _this = _super.call(this, inj, WIDGET_CONFIG) || this;
            _this.page = page;
            _this.binditemlabel = binditemlabel;
            _this.binditemicon = binditemicon;
            _this.binditemlink = binditemlink;
            _this.tabItems = [];
            _this.layout = {};
            _this._layouts = [
                { minwidth: 2048, max: 12 },
                { minwidth: 1024, max: 10 },
                { minwidth: 768, max: 7 },
                { minwidth: 480, max: 5 },
                { minwidth: 0, max: 4 }
            ];
            base.styler(_this.nativeElement, _this);
            page.notify('wmMobileTabbar:ready', _this);
            return _this;
        }
        MobileTabbarComponent_1 = MobileTabbarComponent;
        MobileTabbarComponent.prototype.onPropertyChange = function (key, nv, ov) {
            if (key === 'dataset') {
                if (nv) {
                    this.tabItems = this.getTabItems(nv);
                }
            }
            else {
                _super.prototype.onPropertyChange.call(this, key, nv, ov);
            }
        };
        MobileTabbarComponent.prototype.ngAfterViewInit = function () {
            var _this = this;
            setTimeout(function () {
                _this.layout = _this.getSuitableLayout();
                $(window).on('resize.tabbar', _.debounce(function () { return _this.layout = _this.getSuitableLayout(); }, 20));
            });
            _super.prototype.ngAfterViewInit.call(this);
        };
        MobileTabbarComponent.prototype.ngOnDestroy = function () {
            $(window).off('.tabbar');
            _super.prototype.ngOnDestroy.call(this);
        };
        // triggered on item selection
        MobileTabbarComponent.prototype.onItemSelect = function ($event, selectedItem) {
            this.invokeEventCallback('select', { $event: $event, $item: selectedItem.value || selectedItem.label });
        };
        MobileTabbarComponent.prototype.getItems = function (itemArray) {
            return itemArray.map(function (item) { return ({
                label: item,
                icon: 'wi wi-' + item
            }); });
        };
        MobileTabbarComponent.prototype.getSuitableLayout = function () {
            var avaiableWidth = $(this.nativeElement).parent().width();
            return this._layouts.find(function (l) { return avaiableWidth >= l.minwidth; });
        };
        MobileTabbarComponent.prototype.getTabItems = function (value) {
            var _this = this;
            if (_.isArray(value)) {
                if (_.isObject(value[0])) {
                    return value.map(function (item) {
                        var link = base.getEvaluatedData(item, { expression: 'itemlink', 'bindExpression': _this.binditemlink }, _this.viewParent) || item.link;
                        var activePageName = window.location.hash.substr(2);
                        return {
                            label: base.getEvaluatedData(item, { expression: 'itemlabel', bindExpression: _this.binditemlabel }, _this.viewParent) || item.label,
                            icon: base.getEvaluatedData(item, { expression: 'itemicon', bindExpression: _this.binditemicon }, _this.viewParent) || item.icon,
                            link: link,
                            active: _.includes([activePageName, '#' + activePageName, '#/' + activePageName], link)
                        };
                    });
                }
                else {
                    return this.getItems(value);
                }
            }
            else if (_.isString(value)) {
                return this.getItems(value.split(','));
            }
        };
        var MobileTabbarComponent_1;
        MobileTabbarComponent.initializeProps = registerProps();
        MobileTabbarComponent.ctorParameters = function () { return [
            { type: page.PageDirective },
            { type: core.Injector },
            { type: undefined, decorators: [{ type: core.Attribute, args: ['itemlabel.bind',] }] },
            { type: undefined, decorators: [{ type: core.Attribute, args: ['itemicon.bind',] }] },
            { type: undefined, decorators: [{ type: core.Attribute, args: ['itemicon.bind',] }] }
        ]; };
        MobileTabbarComponent = MobileTabbarComponent_1 = __decorate([
            core.Component({
                selector: 'div[wmMobileTabbar]',
                template: "<nav class=\"navbar navbar-default\">\n    <ul class=\"tab-items nav navbar-nav\">\n        <li class=\"tab-item\" *ngFor=\"let item of tabItems; index as i\" [class.hidden]=\"!(tabItems.length === layout.max || i < layout.max)\" >\n            <a [class.active]=\"item.active\" [href]=\"(item.link || 'javascript:void(0)')| trustAs: 'resource'\" (click)=\"onItemSelect($event, item)\">\n                <i class=\"app-icon\" [ngClass]=\"item.icon\"></i><label>{{item.label}}</label>\n            </a>\n        </li>\n        <li class=\"menu-items dropdown\" [class.hidden]=\"tabItems.length <= layout.max\" [ngClass]=\"{dropup : position === bottom}\">\n            <a (click)=\"showMoreMenu = !showMoreMenu\" href=\"javascript:void(0)\">\n                <i class=\"app-icon {{morebuttoniconclass}}\"></i><label>{{morebuttonlabel}}</label>\n            </a>\n            <ul class=\"dropdown-menu dropdown-menu-right\" [ngClass]=\"{'nav navbar-nav' : menutype === thumbnail}\" *ngIf=\"showMoreMenu\">\n                <li role=\"menuitem\" class=\"menu-item\" *ngFor=\"let item of tabItems;index as i\" [class.hidden]=\"i < layout.max\">\n                    <a [ngClass]=\"{active : item.active}\" [href]=\"(item.link || 'javascript:void(0)')| trustAs: 'resource'\" (click)=\"onItemSelect($event, item)\" class=\"dropdown-item\">\n                        <i class=\"app-icon\" [ngClass]=\"item.icon\"></i><label>{{item.label}}</label>\n                    </a>\n                </li>\n            </ul>\n        </li>\n    </ul>\n</nav>\n",
                providers: [
                    base.provideAsWidgetRef(MobileTabbarComponent_1)
                ]
            }),
            __param(2, core.Attribute('itemlabel.bind')),
            __param(3, core.Attribute('itemicon.bind')),
            __param(4, core.Attribute('itemicon.bind')),
            __metadata("design:paramtypes", [page.PageDirective,
                core.Injector, Object, Object, Object])
        ], MobileTabbarComponent);
        return MobileTabbarComponent;
    }(base.StylableComponent));

    var components = [
        MobileTabbarComponent
    ];
    var TabBarModule = /** @class */ (function () {
        function TabBarModule() {
        }
        TabBarModule = __decorate([
            core.NgModule({
                imports: [
                    common.CommonModule,
                    base.WmComponentsModule
                ],
                declarations: __spread(components),
                exports: __spread(components),
                entryComponents: []
            })
        ], TabBarModule);
        return TabBarModule;
    }());

    exports.MobileTabbarComponent = MobileTabbarComponent;
    exports.TabBarModule = TabBarModule;
    exports.ɵa = registerProps;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=index.umd.js.map
