(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@ionic-native/app-version'), require('@ionic-native/barcode-scanner'), require('@ionic-native/calendar'), require('@ionic-native/camera'), require('@ionic-native/device'), require('@ionic-native/contacts'), require('@ionic-native/media-capture'), require('@ionic-native/geolocation'), require('@ionic-native/vibration'), require('@wm/core'), require('@wm/mobile/core'), require('@wm/mobile/offline'), require('@wm/security'), require('@wm/variables'), require('@wm/mobile/components/basic')) :
    typeof define === 'function' && define.amd ? define('@wm/mobile/variables', ['exports', '@angular/core', '@ionic-native/app-version', '@ionic-native/barcode-scanner', '@ionic-native/calendar', '@ionic-native/camera', '@ionic-native/device', '@ionic-native/contacts', '@ionic-native/media-capture', '@ionic-native/geolocation', '@ionic-native/vibration', '@wm/core', '@wm/mobile/core', '@wm/mobile/offline', '@wm/security', '@wm/variables', '@wm/mobile/components/basic'], factory) :
    (global = global || self, factory((global.wm = global.wm || {}, global.wm.mobile = global.wm.mobile || {}, global.wm.mobile.variables = {}), global.ng.core, global.ionicNative.plugins, global.ionicNative.plugins, global.ionicNative.plugins, global.ionicNative.plugins, global.ionicNative.plugins, global.ionicNative.plugins, global.ionicNative.plugins, global.ionicNative.plugins, global.ionicNative.plugins, global.wm.core, global.wm.mobile.core, global.wm.mobile.offline, global.wm.security, global.wm.variables, global.wm.mobile.components.basic));
}(this, (function (exports, core, appVersion, barcodeScanner, calendar, camera, device, contacts, mediaCapture, geolocation, vibration, core$1, core$2, offline, security, variables, basic) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __rest(s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); }
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    function __createBinding(o, m, k, k2) {
        if (k2 === undefined) k2 = k;
        o[k2] = m[k];
    }

    function __exportStar(m, exports) {
        for (var p in m) if (p !== "default" && !exports.hasOwnProperty(p)) exports[p] = m[p];
    }

    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m) return m.call(o);
        if (o && typeof o.length === "number") return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }

    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    }

    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    };

    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }

    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
    }

    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }

    function __asyncValues(o) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
    }

    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
        return cooked;
    };

    function __importStar(mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
        result.default = mod;
        return result;
    }

    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }

    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }

    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    var DEFAULT_TIME = new Date().getTime();
    /*3 months timestamp value*/
    var DELTA_VALUE_DATE = (3 * 30 * 24 * 60 * 60 * 1000);
    var DEFAULT_START_DATE = (DEFAULT_TIME - DELTA_VALUE_DATE);
    var DEFAULT_END_DATE = (DEFAULT_TIME + DELTA_VALUE_DATE);
    var EVENT_META = {
        title: '',
        message: '',
        location: '',
        startDate: new Date(),
        endDate: new Date()
    };
    /**
     * this file contains all calendar operations under 'calendar' service.
     */
    var CalendarService = /** @class */ (function (_super) {
        __extends(CalendarService, _super);
        function CalendarService(calendar) {
            var _this = _super.call(this) || this;
            _this.name = 'calendar';
            _this.operations = [];
            _this.operations.push(new CreateEventOperation(calendar), new DeleteEventOperation(calendar), new GetEventsOperation(calendar));
            return _this;
        }
        return CalendarService;
    }(variables.DeviceVariableService));
    var CreateEventOperation = /** @class */ (function () {
        function CreateEventOperation(calendar) {
            this.calendar = calendar;
            this.name = 'createEvent';
            this.properties = [
                { target: 'eventTitle', type: 'string', dataBinding: true },
                { target: 'eventNotes', type: 'string', dataBinding: true },
                { target: 'eventLocation', type: 'string', dataBinding: true },
                { target: 'eventStart', type: 'datetime', dataBinding: true },
                { target: 'eventEnd', type: 'datetime', dataBinding: true }
            ];
            this.requiredCordovaPlugins = ['CALENDAR'];
        }
        CreateEventOperation.prototype.invoke = function (variable, options, eventInfo) {
            return this.calendar.createEvent(eventInfo.get('eventTitle'), eventInfo.get('eventLocation'), eventInfo.get('eventNotes'), new Date(eventInfo.get('eventStart') || 0), new Date(eventInfo.get('eventEnd') || 0));
        };
        return CreateEventOperation;
    }());
    var DeleteEventOperation = /** @class */ (function () {
        function DeleteEventOperation(calendar) {
            this.calendar = calendar;
            this.name = 'deleteEvent';
            this.properties = [
                { target: 'eventTitle', type: 'string', dataBinding: true },
                { target: 'eventNotes', type: 'string', dataBinding: true },
                { target: 'eventLocation', type: 'string', dataBinding: true },
                { target: 'eventStart', type: 'datetime', dataBinding: true },
                { target: 'eventEnd', type: 'datetime', dataBinding: true }
            ];
            this.requiredCordovaPlugins = ['CALENDAR'];
        }
        DeleteEventOperation.prototype.invoke = function (variable, options, eventInfo) {
            return this.calendar.deleteEvent(eventInfo.get('eventTitle'), eventInfo.get('eventLocation'), eventInfo.get('eventNotes'), new Date(eventInfo.get('eventStart') || DEFAULT_START_DATE), new Date(eventInfo.get('eventEnd') || DEFAULT_END_DATE));
        };
        return DeleteEventOperation;
    }());
    var GetEventsOperation = /** @class */ (function () {
        function GetEventsOperation(calendar) {
            this.calendar = calendar;
            this.name = 'getEvents';
            this.model = [EVENT_META];
            this.properties = [
                { target: 'eventTitle', type: 'string', dataBinding: true },
                { target: 'eventNotes', type: 'string', dataBinding: true },
                { target: 'eventLocation', type: 'string', dataBinding: true },
                { target: 'eventStart', type: 'datetime', dataBinding: true },
                { target: 'eventEnd', type: 'datetime', dataBinding: true }
            ];
            this.requiredCordovaPlugins = ['CALENDAR'];
        }
        GetEventsOperation.prototype.invoke = function (variable, options, eventInfo) {
            return this.calendar.findEvent(eventInfo.get('eventTitle'), eventInfo.get('eventLocation'), eventInfo.get('eventNotes'), new Date(eventInfo.get('eventStart') || DEFAULT_START_DATE), new Date(eventInfo.get('eventEnd') || DEFAULT_END_DATE));
        };
        return GetEventsOperation;
    }());

    var CameraService = /** @class */ (function (_super) {
        __extends(CameraService, _super);
        function CameraService(camera, mediaCapture) {
            var _this = _super.call(this) || this;
            _this.name = 'camera';
            _this.operations = [];
            _this.operations.push(new CaptureImageOperation(camera), new CaptureVideoOperation(mediaCapture));
            return _this;
        }
        return CameraService;
    }(variables.DeviceVariableService));
    var CaptureImageOperation = /** @class */ (function () {
        function CaptureImageOperation(camera) {
            this.camera = camera;
            this.name = 'captureImage';
            this.model = {
                imagePath: 'resources/images/imagelists/default-image.png'
            };
            this.properties = [
                { target: 'allowImageEdit', type: 'boolean', value: false, dataBinding: true },
                { target: 'imageQuality', type: 'number', value: 80, dataBinding: true },
                { target: 'imageEncodingType', type: 'list', options: { '0': 'JPEG', '1': 'PNG' }, value: '0', dataBinding: true },
                { target: 'correctOrientation', type: 'boolean', value: true, dataBinding: true },
                { target: 'imageTargetWidth', type: 'number', dataBinding: true },
                { target: 'imageTargetHeight', type: 'number', dataBinding: true }
            ];
            this.requiredCordovaPlugins = ['CAMERA', 'CAPTURE'];
        }
        CaptureImageOperation.prototype.invoke = function (variable, options, dataBindings) {
            var imageTargetWidth = dataBindings.get('imageTargetWidth'), imageTargetHeight = dataBindings.get('imageTargetHeight');
            var imageEncodingType = parseInt(dataBindings.get('imageEncodingType'), 10), cameraOptions;
            if (isNaN(imageEncodingType)) {
                imageEncodingType = (dataBindings.get('imageEncodingType') === 'JPEG' ? 0 : 1);
            }
            cameraOptions = {
                quality: dataBindings.get('imageQuality'),
                destinationType: 1,
                sourceType: 1,
                allowEdit: dataBindings.get('allowImageEdit'),
                encodingType: imageEncodingType,
                mediaType: 0,
                correctOrientation: dataBindings.get('correctOrientation'),
                targetWidth: core$1.isNumber(imageTargetWidth) ? imageTargetWidth : undefined,
                targetHeight: core$1.isNumber(imageTargetHeight) ? imageTargetHeight : undefined,
            };
            return this.camera.getPicture(cameraOptions).then(function (data) {
                return { imagePath: data };
            });
        };
        return CaptureImageOperation;
    }());
    var CaptureVideoOperation = /** @class */ (function () {
        function CaptureVideoOperation(mediaCapture) {
            this.mediaCapture = mediaCapture;
            this.name = 'captureVideo';
            this.model = {
                videoPath: ''
            };
            this.properties = [];
            this.requiredCordovaPlugins = ['CAMERA', 'CAPTURE'];
        }
        CaptureVideoOperation.prototype.invoke = function (variable, options) {
            return this.mediaCapture.captureVideo({
                limit: 1
            }).then(function (data) {
                var path = data[0].fullPath;
                path = (path.startsWith('file://') ? '' : 'file://') + path;
                return { videoPath: path };
            });
        };
        return CaptureVideoOperation;
    }());

    var FileService = /** @class */ (function (_super) {
        __extends(FileService, _super);
        function FileService(fileOpener, fileUploader) {
            var _this = _super.call(this) || this;
            _this.name = 'file';
            _this.operations = [];
            _this.operations.push(new OpenFileOperation(fileOpener), new UploadFileOperation(fileUploader));
            return _this;
        }
        return FileService;
    }(variables.DeviceVariableService));
    var OpenFileOperation = /** @class */ (function () {
        function OpenFileOperation(fileOpener) {
            this.fileOpener = fileOpener;
            this._defaultFileTypesToOpen = {
                'doc': { 'label': 'Microsoft Office Word Document', 'mimeType': 'application/msword', 'extension': 'doc' },
                'pdf': { 'label': 'PDF Document', 'mimeType': 'application/pdf', 'extension': 'pdf' },
                'ppt': { 'label': 'Microsoft Office Powerpoint', 'mimeType': 'application/vnd.ms-powerpoint', 'extension': 'ppt' },
                'xls': { 'label': 'Microsoft Office Excel', 'mimeType': 'application/vnd.ms-excel', 'extension': 'xls' }
            };
            this.name = 'openFile';
            this.model = {};
            this.properties = [
                { target: 'filePath', type: 'string', value: '', dataBinding: true },
                { target: 'fileType', type: 'list', options: _.mapValues(this._defaultFileTypesToOpen, 'label'), value: 'pdf', dataBinding: true, hide: true },
                { target: 'spinnerContext', hide: false },
                { target: 'spinnerMessage', hide: false }
            ];
            this.requiredCordovaPlugins = [];
        }
        OpenFileOperation.prototype.invoke = function (variable, options, dataBindings) {
            var fileType = this._defaultFileTypesToOpen[dataBindings.get('fileType')];
            var filePath = dataBindings.get('filePath');
            // if relative path is given, then append url with deployedUrl, to access files in resources.
            if (!core$1.isValidWebURL(filePath)) {
                filePath = variables.$rootScope.project.deployedUrl + filePath;
            }
            return this.fileOpener.openRemoteFile(filePath, fileType.extension);
        };
        return OpenFileOperation;
    }());
    var UploadFileOperation = /** @class */ (function () {
        function UploadFileOperation(fileUploader) {
            this.fileUploader = fileUploader;
            this.name = 'upload';
            this.model = {
                fileName: '',
                path: '',
                length: 0,
                success: false,
                inlinePath: '',
                errorMessage: '',
                inProgress: false,
                loaded: 0
            };
            this.properties = [
                { target: 'localFile', type: 'string', value: '', dataBinding: true },
                { target: 'remoteFolder', type: 'string', value: '', dataBinding: true },
                { target: 'onProgress', hide: false },
                { target: 'spinnerContext', hide: false },
                { target: 'spinnerMessage', hide: false }
            ];
            this.requiredCordovaPlugins = [];
        }
        UploadFileOperation.prototype.invoke = function (variable, options, dataBindings) {
            var serverUrl = variables.$rootScope.project.deployedUrl + 'services/file/uploadFile?relativePath=' + (dataBindings.get('remoteFolder') || ''), filePath = dataBindings.get('localFile'), fileName = filePath.split('/').pop(), data = {
                fileName: fileName,
                fileSize: 0,
                inProgress: true,
                length: 0,
                loaded: 0
            };
            return this.fileUploader.upload(serverUrl, 'files', filePath, fileName)
                .then(function (uploadResponse) {
                _.assignIn(data, JSON.parse(uploadResponse.text)[0]);
                data.loaded = data.length;
                return data;
            });
        };
        return UploadFileOperation;
    }());

    var APP_IS_OFFLINE = 'App is offline.';
    var OFFLINE_PLUGIN_NOT_FOUND = 'Offline DB Plugin is required, but missing.';
    var ON_BEFORE_BLOCKED = 'onBefore callback returned false.';
    var REQUIRED_PLUGINS = ['OFFLINE_DB', 'NETWORK'];
    var DatasyncService = /** @class */ (function (_super) {
        __extends(DatasyncService, _super);
        function DatasyncService(app, changeLogService, fileSelectorService, localDBManagementService, localDBDataPullService, processManagementService, securityService, networkService) {
            var _this = _super.call(this) || this;
            _this.name = 'datasync';
            _this.operations = [];
            _this.operations.push(new ExportDBOperation(localDBManagementService));
            _this.operations.push(new GetOfflineChangesOperation(changeLogService));
            _this.operations.push(new ImportDBOperation(fileSelectorService, localDBManagementService));
            _this.operations.push(new LastPullInfoOperation(localDBDataPullService));
            _this.operations.push(new LastPushInfoOperation(changeLogService));
            _this.operations.push(new PullOperation(app, processManagementService, networkService, securityService, localDBDataPullService));
            _this.operations.push(new PushOperation(app, changeLogService, processManagementService, networkService, securityService));
            return _this;
        }
        return DatasyncService;
    }(variables.DeviceVariableService));
    var ExportDBOperation = /** @class */ (function () {
        function ExportDBOperation(localDBManagementService) {
            this.localDBManagementService = localDBManagementService;
            this.name = 'exportDB';
            this.model = { path: '' };
            this.properties = [
                { target: 'spinnerContext', hide: false },
                { target: 'spinnerMessage', hide: false }
            ];
            this.requiredCordovaPlugins = REQUIRED_PLUGINS;
        }
        ExportDBOperation.prototype.invoke = function (variable, options, dataBindings) {
            if (window['SQLitePlugin']) {
                return this.localDBManagementService.exportDB();
            }
            return Promise.reject(OFFLINE_PLUGIN_NOT_FOUND);
        };
        return ExportDBOperation;
    }());
    var GetOfflineChangesOperation = /** @class */ (function () {
        function GetOfflineChangesOperation(changeLogService) {
            this.changeLogService = changeLogService;
            this.name = 'getOfflineChanges';
            this.model = {
                total: 0,
                pendingToSync: GetOfflineChangesOperation.CHANGE_LOG_SET,
                failedToSync: GetOfflineChangesOperation.CHANGE_LOG_SET
            };
            this.properties = [
                { target: 'startUpdate', type: 'boolean', value: true, hide: true },
                { target: 'autoUpdate', type: 'boolean', value: true, hide: true }
            ];
            this.requiredCordovaPlugins = REQUIRED_PLUGINS;
        }
        GetOfflineChangesOperation.prototype.invoke = function (variable, options, dataBindings) {
            if (window['SQLitePlugin']) {
                return getOfflineChanges(this.changeLogService);
            }
            return Promise.reject(OFFLINE_PLUGIN_NOT_FOUND);
        };
        GetOfflineChangesOperation.DATA_CHANGE_TEMPLATE = {
            service: 'DatabaseService',
            operation: 'operation',
            params: {
                data: {},
                dataModelName: 'dataModelName',
                entityName: 'entityName'
            },
            hasError: 0,
            errorMessage: ''
        };
        GetOfflineChangesOperation.CHANGE_LOG_SET = {
            total: 0,
            database: {
                create: [GetOfflineChangesOperation.DATA_CHANGE_TEMPLATE],
                update: [GetOfflineChangesOperation.DATA_CHANGE_TEMPLATE],
                delete: [GetOfflineChangesOperation.DATA_CHANGE_TEMPLATE]
            },
            uploads: [{
                    service: 'OfflineFileUploadService',
                    operation: 'uploadToServer',
                    params: {
                        file: 'localFilePath',
                        serverUrl: 'serverUrl',
                        ftOptions: {}
                    },
                    hasError: 0,
                    errorMessage: ''
                }]
        };
        return GetOfflineChangesOperation;
    }());
    var LastPullInfoOperation = /** @class */ (function () {
        function LastPullInfoOperation(localDBDataPullService) {
            this.localDBDataPullService = localDBDataPullService;
            this.name = 'lastPullInfo';
            this.model = {
                databases: [{
                        name: 'datbaseName',
                        entities: [{
                                entityName: 'entityName',
                                pulledRecordCount: 0
                            }],
                        pulledRecordCount: 0
                    }],
                totalPulledRecordCount: 0,
                startTime: new Date().toJSON(),
                endTime: new Date().toJSON()
            };
            this.properties = [
                { target: 'startUpdate', type: 'boolean', value: true, hide: true },
                { target: 'spinnerContext', hide: false },
                { target: 'spinnerMessage', hide: false }
            ];
            this.requiredCordovaPlugins = REQUIRED_PLUGINS;
        }
        LastPullInfoOperation.prototype.invoke = function (variable, options, dataBindings) {
            if (window['SQLitePlugin']) {
                return this.localDBDataPullService.getLastPullInfo();
            }
            return Promise.reject(OFFLINE_PLUGIN_NOT_FOUND);
        };
        return LastPullInfoOperation;
    }());
    var LastPushInfoOperation = /** @class */ (function () {
        function LastPushInfoOperation(changeLogService) {
            this.changeLogService = changeLogService;
            this.name = 'lastPushInfo';
            this.model = {
                successfulTaskCount: 0,
                failedTaskCount: 0,
                completedTaskCount: 0,
                totalTaskCount: 0,
                startTime: new Date().toJSON(),
                endTime: new Date().toJSON()
            };
            this.properties = [
                { target: 'startUpdate', type: 'boolean', value: true, hide: true },
                { target: 'spinnerContext', hide: false },
                { target: 'spinnerMessage', hide: false }
            ];
            this.requiredCordovaPlugins = REQUIRED_PLUGINS;
        }
        LastPushInfoOperation.prototype.invoke = function (variable, options, dataBindings) {
            if (window['SQLitePlugin']) {
                return this.changeLogService.getLastPushInfo();
            }
            return Promise.reject(OFFLINE_PLUGIN_NOT_FOUND);
        };
        return LastPushInfoOperation;
    }());
    var ImportDBOperation = /** @class */ (function () {
        function ImportDBOperation(fileSelectorService, localDBManagementService) {
            this.fileSelectorService = fileSelectorService;
            this.localDBManagementService = localDBManagementService;
            this.name = 'importDB';
            this.model = {};
            this.properties = [
                { target: 'spinnerContext', hide: false },
                { target: 'spinnerMessage', hide: false }
            ];
            this.requiredCordovaPlugins = REQUIRED_PLUGINS;
        }
        ImportDBOperation.prototype.invoke = function (variable, options, dataBindings) {
            var _this = this;
            if (window['SQLitePlugin']) {
                return this.fileSelectorService.selectFiles(false, 'zip')
                    .then(function (files) {
                    if (files && files.length) {
                        return _this.localDBManagementService.importDB(files[0].path, true);
                    }
                });
            }
            return Promise.reject(OFFLINE_PLUGIN_NOT_FOUND);
        };
        return ImportDBOperation;
    }());
    var PullOperation = /** @class */ (function () {
        function PullOperation(app, processManagementService, networkService, securityService, localDBDataPullService) {
            this.app = app;
            this.processManagementService = processManagementService;
            this.networkService = networkService;
            this.securityService = securityService;
            this.localDBDataPullService = localDBDataPullService;
            this.name = 'pull';
            this.model = {
                totalTaskCount: 0,
                completedTaskCount: 0,
                inProgress: false
            };
            this.properties = [
                { target: 'clearData', type: 'boolean', widgettype: 'boolean-inputfirst', value: true, group: 'properties', subGroup: 'behavior' },
                { target: 'startUpdate', type: 'boolean', hide: false },
                { target: 'onBefore', hide: false },
                { target: 'onProgress', hide: false },
                { target: 'showProgress', hide: false }
            ];
            this.requiredCordovaPlugins = REQUIRED_PLUGINS;
        }
        PullOperation.prototype.invoke = function (variable, options, dataBindings) {
            var _this = this;
            var progressInstance;
            return canExecute(variable, this.networkService, this.securityService)
                .then(function () {
                if (variable.showProgress) {
                    return _this.processManagementService.createInstance(_this.app.appLocale.LABEL_DATA_PULL_PROGRESS, 0, 0);
                }
                return null;
            }).then(function (instance) {
                var progressObserver = {
                    next: function (pullInfo) {
                        // variable.dataSet = progress; Todo: progress
                        variables.initiateCallback('onProgress', variable, pullInfo);
                        if (progressInstance) {
                            progressInstance.set('max', pullInfo.totalRecordsToPull);
                            progressInstance.set('value', pullInfo.totalPulledRecordCount);
                        }
                    }, error: core$1.noop, complete: core$1.noop
                };
                var clearData = variable.clearData === 'true' || variable.clearData === true, pullPromise = _this.localDBDataPullService.pullAllDbData(clearData, progressObserver);
                if (instance) {
                    progressInstance = instance;
                    progressInstance.set('stopButtonLabel', _this.app.appLocale.LABEL_DATA_PULL_PROGRESS_STOP_BTN);
                    progressInstance.set('onStop', function () {
                        _this.localDBDataPullService.cancel(pullPromise);
                    });
                }
                return pullPromise;
            }).catch(function (pullInfo) { return pullInfo; })
                .then(function (pullInfo) {
                if (progressInstance) {
                    progressInstance.destroy();
                }
                return pullInfo;
            });
        };
        return PullOperation;
    }());
    var PushOperation = /** @class */ (function () {
        function PushOperation(app, changeLogService, processManagementService, networkService, securityService) {
            this.app = app;
            this.changeLogService = changeLogService;
            this.processManagementService = processManagementService;
            this.networkService = networkService;
            this.securityService = securityService;
            this.name = 'push';
            this.model = {
                successfulTaskCount: 0,
                failedTaskCount: 0,
                completedTaskCount: 0,
                totalTaskCount: 0,
                inProgress: false
            };
            this.properties = [
                { target: 'onBefore', hide: false },
                { target: 'onProgress', hide: false },
                { target: 'showProgress', 'hide': false, 'value': true }
            ];
            this.requiredCordovaPlugins = REQUIRED_PLUGINS;
        }
        PushOperation.prototype.invoke = function (variable, options, dataBindings) {
            var _this = this;
            var progressInstance;
            if (this.changeLogService.isFlushInProgress()) {
                return Promise.resolve();
            }
            return canExecute(variable, this.networkService, this.securityService)
                .then(function () { return getOfflineChanges(_this.changeLogService); })
                .then(function (changes) {
                if (changes.pendingToSync.total <= 0) {
                    return Promise.reject(_.clone(_this.model));
                }
            }).then(function () {
                if (variable.showProgress) {
                    return _this.processManagementService.createInstance(_this.app.appLocale.LABEL_DATA_PUSH_PROGRESS, 0, 0);
                }
                return null;
            }).then(function (instance) {
                var progressObserver = {
                    next: function (pushInfo) {
                        pushInfo = addOldPropertiesForPushData(pushInfo);
                        variables.initiateCallback('onProgress', variable, pushInfo);
                        if (progressInstance) {
                            progressInstance.set('max', pushInfo.totalTaskCount);
                            progressInstance.set('value', pushInfo.completedTaskCount);
                        }
                    }, error: core$1.noop, complete: core$1.noop
                };
                var pushPromise = _this.changeLogService.flush(progressObserver);
                if (instance) {
                    progressInstance = instance;
                    progressInstance.set('stopButtonLabel', _this.app.appLocale.LABEL_DATA_PUSH_PROGRESS_STOP_BTN);
                    progressInstance.set('onStop', function () { return _this.changeLogService.stop(); });
                }
                return pushPromise;
            })
                .catch(function (pushInfo) { return pushInfo; })
                .then(function (pushInfo) {
                if (progressInstance) {
                    progressInstance.destroy();
                }
                if (pushInfo && pushInfo.totalTaskCount !== undefined) {
                    pushInfo = addOldPropertiesForPushData(pushInfo);
                    if (pushInfo.failedTaskCount !== 0) {
                        return Promise.reject(pushInfo);
                    }
                    return pushInfo;
                }
                return Promise.reject(pushInfo);
            });
        };
        return PushOperation;
    }());
    /**
     * This function adds the old properties to the push dataSet to support old projects.
     * @param data
     * @returns {*}
     */
    var addOldPropertiesForPushData = function (data) {
        var result = _.clone(data);
        result.success = data.successfulTaskCount;
        result.error = data.failedTaskCount;
        result.completed = data.completedTaskCount;
        result.total = data.totalTaskCount;
        return result;
    };
    var ɵ0 = addOldPropertiesForPushData;
    var canExecute = function (variable, networkService, securityService) {
        if (!window['SQLitePlugin']) {
            return Promise.reject(OFFLINE_PLUGIN_NOT_FOUND);
        }
        if (!networkService.isConnected()) {
            return Promise.reject(APP_IS_OFFLINE);
        }
        return core$1.toPromise(variables.initiateCallback(variables.VARIABLE_CONSTANTS.EVENT.BEFORE, variable, null))
            .then(function (proceed) {
            if (proceed === false) {
                return Promise.reject(ON_BEFORE_BLOCKED);
            }
            // If user is authenticated and online, then start the data pull process.
            return securityService.onUserLogin();
        });
    };
    var ɵ1 = canExecute;
    var generateChangeSet = function (changes) {
        var createChanges = _.filter(changes, function (c) {
            return c.service === 'DatabaseService' &&
                (c.operation === 'insertTableData'
                    || c.operation === 'insertMultiPartTableData');
        }), updateChanges = _.filter(changes, function (c) {
            return c.service === 'DatabaseService' &&
                (c.operation === 'updateTableData'
                    || c.operation === 'updateMultiPartTableData');
        });
        return {
            total: changes ? changes.length : 0,
            database: {
                create: createChanges,
                update: updateChanges,
                delete: _.filter(changes, { service: 'DatabaseService', operation: 'deleteTableData' })
            },
            uploads: _.filter(changes, { service: 'OfflineFileUploadService', operation: 'uploadToServer' })
        };
    };
    var ɵ2 = generateChangeSet;
    var getOfflineChanges = function (changeLogService) {
        return changeLogService.getChanges().then(function (changes) {
            return {
                'total': changes ? changes.length : 0,
                'pendingToSync': generateChangeSet(_.filter(changes, { 'hasError': 0 })),
                'failedToSync': generateChangeSet(_.filter(changes, { 'hasError': 1 }))
            };
        });
    };
    var ɵ3 = getOfflineChanges;

    /**
     * this file contains all device operations under 'device' service.
     */
    var DeviceService = /** @class */ (function (_super) {
        __extends(DeviceService, _super);
        function DeviceService(app, appVersion, device, geoLocation, networkService, vibrateService) {
            var _this = _super.call(this) || this;
            _this.name = 'device';
            _this.operations = [];
            _this.operations.push(new AppInfoOperation(device, appVersion), new CurrentGeoPositionOperation(geoLocation), new DeviceInfoOperation(device), new GetNetworkInfoOperation(app, networkService), new GoOfflineOperation(networkService), new GoOnlineOperation(networkService), new VibrateOperation(vibrateService));
            app.subscribe('onNetworkStateChange', function (data) {
                app.networkStatus = data;
                core$1.$appDigest();
            });
            app.networkStatus = {
                isConnecting: false,
                isConnected: true,
                isNetworkAvailable: true,
                isServiceAvailable: true
            };
            return _this;
        }
        return DeviceService;
    }(variables.DeviceVariableService));
    /**
     * This class handles 'getAppInfo' device operation.
     */
    var AppInfoOperation = /** @class */ (function () {
        function AppInfoOperation(device, appVersion) {
            this.device = device;
            this.appVersion = appVersion;
            this.name = 'getAppInfo';
            this.model = {
                appversion: 'X.X.X',
                cordovaversion: 'X.X.X'
            };
            this.properties = [
                { target: 'startUpdate', type: 'boolean', value: true, hide: true }
            ];
        }
        AppInfoOperation.prototype.invoke = function (variable, options) {
            var cordovaVersion = this.device.cordova;
            if (core$1.isSpotcues) {
                return Promise.resolve({
                    appversion: window['_WM_APP_PROPERTIES']['version'],
                    cordovaversion: cordovaVersion
                });
            }
            return this.appVersion.getVersionNumber().then(function (appVersion) {
                return {
                    appversion: appVersion,
                    cordovaversion: cordovaVersion
                };
            });
        };
        return AppInfoOperation;
    }());
    /**
     * This class handles 'getCurrentGeoPosition' device operation.
     */
    var CurrentGeoPositionOperation = /** @class */ (function () {
        function CurrentGeoPositionOperation(geoLocation) {
            this.geoLocation = geoLocation;
            this.name = 'getCurrentGeoPosition';
            this.model = {
                coords: {
                    latitude: 0,
                    longitude: 0,
                    altitude: 0,
                    accuracy: 0,
                    altitudeAccuracy: 0,
                    heading: 0,
                    speed: 0
                },
                timestamp: 0
            };
            this.properties = [
                { target: 'startUpdate', type: 'boolean', value: true, hide: true },
                { target: 'autoUpdate', type: 'boolean', value: true, hide: true },
                { target: 'geolocationHighAccuracy', type: 'boolean', value: true, dataBinding: true },
                { target: 'geolocationMaximumAge', type: 'number', value: 3, dataBinding: true },
                { target: 'geolocationTimeout', type: 'number', value: 5, dataBinding: true }
            ];
            this.requiredCordovaPlugins = ['GEOLOCATION'];
            this.waitingQueue = [];
            this.options = {
                maximumAge: 3000,
                timeout: (2 * 60) * 1000,
                enableHighAccuracy: true
            };
        }
        CurrentGeoPositionOperation.prototype.watchPosition = function () {
            var _this = this;
            if (this.watchId) {
                navigator.geolocation.clearWatch(this.watchId);
                this.watchId = null;
            }
            var options = window['WM_GEO_LOCATION_OPTIONS'] || this.options;
            this.watchId = navigator.geolocation.watchPosition(function (position) {
                _this.lastKnownPosition = {
                    coords: {
                        latitude: position.coords.latitude,
                        longitude: position.coords.longitude,
                        altitude: position.coords.altitude,
                        accuracy: position.coords.accuracy,
                        altitudeAccuracy: position.coords.altitudeAccuracy,
                        heading: position.coords.heading,
                        speed: position.coords.speed
                    },
                    timestamp: position.timestamp
                };
                if (_this.waitingQueue.length > 0) {
                    _this.waitingQueue.forEach(function (fn) { return fn(_this.lastKnownPosition); });
                    _this.waitingQueue.length = 0;
                }
                $(document).off('touchend.usergesture');
            }, function () {
                _this.watchId = null;
            }, options);
        };
        CurrentGeoPositionOperation.prototype.invoke = function (variable, options, dataBindings) {
            var _this = this;
            if (!this.watchId || !this.lastKnownPosition) {
                this.watchPosition();
                $(document).on('touchend.usergesture', function () { return _this.watchPosition(); });
            }
            var geoLocationOptions = {
                maximumAge: dataBindings.get('geolocationMaximumAge') * 1000,
                timeout: dataBindings.get('geolocationTimeout') * 1000,
                enableHighAccuracy: dataBindings.get('geolocationHighAccuracy')
            };
            if (this.lastKnownPosition) {
                return Promise.resolve(this.lastKnownPosition);
            }
            return new Promise(function (resolve) {
                var c = function (position) {
                    resolve(position);
                };
                setTimeout(function () {
                    var index = _this.waitingQueue.indexOf(c);
                    if (index > -1) {
                        _this.waitingQueue.splice(index, 1);
                        resolve(_this.model);
                    }
                }, _this.options.timeout);
                _this.waitingQueue.push(c);
            });
        };
        return CurrentGeoPositionOperation;
    }());
    /**
     * This class handles 'getDeviceInfo' device operation.
     */
    var DeviceInfoOperation = /** @class */ (function () {
        function DeviceInfoOperation(device) {
            this.device = device;
            this.name = 'getDeviceInfo';
            this.model = {
                deviceModel: 'DEVICEMODEL',
                os: 'DEVICEOS',
                osVersion: 'X.X.X',
                deviceUUID: 'DEVICEUUID'
            };
            this.properties = [
                { target: 'startUpdate', type: 'boolean', value: true, hide: true }
            ];
        }
        DeviceInfoOperation.prototype.invoke = function (variable, options) {
            var response = {
                'deviceModel': this.device.model,
                'os': this.device.platform,
                'osVersion': this.device.version,
                'deviceUUID': this.device.uuid
            };
            return Promise.resolve(response);
        };
        return DeviceInfoOperation;
    }());
    var GetNetworkInfoOperation = /** @class */ (function () {
        function GetNetworkInfoOperation(app, networkService) {
            this.app = app;
            this.networkService = networkService;
            this.name = 'getNetworkInfo';
            this.model = {
                connectionType: 'NONE',
                isConnecting: false,
                isNetworkAvailable: true,
                isOnline: true,
                isOffline: false
            };
            this.properties = [
                { target: 'autoUpdate', type: 'boolean', value: true, hide: true },
                { target: 'startUpdate', type: 'boolean', value: true, hide: true },
                { target: 'networkStatus', type: 'object', value: 'bind:App.networkStatus', dataBinding: true, hide: true },
                { target: 'onOnline', hide: false },
                { target: 'onOffline', hide: false }
            ];
            this.requiredCordovaPlugins = ['NETWORK'];
        }
        GetNetworkInfoOperation.prototype.invoke = function (variable, options, dataBindings) {
            var data = {
                connectionType: navigator.connection.type,
                isConnecting: this.app.networkStatus.isConnecting,
                isNetworkAvailable: this.app.networkStatus.isNetworkAvailable,
                isOnline: this.app.networkStatus.isConnected,
                isOffline: !this.app.networkStatus.isConnected
            };
            if (this.networkService.isConnected()) {
                variables.initiateCallback('onOnline', variable, data);
            }
            else {
                variables.initiateCallback('onOffline', variable, data);
            }
            return Promise.resolve(data);
        };
        return GetNetworkInfoOperation;
    }());
    var GoOfflineOperation = /** @class */ (function () {
        function GoOfflineOperation(networkService) {
            this.networkService = networkService;
            this.name = 'goOffline';
            this.model = {};
            this.properties = [];
            this.requiredCordovaPlugins = ['NETWORK'];
        }
        GoOfflineOperation.prototype.invoke = function (variable, options, dataBindings) {
            return this.networkService.disconnect();
        };
        return GoOfflineOperation;
    }());
    var GoOnlineOperation = /** @class */ (function () {
        function GoOnlineOperation(networkService) {
            this.networkService = networkService;
            this.name = 'goOnline';
            this.model = {};
            this.properties = [];
            this.requiredCordovaPlugins = ['NETWORK'];
        }
        GoOnlineOperation.prototype.invoke = function (variable, options, dataBindings) {
            return this.networkService.connect();
        };
        return GoOnlineOperation;
    }());
    /**
     * This class handles 'vibrate' device operation.
     */
    var VibrateOperation = /** @class */ (function () {
        function VibrateOperation(vibrationService) {
            this.vibrationService = vibrationService;
            this.name = 'vibrate';
            this.model = {
                appversion: 'X.X.X',
                cordovaversion: 'X.X.X'
            };
            this.properties = [
                { target: 'vibrationtime', type: 'number', value: 2, dataBinding: true }
            ];
            this.requiredCordovaPlugins = ['VIBRATE'];
        }
        VibrateOperation.prototype.invoke = function (variable, options, dataBindings) {
            this.vibrationService.vibrate(dataBindings.get('vibrationtime') * 1000);
            return Promise.resolve();
        };
        return VibrateOperation;
    }());

    var ContactsService = /** @class */ (function (_super) {
        __extends(ContactsService, _super);
        function ContactsService(contacts) {
            var _this = _super.call(this) || this;
            _this.name = 'contacts';
            _this.operations = [];
            _this.operations.push(new GetContactsOperation(contacts));
            return _this;
        }
        return ContactsService;
    }(variables.DeviceVariableService));
    var GetContactsOperation = /** @class */ (function () {
        function GetContactsOperation(contacts) {
            this.contacts = contacts;
            this.name = 'getContacts';
            this.model = {
                id: '',
                displayName: '',
                phoneNumbers: [{ value: '' }]
            };
            this.properties = [
                { target: 'startUpdate', type: 'boolean' },
                { target: 'autoUpdate', type: 'boolean' },
                { target: 'contactFilter', type: 'string', value: '', dataBinding: true }
            ];
            this.requiredCordovaPlugins = ['CONTACTS'];
            this.waitingCalls = [];
        }
        GetContactsOperation.prototype.extractDisplayName = function (c) {
            var name = c.displayName;
            // In IOS, displayName is undefined, so using the formatted name.
            if (!name || name === '') {
                if (c.name.formatted) {
                    return c.name.formatted;
                }
            }
            return name;
        };
        GetContactsOperation.prototype.processNextCall = function () {
            if (this.waitingCalls.length > 0) {
                this.waitingCalls[0]();
            }
        };
        GetContactsOperation.prototype.findContacts = function (requiredFields, findOptions) {
            var _this = this;
            return new Promise(function (resolve, reject) {
                // Contacts plugin is not processing two simultaneous calls. It is anwsering to only call.
                _this.waitingCalls.push(function () {
                    _this.contacts.find(requiredFields, findOptions).then(function (data) {
                        if (data != null) {
                            var contacts = data.filter(function (c) {
                                c.displayName = _this.extractDisplayName(c);
                                return c.phoneNumbers && c.phoneNumbers.length > 0;
                            });
                            resolve(contacts);
                        }
                    }, reject).then(function () {
                        _this.waitingCalls.shift();
                        _this.processNextCall();
                    });
                });
                if (_this.waitingCalls.length === 1) {
                    _this.processNextCall();
                }
            });
        };
        GetContactsOperation.prototype.invoke = function (variable, options, dataBindings) {
            var requiredFields = ['displayName', 'name'];
            var findOptions = {
                filter: dataBindings.get('contactFilter'),
                multiple: true
            };
            return this.findContacts(requiredFields, findOptions);
        };
        return GetContactsOperation;
    }());

    var barcodeFormatOptions = {
        'ALL': 'ALL',
        'CODABAR': 'CODABAR (not supported in iOS)',
        'CODE_39': 'CODE_39',
        'CODE_93': 'CODE_93 (not supported in iOS)',
        'CODE_128': 'CODE_128',
        'DATA_MATRIX': 'DATA_MATRIX',
        'EAN_8': 'EAN_8',
        'EAN_13': 'EAN_13',
        'ITF': 'ITF',
        'PDF_417': 'PDF_417 (not supported in iOS)',
        'QR_CODE': 'QR_CODE',
        'RSS14': 'RSS14 (not supported in iOS)',
        'RSS_EXPANDED': 'RSS_EXPANDED (not supported in iOS)',
        'UPC_E': 'UPC_E',
        'UPC_A': 'UPC_A'
    };
    var ScanService = /** @class */ (function (_super) {
        __extends(ScanService, _super);
        function ScanService(barcodeScanner) {
            var _this = _super.call(this) || this;
            _this.name = 'scan';
            _this.operations = [];
            _this.operations.push(new ScanOperation(barcodeScanner));
            return _this;
        }
        return ScanService;
    }(variables.DeviceVariableService));
    var ScanOperation = /** @class */ (function () {
        function ScanOperation(barcodeScanner) {
            this.barcodeScanner = barcodeScanner;
            this.name = 'scanBarCode';
            this.model = {
                text: 'BAR CODE',
                format: 'TEXT',
                cancelled: false
            };
            this.properties = [
                {
                    target: 'barcodeFormat',
                    type: 'list',
                    options: barcodeFormatOptions,
                    value: 'ALL',
                    group: 'properties',
                    subGroup: 'behavior',
                    hide: false
                }
            ];
            this.requiredCordovaPlugins = ['BARCODE_SCANNER'];
        }
        ScanOperation.prototype.invoke = function (variable, options) {
            var scanOptions;
            if (variable.barcodeFormat && variable.barcodeFormat !== 'ALL') {
                scanOptions = { formats: variable.barcodeFormat };
            }
            return this.barcodeScanner.scan(scanOptions);
        };
        return ScanOperation;
    }());

    var VariablesModule = /** @class */ (function () {
        function VariablesModule(app, appVersion, barcodeScanner, changeLogService, calendar, contacts, camera, fileOpener, fileSelectorService, fileUploader, device, geoLocation, localDBDataPullService, localDBManagementService, mediaCapture, processManagementService, securityService, networkService, vibrateService) {
            VariablesModule_1.initialize(app, appVersion, barcodeScanner, changeLogService, calendar, contacts, camera, fileOpener, fileSelectorService, fileUploader, device, geoLocation, localDBDataPullService, localDBManagementService, mediaCapture, processManagementService, securityService, networkService, vibrateService);
        }
        VariablesModule_1 = VariablesModule;
        // Device variable services have to be added only once in the app life-cycle.
        VariablesModule.initialize = function (app, appVersion, barcodeScanner, changeLogService, calendar, contacts, camera, fileOpener, fileSelectorService, fileUploader, device, geoLocation, localDBDataPullService, localDBManagementService, mediaCapture, processManagementService, securityService, networkService, vibrateService) {
            if (this.initialized) {
                return;
            }
            this.initialized = true;
            var deviceVariableManager = variables.VariableManagerFactory.get(variables.VARIABLE_CONSTANTS.CATEGORY.DEVICE);
            deviceVariableManager.registerService(new CameraService(camera, mediaCapture));
            deviceVariableManager.registerService(new CalendarService(calendar));
            deviceVariableManager.registerService(new FileService(fileOpener, fileUploader));
            deviceVariableManager.registerService(new ContactsService(contacts));
            deviceVariableManager.registerService(new DatasyncService(app, changeLogService, fileSelectorService, localDBManagementService, localDBDataPullService, processManagementService, securityService, networkService));
            deviceVariableManager.registerService(new DeviceService(app, appVersion, device, geoLocation, networkService, vibrateService));
            deviceVariableManager.registerService(new ScanService(barcodeScanner));
        };
        var VariablesModule_1;
        VariablesModule.initialized = false;
        VariablesModule.ctorParameters = function () { return [
            { type: core$1.App },
            { type: appVersion.AppVersion },
            { type: barcodeScanner.BarcodeScanner },
            { type: offline.ChangeLogService },
            { type: calendar.Calendar },
            { type: contacts.Contacts },
            { type: camera.Camera },
            { type: core$2.DeviceFileOpenerService },
            { type: basic.FileSelectorService },
            { type: core$2.DeviceFileUploadService },
            { type: device.Device },
            { type: geolocation.Geolocation },
            { type: offline.LocalDBDataPullService },
            { type: offline.LocalDBManagementService },
            { type: mediaCapture.MediaCapture },
            { type: basic.ProcessManagementService },
            { type: security.SecurityService },
            { type: core$2.NetworkService },
            { type: vibration.Vibration }
        ]; };
        VariablesModule = VariablesModule_1 = __decorate([
            core.NgModule({
                imports: [
                    offline.OfflineModule
                ],
                declarations: [],
                providers: [
                // add providers to mobile-runtime module.
                ]
            }),
            __metadata("design:paramtypes", [core$1.App,
                appVersion.AppVersion,
                barcodeScanner.BarcodeScanner,
                offline.ChangeLogService,
                calendar.Calendar,
                contacts.Contacts,
                camera.Camera,
                core$2.DeviceFileOpenerService,
                basic.FileSelectorService,
                core$2.DeviceFileUploadService,
                device.Device,
                geolocation.Geolocation,
                offline.LocalDBDataPullService,
                offline.LocalDBManagementService,
                mediaCapture.MediaCapture,
                basic.ProcessManagementService,
                security.SecurityService,
                core$2.NetworkService,
                vibration.Vibration])
        ], VariablesModule);
        return VariablesModule;
    }());

    exports.VariablesModule = VariablesModule;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=index.umd.js.map
