import { ApplicationRef, DoCheck, ElementRef, NgZone, ViewContainerRef, AfterViewInit } from '@angular/core';
import { Router, RouterOutlet } from '@angular/router';
import { AbstractDialogService, AbstractSpinnerService, App } from '@wm/core';
import { OAuthService } from '@wm/oAuth';
import { AppManagerService } from '../../services/app.manager.service';
import { PipeProvider } from '../../services/pipe-provider.service';
interface SPINNER {
    show: boolean;
    messages: Array<string>;
}
export declare class AppComponent implements DoCheck, AfterViewInit {
    private elRef;
    private oAuthService;
    private dialogService;
    private spinnerService;
    private router;
    private app;
    private appManager;
    startApp: boolean;
    isApplicationType: boolean;
    routerOutlet: RouterOutlet;
    dynamicComponentContainerRef: ViewContainerRef;
    spinner: SPINNER;
    constructor(_pipeProvider: PipeProvider, _appRef: ApplicationRef, elRef: ElementRef, oAuthService: OAuthService, dialogService: AbstractDialogService, spinnerService: AbstractSpinnerService, ngZone: NgZone, router: Router, app: App, appManager: AppManagerService);
    providersConfig: any;
    isOAuthDialogOpen: boolean;
    showOAuthDialog(): void;
    closeOAuthDialog(): void;
    private start;
    private overrideRouterOutlet;
    ngAfterViewInit(): void;
    ngDoCheck(): void;
}
export {};
