import { ModuleWithProviders } from '@angular/core';
import { App, CoreModule, Viewport } from '@wm/core';
import { DialogModule } from '@wm/components/dialogs';
import { MobileRuntimeModule } from '@wm/mobile/runtime';
export declare function getSettingProvider(key: string, defaultValue: any): {
    provide: string;
    useValue: any;
};
export declare function InitializeApp(I18nService: any): () => any;
export declare function setAngularLocale(I18nService: any): any;
export declare const REQUIRED_MODULES_FOR_DYNAMIC_COMPONENTS: (typeof DialogModule)[];
export declare class RuntimeBaseModule {
    static addCustomEventPolyfill(): boolean;
    static forRoot(): ModuleWithProviders<RuntimeBaseModule>;
    constructor(mobileRuntimeModule: MobileRuntimeModule, app: App, viewport: Viewport);
    private getDeviceDetails;
}
export declare const WM_MODULES_FOR_ROOT: ModuleWithProviders<CoreModule>[];
