import { HttpEvent, HttpHandler, HttpInterceptor, HttpRequest } from '@angular/common/http';
import { Observable, Subject } from 'rxjs';
/**
 * This Interceptor intercepts all network calls and if a network call fails
 * due to session timeout, then it calls a function to handle session timeout.
 */
export declare class HttpCallInterceptor implements HttpInterceptor {
    wmHttpRequest: any;
    wmHttpResponse: any;
    constructor();
    createSubject(): Subject<unknown>;
    intercept(request: HttpRequest<any>, next: HttpHandler): Observable<HttpEvent<any>>;
}
