(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/platform-browser-dynamic'), require('@angular/platform-browser'), require('@angular/common'), require('@angular/router'), require('@angular/common/http'), require('@angular/forms'), require('ngx-bootstrap/typeahead'), require('ngx-bootstrap/timepicker'), require('ngx-bootstrap/progressbar'), require('ngx-bootstrap/pagination'), require('ngx-bootstrap/modal'), require('ngx-bootstrap/tooltip'), require('ngx-bootstrap/datepicker'), require('ngx-bootstrap/dropdown'), require('ngx-bootstrap/popover'), require('ng-circle-progress'), require('ngx-toastr'), require('ngx-bootstrap/carousel'), require('@wm/core'), require('@wm/components/basic'), require('@wm/components/basic/progress'), require('@wm/components/basic/rich-text-editor'), require('@wm/components/basic/search'), require('@wm/components/basic/tree'), require('@wm/components/input'), require('@wm/components/input/calendar'), require('@wm/components/input/chips'), require('@wm/components/input/color-picker'), require('@wm/components/input/currency'), require('@wm/components/input/epoch'), require('@wm/components/input/file-upload'), require('@wm/components/input/rating'), require('@wm/components/input/slider'), require('@wm/mobile/runtime/dynamic'), require('@wm/components/data/card'), require('@wm/components/data/form'), require('@wm/components/data/list'), require('@wm/components/data/live-table'), require('@wm/components/data/pagination'), require('@wm/components/data/table'), require('@wm/components/chart'), require('@wm/components/containers/accordion'), require('@wm/components/containers/layout-grid'), require('@wm/components/containers/panel'), require('@wm/components/containers/tabs'), require('@wm/components/containers/tile'), require('@wm/components/containers/wizard'), require('@wm/components/dialogs/alert-dialog'), require('@wm/components/dialogs/iframe-dialog'), require('@wm/components/dialogs/login-dialog'), require('@wm/components/dialogs/partial-dialog'), require('@wm/components/navigation/breadcrumb'), require('@wm/components/navigation/menu'), require('@wm/components/navigation/navbar'), require('@wm/components/navigation/popover'), require('@wm/components/advanced/carousel'), require('@wm/components/advanced/login'), require('@wm/components/advanced/marquee'), require('@wm/components/page'), require('@wm/components/page/footer'), require('@wm/components/page/header'), require('@wm/components/page/left-panel'), require('@wm/components/page/right-panel'), require('@wm/components/page/top-nav'), require('@wm/components/prefab'), require('@wm/runtime/base'), require('@wm/variables'), require('@wm/security'), require('@wm/transpiler'), require('@angular/platform-browser/animations')) :
    typeof define === 'function' && define.amd ? define('@wm/runtime/dynamic', ['exports', '@angular/core', '@angular/platform-browser-dynamic', '@angular/platform-browser', '@angular/common', '@angular/router', '@angular/common/http', '@angular/forms', 'ngx-bootstrap/typeahead', 'ngx-bootstrap/timepicker', 'ngx-bootstrap/progressbar', 'ngx-bootstrap/pagination', 'ngx-bootstrap/modal', 'ngx-bootstrap/tooltip', 'ngx-bootstrap/datepicker', 'ngx-bootstrap/dropdown', 'ngx-bootstrap/popover', 'ng-circle-progress', 'ngx-toastr', 'ngx-bootstrap/carousel', '@wm/core', '@wm/components/basic', '@wm/components/basic/progress', '@wm/components/basic/rich-text-editor', '@wm/components/basic/search', '@wm/components/basic/tree', '@wm/components/input', '@wm/components/input/calendar', '@wm/components/input/chips', '@wm/components/input/color-picker', '@wm/components/input/currency', '@wm/components/input/epoch', '@wm/components/input/file-upload', '@wm/components/input/rating', '@wm/components/input/slider', '@wm/mobile/runtime/dynamic', '@wm/components/data/card', '@wm/components/data/form', '@wm/components/data/list', '@wm/components/data/live-table', '@wm/components/data/pagination', '@wm/components/data/table', '@wm/components/chart', '@wm/components/containers/accordion', '@wm/components/containers/layout-grid', '@wm/components/containers/panel', '@wm/components/containers/tabs', '@wm/components/containers/tile', '@wm/components/containers/wizard', '@wm/components/dialogs/alert-dialog', '@wm/components/dialogs/iframe-dialog', '@wm/components/dialogs/login-dialog', '@wm/components/dialogs/partial-dialog', '@wm/components/navigation/breadcrumb', '@wm/components/navigation/menu', '@wm/components/navigation/navbar', '@wm/components/navigation/popover', '@wm/components/advanced/carousel', '@wm/components/advanced/login', '@wm/components/advanced/marquee', '@wm/components/page', '@wm/components/page/footer', '@wm/components/page/header', '@wm/components/page/left-panel', '@wm/components/page/right-panel', '@wm/components/page/top-nav', '@wm/components/prefab', '@wm/runtime/base', '@wm/variables', '@wm/security', '@wm/transpiler', '@angular/platform-browser/animations'], factory) :
    (global = global || self, factory((global.wm = global.wm || {}, global.wm.runtime = global.wm.runtime || {}, global.wm.runtime.dynamic = {}), global.ng.core, global.ng.platformBrowserDynamic, global.ng.platformBrowser, global.ng.common, global.ng.router, global.ng.common.http, global.ng.forms, global['ngx-bootstrap'].typeahead, global['ngx-bootstrap'].timepicker, global['ngx-bootstrap'].progressbar, global['ngx-bootstrap'].pagination, global['ngx-bootstrap'].modal, global.tooltip, global['ngx-bootstrap'].datepicker, global['ngx-bootstrap'].dropdown, global['ngx-bootstrap'].popover, global.ngCircleProgress, global.ngxToastr, global['ngx-bootstrap'].carousel, global.wm.core, global.wm.components.basic, global.wm.components.basic.progress, global.wm.components.basic.richtexteditor, global.wm.components.basic.search, global.wm.components.basic.tree, global.wm.components.input, global.wm.components.input.calendar, global.wm.components.input.chips, global.wm.components.input.colorpicker, global.wm.components.input.currency, global.wm.components.input.epoch, global.wm.components.input.fileupload, global.wm.components.input.rating, global.wm.components.input.slider, global.wm.mobile.runtime.dynamic, global.wm.components.data.card, global.wm.components.data.form, global.wm.components.data.list, global.wm.components.data.livetable, global.wm.components.data.pagination, global.wm.components.data.table, global.wm.components.chart, global.wm.components.containers.accordion, global.wm.components.containers.layoutgrid, global.wm.components.containers.panel, global.wm.components.containers.tabs, global.wm.components.containers.tile, global.wm.components.containers.wizard, global.wm.components.dialogs.alertdialog, global.wm.components.dialogs.iframedialog, global.wm.components.dialogs.logindialog, global.wm.components.dialogs.partialdialog, global.wm.components.navigation.breadcrumb, global.wm.components.navigation.menu, global.wm.components.navigation.navbar, global.wm.components.navigation.popover, global.wm.components.advanced.carousel, global.wm.components.advanced.login, global.wm.components.advanced.marquee, global.wm.components.page, global.wm.components.page.footer, global.wm.components.page.header, global.wm.components.page.leftpanel, global.wm.components.page.rightpanel, global.wm.components.page.topnav, global.wm.components.prefab, global.wm.runtime.base, global.wm.variables, global.wm.security, global.wm.transpiler, global.ng.platformBrowser.animations));
}(this, (function (exports, core, platformBrowserDynamic, platformBrowser, common, router, http, forms, typeahead, timepicker, progressbar, pagination, modal, tooltip, datepicker, dropdown, popover, ngCircleProgress, ngxToastr, carousel, core$1, basic, progress, richTextEditor, search, tree, input, calendar, chips, colorPicker, currency, epoch, fileUpload, rating, slider, dynamic, card, form, list, liveTable, pagination$1, table, chart, accordion, layoutGrid, panel, tabs, tile, wizard, alertDialog, iframeDialog, loginDialog, partialDialog, breadcrumb, menu, navbar, popover$1, carousel$1, login, marquee, page, footer, header, leftPanel, rightPanel, topNav, prefab, base, variables, security, transpiler, animations) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __rest(s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); }
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    function __createBinding(o, m, k, k2) {
        if (k2 === undefined) k2 = k;
        o[k2] = m[k];
    }

    function __exportStar(m, exports) {
        for (var p in m) if (p !== "default" && !exports.hasOwnProperty(p)) exports[p] = m[p];
    }

    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m) return m.call(o);
        if (o && typeof o.length === "number") return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }

    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    }

    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    };

    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }

    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
    }

    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }

    function __asyncValues(o) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
    }

    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
        return cooked;
    };

    function __importStar(mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
        result.default = mod;
        return result;
    }

    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }

    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }

    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    var PageWrapperComponent = /** @class */ (function () {
        function PageWrapperComponent(injector, route, vcRef, appRef, metadataService, securityService, appManager, app, ngZone, elRef, spinnerService, componentRefProvider, router) {
            this.injector = injector;
            this.route = route;
            this.vcRef = vcRef;
            this.appRef = appRef;
            this.metadataService = metadataService;
            this.securityService = securityService;
            this.appManager = appManager;
            this.app = app;
            this.ngZone = ngZone;
            this.elRef = elRef;
            this.spinnerService = spinnerService;
            this.componentRefProvider = componentRefProvider;
            this.router = router;
        }
        PageWrapperComponent.prototype.getTargetNode = function () {
            return this.elRef.nativeElement;
        };
        PageWrapperComponent.prototype.resetViewContainer = function () {
            this.vcRef.clear();
            var $target = this.getTargetNode();
            $target.innerHTML = '';
        };
        PageWrapperComponent.prototype.renderPage = function (pageName) {
            var _this = this;
            var $target = this.getTargetNode();
            this.appManager.loadAppVariables()
                .then(function () { return __awaiter(_this, void 0, void 0, function () {
                var pageComponentFactoryRef, componentRef;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.componentRefProvider.getComponentFactoryRef(pageName, base.ComponentType.PAGE)];
                        case 1:
                            pageComponentFactoryRef = _a.sent();
                            if (pageComponentFactoryRef) {
                                componentRef = this.vcRef.createComponent(pageComponentFactoryRef, 0, this.injector);
                                this.instance = componentRef.instance;
                                $target.appendChild(componentRef.location.nativeElement);
                            }
                            else {
                                base.BasePageComponent.clear();
                            }
                            if (this.vcRef.length > 1) {
                                this.vcRef.remove(1);
                            }
                            return [2 /*return*/];
                    }
                });
            }); });
        };
        PageWrapperComponent.prototype.renderPrefabPreviewPage = function () {
            this.router.navigate(['prefab-preview']);
        };
        PageWrapperComponent.prototype.loadPage = function (pageName) {
            var _this = this;
            this.ngZone.run(function () {
                if (pageName) {
                    _this.renderPage(pageName);
                }
            });
        };
        PageWrapperComponent.prototype.ngOnInit = function () {
            var _this = this;
            if (this.app.isPrefabType) {
                // there is only one route
                this.renderPrefabPreviewPage();
            }
            else {
                $(this.getTargetNode()).find('>div').first().remove();
                this.subscription = this.route.params.subscribe(function (_a) {
                    var pageName = _a.pageName;
                    _this.loadPage(pageName);
                });
            }
        };
        PageWrapperComponent.prototype.ngOnDestroy = function () {
            this.vcRef.clear();
            if (this.subscription) {
                this.subscription.unsubscribe();
            }
        };
        PageWrapperComponent.prototype.ngOnAttach = function () {
            this.getTargetNode().appendChild(this.instance.$page[0]);
            this.instance.ngOnAttach();
        };
        PageWrapperComponent.prototype.ngOnDetach = function () {
            this.instance.ngOnDetach();
        };
        PageWrapperComponent.ctorParameters = function () { return [
            { type: core.Injector },
            { type: router.ActivatedRoute },
            { type: core.ViewContainerRef },
            { type: core.ApplicationRef },
            { type: variables.MetadataService },
            { type: security.SecurityService },
            { type: base.AppManagerService },
            { type: core$1.App },
            { type: core.NgZone },
            { type: core.ElementRef },
            { type: core$1.AbstractSpinnerService },
            { type: base.ComponentRefProvider },
            { type: router.Router }
        ]; };
        PageWrapperComponent = __decorate([
            core.Component({
                selector: 'app-page-outlet',
                template: '<div></div>'
            }),
            __metadata("design:paramtypes", [core.Injector,
                router.ActivatedRoute,
                core.ViewContainerRef,
                core.ApplicationRef,
                variables.MetadataService,
                security.SecurityService,
                base.AppManagerService,
                core$1.App,
                core.NgZone,
                core.ElementRef,
                core$1.AbstractSpinnerService,
                base.ComponentRefProvider,
                router.Router])
        ], PageWrapperComponent);
        return PageWrapperComponent;
    }());

    var appDependenciesResolve = {
        securityConfig: base.SecurityConfigResolve,
        metadata: base.MetadataResolve,
        appJS: base.AppJSResolve,
        appMetaConfig: base.AppExtensionJSResolve
    };
    var routes = [
        {
            path: '',
            pathMatch: 'full',
            resolve: appDependenciesResolve,
            component: base.EmptyPageComponent
        },
        {
            path: 'prefab-preview',
            pathMatch: 'full',
            resolve: appDependenciesResolve,
            component: base.PrefabPreviewComponent
        },
        {
            path: ':pageName',
            pathMatch: 'full',
            resolve: appDependenciesResolve,
            component: PageWrapperComponent,
            canDeactivate: [base.CanDeactivatePageGuard]
        }
    ];

    var AppJSProviderService = /** @class */ (function (_super) {
        __extends(AppJSProviderService, _super);
        function AppJSProviderService($http) {
            var _this = _super.call(this) || this;
            _this.$http = $http;
            return _this;
        }
        AppJSProviderService.prototype.getAppScriptFn = function () {
            return this.$http.get('./app.js', { responseType: 'text' })
                .toPromise()
                .then(function (script) { return new Function('App', 'Utils', 'Injector', script); });
        };
        AppJSProviderService.ctorParameters = function () { return [
            { type: http.HttpClient }
        ]; };
        AppJSProviderService.ɵprov = core["ɵɵdefineInjectable"]({ factory: function AppJSProviderService_Factory() { return new AppJSProviderService(core["ɵɵinject"](http.HttpClient)); }, token: AppJSProviderService, providedIn: "root" });
        AppJSProviderService = __decorate([
            core.Injectable({
                providedIn: 'root'
            }),
            __metadata("design:paramtypes", [http.HttpClient])
        ], AppJSProviderService);
        return AppJSProviderService;
    }(base.AppJSProvider));

    var cache = new Map();
    var AppResourceManagerService = /** @class */ (function () {
        function AppResourceManagerService($http) {
            this.$http = $http;
        }
        AppResourceManagerService.prototype.get = function (url, useCache) {
            var cachedResponse = cache.get(url);
            if (cachedResponse) {
                return Promise.resolve(cachedResponse);
            }
            return this.$http.get(url).then(function (response) {
                if (useCache) {
                    cache.set(url, response);
                }
                return response;
            });
        };
        AppResourceManagerService.prototype.clearCache = function () {
            cache.clear();
        };
        AppResourceManagerService.ctorParameters = function () { return [
            { type: core$1.AbstractHttpService }
        ]; };
        AppResourceManagerService = __decorate([
            core.Injectable(),
            __metadata("design:paramtypes", [core$1.AbstractHttpService])
        ], AppResourceManagerService);
        return AppResourceManagerService;
    }());

    var AppVariablesProviderService = /** @class */ (function (_super) {
        __extends(AppVariablesProviderService, _super);
        function AppVariablesProviderService(resourceManager) {
            var _this = _super.call(this) || this;
            _this.resourceManager = resourceManager;
            return _this;
        }
        AppVariablesProviderService.prototype.getAppVariables = function () {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    return [2 /*return*/, this.resourceManager.get('./app.variables.json')];
                });
            });
        };
        AppVariablesProviderService.ctorParameters = function () { return [
            { type: AppResourceManagerService }
        ]; };
        AppVariablesProviderService.ɵprov = core["ɵɵdefineInjectable"]({ factory: function AppVariablesProviderService_Factory() { return new AppVariablesProviderService(core["ɵɵinject"](AppResourceManagerService)); }, token: AppVariablesProviderService, providedIn: "root" });
        AppVariablesProviderService = __decorate([
            core.Injectable({
                providedIn: 'root'
            }),
            __metadata("design:paramtypes", [AppResourceManagerService])
        ], AppVariablesProviderService);
        return AppVariablesProviderService;
    }(base.AppVariablesProvider));

    var AppExtensionProviderService = /** @class */ (function (_super) {
        __extends(AppExtensionProviderService, _super);
        function AppExtensionProviderService() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        // With renderer create element, added onloaded callback the append to the body
        AppExtensionProviderService.prototype.loadFormatterConfigScript = function (callback) {
            try {
                core$1.appendScriptToHead(callback);
            }
            catch (e) {
                console.warn('Error while loading the formatters.js file');
            }
        };
        AppExtensionProviderService.ɵprov = core["ɵɵdefineInjectable"]({ factory: function AppExtensionProviderService_Factory() { return new AppExtensionProviderService(); }, token: AppExtensionProviderService, providedIn: "root" });
        AppExtensionProviderService = __decorate([
            core.Injectable({
                providedIn: 'root'
            })
        ], AppExtensionProviderService);
        return AppExtensionProviderService;
    }(base.AppExtensionProvider));

    var fragmentCache = new Map();
    window.resourceCache = fragmentCache;
    var componentFactoryRefCache = new Map();
    componentFactoryRefCache.set(base.ComponentType.PAGE, new Map());
    componentFactoryRefCache.set(base.ComponentType.PARTIAL, new Map());
    componentFactoryRefCache.set(base.ComponentType.PREFAB, new Map());
    var _decodeURIComponent = function (str) { return decodeURIComponent(str.replace(/\+/g, ' ')); };
    var ɵ0 = _decodeURIComponent;
    var getFragmentUrl = function (fragmentName, type) {
        if (type === base.ComponentType.PAGE || type === base.ComponentType.PARTIAL) {
            return "./pages/" + fragmentName + "/page.min.json";
        }
        else if (type === base.ComponentType.PREFAB) {
            return base.getPrefabMinJsonUrl(fragmentName);
        }
    };
    var ɵ1 = getFragmentUrl;
    var scriptCache = new Map();
    var execScript = function (script, identifier, ctx, instance, app, utils) {
        var fn = scriptCache.get(identifier);
        if (!fn) {
            fn = new Function(ctx, 'App', 'Utils', script);
            scriptCache.set(identifier, fn);
        }
        fn(instance, app, utils);
    };
    var ɵ2 = execScript;
    var BaseDynamicComponent = /** @class */ (function () {
        function BaseDynamicComponent() {
        }
        BaseDynamicComponent.prototype.init = function () { };
        return BaseDynamicComponent;
    }());
    var getDynamicModule = function (componentRef) {
        var DynamicModule = /** @class */ (function () {
            function DynamicModule() {
            }
            DynamicModule = __decorate([
                core.NgModule({
                    declarations: [componentRef],
                    imports: [
                        base.RuntimeBaseModule
                    ],
                    schemas: [core.CUSTOM_ELEMENTS_SCHEMA, core.NO_ERRORS_SCHEMA]
                })
            ], DynamicModule);
            return DynamicModule;
        }());
        return DynamicModule;
    };
    var ɵ3 = getDynamicModule;
    var getDynamicComponent = function (componentName, type, template, css, script, variables) {
        var componentDef = {
            template: template,
            styles: [css],
            encapsulation: core.ViewEncapsulation.None
        };
        var BaseClass = BaseDynamicComponent;
        var selector = '';
        var context = '';
        switch (type) {
            case base.ComponentType.PAGE:
                BaseClass = base.BasePageComponent;
                selector = "app-page-" + componentName;
                context = 'Page';
                break;
            case base.ComponentType.PARTIAL:
                BaseClass = base.BasePartialComponent;
                selector = "app-partial-" + componentName;
                context = 'Partial';
                break;
            case base.ComponentType.PREFAB:
                BaseClass = base.BasePrefabComponent;
                selector = "app-prefab-" + componentName;
                context = 'Prefab';
                break;
        }
        var DynamicComponent = /** @class */ (function (_super) {
            __extends(DynamicComponent, _super);
            function DynamicComponent(injector) {
                var _this = _super.call(this) || this;
                _this.injector = injector;
                switch (type) {
                    case base.ComponentType.PAGE:
                        _this.pageName = componentName;
                        break;
                    case base.ComponentType.PARTIAL:
                        _this.partialName = componentName;
                        break;
                    case base.ComponentType.PREFAB:
                        _this.prefabName = componentName;
                        break;
                }
                _super.prototype.init.call(_this);
                return _this;
            }
            DynamicComponent_1 = DynamicComponent;
            DynamicComponent.prototype.evalUserScript = function (instance, appContext, utils) {
                execScript(script, selector, context, instance, appContext, utils);
            };
            DynamicComponent.prototype.getVariables = function () {
                return JSON.parse(variables);
            };
            var DynamicComponent_1;
            DynamicComponent.ctorParameters = function () { return [
                { type: core.Injector }
            ]; };
            DynamicComponent = DynamicComponent_1 = __decorate([
                core.Component(__assign(__assign({}, componentDef), { selector: selector, providers: [
                        {
                            provide: core$1.UserDefinedExecutionContext,
                            useExisting: DynamicComponent_1
                        }
                    ] })),
                __metadata("design:paramtypes", [core.Injector])
            ], DynamicComponent);
            return DynamicComponent;
        }(BaseClass));
        return DynamicComponent;
    };
    var ɵ4 = getDynamicComponent;
    var ComponentRefProviderService = /** @class */ (function (_super) {
        __extends(ComponentRefProviderService, _super);
        function ComponentRefProviderService(resouceMngr, app, appManager, compiler) {
            var _this = _super.call(this) || this;
            _this.resouceMngr = resouceMngr;
            _this.app = app;
            _this.appManager = appManager;
            _this.compiler = compiler;
            return _this;
        }
        ComponentRefProviderService.prototype.loadResourcesOfFragment = function (componentName, componentType) {
            var _this = this;
            var url = getFragmentUrl(componentName, componentType);
            var resource = fragmentCache.get(url);
            if (resource) {
                return Promise.resolve(resource);
            }
            return this.resouceMngr.get(url, true)
                .then(function (_a) {
                var markup = _a.markup, script = _a.script, styles = _a.styles, variables = _a.variables;
                var response = {
                    markup: transpiler.transpile(_decodeURIComponent(markup)).markup,
                    script: _decodeURIComponent(script),
                    styles: transpiler.scopeComponentStyles(componentName, componentType, _decodeURIComponent(styles)),
                    variables: core$1.getValidJSON(_decodeURIComponent(variables))
                };
                fragmentCache.set(url, response);
                return response;
            }, function (e) {
                var status = e.details.status;
                var errorMsgMap = {
                    404: _this.app.appLocale.MESSAGE_PAGE_NOT_FOUND || 'The page you are trying to reach is not available',
                    403: _this.app.appLocale.LABEL_ACCESS_DENIED || 'Access Denied'
                };
                return Promise.reject(errorMsgMap[status]);
            });
        };
        ComponentRefProviderService.prototype.getComponentFactoryRef = function (componentName, componentType) {
            return __awaiter(this, void 0, void 0, function () {
                var componentFactoryMap, componentFactoryRef;
                var _this = this;
                return __generator(this, function (_a) {
                    componentFactoryMap = componentFactoryRefCache.get(componentType);
                    if (componentFactoryMap) {
                        componentFactoryRef = componentFactoryMap.get(componentName);
                        if (componentFactoryRef) {
                            return [2 /*return*/, componentFactoryRef];
                        }
                    }
                    return [2 /*return*/, this.loadResourcesOfFragment(componentName, componentType)
                            .then(function (_a) {
                            var markup = _a.markup, script = _a.script, styles = _a.styles, variables = _a.variables;
                            var componentDef = getDynamicComponent(componentName, componentType, markup, styles, script, JSON.stringify(variables));
                            var moduleDef = getDynamicModule(componentDef);
                            componentFactoryRef = _this.compiler
                                .compileModuleAndAllComponentsSync(moduleDef)
                                .componentFactories
                                .filter(function (factory) { return factory.componentType === componentDef; })[0];
                            componentFactoryRefCache.get(componentType).set(componentName, componentFactoryRef);
                            return componentFactoryRef;
                        }, function (err) {
                            if (err) {
                                var msg = "Error while loading page";
                                // console the error for easy debugging
                                console.log(msg, err);
                                _this.appManager.notifyApp(_.isString(err) ? err : msg + ', check browser console for error details', 'error');
                            }
                        })];
                });
            });
        };
        // clears the cache map
        ComponentRefProviderService.prototype.clearComponentFactoryRefCache = function () {
            this.resouceMngr.clearCache();
            fragmentCache.clear();
            componentFactoryRefCache.forEach(function (map) {
                map.clear();
            });
        };
        ComponentRefProviderService.ctorParameters = function () { return [
            { type: AppResourceManagerService },
            { type: core$1.App },
            { type: base.AppManagerService },
            { type: core.Compiler }
        ]; };
        ComponentRefProviderService = __decorate([
            core.Injectable(),
            __metadata("design:paramtypes", [AppResourceManagerService,
                core$1.App,
                base.AppManagerService,
                core.Compiler])
        ], ComponentRefProviderService);
        return ComponentRefProviderService;
    }(base.ComponentRefProvider));

    var cache$1 = new Map();
    var PrefabConfigProviderService = /** @class */ (function (_super) {
        __extends(PrefabConfigProviderService, _super);
        function PrefabConfigProviderService(resourceMngr) {
            var _this = _super.call(this) || this;
            _this.resourceMngr = resourceMngr;
            return _this;
        }
        PrefabConfigProviderService.prototype.getConfig = function (prefabName) {
            var config = cache$1.get(prefabName);
            if (config) {
                return Promise.resolve(config);
            }
            return this.resourceMngr.get(base.getPrefabConfigUrl(prefabName))
                .then(function (_config) {
                cache$1.set(prefabName, _config);
                return _config;
            });
        };
        PrefabConfigProviderService.ctorParameters = function () { return [
            { type: AppResourceManagerService }
        ]; };
        PrefabConfigProviderService = __decorate([
            core.Injectable(),
            __metadata("design:paramtypes", [AppResourceManagerService])
        ], PrefabConfigProviderService);
        return PrefabConfigProviderService;
    }(base.PrefabConfigProvider));

    var routerModule = router.RouterModule.forRoot(routes, { useHash: true, scrollPositionRestoration: 'top' });
    var toastrModule = ngxToastr.ToastNoAnimationModule.forRoot({ maxOpened: 1, autoDismiss: true });
    var httpClientXsrfModule = http.HttpClientXsrfModule.withOptions({
        cookieName: 'wm_xsrf_token',
        headerName: core$1.getWmProjectProperties().xsrf_header_name
    });
    var modalModule = modal.ModalModule.forRoot();
    var bsDatePickerModule = datepicker.BsDatepickerModule.forRoot();
    var datepickerModule = datepicker.DatepickerModule.forRoot();
    var timepickerModule = timepicker.TimepickerModule.forRoot();
    var bsDropdownModule = dropdown.BsDropdownModule.forRoot();
    var paginationModule = pagination.PaginationModule.forRoot();
    var typeaheadModule = typeahead.TypeaheadModule.forRoot();
    var progressbarModule = progressbar.ProgressbarModule.forRoot();
    var carouselModule = carousel.CarouselModule.forRoot();
    var popoverModule = popover.PopoverModule.forRoot();
    var ngCircleProgressModule = ngCircleProgress.NgCircleProgressModule.forRoot({});
    var tooltipModule = tooltip.TooltipModule.forRoot();
    var componentsModule = [
        // NGX Bootstrap
        datepicker.BsDatepickerModule,
        datepicker.DatepickerModule,
        timepicker.TimepickerModule,
        dropdown.BsDropdownModule,
        pagination.PaginationModule,
        typeahead.TypeaheadModule,
        progressbar.ProgressbarModule,
        carousel.CarouselModule,
        popover.PopoverModule,
        ngCircleProgress.NgCircleProgressModule,
        tooltip.TooltipModule,
        // Basic widgets
        basic.BasicModule,
        progress.ProgressModule,
        richTextEditor.RichTextEditorModule,
        search.SearchModule,
        tree.TreeModule,
        // Input
        calendar.CalendarModule,
        chips.ChipsModule,
        colorPicker.ColorPickerModule,
        currency.CurrencyModule,
        epoch.EpochModule,
        fileUpload.FileUploadModule,
        input.InputModule,
        rating.RatingModule,
        slider.SliderModule,
        // Data
        card.CardModule,
        form.FormModule,
        list.ListModule,
        liveTable.LiveTableModule,
        pagination$1.PaginationModule,
        table.TableModule,
        // chart
        chart.ChartModule,
        // container modules
        accordion.AccordionModule,
        layoutGrid.LayoutGridModule,
        panel.PanelModule,
        tabs.TabsModule,
        tile.TileModule,
        wizard.WizardModule,
        // dialogs
        alertDialog.AlertDialogModule,
        iframeDialog.IframeDialogModule,
        loginDialog.LoginDialogModule,
        partialDialog.PartialDialogModule,
        // navigation
        breadcrumb.BreadcrumbModule,
        menu.MenuModule,
        navbar.NavbarModule,
        popover$1.PopoverModule,
        // Advanced
        carousel$1.CarouselModule,
        login.LoginModule,
        marquee.MarqueeModule,
        page.PageModule,
        footer.FooterModule,
        header.HeaderModule,
        leftPanel.LeftPanelModule,
        rightPanel.RightPanelModule,
        topNav.TopNavModule,
        prefab.PrefabModule
    ];
    base.REQUIRED_MODULES_FOR_DYNAMIC_COMPONENTS.push.apply(base.REQUIRED_MODULES_FOR_DYNAMIC_COMPONENTS, __spread(componentsModule));
    base.REQUIRED_MODULES_FOR_DYNAMIC_COMPONENTS.push.apply(base.REQUIRED_MODULES_FOR_DYNAMIC_COMPONENTS, __spread(dynamic.MOBILE_COMPONENT_MODULES_FOR_ROOT));
    base.REQUIRED_MODULES_FOR_DYNAMIC_COMPONENTS.push(forms.FormsModule, forms.ReactiveFormsModule);
    var AppModule = /** @class */ (function () {
        function AppModule(app, inj, componentRefProvider) {
            this.app = app;
            this.inj = inj;
            this.componentRefProvider = componentRefProvider;
            if (window['cordova']) {
                // clear the cached urls on logout, to load the Login Page and not the Main Page as app reload(window.location.reload) is not invoked in mobile
                this.app.subscribe('userLoggedOut', this.componentRefProvider.clearComponentFactoryRefCache.bind(this.componentRefProvider));
            }
        }
        AppModule.ctorParameters = function () { return [
            { type: core$1.App },
            { type: core.Injector },
            { type: base.ComponentRefProvider }
        ]; };
        AppModule = __decorate([
            core.NgModule({
                declarations: [
                    PageWrapperComponent
                ],
                imports: [
                    platformBrowser.BrowserModule,
                    animations.BrowserAnimationsModule,
                    common.CommonModule,
                    router.RouterModule,
                    http.HttpClientModule,
                    modalModule,
                    bsDatePickerModule,
                    datepickerModule,
                    timepickerModule,
                    bsDropdownModule,
                    paginationModule,
                    typeaheadModule,
                    tooltipModule,
                    progressbarModule,
                    carouselModule,
                    popoverModule,
                    ngCircleProgressModule,
                    routerModule,
                    toastrModule,
                    httpClientXsrfModule,
                    base.WM_MODULES_FOR_ROOT
                ],
                providers: [
                    AppResourceManagerService,
                    { provide: base.AppJSProvider, useClass: AppJSProviderService },
                    { provide: base.AppVariablesProvider, useClass: AppVariablesProviderService },
                    { provide: base.AppExtensionProvider, useClass: AppExtensionProviderService },
                    { provide: base.ComponentRefProvider, useClass: ComponentRefProviderService },
                    { provide: core$1.PartialRefProvider, useClass: ComponentRefProviderService },
                    { provide: base.PrefabConfigProvider, useClass: PrefabConfigProviderService },
                    { provide: router.RouteReuseStrategy, useClass: base.WmRouteReuseStrategy }
                ],
                bootstrap: [base.AppComponent]
            }),
            __metadata("design:paramtypes", [core$1.App, core.Injector, base.ComponentRefProvider])
        ], AppModule);
        return AppModule;
    }());

    var DEBUG_MODE = 'debugMode';
    if (sessionStorage.getItem(DEBUG_MODE) !== 'true') {
        core.enableProdMode();
    }
    console.time('bootstrap');
    document.addEventListener('DOMContentLoaded', function () {
        new Promise(function (resolve) {
            if (core$1.isSpotcues) {
                base.initSpotCues().then(resolve);
            }
            else if (window['cordova']) {
                document.addEventListener('deviceready', resolve);
            }
            else {
                resolve();
            }
        }).then(function () { return platformBrowserDynamic.platformBrowserDynamic().bootstrapModule(AppModule); })
            .then(function (appModuleRef) {
            var applicationRef = appModuleRef.injector.get(core.ApplicationRef);
            window.addEventListener('unload', function () {
                applicationRef.components.map(function (c) { return c && c.destroy(); });
            });
            console.timeEnd('bootstrap');
        }, function (err) { return console.log(err); });
    });
    window.debugMode = function (on) {
        if (_.isEmpty(on)) {
            on = true;
        }
        var value = on ? 'true' : 'false';
        if (sessionStorage.getItem(DEBUG_MODE) !== value) {
            sessionStorage.setItem(DEBUG_MODE, value);
            window.location.reload();
        }
    };
    var main = (function () { });

    exports.AppModule = AppModule;
    exports.AppResourceManagerService = AppResourceManagerService;
    exports.bsDatePickerModule = bsDatePickerModule;
    exports.bsDropdownModule = bsDropdownModule;
    exports.carouselModule = carouselModule;
    exports.datepickerModule = datepickerModule;
    exports.httpClientXsrfModule = httpClientXsrfModule;
    exports.modalModule = modalModule;
    exports.ngCircleProgressModule = ngCircleProgressModule;
    exports.paginationModule = paginationModule;
    exports.popoverModule = popoverModule;
    exports.progressbarModule = progressbarModule;
    exports.routerModule = routerModule;
    exports.timepickerModule = timepickerModule;
    exports.toastrModule = toastrModule;
    exports.tooltipModule = tooltipModule;
    exports.typeaheadModule = typeaheadModule;
    exports.ɵa = routes;
    exports.ɵb = PageWrapperComponent;
    exports.ɵc = AppJSProviderService;
    exports.ɵd = AppVariablesProviderService;
    exports.ɵe = AppExtensionProviderService;
    exports.ɵf = ComponentRefProviderService;
    exports.ɵg = PrefabConfigProviderService;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=index.umd.js.map
