(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common'), require('@angular/router'), require('@wm/core')) :
    typeof define === 'function' && define.amd ? define('@wm/security', ['exports', '@angular/core', '@angular/common', '@angular/router', '@wm/core'], factory) :
    (global = global || self, factory((global.wm = global.wm || {}, global.wm.security = {}), global.ng.core, global.ng.common, global.ng.router, global.wm.core));
}(this, (function (exports, core, common, router, core$1) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __rest(s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); }
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    function __createBinding(o, m, k, k2) {
        if (k2 === undefined) k2 = k;
        o[k2] = m[k];
    }

    function __exportStar(m, exports) {
        for (var p in m) if (p !== "default" && !exports.hasOwnProperty(p)) exports[p] = m[p];
    }

    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m) return m.call(o);
        if (o && typeof o.length === "number") return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }

    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    }

    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    };

    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }

    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
    }

    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }

    function __asyncValues(o) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
    }

    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
        return cooked;
    };

    function __importStar(mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
        result.default = mod;
        return result;
    }

    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }

    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }

    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    // Todo[Shubham]: Move below constants to a common file
    var XSRF_COOKIE_NAME = 'wm_xsrf_token', isApplicationType = true;
    var SecurityService = /** @class */ (function () {
        function SecurityService(injector, $http, routerService, activatedRoute, _location) {
            this.injector = injector;
            this.$http = $http;
            this.routerService = routerService;
            this.activatedRoute = activatedRoute;
            this._location = _location;
            this.requestQueue = {};
        }
        SecurityService.prototype.isLoaded = function () {
            return this.config;
        };
        SecurityService.prototype.get = function () {
            return this.config;
        };
        SecurityService.prototype.load = function (forceFlag) {
            var _this = this;
            if (this.loadPromise) {
                return this.loadPromise;
            }
            if (!forceFlag && this.config) {
                return Promise.resolve(this.config);
            }
            this.loadPromise = new Promise(function (resolve, reject) {
                _this.$http.send({ 'url': './services/security/info', 'method': 'GET' }).then(function (response) {
                    _this.config = response.body;
                    _this.lastLoggedInUser = core$1.getClonedObject(_this.loggedInUser);
                    _this.loggedInUser = _this.config.userInfo;
                    resolve(response.body);
                }).catch(function (err) {
                    reject(err);
                }).finally(function () {
                    _this.loadPromise = null;
                });
            });
            return this.loadPromise;
        };
        /**
         * gets the security config from the deployed app (backend call)
         * @param success
         * @param error
         */
        SecurityService.prototype.getWebConfig = function (success, error) {
            if (this.get()) {
                // if already fetched, return it
                core$1.triggerFn(success, this.get());
                return;
            }
            this.load()
                .then(function (config) {
                core$1.triggerFn(success, config);
            }, error);
        };
        /**
         * Returns security config
         * @param successCallback
         * @param failureCallback
         */
        SecurityService.prototype.getConfig = function (successCallback, failureCallback) {
            function invokeQueuedCallbacks(id, method, data) {
                _.forEach(this.requestQueue[id], function (fn) { return core$1.triggerFn(fn[method], data); });
                this.requestQueue[id] = null;
            }
            function onSuccess(config) {
                config.homePage = core$1.getWmProjectProperties().homePage;
                if (config.userInfo) {
                    // Backend returns landingPage instead of homePage, hence this statement(for consistency)
                    // config.userInfo.homePage = config.userInfo.landingPage;
                }
                this.config = config;
                this.lastLoggedInUser = core$1.getClonedObject(this.loggedInUser);
                this.loggedInUser = config.userInfo;
                invokeQueuedCallbacks.call(this, 'config', 'success', this.get());
            }
            function onError(error) {
                /*if ($rootScope.isMobileApplicationType) {
                 this.config = {
                 'securityEnabled': false,
                 'authenticated': false,
                 'homePage': _WM_APP_PROPERTIES.homePage,
                 'userInfo': null,
                 'login': null
                 };
                 invokeQueuedCallbacks('config', 'success', this.get());
                 } else {*/
                invokeQueuedCallbacks.call(this, 'config', 'error', error);
                // }
            }
            if (this.get()) {
                // if already fetched, return it
                core$1.triggerFn(successCallback, this.get());
                return;
            }
            // Queue check, if same queue is already in progress, do not send another request
            this.requestQueue.config = this.requestQueue.config || [];
            this.requestQueue.config.push({
                success: successCallback,
                error: failureCallback
            });
            if (this.requestQueue.config.length > 1) {
                return;
            }
            if (!core$1.hasCordova() || core$1.isSpotcues) {
                // for web project, return config returned from backend API call.
                this.getWebConfig(onSuccess.bind(this), onError.bind(this));
            }
            /* else {
             /!*
             * for mobile app, first get the mobile config (saved in the apk)
             * - if security not enabled, just return mobile config (no backend call required)
             * - else, get Web config (will be  the same API hit for login) and merge the config with _mobileconfig
             *!/
             getMobileConfig(function (mobileconfig) {
             if (!mobileconfig.securityEnabled) {
             onSuccess(mobileconfig);
             } else {
             getWebConfig(function (config) {
             config = mergeWebAndMobileConfig(config);
             onSuccess(config);
             }, function () {onSuccess(mobileconfig); });
             }
             }, onError);
             }*/
        };
        SecurityService.prototype.getLastLoggedInUsername = function () {
            return this.lastLoggedInUser && this.lastLoggedInUser.userName;
        };
        /**
         * Returns the current page name
         * @returns {string}
         */
        SecurityService.prototype.getCurrentRoutePage = function () {
            var p = this._location.path();
            var lIndex = p.indexOf('?');
            lIndex = lIndex === -1 ? p.length : lIndex - 1;
            return p.substr(1, lIndex); // ignore the query params
        };
        /**
         * Returns Query params for specified param name in current Route
         * @param paramName, the param name whose query param value is to be retrieved
         * @returns {any}
         */
        SecurityService.prototype.getCurrentRouteQueryParam = function (paramName) {
            var paramVal;
            this.activatedRoute.queryParams.subscribe(function (params) {
                paramVal = params[paramName];
            });
            return paramVal;
        };
        SecurityService.prototype.isNoPageLoaded = function () {
            return !_.isEmpty(this.getCurrentRoutePage());
        };
        SecurityService.prototype.getPageByLoggedInUser = function () {
            var that = this;
            return new Promise(function (resolve) {
                var page;
                if (!isApplicationType) {
                    if (that.isNoPageLoaded()) {
                        page = core$1.getWmProjectProperties().homePage;
                        resolve(page);
                    }
                }
                else {
                    that.getConfig(function (config) {
                        if (config.securityEnabled && config.authenticated) {
                            page = config.userInfo.landingPage || core$1.getWmProjectProperties().homePage;
                            // override the default xsrf cookie name and xsrf header names with WaveMaker specific values
                            if (that.isXsrfEnabled()) {
                                // this.$http.defaults.xsrfCookieName = XSRF_COOKIE;
                                // this.$http.defaults.xsrfHeaderName = config.csrfHeaderName;
                            }
                        }
                        else {
                            page = core$1.getWmProjectProperties().homePage;
                        }
                        resolve(page);
                    }, function () {
                        resolve(core$1.getWmProjectProperties().homePage);
                    });
                }
            });
        };
        /**
         * Loads the App page as follows:
         * Security disabled:
         *      - Home page
         * Security enabled:
         *      - User is logged in, respective landing page is loaded
         *      - Not logged in:
         *          - Home page is public, loads the home page
         *          - Home page not public, Login page(in config) is loaded
         * @param forcePageLoad
         * @returns {Promise<T>}
         */
        SecurityService.prototype.loadPageByUserRole = function (forcePageLoad) {
            var that = this;
            return this.getPageByLoggedInUser().then(function (page) {
                if (that.isNoPageLoaded() || forcePageLoad) {
                    // Reload the page when current page and post login landing page are same
                    if (that.getCurrentRoutePage() === page) {
                        window.location.reload();
                    }
                    else {
                        that.routerService.navigate(["/" + page]);
                    }
                }
            });
        };
        /**
         * Navigates to the current user's homePage based on the config in SecurityService
         * Assumption is the SecurityService is updated with the latest security config before making call to this function
         */
        SecurityService.prototype.navigateOnLogin = function () {
            this.loadPageByUserRole(true);
        };
        /**
         * Gets the page which needs to be redirected to on successful login
         * @param config,
         * @param page, page name for redirection
         * @returns {any|string}
         */
        SecurityService.prototype.getRedirectPage = function (config, page) {
            var homePage = core$1.getWmProjectProperties().homePage, loginPage = _.get(config, 'loginConfig.pageName');
            var prevRedirectPage, redirectPage = page || this.getCurrentRoutePage();
            // if user is already on Home page or Login page, they should not be redirected to that page, hence return undefined
            if (redirectPage === homePage || redirectPage === loginPage) {
                /*
                 * find previous redirect page from URL, if exists, user should redirect to that page.
                 * USE CASE:
                 *  user is on http://localhost:8080/app/#/Login?redirectTo=page
                 *  a variable call fails resulting 401
                 *  in this case, redirectTo page should be 'page' and not undefined
                 */
                prevRedirectPage = this.getCurrentRouteQueryParam('redirectTo');
                redirectPage = !_.isEmpty(prevRedirectPage) ? prevRedirectPage : undefined;
            }
            return redirectPage;
        };
        /**
         * Returns all the query params(including page params and redirect to params) associated with redirected page
         */
        SecurityService.prototype.getRedirectedRouteQueryParams = function () {
            var queryParams = {};
            this.activatedRoute.queryParams.subscribe(function (paramVal) {
                _.forEach(paramVal, function (val, key) {
                    queryParams[key] = val;
                });
            });
            return queryParams;
        };
        // accepts query object like {a:1, b:2} and returns a=1&b=2 string
        SecurityService.prototype.getQueryString = function (queryObject) {
            var params = [];
            _.forEach(queryObject, function (value, key) {
                params.push(key + '=' + value);
            });
            return _.join(params, '&');
        };
        SecurityService.prototype.appLogin = function (params, successCallback, failureCallback) {
            var _this = this;
            var payload = '';
            // encode all parameters
            _.each(params, function (value, name) {
                payload += (payload ? '&' : '') + encodeURIComponent(name) + '=' + encodeURIComponent(value);
            });
            return this.$http.send({
                method: 'POST',
                headers: {
                    'Content-Type': 'application/x-www-form-urlencoded'
                },
                url: 'j_spring_security_check',
                'data': payload
            }).then(function (response) {
                var xsrfCookieValue = response.body ? response.body[XSRF_COOKIE_NAME] : '';
                // override the default xsrf cookie name and xsrf header names with WaveMaker specific values
                if (xsrfCookieValue) {
                    if (core$1.hasCordova()) {
                        localStorage.setItem(XSRF_COOKIE_NAME, xsrfCookieValue || '');
                    }
                }
                // After the successful login in device, this function triggers the pending onLoginCallbacks.
                _this.injector.get(core$1.App).notify('userLoggedIn', {});
                core$1.triggerFn(successCallback, response);
            }, failureCallback);
        };
        /**
         * The API is used to check if the user is authenticated in the RUN mode.
         *
         * @param {function} successCallback to be called on success
         * @param {function} failureCallback to be called on failure
         */
        SecurityService.prototype.isAuthenticated = function (successCallback, failureCallback) {
            this.getConfig(function (config) {
                core$1.triggerFn(successCallback, config.authenticated);
            }, failureCallback);
        };
        /**
         * The API is used to logout of the app.
         *
         * @param {function} successCallback to be called on success
         * @param {function} failureCallback to be called on failure
         */
        SecurityService.prototype.appLogout = function (successCallback, failureCallback) {
            var _this = this;
            return this.$http.send({
                target: 'Security',
                url: 'j_spring_security_logout',
                method: 'POST',
                responseType: 'text',
                byPassResult: true
            }).then(function (response) {
                _.set(_this.get(), 'authenticated', false);
                _.set(_this.get(), 'userInfo', null);
                /*if (CONSTANTS.hasCordova) {
                    localStorage.setItem(CONSTANTS.XSRF_COOKIE_NAME, '');
                }*/
                _this.injector.get(core$1.App).notify('userLoggedOut', {});
                core$1.triggerFn(successCallback, response);
            }, failureCallback);
        };
        /**
         * Checks and return the cookie
         * @param name, cookie key
         * @returns {string}
         */
        SecurityService.prototype.getCookieByName = function (name) {
            // Todo: Shubham Implement cookie native js
            return 'cookie';
        };
        /**
         * This function returns the cookieValue if xsrf is enabled.
         * In device, xsrf cookie is stored in localStorage.
         * @returns xsrf cookie value
         */
        SecurityService.prototype.isXsrfEnabled = function () {
            if (core$1.hasCordova()) {
                return localStorage.getItem(XSRF_COOKIE_NAME);
            }
            return this.getCookieByName(XSRF_COOKIE_NAME);
        };
        /**
         * This function returns a promise. Promise is resolved when security is
         * 1. disabled
         * 2. enabled and user is authenticated
         * 3. enabled and user is not authenticated, then promise is resolved on user login
         * @returns {*} promise
         */
        SecurityService.prototype.onUserLogin = function () {
            var _this = this;
            return new Promise(function (resolve, reject) {
                _this.getConfig(function (config) {
                    if (config.securityEnabled) {
                        if (config.authenticated) {
                            resolve();
                        }
                        else {
                            var unsubscribe_1 = _this.injector.get(core$1.App).subscribe('userLoggedIn', function () {
                                resolve();
                                unsubscribe_1();
                            });
                        }
                    }
                    else {
                        resolve();
                    }
                }, reject);
            });
        };
        /**
         * @returns a promise that is resolved with logged-in-user
         */
        SecurityService.prototype.getLoggedInUser = function () {
            var _this = this;
            return new Promise(function (resolve, reject) {
                _this.getConfig(function (config) {
                    if (config && config.userInfo) {
                        resolve(config.userInfo);
                    }
                    else {
                        reject();
                    }
                }, reject);
            });
        };
        /**
         * This is for mobile apps to authenticate via browser.
         *
         * @returns a promise that is resolved after login
         */
        SecurityService.prototype.authInBrowser = function () {
            return Promise.reject('This authInBrowser should not be called');
        };
        SecurityService.ctorParameters = function () { return [
            { type: core.Injector },
            { type: core$1.AbstractHttpService },
            { type: router.Router },
            { type: router.ActivatedRoute },
            { type: common.Location }
        ]; };
        SecurityService = __decorate([
            core.Injectable(),
            __metadata("design:paramtypes", [core.Injector,
                core$1.AbstractHttpService,
                router.Router,
                router.ActivatedRoute,
                common.Location])
        ], SecurityService);
        return SecurityService;
    }());

    var SecurityModule = /** @class */ (function () {
        function SecurityModule() {
        }
        SecurityModule_1 = SecurityModule;
        SecurityModule.forRoot = function () {
            return {
                ngModule: SecurityModule_1,
                providers: [SecurityService]
            };
        };
        var SecurityModule_1;
        SecurityModule = SecurityModule_1 = __decorate([
            core.NgModule({})
        ], SecurityModule);
        return SecurityModule;
    }());

    exports.SecurityModule = SecurityModule;
    exports.SecurityService = SecurityService;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=index.umd.js.map
