// import initSwipeyJqueryPlugin from './swipey.jquery.plugin';
var SwipeAnimation = /** @class */ (function () {
    function SwipeAnimation() {
        this._isGesturesEnabled = true;
    }
    SwipeAnimation.prototype.bindEvents = function () {
        if (window['PointerEvent']) {
            return ['pointer'];
        }
        return ['touch'];
    };
    SwipeAnimation.prototype.bounds = function (e, $d) { return {}; };
    SwipeAnimation.prototype.context = function () { return {}; };
    SwipeAnimation.prototype.direction = function () { return $.fn.swipey.DIRECTIONS.HORIZONTAL; };
    SwipeAnimation.prototype.setGesturesEnabled = function (enabled) { this._isGesturesEnabled = enabled; };
    SwipeAnimation.prototype.isGesturesEnabled = function () { return this._isGesturesEnabled; };
    SwipeAnimation.prototype.goToLower = function (time) {
        this._$ele.swipeAnimation('gotoLower', time);
    };
    SwipeAnimation.prototype.goToUpper = function (time) {
        this._$ele.swipeAnimation('gotoUpper', time);
    };
    SwipeAnimation.prototype.onAnimation = function (e, distanceMoved) { };
    SwipeAnimation.prototype.onUpper = function () { };
    SwipeAnimation.prototype.onLower = function () { };
    SwipeAnimation.prototype.threshold = function () { return 30; };
    SwipeAnimation.prototype.init = function ($ele, $swipeTargetEle) {
        this._$ele = $ele;
        $ele.swipeAnimation({
            animation: this.animation(),
            target: $swipeTargetEle,
            bounds: this.bounds.bind(this),
            bindEvents: this.bindEvents(),
            context: this.context.bind(this),
            direction: this.direction(),
            enableGestures: this.isGesturesEnabled.bind(this),
            onAnimation: this.onAnimation.bind(this),
            onLower: this.onLower.bind(this),
            onUpper: this.onUpper.bind(this),
            threshold: this.threshold(),
            disableMouse: true
        });
    };
    return SwipeAnimation;
}());

/**
 * Generated bundle index. Do not edit.
 */

export { SwipeAnimation };
//# sourceMappingURL=index.js.map
