(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@wm/core'), require('@wm/components/base'), require('@angular/common')) :
    typeof define === 'function' && define.amd ? define('@wm/components/basic', ['exports', '@angular/core', '@wm/core', '@wm/components/base', '@angular/common'], factory) :
    (global = global || self, factory((global.wm = global.wm || {}, global.wm.components = global.wm.components || {}, global.wm.components.basic = {}), global.ng.core, global.wm.core, global.wm.components.base, global.ng.common));
}(this, (function (exports, core, core$1, base, common) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __rest(s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); }
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    function __createBinding(o, m, k, k2) {
        if (k2 === undefined) k2 = k;
        o[k2] = m[k];
    }

    function __exportStar(m, exports) {
        for (var p in m) if (p !== "default" && !exports.hasOwnProperty(p)) exports[p] = m[p];
    }

    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m) return m.call(o);
        if (o && typeof o.length === "number") return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }

    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    }

    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    };

    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }

    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
    }

    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }

    function __asyncValues(o) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
    }

    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
        return cooked;
    };

    function __importStar(mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
        result.default = mod;
        return result;
    }

    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }

    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }

    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    var registerProps = function () {
        base.register('wm-anchor', new Map([
            ['animation', base.PROP_STRING],
            ['badgevalue', base.PROP_STRING],
            ['caption', __assign({ value: 'Link' }, base.PROP_STRING)],
            ['class', base.PROP_STRING],
            ['conditionalclass', base.PROP_ANY],
            ['conditionalstyle', base.PROP_ANY],
            ['encodeurl', base.PROP_BOOLEAN],
            ['hint', base.PROP_STRING],
            ['hyperlink', __assign({ value: '' }, base.PROP_STRING)],
            ['iconclass', base.PROP_STRING],
            ['iconheight', base.PROP_STRING],
            ['iconmargin', base.PROP_STRING],
            ['iconposition', base.PROP_STRING],
            ['iconurl', base.PROP_STRING],
            ['iconwidth', base.PROP_STRING],
            ['name', base.PROP_STRING],
            ['shortcutkey', base.PROP_STRING],
            ['show', __assign({ value: true }, base.PROP_BOOLEAN)],
            ['tabindex', __assign({ value: 0 }, base.PROP_NUMBER)],
            ['target', __assign({ value: '_self' }, base.PROP_STRING)]
        ]));
    };

    var DEFAULT_CLS = 'app-anchor';
    var WIDGET_CONFIG = {
        widgetType: 'wm-anchor',
        hostClass: DEFAULT_CLS,
        displayType: base.DISPLAY_TYPE.INLINE_BLOCK
    };
    var regex = /Actions.goToPage_(\w+)\.invoke\(\)/g;
    var disableContextMenu = function ($event) {
        $event.preventDefault();
    };
    var AnchorComponent = /** @class */ (function (_super) {
        __extends(AnchorComponent, _super);
        function AnchorComponent(inj, app) {
            var _this = _super.call(this, inj, WIDGET_CONFIG) || this;
            _this.app = app;
            _this._eventNotifier = new core$1.EventNotifier();
            base.styler(_this.nativeElement, _this);
            return _this;
        }
        AnchorComponent_1 = AnchorComponent;
        AnchorComponent.prototype.processEventAttr = function (eventName, expr, meta) {
            var _this = this;
            _super.prototype.processEventAttr.call(this, eventName, expr, meta);
            if (!this.hasNavigationToCurrentPageExpr) {
                var app_1 = this.inj.get(core$1.App);
                var fns = expr.split(';').map(Function.prototype.call, String.prototype.trim);
                if (fns.some(function (fn) {
                    regex.lastIndex = 0;
                    var matches = regex.exec(fn);
                    _this.hasGoToPageExpr = matches && (matches.length > 0);
                    return _this.hasGoToPageExpr && matches[1] === app_1.activePageName;
                })) {
                    this.hasNavigationToCurrentPageExpr = true;
                }
            }
        };
        AnchorComponent.prototype.onActive = function (callback) {
            this._eventNotifier.subscribe('on-active', callback);
        };
        AnchorComponent.prototype.handleEvent = function (node, eventName, eventCallback, locals, meta) {
            var _this = this;
            _super.prototype.handleEvent.call(this, node, eventName, function (e) {
                if (_this.hasGoToPageExpr && locals.$event) {
                    locals.$event.preventDefault();
                }
                eventCallback();
            }, locals, meta);
        };
        AnchorComponent.prototype.onPropertyChange = function (key, nv, ov) {
            if (key === 'hyperlink') {
                if (!nv) {
                    core$1.setAttr(this.nativeElement, 'href', 'javascript:void(0)');
                    this.nativeElement.addEventListener('contextmenu', disableContextMenu);
                    return;
                }
                if (this.encodeurl) {
                    nv = core$1.encodeUrl(nv);
                }
                // if hyperlink starts with 'www.' append '//' in the beginning
                if (nv.startsWith('www.')) {
                    nv = "//" + nv;
                }
                core$1.setAttr(this.nativeElement, 'href', nv);
                this.nativeElement.removeEventListener('contextmenu', disableContextMenu);
            }
            else {
                _super.prototype.onPropertyChange.call(this, key, nv, ov);
            }
        };
        AnchorComponent.prototype.init = function () {
            if (this.hasNavigationToCurrentPageExpr) {
                core$1.addClass(this.nativeElement, 'active');
            }
            if (this.hyperlink && core$1.getRouteNameFromLink(this.hyperlink) === "/" + this.app.activePageName
                || this.hasNavigationToCurrentPageExpr) {
                this._eventNotifier.notify("on-active", {});
            }
        };
        AnchorComponent.prototype.ngAfterViewInit = function () {
            _super.prototype.ngAfterViewInit.call(this);
            this.init();
        };
        AnchorComponent.prototype.ngOnAttach = function () {
            this.init();
            _super.prototype.ngOnAttach.call(this);
        };
        AnchorComponent.prototype.ngOnDestroy = function () {
            this._eventNotifier.destroy();
            _super.prototype.ngOnDestroy.call(this);
        };
        var AnchorComponent_1;
        AnchorComponent.initializeProps = registerProps();
        AnchorComponent.ctorParameters = function () { return [
            { type: core.Injector },
            { type: core$1.App }
        ]; };
        __decorate([
            core.HostBinding('target'),
            __metadata("design:type", String)
        ], AnchorComponent.prototype, "target", void 0);
        __decorate([
            core.HostBinding('attr.accesskey'),
            __metadata("design:type", String)
        ], AnchorComponent.prototype, "shortcutkey", void 0);
        __decorate([
            core.HostBinding('attr.icon-position'),
            __metadata("design:type", String)
        ], AnchorComponent.prototype, "iconposition", void 0);
        AnchorComponent = AnchorComponent_1 = __decorate([
            core.Component({
                selector: 'a[wmAnchor]',
                template: "<img data-identifier=\"img\" alt=\"Image\" class=\"anchor-image-icon\" [src]=\"iconurl | image\" *ngIf=\"iconurl\" [ngStyle]=\"{width:iconwidth, height:iconheight, margin:iconmargin}\"/>\n<i class=\"app-icon {{iconclass}}\" aria-hidden=\"true\" [ngStyle]=\"{width:iconwidth, height:iconheight, margin:iconmargin}\" *ngIf=\"iconclass\"></i>\n<span class=\"sr-only\" *ngIf=\"iconclass\">{{caption | trustAs:'html'}} {{appLocale.LABEL_ICON}}</span>\n<span class=\"anchor-caption\" [innerHTML]=\"caption | trustAs:'html'\"></span>\n<ng-content select=\".caret\"></ng-content>\n<span *ngIf=\"badgevalue\" class=\"badge pull-right\" [textContent]=\"badgevalue\"></span>",
                providers: [
                    base.provideAsWidgetRef(AnchorComponent_1)
                ]
            }),
            __metadata("design:paramtypes", [core.Injector,
                core$1.App])
        ], AnchorComponent);
        return AnchorComponent;
    }(base.StylableComponent));

    var registerProps$1 = function () {
        base.register('wm-audio', new Map([
            ['audiopreload', __assign({ value: 'none' }, base.PROP_STRING)],
            ['audiosupportmessage', __assign({ value: 'Your browser does not support the audio tag.' }, base.PROP_STRING)],
            ['autoplay', base.PROP_BOOLEAN],
            ['class', base.PROP_STRING],
            ['controls', base.PROP_BOOLEAN],
            ['hint', base.PROP_STRING],
            ['loop', base.PROP_BOOLEAN],
            ['mp3format', base.PROP_STRING],
            ['muted', base.PROP_BOOLEAN],
            ['name', base.PROP_STRING],
            ['show', __assign({ value: true }, base.PROP_BOOLEAN)],
            ['tabindex', __assign({ value: 0 }, base.PROP_NUMBER)]
        ]));
    };

    var DEFAULT_CLS$1 = 'app-audio';
    var WIDGET_CONFIG$1 = {
        widgetType: 'wm-audio',
        hostClass: DEFAULT_CLS$1,
        displayType: base.DISPLAY_TYPE.INLINE_BLOCK
    };
    var AudioComponent = /** @class */ (function (_super) {
        __extends(AudioComponent, _super);
        function AudioComponent(inj) {
            var _this = _super.call(this, inj, WIDGET_CONFIG$1) || this;
            base.styler(_this.nativeElement, _this);
            return _this;
        }
        AudioComponent_1 = AudioComponent;
        var AudioComponent_1;
        AudioComponent.initializeProps = registerProps$1();
        AudioComponent.ctorParameters = function () { return [
            { type: core.Injector }
        ]; };
        AudioComponent = AudioComponent_1 = __decorate([
            core.Component({
                selector: '[wmAudio]',
                template: "<audio [src]=\"mp3format | trustAs: 'resource'\" [muted]=\"muted\" [autoplay]=\"autoplay\" [controls]=\"controls\" [loop]=\"loop\" [preload]=\"audiopreload\" role=\"application\" aria-describedby=\"recorded audio\">\n    <source type=\"audio/mp3\" [src]=\"mp3format | trustAs: 'resource'\">\n    {{audiosupportmessage}}\n</audio>\n",
                providers: [
                    base.provideAsWidgetRef(AudioComponent_1)
                ]
            }),
            __metadata("design:paramtypes", [core.Injector])
        ], AudioComponent);
        return AudioComponent;
    }(base.StylableComponent));

    var registerProps$2 = function () {
        base.register('wm-html', new Map([
            ['class', base.PROP_STRING],
            ['content', base.PROP_STRING],
            ['hint', base.PROP_STRING],
            ['name', base.PROP_STRING],
            ['show', __assign({ value: true }, base.PROP_BOOLEAN)]
        ]));
    };

    var DEFAULT_CLS$2 = 'app-html-container';
    var WIDGET_CONFIG$2 = {
        widgetType: 'wm-html',
        hostClass: DEFAULT_CLS$2
    };
    var HtmlDirective = /** @class */ (function (_super) {
        __extends(HtmlDirective, _super);
        function HtmlDirective(inj, height, boundContent, trustAsPipe) {
            var _this = _super.call(this, inj, WIDGET_CONFIG$2) || this;
            _this.boundContent = boundContent;
            _this.trustAsPipe = trustAsPipe;
            // if the height is provided set the overflow to auto
            if (height) {
                core$1.setCSS(_this.nativeElement, 'overflow', 'auto');
            }
            base.styler(_this.nativeElement, _this);
            return _this;
        }
        HtmlDirective_1 = HtmlDirective;
        HtmlDirective.prototype.ngOnInit = function () {
            _super.prototype.ngOnInit.call(this);
            if (this.boundContent) {
                this.nativeElement.innerHTML = '';
            }
            if (!this.content && this.nativeElement.innerHTML) {
                this.content = this.nativeElement.innerHTML;
            }
        };
        HtmlDirective.prototype.onPropertyChange = function (key, nv, ov) {
            if (key === 'content') {
                core$1.setProperty(this.nativeElement, 'innerHTML', this.trustAsPipe.transform(nv, core.SecurityContext.HTML));
            }
            else {
                _super.prototype.onPropertyChange.call(this, key, nv, ov);
            }
        };
        var HtmlDirective_1;
        HtmlDirective.initializeProps = registerProps$2();
        HtmlDirective.ctorParameters = function () { return [
            { type: core.Injector },
            { type: String, decorators: [{ type: core.Attribute, args: ['height',] }] },
            { type: String, decorators: [{ type: core.Attribute, args: ['content.bind',] }] },
            { type: base.TrustAsPipe }
        ]; };
        HtmlDirective = HtmlDirective_1 = __decorate([
            core.Directive({
                selector: '[wmHtml]',
                providers: [
                    base.provideAsWidgetRef(HtmlDirective_1)
                ]
            }),
            __param(1, core.Attribute('height')),
            __param(2, core.Attribute('content.bind')),
            __metadata("design:paramtypes", [core.Injector, String, String, base.TrustAsPipe])
        ], HtmlDirective);
        return HtmlDirective;
    }(base.StylableComponent));

    var registerProps$3 = function () {
        base.register('wm-icon', new Map([
            ['animation', base.PROP_STRING],
            ['caption', base.PROP_STRING],
            ['class', base.PROP_STRING],
            ['conditionalclass', base.PROP_ANY],
            ['conditionalstyle', base.PROP_ANY],
            ['hint', base.PROP_STRING],
            ['iconclass', __assign({ value: 'wi wi-star-border' }, base.PROP_STRING)],
            ['iconposition', __assign({ value: 'left' }, base.PROP_STRING)],
            ['iconsize', base.PROP_STRING],
            ['iconurl', base.PROP_STRING],
            ['name', base.PROP_STRING],
            ['show', __assign({ value: true }, base.PROP_BOOLEAN)]
        ]));
    };

    var DEFAULT_CLS$3 = 'app-icon-wrapper';
    var WIDGET_CONFIG$3 = {
        widgetType: 'wm-icon',
        hostClass: DEFAULT_CLS$3
    };
    var IconComponent = /** @class */ (function (_super) {
        __extends(IconComponent, _super);
        function IconComponent(inj) {
            var _this = _super.call(this, inj, WIDGET_CONFIG$3) || this;
            base.styler(_this.nativeElement, _this);
            return _this;
        }
        IconComponent_1 = IconComponent;
        var IconComponent_1;
        IconComponent.initializeProps = registerProps$3();
        IconComponent.ctorParameters = function () { return [
            { type: core.Injector }
        ]; };
        __decorate([
            core.HostBinding('attr.icon-position'),
            __metadata("design:type", String)
        ], IconComponent.prototype, "iconposition", void 0);
        __decorate([
            core.HostBinding('style.fontSize'),
            __metadata("design:type", String)
        ], IconComponent.prototype, "iconsize", void 0);
        IconComponent = IconComponent_1 = __decorate([
            core.Component({
                selector: '[wmIcon]',
                template: "<i class=\"app-icon {{iconclass}}\"></i>\n<span class=\"sr-only\" *ngIf=\"iconclass\">{{caption}} {{appLocale.LABEL_ICON}}</span>\n<label class=\"app-label\" [textContent]=\"caption\" *ngIf=\"caption\"></label>",
                providers: [
                    base.provideAsWidgetRef(IconComponent_1)
                ]
            }),
            __metadata("design:paramtypes", [core.Injector])
        ], IconComponent);
        return IconComponent;
    }(base.StylableComponent));

    var registerProps$4 = function () {
        base.register('wm-iframe', new Map([
            ['class', base.PROP_STRING],
            ['encodeurl', base.PROP_BOOLEAN],
            ['height', __assign({ value: '150px' }, base.PROP_STRING)],
            ['iframesrc', base.PROP_STRING],
            ['name', base.PROP_STRING],
            ['show', __assign({ value: true }, base.PROP_BOOLEAN)],
            ['width', __assign({ value: '300px' }, base.PROP_STRING)]
        ]));
    };

    var DEFAULT_CLS$4 = 'embed-responsive app-iframe';
    var WIDGET_CONFIG$4 = {
        widgetType: 'wm-iframe',
        hostClass: DEFAULT_CLS$4
    };
    var IframeComponent = /** @class */ (function (_super) {
        __extends(IframeComponent, _super);
        function IframeComponent(inj, trustAsPipe) {
            var _this = _super.call(this, inj, WIDGET_CONFIG$4) || this;
            _this.trustAsPipe = trustAsPipe;
            /**
             * this property member is set to true when the content request url doesn't match windows protocol
             */
            _this.showContentLoadError = false;
            base.styler(_this.nativeElement, _this);
            return _this;
        }
        IframeComponent_1 = IframeComponent;
        IframeComponent.prototype.computeIframeSrc = function () {
            this.showContentLoadError = false;
            this._iframesrc = undefined;
            if (this.iframesrc) {
                var url = this.iframesrc;
                if (this.encodeurl) {
                    url = core$1.encodeUrl(this.iframesrc);
                }
                var trustedUrl = this.trustAsPipe.transform(url, core.SecurityContext.RESOURCE_URL);
                if (core$1.isInsecureContentRequest(url)) {
                    this.showContentLoadError = true;
                    this.errorMsg = this.appLocale.MESSAGE_ERROR_CONTENT_DISPLAY + " " + this.iframesrc;
                    this.hintMsg = this.errorMsg;
                }
                this._iframesrc = trustedUrl;
            }
        };
        IframeComponent.prototype.onPropertyChange = function (key, nv, ov) {
            if (key === 'iframesrc' || key === 'encodeurl') {
                this.computeIframeSrc();
            }
            else {
                _super.prototype.onPropertyChange.call(this, key, nv, ov);
            }
        };
        var IframeComponent_1;
        IframeComponent.initializeProps = registerProps$4();
        IframeComponent.ctorParameters = function () { return [
            { type: core.Injector },
            { type: base.TrustAsPipe }
        ]; };
        IframeComponent = IframeComponent_1 = __decorate([
            core.Component({
                selector: '[wmIframe]',
                template: "<iframe title=\"\" class=\"embed-responsive-item iframe-content\" role=\"document\"\n        scrolling=\"auto\"\n        marginheight=\"0\"\n        marginwidth=\"0\"\n        frameborder=\"0\"\n        [name]=\"name\"\n        [attr.src]=\"_iframesrc\"\n        seamless=\"seamless\">\n</iframe>\n<div class=\"wm-content-info readonly-wrapper\" *ngIf=\"showContentLoadError\">\n    <p class=\"wm-message\" [title]=\"hintMsg\" [textContent]=\"errMsg\"></p>\n</div>",
                providers: [
                    base.provideAsWidgetRef(IframeComponent_1)
                ]
            }),
            __metadata("design:paramtypes", [core.Injector, base.TrustAsPipe])
        ], IframeComponent);
        return IframeComponent;
    }(base.StylableComponent));

    var registerProps$5 = function () {
        base.register('wm-label', new Map([
            ['animation', base.PROP_STRING],
            ['caption', __assign({ value: 'Label' }, base.PROP_STRING)],
            ['class', base.PROP_STRING],
            ['conditionalclass', base.PROP_ANY],
            ['conditionalstyle', base.PROP_ANY],
            ['hint', base.PROP_STRING],
            ['name', base.PROP_STRING],
            ['required', base.PROP_BOOLEAN],
            ['show', __assign({ value: true }, base.PROP_BOOLEAN)]
        ]));
    };

    var DEFAULT_CLS$5 = 'app-label';
    var WIDGET_CONFIG$5 = {
        widgetType: 'wm-label',
        hostClass: DEFAULT_CLS$5,
        displayType: base.DISPLAY_TYPE.INLINE_BLOCK
    };
    var LabelDirective = /** @class */ (function (_super) {
        __extends(LabelDirective, _super);
        function LabelDirective(inj, trustAsPipe) {
            var _this = _super.call(this, inj, WIDGET_CONFIG$5) || this;
            _this.trustAsPipe = trustAsPipe;
            base.styler(_this.nativeElement, _this);
            return _this;
        }
        LabelDirective_1 = LabelDirective;
        LabelDirective.prototype.onPropertyChange = function (key, nv, ov) {
            if (key === 'caption') {
                if (_.isObject(nv)) {
                    core$1.setProperty(this.nativeElement, 'textContent', JSON.stringify(nv));
                }
                else {
                    core$1.setProperty(this.nativeElement, 'innerHTML', this.trustAsPipe.transform(nv, core.SecurityContext.HTML));
                }
            }
            else if (key === 'required') {
                core$1.toggleClass(this.nativeElement, 'required', nv);
            }
            else {
                _super.prototype.onPropertyChange.call(this, key, nv, ov);
            }
        };
        var LabelDirective_1;
        LabelDirective.initializeProps = registerProps$5();
        LabelDirective.ctorParameters = function () { return [
            { type: core.Injector },
            { type: base.TrustAsPipe }
        ]; };
        LabelDirective = LabelDirective_1 = __decorate([
            core.Directive({
                selector: '[wmLabel]',
                providers: [
                    base.provideAsWidgetRef(LabelDirective_1)
                ]
            }),
            __metadata("design:paramtypes", [core.Injector, base.TrustAsPipe])
        ], LabelDirective);
        return LabelDirective;
    }(base.StylableComponent));

    var registerProps$6 = function () {
        var props = new Map([
            ['animation', base.PROP_STRING],
            ['class', base.PROP_STRING],
            ['conditionalclass', base.PROP_ANY],
            ['conditionalstyle', base.PROP_ANY],
            ['encodeurl', base.PROP_STRING],
            ['hint', base.PROP_STRING],
            ['name', base.PROP_STRING],
            ['pictureaspect', __assign({ value: 'None' }, base.PROP_STRING)],
            ['pictureplaceholder', base.PROP_STRING],
            ['picturesource', base.PROP_STRING],
            ['shape', base.PROP_STRING],
            ['show', __assign({ value: true }, base.PROP_BOOLEAN)],
            ['tabindex', __assign({ value: 0 }, base.PROP_NUMBER)]
        ]);
        if (core$1.isMobileApp()) {
            props.set('offline', __assign({ value: true }, base.PROP_BOOLEAN));
        }
        base.register('wm-picture', props);
    };

    var DEFAULT_CLS$6 = 'app-picture';
    var WIDGET_CONFIG$6 = {
        widgetType: 'wm-picture',
        hostClass: DEFAULT_CLS$6,
        displayType: base.DISPLAY_TYPE.INLINE_BLOCK
    };
    var PictureDirective = /** @class */ (function (_super) {
        __extends(PictureDirective, _super);
        function PictureDirective(inj, imagePipe) {
            var _this = _super.call(this, inj, WIDGET_CONFIG$6) || this;
            _this.imagePipe = imagePipe;
            base.styler(_this.nativeElement, _this);
            return _this;
        }
        PictureDirective_1 = PictureDirective;
        PictureDirective.prototype.setImgSource = function () {
            this.imgSource = this.imagePipe.transform(this.picturesource, this.encodeurl, this.pictureplaceholder);
        };
        PictureDirective.prototype.onPropertyChange = function (key, nv, ov) {
            if (key === 'pictureaspect') {
                var width = '';
                var height = '';
                switch (nv) {
                    case 'None':
                        width = this.width;
                        height = this.height;
                        break;
                    case 'H':
                        width = '100%';
                        break;
                    case 'V':
                        height = '100%';
                        break;
                    case 'Both':
                        width = '100%';
                        height = '100%';
                        break;
                }
                core$1.setCSS(this.nativeElement, 'width', width, true);
                core$1.setCSS(this.nativeElement, 'height', height, true);
            }
            else if (key === 'encodeurl' || key === 'pictureplaceholder') {
                this.setImgSource();
            }
            else if (key === 'shape') {
                core$1.switchClass(this.nativeElement, "img-" + nv, "img-" + ov);
            }
            else if (key === 'hint') {
                core$1.setAttr(this.nativeElement, 'alt', nv);
            }
            _super.prototype.onPropertyChange.call(this, key, nv, ov);
        };
        PictureDirective.prototype.onStyleChange = function (key, nv, ov) {
            if (key === 'picturesource') {
                this.setImgSource();
            }
            else {
                _super.prototype.onStyleChange.call(this, key, nv, ov);
            }
        };
        PictureDirective.prototype.ngOnInit = function () {
            this.setImgSource();
            _super.prototype.ngOnInit.call(this);
        };
        var PictureDirective_1;
        PictureDirective.initializeProps = registerProps$6();
        PictureDirective.ctorParameters = function () { return [
            { type: core.Injector },
            { type: base.ImagePipe }
        ]; };
        __decorate([
            core.HostBinding('src'),
            __metadata("design:type", String)
        ], PictureDirective.prototype, "imgSource", void 0);
        PictureDirective = PictureDirective_1 = __decorate([
            core.Directive({
                selector: 'img[wmPicture]',
                providers: [
                    base.provideAsWidgetRef(PictureDirective_1)
                ]
            }),
            __metadata("design:paramtypes", [core.Injector, base.ImagePipe])
        ], PictureDirective);
        return PictureDirective;
    }(base.StylableComponent));

    var registerProps$7 = function () {
        base.register('wm-spinner', new Map([
            ['animation', { value: 'spin', PROP_STRING: base.PROP_STRING }],
            ['caption', __assign({ value: 'Loading...' }, base.PROP_STRING)],
            ['class', base.PROP_STRING],
            ['iconclass', __assign({ value: 'fa fa-circle-o-notch fa-spin' }, base.PROP_STRING)],
            ['iconsize', base.PROP_STRING],
            ['image', base.PROP_STRING],
            ['imageheight', base.PROP_STRING],
            ['imagewidth', __assign({ value: '20px' }, base.PROP_STRING)],
            ['name', base.PROP_STRING],
            ['show', __assign({ value: true }, base.PROP_BOOLEAN)],
            ['type', __assign({ value: 'icon' }, base.PROP_STRING)],
            ['servicevariabletotrack', base.PROP_STRING]
        ]));
    };

    var DEFAULT_CLS$7 = 'app-spinner';
    var WIDGET_CONFIG$7 = { widgetType: 'wm-spinner', hostClass: DEFAULT_CLS$7 };
    var SpinnerComponent = /** @class */ (function (_super) {
        __extends(SpinnerComponent, _super);
        function SpinnerComponent(inj, imagePipe) {
            var _this = _super.call(this, inj, WIDGET_CONFIG$7) || this;
            _this.imagePipe = imagePipe;
            _this.iconclass = '';
            _this.animation = '';
            _this.showCaption = true;
            base.styler(_this.nativeElement, _this);
            return _this;
        }
        SpinnerComponent_1 = SpinnerComponent;
        Object.defineProperty(SpinnerComponent.prototype, "spinnerMessages", {
            get: function () {
                return this._spinnerMessages;
            },
            set: function (newVal) {
                this.showCaption = _.isEmpty(newVal);
                this._spinnerMessages = newVal;
            },
            enumerable: true,
            configurable: true
        });
        SpinnerComponent.prototype.listenOnDataSource = function () {
            var _this = this;
            var variables = _.split(this.servicevariabletotrack, ',');
            this.getAppInstance().subscribe('toggle-variable-state', function (data) {
                var name = data.variable.execute(core$1.DataSource.Operation.GET_NAME);
                if (_.includes(variables, name) && core$1.validateDataSourceCtx(data.variable, _this.getViewParent())) {
                    _this.widget.show = data.active;
                }
            });
        };
        SpinnerComponent.prototype.onPropertyChange = function (key, nv, ov) {
            if (key === 'image') {
                this.picture = this.imagePipe.transform(nv);
            }
            else if (key === 'animation') {
                if (nv === 'spin') {
                    this.animation = 'fa-spin';
                }
                else {
                    this.animation = nv || '';
                }
            }
            else {
                _super.prototype.onPropertyChange.call(this, key, nv, ov);
            }
        };
        SpinnerComponent.prototype.ngOnInit = function () {
            _super.prototype.ngOnInit.call(this);
            // if variables are to be listened to, hide the widget and set the listener
            if (this.servicevariabletotrack) {
                this.widget.show = false;
                this.listenOnDataSource();
            }
        };
        var SpinnerComponent_1;
        SpinnerComponent.initializeProps = registerProps$7();
        SpinnerComponent.ctorParameters = function () { return [
            { type: core.Injector },
            { type: base.ImagePipe }
        ]; };
        SpinnerComponent = SpinnerComponent_1 = __decorate([
            core.Component({
                selector: '[wmSpinner]',
                template: "<div class=\"spinner-message\" aria-label=\"loading gif\">\n    <span class=\"spinner-image animated infinite\" [ngClass]=\"animation\" aria-hidden=\"true\"\n        [ngStyle]=\"{width: imagewidth, height: imageheight, backgroundImage: 'url(' + picture + ')', backgroundSize: imagewidth}\"\n        *ngIf=\"type === 'image'\"></span>\n    <i class=\"spinner-image animated infinite\" [ngClass]=\"[iconclass, animation]\" [style.fonSize]=\"iconsize\" *ngIf=\"type === 'icon'\"></i>\n    <span class=\"spinner-text\" [innerHTML]=\"caption | trustAs: 'html'\" *ngIf=\"showCaption\"></span>\n    <div class=\"spinner-messages\" *ngIf=\"!showCaption && spinnerMessages\">\n        <p *ngFor=\"let value of spinnerMessages\" [textContent]=\"value\"></p>\n    </div>\n</div>",
                providers: [
                    base.provideAsWidgetRef(SpinnerComponent_1)
                ]
            }),
            __metadata("design:paramtypes", [core.Injector, base.ImagePipe])
        ], SpinnerComponent);
        return SpinnerComponent;
    }(base.StylableComponent));

    var registerProps$8 = function () {
        base.register('wm-video', new Map([
            ['autoplay', base.PROP_BOOLEAN],
            ['class', base.PROP_STRING],
            ['controls', base.PROP_BOOLEAN],
            ['hint', base.PROP_STRING],
            ['loop', base.PROP_BOOLEAN],
            ['mp4format', base.PROP_STRING],
            ['muted', base.PROP_BOOLEAN],
            ['name', base.PROP_STRING],
            ['oggformat', base.PROP_STRING],
            ['show', __assign({ value: true }, base.PROP_BOOLEAN)],
            ['subtitlelang', __assign({ value: 'en' }, base.PROP_STRING)],
            ['subtitlesource', base.PROP_STRING],
            ['tabindex', __assign({ value: 0 }, base.PROP_NUMBER)],
            ['videoposter', __assign({ value: 'resources/images/imagelists/default-image.png' }, base.PROP_STRING)],
            ['videopreload', __assign({ value: 'none' }, base.PROP_STRING)],
            ['videosupportmessage', __assign({ value: 'Your browser does not support the video tag.' }, base.PROP_STRING)],
            ['webmformat', base.PROP_STRING]
        ]));
    };

    var DEFAULT_CLS$8 = 'app-video';
    var WIDGET_CONFIG$8 = {
        widgetType: 'wm-video',
        hostClass: DEFAULT_CLS$8,
        displayType: base.DISPLAY_TYPE.INLINE_BLOCK
    };
    var VideoComponent = /** @class */ (function (_super) {
        __extends(VideoComponent, _super);
        function VideoComponent(inj, trustAsPipe) {
            var _this = _super.call(this, inj, WIDGET_CONFIG$8) || this;
            _this.trustAsPipe = trustAsPipe;
            /**
             * subtitle language property eg: en
             */
            _this.subtitlelang = 'en';
            base.styler(_this.nativeElement, _this);
            return _this;
        }
        VideoComponent_1 = VideoComponent;
        // DO NOT use ngIf binding for the track. As of v6.0.Beta7 there is an error creating a void track node
        VideoComponent.prototype.onPropertyChange = function (key, nv, ov) {
            if (key === 'subtitlesource') {
                var track = this.nativeElement.querySelector('track');
                if (track) {
                    core$1.removeNode(track, true);
                }
                track = core$1.createElement('track', {
                    kind: 'subtitles',
                    label: this.subtitlelang,
                    srclang: this.subtitlelang,
                    src: this.trustAsPipe.transform(nv, core.SecurityContext.RESOURCE_URL),
                    default: ''
                }, true);
                core$1.appendNode(track, this.nativeElement.querySelector('video'));
            }
            else if (key === 'mp4format') {
                this.mp4format = core$1.transformFileURI(nv);
            }
            else if (key === 'webmformat') {
                this.webmformat = core$1.transformFileURI(nv);
            }
            else if (key === 'oggformat') {
                this.oggformat = core$1.transformFileURI(nv);
            }
            _super.prototype.onPropertyChange.call(this, key, nv, ov);
        };
        var VideoComponent_1;
        VideoComponent.initializeProps = registerProps$8();
        VideoComponent.ctorParameters = function () { return [
            { type: core.Injector },
            { type: base.TrustAsPipe }
        ]; };
        VideoComponent = VideoComponent_1 = __decorate([
            core.Component({
                selector: '[wmVideo]',
                template: "<video [preload]=\"videopreload\" role=\"application\"\n       [src]=\"mp4format | trustAs: 'resource'\"\n       [muted]=\"muted\"\n       [poster]=\"videoposter | image\"\n       [controls]=\"controls\"\n       [loop]=\"loop\"\n       [autoplay]=\"autoplay\">\n    <source type=\"video/mp4\" [src]=\"mp4format | trustAs: 'resource'\" *ngIf=\"mp4format\">\n    <source type=\"video/webm\" [src]=\"webmformat | trustAs: 'resource'\" *ngIf=\"webmformat\">\n    <source type=\"video/ogg\" [src]=\"oggformat | trustAs: 'resource'\" *ngIf=\"oggformat\">\n    {{videosupportmessage}}\n</video>",
                providers: [
                    base.provideAsWidgetRef(VideoComponent_1)
                ]
            }),
            __metadata("design:paramtypes", [core.Injector, base.TrustAsPipe])
        ], VideoComponent);
        return VideoComponent;
    }(base.StylableComponent));

    var components = [
        AnchorComponent,
        AudioComponent,
        HtmlDirective,
        IconComponent,
        IframeComponent,
        LabelDirective,
        PictureDirective,
        SpinnerComponent,
        VideoComponent
    ];
    var BasicModule = /** @class */ (function () {
        function BasicModule() {
        }
        BasicModule = __decorate([
            core.NgModule({
                imports: [
                    common.CommonModule,
                    base.WmComponentsModule
                ],
                declarations: __spread(components),
                exports: __spread(components),
                entryComponents: []
            })
        ], BasicModule);
        return BasicModule;
    }());

    exports.AnchorComponent = AnchorComponent;
    exports.BasicModule = BasicModule;
    exports.disableContextMenu = disableContextMenu;
    exports.ɵa = registerProps;
    exports.ɵb = AudioComponent;
    exports.ɵc = registerProps$1;
    exports.ɵd = HtmlDirective;
    exports.ɵe = registerProps$2;
    exports.ɵf = IconComponent;
    exports.ɵg = registerProps$3;
    exports.ɵh = IframeComponent;
    exports.ɵi = registerProps$4;
    exports.ɵj = LabelDirective;
    exports.ɵk = registerProps$5;
    exports.ɵl = PictureDirective;
    exports.ɵm = registerProps$6;
    exports.ɵn = SpinnerComponent;
    exports.ɵo = registerProps$7;
    exports.ɵp = VideoComponent;
    exports.ɵq = registerProps$8;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=index.umd.js.map
