import { Injector } from '@angular/core';
import { SafeResourceUrl } from '@angular/platform-browser';
import { StylableComponent, TrustAsPipe } from '@wm/components/base';
export declare class IframeComponent extends StylableComponent {
    private trustAsPipe;
    static initializeProps: void;
    iframesrc: string;
    encodeurl: boolean;
    _iframesrc: SafeResourceUrl;
    private errorMsg;
    private hintMsg;
    caption: any;
    name: string;
    /**
     * this property member is set to true when the content request url doesn't match windows protocol
     */
    showContentLoadError: boolean;
    constructor(inj: Injector, trustAsPipe: TrustAsPipe);
    protected computeIframeSrc(): void;
    onPropertyChange(key: any, nv: any, ov?: any): void;
}
