import { AfterViewInit, OnDestroy, Injector } from '@angular/core';
import { App } from '@wm/core';
import { IRedrawableComponent, StylableComponent } from '@wm/components/base';
export declare class ChartComponent extends StylableComponent implements AfterViewInit, OnDestroy, IRedrawableComponent {
    private app;
    static initializeProps: void;
    xaxisdatakey: any;
    yaxisdatakey: any;
    groupby: any;
    aggregation: any;
    aggregationcolumn: any;
    isVisuallyGrouped: any;
    orderby: any;
    iconclass: string;
    type: string;
    showContentLoadError: any;
    invalidConfig: any;
    errMsg: any;
    shape: string;
    datasource: any;
    fontsize: string;
    selecteditem: any;
    fontunit: string;
    offsettop: number;
    offsetleft: number;
    offsetright: number;
    offsetbottom: number;
    showlabels: any;
    theme: string;
    private $id;
    private scopedataset;
    private binddataset;
    private showlabelsoutside;
    private _resizeFn;
    private chart;
    private clearCanvas;
    isLoadInProgress: boolean;
    private filterFields;
    private dataset;
    private axisoptions;
    private numericColumns;
    private nonPrimaryColumns;
    private variableInflight;
    private chartReady;
    private xDataKeyArr;
    private xAxisDataType;
    private bubblesize;
    showNoDataMsg: any;
    private sampleData;
    private chartData;
    private _processedData;
    private _subsciptions;
    title: any;
    isGroupByEnabled(): boolean;
    isValidAxis(): any;
    isAggregationEnabled(): boolean;
    isDataFilteringEnabled(): any;
    getxAxisVal(dataObj: any, xKey: any, index: any): any;
    getXMinMaxValues(datum: any): any;
    getYMinMaxValues(datum: any): any;
    getValidData(values: any): any;
    valueFinder(dataObj: any, xKey: any, yKey: any, index?: any, shape?: any): any;
    setErrMsg(message: any): void;
    processChartData(): any[];
    setChartData(data: any): void;
    getChartData(): any[];
    getVisuallyGroupedData(queryResponse: any, groupingColumn: any): any;
    getGroupingDetails(): {
        expression: any;
        isVisuallyGrouped: boolean;
        visualGroupingColumn: any;
    };
    getAggregatedData(callback: any): void;
    setLabelsMaxWidth(): void;
    getDefaultColumns(): any[];
    attachClickEvent(): void;
    postPlotProcess(chart: any): void;
    configureChart(): any;
    plotChart(): void;
    get isLiveVariable(): boolean;
    plotChartProxy(): void;
    setDefaultAxisOptions(): void;
    getCutomizedOptions(prop: any, fields: any): any;
    setNumericandNonPrimaryColumns(): void;
    handleDataSet(newVal: any): void;
    _plotChartProxy: any;
    onPropertyChange(key: any, newVal: any, oldVal?: any): void;
    handleLoading(data: any): void;
    onStyleChange(key: any, newVal: any, oldVal: any): void;
    constructor(inj: Injector, app: App);
    ngAfterViewInit(): void;
    ngOnDestroy(): void;
    redraw: any;
}
