(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common'), require('@wm/components/base'), require('@wm/core')) :
    typeof define === 'function' && define.amd ? define('@wm/components/containers/accordion', ['exports', '@angular/core', '@angular/common', '@wm/components/base', '@wm/core'], factory) :
    (global = global || self, factory((global.wm = global.wm || {}, global.wm.components = global.wm.components || {}, global.wm.components.containers = global.wm.components.containers || {}, global.wm.components.containers.accordion = {}), global.ng.core, global.ng.common, global.wm.components.base, global.wm.core));
}(this, (function (exports, core, common, base, core$1) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __rest(s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); }
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    function __createBinding(o, m, k, k2) {
        if (k2 === undefined) k2 = k;
        o[k2] = m[k];
    }

    function __exportStar(m, exports) {
        for (var p in m) if (p !== "default" && !exports.hasOwnProperty(p)) exports[p] = m[p];
    }

    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m) return m.call(o);
        if (o && typeof o.length === "number") return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }

    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    }

    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    };

    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }

    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
    }

    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }

    function __asyncValues(o) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
    }

    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
        return cooked;
    };

    function __importStar(mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
        result.default = mod;
        return result;
    }

    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }

    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }

    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    var registerProps = function () {
        base.register('wm-accordion', new Map([
            ['class', base.PROP_STRING],
            ['closeothers', __assign({ value: true }, base.PROP_BOOLEAN)],
            ['defaultpaneindex', __assign({ value: 0 }, base.PROP_NUMBER)],
            ['name', base.PROP_STRING],
            ['show', __assign({ value: true }, base.PROP_BOOLEAN)],
            ['statehandler', __assign({ value: 'none' }, base.PROP_STRING)],
            ['tabindex', __assign({ value: 0 }, base.PROP_NUMBER)]
        ]));
    };

    var registerProps$1 = function () {
        base.register('wm-accordionpane', new Map([
            ['active', base.PROP_BOOLEAN],
            ['badgetype', __assign({ value: 'default' }, base.PROP_STRING)],
            ['badgevalue', base.PROP_STRING],
            ['class', base.PROP_STRING],
            ['content', base.PROP_STRING],
            ['dynamicPaneIndex', base.PROP_NUMBER],
            ['iconclass', base.PROP_STRING],
            ['isdefaultpane', base.PROP_BOOLEAN],
            ['isdynamic', base.PROP_STRING],
            ['name', base.PROP_STRING],
            ['show', __assign({ value: true }, base.PROP_BOOLEAN)],
            ['smoothscroll', __assign({ value: true }, base.PROP_BOOLEAN)],
            ['subheading', base.PROP_STRING],
            ['tabindex', __assign({ value: 0 }, base.PROP_NUMBER)],
            ['title', __assign({ value: 'Title' }, base.PROP_STRING)]
        ]));
    };

    var DEFAULT_CLS = 'app-accordion-panel panel';
    var WIDGET_CONFIG = { widgetType: 'wm-accordionpane', hostClass: DEFAULT_CLS };
    var AccordionPaneComponent = /** @class */ (function (_super) {
        __extends(AccordionPaneComponent, _super);
        function AccordionPaneComponent(inj, accordionRef) {
            var _this = _super.call(this, inj, WIDGET_CONFIG) || this;
            _this.accordionRef = accordionRef;
            _this.isActive = false;
            _this.$lazyLoad = core$1.noop;
            base.styler(_this.nativeElement, _this, base.APPLY_STYLES_TYPE.SHELL);
            // title property here serves the purpose of heading.
            // remove title property as attribute
            core$1.removeAttr(_this.nativeElement, 'title');
            return _this;
        }
        AccordionPaneComponent_1 = AccordionPaneComponent;
        /**
         * handles the pane expand
         * invoke $lazyLoad method which takes care of loading the partial when the content property is provided - lazyLoading or partial
         * invoke redraw on the re-drawable children
         * invoke expand callback
         * notify parent about the change
         * @param {Event} evt
         */
        AccordionPaneComponent.prototype.expand = function (evt) {
            if (this.isActive) {
                return;
            }
            this.isActive = true;
            this.$lazyLoad();
            this.redrawChildren();
            this.invokeEventCallback('expand', { $event: evt });
            this.notifyParent(true, evt);
        };
        /**
         * handles the pane collapse
         * invoke collapse callback
         * notify parent about the change
         * @param {Event} evt
         */
        AccordionPaneComponent.prototype.collapse = function (evt) {
            if (!this.isActive) {
                return;
            }
            this.isActive = false;
            this.invokeEventCallback('collapse', { $event: evt });
            this.notifyParent(false, evt);
        };
        AccordionPaneComponent.prototype.remove = function () {
            var paneIndex = this.accordionRef.getPaneIndexByRef(this);
            if (this.isActive && this.accordionRef.panes.length > 1) {
                this === this.accordionRef.panes.last ? this.accordionRef.panes.toArray()[paneIndex - 1].expand() : this.accordionRef.panes.toArray()[paneIndex + 1].expand();
            }
            var availablePanes = this.accordionRef.panes.toArray();
            availablePanes.splice(this.accordionRef.getPaneIndexByRef(this), 1);
            this.accordionRef.panes.reset(__spread(availablePanes));
            this.nativeElement.remove();
        };
        AccordionPaneComponent.prototype.toggle = function (evt) {
            if (this.isActive) {
                this.collapse(evt);
            }
            else {
                this.expand(evt);
            }
        };
        // Todo - Vinay externalize
        AccordionPaneComponent.prototype.redrawChildren = function () {
            var _this = this;
            setTimeout(function () {
                if (_this.reDrawableComponents) {
                    _this.reDrawableComponents.forEach(function (c) { return c.redraw(); });
                }
            }, 100);
        };
        AccordionPaneComponent.prototype.notifyParent = function (isExpand, evt) {
            this.accordionRef.notifyChange(this, isExpand, evt);
        };
        AccordionPaneComponent.prototype.onPropertyChange = function (key, nv, ov) {
            var _this = this;
            if (key === 'content') {
                if (this.isActive) {
                    setTimeout(function () { return _this.$lazyLoad(); }, 100);
                }
            }
            else {
                _super.prototype.onPropertyChange.call(this, key, nv, ov);
            }
        };
        AccordionPaneComponent.prototype.ngAfterViewInit = function () {
            _super.prototype.ngAfterViewInit.call(this);
            base.styler(this.nativeElement.querySelector('.panel-body'), this, base.APPLY_STYLES_TYPE.INNER_SHELL);
            if (this.isdynamic) {
                this.accordionRef.registerDynamicPane(this);
            }
        };
        var AccordionPaneComponent_1;
        AccordionPaneComponent.initializeProps = registerProps$1();
        AccordionPaneComponent.ctorParameters = function () { return [
            { type: core.Injector },
            { type: AccordionDirective }
        ]; };
        __decorate([
            core.ContentChildren(base.RedrawableDirective, { descendants: true }),
            __metadata("design:type", Object)
        ], AccordionPaneComponent.prototype, "reDrawableComponents", void 0);
        AccordionPaneComponent = AccordionPaneComponent_1 = __decorate([
            core.Component({
                selector: 'div[wmAccordionPane]',
                template: "<div class=\"panel-heading clearfix\" role=\"tab\" (click)=\"toggle($event)\" [ngClass]=\"{active: isActive}\">\n    <h3 class=\"panel-title\">\n        <a href=\"javascript:void(0);\" role=\"button\" class=\"accordion-toggle\" [attr.aria-expanded]=\"isActive\" [attr.aria-controls]=\"name\">\n            <div class=\"pull-left\">\n                <i class=\"app-icon panel-icon {{iconclass}}\" [hidden]=\"!iconclass\"></i>\n            </div>\n            <div class=\"pull-left\">\n                <div class=\"heading\" [innerHTML]=\"title | trustAs: 'html'\"></div>\n                <div class=\"description\" [innerHTML]=\"subheading | trustAs: 'html'\"></div>\n            </div>\n        </a>\n    </h3>\n    <div class=\"panel-actions\">\n        <span class=\"label label-{{badgetype}}\">{{badgevalue}}</span>\n        <button type=\"button\" aria-label=\"Collapse/Expand\" [attr.aria-expanded]=\"isActive\" [attr.aria-controls]=\"name\"\n                class=\"app-icon panel-action wi\"\n                title=\"{{appLocale.LABEL_COLLAPSE}}/{{appLocale.LABEL_EXPAND}}\">\n            <i [ngClass]=\"isActive ? 'wi-minus' : 'wi-plus'\"></i>\n        </button>\n    </div>\n</div>\n<div class=\"panel-collapse collapse\" role=\"tabpanel\" aria-labelledby=\"panel description\" [ngClass]=\"isActive ? 'collapse in' : 'collapse'\">\n    <div class=\"panel-body\" [wmSmoothscroll]=\"smoothscroll\" partial-container-target>\n        <ng-content></ng-content>\n    </div>\n</div>\n",
                providers: [
                    base.provideAsWidgetRef(AccordionPaneComponent_1)
                ]
            }),
            __metadata("design:paramtypes", [core.Injector, AccordionDirective])
        ], AccordionPaneComponent);
        return AccordionPaneComponent;
    }(base.StylableComponent));

    var DEFAULT_CLS$1 = 'app-accordion panel-group';
    var WIDGET_CONFIG$1 = {
        widgetType: 'wm-accordion',
        hostClass: DEFAULT_CLS$1
    };
    var AccordionDirective = /** @class */ (function (_super) {
        __extends(AccordionDirective, _super);
        function AccordionDirective(inj, statePersistence, dynamicComponentProvider) {
            var _this = this;
            var resolveFn = core$1.noop;
            _this = _super.call(this, inj, WIDGET_CONFIG$1, new Promise(function (res) { return resolveFn = res; })) || this;
            _this.promiseResolverFn = resolveFn;
            _this.statePersistence = statePersistence;
            _this.dynamicComponentProvider = dynamicComponentProvider;
            _this.dynamicPanes = [];
            _this.dynamicPaneIndex = 0;
            base.styler(_this.nativeElement, _this, base.APPLY_STYLES_TYPE.SCROLLABLE_CONTAINER);
            return _this;
        }
        AccordionDirective_1 = AccordionDirective;
        /**
         * AccordionPane children components invoke this method to communicate with the parent
         * if isExpand is true and when closeothers is true, all the other panes are collapsed
         * if the evt argument is defined on-change callback will be invoked.
         * updates the activePane index property
         * @param {AccordionPaneComponent} paneRef
         * @param {boolean} isExpand
         * @param {Event} evt
         */
        AccordionDirective.prototype.notifyChange = function (paneRef, isExpand, evt) {
            if (isExpand) {
                this.closePanesExcept(paneRef);
                var index = this.getPaneIndexByRef(paneRef);
                this.activePane = paneRef.getWidget();
                // if the event is defined invoke the change callback.
                // programmatic invocations of expand/collapse on accordion-pane will not trigger change event
                if (evt) {
                    this.invokeEventCallback('change', {
                        $event: evt,
                        newPaneIndex: index,
                        oldPaneIndex: this.activePaneIndex
                    });
                }
                this.activePaneIndex = index;
            }
            var mode = this.statePersistence.computeMode(this.statehandler);
            if (evt && mode && mode.toLowerCase() !== 'none') {
                var activePanes_1 = [];
                this.panes.forEach(function (pane) {
                    if (pane.isActive) {
                        activePanes_1.push(pane.name);
                    }
                });
                if (activePanes_1.length) {
                    this.statePersistence.setWidgetState(this, activePanes_1);
                }
                else {
                    this.statePersistence.removeWidgetState(this);
                }
            }
        };
        /**
         * This method is used to register the dynamic panes.
         * After all panes are initialzed, update the querylist manually based on index.
         * @param paneRef - refrence of the tabpane
         */
        AccordionDirective.prototype.registerDynamicPane = function (paneRef) {
            this.dynamicPanes.push(paneRef);
            var isLastPane = this.dynamicPanes.length === this.dynamicPaneIndex;
            if (isLastPane) {
                var _loop_1 = function (i) {
                    var newPaneRef = _.find(this_1.dynamicPanes, function (pane) { return pane.dynamicPaneIndex === i; });
                    var isDuplicatePane = _.find(this_1.panes.toArray(), newPaneRef);
                    if (!isDuplicatePane) {
                        this_1.panes.reset(__spread(this_1.panes.toArray(), [newPaneRef]));
                        if (newPaneRef.active) {
                            newPaneRef.expand();
                        }
                    }
                };
                var this_1 = this;
                for (var i = 0; i < this.dynamicPanes.length; i++) {
                    _loop_1(i);
                }
            }
        };
        /**
         * This method is to add the tabpane dynamically
         * @param tabpanes - list of tabpanes
         */
        AccordionDirective.prototype.addPane = function (tabpanes) {
            var _this = this;
            if (!_.isArray(tabpanes)) {
                tabpanes = [tabpanes];
            }
            var paneNamesList = [];
            _.forEach(tabpanes, function (pane, index) {
                var isPaneAlreadyCreated = _.find(_this.panes.toArray(), { name: pane.name });
                var isPaneNameExist = _.indexOf(paneNamesList, pane.name);
                // If user tries to add tabpane with the same name which is already exists then do not create the pane
                if (isPaneAlreadyCreated || isPaneNameExist > 0) {
                    console.warn("The tab pane with name " + pane.name + " already exists");
                    return;
                }
                var paramMarkup = '';
                var propsTmpl = '';
                _this.dynamicPaneIndex++;
                var name = pane.name ? pane.name : "accordionpane" + (_this.panes.toArray().length + (index + 1));
                paneNamesList.push(name);
                var partialParams = _.get(pane, 'params');
                _.forEach(pane, function (value, key) {
                    if (key !== 'params') {
                        propsTmpl = propsTmpl + " " + key + "=\"" + value + "\"";
                    }
                });
                _.forEach(partialParams, function (value, key) {
                    paramMarkup = paramMarkup + " <wm-param name=\"" + key + "\" value=\"" + value + "\"></wm-param>";
                });
                var markup = "<wm-accordionpane dynamicPaneIndex=\"" + (_this.dynamicPaneIndex - 1) + "\" isdynamic=\"true\" name=\"" + name + "\" " + propsTmpl + ">\n                            " + paramMarkup + "\n                        </wm-accordionpane>";
                if (!_this._dynamicContext) {
                    _this._dynamicContext = Object.create(_this.viewParent);
                    _this._dynamicContext[_this.getAttr('wmAccordian')] = _this;
                }
                _this.dynamicComponentProvider.addComponent(_this.getNativeElement(), markup, _this._dynamicContext, { inj: _this.inj });
            });
            return paneNamesList;
        };
        /**
         * This method is to remove the tabpane
         * @param paneName - name of the pane
         */
        AccordionDirective.prototype.removePane = function (paneName) {
            var paneRef = this.getPaneRefByName(paneName);
            if (paneRef) {
                paneRef.remove();
            }
        };
        AccordionDirective.prototype.isValidPaneIndex = function (index) {
            return (index >= 0 && index < this.panes.length);
        };
        AccordionDirective.prototype.getPaneRefByName = function (name) {
            return _.find(this.panes.toArray(), { name: name });
        };
        AccordionDirective.prototype.getPaneIndexByRef = function (paneRef) {
            return this.panes.toArray().indexOf(paneRef);
        };
        AccordionDirective.prototype.getPaneRefByIndex = function (index) {
            return this.panes.toArray()[index];
        };
        // Except the pane provided close all other panes
        AccordionDirective.prototype.closePanesExcept = function (paneRef) {
            if (core$1.isNumber(paneRef)) {
                paneRef = this.getPaneRefByIndex(paneRef);
            }
            if (this.closeothers) {
                this.panes.forEach(function (pane) {
                    if (pane !== paneRef) {
                        pane.collapse();
                    }
                });
            }
        };
        AccordionDirective.prototype.expandPane = function (index) {
            this.closePanesExcept(index);
            this.panes.toArray()[index].expand();
        };
        AccordionDirective.prototype.onPropertyChange = function (key, nv, ov) {
            var _this = this;
            if (key === 'defaultpaneindex') {
                this.defaultpaneindex = nv;
            }
            else if (key === 'statehandler') {
                var widgetState = this.statePersistence.getWidgetState(this);
                var paneToSelect_1 = [];
                if (nv !== 'none' && _.isArray(widgetState)) {
                    widgetState.forEach(function (paneName) {
                        paneToSelect_1 = _this.panes.filter(function (pane) {
                            return paneName === pane.name;
                        });
                        if (!paneToSelect_1.length) {
                            console.warn('Accordion pane name ' + paneName + ' in State is incorrect.');
                        }
                        else {
                            _this.expandPane(_this.getPaneIndexByRef(paneToSelect_1[0]));
                        }
                    });
                }
                else {
                    if (this.isValidPaneIndex(this.defaultpaneindex)) {
                        this.expandPane(this.defaultpaneindex);
                    }
                }
            }
            else {
                _super.prototype.onPropertyChange.call(this, key, nv, ov);
            }
        };
        AccordionDirective.prototype.ngAfterContentInit = function () {
            _super.prototype.ngAfterContentInit.call(this);
            this.promiseResolverFn();
        };
        var AccordionDirective_1;
        AccordionDirective.initializeProps = registerProps();
        AccordionDirective.ctorParameters = function () { return [
            { type: core.Injector },
            { type: core$1.StatePersistence },
            { type: core$1.DynamicComponentRefProvider }
        ]; };
        __decorate([
            core.ContentChildren(AccordionPaneComponent),
            __metadata("design:type", core.QueryList)
        ], AccordionDirective.prototype, "panes", void 0);
        AccordionDirective = AccordionDirective_1 = __decorate([
            core.Directive({
                selector: 'div[wmAccordion]',
                providers: [
                    base.provideAsWidgetRef(AccordionDirective_1)
                ]
            }),
            __metadata("design:paramtypes", [core.Injector, core$1.StatePersistence, core$1.DynamicComponentRefProvider])
        ], AccordionDirective);
        return AccordionDirective;
    }(base.StylableComponent));

    var components = [
        AccordionPaneComponent,
        AccordionDirective
    ];
    var AccordionModule = /** @class */ (function () {
        function AccordionModule() {
        }
        AccordionModule = __decorate([
            core.NgModule({
                imports: [
                    common.CommonModule,
                    base.WmComponentsModule
                ],
                declarations: __spread(components),
                exports: __spread(components),
                entryComponents: []
            })
        ], AccordionModule);
        return AccordionModule;
    }());

    exports.AccordionModule = AccordionModule;
    exports.ɵa = AccordionPaneComponent;
    exports.ɵb = AccordionDirective;
    exports.ɵc = registerProps;
    exports.ɵd = registerProps$1;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=index.umd.js.map
