(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common'), require('ngx-bootstrap/dropdown'), require('@wm/components/base'), require('@wm/components/navigation/menu'), require('@wm/core')) :
    typeof define === 'function' && define.amd ? define('@wm/components/containers/panel', ['exports', '@angular/core', '@angular/common', 'ngx-bootstrap/dropdown', '@wm/components/base', '@wm/components/navigation/menu', '@wm/core'], factory) :
    (global = global || self, factory((global.wm = global.wm || {}, global.wm.components = global.wm.components || {}, global.wm.components.containers = global.wm.components.containers || {}, global.wm.components.containers.panel = {}), global.ng.core, global.ng.common, global['ngx-bootstrap'].dropdown, global.wm.components.base, global.wm.components.navigation.menu, global.wm.core));
}(this, (function (exports, core, common, dropdown, base, menu, core$1) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __rest(s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); }
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    function __createBinding(o, m, k, k2) {
        if (k2 === undefined) k2 = k;
        o[k2] = m[k];
    }

    function __exportStar(m, exports) {
        for (var p in m) if (p !== "default" && !exports.hasOwnProperty(p)) exports[p] = m[p];
    }

    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m) return m.call(o);
        if (o && typeof o.length === "number") return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }

    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    }

    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    };

    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }

    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
    }

    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }

    function __asyncValues(o) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
    }

    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
        return cooked;
    };

    function __importStar(mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
        result.default = mod;
        return result;
    }

    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }

    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }

    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    var registerProps = function () {
        base.register('wm-panel', new Map([
            ['actions', {}],
            ['animation', base.PROP_STRING],
            ['autoclose', base.PROP_STRING],
            ['badgetype', __assign({ value: 'default' }, base.PROP_STRING)],
            ['badgevalue', base.PROP_STRING],
            ['class', base.PROP_STRING],
            ['closable', base.PROP_BOOLEAN],
            ['collapsible', base.PROP_BOOLEAN],
            ['conditionalclass', base.PROP_ANY],
            ['conditionalstyle', base.PROP_ANY],
            ['content', base.PROP_STRING],
            ['datafield', base.PROP_STRING],
            ['enablefullscreen', base.PROP_BOOLEAN],
            ['expanded', __assign({ value: true }, base.PROP_BOOLEAN)],
            ['fullscreen', base.PROP_BOOLEAN],
            ['helptext', base.PROP_STRING],
            ['iconclass', base.PROP_STRING],
            ['iconheight', base.PROP_STRING],
            ['iconmargin', base.PROP_STRING],
            ['iconurl', base.PROP_STRING],
            ['iconwidth', base.PROP_STRING],
            ['itemaction', base.PROP_STRING],
            ['itemchildren', base.PROP_STRING],
            ['itemicon', base.PROP_STRING],
            ['itemlabel', base.PROP_STRING],
            ['itemlink', base.PROP_STRING],
            ['name', base.PROP_STRING],
            ['show', __assign({ value: true }, base.PROP_BOOLEAN)],
            ['subheading', base.PROP_STRING],
            ['title', base.PROP_STRING],
            ['userrole', base.PROP_STRING]
        ]));
    };

    var DEFAULT_CLS = 'app-panel panel';
    var WIDGET_CONFIG = { widgetType: 'wm-panel', hostClass: DEFAULT_CLS };
    var PanelComponent = /** @class */ (function (_super) {
        __extends(PanelComponent, _super);
        function PanelComponent(inj) {
            var _this = _super.call(this, inj, WIDGET_CONFIG) || this;
            _this.$lazyLoad = core$1.noop;
            _this.expanded = true;
            _this.helpClass = '';
            _this.helptext = '';
            base.styler(_this.nativeElement, _this, base.APPLY_STYLES_TYPE.SHELL);
            _this.fullScreenTitle = _this.appLocale.LABEL_FULLSCREEN + "/" + _this.appLocale.LABEL_EXITFULLSCREEN;
            _this.expandCollapseTitle = _this.appLocale.LABEL_COLLAPSE + "/" + _this.appLocale.LABEL_EXPAND;
            core$1.removeAttr(_this.nativeElement, 'title');
            return _this;
        }
        PanelComponent_1 = PanelComponent;
        Object.defineProperty(PanelComponent.prototype, "hideFooter", {
            // conditions to show the footer
            get: function () {
                return !this.hasFooter || !this.expanded;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PanelComponent.prototype, "showHeader", {
            // conditions to show header
            get: function () {
                return this.iconurl || this.iconclass || this.collapsible || this.actions || this.title || this.subheading || this.enablefullscreen;
            },
            enumerable: true,
            configurable: true
        });
        // toggle the panel state between collapsed - expanded. invoke the respective callbacks
        PanelComponent.prototype.toggle = function ($event) {
            if (this.collapsible) {
                this.invokeEventCallback(this.expanded ? 'collapse' : 'expand', { $event: $event });
                this.expanded = !this.expanded;
                if (this.expanded) {
                    this.$lazyLoad();
                    this.reDrawChildren();
                }
            }
        };
        PanelComponent.prototype.expand = function ($event) {
            if (!this.expanded) {
                this.toggle($event);
            }
        };
        PanelComponent.prototype.collapse = function ($event) {
            if (this.expanded) {
                this.toggle($event);
            }
        };
        // toggle the fullscreen state of the panel. invoke the respective callbacks
        PanelComponent.prototype.toggleFullScreen = function ($event) {
            if (this.enablefullscreen) {
                this.invokeEventCallback(this.fullscreen ? 'exitfullscreen' : 'fullscreen', { $event: $event });
                this.fullscreen = !this.fullscreen;
                core$1.toggleClass(this.nativeElement, 'fullscreen', this.fullscreen);
                // Re-plot the widgets inside panel
                this.reDrawChildren();
            }
            this.computeDimensions();
        };
        // show/hide help
        PanelComponent.prototype.toggleHelp = function () {
            this.helpClass = this.helpClass ? '' : 'show-help';
            core$1.toggleClass(this.nativeElement, 'show-help', !!this.helpClass);
            core$1.$appDigest();
        };
        // On action item click
        PanelComponent.prototype.menuActionItemClick = function ($event, $item) {
            this.selectedAction = _.omit($item, ['children', 'value']);
            this.invokeEventCallback('actionsclick', { $event: $event, $item: this.selectedAction });
        };
        // hide the panel and invoke the respective event handler
        PanelComponent.prototype.close = function ($event) {
            this.getWidget().show = false;
            this.invokeEventCallback('close', { $event: $event });
        };
        // calculation of dimensions when the panel the panel state changes from/to fullscreen
        PanelComponent.prototype.computeDimensions = function () {
            var headerHeight = this.panelHeader.nativeElement.offsetHeight;
            var footer = this.nativeElement.querySelector('.panel-footer');
            var content = this.panelContent.nativeElement;
            var vHeight = window.innerHeight;
            var inlineHeight;
            if (this.fullscreen) {
                inlineHeight = this.hideFooter ? (vHeight - headerHeight) : vHeight - (footer.offsetHeight + headerHeight);
            }
            else {
                inlineHeight = this.height || '';
            }
            core$1.setCSS(content, 'height', inlineHeight);
        };
        // notify the redrawable components(charts, grid)
        PanelComponent.prototype.reDrawChildren = function () {
            var _this = this;
            setTimeout(function () {
                if (_this.reDrawableComponents) {
                    _this.reDrawableComponents.forEach(function (c) { return c.redraw(); });
                }
            }, 100);
        };
        PanelComponent.prototype.onPropertyChange = function (key, nv, ov) {
            var _this = this;
            if (key === 'expanded') {
                this.expanded = nv;
            }
            else if (key === 'content') {
                setTimeout(function () {
                    if (_this.expanded || !_this.collapsible) {
                        _this.$lazyLoad();
                    }
                }, 20);
            }
            else {
                _super.prototype.onPropertyChange.call(this, key, nv, ov);
            }
        };
        PanelComponent.prototype.ngAfterContentInit = function () {
            _super.prototype.ngAfterContentInit.call(this);
            this.hasFooter = !!this.nativeElement.querySelector('[wmPanelFooter]');
            base.styler(this.panelBody.nativeElement, this, base.APPLY_STYLES_TYPE.INNER_SHELL);
        };
        var PanelComponent_1;
        PanelComponent.initializeProps = registerProps();
        PanelComponent.ctorParameters = function () { return [
            { type: core.Injector }
        ]; };
        __decorate([
            core.ViewChild('panelHeading', { static: false }),
            __metadata("design:type", core.ElementRef)
        ], PanelComponent.prototype, "panelHeader", void 0);
        __decorate([
            core.ViewChild('panelContent', { static: true }),
            __metadata("design:type", core.ElementRef)
        ], PanelComponent.prototype, "panelContent", void 0);
        __decorate([
            core.ViewChild('panelBody', { static: true }),
            __metadata("design:type", core.ElementRef)
        ], PanelComponent.prototype, "panelBody", void 0);
        __decorate([
            core.ContentChildren(base.RedrawableDirective, { descendants: true }),
            __metadata("design:type", Object)
        ], PanelComponent.prototype, "reDrawableComponents", void 0);
        PanelComponent = PanelComponent_1 = __decorate([
            core.Component({
                selector: '[wmPanel]',
                template: "<div class=\"panel-heading {{helpClass}}\" *ngIf=\"showHeader\" #panelHeading>\n    <h3 class=\"panel-title\">\n        <a href=\"javascript:void(0)\" class=\"panel-toggle\" (click)=\"toggle($event)\">\n            <div class=\"pull-left\">\n                <i class=\"app-icon panel-icon {{iconclass}}\" *ngIf=\"iconclass && !iconurl\"></i>\n                <img data-identifier=\"img\" title=\"iconurl\" alt=\"Panel icon\" class=\"panel-image-icon\"\n                     [src]=\"iconurl | image\" *ngIf=\"iconurl\"\n                     [ngStyle]=\"{width: iconwidth ,height: iconheight, margin: iconmargin}\" />\n            </div>\n            <div class=\"pull-left\">\n                <div class=\"heading\" [innerHTML]=\"title | trustAs: 'html'\" [title]=\"title\"></div>\n                <div class=\"description\" [innerHTML]=\"subheading | trustAs: 'html'\"></div>\n            </div>\n        </a>\n        <div class=\"panel-actions\">\n            <span *ngIf=\"badgevalue\" aria-label=\"badge\"\n                  class=\"app-badge label label-{{badgetype}}\">{{badgevalue}}</span>\n            <div wmMenu aria-label=\"dropdown\" dropdown type=\"anchor\" class=\"panel-action\" dataset.bind=\"actions\"\n                 *ngIf=\"actions\" caption=\"\" menuposition=\"down,left\" iconclass=\"wi wi-more-vert\"\n                 autoclose.bind=\"autoclose\" datafield.bind=\"datafield\" select.event=\"menuActionItemClick($event,$item)\">\n            </div>\n            <button type=\"button\" aria-label=\"Help\" class=\"app-icon panel-action wi\" [title]=\"appLocale.LABEL_HELP\"\n                    *ngIf=\"helptext\" (click)=\"toggleHelp()\"><i class=\"wi-question\"></i></button>\n            <button type=\"button\" aria-label=\"Collapse/Expand\" class=\"app-icon wi panel-action\" *ngIf=\"collapsible\"\n                    [title]=\"expandCollapseTitle\" (click)=\"toggle($event);\"><i\n                   [ngClass]=\"expanded ? 'wi-minus' : 'wi-plus'\"></i></button>\n            <button type=\"button\" aria-label=\"Fullscreen/Exit\" class=\"app-icon panel-action wi\" *ngIf=\"enablefullscreen\"\n                    [title]=\"fullScreenTitle\" (click)=\"toggleFullScreen($event);\"><i\n                   [ngClass]=\"fullscreen ? 'wi-fullscreen-exit' : 'wi-fullscreen'\"></i></button>\n            <button type=\"button\" aria-label=\"Close button\" class=\"app-icon panel-action\"\n                    title=\"{{appLocale.LABEL_CLOSE}}\" *ngIf=\"closable\" (click)=\"close($event)\"><i\n                   class=\"wi wi-close\"></i></button>\n        </div>\n    </h3>\n</div>\n<div class=\"panel-content\" [hidden]=\"!expanded\" #panelContent>\n    <!-- Todo Bandhavya - implement smooth scroll -->\n    <div partial-container-target #panelBody [ngClass]=\"['panel-body', helpClass]\">\n        <ng-content></ng-content>\n    </div>\n    <aside class=\"panel-help-message\" [ngClass]=\"helpClass\">\n        <h5 class=\"panel-help-header\" [textContent]=\"appLocale.LABEL_HELP\"></h5>\n        <div class=\"panel-help-content\" [innerHTML]=\"helptext | trustAs : 'html'\"></div>\n    </aside>\n</div>\n<div class=\"app-panel-footer panel-footer clearfix\" [hidden]=\"hideFooter\">\n    <ng-content select=\"[wmPanelFooter]\"></ng-content>\n</div>",
                providers: [
                    base.provideAsWidgetRef(PanelComponent_1)
                ]
            }),
            __metadata("design:paramtypes", [core.Injector])
        ], PanelComponent);
        return PanelComponent;
    }(menu.MenuAdapterComponent));

    var components = [
        PanelComponent
    ];
    var PanelModule = /** @class */ (function () {
        function PanelModule() {
        }
        PanelModule = __decorate([
            core.NgModule({
                imports: [
                    dropdown.BsDropdownModule,
                    common.CommonModule,
                    menu.MenuModule,
                    base.WmComponentsModule
                ],
                declarations: __spread(components),
                exports: __spread(components),
                entryComponents: []
            })
        ], PanelModule);
        return PanelModule;
    }());

    exports.PanelModule = PanelModule;
    exports.ɵa = PanelComponent;
    exports.ɵb = registerProps;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=index.umd.js.map
