(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common'), require('@wm/components/base'), require('@wm/core'), require('@swipey')) :
    typeof define === 'function' && define.amd ? define('@wm/components/containers/tabs', ['exports', '@angular/core', '@angular/common', '@wm/components/base', '@wm/core', '@swipey'], factory) :
    (global = global || self, factory((global.wm = global.wm || {}, global.wm.components = global.wm.components || {}, global.wm.components.containers = global.wm.components.containers || {}, global.wm.components.containers.tabs = {}), global.ng.core, global.ng.common, global.wm.components.base, global.wm.core, global.swipey));
}(this, (function (exports, core, common, base, core$1, _swipey) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __rest(s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); }
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    function __createBinding(o, m, k, k2) {
        if (k2 === undefined) k2 = k;
        o[k2] = m[k];
    }

    function __exportStar(m, exports) {
        for (var p in m) if (p !== "default" && !exports.hasOwnProperty(p)) exports[p] = m[p];
    }

    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m) return m.call(o);
        if (o && typeof o.length === "number") return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }

    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    }

    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    };

    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }

    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
    }

    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }

    function __asyncValues(o) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
    }

    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
        return cooked;
    };

    function __importStar(mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
        result.default = mod;
        return result;
    }

    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }

    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }

    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    var TabsAnimator = /** @class */ (function (_super) {
        __extends(TabsAnimator, _super);
        function TabsAnimator(tabs) {
            var e_1, _a;
            var _this = _super.call(this) || this;
            _this.tabs = tabs;
            _this._$el = $(_this.tabs.getNativeElement()).find('>.tab-content');
            var childEls = _this._$el.find('>[wmTabPane]');
            _this._noOfTabs = childEls.length;
            var maxWidth = _this._noOfTabs * 100 + "%";
            core$1.addClass(_this.tabs.getNativeElement(), 'has-transition');
            core$1.setCSSFromObj(_this._$el[0], { maxWidth: maxWidth, width: maxWidth });
            var width = 100 / _this._noOfTabs + "%";
            try {
                for (var _b = __values(Array.from(childEls)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var child = _c.value;
                    core$1.setCSS(child, 'width', width);
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                }
                finally { if (e_1) throw e_1.error; }
            }
            _this.init(_this._$el);
            return _this;
        }
        TabsAnimator.prototype.bounds = function () {
            var activeTabIndex = this.tabs.getActiveTabIndex(), w = this._$el.find('>.tab-pane').first().width(), noOfTabs = this._$el.find('>.tab-pane:visible').length, centerVal = -1 * activeTabIndex * w;
            this.clearContentFocus();
            return {
                strict: false,
                lower: activeTabIndex === noOfTabs - 1 ? 0 : -w,
                center: centerVal,
                upper: activeTabIndex === 0 ? centerVal : w
            };
        };
        TabsAnimator.prototype.context = function () {
            return {
                'w': this._$el.width()
            };
        };
        TabsAnimator.prototype.animation = function () {
            return {
                'transform': 'translate3d(${{ ($D + $d)/w * 100 + \'%\'}}, 0, 0)',
                '-webkit-transform': 'translate3d(${{ ($D + $d)/w * 100 + \'%\'}}, 0, 0)'
            };
        };
        /* WMS-18031 | On Tab Switch | Remove the Focus on the Existing Tab Contents */
        TabsAnimator.prototype.clearContentFocus = function () {
            var activeTab = this._$el.find('>.tab-pane.active');
            if (activeTab.length && activeTab.find(document.activeElement).length) {
                document.activeElement.blur();
            }
        };
        TabsAnimator.prototype.transitionTabIntoView = function () {
            var activeTabIndex = this.tabs.getActiveTabIndex();
            core$1.setCSS(this._$el[0], 'transform', "translate3d(" + -1 * activeTabIndex / this._noOfTabs * 100 + "%, 0, 0)");
        };
        TabsAnimator.prototype.onUpper = function () {
            this.tabs.prev();
            core$1.$appDigest();
        };
        TabsAnimator.prototype.onLower = function () {
            this.tabs.next();
            core$1.$appDigest();
        };
        TabsAnimator.prototype.threshold = function () {
            return 5;
        };
        return TabsAnimator;
    }(_swipey.SwipeAnimation));

    var registerProps = function () {
        var props = new Map([
            ['class', base.PROP_STRING],
            ['defaultpaneindex', __assign({ value: 0 }, base.PROP_NUMBER)],
            ['justified', base.PROP_BOOLEAN],
            ['tabsposition', __assign({ value: 'top' }, base.PROP_STRING)],
            ['name', base.PROP_STRING],
            ['show', __assign({ value: true }, base.PROP_BOOLEAN)],
            ['statehandler', __assign({ value: 'none' }, base.PROP_STRING)],
            ['transition', base.PROP_STRING]
        ]);
        if (core$1.isMobileApp()) {
            props.set('transition', __assign({ value: 'slide' }, base.PROP_STRING));
        }
        base.register('wm-tabs', props);
    };

    var registerProps$1 = function () {
        base.register('wm-tabpane', new Map([
            ['active', base.PROP_BOOLEAN],
            ['badgevalue', base.PROP_STRING],
            ['badgetype', __assign({ value: 'default' }, base.PROP_STRING)],
            ['class', base.PROP_STRING],
            ['content', base.PROP_STRING],
            ['disabled', base.PROP_BOOLEAN],
            ['dynamicPaneIndex', base.PROP_NUMBER],
            ['heading', base.PROP_STRING],
            ['isdefaulttab', base.PROP_STRING],
            ['isdynamic', base.PROP_BOOLEAN],
            ['name', base.PROP_STRING],
            ['paneicon', base.PROP_STRING],
            ['show', __assign({ value: true }, base.PROP_BOOLEAN)],
            ['smoothscroll', __assign({ value: true }, base.PROP_BOOLEAN)],
            ['tabindex', __assign({ value: 0 }, base.PROP_NUMBER)],
            ['title', __assign({ value: 'Tab Title' }, base.PROP_STRING)]
        ]));
    };

    var DEFAULT_CLS = 'tab-pane';
    var WIDGET_CONFIG = {
        widgetType: 'wm-tabpane',
        hostClass: DEFAULT_CLS
    };
    var TabPaneComponent = /** @class */ (function (_super) {
        __extends(TabPaneComponent, _super);
        function TabPaneComponent(inj, tabsRef, heading, title) {
            var _this = _super.call(this, inj, WIDGET_CONFIG) || this;
            _this.tabsRef = tabsRef;
            _this.heading = heading;
            _this.title = title;
            _this._isFirstLoad = true;
            _this.$lazyLoad = core$1.noop;
            _this.isActive = false;
            _this.disabled = false;
            // title property here serves the purpose of heading.
            // TODO: make it common for all the widget.
            core$1.removeAttr(_this.nativeElement, 'title');
            return _this;
        }
        TabPaneComponent_1 = TabPaneComponent;
        // parent tabs component will call this method for the order of callbacks to be proper
        // order of callbacks - deselect, select, change
        TabPaneComponent.prototype.invokeOnSelectCallback = function ($event) {
            this.invokeEventCallback('select', { $event: $event });
        };
        TabPaneComponent.prototype.select = function ($event) {
            // When called programatically $event won't be available
            if (this.isActive || this.disabled) {
                return;
            }
            this.isActive = true;
            this.$lazyLoad();
            this.redrawChildren();
            this.notifyParent($event);
        };
        TabPaneComponent.prototype.deselect = function () {
            if (this.isActive) {
                this.isActive = false;
                this.invokeEventCallback('deselect');
            }
        };
        TabPaneComponent.prototype.remove = function () {
            if (this.isActive) {
                this === this.tabsRef.panes.last ? this.tabsRef.prev() : this.tabsRef.next();
            }
            var availablePanes = this.tabsRef.panes.toArray();
            availablePanes.splice(this.tabsRef.getPaneIndexByRef(this), 1);
            this.tabsRef.panes.reset(__spread(availablePanes));
            this.nativeElement.remove();
            this.tabsRef.$element.find(".tab-header[data-paneid='" + this.$element.attr('widget-id') + "'] a").remove();
        };
        TabPaneComponent.prototype.redrawChildren = function () {
            var _this = this;
            setTimeout(function () {
                if (_this.reDrawableComponents) {
                    _this.reDrawableComponents.forEach(function (c) { return c.redraw(); });
                }
            }, 100);
        };
        TabPaneComponent.prototype.notifyParent = function (evt) {
            this.tabsRef.notifyChange(this, evt);
        };
        // select next valid tab
        TabPaneComponent.prototype.handleSwipeLeft = function () {
            this.tabsRef.next();
        };
        // select prev valid tab
        TabPaneComponent.prototype.handleSwipeRight = function () {
            this.tabsRef.prev();
        };
        // select event is called manually
        TabPaneComponent.prototype.handleEvent = function (node, eventName, callback, locals) {
            if (eventName !== 'select') {
                _super.prototype.handleEvent.call(this, this.nativeElement, eventName, callback, locals);
            }
        };
        TabPaneComponent.prototype.onPropertyChange = function (key, nv, ov) {
            var _this = this;
            if (key === 'content') {
                if (this.isActive) {
                    setTimeout(function () { return _this.$lazyLoad(); }, 100);
                }
            }
            else if (key === 'show') {
                // overridding the base component show propertyChangeHandler
                this.nativeElement.hidden = !nv;
                // setting default tab pane on pageload whenever show property is bindable
                if (this._isFirstLoad) {
                    this.tabsRef.selectDefaultPaneByIndex(this.tabsRef.defaultpaneindex);
                }
                this._isFirstLoad = false;
            }
            else {
                _super.prototype.onPropertyChange.call(this, key, nv, ov);
            }
        };
        TabPaneComponent.prototype.ngOnInit = function () {
            _super.prototype.ngOnInit.call(this);
            this.title = this.title || this.heading;
        };
        TabPaneComponent.prototype.ngAfterViewInit = function () {
            base.styler(this.nativeElement.querySelector('.tab-body'), this, base.APPLY_STYLES_TYPE.CONTAINER);
            _super.prototype.ngAfterViewInit.call(this);
            if (this.isdynamic) {
                this.tabsRef.registerDynamicTab(this);
            }
        };
        var TabPaneComponent_1;
        TabPaneComponent.initializeProps = registerProps$1();
        TabPaneComponent.ctorParameters = function () { return [
            { type: core.Injector },
            { type: TabsComponent },
            { type: undefined, decorators: [{ type: core.Attribute, args: ['heading',] }] },
            { type: undefined, decorators: [{ type: core.Attribute, args: ['title',] }] }
        ]; };
        __decorate([
            core.HostBinding('class.active'),
            __metadata("design:type", Object)
        ], TabPaneComponent.prototype, "isActive", void 0);
        __decorate([
            core.HostBinding('class.disabled'),
            __metadata("design:type", Object)
        ], TabPaneComponent.prototype, "disabled", void 0);
        __decorate([
            core.ContentChildren(base.RedrawableDirective, { descendants: true }),
            __metadata("design:type", Object)
        ], TabPaneComponent.prototype, "reDrawableComponents", void 0);
        TabPaneComponent = TabPaneComponent_1 = __decorate([
            core.Component({
                selector: 'div[wmTabPane]',
                template: "<div class=\"tab-body\" partial-container-target [wmSmoothscroll]=\"smoothscroll\">\n    <ng-content></ng-content>\n</div>",
                providers: [
                    base.provideAsWidgetRef(TabPaneComponent_1)
                ]
            }),
            __param(2, core.Attribute('heading')),
            __param(3, core.Attribute('title')),
            __metadata("design:paramtypes", [core.Injector,
                TabsComponent, Object, Object])
        ], TabPaneComponent);
        return TabPaneComponent;
    }(base.StylableComponent));

    var DEFAULT_CLS$1 = 'app-tabs clearfix';
    var WIDGET_CONFIG$1 = {
        widgetType: 'wm-tabs',
        hostClass: DEFAULT_CLS$1
    };
    var TabsComponent = /** @class */ (function (_super) {
        __extends(TabsComponent, _super);
        function TabsComponent(inj, dynamicComponentProvider, _transition, _tabsPosition, statePersistence) {
            var _this = this;
            // handle to the promise resolver
            var resolveFn = core$1.noop;
            _this = _super.call(this, inj, WIDGET_CONFIG$1, new Promise(function (res) { return resolveFn = res; })) || this;
            _this.transition = _transition;
            _this.tabsposition = _tabsPosition;
            _this.statePersistence = statePersistence;
            _this.dynamicComponentProvider = dynamicComponentProvider;
            _this.dynamicTabs = [];
            _this.dynamicPaneIndex = 0;
            _this.promiseResolverFn = resolveFn;
            base.styler(_this.nativeElement, _this, base.APPLY_STYLES_TYPE.CONTAINER);
            return _this;
        }
        TabsComponent_1 = TabsComponent;
        TabsComponent.prototype.animateIn = function (element) {
            var tabHeader = $(element);
            // when the animation is not present toggle the active class.
            tabHeader.siblings('.active').removeClass('active');
            tabHeader.addClass('active');
            var ul = this.nativeElement.querySelector('ul.nav.nav-tabs');
            // move the tabheader into the viewport
            var $prevHeaderEle = tabHeader.prev();
            if ($prevHeaderEle.length) {
                ul.scrollLeft = $prevHeaderEle[0].offsetLeft;
            }
            else {
                ul.scrollLeft = 0;
            }
        };
        /**
         * This method is used to register the dynamic panes.
         * After all panes are initialzed, update the querylist manually based on index.
         * @param paneRef - refrence of the tabpane
         */
        TabsComponent.prototype.registerDynamicTab = function (paneRef) {
            this.dynamicTabs.push(paneRef);
            var isLastPane = this.dynamicTabs.length === this.dynamicPaneIndex;
            if (isLastPane) {
                var _loop_1 = function (i) {
                    var newPaneRef = _.find(this_1.dynamicTabs, function (pane) { return pane.dynamicPaneIndex === i; });
                    var isPaneAlreadyExist = _.find(this_1.panes.toArray(), newPaneRef);
                    if (!isPaneAlreadyExist) {
                        this_1.panes.reset(__spread(this_1.panes.toArray(), [newPaneRef]));
                        if (newPaneRef.active) {
                            setTimeout(function () {
                                newPaneRef.select();
                            }, 20);
                        }
                    }
                };
                var this_1 = this;
                for (var i = 0; i < this.dynamicTabs.length; i++) {
                    _loop_1(i);
                }
            }
        };
        /**
         * This method is to add the tabpane dynamically
         * @param tabpanes - list of tabpanes
         */
        TabsComponent.prototype.addPane = function (tabpanes) {
            var _this = this;
            if (!_.isArray(tabpanes)) {
                tabpanes = [tabpanes];
            }
            var paneNamesList = [];
            _.forEach(tabpanes, function (pane, index) {
                var isPaneAlreadyCreated = _.find(_this.panes.toArray(), { name: pane.name });
                var isPaneNameExist = _.indexOf(paneNamesList, pane.name);
                // If user tries to add tabpane with the same name which is already exists then do not create the pane
                if (isPaneAlreadyCreated || isPaneNameExist > 0) {
                    console.warn("The tab pane with name " + pane.name + " already exists");
                    return;
                }
                var paramMarkup = '';
                var propsTmpl = '';
                _this.dynamicPaneIndex++;
                var name = pane.name ? pane.name : "tabpane" + (_this.panes.toArray().length + (index + 1));
                paneNamesList.push(name);
                var partialParams = _.get(pane, 'params');
                _.forEach(pane, function (value, key) {
                    if (key !== 'params') {
                        propsTmpl = propsTmpl + " " + key + "=\"" + value + "\"";
                    }
                });
                _.forEach(partialParams, function (value, key) {
                    paramMarkup = paramMarkup + " <wm-param name=\"" + key + "\" value=\"" + value + "\"></wm-param>";
                });
                var markup = "<wm-tabpane dynamicPaneIndex=\"" + (_this.dynamicPaneIndex - 1) + "\" isdynamic=\"true\" name=\"" + name + "\" " + propsTmpl + ">\n                            " + paramMarkup + "\n                        </wm-tabpane>";
                if (!_this._dynamicContext) {
                    _this._dynamicContext = Object.create(_this.viewParent);
                    _this._dynamicContext[_this.getAttr('wmTab')] = _this;
                }
                _this.dynamicComponentProvider.addComponent(_this.getNativeElement().querySelector('.tab-content'), markup, _this._dynamicContext, { inj: _this.inj });
            });
            return paneNamesList;
        };
        /**
         * This method is to remove the tabpane
         * @param paneIndex - index of the pane
         */
        TabsComponent.prototype.removePane = function (paneName) {
            var paneRef = this.getPaneRefByName(paneName);
            if (paneRef) {
                paneRef.remove();
            }
        };
        /**
         * TabPane children components invoke this method to communicate with the parent
         * if the evt argument is defined on-change callback will be invoked.
         */
        TabsComponent.prototype.notifyChange = function (paneRef, evt) {
            if (!this.isSelectableTab(paneRef)) {
                return;
            }
            var headerElement;
            // invoke deselect event callback on the preset active tab
            if (this.activeTab) {
                this.activeTab.deselect();
            }
            // invoke select callback on the selected tab
            paneRef.invokeOnSelectCallback(evt);
            this.activeTab = paneRef.getWidget();
            var newPaneIndex = this.getPaneIndexByRef(paneRef);
            var mode = this.statePersistence.computeMode(this.statehandler);
            if (!this.isPageLoadCall && mode && mode.toLowerCase() !== 'none') {
                this.statePersistence.setWidgetState(this, this.activeTab.name);
            }
            else {
                this.defaultpaneindex = this.getPaneIndexByRef(paneRef);
                this.isPageLoadCall = false;
            }
            // invoke change callback if the evt is present, select a tab programmatically will not have the event
            if (evt) {
                this.invokeEventCallback('change', {
                    $event: evt,
                    newPaneIndex: newPaneIndex,
                    oldPaneIndex: this._oldPaneIndex || 0
                });
            }
            this._oldPaneIndex = newPaneIndex;
            if (evt) {
                headerElement = $(evt.target).closest('li.tab-header');
            }
            else {
                headerElement = this.nativeElement.querySelector("li[data-paneid=" + paneRef.widgetId + "]");
            }
            this.animateIn(headerElement);
            // this.setTabsLeftPosition(this.getPaneIndexByRef(this.activeTab), this.panes.length);
            if (this.canSlide()) {
                if (!this.tabsAnimator) {
                    this.tabsAnimator = new TabsAnimator(this);
                    this.tabsAnimator.setGesturesEnabled(this.canSlide());
                }
                this.tabsAnimator.transitionTabIntoView();
            }
        };
        TabsComponent.prototype.goToTab = function (tabIndex) {
            if (this.isValidPaneIndex(tabIndex - 1)) {
                var tab = this.getPaneRefByIndex(tabIndex - 1);
                tab.select();
            }
        };
        TabsComponent.prototype.getPaneIndexByRef = function (paneRef) {
            return this.panes.toArray().indexOf(paneRef);
        };
        // Returns the active tab index from tabs.
        TabsComponent.prototype.getActiveTabIndex = function () {
            return _.findIndex(this.panes.toArray(), { isActive: true });
        };
        TabsComponent.prototype.isValidPaneIndex = function (index) {
            return (index >= 0 && index < this.panes.length);
        };
        TabsComponent.prototype.getPaneRefByIndex = function (index) {
            return this.panes.toArray()[index];
        };
        TabsComponent.prototype.getPaneRefByName = function (name) {
            return _.find(this.panes.toArray(), { name: name });
        };
        // returns false if the pane is hidden or disabled
        TabsComponent.prototype.isSelectableTab = function (paneRef) {
            return paneRef.show && !paneRef.disabled;
        };
        TabsComponent.prototype.canSlide = function () {
            return this.transition === 'slide' && !this.vertical;
        };
        TabsComponent.prototype.getSelectableTabAfterIndex = function (index) {
            for (var i = index + 1; i < this.panes.length; i++) {
                var pane = this.getPaneRefByIndex(i);
                if (this.isSelectableTab(pane)) {
                    return pane;
                }
            }
        };
        TabsComponent.prototype.getSelectableTabBeforeIndex = function (index) {
            for (var i = index - 1; i >= 0; i--) {
                var pane = this.getPaneRefByIndex(i);
                if (this.isSelectableTab(pane)) {
                    return pane;
                }
            }
        };
        // select next tab relative to the current active tab
        TabsComponent.prototype.next = function () {
            var pane = this.getSelectableTabAfterIndex(this.getActiveTabIndex());
            if (pane) {
                pane.select();
            }
        };
        // select prev tab relative to the current active tab
        TabsComponent.prototype.prev = function () {
            var pane = this.getSelectableTabBeforeIndex(this.getActiveTabIndex());
            if (pane) {
                pane.select();
            }
        };
        /**
         * this method will be invoked during the initialization of the component and on defaultpaneindex property change,
         * if the provided defaultpaneindex is not valid, find the first pane index which can be shown and select it
         */
        TabsComponent.prototype.selectDefaultPaneByIndex = function (index) {
            if (!this.isValidPaneIndex(index)) {
                return;
            }
            var paneRef = this.getPaneRefByIndex(index);
            if (!this.isSelectableTab(paneRef)) {
                paneRef = this.getSelectableTabAfterIndex(0);
            }
            if (paneRef) {
                paneRef.select();
            }
        };
        // update the postion of tab header
        TabsComponent.prototype.setTabsPosition = function () {
            var ul = this.nativeElement.children[0];
            this.vertical = (this.tabsposition === 'left' || this.tabsposition === 'right');
            core$1.removeClass(this.nativeElement, 'inverted');
            if (this.tabsposition === 'bottom' || this.tabsposition === 'right') {
                core$1.appendNode(ul, this.nativeElement);
                core$1.addClass(this.nativeElement, 'inverted');
            }
        };
        TabsComponent.prototype.onPropertyChange = function (key, nv, ov) {
            var _this = this;
            if (key === 'defaultpaneindex') {
                this.defaultpaneindex = nv;
            }
            else if (key === 'statehandler') {
                this.isPageLoadCall = true;
                var widgetState_1 = this.statePersistence.getWidgetState(this);
                if (nv !== 'none' && widgetState_1) {
                    var paneToSelect = this.panes.filter(function (pane) {
                        return widgetState_1 === pane.name;
                    });
                    if (!paneToSelect.length) {
                        console.warn('Tab pane name ' + widgetState_1 + ' in State is incorrect. Falling back to the default pane');
                        setTimeout(function () { return _this.selectDefaultPaneByIndex(_this.defaultpaneindex || 0); }, 20);
                    }
                    else {
                        var index_1 = this.getPaneIndexByRef(paneToSelect[0]);
                        setTimeout(function () { return _this.selectDefaultPaneByIndex(index_1); }, 20);
                    }
                }
                else {
                    setTimeout(function () { return _this.selectDefaultPaneByIndex(_this.defaultpaneindex || 0); }, 20);
                }
            }
            else {
                _super.prototype.onPropertyChange.call(this, key, nv, ov);
            }
        };
        TabsComponent.prototype.registerTabsScroll = function () {
            var _this = this;
            setTimeout(function () {
                var $ul = _this.$element.find('> ul');
                var $liPosition;
                var $li = $ul.children();
                $liPosition = $li.last().position();
                if ($liPosition && ($liPosition.left > $ul.width())) {
                    $ul.on('mousewheel', function (e) {
                        var left = $ul[0].scrollLeft, _delta = -1 * e.originalEvent.wheelDelta;
                        e.stopPropagation();
                        e.preventDefault();
                        $ul.animate({ scrollLeft: left + _delta }, { 'duration': 10 });
                    });
                }
            });
        };
        TabsComponent.prototype.ngAfterContentInit = function () {
            this.promiseResolverFn();
            _super.prototype.ngAfterContentInit.call(this);
            this.setTabsPosition();
        };
        TabsComponent.prototype.ngAfterViewInit = function () {
            _super.prototype.ngAfterViewInit.call(this);
            this.registerTabsScroll();
        };
        var TabsComponent_1;
        TabsComponent.initializeProps = registerProps();
        TabsComponent.ctorParameters = function () { return [
            { type: core.Injector },
            { type: core$1.DynamicComponentRefProvider },
            { type: String, decorators: [{ type: core.Attribute, args: ['transition',] }] },
            { type: String, decorators: [{ type: core.Attribute, args: ['tabsposition',] }] },
            { type: core$1.StatePersistence }
        ]; };
        __decorate([
            core.ContentChildren(TabPaneComponent),
            __metadata("design:type", core.QueryList)
        ], TabsComponent.prototype, "panes", void 0);
        TabsComponent = TabsComponent_1 = __decorate([
            core.Component({
                selector: 'div[wmTabs]',
                template: "<ul class=\"nav nav-tabs\" [ngClass]=\"{'nav-stacked': vertical, 'nav-justified': justified}\" role=\"tablist\">\n    <li class=\"tab-header\" *ngFor=\"let pane of panes;\" [attr.data-paneid]=\"pane.widgetId\" [ngClass]=\"{'active': pane.isActive, 'disabled': pane.disabled}\"\n        [hidden]=\"!pane.show\" (click)=\"pane.select($event)\" role=\"tab\">\n        <a href=\"javascript:void(0);\" role=\"button\" [attr.aria-label]=\"pane.title\" [attr.title]=\"pane.title\" [tabindex]=\"pane.tabindex\">\n            <div class=\"tab-heading\">\n                <i [ngClass]=\"['app-icon', pane.paneicon]\" *ngIf=\"pane.paneicon\"></i>\n                <span [textContent]=\"pane.title\"></span>\n                <span *ngIf=\"pane.badgevalue\" class=\"label label-{{pane.badgetype}}\" [textContent]=\"pane.badgevalue\"></span>\n            </div>\n        </a>\n    </li>\n</ul>\n<div class=\"tab-content\" [ngClass]=\"{'tab-stacked': vertical, 'tab-justified': justified}\">\n    <ng-content select=\"div[wmTabPane]\"></ng-content>\n</div>\n",
                providers: [
                    base.provideAsWidgetRef(TabsComponent_1)
                ]
            }),
            __param(2, core.Attribute('transition')),
            __param(3, core.Attribute('tabsposition')),
            __metadata("design:paramtypes", [core.Injector,
                core$1.DynamicComponentRefProvider, String, String, core$1.StatePersistence])
        ], TabsComponent);
        return TabsComponent;
    }(base.StylableComponent));

    var components = [
        TabPaneComponent,
        TabsComponent
    ];
    var TabsModule = /** @class */ (function () {
        function TabsModule() {
        }
        TabsModule = __decorate([
            core.NgModule({
                imports: [
                    common.CommonModule,
                    base.WmComponentsModule
                ],
                declarations: __spread(components),
                exports: __spread(components),
                entryComponents: []
            })
        ], TabsModule);
        return TabsModule;
    }());

    exports.TabsModule = TabsModule;
    exports.ɵa = TabPaneComponent;
    exports.ɵb = TabsComponent;
    exports.ɵc = registerProps;
    exports.ɵd = registerProps$1;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=index.umd.js.map
