(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common'), require('@wm/components/base'), require('@wm/core'), require('@angular/forms')) :
    typeof define === 'function' && define.amd ? define('@wm/components/containers/wizard', ['exports', '@angular/core', '@angular/common', '@wm/components/base', '@wm/core', '@angular/forms'], factory) :
    (global = global || self, factory((global.wm = global.wm || {}, global.wm.components = global.wm.components || {}, global.wm.components.containers = global.wm.components.containers || {}, global.wm.components.containers.wizard = {}), global.ng.core, global.ng.common, global.wm.components.base, global.wm.core, global.ng.forms));
}(this, (function (exports, core, common, base, core$1, forms) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __rest(s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); }
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    function __createBinding(o, m, k, k2) {
        if (k2 === undefined) k2 = k;
        o[k2] = m[k];
    }

    function __exportStar(m, exports) {
        for (var p in m) if (p !== "default" && !exports.hasOwnProperty(p)) exports[p] = m[p];
    }

    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m) return m.call(o);
        if (o && typeof o.length === "number") return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }

    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    }

    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    };

    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }

    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
    }

    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }

    function __asyncValues(o) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
    }

    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
        return cooked;
    };

    function __importStar(mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
        result.default = mod;
        return result;
    }

    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }

    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }

    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    var registerProps = function () {
        base.register('wm-wizard', new Map([
            ['actionsalignment', __assign({ value: 'right' }, base.PROP_STRING)],
            ['cancelable', __assign({ value: true }, base.PROP_BOOLEAN)],
            ['cancelbtnlabel', __assign({ value: 'Cancel' }, base.PROP_STRING)],
            ['class', __assign({ value: 'classic' }, base.PROP_STRING)],
            ['defaultstep', __assign({ value: 'none' }, base.PROP_STRING)],
            ['donebtnlabel', __assign({ value: 'Done' }, base.PROP_STRING)],
            ['name', base.PROP_STRING],
            ['nextbtnlabel', __assign({ value: 'Next' }, base.PROP_STRING)],
            ['previousbtnlabel', __assign({ value: 'Previous' }, base.PROP_STRING)],
            ['show', __assign({ value: true }, base.PROP_BOOLEAN)],
            ['stepstyle', __assign({ value: 'auto' }, base.PROP_STRING)]
        ]));
    };

    var registerProps$1 = function () {
        base.register('wm-wizardstep', new Map([
            ['class', base.PROP_STRING],
            ['enableskip', __assign({ value: false }, base.PROP_BOOLEAN)],
            ['iconclass', __assign({ value: 'wi wi-done' }, base.PROP_STRING)],
            ['name', base.PROP_STRING],
            ['show', __assign({ value: true }, base.PROP_BOOLEAN)],
            ['title', __assign({ value: 'Step Title' }, base.PROP_STRING)]
        ]));
    };

    var DEFAULT_CLS = 'app-wizard-step-content';
    var WIDGET_CONFIG = {
        widgetType: 'wm-wizardstep',
        hostClass: DEFAULT_CLS,
    };
    var WizardStepDirective = /** @class */ (function (_super) {
        __extends(WizardStepDirective, _super);
        function WizardStepDirective(inj, ngForm) {
            var _this = _super.call(this, inj, WIDGET_CONFIG) || this;
            _this.ngForm = ngForm;
            _this.isDone = false;
            _this.status = 2 /* DISABLED */;
            // If we inject directly as a param in the constructor, getting circular dependency error in unit testcases
            _this.wizardComponent = _this.inj.get(WizardComponent);
            return _this;
        }
        WizardStepDirective_1 = WizardStepDirective;
        Object.defineProperty(WizardStepDirective.prototype, "isCurrent", {
            get: function () {
                return this.active;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(WizardStepDirective.prototype, "isValid", {
            /**
             * along with the wizard form , also validate the forms
             * if there are any inside the wizard
             * @returns {boolean}
             */
            get: function () {
                return this.ngForm.valid && this.areEmbeddedFormsValid();
            },
            enumerable: true,
            configurable: true
        });
        /**
         * get all the forms inside the wizard if any and validate
         * @returns {boolean}
         */
        WizardStepDirective.prototype.areEmbeddedFormsValid = function () {
            var e_1, _a;
            var embeddedForms = this.getAllEmbeddedForms();
            try {
                for (var embeddedForms_1 = __values(embeddedForms), embeddedForms_1_1 = embeddedForms_1.next(); !embeddedForms_1_1.done; embeddedForms_1_1 = embeddedForms_1.next()) {
                    var form = embeddedForms_1_1.value;
                    if (form.widget && !form.widget.ngform.valid) {
                        return false;
                    }
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (embeddedForms_1_1 && !embeddedForms_1_1.done && (_a = embeddedForms_1.return)) _a.call(embeddedForms_1);
                }
                finally { if (e_1) throw e_1.error; }
            }
            return true;
        };
        WizardStepDirective.prototype.getAllEmbeddedForms = function () {
            return this.$element.find('form');
        };
        Object.defineProperty(WizardStepDirective.prototype, "enableNext", {
            get: function () {
                return !this.disablenext;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(WizardStepDirective.prototype, "enableDone", {
            get: function () {
                return !this.disabledone;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(WizardStepDirective.prototype, "enablePrev", {
            get: function () {
                return !this.disableprevious;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(WizardStepDirective.prototype, "active", {
            get: function () {
                return this.status === 1 /* CURRENT */;
            },
            set: function (nv) {
                var isActive = this.active;
                this.status = 1 /* CURRENT */;
                if (nv && !isActive) {
                    this.redrawChildren();
                }
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(WizardStepDirective.prototype, "done", {
            get: function () {
                return this.status === 3 /* COMPLETED */;
            },
            set: function (nv) {
                if (nv) {
                    this.status = 3 /* COMPLETED */;
                }
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(WizardStepDirective.prototype, "disabled", {
            get: function () {
                return this.status === 2 /* DISABLED */;
            },
            set: function (nv) {
                if (nv) {
                    this.status = 2 /* DISABLED */;
                }
            },
            enumerable: true,
            configurable: true
        });
        WizardStepDirective.prototype.invokeNextCB = function (index) {
            return this.invokeEventCallback('next', { currentStep: this, stepIndex: index });
        };
        WizardStepDirective.prototype.invokePrevCB = function (index) {
            return this.invokeEventCallback('prev', { currentStep: this, stepIndex: index });
        };
        WizardStepDirective.prototype.invokeSkipCB = function (index) {
            return this.invokeEventCallback('skip', { currentStep: this, stepIndex: index });
        };
        // redraw all the projected components which are projected.
        WizardStepDirective.prototype.redrawChildren = function () {
            var _this = this;
            setTimeout(function () {
                if (_this.reDrawableComponents) {
                    _this.reDrawableComponents.forEach(function (c) { return c.redraw(); });
                }
                var stepIndex = _this.wizardComponent.getCurrentStepIndex();
                _this.invokeEventCallback('load', { stepIndex: stepIndex });
            }, 100);
        };
        var WizardStepDirective_1;
        WizardStepDirective.initializeProps = registerProps$1();
        WizardStepDirective.ctorParameters = function () { return [
            { type: core.Injector },
            { type: forms.NgForm, decorators: [{ type: core.Self }] }
        ]; };
        __decorate([
            core.ContentChildren(base.RedrawableDirective, { descendants: true }),
            __metadata("design:type", Object)
        ], WizardStepDirective.prototype, "reDrawableComponents", void 0);
        __decorate([
            core.HostBinding('class.current'),
            __metadata("design:type", Object),
            __metadata("design:paramtypes", [])
        ], WizardStepDirective.prototype, "isCurrent", null);
        WizardStepDirective = WizardStepDirective_1 = __decorate([
            core.Directive({
                selector: 'form[wmWizardStep]',
                providers: [
                    base.provideAsWidgetRef(WizardStepDirective_1)
                ],
                exportAs: 'wmWizardStep'
            }),
            __param(1, core.Self()),
            __metadata("design:paramtypes", [core.Injector, forms.NgForm])
        ], WizardStepDirective);
        return WizardStepDirective;
    }(base.BaseComponent));

    var DEFAULT_CLS$1 = 'app-wizard panel clearfix';
    var WIDGET_CONFIG$1 = {
        widgetType: 'wm-wizard',
        hostClass: DEFAULT_CLS$1
    };
    var WizardComponent = /** @class */ (function (_super) {
        __extends(WizardComponent, _super);
        function WizardComponent(inj) {
            var _this = this;
            var resolveFn = core$1.noop;
            _this = _super.call(this, inj, WIDGET_CONFIG$1, new Promise(function (res) { return resolveFn = res; })) || this;
            base.styler(_this.nativeElement, _this, base.APPLY_STYLES_TYPE.SHELL);
            _this.promiseResolverFn = resolveFn;
            // initialize the message object with default values
            _this.message = {
                caption: '',
                type: ''
            };
            return _this;
        }
        WizardComponent_1 = WizardComponent;
        Object.defineProperty(WizardComponent.prototype, "hasPrevStep", {
            get: function () {
                return !this.isFirstStep(this.currentStep);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(WizardComponent.prototype, "hasNextStep", {
            get: function () {
                return !this.isLastStep(this.currentStep);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(WizardComponent.prototype, "showDoneBtn", {
            get: function () {
                if (!this.currentStep) {
                    return;
                }
                return !this.hasNextStep && this.currentStep.enableDone;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(WizardComponent.prototype, "enablePrev", {
            get: function () {
                if (!this.currentStep) {
                    return;
                }
                return this.currentStep.enablePrev;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(WizardComponent.prototype, "enableNext", {
            get: function () {
                if (!this.currentStep) {
                    return;
                }
                return this.currentStep.enableNext && this.currentStep.isValid;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(WizardComponent.prototype, "enableDone", {
            get: function () {
                if (!this.currentStep) {
                    return;
                }
                return this.currentStep.enableDone && this.currentStep.isValid;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * returns next valid step. the index passed is also checked if its valid step
         * @param index
         * @returns {WizardStepDirective}
         */
        WizardComponent.prototype.getNextValidStepFormIndex = function (index) {
            for (var i = index; i < this.steps.length; i++) {
                var step = this.getStepRefByIndex(i);
                if (step.show) {
                    return step;
                }
            }
        };
        /**
         * returns previous valid step. the index passed is also checked if its valid step
         * @param index
         * @returns {WizardStepDirective}
         */
        WizardComponent.prototype.getPreviousValidStepFormIndex = function (index) {
            for (var i = index; i >= 0; i--) {
                var step = this.getStepRefByIndex(i);
                if (step.show) {
                    return step;
                }
            }
        };
        /**
         * returns current step index value.
         * @returns {number}
         */
        WizardComponent.prototype.getCurrentStepIndex = function () {
            return this.getStepIndexByRef(this.currentStep);
        };
        /**
         * returns stepRef when index is passed.
         * @param {number} index
         * @returns {WizardStepDirective}
         */
        WizardComponent.prototype.getStepRefByIndex = function (index) {
            return this.steps.toArray()[index];
        };
        /**
         * returns the index value of the step.
         * @param {WizardStepDirective} wizardStep
         * @returns {number}
         */
        WizardComponent.prototype.getStepIndexByRef = function (wizardStep) {
            return this.steps.toArray().indexOf(wizardStep);
        };
        /**
         * gets stepRef by searching on the name property.
         * @param {string} name
         * @returns {WizardStepDirective}
         */
        WizardComponent.prototype.getStepRefByName = function (name) {
            return this.steps.find(function (step) { return step.name === name; });
        };
        /**
         * sets default step as current step if configured
         * or finds first valid step and set it as current step.
         * @param {WizardStepDirective} step
         */
        WizardComponent.prototype.setDefaultStep = function (step) {
            // If the default step has show true then only update the currentStep
            if (step && step.show) {
                this.currentStep = step;
                step.active = true;
                step.isInitialized = true;
                // Mark all previous step status COMPLETED
                var index = this.getStepIndexByRef(step) - 1;
                while (index >= 0) {
                    var prevStep = this.getStepRefByIndex(index);
                    prevStep.done = true;
                    prevStep.isInitialized = true;
                    index--;
                }
            }
            else {
                // set next valid step as current step
                step = this.getNextValidStepFormIndex(0);
                if (step) {
                    this.setDefaultStep(step);
                }
            }
        };
        /**
         * Selects the associated step when the wizard header is clicked.
         * @param $event
         * @param {WizardStepDirective} currentStep
         */
        WizardComponent.prototype.onWizardHeaderClick = function ($event, currentStep) {
            var _this = this;
            // select the step if it's status is done
            if (currentStep.done) {
                // set all the next steps status as disabled and previous steps as done
                this.steps.forEach(function (step, index) {
                    if (index < _this.getStepIndexByRef(currentStep)) {
                        step.done = true;
                        step.isDone = true;
                    }
                    else {
                        step.disabled = true;
                        step.isDone = false;
                    }
                });
                // set the selected step as current step and make it active
                this.currentStep = currentStep;
                this.currentStep.active = true;
            }
        };
        // Method to navigate to next step
        WizardComponent.prototype.next = function (eventName) {
            if (eventName === void 0) { eventName = 'next'; }
            var currentStep = this.currentStep;
            var currentStepIndex = this.getCurrentStepIndex();
            var nextStep;
            // abort if onSkip method returns false
            if (eventName === 'skip') {
                if (currentStep.invokeSkipCB(currentStepIndex) === false) {
                    return;
                }
            }
            else if (eventName === 'next') {
                if (currentStep.invokeNextCB(currentStepIndex) === false) {
                    return;
                }
            }
            nextStep = this.getNextValidStepFormIndex(currentStepIndex + 1);
            nextStep.isInitialized = true;
            // If there are any steps which has show then only change state of current step else remain same
            if (nextStep) {
                currentStep.isDone = true;
                currentStep.done = true;
                nextStep.active = true;
                this.currentStep = nextStep;
            }
        };
        // Method to navigate to previous step
        WizardComponent.prototype.prev = function () {
            var currentStep = this.currentStep;
            var currentStepIndex = this.getCurrentStepIndex();
            var prevStep;
            // abort if onPrev method returns false.
            if (currentStep.invokePrevCB(currentStepIndex) === false) {
                return;
            }
            prevStep = this.getPreviousValidStepFormIndex(currentStepIndex - 1);
            // If there are any steps which has show then only change state of current step else remain same
            if (prevStep) {
                currentStep.isDone = false;
                currentStep.disabled = true;
                prevStep.active = true;
                this.currentStep = prevStep;
            }
        };
        WizardComponent.prototype.skip = function () {
            this.next('skip');
        };
        // Method to invoke on-Done event on wizard
        WizardComponent.prototype.done = function () {
            this.currentStep.isDone = true;
            this.invokeEventCallback('done', { steps: this.steps.toArray() });
        };
        // Method to invoke on-Cancel event on wizard
        WizardComponent.prototype.cancel = function () {
            this.invokeEventCallback('cancel', { steps: this.steps.toArray() });
        };
        WizardComponent.prototype.isFirstStep = function (stepRef) {
            return this.steps.first === stepRef;
        };
        WizardComponent.prototype.isLastStep = function (stepRef) {
            return this.steps.last === stepRef;
        };
        // Define the property change handler. This Method will be triggered when there is a change in the widget property
        WizardComponent.prototype.onPropertyChange = function (key, nv, ov) {
            // Monitoring changes for properties and accordingly handling respective changes
            if (key === 'stepstyle') {
                this.stepClass = nv === 'justified' ? 'nav-justified' : '';
            }
            else if (key === 'defaultstep') {
                this.setDefaultStep(this.getStepRefByName(nv));
            }
            else {
                _super.prototype.onPropertyChange.call(this, key, nv, ov);
            }
        };
        WizardComponent.prototype.ngAfterContentInit = function () {
            _super.prototype.ngAfterContentInit.call(this);
            this.promiseResolverFn();
        };
        WizardComponent.prototype.ngAfterViewInit = function () {
            _super.prototype.ngAfterViewInit.call(this);
            base.styler(this.nativeElement.querySelector('.panel-body'), this, base.APPLY_STYLES_TYPE.INNER_SHELL);
        };
        var WizardComponent_1;
        WizardComponent.initializeProps = registerProps();
        WizardComponent.ctorParameters = function () { return [
            { type: core.Injector }
        ]; };
        __decorate([
            core.ContentChildren(WizardStepDirective),
            __metadata("design:type", core.QueryList)
        ], WizardComponent.prototype, "steps", void 0);
        WizardComponent = WizardComponent_1 = __decorate([
            core.Component({
                selector: 'div[wmWizard]',
                template: "<div class=\"app-wizard-heading\" role=\"tab\">\n    <ul class=\"app-wizard-steps nav nav-pills {{stepClass}}\">\n        <li class=\"app-wizard-step\" *ngFor=\"let step of steps; let i = index\" [hidden]=\"!step.show\"\n            [ngClass]=\"{active: step.done, current: step.active, disabled: step.disabled}\"\n            (click)=\"onWizardHeaderClick($event, step)\">\n            <a href=\"javascript:void(0)\" [attr.aria-label]=\"step.title\" [attr.title]=\"step.title\">\n                <span class=\"arrow\" *ngIf=\"class && class.includes('classic')\"></span>\n                <span class=\"wizard-step-number\">\n                    <span class=\"count\" *ngIf=\"class && class.includes('number') && !step.isDone\">{{i+1}}</span>\n                    <i class=\"dottedstepper\" *ngIf=\"class && (class.includes('dottedstepper') || class.includes('text-inline')) && !step.isDone\"></i>\n                    <i class=\"app-icon {{step.iconclass}}\" *ngIf=\"step.iconclass && step.isDone\"></i>\n                </span>\n                <span class=\"title-wrapper\">\n                    <span *ngIf=\"class && class.includes('text-inline')\">{{'0' + (i+1)}}</span>\n                    <span class=\"step-title\" [textContent]=\"step.title\"></span>\n                </span>\n            </a>\n        </li>\n    </ul>\n</div>\n<div class=\"app-wizard-body panel-body\" role=\"tabpanel\">\n    <p wmMessage *ngIf=\"message.caption\" caption.bind=\"message.caption\" type.bind=\"message.type\"></p>\n    <ng-content select=\"form[wmWizardStep]\"></ng-content>\n</div>\n<div class=\"app-wizard-actions panel-footer {{actionsalignment}}\">\n    <a class=\"app-wizard-skip\" name=\"skipStep_{{name}}\" *ngIf=\"currentStep?.enableskip\" title=\"Skip step\" (click)=\"skip()\">Skip &raquo;</a>\n    <div class=\"app-wizard-actions-right\">\n        <button type=\"button\" name=\"cancelBtn_{{name}}\" class=\"btn app-button btn-default\" *ngIf=\"cancelable\"\n                (click)=\"cancel()\" [title]=\"cancelbtnlabel\" [textContent]=\"cancelbtnlabel\"></button>\n        <button type=\"button\" name=\"previousBtn_{{name}}\" class=\"btn app-button btn-default\"\n                *ngIf=\"hasPrevStep\" (click)=\"prev()\" [disabled]=\"!enablePrev\">\n            <i class=\"app-icon wi wi-chevron-left\"></i>\n            <span class=\"btn-caption\" [textContent]=\"previousbtnlabel\"></span>\n        </button>\n        <button type=\"button\" name=\"nextBtn_{{name}}\" class=\"btn app-button btn-primary\"\n                *ngIf=\"hasNextStep\" (click)=\"next()\" [disabled]=\"!enableNext\">\n            <span class=\"btn-caption\" [textContent]=\"nextbtnlabel\"></span>\n            <i class=\"app-icon wi wi-chevron-right\"></i>\n        </button>\n        <button type=\"button\" name=\"doneBtn_{{name}}\" class=\"btn app-button btn-success\"\n                *ngIf=\"showDoneBtn\" (click)=\"done()\"\n                [disabled]=\"!enableDone\">\n            <i class=\"app-icon wi wi-done\"></i>\n            <span class=\"btn-caption\" [textContent]=\"donebtnlabel\"></span>\n        </button>\n    </div>\n</div>\n",
                providers: [
                    base.provideAsWidgetRef(WizardComponent_1)
                ]
            }),
            __metadata("design:paramtypes", [core.Injector])
        ], WizardComponent);
        return WizardComponent;
    }(base.StylableComponent));

    var components = [
        WizardStepDirective,
        WizardComponent
    ];
    var WizardModule = /** @class */ (function () {
        function WizardModule() {
        }
        WizardModule = __decorate([
            core.NgModule({
                imports: [
                    common.CommonModule,
                    base.WmComponentsModule
                ],
                declarations: __spread(components),
                exports: __spread(components),
                entryComponents: []
            })
        ], WizardModule);
        return WizardModule;
    }());

    exports.WizardModule = WizardModule;
    exports.ɵa = WizardStepDirective;
    exports.ɵb = registerProps$1;
    exports.ɵc = WizardComponent;
    exports.ɵd = registerProps;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=index.umd.js.map
