import { Injector } from '@angular/core';
import { NgForm } from '@angular/forms';
import { BaseComponent } from '@wm/components/base';
export declare class WizardStepDirective extends BaseComponent {
    private ngForm;
    static initializeProps: void;
    show: boolean;
    name: string;
    enableskip: any;
    disablenext: boolean;
    disabledone: boolean;
    disableprevious: boolean;
    isInitialized: boolean;
    isDone: boolean;
    private status;
    private wizardComponent;
    reDrawableComponents: any;
    get isCurrent(): boolean;
    /**
     * along with the wizard form , also validate the forms
     * if there are any inside the wizard
     * @returns {boolean}
     */
    get isValid(): boolean;
    /**
     * get all the forms inside the wizard if any and validate
     * @returns {boolean}
     */
    private areEmbeddedFormsValid;
    private getAllEmbeddedForms;
    get enableNext(): boolean;
    get enableDone(): boolean;
    get enablePrev(): boolean;
    set active(nv: boolean);
    get active(): boolean;
    set done(nv: boolean);
    get done(): boolean;
    set disabled(nv: boolean);
    get disabled(): boolean;
    constructor(inj: Injector, ngForm: NgForm);
    invokeNextCB(index: number): boolean;
    invokePrevCB(index: number): boolean;
    invokeSkipCB(index: number): boolean;
    private redrawChildren;
}
