import { AfterViewInit, ElementRef, Injector, OnInit } from '@angular/core';
import { Observable, Subject } from 'rxjs';
import { App } from '@wm/core';
import { ListComponent } from './list.component';
export declare class ListItemDirective implements OnInit, AfterViewInit {
    private inj;
    private app;
    item: any;
    context: any;
    destroy: Subject<any>;
    destroy$: Observable<any>;
    nativeElement: HTMLElement;
    readonly listComponent: ListComponent;
    private itemClass;
    private _currentItemWidgets;
    isActive: boolean;
    disableItem: boolean;
    onFocus(): void;
    get $index(): any;
    get $even(): any;
    get $odd(): any;
    get $first(): any;
    get $last(): any;
    get currentItemWidgets(): {};
    set wmListItem(val: any);
    constructor(inj: Injector, elRef: ElementRef, app: App);
    private registerWatch;
    private itemClassWatcher;
    private disableItemWatcher;
    private setUpCUDHandlers;
    ngOnInit(): void;
    ngAfterViewInit(): void;
}
