(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common'), require('@angular/forms'), require('ngx-bootstrap/pagination'), require('@wm/components/base'), require('@wm/core')) :
    typeof define === 'function' && define.amd ? define('@wm/components/data/pagination', ['exports', '@angular/core', '@angular/common', '@angular/forms', 'ngx-bootstrap/pagination', '@wm/components/base', '@wm/core'], factory) :
    (global = global || self, factory((global.wm = global.wm || {}, global.wm.components = global.wm.components || {}, global.wm.components.data = global.wm.components.data || {}, global.wm.components.data.pagination = {}), global.ng.core, global.ng.common, global.ng.forms, global['ngx-bootstrap'].pagination, global.wm.components.base, global.wm.core));
}(this, (function (exports, core, common, forms, pagination, base, core$1) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __rest(s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); }
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    function __createBinding(o, m, k, k2) {
        if (k2 === undefined) k2 = k;
        o[k2] = m[k];
    }

    function __exportStar(m, exports) {
        for (var p in m) if (p !== "default" && !exports.hasOwnProperty(p)) exports[p] = m[p];
    }

    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m) return m.call(o);
        if (o && typeof o.length === "number") return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }

    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    }

    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    };

    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }

    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
    }

    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }

    function __asyncValues(o) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
    }

    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
        return cooked;
    };

    function __importStar(mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
        result.default = mod;
        return result;
    }

    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }

    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }

    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    var registerProps = function () {
        base.register('wm-pagination', new Map([
            ['boundarylinks', __assign({ value: false }, base.PROP_BOOLEAN)],
            ['class', base.PROP_STRING],
            ['dataset', base.PROP_ANY],
            ['directionlinks', __assign({ value: true }, base.PROP_BOOLEAN)],
            ['forceellipses', __assign({ value: true }, base.PROP_BOOLEAN)],
            ['maxResults', base.PROP_NUMBER],
            ['maxsize', __assign({ value: 5 }, base.PROP_NUMBER)],
            ['name', base.PROP_STRING],
            ['navigation', __assign({ value: 'Basic' }, base.PROP_STRING)],
            ['navigationalign', __assign({ value: 'left' }, base.PROP_STRING)],
            ['navigationsize', base.PROP_STRING],
            ['show', __assign({ value: true }, base.PROP_BOOLEAN)],
            ['showrecordcount', base.PROP_BOOLEAN],
            ['tabindex', __assign({ value: 0 }, base.PROP_NUMBER)]
        ]));
    };

    var DEFAULT_CLS = 'app-datanavigator clearfix';
    var WIDGET_CONFIG = { widgetType: 'wm-pagination', hostClass: DEFAULT_CLS };
    var sizeClasses = {
        'Pager': {
            'small': 'pager-sm',
            'large': 'pager-lg'
        },
        'Basic': {
            'small': 'pagination-sm',
            'large': 'pagination-lg'
        },
        'Classic': {
            'small': 'pagination-sm',
            'large': 'pagination-lg'
        }
    };
    var unsupportedStatePersistenceTypes = ['On-Demand', 'Scroll'];
    var PaginationComponent = /** @class */ (function (_super) {
        __extends(PaginationComponent, _super);
        function PaginationComponent(inj, parent) {
            var _this = _super.call(this, inj, WIDGET_CONFIG) || this;
            _this.parent = parent;
            _this.resultEmitter = new core.EventEmitter();
            _this.maxResultsEmitter = new core.EventEmitter();
            _this.dn = {
                currentPage: 1
            };
            _this.pageCount = 0;
            _this.isDisableNext = true;
            _this.isDisablePrevious = true;
            _this.isDisableFirst = true;
            _this.isDisableLast = true;
            _this._debouncedApplyDataset = core$1.debounce(function () { return _this.widget.dataset = _this.dataset; }, base.DEBOUNCE_TIMES.PAGINATION_DEBOUNCE_TIME);
            _this._debouncedPageChanged = core$1.debounce(function (event) {
                var currentPage = event && event.page;
                // Do not call goToPage if page has not changed
                if (currentPage !== _this.dn.currentPage) {
                    var inst = _this.parent || _this;
                    _this.dn.currentPage = currentPage;
                    inst.invokeEventCallback('paginationchange', { $event: undefined, $index: _this.dn.currentPage });
                    _this.goToPage();
                }
            }, base.DEBOUNCE_TIMES.PAGINATION_DEBOUNCE_TIME);
            base.styler(_this.nativeElement, _this);
            return _this;
        }
        PaginationComponent_1 = PaginationComponent;
        PaginationComponent.prototype.setResult = function (result) {
            // TODO: Emit event only if result is changed
            this.result = result;
            this.resultEmitter.emit(this.result);
        };
        // Update navigationClass based on navigation and navigationSize props
        PaginationComponent.prototype.updateNavSize = function () {
            var sizeCls = sizeClasses[this.navcontrols];
            if (sizeCls && this.navigationsize) {
                this.navigationClass = sizeCls[this.navigationsize];
            }
            else {
                this.navigationClass = '';
            }
        };
        // Function to reset the paging values to default.
        PaginationComponent.prototype.resetPageNavigation = function () {
            this.pageCount = 0;
            this.dn.currentPage = 1;
            this.dataSize = 0;
        };
        /*Function to calculate the paging values.*/
        PaginationComponent.prototype.calculatePagingValues = function () {
            this.pageCount = (this.dataSize > this.maxResults) ? (Math.ceil(this.dataSize / this.maxResults)) : (this.dataSize < 0 ? 0 : 1);
            this.dn.currentPage = this.dn.currentPage || 1;
        };
        /*Function to set default values to the paging parameters*/
        PaginationComponent.prototype.setDefaultPagingValues = function (dataSize, maxResults, currentPage) {
            /*If neither 'dataSize' nor 'maxResults' is set, then set default values to the paging parameters.*/
            if (!dataSize && !maxResults) {
                this.pageCount = 1;
                this.dn.currentPage = 1;
                this.maxResults = dataSize;
                this.dataSize = dataSize;
            }
            else { /*Else, set the specified values and recalculate paging parameters.*/
                this.maxResults = maxResults || this.maxResults;
                this.dataSize = core$1.isDefined(dataSize) ? dataSize : this.dataSize;
                this.dn.currentPage = currentPage || this.dn.currentPage;
                this.calculatePagingValues();
            }
            this.maxResultsEmitter.emit(this.maxResults);
        };
        /*Function to check the dataSize and manipulate the navigator accordingly.*/
        PaginationComponent.prototype.checkDataSize = function (dataSize, numberOfElements, size) {
            /*If the dataSize is -1 or Integer.MAX_VALUE( which is 2147483647), then the total number of records is not known.
             * Hence,
             * 1. Hide the 'Total Record Count'.
             * 2. Disable the 'GoToLastPage' link as the page number of the last page is not known.*/
            if (dataSize === -1 || dataSize === core$1.AppConstants.INT_MAX_VALUE) {
                this.prevshowrecordcount = this.showrecordcount;
                this.isDisableLast = true;
                this.isDisableCount = true;
                this.showrecordcount = false;
                // If number of records in current page is less than the max records size, this is the last page. So disable next button.
                if (numberOfElements < size) {
                    this.isDisableNext = true;
                }
            }
            else {
                this.isDisableCount = false;
                this.showrecordcount = this.prevshowrecordcount || this.showrecordcount;
            }
        };
        /*Function to disable navigation based on the current and total pages.*/
        PaginationComponent.prototype.disableNavigation = function () {
            var isCurrentPageFirst = (this.dn.currentPage === 1), isCurrentPageLast = (this.dn.currentPage === this.pageCount);
            this.isDisableFirst = this.isDisablePrevious = isCurrentPageFirst;
            this.isDisableNext = this.isDisableLast = isCurrentPageLast;
            this.isDisableCurrent = isCurrentPageFirst && isCurrentPageLast;
        };
        /*Function to check if the variable bound to the data-navigator has paging.*/
        PaginationComponent.prototype.isDataSourceHasPaging = function () {
            return this.datasource && this.datasource.execute(core$1.DataSource.Operation.IS_PAGEABLE);
        };
        // Set the result for client side pagination
        PaginationComponent.prototype.setNonPageableData = function (newVal) {
            var dataSize, maxResults, currentPage, startIndex;
            dataSize = _.isArray(newVal) ? newVal.length : (_.isEmpty(newVal) ? 0 : 1);
            maxResults = (this.options && this.options.maxResults) || dataSize;
            // For static variable, keep the current page. For other variables without pagination reset the page to 1
            if (this.datasource && this.datasource.execute(core$1.DataSource.Operation.IS_API_AWARE)) {
                currentPage = 1;
            }
            else {
                currentPage = this.dn.currentPage || 1;
            }
            this.setDefaultPagingValues(dataSize, maxResults, currentPage);
            this.disableNavigation();
            startIndex = (this.dn.currentPage - 1) * this.maxResults;
            this.setResult(_.isArray(newVal) ? newVal.slice(startIndex, startIndex + this.maxResults) : newVal);
        };
        /*Function to set the values needed for pagination*/
        PaginationComponent.prototype.setPagingValues = function (newVal) {
            var dataSize, maxResults, currentPage, dataSource;
            var variableOptions = {};
            // Store the data in __fullData. This is used for client side searching witvah out modifying the actual dataset.
            this.__fullData = newVal;
            /*Check for sanity*/
            if (this.binddataset) {
                dataSource = this.datasource || {};
                variableOptions = dataSource._options || {};
                /*Check for number of elements in the data set*/
                if (newVal) {
                    if (this.isDataSourceHasPaging()) {
                        this.pagination = this.datasource.execute(core$1.DataSource.Operation.GET_PAGING_OPTIONS) || {};
                        // If "filterFields" and "sortOptions" have been set, then set them so that the filters can be retained while fetching data upon page navigation.
                        this.filterFields = variableOptions.filterFields || {};
                        this.sortOptions = variableOptions.orderBy ||
                            (_.isArray(this.pagination.sort) ? base.getOrderByExpr(this.pagination.sort) : '');
                        dataSize = this.pagination.totalElements;
                        maxResults = this.pagination.size;
                        if (this.pagination.numberOfElements > 0) {
                            if (core$1.isDefined(this.pagination.number)) { // number is page number received from backend
                                this.dn.currentPage = this.pagination.number + 1;
                            }
                            currentPage = this.dn.currentPage || 1;
                        }
                        else {
                            currentPage = 1;
                        }
                        /* Sending pageCount undefined to calculate it again for query.*/
                        this.setDefaultPagingValues(dataSize, maxResults, currentPage);
                        this.disableNavigation();
                        this.checkDataSize(dataSize, this.pagination.numberOfElements, this.pagination.size);
                        this.setResult(newVal);
                    }
                    else if (!_.isString(newVal)) {
                        this.setNonPageableData(newVal);
                    }
                }
                else {
                    this.setResult(newVal);
                    this.resetPageNavigation();
                }
            }
            else {
                if (newVal && !_.isString(newVal)) {
                    this.setNonPageableData(newVal);
                }
            }
        };
        /*Function to check if the current page is the first page*/
        PaginationComponent.prototype.isFirstPage = function () {
            return (this.dn.currentPage === 1 || !this.dn.currentPage);
        };
        /*Function to check if the current page is the last page*/
        PaginationComponent.prototype.isLastPage = function () {
            return (this.dn.currentPage === this.pageCount);
        };
        /*Function to navigate to the last page*/
        PaginationComponent.prototype.goToLastPage = function (isRefresh, event, callback) {
            if (!this.isLastPage()) {
                this.dn.currentPage = this.pageCount;
                this.goToPage(event, callback);
            }
            else if (isRefresh) {
                this.goToPage(event, callback);
            }
        };
        /*Function to navigate to the first page*/
        PaginationComponent.prototype.goToFirstPage = function (isRefresh, event, callback) {
            if (!this.isFirstPage()) {
                this.dn.currentPage = 1;
                this.goToPage(event, callback);
            }
            else if (isRefresh) {
                this.goToPage(event, callback);
            }
        };
        /*Function to navigate to the current page*/
        PaginationComponent.prototype.goToPage = function (event, callback) {
            this.firstRow = (this.dn.currentPage - 1) * this.maxResults;
            var mode = this.parent.statePersistence.computeMode(this.statehandler);
            if (mode && mode.toLowerCase() !== 'none' && (this.parent.widgetType === 'wm-table' || this.parent.widgetType === 'wm-list')) {
                this.parent._selectedItemsExist = true;
                if (this.isFirstPage()) {
                    this.parent.statePersistence.removeWidgetState(this.parent, 'pagination');
                }
                else {
                    if (unsupportedStatePersistenceTypes.indexOf(this.parent.navigation) < 0) {
                        this.parent.statePersistence.setWidgetState(this.parent, { pagination: this.dn.currentPage });
                    }
                    else if (this.parent.widgetType === 'wm-list') {
                        console.warn('Retain State handling on Widget ' + this.parent.name + ' is not supported for current pagination type.');
                    }
                }
            }
            // call getPageData after checking state config so that Static Variables can use it
            this.getPageData(event, callback);
        };
        /*Function to be invoked after the data of the page has been fetched.*/
        PaginationComponent.prototype.onPageDataReady = function (event, data, callback) {
            this.disableNavigation();
            this.invokeSetRecord(event, data);
            core$1.triggerFn(callback);
        };
        /*Function to get data for the current page*/
        PaginationComponent.prototype.getPageData = function (event, callback) {
            var _this = this;
            var data, startIndex;
            if (this.isDataSourceHasPaging()) {
                this.datasource.execute(core$1.DataSource.Operation.LIST_RECORDS, {
                    'page': this.dn.currentPage,
                    'filterFields': this.filterFields,
                    'orderBy': this.sortOptions,
                    'matchMode': 'anywhereignorecase'
                }).then(function (response) {
                    _this.onPageDataReady(event, response && response.data, callback);
                    core$1.$appDigest();
                }, function (error) {
                    // If error is undefined, do not show any message as this may be discarded request
                    if (error) {
                        // TODO: Handle Error
                        // wmToaster.show('error', 'ERROR', 'Unable to get data of page -' + this.dn.currentPage + ':' + error);
                    }
                });
            }
            else {
                startIndex = (this.dn.currentPage - 1) * this.maxResults;
                data = _.isArray(this.__fullData) ? this.__fullData.slice(startIndex, startIndex + this.maxResults) : this.__fullData;
                this.setResult(data);
                this.onPageDataReady(event, data, callback);
            }
        };
        PaginationComponent.prototype.invokeSetRecord = function (event, data) {
            // Trigger the event handler if exists.
            var pageInfo = {
                currentPage: this.dn.currentPage,
                size: this.maxResults,
                totalElements: this.dataSize,
                totalPages: this.pageCount
            };
            if (this.parent) {
                this.parent.invokeEventCallback('setrecord', { $event: event, $data: data, $index: this.dn.currentPage, pageInfo: pageInfo, data: data });
            }
            else {
                this.invokeEventCallback('setrecord', { $event: event, $data: data, $index: this.dn.currentPage, pageInfo: pageInfo, data: data });
            }
        };
        /*Function to validate the page input.
         In case of invalid input, navigate to the appropriate page; also return false.
         In case of valid input, return true.*/
        PaginationComponent.prototype.validateCurrentPage = function (event, callback) {
            /*If the value entered is greater than the last page number or invalid value, then highlighting the field showing error.*/
            if (event && (isNaN(this.dn.currentPage) || this.dn.currentPage <= 0 || (this.pageCount && (this.dn.currentPage > this.pageCount || _.isNull(this.dn.currentPage))))) {
                $(event.target).closest('a').addClass('ng-invalid');
                return false;
            }
            return true;
        };
        PaginationComponent.prototype.onModelChange = function (event) {
            if (!this.validateCurrentPage(event)) {
                return;
            }
            this.goToPage(event);
        };
        PaginationComponent.prototype.onKeyDown = function (event) {
            var targetEle = $(event.target).closest('a');
            if (event.code === 'KeyE') {
                targetEle.addClass('ng-invalid');
                return false;
            }
            targetEle.removeClass('ng-invalid');
            return true;
        };
        PaginationComponent.prototype.pageChanged = function (event) {
            this._debouncedPageChanged(event);
        };
        /*Function to navigate to the respective pages.*/
        PaginationComponent.prototype.navigatePage = function (index, event, isRefresh, callback) {
            this.invokeEventCallback('paginationchange', { $event: undefined, $index: this.dn.currentPage });
            // Convert the current page to a valid page number.
            this.dn.currentPage = +this.dn.currentPage;
            switch (index) {
                case 'first':
                    this.goToFirstPage(isRefresh, event, callback);
                    return;
                case 'prev':
                    /*Return if already on the first page.*/
                    if (this.isFirstPage() || !this.validateCurrentPage(event, callback)) {
                        return;
                    }
                    /*Decrement the current page by 1.*/
                    this.dn.currentPage -= 1;
                    break;
                case 'next':
                    /*Return if already on the last page.*/
                    if (this.isLastPage() || !this.validateCurrentPage(event, callback)) {
                        return;
                    }
                    /*Increment the current page by 1.*/
                    this.dn.currentPage += 1;
                    break;
                case 'last':
                    this.goToLastPage(isRefresh, event, callback);
                    return;
                default:
                    break;
            }
            /*Navigate to the current page.*/
            this.goToPage(event, callback);
        };
        PaginationComponent.prototype.setBindDataSet = function (binddataset, parent, dataSource, dataset, binddatasource, datasetBoundExpr, statehandler) {
            var _this = this;
            var parts = binddataset.split('.');
            var bindPagingOptions;
            this.statehandler = statehandler;
            if (parts[0] === 'Variables' || parts[0] === 'Widgets') {
                bindPagingOptions = parts[0] + "." + parts[1] + ".pagination";
            }
            if (!binddatasource && dataset && !datasetBoundExpr) {
                this.dataset = dataset;
                this._debouncedApplyDataset();
                return;
            }
            this.binddataset = binddataset;
            setTimeout(function () {
                // watching for dataset changes even when dataset is bound to "item." (i.e. by checking for datasetBoundExpr)
                // item context is passed as dataSource here
                _this.registerDestroyListener(core$1.$watch(binddataset, parent, datasetBoundExpr ? dataSource : {}, function (nv) {
                    if (nv) {
                        _this.dataset = nv;
                        _this._debouncedApplyDataset();
                    }
                    else {
                        // WMS-19285: Setting dataset on proxy only to handle propertychange handler call for undefined cases
                        _this.widget.dataset = nv;
                    }
                }));
                // Register a watch on paging options. Call dataset property change handler even if paging options changes to reflect pagination state
                if (!bindPagingOptions) {
                    return;
                }
                _this.registerDestroyListener(core$1.$watch(bindPagingOptions, parent, {}, function () { return _this._debouncedApplyDataset(); }));
            });
            // apply datasource only when dataset is not bound to "item.FIELD"
            if (!datasetBoundExpr) {
                this.datasource = dataSource;
            }
        };
        // Set the datasource of pagination from the parent widget
        PaginationComponent.prototype.setDataSource = function (dataSource) {
            this.datasource = dataSource;
        };
        PaginationComponent.prototype.onPropertyChange = function (key, nv, ov) {
            if (key === 'dataset') {
                var data = void 0;
                if (this.parent && this.parent.onDataNavigatorDataSetChange) {
                    data = this.parent.onDataNavigatorDataSetChange(nv);
                }
                else {
                    data = nv;
                }
                this.setPagingValues(data);
            }
            else if (key === 'navigation') {
                if (nv === 'Advanced') { // Support for older projects where navigation type was advanced instead of clasic
                    this.navigation = 'Classic';
                }
                this.updateNavSize();
                this.navcontrols = nv;
            }
            else if (key === 'navigationsize') {
                this.updateNavSize();
            }
            else if (key === 'navigationalign') {
                core$1.switchClass(this.nativeElement, "text-" + nv, "text-" + ov);
            }
            else if (key === 'maxResults') {
                this.setPagingValues(this.dataset);
            }
            else {
                _super.prototype.onPropertyChange.call(this, key, nv, ov);
            }
        };
        PaginationComponent.prototype.ngAfterViewInit = function () {
            var paginationElem = this.nativeElement;
            paginationElem.onclick = function (event) {
                event.stopPropagation();
            };
        };
        var PaginationComponent_1;
        PaginationComponent.initializeProps = registerProps();
        PaginationComponent.ctorParameters = function () { return [
            { type: core.Injector },
            { type: undefined, decorators: [{ type: core.SkipSelf }, { type: core.Inject, args: [base.WidgetRef,] }] }
        ]; };
        __decorate([
            core.Output(),
            __metadata("design:type", core.EventEmitter)
        ], PaginationComponent.prototype, "resultEmitter", void 0);
        __decorate([
            core.Output(),
            __metadata("design:type", core.EventEmitter)
        ], PaginationComponent.prototype, "maxResultsEmitter", void 0);
        PaginationComponent = PaginationComponent_1 = __decorate([
            core.Component({
                selector: '[wmPagination]',
                template: "\n<ul class=\"pagination advanced {{navigationClass}}\" *ngIf=\"navcontrols === 'Classic'\">\n    <li [ngClass]=\"{'disabled':isDisableFirst}\">\n        <a [title]=\"appLocale.LABEL_FIRST\" name=\"first\" href=\"javascript:void(0);\" aria-label=\"First\"\n           (click)=\"navigatePage('first', $event)\">\n            <span aria-hidden=\"true\"><i class=\"wi wi-first-page\"></i></span>\n            <span class=\"sr-only\">{{appLocale.LABEL_FIRST}}</span>\n        </a>\n    </li>\n    <li [ngClass]=\"{'disabled':isDisablePrevious}\">\n        <a [title]=\"appLocale.LABEL_PREVIOUS\" name=\"prev\" href=\"javascript:void(0);\" aria-label=\"Previous\"\n           (click)=\"navigatePage('prev', $event)\">\n            <span aria-hidden=\"true\"><i class=\"wi wi-chevron-left\"></i></span>\n            <span class=\"sr-only\">{{appLocale.LABEL_PREVIOUS}}</span>\n        </a>\n    </li>\n    <li class=\"pagecount disabled\">\n        <a><input type=\"number\" [disabled]=\"isDisableCurrent\" [(ngModel)]=\"dn.currentPage\"\n                  (keydown)=\"onKeyDown($event)\" (change)=\"onModelChange($event)\" class=\"form-control\"/></a>\n    </li>\n    <li class=\"disabled\">\n        <a [hidden]=\"isDisableCount\"> / {{pageCount}}</a>\n    </li>\n    <li [ngClass]=\"{'disabled':isDisableNext}\">\n        <a [title]=\"appLocale.LABEL_NEXT\" name=\"next\" href=\"javascript:void(0);\" aria-label=\"Next\"\n           (click)=\"navigatePage('next', $event)\">\n            <span aria-hidden=\"true\"><i class=\"wi wi-chevron-right\"></i></span>\n            <span class=\"sr-only\">{{appLocale.LABEL_NEXT}}</span>\n        </a>\n    </li>\n    <li [ngClass]=\"{'disabled':isDisableLast}\">\n        <a [title]=\"appLocale.LABEL_LAST\" name=\"last\" href=\"javascript:void(0);\" aria-label=\"Last\"\n           (click)=\"navigatePage('last', $event)\">\n            <span aria-hidden=\"true\"><i class=\"wi wi-last-page\"></i></span>\n            <span class=\"sr-only\">{{appLocale.LABEL_LAST}}</span>\n        </a>\n    </li>\n    <li *ngIf=\"showrecordcount\" class=\"totalcount disabled\">\n        <a>{{appLocale.LABEL_TOTAL_RECORDS}}: {{dataSize}}</a>\n    </li>\n</ul>\n<ul class=\"pager {{navigationClass}}\" *ngIf=\"navcontrols === 'Pager'\">\n    <li class=\"previous\" [ngClass]=\"{'disabled':isDisablePrevious}\">\n        <a href=\"javascript:void(0);\" (click)=\"navigatePage('prev', $event)\" aria-label=\"Previous\">\n            <span aria-hidden=\"true\"><i class=\"wi wi-chevron-left\"></i></span>\n            {{appLocale.LABEL_PREVIOUS}}\n            <span class=\"sr-only\">{{appLocale.LABEL_PREVIOUS}}</span>\n        </a>\n    </li>\n    <li class=\"next\" [ngClass]=\"{'disabled':isDisableNext}\">\n        <a href=\"javascript:void(0);\" (click)=\"navigatePage('next', $event)\" aria-label=\"Next\">\n            {{appLocale.LABEL_NEXT}}\n            <span aria-hidden=\"true\"><i class=\"wi wi-chevron-right\"></i></span>\n            <span class=\"sr-only\">{{appLocale.LABEL_NEXT}}</span>\n        </a>\n    </li>\n</ul>\n\n<pagination class=\"pagination basic\" [ngClass]=\"navigationClass\" *ngIf=\"navcontrols === 'Basic'\"\n            [itemsPerPage]=\"maxResults\" [totalItems]=\"dataSize\"\n            [ngModel]=\"dn.currentPage\" (pageChanged)=\"pageChanged($event)\"\n            [boundaryLinks]=\"boundarylinks\" [maxSize]=\"maxsize\"\n            [directionLinks]=\"directionlinks\" previousText=\".\" nextText=\".\" firstText=\".\" lastText=\".\"></pagination>\n\n<ul *ngIf=\"navcontrols === 'Basic' && showrecordcount\" class=\"pagination\">\n    <li class=\"totalcount disabled basiccount\"><a>{{appLocale.LABEL_TOTAL_RECORDS}}: {{dataSize}}</a></li>\n</ul>\n",
                providers: [
                    base.provideAsWidgetRef(PaginationComponent_1)
                ]
            }),
            __param(1, core.SkipSelf()), __param(1, core.Inject(base.WidgetRef)),
            __metadata("design:paramtypes", [core.Injector, Object])
        ], PaginationComponent);
        return PaginationComponent;
    }(base.StylableComponent));

    var components = [
        PaginationComponent
    ];
    var PaginationModule = /** @class */ (function () {
        function PaginationModule() {
        }
        PaginationModule = __decorate([
            core.NgModule({
                imports: [
                    common.CommonModule,
                    forms.FormsModule,
                    pagination.PaginationModule,
                    base.WmComponentsModule
                ],
                declarations: __spread(components),
                exports: __spread(components),
                entryComponents: []
            })
        ], PaginationModule);
        return PaginationModule;
    }());

    exports.PaginationComponent = PaginationComponent;
    exports.PaginationModule = PaginationModule;
    exports.ɵa = registerProps;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=index.umd.js.map
