import { Injector, OnInit, TemplateRef } from '@angular/core';
import { App } from '@wm/core';
import { BaseDialog } from '@wm/components/dialogs';
export declare class PartialDialogComponent extends BaseDialog implements OnInit {
    static initializeProps: void;
    dialogTemplate: TemplateRef<any>;
    dialogContent: TemplateRef<any>;
    partialRef: any;
    protected app: any;
    protected Widgets: any;
    protected Variables: any;
    protected Actions: any;
    constructor(inj: Injector, app: App, dialogClass: string, modal: string | boolean, closable: string | boolean);
    protected getTemplateRef(): TemplateRef<any>;
    /**
     * Click event handler for the ok button
     * invokes on-ok event callback
     * @param {Event} $event
     */
    onOk($event: Event): void;
    ngOnInit(): void;
    private setPartialLoadListener;
    open(initState?: any): void;
}
