import { ElementRef, Injector } from '@angular/core';
import { NgModel } from '@angular/forms';
import { AbstractI18nService, AppDefaults } from '@wm/core';
import { TrailingZeroDecimalPipe } from '@wm/components/base';
import { NumberLocale } from '@wm/components/input';
export declare class CurrencyComponent extends NumberLocale {
    private appDefaults;
    static initializeProps: void;
    currency: string;
    currencySymbol: string;
    required: boolean;
    regexp: any;
    disabled: boolean;
    autofocus: boolean;
    name: string;
    tabindex: any;
    shortcutkey: string;
    ngModel: NgModel;
    inputEl: ElementRef;
    constructor(inj: Injector, appDefaults: AppDefaults, i18nService: AbstractI18nService, trailingZeroDecimalPipe: TrailingZeroDecimalPipe);
    onPropertyChange(key: string, nv: any, ov?: any): void;
}
