(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common'), require('@angular/forms'), require('ngx-bootstrap/datepicker'), require('ngx-bootstrap/dropdown'), require('ngx-bootstrap/timepicker'), require('@wm/components/base'), require('@angular/platform-browser'), require('@wm/core'), require('@wm/components/input')) :
    typeof define === 'function' && define.amd ? define('@wm/components/input/epoch', ['exports', '@angular/core', '@angular/common', '@angular/forms', 'ngx-bootstrap/datepicker', 'ngx-bootstrap/dropdown', 'ngx-bootstrap/timepicker', '@wm/components/base', '@angular/platform-browser', '@wm/core', '@wm/components/input'], factory) :
    (global = global || self, factory((global.wm = global.wm || {}, global.wm.components = global.wm.components || {}, global.wm.components.input = global.wm.components.input || {}, global.wm.components.input.epoch = {}), global.ng.core, global.ng.common, global.ng.forms, global['ngx-bootstrap'].datepicker, global['ngx-bootstrap'].dropdown, global['ngx-bootstrap'].timepicker, global.wm.components.base, global.ng.platformBrowser, global.wm.core, global.wm.components.input));
}(this, (function (exports, core, common, forms, datepicker, dropdown, timepicker, base, platformBrowser, core$1, input) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __rest(s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); }
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    function __createBinding(o, m, k, k2) {
        if (k2 === undefined) k2 = k;
        o[k2] = m[k];
    }

    function __exportStar(m, exports) {
        for (var p in m) if (p !== "default" && !exports.hasOwnProperty(p)) exports[p] = m[p];
    }

    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m) return m.call(o);
        if (o && typeof o.length === "number") return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }

    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    }

    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    };

    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }

    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
    }

    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }

    function __asyncValues(o) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
    }

    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
        return cooked;
    };

    function __importStar(mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
        result.default = mod;
        return result;
    }

    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }

    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }

    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    var CURRENT_DATE = 'CURRENT_DATE';
    var months = ['January', 'February', 'March', 'April', 'May', 'June', 'July', 'August', 'September', 'October', 'November', 'December'];
    var DATEPICKER_DROPDOWN_OPTIONS = {
        BUTTON: 'button',
        DEFAULT: 'default'
    };
    var DATAENTRYMODE_DROPDOWN_OPTIONS = {
        PICKER: 'picker',
        DEFAULT: 'default'
    };
    // Providing meridians to the timepicker baesd on selected locale
    function getTimepickerConfig(i18nService) {
        return Object.assign(new timepicker.TimepickerConfig(), {
            meridians: common.getLocaleDayPeriods(i18nService.getSelectedLocale(), common.FormStyle.Format, common.TranslationWidth.Abbreviated)
        });
    }
    var BaseDateTimeComponent = /** @class */ (function (_super) {
        __extends(BaseDateTimeComponent, _super);
        function BaseDateTimeComponent(inj, WIDGET_CONFIG) {
            var _this = _super.call(this, inj, WIDGET_CONFIG) || this;
            _this.isReadOnly = false;
            /**
             * This is an internal property used to map the containerClass, showWeekNumbers etc., to the bsDatepicker
             */
            _this._dateOptions = new datepicker.BsDatepickerConfig();
            _this.datePipe = _this.inj.get(base.ToDatePipe);
            _this.i18nService = _this.inj.get(core$1.AbstractI18nService);
            _this.selectedLocale = _this.i18nService.getSelectedLocale();
            _this.meridians = common.getLocaleDayPeriods(_this.selectedLocale, common.FormStyle.Format, common.TranslationWidth.Abbreviated);
            _this.loadNativeDateInput = core$1.isMobile();
            return _this;
        }
        /**
         * returns true if the input value is default (i.e open date picker on input click)
         * @param1 dropdownvalue, user selected value (by default datepicker opens on input click)
         * **/
        BaseDateTimeComponent.prototype.isDropDownDisplayEnabledOnInput = function (dropdownvalue) {
            return dropdownvalue === DATEPICKER_DROPDOWN_OPTIONS.DEFAULT;
        };
        /**
         * returns true if the input value is default (i.e Data entry can be done either by selecting from the Date/DateTime/Time Picker or by entering  manually using the keyboard. )
         * @param1 dropdownvalue, user selected value
         * **/
        BaseDateTimeComponent.prototype.isDataEntryModeEnabledOnInput = function (dropdownvalue) {
            return dropdownvalue === DATAENTRYMODE_DROPDOWN_OPTIONS.DEFAULT;
        };
        /**
         * This method is used to show validation message depending on the isNativePicker flag.
         */
        BaseDateTimeComponent.prototype.showValidation = function ($event, displayValue, isNativePicker, msg) {
            if (isNativePicker) {
                console.warn('min max date validation failed ', msg);
                return $($event.target).val(displayValue);
            }
        };
        BaseDateTimeComponent.prototype.resetDisplayInput = function () {
            $(this.nativeElement).find('.display-input').val('');
        };
        BaseDateTimeComponent.prototype.validate = function (c) {
            if (this.invalidDateTimeFormat) {
                return {
                    invalidDateTimeFormat: {
                        valid: false
                    }
                };
            }
            if (!_.isUndefined(this.dateNotInRange) && this.dateNotInRange) {
                return {
                    dateNotInRange: {
                        valid: false
                    },
                };
            }
            if (!_.isUndefined(this.timeNotInRange) && this.timeNotInRange) {
                return {
                    timeNotInRange: {
                        valid: false
                    },
                };
            }
            /* WMS-18269 | Extending the existing validation for 'required' */
            if (this["show"] && this["required"]) {
                return !!c.value ? null : { required: true };
            }
            this.validateType = '';
            return null;
        };
        /**
         * This method is used to validate date pattern and time pattern
         * If user selects one pattern in design time and if he tries to enter the date in another pattern then the device is throwing an error
         */
        BaseDateTimeComponent.prototype.formatValidation = function (newVal, inputVal, isNativePicker) {
            var pattern = this.datepattern || this.timepattern;
            var formattedDate = core$1.getFormattedDate(this.datePipe, newVal, pattern);
            inputVal = inputVal.trim();
            if (inputVal) {
                if (pattern === 'timestamp') {
                    if (!_.isNaN(inputVal) && _.parseInt(inputVal) !== formattedDate) {
                        this.invalidDateTimeFormat = true;
                        this.validateType = 'incorrectformat';
                        this.invokeOnChange(this.datavalue, undefined, false);
                        return false;
                    }
                }
                else {
                    if (isNativePicker) {
                        // format the date value only when inputVal is obtained from $event.target.value, as the format doesnt match.
                        inputVal = core$1.getFormattedDate(this.datePipe, inputVal, pattern);
                    }
                    if (inputVal !== formattedDate) {
                        this.invalidDateTimeFormat = true;
                        this.validateType = 'incorrectformat';
                        this.invokeOnChange(this.datavalue, undefined, false);
                        return false;
                    }
                }
            }
            return true;
        };
        /**
         * This method is used to validate min date, max date, exclude dates and exclude days
         * In mobile if invalid dates are entered, device is showing an alert.
         * In web if invalid dates are entered, device is showing validation message.
         */
        BaseDateTimeComponent.prototype.minDateMaxDateValidationOnInput = function (newVal, $event, displayValue, isNativePicker) {
            var _this = this;
            if (newVal) {
                newVal = moment(newVal).startOf('day').toDate();
                var minDate = moment(core$1.getDateObj(this.mindate)).startOf('day').toDate();
                var maxDate = moment(core$1.getDateObj(this.maxdate)).startOf('day').toDate();
                if (this.mindate && newVal < minDate) {
                    var msg = this.appLocale.LABEL_MINDATE_VALIDATION_MESSAGE + " " + this.mindate + ".";
                    this.dateNotInRange = true;
                    this.validateType = 'mindate';
                    this.invokeOnChange(this.datavalue, undefined, false);
                    return this.showValidation($event, displayValue, isNativePicker, msg);
                }
                if (this.maxdate && newVal > maxDate) {
                    var msg = this.appLocale.LABEL_MAXDATE_VALIDATION_MESSAGE + " " + this.maxdate + ".";
                    this.dateNotInRange = true;
                    this.validateType = 'maxdate';
                    this.invokeOnChange(this.datavalue, undefined, false);
                    return this.showValidation($event, displayValue, isNativePicker, msg);
                }
                if (this.excludedates) {
                    var excludeDatesArray = void 0;
                    if (core$1.isString(this.excludedates)) {
                        excludeDatesArray = _.split(this.excludedates, ',');
                    }
                    else {
                        excludeDatesArray = this.excludedates;
                    }
                    excludeDatesArray = excludeDatesArray.map(function (d) { return core$1.getFormattedDate(_this.datePipe, d, _this.datepattern); });
                    if (excludeDatesArray.indexOf(core$1.getFormattedDate(this.datePipe, newVal, this.datepattern)) > -1) {
                        this.dateNotInRange = true;
                        this.validateType = 'excludedates';
                        this.invokeOnChange(this.datavalue, undefined, false);
                        return;
                    }
                }
                if (this.excludedays) {
                    var excludeDaysArray = _.split(this.excludedays, ',');
                    if (excludeDaysArray.indexOf(newVal.getDay().toString()) > -1) {
                        this.dateNotInRange = true;
                        this.validateType = 'excludedays';
                        this.invokeOnChange(this.datavalue, undefined, false);
                        return;
                    }
                }
            }
            if (!isNativePicker) {
                this.dateNotInRange = false;
                this.invokeOnChange(this.datavalue, undefined, false);
            }
        };
        /**
         * This method is used to highlight the current date
         */
        BaseDateTimeComponent.prototype.hightlightToday = function () {
            var toDay = new Date().getDate().toString();
            _.filter($("span:contains(" + toDay + ")").not('.is-other-month'), function (obj) {
                if ($(obj).text() === toDay) {
                    $(obj).addClass('current-date text-info');
                }
            });
        };
        /**
         * This method is used to find the new date is from another year or not
         * @param newDate - newly selected date value
         */
        BaseDateTimeComponent.prototype.isOtheryear = function (newDate) {
            return (newDate.getMonth() === 0 && this.activeDate.getMonth() === 11) || (newDate.getMonth() === 11 && this.activeDate.getMonth() === 0);
        };
        /**
         * This method is used to set focus for active day
         * @param newDate - newly selected date value
         * @param isMouseEvent - boolean value represents the event is mouse event/ keyboard event
         */
        BaseDateTimeComponent.prototype.setActiveDateFocus = function (newDate, isMouseEvent) {
            var _this = this;
            var activeMonth = this.activeDate.getMonth();
            // check for keyboard event
            if (!isMouseEvent) {
                if (newDate.getMonth() < activeMonth) {
                    this.isOtheryear(newDate) ? this.goToOtherMonthOryear('next', 'days') : this.goToOtherMonthOryear('previous', 'days');
                }
                else if (newDate.getMonth() > activeMonth) {
                    this.isOtheryear(newDate) ? this.goToOtherMonthOryear('previous', 'days') : this.goToOtherMonthOryear('next', 'days');
                }
            }
            setTimeout(function () {
                if (newDate.getMonth() === new Date().getMonth() && newDate.getFullYear() === new Date().getFullYear()) {
                    _this.hightlightToday();
                }
                var newDay = newDate.getDate().toString();
                _.filter($("span:contains(" + newDay + ")").not('.is-other-month'), function (obj) {
                    if ($(obj).text() === newDay) {
                        $(obj).focus();
                        _this.activeDate = newDate;
                    }
                });
            });
        };
        /**
         * This method is used to load other month days or other month or other year
         * @param btnClass - class(previous/next) of the button which we have to click
         * @param timePeriod - String value decides to load other month days or other month or other year
         */
        BaseDateTimeComponent.prototype.goToOtherMonthOryear = function (btnClass, timePeriod) {
            var $node = $(".bs-datepicker-head ." + btnClass);
            if ($node.attr('disabled')) {
                return;
            }
            $node.trigger('click');
            if (timePeriod === 'days') {
                this.loadDays();
            }
            else if (timePeriod === 'month') {
                this.loadMonths();
            }
            else if (timePeriod === 'year') {
                this.loadYears();
            }
        };
        /**
        * This method sets the mouse events to Datepicker popup. These events are required when we navigate date picker through mouse.
         */
        BaseDateTimeComponent.prototype.addDatepickerMouseEvents = function () {
            var _this = this;
            var datePikcerHead = $(".bs-datepicker-head");
            datePikcerHead.find(".previous").click(function (event) {
                // check for original mouse click
                if (event.originalEvent) {
                    _this.setFocusForDate(-1);
                }
            });
            datePikcerHead.find(".next").click(function (event) {
                // check for original mouse click
                if (event.originalEvent) {
                    _this.setFocusForDate(1);
                }
            });
            datePikcerHead.find(".current").click(function (event) {
                // check for original mouse click
                if (event.originalEvent) {
                    _this.setFocusForCurrentMonthOryear();
                }
            });
            $('.bs-datepicker-body, .bs-datepicker-action-buttons').click(function (event) {
                event.stopPropagation();
                // check for original mouse click
                if (event.originalEvent) {
                    _this.setFocusForMonthOrDay();
                }
            });
        };
        /**
         * This method sets focus for months/days depending on the loaded datepicker table
         */
        BaseDateTimeComponent.prototype.setFocusForMonthOrDay = function () {
            var activeMonthOrYear = $(".bs-datepicker-head .current").first().text();
            var datePickerBody = $('.bs-datepicker-body');
            if (datePickerBody.find('table.months').length > 0) {
                if (_.parseInt(activeMonthOrYear) !== this.activeDate.getFullYear()) {
                    this.loadMonths();
                }
                var newDate = new Date(_.parseInt(activeMonthOrYear), this.activeDate.getMonth(), this.activeDate.getDate());
                this.setActiveMonthFocus(newDate, true);
            }
            else if (datePickerBody.find('table.days').length > 0) {
                var newMonth = months.indexOf(activeMonthOrYear);
                if (newMonth !== this.activeDate.getMonth()) {
                    this.loadDays();
                }
                var newDate = new Date(this.activeDate.getFullYear(), newMonth, 1);
                this.setActiveDateFocus(newDate, true);
            }
        };
        /**
         * This method sets focus for months/years depending on the loaded datepicker table
         */
        BaseDateTimeComponent.prototype.setFocusForCurrentMonthOryear = function () {
            var datePickerBody = $('.bs-datepicker-body');
            if (datePickerBody.find('table.months').length > 0) {
                this.loadMonths();
                this.setActiveMonthFocus(this.activeDate, true);
            }
            else if (datePickerBody.find('table.years').length > 0) {
                this.loadYears();
                this.setActiveYearFocus(this.activeDate, true);
            }
        };
        /**
         * This method sets focus for months/years/days depending on the loaded datepicker table
         */
        BaseDateTimeComponent.prototype.setFocusForDate = function (count) {
            var datePickerBody = $('.bs-datepicker-body');
            if (datePickerBody.find('table.months').length > 0) {
                this.loadMonths();
                var newDate = new Date(this.activeDate.getFullYear() + count, 0, this.activeDate.getDate());
                this.setActiveMonthFocus(newDate, true);
            }
            else if (datePickerBody.find('table.years').length > 0) {
                this.loadYears();
                var startYear = datePickerBody.find('table.years span').first().text();
                var newDate = new Date(_.parseInt(startYear), this.activeDate.getMonth(), this.activeDate.getDate());
                this.setActiveYearFocus(newDate, true);
            }
            else if (datePickerBody.find('table.days').length > 0) {
                this.loadDays();
                var newDate = new Date(this.activeDate.getFullYear(), this.activeDate.getMonth() + count, 1);
                this.setActiveDateFocus(newDate, true);
            }
        };
        /**
         * This method is used to add keyboard events while opening the date picker
         * @param scope - scope of the date/datetime widget
         * @param isDateTime - boolean value represents the loaded widget is date or datetime
         */
        BaseDateTimeComponent.prototype.addDatepickerKeyboardEvents = function (scope, isDateTime) {
            var _this = this;
            this.keyEventPluginInstance = scope.keyEventPlugin.constructor;
            this.elementScope = scope;
            var dateContainer = document.querySelector("." + scope.dateContainerCls);
            core$1.setAttr(dateContainer, 'tabindex', '0');
            dateContainer.onkeydown = function (event) {
                var action = _this.keyEventPluginInstance.getEventFullKey(event);
                // Check for Shift+Tab key or Tab key or escape
                if (action === 'shift.tab' || action === 'escape' || (action === 'tab' && !isDateTime)) {
                    _this.elementScope.hideDatepickerDropdown();
                    var displayInputElem_1 = _this.elementScope.nativeElement.querySelector('.display-input');
                    setTimeout(function () { return displayInputElem_1.focus(); });
                }
                if (action === 'tab' && isDateTime) {
                    _this.bsDatePickerDirective.hide();
                    _this.elementScope.toggleTimePicker(true);
                }
            };
            this.loadDays();
            this.setActiveDateFocus(this.activeDate);
        };
        /**
         * This method is used to add tabindex, keybord and mouse events for days
         */
        BaseDateTimeComponent.prototype.loadDays = function () {
            var _this = this;
            setTimeout(function () {
                $('.bs-datepicker-body').attr('tabindex', '0');
                $('[bsdatepickerdaydecorator]').not('.is-other-month').attr('tabindex', '0');
                _this.addKeyBoardEventsForDays();
                _this.addDatepickerMouseEvents();
            });
        };
        /**
         * This method sets keyboard events for days
         */
        BaseDateTimeComponent.prototype.addKeyBoardEventsForDays = function () {
            var _this = this;
            var datePickerBody = $('.bs-datepicker-body');
            datePickerBody.keydown(function (event) {
                var action = _this.keyEventPluginInstance.getEventFullKey(event);
                var newdate;
                if (action === 'arrowdown') {
                    event.preventDefault();
                    newdate = moment(_this.activeDate).add(+7, 'days').toDate();
                    _this.setActiveDateFocus(newdate);
                }
                else if (action === 'arrowup') {
                    event.preventDefault();
                    newdate = moment(_this.activeDate).add(-7, 'days').toDate();
                    _this.setActiveDateFocus(newdate);
                }
                else if (action === 'arrowleft') {
                    newdate = moment(_this.activeDate).add(-1, 'days').toDate();
                    _this.setActiveDateFocus(newdate);
                }
                else if (action === 'arrowright') {
                    newdate = moment(_this.activeDate).add(+1, 'days').toDate();
                    _this.setActiveDateFocus(newdate);
                }
                else if (action === 'pageup') {
                    event.preventDefault();
                    newdate = moment(_this.activeDate).add(-1, 'month').toDate();
                    _this.setActiveDateFocus(newdate);
                }
                else if (action === 'pagedown') {
                    event.preventDefault();
                    newdate = moment(_this.activeDate).add(+1, 'month').toDate();
                    _this.setActiveDateFocus(newdate);
                }
                else if (action === 'control.arrowup') {
                    // clicking on table header month name to load list of months
                    $('.bs-datepicker-head .current').first().click();
                    _this.loadMonths();
                    _this.setActiveMonthFocus(_this.activeDate);
                }
                else if (action === 'enter') {
                    if ($(document.activeElement).hasClass('disabled')) {
                        return;
                    }
                    $(document.activeElement).click();
                    _this.elementScope.hideDatepickerDropdown();
                    var displayInputElem_2 = _this.elementScope.nativeElement.querySelector('.display-input');
                    setTimeout(function () { return displayInputElem_2.focus(); });
                }
            });
        };
        /**
         * This method is used to add tabindex, keybord and mouse events for months
         */
        BaseDateTimeComponent.prototype.loadMonths = function () {
            var _this = this;
            setTimeout(function () {
                var datePickerBody = $('.bs-datepicker-body');
                datePickerBody.attr('tabindex', '0');
                datePickerBody.find('table.months span').attr('tabindex', '0');
                _this.addKeyBoardEventsForMonths();
                _this.addDatepickerMouseEvents();
            });
        };
        /**
         * This method sets keyboard events for months
         */
        BaseDateTimeComponent.prototype.addKeyBoardEventsForMonths = function () {
            var _this = this;
            $('.bs-datepicker-body').keydown(function (event) {
                var action = _this.keyEventPluginInstance.getEventFullKey(event);
                var newdate;
                if (action === 'arrowdown') {
                    event.preventDefault();
                    newdate = moment(_this.activeDate).add(+3, 'month').toDate();
                    _this.setActiveMonthFocus(newdate);
                }
                else if (action === 'arrowup') {
                    event.preventDefault();
                    newdate = moment(_this.activeDate).add(-3, 'month').toDate();
                    _this.setActiveMonthFocus(newdate);
                }
                else if (action === 'arrowleft') {
                    newdate = moment(_this.activeDate).add(-1, 'month').toDate();
                    _this.setActiveMonthFocus(newdate);
                }
                else if (action === 'arrowright') {
                    newdate = moment(_this.activeDate).add(+1, 'month').toDate();
                    _this.setActiveMonthFocus(newdate);
                }
                else if (action === 'control.arrowup') {
                    // clicking on table header year to load list of years
                    $('.bs-datepicker-head .current').first().click();
                    _this.loadYears();
                    _this.setActiveYearFocus(_this.activeDate);
                }
                else if (action === 'control.arrowdown' || action === 'enter') {
                    if ($(document.activeElement).parent().hasClass('disabled')) {
                        return;
                    }
                    $(document.activeElement).click();
                    _this.loadDays();
                    var newDate = new Date(_this.activeDate.getFullYear(), _this.activeDate.getMonth(), 1);
                    _this.setActiveDateFocus(newDate);
                }
            });
        };
        /**
         * This method is used to add tabindex, keybord and mouse events for years
         */
        BaseDateTimeComponent.prototype.loadYears = function () {
            var _this = this;
            setTimeout(function () {
                var datePickerBody = $('.bs-datepicker-body');
                datePickerBody.attr('tabindex', '0');
                datePickerBody.find('table.years span').attr('tabindex', '0');
                _this.addKeyBoardEventsForYears();
                _this.addDatepickerMouseEvents();
            });
        };
        /**
         * This method is used to set focus for active month
         */
        BaseDateTimeComponent.prototype.setActiveMonthFocus = function (newDate, isMoouseEvent) {
            var _this = this;
            var newMonth = months[newDate.getMonth()];
            // check for keyboard event
            if (!isMoouseEvent) {
                if (newDate.getFullYear() < this.activeDate.getFullYear()) {
                    this.goToOtherMonthOryear('previous', 'month');
                }
                else if (newDate.getFullYear() > this.activeDate.getFullYear()) {
                    this.goToOtherMonthOryear('next', 'month');
                }
            }
            setTimeout(function () {
                $(".bs-datepicker-body table.months span:contains(" + newMonth + ")").focus();
                _this.activeDate = newDate;
            });
        };
        /**
         * This method sets keyboard events for years
         */
        BaseDateTimeComponent.prototype.addKeyBoardEventsForYears = function () {
            var _this = this;
            $('.bs-datepicker-body').keydown(function (event) {
                var action = _this.keyEventPluginInstance.getEventFullKey(event);
                var newdate;
                if (action === 'arrowdown') {
                    event.preventDefault();
                    newdate = moment(_this.activeDate).add(+4, 'year').toDate();
                    _this.setActiveYearFocus(newdate);
                }
                else if (action === 'arrowup') {
                    event.preventDefault();
                    newdate = moment(_this.activeDate).add(-4, 'year').toDate();
                    _this.setActiveYearFocus(newdate);
                }
                else if (action === 'arrowleft') {
                    newdate = moment(_this.activeDate).add(-1, 'year').toDate();
                    _this.setActiveYearFocus(newdate);
                }
                else if (action === 'arrowright') {
                    newdate = moment(_this.activeDate).add(+1, 'year').toDate();
                    _this.setActiveYearFocus(newdate);
                }
                else if (action === 'control.arrowdown' || action === 'enter') {
                    if ($(document.activeElement).parent().hasClass('disabled')) {
                        return;
                    }
                    $(document.activeElement).click();
                    _this.loadMonths();
                    _this.setActiveMonthFocus(_this.activeDate);
                }
            });
        };
        /**
         * This method is used to set focus for active year
         */
        BaseDateTimeComponent.prototype.setActiveYearFocus = function (newDate, isMouseEvent) {
            var _this = this;
            var newYear = newDate.getFullYear();
            var datePickerYears = $('.bs-datepicker-body table.years span');
            var startYear = datePickerYears.first().text();
            var endYear = datePickerYears.last().text();
            // check for keyboard event
            if (!isMouseEvent) {
                if (newDate.getFullYear() < _.parseInt(startYear)) {
                    this.goToOtherMonthOryear('previous', 'year');
                }
                else if (newDate.getFullYear() > _.parseInt(endYear)) {
                    this.goToOtherMonthOryear('next', 'year');
                }
            }
            setTimeout(function () {
                $(".bs-datepicker-body table.years span:contains(" + newYear + ")").focus();
                _this.activeDate = newDate;
            });
        };
        /**
         * This method sets focus for timepicker first input field(hours field) while opening time picker
         * @param scope - scope of the time picker widget
         */
        BaseDateTimeComponent.prototype.focusTimePickerPopover = function (scope) {
            this.keyEventPluginInstance = scope.keyEventPlugin.constructor;
            this.elementScope = scope;
            // setTimeout is used so that by then time input has the updated value. focus is setting back to the input field
            this.elementScope.ngZone.runOutsideAngular(function () {
                setTimeout(function () {
                    $('timepicker .form-group').first().find('> input.form-control').focus();
                });
            });
        };
        /**
         * This function sets the keyboard events to Timepicker popup
         */
        BaseDateTimeComponent.prototype.bindTimePickerKeyboardEvents = function () {
            var _this = this;
            setTimeout(function () {
                var $timepickerPopup = $('body').find('> bs-dropdown-container timepicker');
                $timepickerPopup.attr('tabindex', 0);
                _this.addEventsOnTimePicker($timepickerPopup);
            });
        };
        /**
         * This function checks whether the given date is valid or not
         * @returns boolean value, true if date is valid else returns false
         */
        BaseDateTimeComponent.prototype.isValidDate = function (date) {
            return date && date instanceof Date && !isNaN(date.getTime());
        };
        /**
         * This function checks whether the given time is valid or not
         */
        BaseDateTimeComponent.prototype.timeFormatValidation = function () {
            var enteredDate = $(this.nativeElement).find('input').val();
            var newVal = core$1.getNativeDateObject(enteredDate, { meridians: this.meridians, pattern: this.datepattern });
            if (!this.formatValidation(newVal, enteredDate)) {
                return;
            }
            this.invalidDateTimeFormat = false;
            this.invokeOnChange(this.datavalue, undefined, false);
        };
        BaseDateTimeComponent.prototype.updateTimeValue = function (value, fieldName) {
            var _this = this;
            if (value.length < 2) {
                setTimeout(function () {
                    fieldName === 'minutes' ? _this.bsTimePicker.updateMinutes('00') : _this.bsTimePicker.updateSeconds('00');
                }, 500);
            }
            else {
                fieldName === 'minutes' ? this.bsTimePicker.updateMinutes('00') : this.bsTimePicker.updateSeconds('00');
            }
        };
        /**
         * This function sets the events to given element
         * @param $el - element on which the event is added
         */
        BaseDateTimeComponent.prototype.addEventsOnTimePicker = function ($el) {
            var _this = this;
            var inputFields = $el.find('.bs-timepicker-field');
            // WMS-19382: update minutes and seconds to 0 when we enter hour value
            inputFields.first().on('keyup', function (evt) {
                var hourValue = evt.target.value;
                _.forEach(inputFields, function (field, index) {
                    if (evt.target !== field && field.value === '' && hourValue.length) {
                        var fieldName = index === 1 ? 'minutes' : 'seconds';
                        _this.updateTimeValue(hourValue, fieldName);
                    }
                });
            });
            this.removeKeyupListener = function () {
                inputFields.first().off('keyup');
            };
            $el.on('keydown', function (evt) {
                var $target = $(evt.target);
                var $parent = $target.parent();
                var elementScope = _this.elementScope;
                var action = _this.keyEventPluginInstance.getEventFullKey(evt);
                var stopPropogation, preventDefault;
                if (action === 'escape') {
                    elementScope.hideTimepickerDropdown();
                }
                if ($target.hasClass('bs-timepicker-field')) {
                    if ($parent.is(':first-child')) {
                        if (action === 'shift.tab' || action === 'enter' || action === 'escape') {
                            elementScope.setIsTimeOpen(false);
                            _this.focus();
                            stopPropogation = true;
                            preventDefault = true;
                        }
                    }
                    else if ($parent.is(':last-child') || ($parent.next().next().find('button.disabled').length)) {
                        if (action === 'tab' || action === 'escape' || action === 'enter') {
                            elementScope.setIsTimeOpen(false);
                            _this.focus();
                            stopPropogation = true;
                            preventDefault = true;
                        }
                    }
                    else {
                        if (action === 'enter' || action === 'escape') {
                            elementScope.setIsTimeOpen(false);
                            _this.focus();
                            stopPropogation = true;
                            preventDefault = true;
                        }
                    }
                    if (stopPropogation) {
                        evt.stopPropagation();
                    }
                    if (preventDefault) {
                        evt.preventDefault();
                    }
                    if (elementScope.mintime && elementScope.maxtime && !_this.isValidDate(elementScope.bsTimeValue)) {
                        if (action === 'arrowdown') {
                            elementScope.bsTimeValue = elementScope.maxTime;
                        }
                        else if (action === 'arrowup') {
                            elementScope.bsTimeValue = elementScope.minTime;
                        }
                    }
                    if (action === 'tab') {
                        _this.invalidDateTimeFormat = false;
                        _this.invokeOnChange(_this.datavalue, undefined, false);
                        var pattern = _this.datepattern || _this.timepattern;
                        if (core$1.getFormattedDate(elementScope.datePipe, elementScope.bsTimeValue, pattern) === elementScope.displayValue) {
                            $(_this.nativeElement).find('.display-input').val(elementScope.displayValue);
                        }
                    }
                    if (action === 'arrowdown' || action === 'arrowup') {
                        _this.timeFormatValidation();
                    }
                }
                else if ($target.hasClass('btn-default')) {
                    if (action === 'tab' || action === 'escape') {
                        elementScope.setIsTimeOpen(false);
                        _this.focus();
                    }
                }
            });
            $el.find('a').on('click', function (evt) {
                var elementScope = _this.elementScope;
                var $target = $(evt.target);
                if (elementScope.mintime && elementScope.maxtime && !_this.isValidDate(elementScope.bsTimeValue)) {
                    if ($target.find('span').hasClass('bs-chevron-down')) {
                        elementScope.bsTimeValue = elementScope.maxTime;
                    }
                    else if ($target.find('span').hasClass('bs-chevron-up')) {
                        elementScope.bsTimeValue = elementScope.minTime;
                    }
                }
                _this.timeFormatValidation();
            });
        };
        BaseDateTimeComponent.prototype.updateFormat = function (pattern) {
            if (pattern === 'datepattern') {
                this._dateOptions.dateInputFormat = this.datepattern;
                this.showseconds = _.includes(this.datepattern, 's');
                this.ismeridian = _.includes(this.datepattern, 'h');
            }
            else if (pattern === 'timepattern') {
                this.showseconds = _.includes(this.timepattern, 's');
                this.ismeridian = _.includes(this.timepattern, 'h');
            }
        };
        BaseDateTimeComponent.prototype.getMobileInput = function () {
            return this.nativeElement.querySelector('.mobile-input');
        };
        BaseDateTimeComponent.prototype.onDateTimeInputBlur = function () {
            // removing the opacity on blur of the mobile widget
            var displayInputElem = this.getMobileInput();
            if (displayInputElem && !core$1.hasCordova()) {
                var children = this.nativeElement.children;
                for (var i = 0; i < children.length; i++) {
                    children[i].classList.remove('add-opacity');
                }
                displayInputElem.classList.remove('remove-opacity');
            }
        };
        BaseDateTimeComponent.prototype.onDateTimeInputFocus = function (skipFocus) {
            if (skipFocus === void 0) { skipFocus = false; }
            var displayInputElem = this.getMobileInput();
            // toggling the classes to show and hide the native widget using opacity
            if (skipFocus && !core$1.hasCordova()) {
                var children = this.nativeElement.children;
                for (var i = 0; i < children.length; i++) {
                    children[i].classList.add('add-opacity');
                }
                displayInputElem.classList.add('remove-opacity');
                return;
            }
            if (displayInputElem) {
                displayInputElem.focus();
                displayInputElem.click();
            }
        };
        BaseDateTimeComponent.prototype.onPropertyChange = function (key, nv, ov) {
            if (key === 'tabindex') {
                return;
            }
            if (key === 'required') {
                this._onChange(this.datavalue);
                return;
            }
            if (key === 'datepattern') {
                this.updateFormat(key);
            }
            else if (key === 'showweeks') {
                this._dateOptions.showWeekNumbers = nv;
            }
            else if (key === 'mindate') {
                this._dateOptions.minDate = (nv === CURRENT_DATE) ? this.mindate = new Date() : core$1.getDateObj(nv);
                this.minDateMaxDateValidationOnInput(this.datavalue);
            }
            else if (key === 'maxdate') {
                this._dateOptions.maxDate = (nv === CURRENT_DATE) ? this.maxdate = new Date() : core$1.getDateObj(nv);
                this.minDateMaxDateValidationOnInput(this.datavalue);
            }
            else if (key === 'excludedates' || key === 'excludedays') {
                if (this.excludedays) {
                    this.excludedDaysToDisable = _.split(this.excludedays, ',').map(function (day) {
                        return +day;
                    });
                }
                if (this.excludedates) {
                    this.excludedDatesToDisable = this.excludedates;
                    if (core$1.isString(this.excludedates)) {
                        this.excludedDatesToDisable = _.split(this.excludedates, ',');
                    }
                    this.excludedDatesToDisable = this.excludedDatesToDisable.map(function (d) { return core$1.getDateObj(d); });
                }
                this.minDateMaxDateValidationOnInput(this.datavalue);
            }
            else if (key === 'selectfromothermonth') {
                this._dateOptions.selectFromOtherMonth = nv;
            }
            else if (key === 'todaybutton') {
                this._dateOptions.showTodayButton = nv;
            }
            else if (key === 'clearbutton') {
                this._dateOptions.showClearButton = nv;
            }
            else if (key === 'todaybuttonlabel') {
                this._dateOptions.todayButtonLabel = this.i18nService.getLocalizedMessage(nv) || nv;
            }
            else if (key === 'clearbuttonlabel') {
                this._dateOptions.clearButtonLabel = this.i18nService.getLocalizedMessage(nv) || nv;
            }
            else {
                _super.prototype.onPropertyChange.call(this, key, nv, ov);
            }
        };
        BaseDateTimeComponent.prototype.ngAfterViewInit = function () {
            _super.prototype.ngAfterViewInit.call(this);
            this.containerTarget = base.getContainerTargetClass(this.nativeElement);
            this.isReadOnly = this.dataentrymode != 'undefined' && !this.isDataEntryModeEnabledOnInput(this.dataentrymode);
        };
        BaseDateTimeComponent.prototype.ngOnDestroy = function () {
            if (this.dateOnShowSubscription) {
                this.dateOnShowSubscription.unsubscribe();
            }
            _super.prototype.ngOnDestroy.call(this);
        };
        BaseDateTimeComponent.ctorParameters = function () { return [
            { type: core.Injector },
            null
        ]; };
        __decorate([
            core.ViewChild(dropdown.BsDropdownDirective),
            __metadata("design:type", Object)
        ], BaseDateTimeComponent.prototype, "bsDropdown", void 0);
        __decorate([
            core.ViewChild(timepicker.TimepickerComponent),
            __metadata("design:type", Object)
        ], BaseDateTimeComponent.prototype, "bsTimePicker", void 0);
        BaseDateTimeComponent = __decorate([
            core.Directive(),
            __metadata("design:paramtypes", [core.Injector, Object])
        ], BaseDateTimeComponent);
        return BaseDateTimeComponent;
    }(input.BaseFormCustomComponent));

    var dateProps = new Map([
        ['autofocus', base.PROP_BOOLEAN],
        ['class', base.PROP_STRING],
        ['dataentrymode', __assign({ value: 'default' }, base.PROP_STRING)],
        ['datavaluesource', base.PROP_ANY],
        ['datavalue', base.PROP_STRING],
        ['datepattern', base.PROP_STRING],
        ['disabled', base.PROP_BOOLEAN],
        ['excludedays', base.PROP_STRING],
        ['excludedates', base.PROP_STRING],
        ['hint', base.PROP_STRING],
        ['maxdate', base.PROP_STRING],
        ['mindate', base.PROP_STRING],
        ['name', base.PROP_STRING],
        ['outputformat', __assign({ value: 'yyyy-MM-dd' }, base.PROP_STRING)],
        ['placeholder', __assign({ value: 'Select Date' }, base.PROP_STRING)],
        ['readonly', base.PROP_BOOLEAN],
        ['required', base.PROP_BOOLEAN],
        ['shortcutkey', base.PROP_STRING],
        ['show', __assign({ value: true }, base.PROP_BOOLEAN)],
        ['showdropdownon', __assign({ value: 'default' }, base.PROP_STRING)],
        ['showbuttonbar', __assign({ value: true }, base.PROP_BOOLEAN)],
        ['showindevice', __assign({ displayType: 'inline-block', value: 'all' }, base.PROP_STRING)],
        ['showweeks', __assign({ value: false }, base.PROP_BOOLEAN)],
        ['tabindex', __assign({ value: 0 }, base.PROP_NUMBER)],
        ['selectfromothermonth', __assign({ value: true }, base.PROP_BOOLEAN)],
        ['todaybutton', __assign({ value: true }, base.PROP_BOOLEAN)],
        ['clearbutton', __assign({ value: true }, base.PROP_BOOLEAN)],
        ['todaybuttonlabel', __assign({ value: 'LABEL_TODAY_DATE' }, base.PROP_STRING)],
        ['clearbuttonlabel', __assign({ value: 'LABEL_CLEAR_DATE' }, base.PROP_STRING)]
    ]);
    var registerProps = function () {
        base.register('wm-date', dateProps);
        base.registerFormWidget(core$1.FormWidgetType.DATE, new Map(dateProps));
    };

    var CURRENT_DATE$1 = 'CURRENT_DATE';
    var DEFAULT_CLS = 'app-date input-group';
    var WIDGET_CONFIG = {
        widgetType: 'wm-date',
        hostClass: DEFAULT_CLS
    };
    var DateComponent = /** @class */ (function (_super) {
        __extends(DateComponent, _super);
        // TODO use BsLocaleService to set the current user's locale to see the localized labels
        function DateComponent(inj, cdRef, appDefaults, evtMngrPlugins) {
            var _this = _super.call(this, inj, WIDGET_CONFIG) || this;
            _this.cdRef = cdRef;
            _this.appDefaults = appDefaults;
            _this.isEnterPressedOnDateInput = false;
            base.styler(_this.nativeElement, _this);
            // KeyEventsPlugin
            _this.keyEventPlugin = evtMngrPlugins[1];
            _this.dateContainerCls = "app-date-" + _this.widgetId;
            _this._dateOptions.containerClass = "app-date " + _this.dateContainerCls;
            _this._dateOptions.showWeekNumbers = false;
            _this.datepattern = _this.appDefaults.dateFormat || core$1.getDisplayDateTimeFormat(core$1.FormWidgetType.DATE);
            _this.updateFormat('datepattern');
            return _this;
        }
        DateComponent_1 = DateComponent;
        Object.defineProperty(DateComponent.prototype, "timestamp", {
            get: function () {
                return this.bsDataValue ? this.bsDataValue.valueOf() : undefined;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DateComponent.prototype, "dateInputFormat", {
            get: function () {
                return this._dateOptions.dateInputFormat || 'yyyy-MM-dd';
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DateComponent.prototype, "displayValue", {
            get: function () {
                return core$1.getFormattedDate(this.datePipe, this.bsDataValue, this.dateInputFormat) || '';
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DateComponent.prototype, "nativeDisplayValue", {
            get: function () {
                return core$1.getFormattedDate(this.datePipe, this.bsDataValue, 'yyyy-MM-dd') || '';
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DateComponent.prototype, "datavalue", {
            get: function () {
                return core$1.getFormattedDate(this.datePipe, this.bsDataValue, this.outputformat) || '';
            },
            // Todo[Shubham]: needs to be redefined
            // sets the dataValue and computes the display model values
            set: function (newVal) {
                if (newVal === CURRENT_DATE$1) {
                    this.bsDataValue = new Date();
                }
                else {
                    this.bsDataValue = newVal ? core$1.getDateObj(newVal) : undefined;
                }
                // update the previous datavalue.
                this.invokeOnChange(this.datavalue, undefined, true);
                this.cdRef.detectChanges();
            },
            enumerable: true,
            configurable: true
        });
        /**
         * This is an internal method triggered when the date input changes
         */
        DateComponent.prototype.onDisplayDateChange = function ($event, isNativePicker) {
            if (this.isEnterPressedOnDateInput) {
                this.isEnterPressedOnDateInput = false;
                return;
            }
            var newVal = core$1.getDateObj($event.target.value, { pattern: this.datepattern });
            // date pattern validation
            // if invalid pattern is entered, device is showing an error.
            if (!this.formatValidation(newVal, $event.target.value, isNativePicker)) {
                return;
            }
            // min date and max date validation in mobile view.
            // if invalid dates are entered, device is showing an alert.
            if (isNativePicker && this.minDateMaxDateValidationOnInput(newVal, $event, this.displayValue, isNativePicker)) {
                return;
            }
            this.setDataValue(newVal);
        };
        // sets the dataValue and computes the display model values
        DateComponent.prototype.setDataValue = function (newVal) {
            this.invalidDateTimeFormat = false;
            // min date and max date validation in web.
            // if invalid dates are entered, device is showing validation message.
            this.minDateMaxDateValidationOnInput(newVal);
            if (core$1.getFormattedDate(this.datePipe, newVal, this.dateInputFormat) === this.displayValue) {
                $(this.nativeElement).find('.display-input').val(this.displayValue);
            }
            if (newVal) {
                this.bsDataValue = newVal;
            }
            else {
                this.bsDataValue = undefined;
            }
            this.invokeOnChange(this.datavalue, {}, true);
        };
        DateComponent.prototype.onDatePickerOpen = function () {
            this.isOpen = true;
            this.bsDataValue ? this.activeDate = this.bsDataValue : this.activeDate = new Date();
            if (!this.bsDataValue) {
                this.hightlightToday();
            }
            // We are using the two input tags(To maintain the modal and proxy modal) for the date control.
            // So actual bootstrap input target width we made it to 0, so bootstrap calculating the calendar container top position improperly.
            // To fix the container top position set the width 1px;
            this.$element.find('.model-holder').width('1px');
            this.addDatepickerKeyboardEvents(this, false);
            core$1.adjustContainerPosition($('bs-datepicker-container'), this.nativeElement, this.bsDatePickerDirective._datepicker);
            core$1.adjustContainerRightEdges($('bs-datepicker-container'), this.nativeElement, this.bsDatePickerDirective._datepicker);
        };
        DateComponent.prototype.onInputBlur = function ($event) {
            if (!$($event.relatedTarget).hasClass('current-date')) {
                this.invokeOnTouched();
                this.invokeEventCallback('blur', { $event: $event });
            }
        };
        DateComponent.prototype.hideDatepickerDropdown = function () {
            this.invokeOnTouched();
            this.isOpen = false;
            this.isEnterPressedOnDateInput = false;
            if (this.deregisterEventListener) {
                this.deregisterEventListener();
            }
        };
        // change and blur events are added from the template
        DateComponent.prototype.handleEvent = function (node, eventName, callback, locals) {
            if (!_.includes(['blur', 'focus', 'change', 'click'], eventName)) {
                _super.prototype.handleEvent.call(this, node, eventName, callback, locals);
            }
        };
        /**
         * This is an internal method used to toggle the dropdown of the date widget
         */
        DateComponent.prototype.toggleDpDropdown = function ($event) {
            if (core$1.isMobile()) {
                this.onDateTimeInputFocus();
                return;
            }
            if ($event.type === 'click') {
                this.invokeEventCallback('click', { $event: $event });
            }
            if ($event.target && $($event.target).is('input') && !(this.isDropDownDisplayEnabledOnInput(this.showdropdownon))) {
                $event.stopPropagation();
                return;
            }
            this.bsDatePickerDirective.toggle();
            this.addBodyClickListener(this.bsDatePickerDirective.isOpen);
        };
        DateComponent.prototype.addBodyClickListener = function (skipListener) {
            var _this = this;
            if (!skipListener) {
                return;
            }
            var bodyElement = document.querySelector('body');
            setTimeout(function () {
                var bsDateContainerElement = bodyElement.querySelector("." + _this.dateContainerCls);
                _this.deregisterEventListener = core$1.addEventListenerOnElement(bodyElement, bsDateContainerElement, _this.nativeElement, 'click', _this.isDropDownDisplayEnabledOnInput(_this.showdropdownon), function () {
                    _this.isOpen = false;
                }, 0 /* ONCE */, true);
            }, 350);
        };
        /**
         * This is an internal method triggered when pressing key on the date input
         */
        DateComponent.prototype.onDisplayKeydown = function (event) {
            if (this.isDropDownDisplayEnabledOnInput(this.showdropdownon)) {
                event.stopPropagation();
                var action = this.keyEventPlugin.constructor.getEventFullKey(event);
                if (action === 'enter' || action === 'arrowdown') {
                    var newVal = core$1.getDateObj(event.target.value, { pattern: this.datepattern });
                    event.preventDefault();
                    var formattedDate = core$1.getFormattedDate(this.datePipe, newVal, this.dateInputFormat);
                    var inputVal = event.target.value.trim();
                    if (inputVal && this.datepattern === 'timestamp') {
                        if (!_.isNaN(inputVal) && _.parseInt(inputVal) !== formattedDate) {
                            this.invalidDateTimeFormat = true;
                            this.invokeOnChange(this.datavalue, event, false);
                        }
                    }
                    else if (inputVal && inputVal !== formattedDate) {
                        this.invalidDateTimeFormat = true;
                        this.invokeOnChange(this.datavalue, event, false);
                    }
                    else {
                        this.invalidDateTimeFormat = false;
                        this.isEnterPressedOnDateInput = true;
                        this.bsDatePickerDirective.bsValue = newVal;
                    }
                    this.toggleDpDropdown(event);
                }
                else {
                    this.hideDatepickerDropdown();
                }
            }
            else {
                this.hideDatepickerDropdown();
            }
        };
        /**
         * This is an internal method triggered when the date selection changes
         */
        DateComponent.prototype.onDateChange = function (newVal) {
            var displayInputElem = this.nativeElement.querySelector('.display-input');
            if (this.isOpen) {
                setTimeout(function () { return displayInputElem.focus(); });
            }
            this.setDataValue(newVal);
        };
        var DateComponent_1;
        DateComponent.initializeProps = registerProps();
        DateComponent.ctorParameters = function () { return [
            { type: core.Injector },
            { type: core.ChangeDetectorRef },
            { type: core$1.AppDefaults },
            { type: undefined, decorators: [{ type: core.Inject, args: [platformBrowser.EVENT_MANAGER_PLUGINS,] }] }
        ]; };
        __decorate([
            core.ViewChild(datepicker.BsDatepickerDirective),
            __metadata("design:type", Object)
        ], DateComponent.prototype, "bsDatePickerDirective", void 0);
        DateComponent = DateComponent_1 = __decorate([
            core.Component({
                selector: '[wmDate]',
                template: "    <input class=\"form-control app-textbox app-dateinput display-input\"\n        aria-label=\"Select date\"\n        focus-target\n        type=\"text\"\n        [name]=\"name\"\n        [tabindex]=\"tabindex\"\n        [value]=\"displayValue\"\n        (click)=\"toggleDpDropdown($event)\"\n        (focus)=\"invokeOnFocus($event)\"\n        (blur)=\"onInputBlur($event)\"\n        [disabled]=\"disabled || readonly\"\n        [autofocus]=\"autofocus\"\n        [required]=\"required\"\n        [readOnly]=\"isReadOnly\"\n        [attr.placeholder]=\"placeholder\"\n        [attr.accesskey]=\"shortcutkey\"\n        (change)=\"onDisplayDateChange($event)\"\n        (keydown)=\"onDisplayKeydown($event)\">\n    <div style=\"width: 0;display: inline-block;\"\n        aria-label=\"datepicker dropdownmenu\"\n        aria-controls=\"date\">\n        <input class=\"model-holder\"\n            [container]=\"containerTarget || 'body'\"\n            [bsConfig]=\"_dateOptions\"\n            [isOpen]=\"isOpen\"\n            #datepicker=\"bsDatepicker\"\n            bsDatepicker\n            [daysDisabled]=\"excludedDaysToDisable\"\n            [datesDisabled]=\"excludedDatesToDisable\"\n            placement=\"bottom right\"\n            [isDisabled]=\"disabled || readonly\"\n            [bsValue]=\"bsDataValue\"\n            (onShown)=\"onDatePickerOpen()\"\n            (onHidden)=\"hideDatepickerDropdown()\"\n            (bsValueChange)=\"onDateChange($event)\">\n    </div>\n    <span class=\"input-group-btn\">\n        <button type=\"button\"\n            class=\"btn btn-default btn-time\"\n            [tabindex]=\"tabindex\"\n            [disabled]=\"disabled || readonly\"\n            aria-label=\"Select date\"\n            aria-haspopup=\"true\"\n            aria-expanded=\"false\"\n            (click)=\"toggleDpDropdown($event)\">\n            <i aria-hidden=\"true\"\n                class=\"app-icon wi wi-calendar\"></i>\n        </button>\n    </span>\n\n<ng-template [ngIf]=\"loadNativeDateInput\">\n    <input type=\"date\"\n        class=\"form-control app-textbox app-dateinput mobile-input\"\n        role=\"input\"\n        step=\"any\"\n        placeholder=\"yyyy-mm-dd\" [min]=\"mindate | date:'yyyy-MM-dd'\" [max]=\"maxdate | date:'yyyy-MM-dd'\"\n        [value]=\"nativeDisplayValue\"\n        [tabindex]=\"tabindex\"\n        [required]=\"required\"\n        [disabled]=\"disabled || readonly\"\n        (change)=\"onDisplayDateChange($event, true)\"\n        (focus)=\"onDateTimeInputFocus(true); invokeOnFocus($event);\"\n        (blur)=\"onDateTimeInputBlur(); invokeOnTouched($event)\">\n</ng-template>\n",
                providers: [
                    base.provideAs(DateComponent_1, forms.NG_VALUE_ACCESSOR, true),
                    base.provideAs(DateComponent_1, forms.NG_VALIDATORS, true),
                    base.provideAsWidgetRef(DateComponent_1)
                ]
            }),
            __param(3, core.Inject(platformBrowser.EVENT_MANAGER_PLUGINS)),
            __metadata("design:paramtypes", [core.Injector,
                core.ChangeDetectorRef,
                core$1.AppDefaults, Object])
        ], DateComponent);
        return DateComponent;
    }(BaseDateTimeComponent));

    var dateTimeProps = new Map([
        ['autofocus', base.PROP_BOOLEAN],
        ['class', base.PROP_STRING],
        ['dataentrymode', __assign({ value: 'default' }, base.PROP_STRING)],
        ['datavaluesource', base.PROP_ANY],
        ['datavalue', base.PROP_STRING],
        ['datepattern', base.PROP_STRING],
        ['disabled', base.PROP_BOOLEAN],
        ['excludedays', base.PROP_STRING],
        ['excludedates', base.PROP_STRING],
        ['hint', base.PROP_STRING],
        ['hourstep', __assign({ value: 1 }, base.PROP_NUMBER)],
        ['maxdate', base.PROP_STRING],
        ['mindate', base.PROP_STRING],
        ['minutestep', __assign({ value: 15 }, base.PROP_NUMBER)],
        ['name', base.PROP_STRING],
        ['outputformat', __assign({ value: 'timestamp' }, base.PROP_STRING)],
        ['placeholder', __assign({ value: 'Select date time' }, base.PROP_STRING)],
        ['readonly', base.PROP_BOOLEAN],
        ['required', base.PROP_BOOLEAN],
        ['secondsstep', __assign({ value: 1 }, base.PROP_NUMBER)],
        ['shortcutkey', base.PROP_STRING],
        ['show', __assign({ value: true }, base.PROP_BOOLEAN)],
        ['showdropdownon', __assign({ value: 'default' }, base.PROP_STRING)],
        ['showbuttonbar', base.PROP_BOOLEAN],
        ['showindevice', __assign({ displayType: 'inline-block', value: 'all' }, base.PROP_STRING)],
        ['showweeks', base.PROP_BOOLEAN],
        ['tabindex', __assign({ value: 0 }, base.PROP_NUMBER)],
        ['timestamp', base.PROP_STRING],
        ['selectfromothermonth', __assign({ value: true }, base.PROP_BOOLEAN)],
        ['todaybutton', __assign({ value: true }, base.PROP_BOOLEAN)],
        ['clearbutton', __assign({ value: true }, base.PROP_BOOLEAN)],
        ['todaybuttonlabel', __assign({ value: 'LABEL_TODAY_DATE' }, base.PROP_STRING)],
        ['clearbuttonlabel', __assign({ value: 'LABEL_CLEAR_DATE' }, base.PROP_STRING)]
    ]);
    var registerProps$1 = function () {
        base.register('wm-datetime', dateTimeProps);
        base.registerFormWidget(core$1.FormWidgetType.DATETIME, new Map(dateTimeProps));
        base.registerFormWidget(core$1.FormWidgetType.TIMESTAMP, new Map(dateTimeProps));
    };

    var DEFAULT_CLS$1 = 'app-datetime input-group';
    var WIDGET_CONFIG$1 = { widgetType: 'wm-datetime', hostClass: DEFAULT_CLS$1 };
    var CURRENT_DATE$2 = 'CURRENT_DATE';
    var ɵ0 = getTimepickerConfig;
    var DatetimeComponent = /** @class */ (function (_super) {
        __extends(DatetimeComponent, _super);
        function DatetimeComponent(inj, ngZone, cdRef, appDefaults, evtMngrPlugins) {
            var _this = _super.call(this, inj, WIDGET_CONFIG$1) || this;
            _this.ngZone = ngZone;
            _this.cdRef = cdRef;
            _this.appDefaults = appDefaults;
            _this.isEnterPressedOnDateInput = false;
            /**
             * This property checks if the timePicker is Open
             */
            _this.isTimeOpen = false;
            /**
             * This property checks if the datePicker is Open
             */
            _this.isDateOpen = false;
            /**
             * This property is set to TRUE if the time component value is set to CURRENT_TIME; In this case the timer keeps changing the time value until the widget is available.
             */
            _this.isCurrentDate = false;
            _this._debouncedOnChange = _.debounce(_this.invokeOnChange, 10);
            _this.registerDestroyListener(function () { return _this.clearTimeInterval(); });
            base.styler(_this.nativeElement, _this);
            // KeyEventsPlugin
            _this.keyEventPlugin = evtMngrPlugins[1];
            _this.dateContainerCls = "app-date-" + _this.widgetId;
            _this._dateOptions.containerClass = "app-date " + _this.dateContainerCls;
            _this._dateOptions.showWeekNumbers = false;
            _this.datepattern = _this.appDefaults.dateTimeFormat || core$1.getDisplayDateTimeFormat(core$1.FormWidgetType.DATETIME);
            _this.updateFormat('datepattern');
            return _this;
        }
        DatetimeComponent_1 = DatetimeComponent;
        Object.defineProperty(DatetimeComponent.prototype, "timestamp", {
            get: function () {
                return this.proxyModel ? this.proxyModel.valueOf() : undefined;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DatetimeComponent.prototype, "dateInputFormat", {
            get: function () {
                return this._dateOptions.dateInputFormat || 'yyyy-MM-ddTHH:mm:ss';
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DatetimeComponent.prototype, "displayValue", {
            /**
             * The displayValue is the display value of the bsDateTimeValue after applying the datePattern on it.
             * @returns {any|string}
             */
            get: function () {
                return core$1.getFormattedDate(this.datePipe, this.proxyModel, this.dateInputFormat) || '';
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DatetimeComponent.prototype, "nativeDisplayValue", {
            get: function () {
                return core$1.getFormattedDate(this.datePipe, this.proxyModel, 'yyyy-MM-ddTHH:mm:ss') || '';
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DatetimeComponent.prototype, "datavalue", {
            get: function () {
                if (this.isCurrentDate && !this.proxyModel) {
                    return CURRENT_DATE$2;
                }
                return core$1.getFormattedDate(this.datePipe, this.proxyModel, this.outputformat);
            },
            /**Todo[Shubham]: needs to be redefined
             * This property sets the default value for the date selection
             */
            set: function (newVal) {
                if (newVal === CURRENT_DATE$2) {
                    this.isCurrentDate = true;
                    this.setTimeInterval();
                }
                else {
                    this.proxyModel = newVal ? core$1.getDateObj(newVal) : undefined;
                    this.clearTimeInterval();
                    this.isCurrentDate = false;
                }
                this.bsTimeValue = this.bsDateValue = this.proxyModel;
                this.cdRef.detectChanges();
            },
            enumerable: true,
            configurable: true
        });
        /**
         * This is an internal method used to maintain a time interval to update the time model when the data value is set to CURRENT_TIME
         */
        DatetimeComponent.prototype.setTimeInterval = function () {
            var _this = this;
            if (this.timeinterval) {
                return;
            }
            this.timeinterval = setInterval(function () {
                var currentTime = new Date();
                _this.onModelUpdate(currentTime);
            }, 1000);
        };
        /**
         * This is an internal method used to clear the time interval created
         */
        DatetimeComponent.prototype.clearTimeInterval = function () {
            if (this.timeinterval) {
                clearInterval(this.timeinterval);
                this.timeinterval = null;
            }
        };
        /**
         * This is an internal method to toggle the time picker
         */
        DatetimeComponent.prototype.toggleTimePicker = function (newVal, $event) {
            if (core$1.isMobile()) {
                this.onDateTimeInputFocus();
                return;
            }
            this.isTimeOpen = newVal;
            if ($event && $event.type === 'click') {
                this.invokeEventCallback('click', { $event: $event });
            }
            this.addTimepickerClickListener(this.isTimeOpen);
        };
        DatetimeComponent.prototype.addTimepickerClickListener = function (skipListener) {
            var _this = this;
            if (!skipListener) {
                return;
            }
            var bodyElement = document.querySelector('body');
            setTimeout(function () {
                var dropdownElement = $(bodyElement).find('>bs-dropdown-container .dropdown-menu').get(0);
                _this.deregisterTimepickeEventListener = core$1.addEventListenerOnElement(bodyElement, dropdownElement, _this.nativeElement, 'click', _this.isDropDownDisplayEnabledOnInput(_this.showdropdownon), function () {
                    _this.toggleTimePicker(false);
                }, 0 /* ONCE */, true);
            }, 350);
        };
        /**
         * This function sets the value isOpen/isTimeOpen (i.e when datepicker popup is closed) based on widget type(i.e  DateTime, Time)
         * @param val - isOpen/isTimeOpen is set based on the timepicker popup is open/closed
         */
        DatetimeComponent.prototype.setIsTimeOpen = function (val) {
            this.isTimeOpen = val;
        };
        DatetimeComponent.prototype.hideTimepickerDropdown = function () {
            this.invokeOnTouched();
            this.toggleTimePicker(false);
            if (this.deregisterTimepickeEventListener) {
                this.deregisterTimepickeEventListener();
            }
        };
        /**
         * This is an internal method to add a click listener once the time dropdown is open
         */
        DatetimeComponent.prototype.onTimepickerOpen = function () {
            // adding class for time widget dropdown menu
            var tpElements = document.querySelectorAll('timepicker');
            _.forEach(tpElements, function (element) {
                core$1.addClass(element.parentElement, 'app-datetime', true);
            });
            this.bsDatePickerDirective.hide();
            this.focusTimePickerPopover(this);
            this.bindTimePickerKeyboardEvents();
            core$1.adjustContainerPosition($('bs-dropdown-container'), this.nativeElement, this.bsDropdown._dropdown, $('bs-dropdown-container .dropdown-menu'));
            core$1.adjustContainerRightEdges($('bs-dropdown-container'), this.nativeElement, this.bsDropdown._dropdown, $('bs-dropdown-container .dropdown-menu'));
        };
        DatetimeComponent.prototype.onDatePickerOpen = function () {
            this.isDateOpen = !this.isDateOpen;
            this.toggleTimePicker(false);
            // We are using the two input tags(To maintain the modal and proxy modal) for the date control.
            // So actual bootstrap input target width we made it to 0 so bootstrap calculating the calendar container top position impropery.
            // To fix the container top position set the width 1px;
            this.$element.find('.model-holder').width('1px');
            this.bsDateValue ? this.activeDate = this.bsDateValue : this.activeDate = new Date();
            if (!this.bsDateValue) {
                this.hightlightToday();
            }
            this.addDatepickerKeyboardEvents(this, true);
            core$1.adjustContainerPosition($('bs-datepicker-container'), this.nativeElement, this.bsDatePickerDirective._datepicker);
        };
        /**
         * This is an internal method to update the model
         */
        DatetimeComponent.prototype.onModelUpdate = function (newVal, type) {
            if (type === 'date') {
                this.invalidDateTimeFormat = false;
                if (core$1.getFormattedDate(this.datePipe, newVal, this.dateInputFormat) === this.displayValue) {
                    $(this.nativeElement).find('.display-input').val(this.displayValue);
                }
            }
            // min date and max date validation in web.
            // if invalid dates are entered, device is showing validation message.
            this.minDateMaxDateValidationOnInput(newVal);
            if (!newVal) {
                // Set timevalue as 00:00:00 if we remove any one from hours/minutes/seconds field in timepicker after selecting date
                if (this.bsDateValue && this.bsTimePicker && (this.bsTimePicker.hours === '' || this.bsTimePicker.minutes === '' || this.bsTimePicker.seconds === '')) {
                    this.bsDateValue = this.bsTimeValue = this.proxyModel = moment(this.bsDateValue).startOf('day').toDate();
                }
                else {
                    this.bsDateValue = this.bsTimeValue = this.proxyModel = undefined;
                }
                this._debouncedOnChange(this.datavalue, {}, true);
                return;
            }
            if (type === 'date') {
                if (this.isDateOpen) {
                    this.toggleTimePicker(true);
                }
            }
            this.proxyModel = newVal;
            if (this.proxyModel) {
                this.bsDateValue = this.bsTimeValue = this.proxyModel;
            }
            this._debouncedOnChange(this.datavalue, {}, true);
            this.cdRef.detectChanges();
        };
        /**
         * This is an internal method used to Prevent time picker close while changing time value
         */
        DatetimeComponent.prototype.preventTpClose = function ($event) {
            $event.stopImmediatePropagation();
        };
        /**
         * This is an internal method used to toggle the dropdown of the date widget
         */
        DatetimeComponent.prototype.toggleDpDropdown = function ($event) {
            if (core$1.isMobile()) {
                this.onDateTimeInputFocus();
                return;
            }
            if ($event.type === 'click') {
                this.invokeEventCallback('click', { $event: $event });
            }
            if ($event.target && $($event.target).is('input') && !(this.isDropDownDisplayEnabledOnInput(this.showdropdownon))) {
                $event.stopPropagation();
                return;
            }
            this.bsDatePickerDirective.toggle();
            this.addBodyClickListener(this.bsDatePickerDirective.isOpen);
        };
        DatetimeComponent.prototype.addBodyClickListener = function (skipListener) {
            var _this = this;
            if (!skipListener) {
                return;
            }
            var bodyElement = document.querySelector('body');
            setTimeout(function () {
                var bsDateContainerElement = bodyElement.querySelector("." + _this.dateContainerCls);
                _this.deregisterDatepickerEventListener = core$1.addEventListenerOnElement(bodyElement, bsDateContainerElement, _this.nativeElement, 'click', _this.isDropDownDisplayEnabledOnInput(_this.showdropdownon), function () {
                    _this.bsDatePickerDirective.hide();
                }, 0 /* ONCE */, true);
            }, 350);
        };
        DatetimeComponent.prototype.hideDatepickerDropdown = function () {
            this.isDateOpen = false;
            this.invokeOnTouched();
            this.bsDatePickerDirective.hide();
            this.isEnterPressedOnDateInput = false;
            if (this.deregisterDatepickerEventListener) {
                this.deregisterDatepickerEventListener();
            }
        };
        DatetimeComponent.prototype.onDateChange = function ($event, isNativePicker) {
            if (this.isEnterPressedOnDateInput) {
                this.isEnterPressedOnDateInput = false;
                return;
            }
            var newVal = $event.target.value.trim();
            newVal = newVal ? core$1.getNativeDateObject(newVal, { pattern: this.datepattern, meridians: this.meridians }) : undefined;
            // datetime pattern validation
            // if invalid pattern is entered, device is showing an error.
            if (!this.formatValidation(newVal, $event.target.value, isNativePicker)) {
                return;
            }
            // min date and max date validation in mobile view.
            // if invalid dates are entered, device is showing an alert.
            if (isNativePicker && this.minDateMaxDateValidationOnInput(newVal, $event, this.displayValue, isNativePicker)) {
                return;
            }
            this.invalidDateTimeFormat = false;
            this.onModelUpdate(newVal);
        };
        /**
         * This is an internal method triggered when pressing key on the datetime input
         */
        DatetimeComponent.prototype.onDisplayKeydown = function (event) {
            if (this.isDropDownDisplayEnabledOnInput(this.showdropdownon)) {
                event.stopPropagation();
                var newVal = event.target.value.trim();
                var action = this.keyEventPlugin.constructor.getEventFullKey(event);
                if (action === 'enter' || action === 'arrowdown') {
                    newVal = newVal ? core$1.getNativeDateObject(newVal, { pattern: this.datepattern, meridians: this.meridians }) : undefined;
                    event.preventDefault();
                    var formattedDate = core$1.getFormattedDate(this.datePipe, newVal, this.dateInputFormat);
                    var inputVal = event.target.value.trim();
                    if (inputVal && this.datepattern === 'timestamp') {
                        if (!_.isNaN(inputVal) && _.parseInt(inputVal) !== formattedDate) {
                            this.invalidDateTimeFormat = true;
                            this.invokeOnChange(this.datavalue, event, false);
                        }
                    }
                    else if (inputVal && inputVal !== formattedDate) {
                        this.invalidDateTimeFormat = true;
                        this.invokeOnChange(this.datavalue, event, false);
                    }
                    else {
                        this.invalidDateTimeFormat = false;
                        this.isEnterPressedOnDateInput = true;
                        this.bsDatePickerDirective.bsValue = newVal;
                    }
                    this.toggleDpDropdown(event);
                }
                else {
                    this.hideDatepickerDropdown();
                    this.hideTimepickerDropdown();
                }
            }
            else {
                this.hideDatepickerDropdown();
                this.hideTimepickerDropdown();
            }
        };
        DatetimeComponent.prototype.isValid = function (event) {
            if (!event) {
                var enteredDate = $(this.nativeElement).find('input').val();
                var newVal = core$1.getNativeDateObject(enteredDate, { pattern: this.datepattern, meridians: this.meridians });
                if (!this.formatValidation(newVal, enteredDate)) {
                    return;
                }
            }
        };
        // change and blur events are added from the template
        DatetimeComponent.prototype.handleEvent = function (node, eventName, callback, locals) {
            if (!_.includes(['blur', 'focus', 'change', 'click'], eventName)) {
                _super.prototype.handleEvent.call(this, node, eventName, callback, locals);
            }
        };
        DatetimeComponent.prototype.onInputBlur = function ($event) {
            if (!$($event.relatedTarget).hasClass('current-date')) {
                this.invokeOnTouched();
                this.invokeEventCallback('blur', { $event: $event });
            }
        };
        var DatetimeComponent_1;
        DatetimeComponent.initializeProps = registerProps$1();
        DatetimeComponent.ctorParameters = function () { return [
            { type: core.Injector },
            { type: core.NgZone },
            { type: core.ChangeDetectorRef },
            { type: core$1.AppDefaults },
            { type: undefined, decorators: [{ type: core.Inject, args: [platformBrowser.EVENT_MANAGER_PLUGINS,] }] }
        ]; };
        __decorate([
            core.ViewChild(datepicker.BsDatepickerDirective),
            __metadata("design:type", Object)
        ], DatetimeComponent.prototype, "bsDatePickerDirective", void 0);
        DatetimeComponent = DatetimeComponent_1 = __decorate([
            core.Component({
                selector: '[wmDateTime]',
                template: "    <div dropdown\n        [isOpen]=\"isTimeOpen\"\n        autoClose=\"false\"\n        [container]=\"'body'\"\n        (onShown)=\"onTimepickerOpen()\"\n        style=\"display: inherit;\">\n        <input class=\"form-control app-textbox display-input\"\n            aria-label=\"Set the date and time\"\n            focus-target\n            [name]=\"name\"\n            [tabindex]=\"tabindex\"\n            type=\"text\"\n            [value]=\"displayValue\"\n            (click)=\"toggleDpDropdown($event)\"\n            (focus)=\"invokeOnFocus($event)\"\n            (blur)=\"onInputBlur($event)\"\n            (change)=\"onDateChange($event)\"\n            [autofocus]=\"autofocus\"\n            [disabled]=\"disabled || readonly || isCurrentDate\"\n            [required]=\"required\"\n            [readOnly]=\"isReadOnly\"\n            [attr.placeholder]=\"placeholder\"\n            [attr.accesskey]=\"shortcutkey\"\n            (keydown)=\"onDisplayKeydown($event)\">\n        <div style=\"width: 0;display: inline-block;\"\n            aria-label=\"datepicker dropdownmenu\"\n            aria-controls=\"date\">\n            <input class=\"model-holder\"\n                focus-target\n                [container]=\"containerTarget || 'body'\"\n                [bsConfig]=\"_dateOptions\"\n                [isOpen]=\"isDateOpen\"\n                 placement=\"bottom right\"\n                (onShown)=\"onDatePickerOpen()\"\n                (onHidden)=\"hideDatepickerDropdown()\"\n                [daysDisabled]=\"excludedDaysToDisable\"\n                [datesDisabled]=\"excludedDatesToDisable\"\n                #datepicker=bsDatepicker\n                bsDatepicker\n                [isDisabled]=\"disabled || readonly || isCurrentDate\"\n                [bsValue]=\"bsDateValue\"\n                (bsValueChange)=\"onModelUpdate($event, 'date')\">\n        </div>\n        <span class=\"input-group-btn\">\n            <button type=\"button\"\n                class=\"btn btn-default btn-date\"\n                [tabindex]=\"tabindex\"\n                [disabled]=\"disabled || readonly || isCurrentDate\"\n                aria-label=\"Select date\"\n                aria-haspopup=\"true\"\n                aria-expanded=\"false\"\n                (click)=\"toggleDpDropdown($event)\">\n                <i aria-hidden=\"true\"\n                    class=\"app-icon wi wi-calendar\"></i>\n            </button>\n            <button type=\"button\"\n                class=\"btn btn-default btn-time\"\n                [tabindex]=\"tabindex\"\n                [disabled]=\"disabled || readonly || isCurrentDate\"\n                aria-label=\"Select time\"\n                aria-haspopup=\"true\"\n                aria-expanded=\"false\"\n                (click)=\"toggleTimePicker(!isTimeOpen, $event)\">\n                <i aria-hidden=\"true\"\n                    class=\"app-icon wi wi-access-time\"></i>\n            </button>\n        </span>\n        <div *dropdownMenu\n            class=\"dropdown-menu\"\n            aria-label=\"timepicker dropdown\"\n            aria-controls=\"time\"\n            (click)=\"preventTpClose($event)\">\n            <timepicker class=\"model-holder\"\n                [showMeridian]=\"ismeridian\"\n                [readonlyInput]=\"disabled || readonly || isCurrentDate\"\n                [(ngModel)]=\"bsTimeValue\"\n                [min]=\"minTime\"\n                [max]=\"maxTime\"\n                [hourStep]=\"hourstep\"\n                [minuteStep]=\"minutestep\"\n                [secondsStep]=\"secondsstep\"\n                [mousewheel]=\"true\"\n                [arrowkeys]=\"true\"\n                (isValid)=\"isValid($event)\"\n                [showSeconds]=\"showseconds\"\n                (ngModelChange)=\"onModelUpdate($event, 'time')\"></timepicker>\n        </div>\n    </div>\n<ng-template [ngIf]=\"loadNativeDateInput\">\n    <input type=\"datetime-local\"\n        class=\"form-control app-textbox mobile-input\"\n        role=\"input\"\n        step=\"any\"\n        [value]=\"nativeDisplayValue\" [min]=\"mindate | date:'yyyy-MM-ddTHH:mm:ss'\" [max]=\"maxdate  | date:'yyyy-MM-ddTHH:mm:ss'\"\n        [tabindex]=\"tabindex\"\n        [required]=\"required\"\n        [disabled]=\"disabled || readonly || isCurrentDate\"\n        (change)=\"onDateChange($event, true)\"\n        (focus)=\"onDateTimeInputFocus(true); invokeOnFocus($event)\"\n        (blur)=\"onDateTimeInputBlur(); invokeOnTouched($event)\">\n</ng-template>\n",
                providers: [
                    base.provideAs(DatetimeComponent_1, forms.NG_VALUE_ACCESSOR, true),
                    base.provideAs(DatetimeComponent_1, forms.NG_VALIDATORS, true),
                    base.provideAsWidgetRef(DatetimeComponent_1),
                    { provide: timepicker.TimepickerConfig, deps: [core$1.AbstractI18nService], useFactory: ɵ0 }
                ]
            }),
            __param(4, core.Inject(platformBrowser.EVENT_MANAGER_PLUGINS)),
            __metadata("design:paramtypes", [core.Injector,
                core.NgZone,
                core.ChangeDetectorRef,
                core$1.AppDefaults, Object])
        ], DatetimeComponent);
        return DatetimeComponent;
    }(BaseDateTimeComponent));

    var timeProps = new Map([
        ['autofocus', base.PROP_BOOLEAN],
        ['class', base.PROP_STRING],
        ['dataentrymode', __assign({ value: 'default' }, base.PROP_STRING)],
        ['datavaluesource', base.PROP_ANY],
        ['datavalue', base.PROP_STRING],
        ['disabled', base.PROP_BOOLEAN],
        ['hint', base.PROP_STRING],
        ['hourstep', __assign({ value: 1 }, base.PROP_NUMBER)],
        ['maxtime', base.PROP_STRING],
        ['mintime', base.PROP_STRING],
        ['minutestep', __assign({ value: 15 }, base.PROP_NUMBER)],
        ['name', base.PROP_STRING],
        ['outputformat', __assign({ value: 'HH:mm:ss' }, base.PROP_STRING)],
        ['placeholder', __assign({ value: 'Select time' }, base.PROP_STRING)],
        ['readonly', base.PROP_BOOLEAN],
        ['required', base.PROP_BOOLEAN],
        ['shortcutkey', base.PROP_STRING],
        ['show', __assign({ value: true }, base.PROP_BOOLEAN)],
        ['showdropdownon', __assign({ value: 'default' }, base.PROP_STRING)],
        ['secondsstep', __assign({ value: 1 }, base.PROP_NUMBER)],
        ['tabindex', __assign({ value: 0 }, base.PROP_NUMBER)],
        ['timepattern', base.PROP_STRING],
        ['timestamp', base.PROP_STRING]
    ]);
    var registerProps$2 = function () {
        base.register('wm-time', timeProps);
        base.registerFormWidget(core$1.FormWidgetType.TIME, new Map(timeProps));
    };

    var CURRENT_TIME = 'CURRENT_TIME';
    var DEFAULT_CLS$2 = 'input-group app-timeinput';
    var WIDGET_CONFIG$2 = { widgetType: 'wm-time', hostClass: DEFAULT_CLS$2 };
    var ɵ0$1 = getTimepickerConfig;
    var TimeComponent = /** @class */ (function (_super) {
        __extends(TimeComponent, _super);
        function TimeComponent(inj, ngZone, appDefaults, evtMngrPlugins) {
            var _this = _super.call(this, inj, WIDGET_CONFIG$2) || this;
            _this.ngZone = ngZone;
            _this.appDefaults = appDefaults;
            /**
             * This is an internal property used to toggle the timepicker dropdown
             */
            _this.status = { isopen: false };
            // KeyEventsPlugin
            _this.keyEventPlugin = evtMngrPlugins[1];
            base.styler(_this.nativeElement, _this);
            /**
             * Destroy the timer once the date widget is gone
             */
            _this.registerDestroyListener(function () { return _this.clearTimeInterval(); });
            _this.timepattern = _this.appDefaults.timeFormat || core$1.getDisplayDateTimeFormat(core$1.FormWidgetType.TIME);
            _this.updateFormat('timepattern');
            return _this;
        }
        TimeComponent_1 = TimeComponent;
        Object.defineProperty(TimeComponent.prototype, "timestamp", {
            get: function () {
                return this.bsTimeValue ? this.bsTimeValue.valueOf() : undefined;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TimeComponent.prototype, "datavalue", {
            get: function () {
                if (this.isCurrentTime && !this.bsTimeValue) {
                    return CURRENT_TIME;
                }
                return core$1.getFormattedDate(this.datePipe, this.bsTimeValue, this.outputformat) || '';
            },
            /**Todo[Shubham]: needs to be redefined
             * This property sets the default value for the time selection
             */
            set: function (newVal) {
                if (newVal) {
                    if (newVal === CURRENT_TIME) {
                        this.isCurrentTime = true;
                        this.setTimeInterval();
                    }
                    else {
                        this.clearTimeInterval();
                        this.bsTimeValue = core$1.getNativeDateObject(newVal);
                        this.isCurrentTime = false;
                        this.mintimeMaxtimeValidation();
                    }
                }
                else {
                    this.bsTimeValue = undefined;
                    this.clearTimeInterval();
                    this.isCurrentTime = false;
                }
                this.invokeOnChange(this.datavalue);
                core$1.$appDigest();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TimeComponent.prototype, "displayValue", {
            get: function () {
                return core$1.getFormattedDate(this.datePipe, this.bsTimeValue, this.timepattern) || '';
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TimeComponent.prototype, "nativeDisplayValue", {
            get: function () {
                return core$1.getFormattedDate(this.datePipe, this.bsTimeValue, 'hh:mm:ss') || '';
            },
            enumerable: true,
            configurable: true
        });
        TimeComponent.prototype.onPropertyChange = function (key, nv, ov) {
            if (key === 'tabindex') {
                return;
            }
            if (key === 'timepattern') {
                this.updateFormat('timepattern');
            }
            if (key === 'mintime') {
                this.minTime = core$1.getNativeDateObject(nv); // TODO it is supposed to be time conversion, not to the day
                this.mintimeMaxtimeValidation();
            }
            else if (key === 'maxtime') {
                this.maxTime = core$1.getNativeDateObject(nv);
                this.mintimeMaxtimeValidation();
            }
            else {
                _super.prototype.onPropertyChange.call(this, key, nv, ov);
            }
        };
        TimeComponent.prototype.setValidateType = function (min, max, val) {
            if (this.timeNotInRange) {
                if (val < min) {
                    this.validateType = 'mintime';
                }
                else if (val > max) {
                    this.validateType = 'maxtime';
                }
            }
        };
        /**
         * This is an internal method used to validate mintime and maxtime
         */
        TimeComponent.prototype.mintimeMaxtimeValidation = function () {
            this.timeNotInRange = this.minTime && this.maxTime && (this.bsTimeValue < this.minTime || this.bsTimeValue > this.maxTime);
            this.setValidateType(this.minTime, this.maxTime, this.bsTimeValue);
            this.invokeOnChange(this.datavalue, undefined, false);
        };
        /**
         * This is an internal method used to toggle the dropdown of the time widget
         */
        TimeComponent.prototype.toggleDropdown = function ($event) {
            var _this = this;
            if (core$1.isMobile()) {
                this.onDateTimeInputFocus();
                return;
            }
            if ($event.type === 'click') {
                this.invokeEventCallback('click', { $event: $event });
            }
            if ($event.target && $($event.target).is('input') && !(this.isDropDownDisplayEnabledOnInput(this.showdropdownon))) {
                return;
            }
            this.ngZone.run(function () {
                _this.status.isopen = !_this.status.isopen;
            });
            this.addBodyClickListener(this.status.isopen);
        };
        /**
         * This is an internal method used to Prevent time picker close while changing time value
         */
        TimeComponent.prototype.preventTpClose = function ($event) {
            $event.stopImmediatePropagation();
        };
        TimeComponent.prototype.addBodyClickListener = function (skipListener) {
            var _this = this;
            if (!skipListener) {
                return;
            }
            var bodyElement = document.querySelector('body');
            setTimeout(function () {
                var dropdownElement = $(bodyElement).find('>bs-dropdown-container .dropdown-menu').get(0);
                _this.deregisterEventListener = core$1.addEventListenerOnElement(bodyElement, dropdownElement, _this.nativeElement, 'click', _this.isDropDownDisplayEnabledOnInput(_this.showdropdownon), function () {
                    _this.status.isopen = false;
                }, 0 /* ONCE */, true);
            }, 350);
        };
        /**
         * This is an internal method triggered when pressing key on the time input
         */
        TimeComponent.prototype.onDisplayKeydown = function (event) {
            if (this.isDropDownDisplayEnabledOnInput(this.showdropdownon)) {
                event.stopPropagation();
                var action = this.keyEventPlugin.constructor.getEventFullKey(event);
                if (action === 'enter' || action === 'arrowdown') {
                    event.preventDefault();
                    this.toggleDropdown(event);
                }
                else {
                    this.hideTimepickerDropdown();
                }
            }
            else {
                this.hideTimepickerDropdown();
            }
        };
        /**
         * This is an internal method triggered when the time input changes
         */
        TimeComponent.prototype.onDisplayTimeChange = function ($event) {
            var newVal = core$1.getNativeDateObject($event.target.value, { meridians: this.meridians });
            // time pattern validation
            // if invalid pattern is entered, device is showing an error.
            if (!this.formatValidation(newVal, $event.target.value)) {
                return;
            }
            this.invalidDateTimeFormat = false;
            this.onTimeChange(newVal);
        };
        TimeComponent.prototype.onInputBlur = function ($event) {
            if (!$($event.relatedTarget).hasClass('bs-timepicker-field')) {
                this.invokeOnTouched();
                this.invokeEventCallback('blur', { $event: $event });
            }
        };
        /**
         * This is an internal method used to execute the on time change functionality
         */
        TimeComponent.prototype.onTimeChange = function (newVal, isNativePicker) {
            var timeValue, timeInputValue, minTimeMeridian, maxTimeMeridian;
            // For nativePicker, newVal is event, get the dateobject from the event.
            if (isNativePicker) {
                newVal = core$1.getNativeDateObject(newVal.target.value);
            }
            if (newVal) {
                this.bsTimeValue = newVal;
                // if the newVal is valid but not in the given range then highlight the input field
                this.timeNotInRange = this.minTime && this.maxTime && (newVal < this.minTime || newVal > this.maxTime);
                this.setValidateType(this.minTime, this.maxTime, newVal);
            }
            else {
                // sometimes library is not returning the correct value when the min and max time are given, displaying the datavalue based on the value given by the user
                if (this.bsTimePicker && this.bsTimePicker.min && this.bsTimePicker.max) {
                    minTimeMeridian = moment(new Date(this.bsTimePicker.min)).format('A');
                    maxTimeMeridian = moment(new Date(this.bsTimePicker.max)).format('A');
                    timeValue = this.bsTimePicker.hours + ':' + (this.bsTimePicker.minutes || 0) + ':' + (this.bsTimePicker.seconds || 0) + (this.bsTimePicker.showMeridian ? (' ' + minTimeMeridian) : '');
                    timeInputValue = core$1.getNativeDateObject(timeValue);
                    this.bsTimePicker.meridian = minTimeMeridian;
                    this.timeNotInRange = (this.bsTimePicker.min > timeInputValue || this.bsTimePicker.max < timeInputValue);
                    this.setValidateType(this.bsTimePicker.min, this.bsTimePicker.max, timeInputValue);
                }
                this.bsTimeValue = timeInputValue;
            }
            this.invokeOnTouched();
            this.invokeOnChange(this.datavalue, {}, true);
        };
        /**
         * This is an internal method used to maintain a time interval to update the time model when the data value is set to CURRENT_TIME
         */
        TimeComponent.prototype.setTimeInterval = function () {
            var _this = this;
            if (this.timeinterval) {
                return;
            }
            this.timeinterval = setInterval(function () {
                var now = new Date();
                now.setSeconds(now.getSeconds() + 1);
                _this.datavalue = CURRENT_TIME;
                _this.onTimeChange(now);
            }, 1000);
        };
        /**
         * This is an internal method used to clear the time interval created
         */
        TimeComponent.prototype.clearTimeInterval = function () {
            if (this.timeinterval) {
                clearInterval(this.timeinterval);
                this.timeinterval = null;
            }
        };
        /**
         * This function sets the value isOpen/isTimeOpen (i.e when datepicker popup is closed) based on widget type(i.e  DateTime, Time)
         * @param val - isOpen/isTimeOpen is set based on the timepicker popup is open/closed
         */
        TimeComponent.prototype.setIsTimeOpen = function (val) {
            this.status.isopen = val;
        };
        // Change event is registered from the template, Prevent the framework from registering one more event
        TimeComponent.prototype.handleEvent = function (node, eventName, eventCallback, locals) {
            if (!_.includes(['blur', 'focus', 'change', 'click'], eventName)) {
                _super.prototype.handleEvent.call(this, node, eventName, eventCallback, locals);
            }
        };
        TimeComponent.prototype.hideTimepickerDropdown = function () {
            this.invokeOnTouched();
            this.status.isopen = false;
            if (this.deregisterEventListener) {
                this.deregisterEventListener();
            }
            this.removeKeyupListener();
        };
        TimeComponent.prototype.isValid = function (event) {
            if (!event) {
                var enteredDate = $(this.nativeElement).find('input').val();
                var newVal = core$1.getNativeDateObject(enteredDate, { meridians: this.meridians });
                if (!this.formatValidation(newVal, enteredDate)) {
                    return;
                }
            }
        };
        /**
         * This is an internal method to add css class for dropdown while opening the time dropdown
         */
        TimeComponent.prototype.onShown = function () {
            var tpElements = document.querySelectorAll('timepicker');
            _.forEach(tpElements, function (element) {
                core$1.addClass(element.parentElement, 'app-datetime', true);
            });
            this.focusTimePickerPopover(this);
            this.bindTimePickerKeyboardEvents();
            core$1.adjustContainerPosition($('bs-dropdown-container'), this.nativeElement, this.bsDropdown._dropdown, $('bs-dropdown-container .dropdown-menu'));
        };
        var TimeComponent_1;
        TimeComponent.initializeProps = registerProps$2();
        TimeComponent.ctorParameters = function () { return [
            { type: core.Injector },
            { type: core.NgZone },
            { type: core$1.AppDefaults },
            { type: undefined, decorators: [{ type: core.Inject, args: [platformBrowser.EVENT_MANAGER_PLUGINS,] }] }
        ]; };
        TimeComponent = TimeComponent_1 = __decorate([
            core.Component({
                selector: '[wmTime]',
                template: "    <div dropdown [isOpen]=\"status.isopen\" (onShown)=\"onShown()\" (onHidden)=\"hideTimepickerDropdown()\" [container]=\"'body'\" style=\"display: inherit\">\n        <input class=\"form-control app-textbox display-input\" aria-label=\"Set the time\"\n               focus-target\n               [tabindex]=\"tabindex\"\n               [name]=\"name\"\n               type=\"text\"\n               [value]=\"displayValue\"\n               [disabled]=\"disabled || readonly || isCurrentTime\"\n               [autofocus]=\"autofocus\"\n               [required]=\"required\"\n               [attr.placeholder]=\"placeholder\"\n               [attr.accesskey]=\"shortcutkey\"\n               [required]=\"required\"\n               [readOnly]=\"isReadOnly\"\n               (click)=\"toggleDropdown($event)\"\n               (focus)=\"invokeOnFocus($event)\"\n               (blur)=\"onInputBlur($event)\"\n               (change)=\"onDisplayTimeChange($event)\"\n               (keydown)=\"onDisplayKeydown($event)\">\n        <span class=\"input-group-btn dropdown-toggle\">\n          <button type=\"button\" class=\"btn btn-default btn-date\" [tabindex]=\"tabindex\" [disabled]=\"disabled || readonly || isCurrentTime\" aria-label=\"Select time\" aria-haspopup=\"true\" aria-expanded=\"false\" (click)=\"toggleDropdown($event)\"><i aria-hidden=\"true\" class=\"app-icon wi wi-access-time\"></i></button>\n        </span>\n        <div *dropdownMenu class=\"dropdown-menu\" (click)=\"preventTpClose($event)\">\n            <timepicker class=\"model-holder\"\n                        [showMeridian]=\"ismeridian\"\n                        [readonlyInput]=\"isDisabled\"\n                        [(ngModel)]=\"bsTimeValue\"\n                        [disabled]=\"disabled || readonly || isCurrentTime\"\n                        [min]=\"minTime\"\n                        [max]=\"maxTime\"\n                        [hourStep]=\"hourstep\"\n                        [minuteStep]=\"minutestep\"\n                        [secondsStep]=\"secondsstep\"\n                        [mousewheel]=\"true\"\n                        [arrowkeys]=\"true\"\n                        (isValid)=\"isValid($event)\"\n                        [showSeconds]=\"showseconds\" (ngModelChange)=\"onTimeChange($event)\"></timepicker>\n        </div>\n    </div>\n<ng-template [ngIf]=\"loadNativeDateInput\">\n    <input type=\"time\" class=\"form-control app-textbox display-input mobile-input\"\n           role=\"input\"\n           [value]=\"nativeDisplayValue\" [min]=\"mintime\" [max]=\"maxtime\"\n           [tabindex]=\"tabindex\"\n           [required]=\"required\"\n           [disabled]=\"disabled || readonly || isCurrentTime\"\n           (change)=\"onTimeChange($event, true)\"\n           (focus)=\"onDateTimeInputFocus(true); invokeOnFocus($event)\"\n           (blur)=\"onDateTimeInputBlur(); invokeOnTouched($event)\">\n</ng-template>\n",
                providers: [
                    base.provideAs(TimeComponent_1, forms.NG_VALUE_ACCESSOR, true),
                    base.provideAs(TimeComponent_1, forms.NG_VALIDATORS, true),
                    base.provideAsWidgetRef(TimeComponent_1),
                    { provide: timepicker.TimepickerConfig, deps: [core$1.AbstractI18nService], useFactory: ɵ0$1 }
                ]
            }),
            __param(3, core.Inject(platformBrowser.EVENT_MANAGER_PLUGINS)),
            __metadata("design:paramtypes", [core.Injector,
                core.NgZone,
                core$1.AppDefaults, Object])
        ], TimeComponent);
        return TimeComponent;
    }(BaseDateTimeComponent));

    var components = [
        DateComponent,
        DatetimeComponent,
        TimeComponent
    ];
    var EpochModule = /** @class */ (function () {
        function EpochModule() {
        }
        EpochModule = __decorate([
            core.NgModule({
                imports: [
                    common.CommonModule,
                    datepicker.BsDatepickerModule,
                    dropdown.BsDropdownModule,
                    forms.FormsModule,
                    timepicker.TimepickerModule,
                    base.WmComponentsModule
                ],
                declarations: __spread(components),
                exports: __spread(components),
                entryComponents: []
            })
        ], EpochModule);
        return EpochModule;
    }());

    exports.DateComponent = DateComponent;
    exports.DatetimeComponent = DatetimeComponent;
    exports.EpochModule = EpochModule;
    exports.TimeComponent = TimeComponent;
    exports.ɵ0 = ɵ0;
    exports.ɵa = getTimepickerConfig;
    exports.ɵb = BaseDateTimeComponent;
    exports.ɵc = registerProps;
    exports.ɵd = registerProps$1;
    exports.ɵe = registerProps$2;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=index.umd.js.map
