(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common'), require('@wm/components/base'), require('rxjs'), require('@wm/core')) :
    typeof define === 'function' && define.amd ? define('@wm/components/input/file-upload', ['exports', '@angular/core', '@angular/common', '@wm/components/base', 'rxjs', '@wm/core'], factory) :
    (global = global || self, factory((global.wm = global.wm || {}, global.wm.components = global.wm.components || {}, global.wm.components.input = global.wm.components.input || {}, global.wm.components.input.fileupload = {}), global.ng.core, global.ng.common, global.wm.components.base, global.rxjs, global.wm.core));
}(this, (function (exports, core, common, base, rxjs, core$1) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __rest(s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); }
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    function __createBinding(o, m, k, k2) {
        if (k2 === undefined) k2 = k;
        o[k2] = m[k];
    }

    function __exportStar(m, exports) {
        for (var p in m) if (p !== "default" && !exports.hasOwnProperty(p)) exports[p] = m[p];
    }

    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m) return m.call(o);
        if (o && typeof o.length === "number") return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }

    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    }

    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    };

    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }

    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
    }

    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }

    function __asyncValues(o) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
    }

    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
        return cooked;
    };

    function __importStar(mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
        result.default = mod;
        return result;
    }

    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }

    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }

    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    var registerProps = function () {
        base.register('wm-fileupload', new Map([
            ['caption', base.PROP_STRING],
            ['name', base.PROP_STRING],
            ['tabindex', base.PROP_NUMBER],
            ['multiple', base.PROP_BOOLEAN],
            ['fileuploadmessage', base.PROP_STRING],
            ['show', __assign({ value: true }, base.PROP_BOOLEAN)],
            ['disabled', base.PROP_BOOLEAN],
            ['contenttype', base.PROP_STRING],
            ['maxfilesize', base.PROP_NUMBER],
            ['iconclass', __assign({ value: 'wi wi-file-upload' }, base.PROP_STRING)],
            ['class', base.PROP_STRING],
            ['uploadpath', __assign({}, base.PROP_STRING)],
            ['datasource', base.PROP_STRING],
            ['selectedFiles', base.PROP_STRING],
            ['destination', base.PROP_STRING],
            ['filelistheight', base.PROP_NUMBER],
        ]));
        base.registerFormWidget(core$1.FormWidgetType.UPLOAD, new Map([
            ['disabled', base.PROP_BOOLEAN],
            ['extensions', base.PROP_STRING],
            ['filetype', base.PROP_STRING],
            ['multiple', base.PROP_BOOLEAN],
            ['readonly', base.PROP_BOOLEAN],
            ['required', base.PROP_BOOLEAN]
        ]));
    };

    var DEFAULT_CLS = 'app-fileupload';
    var WIDGET_CONFIG = {
        widgetType: 'wm-fileupload',
        hostClass: DEFAULT_CLS
    };
    var FileUploadComponent = /** @class */ (function (_super) {
        __extends(FileUploadComponent, _super);
        function FileUploadComponent(inj, app, onSelectEvt) {
            var _this = _super.call(this, inj, WIDGET_CONFIG) || this;
            _this.app = app;
            _this.onSelectEvt = onSelectEvt;
            _this.selectedFiles = [];
            _this.selectedFolders = [];
            _this.fileTransfers = {};
            _this.caption = 'Upload';
            _this.formName = '';
            _this.DEFAULT_CAPTIONS = {
                MULTIPLE_SELECT: 'Drop your files here.',
                SELECT: 'Select'
            };
            _this.DEVICE_CONTENTTYPES = {
                IMAGE: 'image',
                VIDEO: 'video',
                AUDIO: 'audio',
                FILES: 'files'
            };
            _this.FILESIZE_MB = 1048576;
            // parentPrefabScope = element.closest('.app-prefab').isolateScope(),
            _this.CONSTANT_FILE_SERVICE = 'FileService';
            _this.uploadData = {
                file: undefined,
                uploadPath: undefined
            };
            _this.chooseFilter = '';
            _this.fileUploadMessage = 'Drop your files here or click here to browse';
            _this.uploadedFiles = {
                fileName: '',
                path: '',
                length: '',
                status: ''
            };
            _this.uploadUrl = 'services';
            return _this;
            // styler(this.nativeElement, this);
        }
        FileUploadComponent_1 = FileUploadComponent;
        /*_hasOnSuccessEvt = WM.isDefined(attrs.onSuccess);
         _hasOnErrorEvt = WM.isDefined(attrs.onError);*/
        // Checking if the selected file is valid for the choosen filter type
        FileUploadComponent.prototype.isValidFile = function (filename, contenttype, extensionName, isMobileType) {
            var isValid, contentTypes;
            if (!contenttype) {
                return true;
            }
            contentTypes = _.toLower(contenttype).split(',');
            if (_.includes(contentTypes, 'image/*') || (_.includes(contentTypes, 'image') && isMobileType)) {
                isValid = core$1.isImageFile(filename);
                // If one of the content type chosen is image and user uploads image it is valid file
                if (isValid) {
                    return isValid;
                }
            }
            if (_.includes(contentTypes, 'audio/*') || (_.includes(contentTypes, 'audio') && isMobileType)) {
                isValid = core$1.isAudioFile(filename);
                // If one of the content type chosen is audio/* and user uploads audio it is valid file
                if (isValid) {
                    return isValid;
                }
            }
            if (_.includes(contentTypes, 'video/*') || (_.includes(contentTypes, 'video') && isMobileType)) {
                isValid = core$1.isVideoFile(filename);
                // If one of the content type chosen is video/* and user uploads video it is valid file
                if (isValid) {
                    return isValid;
                }
            }
            /*content type and the uploaded file extension should be same*/
            if (_.includes(contentTypes, '.' + _.toLower(extensionName))) {
                isValid = true;
            }
            return isValid;
        };
        /* this return the array of files which are having the file size not more than maxfilesize and filters based on contenttype */
        FileUploadComponent.prototype.getValidFiles = function ($files) {
            var _this = this;
            var validFiles = [];
            var errorFiles = [];
            var MAXFILEUPLOAD_SIZE = parseFloat(this.maxfilesize) * this.FILESIZE_MB || this.FILESIZE_MB;
            var MAX_FILE_UPLOAD_FORMATTED_SIZE = (this.maxfilesize || '1') + 'MB';
            // if contenttype is files for mobile projects.
            if (this.chooseFilter === this.DEVICE_CONTENTTYPES.FILES) {
                this.chooseFilter = '';
            }
            _.forEach($files, function (file) {
                /* check for the file content type before uploading */
                if (!_this.isValidFile(file.name, _this.chooseFilter, _this.getFileExtension(file.name), _this._isMobileType)) {
                    var msg = _this.appLocale.LABEL_FILE_EXTENTION_VALIDATION_MESSAGE + " " + _this.chooseFilter;
                    _this.handleErrorFiles('INVALID_FILE_EXTENSION', msg, file, errorFiles);
                    return;
                }
                if (file.size > MAXFILEUPLOAD_SIZE) {
                    var msg = _this.appLocale.LABEL_FILE_EXCEED_VALIDATION_MESSAGE + " " + MAX_FILE_UPLOAD_FORMATTED_SIZE;
                    _this.handleErrorFiles('INVALID_FILE_SIZE', msg, file, errorFiles);
                    return;
                }
                validFiles.push(file);
            });
            return {
                validFiles: validFiles,
                errorFiles: errorFiles
            };
        };
        FileUploadComponent.prototype.handleErrorFiles = function (key, msg, file, errorFiles) {
            // Check whether the error callback exist or not. If it exists then dont show taoster message
            if (!this.hasEventCallback('error')) {
                this.app.notifyApp(msg, 'Error');
            }
            var error = {
                key: key,
                message: msg
            };
            file.error = error;
            errorFiles.push(file);
        };
        /*Overwrite the caption only if they are default*/
        FileUploadComponent.prototype.getCaption = function (caption, isMultiple, isMobileType) {
            if (_.includes(this.DEFAULT_CAPTIONS, caption)) {
                return isMultiple && !isMobileType ? this.DEFAULT_CAPTIONS.MULTIPLE_SELECT : this.DEFAULT_CAPTIONS.SELECT;
            }
            return caption;
        };
        /* change server path based on user option */
        FileUploadComponent.prototype.changeServerUploadPath = function (path) {
            this.selectedUploadTypePath = path;
        };
        /* this function returns the fileextension */
        FileUploadComponent.prototype.getFileExtension = function (fileName) {
            if (fileName && _.includes(fileName, '.')) {
                return fileName.substring(fileName.lastIndexOf('.') + 1);
            }
            return 'file';
        };
        /**
         * Calls select Event
         * @param $event
         * @param $files
         */
        FileUploadComponent.prototype.onSelectEventCall = function ($event, $files) {
            var _this = this;
            this.selectedFiles = $files;
            setTimeout(function () {
                _this.invokeEventCallback('select', {
                    $event: $.extend($event.$files || {}, $files),
                    selectedFiles: $files
                });
            });
        };
        FileUploadComponent.prototype.onFileElemClick = function () {
            //The file upload widget value should be set to null to reupload the same file.
            this.$element.find('.file-input')[0].value = null;
        };
        /*this function to append upload status dom elements to widget */
        FileUploadComponent.prototype.onFileSelect = function ($event, $files) {
            var _this = this;
            var beforeSelectVal;
            var files = this.getValidFiles($files);
            $files = files.validFiles;
            // If the user has previously tried uploading folders using drop, and then uploading using click method we clear the folders dom
            if ($event.type === "change") {
                this.selectedFolders = [];
            }
            // Trigger error callback event if any invalid file found.
            if (!_.isEmpty(files.errorFiles)) {
                this.invokeEventCallback('error', {
                    $event: $event,
                    files: files.errorFiles
                });
            }
            // Make call if there are valid files else no call is made
            if ($files.length) {
                this.progressObservable = new rxjs.Subject();
                // EVENT: ON_BEFORE_SELECT
                beforeSelectVal = this.invokeEventCallback('beforeselect', {
                    $event: $.extend($event.$files || {}, $files),
                    files: $files
                });
                if (this.datasource) {
                    this.datasource._progressObservable = this.progressObservable;
                    this.datasource._progressObservable.asObservable().subscribe(function (progressObj) {
                        _.forEach(_this.selectedFiles, function (file) {
                            if (file.name === progressObj.fileName) {
                                file.progress = progressObj.progress;
                                if (file.progress === 100) {
                                    file.status = 'success';
                                }
                                else {
                                    file.status = progressObj.status;
                                    if (progressObj.errMsg) {
                                        file.errMsg = progressObj.errMsg;
                                    }
                                }
                            }
                        });
                    });
                }
                else {
                    this.selectedFiles = $files;
                }
                if (beforeSelectVal !== false) {
                    // EVENT: ON_SELECT
                    this.onSelectEventCall($event, $files);
                }
            }
        };
        // Prevent default behavior (Prevent file from being opened)
        FileUploadComponent.prototype.dragOverHandler = function ($event) {
            $event.preventDefault();
            $event.stopPropagation();
        };
        // Get the file data if it exists and call the onFileSelect function
        FileUploadComponent.prototype.onFileDrop = function ($event) {
            $event.preventDefault();
            var listOfFiles = [];
            this.selectedFolders = [];
            var filesData = $event.dataTransfer.items;
            if (filesData.length > 0) {
                // Use DataTransferItemList interface to access the file(s)
                for (var i = 0; i < filesData.length; i++) {
                    // Get all the files and push them into an array
                    if (filesData[i].webkitGetAsEntry().isFile) {
                        listOfFiles.push(filesData[i].getAsFile());
                    }
                    // If a selected item is directory push the folder element into an array and display error message by adding to dom
                    else if (filesData[i].webkitGetAsEntry().isDirectory) {
                        this.selectedFolders.push(filesData[i].getAsFile());
                    }
                }
                this.onFileSelect($event, listOfFiles);
            }
        };
        /**
         * Aborts a file upload request
         * @param $file, the file for which the request is to be aborted
         */
        FileUploadComponent.prototype.abortFileUpload = function ($file) {
            this.datasource.execute(core$1.DataSource.Operation.CANCEL, $file);
        };
        /* Define the property change handler. This function will be triggered when there is a change in the widget property */
        FileUploadComponent.prototype.onPropertyChange = function (key, nv, ov) {
            /*Monitoring changes for styles or properties and accordingly handling respective changes.*/
            switch (key) {
                case 'uploadpath':
                    // TODO Srinivas: why do we need uploadpath
                    this.changeServerUploadPath(nv);
                    break;
                case 'contenttype':
                    this.chooseFilter = nv.split(' ').join(',');
                    break;
                case 'multiple':
                    this.formName = this.name + (this.multiple ? '-multiple-fileupload' : '-single-fileupload');
                    this.caption = this.getCaption(this.caption, this.multiple, this._isMobileType);
                    break;
                case 'fileuploadmessage':
                    this.fileUploadMessage = nv;
            }
            _super.prototype.onPropertyChange.call(this, key, nv, ov);
        };
        FileUploadComponent.prototype.ngOnInit = function () {
            _super.prototype.ngOnInit.call(this);
        };
        FileUploadComponent.prototype.ngAfterViewInit = function () {
            base.styler(this.nativeElement.querySelector('.app-button, .drop-box'), this);
        };
        var FileUploadComponent_1;
        FileUploadComponent.initializeProps = registerProps();
        FileUploadComponent.ctorParameters = function () { return [
            { type: core.Injector },
            { type: core$1.App },
            { type: undefined, decorators: [{ type: core.Attribute, args: ['select.event',] }] }
        ]; };
        FileUploadComponent = FileUploadComponent_1 = __decorate([
            core.Component({
                selector: '[wmFileUpload]',
                template: "<div class=\"app-fileupload\" init-widget>\n    <!-- drag and drop files UI in web -->\n    <div class=\"app-multi-file-upload\" *ngIf=\"!_isMobileType && multiple\">\n        <div class=\"drop-box\" (dragover)=\"dragOverHandler($event)\" (drop)=\"onFileDrop($event)\" >\n            <i class=\"{{iconclass}}\"></i>\n            <div class=\"message\">\n                <label [innerHtml]=\"caption\" class=\"caption\"></label>\n                <form class=\"form-horizontal\" name=\"{{formName}}\">\n                    <input class=\"file-input\" aria-label=\"Select File\" type=\"file\" name=\"files\" *ngIf=\"multiple\" [disabled]=\"disabled\" [accept]=\"chooseFilter\" (click)=\"onFileElemClick()\" (change)=\"onFileSelect($event, $event.target.files)\" multiple >\n                    <a href=\"javascript:void(0);\" class=\"app-anchor\">{{fileUploadMessage}}</a>\n                </form>\n            </div>\n        </div>\n    </div>\n    <!-- single file upload in web and single , multiple file upload UI in mobile runmode -->\n    <div class=\"app-single-file-upload\" *ngIf=\"!_isCordova && (!multiple || _isMobileType)\">\n        <div class=\"app-button-wrapper\">\n            <form class=\"form-horizontal\" name=\"{{formName}}\">\n                <!-- support for file upload in Mobileapp in its runmode (Web) -->\n                <input class=\"file-input\" aria-label=\"Select files\" type=\"file\" name=\"files\" *ngIf=\"multiple\" [disabled]=\"disabled\" [accept]=\"chooseFilter\" (click)=\"onFileElemClick()\" (change)=\"onFileSelect($event, $event.target.files)\" multiple>\n                <input class=\"file-input\" aria-label=\"Select Files\" type=\"file\" name=\"files\" *ngIf=\"!multiple\" [disabled]=\"disabled\" [accept]=\"chooseFilter\" (click)=\"onFileElemClick()\" (change)=\"onFileSelect($event, $event.target.files)\" >\n                <button focus-target class=\"app-button btn btn-default\">\n                    <i class=\"{{iconclass}}\" aria-hidden=\"true\"></i>\n                    <span class=\"caption\">{{caption}}</span>\n                </button>\n            </form>\n        </div>\n        <div class=\"app-files-upload-status single\"></div>\n    </div>\n    <!-- support for file upload in Mobile Application (device) -->\n    <button *ngIf=\"_isCordova\" focus-target class=\"app-button btn btn-default\" (click)=\"openFileSelector()\" [disabled]=\"disabled\">\n        <i class=\"{{iconclass}}\"></i>\n        <span class=\"caption\">{{caption}}</span>\n    </button>\n    <!-- list of selectedfiles UI -->\n    <ul class=\"list-group file-upload\" [ngStyle]=\"{height: filelistheight, overflow: overflow}\" *ngIf=\"selectedFiles.length > 0\" >\n        <div *ngFor=\"let ft of selectedFiles\">\n            <li class=\"list-group-item file-upload-status\" *ngIf=\"ft.status !== 'abort'\">\n                <div class=\"media upload-file-list\">\n                    <div class=\"media-left media-middle file-icon {{getFileExtension(ft.name) | fileIconClass}}\" title=\"{{getFileExtension(ft.name)}}\"></div>\n                    <div class=\"media-body media-middle file-details\">\n                        <p class=\"uploaddetails\">\n                            <label class=\"upload-title\">{{ft.name}}</label><br/>\n                            <span class=\"filesize\" *ngIf=\"ft.fileLength  !== 0\">{{ft.size | filesize:0}}</span>\n                        </p>\n                        <div class=\"progress\" *ngIf=\"ft.status === 'onProgress'\">\n                            <div class=\"progress-bar progress-bar-striped progress-bar-info\" [ngStyle]=\"{width: (ft.progress +'%')}\"></div>\n                        </div>\n                    </div>\n                    <div class=\"media-right media-middle\" *ngIf=\"ft.status === 'onProgress' || ft.status === 'queued'\">\n                        <a class=\"btn btn-transparent file-upload-stop\" type=\"button\" (click)=\"abortFileUpload(ft)\">\n                            <i class=\"wi wi-close\"></i>\n                        </a>\n                    </div>\n                    <div class=\"media-right media-middle\"  *ngIf=\"ft.status === 'success'\">\n                        <span class=\"status-icon {{ft.status | stateClass }}\"></span>\n                    </div>\n                    <div class=\"media-right media-middle\"  *ngIf=\"ft.status === 'error'\" title=\"{{ft.errMsg || this.appLocale.MESSAGE_FILE_UPLOAD_FAILED}}\">\n                        <span class=\"status-icon {{ft.status | stateClass }}\"></span>\n                    </div>\n                </div>\n            </li>\n        </div>\n    </ul>\n    <!-- list of selectedfolders UI to show the error in title -->\n    <ul class=\"list-group file-upload\" [ngStyle]=\"{height: filelistheight, overflow: overflow}\" title=\"{{this.appLocale.MESSAGE_FOLDER_UPLOADS_NOT_ALLOWED}}\" *ngIf=\"selectedFolders.length > 0\" >\n        <li *ngFor=\"let ft of selectedFolders\" class=\"list-group-item file-upload-status\">\n            <div class=\"media upload-file-list\">\n                <div class=\"media-left media-middle file-icon fa fa-folder-o\"></div>\n                <div class=\"media-body media-middle file-details\">\n                    <p class=\"uploaddetails\">\n                        <label class=\"upload-title\">{{ft.name}}</label><br/>\n                    </p>\n                </div>\n                <div class=\"media-right media-middle\" >\n                    <span class=\"status-icon  wi wi-cancel text-danger\"></span>\n                </div>\n            </div>\n        </li>\n    </ul>\n</div>\n",
                providers: [
                    base.provideAsWidgetRef(FileUploadComponent_1)
                ]
            }),
            __param(2, core.Attribute('select.event')),
            __metadata("design:paramtypes", [core.Injector, core$1.App, Object])
        ], FileUploadComponent);
        return FileUploadComponent;
    }(base.StylableComponent));

    var components = [
        FileUploadComponent
    ];
    var FileUploadModule = /** @class */ (function () {
        function FileUploadModule() {
        }
        FileUploadModule = __decorate([
            core.NgModule({
                imports: [
                    common.CommonModule,
                    base.WmComponentsModule
                ],
                declarations: __spread(components),
                exports: __spread(components),
                entryComponents: []
            })
        ], FileUploadModule);
        return FileUploadModule;
    }());

    exports.FileUploadComponent = FileUploadComponent;
    exports.FileUploadModule = FileUploadModule;
    exports.ɵa = registerProps;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=index.umd.js.map
