(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common'), require('ngx-bootstrap/popover'), require('@wm/components/base'), require('@wm/components/basic'), require('@angular/platform-browser'), require('@wm/core')) :
    typeof define === 'function' && define.amd ? define('@wm/components/navigation/popover', ['exports', '@angular/core', '@angular/common', 'ngx-bootstrap/popover', '@wm/components/base', '@wm/components/basic', '@angular/platform-browser', '@wm/core'], factory) :
    (global = global || self, factory((global.wm = global.wm || {}, global.wm.components = global.wm.components || {}, global.wm.components.navigation = global.wm.components.navigation || {}, global.wm.components.navigation.popover = {}), global.ng.core, global.ng.common, global['ngx-bootstrap'].popover, global.wm.components.base, global.wm.components.basic, global.ng.platformBrowser, global.wm.core));
}(this, (function (exports, core, common, popover, base, basic, platformBrowser, core$1) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __rest(s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); }
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    function __createBinding(o, m, k, k2) {
        if (k2 === undefined) k2 = k;
        o[k2] = m[k];
    }

    function __exportStar(m, exports) {
        for (var p in m) if (p !== "default" && !exports.hasOwnProperty(p)) exports[p] = m[p];
    }

    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m) return m.call(o);
        if (o && typeof o.length === "number") return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }

    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    }

    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    };

    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }

    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
    }

    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }

    function __asyncValues(o) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
    }

    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
        return cooked;
    };

    function __importStar(mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
        result.default = mod;
        return result;
    }

    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }

    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }

    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    var registerProps = function () {
        base.register('wm-popover', new Map([
            ['autoclose', __assign({ value: 'outsideClick' }, base.PROP_STRING)],
            ['badgevalue', base.PROP_STRING],
            ['caption', __assign({ value: 'Link' }, base.PROP_STRING)],
            ['class', base.PROP_STRING],
            ['conditionalclass', base.PROP_ANY],
            ['content', base.PROP_STRING],
            ['contentanimation', base.PROP_STRING],
            ['contentsource', __assign({ value: 'partial' }, base.PROP_STRING)],
            ['encodeurl', base.PROP_BOOLEAN],
            ['hint', base.PROP_STRING],
            ['hyperlink', base.PROP_STRING],
            ['iconclass', base.PROP_STRING],
            ['iconheight', base.PROP_STRING],
            ['iconmargin', base.PROP_STRING],
            ['iconposition', base.PROP_STRING],
            ['iconurl', base.PROP_STRING],
            ['iconwidth', base.PROP_STRING],
            ['interaction', __assign({ value: 'click' }, base.PROP_STRING)],
            ['name', base.PROP_STRING],
            ['popoverarrow', __assign({ value: true }, base.PROP_BOOLEAN)],
            ['popoverheight', base.PROP_STRING],
            ['popoverplacement', __assign({ value: 'bottom' }, base.PROP_STRING)],
            ['popoverwidth', base.PROP_STRING],
            ['shortcutkey', base.PROP_STRING],
            ['show', __assign({ value: true }, base.PROP_BOOLEAN)],
            ['tabindex', __assign({ value: 0 }, base.PROP_NUMBER)],
            ['title', base.PROP_STRING],
            ['adaptiveposition', __assign({ value: true }, base.PROP_BOOLEAN)]
        ]));
    };

    var DEFAULT_CLS = 'app-popover-wrapper';
    var WIDGET_CONFIG = {
        widgetType: 'wm-popover',
        hostClass: DEFAULT_CLS
    };
    var eventsMap = {
        click: 'click',
        hover: 'mouseenter:click',
        default: 'click mouseenter'
    };
    var activePopover;
    var PopoverComponent = /** @class */ (function (_super) {
        __extends(PopoverComponent, _super);
        function PopoverComponent(inj, app, evtMngrPlugins) {
            var _this = _super.call(this, inj, WIDGET_CONFIG) || this;
            _this.app = app;
            _this.isOpen = false;
            _this.canPopoverOpen = true;
            // KeyEventsPlugin
            _this.keyEventPlugin = evtMngrPlugins[1];
            _this.popoverContainerCls = "app-popover-" + _this.widgetId;
            return _this;
        }
        PopoverComponent_1 = PopoverComponent;
        // This mehtod is used to show/open the popover. This refers to the same method showPopover.
        PopoverComponent.prototype.open = function () {
            this.showPopover();
        };
        // This mehtod is used to hide/close the popover.
        PopoverComponent.prototype.close = function () {
            this.isOpen = false;
        };
        // Trigger on hiding popover
        PopoverComponent.prototype.onHidden = function () {
            this.invokeEventCallback('hide', { $event: { type: 'hide' } });
        };
        PopoverComponent.prototype.setFocusToPopoverLink = function () {
            var _this = this;
            setTimeout(function () { return _this.anchorRef.nativeElement.focus(); }, 10);
        };
        PopoverComponent.prototype.adjustPopoverArrowPosition = function (popoverElem, popoverLeftShift) {
            this.bsPopoverDirective._popover._ngZone.onStable.subscribe(function () {
                popoverElem.find('.popover-arrow').css('left', popoverLeftShift + 'px');
            });
        };
        PopoverComponent.prototype.calculatePopoverPostion = function (element) {
            var _this = this;
            var popoverElem = $(element);
            var popoverLeft = popoverElem.offset().left;
            var popoverWidth = popoverElem[0].offsetWidth;
            var viewPortWidth = $(window).width();
            var parentDimesion = this.anchorRef.nativeElement.getBoundingClientRect();
            // Adjusting popover position, if it is not visible at left side
            if (popoverLeft < 0) {
                core$1.adjustContainerPosition(popoverElem, this.nativeElement, this.bsPopoverDirective._popover);
                var popoverLeftShift = 4;
                var arrowLeftShift = (parentDimesion.left + (parentDimesion.width / 2)) - popoverLeftShift;
                this.adjustPopoverArrowPosition(popoverElem, arrowLeftShift);
            }
            // Adjusting popover position, if it is not visible at right side
            if (popoverLeft + popoverWidth > viewPortWidth) {
                core$1.adjustContainerRightEdges(popoverElem, this.nativeElement, this.bsPopoverDirective._popover);
                setTimeout(function () {
                    popoverLeft = popoverElem.offset().left;
                    var popoverLeftAdjust = (popoverLeft + popoverWidth) - viewPortWidth;
                    var popoverLeftShift = popoverLeft - popoverLeftAdjust;
                    var arrowLeftShift;
                    if (popoverLeft <= 100) {
                        arrowLeftShift = (parentDimesion.left + (parentDimesion.width / 2)) - popoverLeft;
                    }
                    else {
                        arrowLeftShift = (parentDimesion.left + (parentDimesion.width / 2)) - popoverLeftShift;
                    }
                    if (viewPortWidth > 500) {
                        arrowLeftShift += 30;
                    }
                    _this.adjustPopoverArrowPosition(popoverElem, arrowLeftShift);
                });
            }
        };
        // Trigger on showing popover
        PopoverComponent.prototype.onShown = function () {
            var _this = this;
            var root = core$1.findRootContainer(this.$element);
            // if page styles have to be applied to popover then popover has to be child of page element.
            if (root) {
                $('body > popover-container').wrap('<' + root + '/>');
            }
            if (activePopover && activePopover.isOpen) {
                activePopover.isOpen = false;
            }
            activePopover = this;
            activePopover.isOpen = true;
            var popoverContainer = document.querySelector("." + this.popoverContainerCls);
            core$1.setCSSFromObj(popoverContainer, {
                height: this.popoverheight,
                minWidth: this.popoverwidth,
                width: this.popoverwidth
            });
            if (!this.popoverarrow) {
                core$1.addClass(popoverContainer.querySelector('.arrow'), 'hidden');
            }
            if (this.interaction === 'hover' || this.interaction === 'default') {
                // do not use addEventListener here
                // attaching the event this way will override the existing event handlers
                popoverContainer.onmouseenter = function () { return clearTimeout(_this.closePopoverTimeout); };
                popoverContainer.onmouseleave = function () { return _this.hidePopover(); };
                this.anchorRef.nativeElement.onmouseenter = function () { return clearTimeout(_this.closePopoverTimeout); };
                this.anchorRef.nativeElement.onmouseleave = function () { return _this.hidePopover(); };
            }
            var deRegister = this.eventManager.addEventListener(popoverContainer, 'keydown.esc', function () {
                _this.isOpen = false;
                _this.setFocusToPopoverLink();
                deRegister();
            });
            var popoverStartBtn = popoverContainer.querySelector('.popover-start');
            var popoverEndBtn = popoverContainer.querySelector('.popover-end');
            popoverStartBtn.onkeydown = function (event) {
                var action = _this.keyEventPlugin.constructor.getEventFullKey(event);
                // Check for Shift+Tab key
                if (action === 'shift.tab') {
                    _this.bsPopoverDirective.hide();
                    _this.setFocusToPopoverLink();
                }
            };
            popoverEndBtn.onkeydown = function (event) {
                var action = _this.keyEventPlugin.constructor.getEventFullKey(event);
                // Check for Tab key
                if (action === 'tab') {
                    _this.bsPopoverDirective.hide();
                    _this.setFocusToPopoverLink();
                }
            };
            //Whenever autoclose property is set to 'always', adding the onclick listener to the popover container to close the popover.
            if (this.autoclose === base.AUTOCLOSE_TYPE.ALWAYS) {
                popoverContainer.onclick = function () { return _this.close(); };
            }
            core$1.setAttr(popoverContainer, 'tabindex', 0);
            setTimeout(function () { return popoverStartBtn.focus(); }, 50);
            // Adjusting popover position if the popover placement is top or bottom
            setTimeout(function () {
                if (!_this.adaptiveposition) {
                    _this.calculatePopoverPostion(popoverContainer);
                }
                // triggering onload and onshow events after popover content has rendered
                _this.triggerPopoverEvents();
            });
        };
        PopoverComponent.prototype.triggerPopoverEvents = function () {
            var _this = this;
            if (this.contentsource === 'partial') {
                var cancelSubscription_1 = this.app.subscribe('partialLoaded', function (data) {
                    var parEle = _this.partialRef.nativeElement;
                    var partialScope;
                    if (parEle) {
                        partialScope = parEle.widget;
                        _this.Widgets = partialScope.Widgets;
                        _this.Variables = partialScope.Variables;
                        _this.Actions = partialScope.Actions;
                        _this.invokeEventCallback('load');
                        _this.invokeEventCallback('show', { $event: { type: 'show' } });
                    }
                    cancelSubscription_1();
                });
            }
            else {
                this.Widgets = this.viewParent.Widgets;
                this.Variables = this.viewParent.Variables;
                this.Actions = this.viewParent.Actions;
                this.invokeEventCallback('show', { $event: { type: 'show' } });
            }
        };
        PopoverComponent.prototype.hidePopover = function () {
            var _this = this;
            this.closePopoverTimeout = setTimeout(function () { return _this.isOpen = false; }, 500);
        };
        PopoverComponent.prototype.showPopover = function () {
            this.bsPopoverDirective.show();
        };
        PopoverComponent.prototype.onPopoverAnchorKeydown = function ($event) {
            // if there is no content available, the popover should not open through enter key. So checking whether the canPopoverOpen flag is true or not.
            if (!this.canPopoverOpen) {
                return;
            }
            var action = this.keyEventPlugin.constructor.getEventFullKey(event);
            if (action === 'enter') {
                $event.stopPropagation();
                this.showPopover();
            }
        };
        PopoverComponent.prototype.onPropertyChange = function (key, nv, ov) {
            if (key === 'class' || key === 'tabindex') {
                return;
            }
            if (key === 'contentsource') {
                // if there is no partial content available, the popover should not open
                if (this.contentsource === 'partial' && !this.content) {
                    this.canPopoverOpen = false;
                }
            }
            if (key === 'content' && nv) {
                this.canPopoverOpen = true;
            }
            if (key === 'autoclose') {
                this.outsideclick = (nv === base.AUTOCLOSE_TYPE.OUTSIDECLICK || nv === base.AUTOCLOSE_TYPE.ALWAYS) ? true : false;
            }
            _super.prototype.onPropertyChange.call(this, key, nv, ov);
        };
        PopoverComponent.prototype.ngOnInit = function () {
            _super.prototype.ngOnInit.call(this);
            this.event = eventsMap[this.interaction];
        };
        PopoverComponent.prototype.ngAfterViewInit = function () {
            _super.prototype.ngAfterViewInit.call(this);
            base.styler(this.anchorRef.nativeElement, this);
            this.containerTarget = base.getContainerTargetClass(this.nativeElement);
            var parentElemPopover = $(this.nativeElement).parents();
            if (parentElemPopover.closest('[wmTable]').length ||
                parentElemPopover.closest('[wmtabs]').length ||
                parentElemPopover.closest('modal-container').length) {
                this.adaptiveposition = false;
            }
        };
        var PopoverComponent_1;
        PopoverComponent.initializeProps = registerProps();
        PopoverComponent.ctorParameters = function () { return [
            { type: core.Injector },
            { type: core$1.App },
            { type: undefined, decorators: [{ type: core.Inject, args: [platformBrowser.EVENT_MANAGER_PLUGINS,] }] }
        ]; };
        __decorate([
            core.ViewChild(popover.PopoverDirective),
            __metadata("design:type", Object)
        ], PopoverComponent.prototype, "bsPopoverDirective", void 0);
        __decorate([
            core.ViewChild('anchor', { static: true }),
            __metadata("design:type", core.ElementRef)
        ], PopoverComponent.prototype, "anchorRef", void 0);
        __decorate([
            core.ContentChild(core.TemplateRef),
            __metadata("design:type", Object)
        ], PopoverComponent.prototype, "popoverTemplate", void 0);
        __decorate([
            core.ContentChild('partial'),
            __metadata("design:type", Object)
        ], PopoverComponent.prototype, "partialRef", void 0);
        PopoverComponent = PopoverComponent_1 = __decorate([
            core.Component({
                selector: 'wm-popover',
                template: "<a [popover]=\"popoverTemplate\"\n    [popoverContext]=\"context\"\n    [popoverTitle]=\"title\"\n    [placement]=\"popoverplacement\"\n    [outsideClick]=\"outsideclick\"\n    [triggers]=\"event\"\n    (onShown)=\"onShown()\"\n    (onHidden)=\"onHidden()\"\n    containerClass=\"app-popover animated {{contentanimation}} {{popoverContainerCls}}\"\n    [container]=\"containerTarget || 'body'\"\n    [isOpen]=\"isOpen\"\n    [tabindex]=\"tabindex\"\n    [name]=\"name\"\n    [class]=\"class\"\n    [ngClass]=\"{'disable-popover': !canPopoverOpen}\"\n    [adaptivePosition]=\"adaptiveposition\"\n    #anchor\n    name.bind=\"name\"\n    wmAnchor\n    animation.bind=\"animation\"\n    badgevalue.bind=\"badgevalue\"\n    caption.bind=\"caption\"\n    encodeurl.bind=\"encodeurl\"\n    hint.bind=\"hint\"\n    hyperlink.bind=\"hyperlink\"\n    iconurl.bind=\"iconurl\"\n    iconwidth.bind=\"iconwidth\"\n    iconheight.bind=\"iconheight\"\n    iconmargin.bind=\"iconmargin\"\n    iconclass.bind=\"iconclass\"\n    iconposition.bind=\"iconposition\"\n    shortcutkey.bind=\"shortcutkey\"\n    tabindex.bind=\"tabindex\"\n    (keydown)=\"onPopoverAnchorKeydown($event)\">\n</a>\n",
                providers: [
                    base.provideAsWidgetRef(PopoverComponent_1)
                ]
            }),
            __param(2, core.Inject(platformBrowser.EVENT_MANAGER_PLUGINS)),
            __metadata("design:paramtypes", [core.Injector, core$1.App, Object])
        ], PopoverComponent);
        return PopoverComponent;
    }(base.StylableComponent));

    var components = [
        PopoverComponent
    ];
    var PopoverModule = /** @class */ (function () {
        function PopoverModule() {
        }
        PopoverModule = __decorate([
            core.NgModule({
                imports: [
                    common.CommonModule,
                    basic.BasicModule,
                    popover.PopoverModule,
                    base.WmComponentsModule
                ],
                declarations: __spread(components),
                exports: __spread(components),
                entryComponents: []
            })
        ], PopoverModule);
        return PopoverModule;
    }());

    exports.PopoverModule = PopoverModule;
    exports.ɵa = PopoverComponent;
    exports.ɵb = registerProps;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=index.umd.js.map
