(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common'), require('@wm/components/base'), require('@angular/router'), require('@wm/core'), require('@wm/components/page'), require('@swipey')) :
    typeof define === 'function' && define.amd ? define('@wm/components/page/left-panel', ['exports', '@angular/core', '@angular/common', '@wm/components/base', '@angular/router', '@wm/core', '@wm/components/page', '@swipey'], factory) :
    (global = global || self, factory((global.wm = global.wm || {}, global.wm.components = global.wm.components || {}, global.wm.components.page = global.wm.components.page || {}, global.wm.components.page.leftpanel = {}), global.ng.core, global.ng.common, global.wm.components.base, global.ng.router, global.wm.core, global.wm.components.page, global.swipey));
}(this, (function (exports, core, common, base, router, core$1, page, _swipey) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __rest(s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); }
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    function __createBinding(o, m, k, k2) {
        if (k2 === undefined) k2 = k;
        o[k2] = m[k];
    }

    function __exportStar(m, exports) {
        for (var p in m) if (p !== "default" && !exports.hasOwnProperty(p)) exports[p] = m[p];
    }

    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m) return m.call(o);
        if (o && typeof o.length === "number") return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }

    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    }

    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    };

    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }

    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
    }

    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }

    function __asyncValues(o) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
    }

    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
        return cooked;
    };

    function __importStar(mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
        result.default = mod;
        return result;
    }

    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }

    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }

    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    var registerProps = function () {
        base.register('wm-left-panel', new Map([
            ['animation', __assign({ value: 'slide-in' }, base.PROP_STRING)],
            ['class', base.PROP_STRING],
            ['columnwidth', __assign({ value: 3 }, base.PROP_NUMBER)],
            ['content', base.PROP_STRING],
            ['gestures', __assign({ value: 'on' }, base.PROP_STRING)],
            ['name', base.PROP_STRING],
            ['xscolumnwidth', __assign({ value: 10 }, base.PROP_NUMBER)]
        ]));
    };

    var LeftPanelAnimator = /** @class */ (function (_super) {
        __extends(LeftPanelAnimator, _super);
        function LeftPanelAnimator(leftPanel) {
            var _this = _super.call(this) || this;
            _this.leftPanel = leftPanel;
            _this.init(_this.leftPanel.$ele, _this.leftPanel.$page);
            return _this;
        }
        LeftPanelAnimator.prototype.bounds = function (e, length) {
            var offset = 0;
            this.setGesturesEnabled(this.leftPanel.isGesturesEnabled());
            if (!this._width) {
                this._pageContainerWidth = this.leftPanel.$page.width();
                this._leftPanelWidth = this.leftPanel.$ele.width();
                this._maxX = this._leftPanelWidth / this._pageContainerWidth * 100;
                this._width = this.leftPanel.animation === exports.AnimationType.SLIDE_IN ? this._pageContainerWidth : this._leftPanelWidth;
            }
            this._expanded = this.leftPanel.expanded;
            if (this._expanded) {
                return {
                    'center': this._leftPanelWidth,
                    'lower': -(this._leftPanelWidth - offset)
                };
            }
            if (this.leftPanel.app.isTabletApplicationType) {
                offset = 53.32;
            }
            if (e && (e.pageX || (e.touches && e.touches[0].pageX)) > offset + 100) {
                return {
                    strict: true
                };
            }
            return {
                'center': 0,
                'upper': this._leftPanelWidth - offset
            };
        };
        LeftPanelAnimator.prototype.context = function () {
            return {
                'w': this._width,
                'pageW': this._pageContainerWidth,
                'leftW': this._leftPanelWidth,
                'maxX': this._maxX,
                'limit': function (min, v, max) {
                    if (v < min) {
                        return min;
                    }
                    if (v > max) {
                        return max;
                    }
                    return v;
                }
            };
        };
        LeftPanelAnimator.prototype.animation = function () {
            this._$animatedElements = this.leftPanel.$ele;
            if (this.leftPanel.animation === exports.AnimationType.SLIDE_IN) {
                this._$animatedElements = this._$animatedElements.add(this.leftPanel.$page);
                if (this.leftPanel.app.isTabletApplicationType) {
                    return [
                        {
                            'target': this.leftPanel.$ele,
                            'css': {
                                'transform': 'translate3d(${{ limit(-100, -($d * 100 / leftW), 0) + \'%\' }}, 0, 0)'
                            }
                        },
                        {
                            'target': this.leftPanel.$page,
                            'css': {
                                'transform': 'translate3d(${{ (($d) * 100 / pageW) + \'%\' }}, 0, 0)',
                                'width': '${{ (pageW - $d) + \'px\' }}',
                                'z-index': 101
                            }
                        }
                    ];
                }
                return [
                    {
                        'target': this.leftPanel.$ele,
                        'css': {
                            'transform': 'translate3d(-100%, 0, 0)',
                            'opacity': 1,
                            'z-index': 101
                        }
                    },
                    {
                        'target': this.leftPanel.$page,
                        'css': {
                            'transform': 'translate3d(${{ limit( 0, ((($D + $d) * 100 / w)), maxX ) + \'%\' }}, 0, 0)',
                            'opacity': 1,
                            'z-index': 101
                        }
                    }
                ];
            }
            else {
                return {
                    'transform': 'translate3d(${{ limit( -100, ((($D + $d) * 100 / w) - 100), 0 ) + \'%\'}}, 0, 0)',
                    'opacity': 1,
                    'z-index': 101
                };
            }
        };
        LeftPanelAnimator.prototype.onLower = function () {
            this._expanded = false;
            this.leftPanel.collapse();
            this.resetTransition();
            core$1.$appDigest();
        };
        LeftPanelAnimator.prototype.onUpper = function () {
            this._expanded = true;
            this.leftPanel.expand();
            this.resetTransition();
            core$1.$appDigest();
        };
        LeftPanelAnimator.prototype.resetTransition = function () {
            var _this = this;
            if (this._$animatedElements) {
                /*
                 * This timeout is for preventing UI flicker at the end of animation.
                 */
                setTimeout(function () {
                    _this._$animatedElements.css({
                        'transform': '',
                        'opacity': '',
                        'z-index': '',
                        'width': ''
                    });
                }, 100);
            }
        };
        return LeftPanelAnimator;
    }(_swipey.SwipeAnimation));

    var DEFAULT_CLS = 'app-left-panel left-panel-collapsed';
    var WIDGET_CONFIG = {
        widgetType: 'wm-left-panel',
        hostClass: DEFAULT_CLS
    };

    (function (AnimationType) {
        AnimationType["SLIDE_IN"] = "slide-in";
        AnimationType["SLIDE_OVER"] = "slide-over";
    })(exports.AnimationType || (exports.AnimationType = {}));
    var LeftPanelDirective = /** @class */ (function (_super) {
        __extends(LeftPanelDirective, _super);
        function LeftPanelDirective(app, page, inj, router$1) {
            var _this = _super.call(this, inj, WIDGET_CONFIG) || this;
            _this.app = app;
            _this.page = page;
            base.styler(_this.nativeElement, _this, base.APPLY_STYLES_TYPE.CONTAINER);
            _this.$ele = _this.$element;
            _this.$page = page.$element;
            core$1.addClass(_this.$page[0], 'left-panel-collapsed-container');
            if (_this.columnwidth) {
                _this.setLeftPanelWidth(['md', 'sm'], _this.columnwidth);
            }
            if (_this.app.isTabletApplicationType) {
                core$1.addClass(_this.nativeElement, 'wm-tablet-app-left-panel');
            }
            var onRouteChange = router$1.events.subscribe(function (e) {
                if (e instanceof router.NavigationStart) {
                    _this.collapse();
                }
            });
            _this.registerDestroyListener(function () { return onRouteChange.unsubscribe(); });
            return _this;
        }
        LeftPanelDirective_1 = LeftPanelDirective;
        LeftPanelDirective.prototype.collapse = function () {
            core$1.addClass(this.nativeElement, 'swipee-transition');
            core$1.switchClass(this.nativeElement, 'left-panel-collapsed', 'left-panel-expanded');
            this.expanded = false;
            core$1.switchClass(this.$page[0], 'left-panel-collapsed-container', 'left-panel-expanded-container');
            if (this.animation === exports.AnimationType.SLIDE_IN) {
                this.setPageWidthAndPosition(['md', 'sm'], null, this.columnwidth);
                this.setPageWidthAndPosition(['xs'], null, this.xscolumnwidth);
            }
            if (this._destroyCollapseActionListener) {
                this._destroyCollapseActionListener();
            }
            this.page.notify('wmLeftPanel:collapse');
        };
        LeftPanelDirective.prototype.expand = function () {
            core$1.removeClass(this.nativeElement, 'swipee-transition');
            core$1.switchClass(this.nativeElement, 'left-panel-expanded', 'left-panel-collapsed');
            this.expanded = true;
            if (!(this.app.isTabletApplicationType && this.animation === exports.AnimationType.SLIDE_IN)) {
                this._destroyCollapseActionListener = this.listenForCollapseAction();
            }
            core$1.switchClass(this.$page[0], 'left-panel-expanded-container', 'left-panel-collapsed-container');
            if (this.animation === exports.AnimationType.SLIDE_IN) {
                this.setPageWidthAndPosition(['md', 'sm'], this.columnwidth);
                this.setPageWidthAndPosition(['xs'], this.xscolumnwidth);
            }
            this.page.notify('wmLeftPanel:expand');
        };
        LeftPanelDirective.prototype.isGesturesEnabled = function () {
            return this.gestures === 'on';
        };
        LeftPanelDirective.prototype.isVisible = function () {
            return this.expanded;
        };
        LeftPanelDirective.prototype.onPropertyChange = function (key, nv, ov) {
            switch (key) {
                case 'animation':
                    if (nv === exports.AnimationType.SLIDE_IN) {
                        core$1.removeClass(this.$page[0], 'slide-over-left-panel-container');
                        core$1.addClass(this.$page[0], 'slide-in-left-panel-container');
                        this.setPageWidthAndPosition(['md', 'sm'], this.columnwidth);
                        this.setPageWidthAndPosition(['xs'], this.xscolumnwidth);
                    }
                    else if (nv === exports.AnimationType.SLIDE_OVER) {
                        core$1.removeClass(this.$page[0], 'slide-in-left-panel-container');
                        core$1.addClass(this.$page[0], 'slide-over-left-panel-container');
                    }
                    this._leftPanelAnimator = new LeftPanelAnimator(this);
                    core$1.switchClass(this.nativeElement, nv, ov);
                    break;
                case 'columnwidth':
                    this.setLeftPanelWidth(['md', 'sm'], nv, ov);
                    if (this.animation === exports.AnimationType.SLIDE_IN) {
                        this.setPageWidthAndPosition(['md', 'sm'], nv, ov);
                    }
                    break;
                case 'expanded':
                    core$1.toggleClass(this.nativeElement, 'left-panel-expanded', nv);
                    core$1.toggleClass(this.nativeElement, 'left-panel-collapsed', !nv);
                    break;
                case 'xscolumnwidth':
                    this.setLeftPanelWidth(['xs'], nv, ov);
                    if (this.animation === exports.AnimationType.SLIDE_IN) {
                        this.setPageWidthAndPosition(['xs'], nv, ov);
                    }
                    break;
                default:
                    _super.prototype.onPropertyChange.call(this, key, nv, ov);
            }
        };
        LeftPanelDirective.prototype.toggle = function () {
            var _this = this;
            if (this.app.isTabletApplicationType) {
                setTimeout(function () {
                    _this.expanded ? _this.collapse() : _this.expand();
                }, 50);
            }
            else {
                this.$ele.swipeAnimation(this.expanded ? 'gotoLower' : 'gotoUpper');
            }
        };
        LeftPanelDirective.prototype.listenForCollapseAction = function () {
            var _this = this;
            var eventName = 'click.leftNavToggle';
            var skipEvent = false;
            this.$ele.on(eventName, function () {
                skipEvent = true;
            });
            this.$page.on(eventName, function () {
                if (!skipEvent) {
                    _this.toggle();
                }
                skipEvent = false;
            });
            return function () {
                _this.$ele.off(eventName);
                _this.$page.off(eventName);
            };
        };
        LeftPanelDirective.prototype.setLeftPanelWidth = function (devices, newVal, oldVal) {
            var _this = this;
            devices.forEach(function (device) {
                if (newVal) {
                    core$1.addClass(_this.nativeElement, "col-" + device + "-" + newVal);
                }
                if (oldVal) {
                    core$1.removeClass(_this.nativeElement, "col-" + device + "-" + oldVal);
                }
            });
        };
        LeftPanelDirective.prototype.setPageWidthAndPosition = function (devices, newVal, oldVal) {
            var _this = this;
            devices.forEach(function (device) {
                if (newVal) {
                    core$1.addClass(_this.$page[0], "left-panel-container-" + device + "-" + (12 - newVal));
                }
                if (oldVal) {
                    core$1.removeClass(_this.$page[0], "left-panel-container-" + device + "-" + (12 - oldVal));
                }
            });
        };
        var LeftPanelDirective_1;
        LeftPanelDirective.initializeProps = registerProps();
        LeftPanelDirective.ctorParameters = function () { return [
            { type: core$1.App },
            { type: page.PageDirective },
            { type: core.Injector },
            { type: router.Router }
        ]; };
        LeftPanelDirective = LeftPanelDirective_1 = __decorate([
            core.Directive({
                selector: '[wmLeftPanel]',
                providers: [
                    base.provideAsWidgetRef(LeftPanelDirective_1)
                ]
            }),
            __metadata("design:paramtypes", [core$1.App, page.PageDirective, core.Injector, router.Router])
        ], LeftPanelDirective);
        return LeftPanelDirective;
    }(base.StylableComponent));

    var components = [
        LeftPanelDirective
    ];
    var LeftPanelModule = /** @class */ (function () {
        function LeftPanelModule() {
        }
        LeftPanelModule = __decorate([
            core.NgModule({
                imports: [
                    common.CommonModule,
                    base.WmComponentsModule
                ],
                declarations: __spread(components),
                exports: __spread(components),
                entryComponents: []
            })
        ], LeftPanelModule);
        return LeftPanelModule;
    }());

    exports.LeftPanelDirective = LeftPanelDirective;
    exports.LeftPanelModule = LeftPanelModule;
    exports.ɵa = registerProps;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=index.umd.js.map
