export declare class LRUCache<T> {
    private maxSize;
    private maxAge;
    private onEvict?;
    private cache;
    private evictQueue;
    constructor(maxSize?: number, maxAge?: number, onEvict?: ((key: string, value: T) => any));
    private addToEvictQueue;
    private evict;
    set(key: string, dataToCache: T): void;
    get(key: string): T;
    delete(key: string): void;
    has(key: string): boolean;
    size(): number;
    clear(): void;
}
