(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@wm/components/base'), require('@angular/common/http'), require('@ionic-native/file'), require('@ionic-native/file-opener'), require('@wm/core'), require('@wm/mobile/core'), require('@angular/common'), require('@wm/components/basic/progress')) :
    typeof define === 'function' && define.amd ? define('@wm/mobile/components/basic', ['exports', '@angular/core', '@wm/components/base', '@angular/common/http', '@ionic-native/file', '@ionic-native/file-opener', '@wm/core', '@wm/mobile/core', '@angular/common', '@wm/components/basic/progress'], factory) :
    (global = global || self, factory((global.wm = global.wm || {}, global.wm.mobile = global.wm.mobile || {}, global.wm.mobile.components = global.wm.mobile.components || {}, global.wm.mobile.components.basic = {}), global.ng.core, global.wm.components.base, global.ng.common.http, global.ionicNative.plugins, global.ionicNative.plugins, global.wm.core, global.wm.mobile.core, global.ng.common, global.wm.components.basic.progress));
}(this, (function (exports, core, base, http, file, fileOpener, core$1, core$2, common, progress) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __rest(s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); }
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    function __createBinding(o, m, k, k2) {
        if (k2 === undefined) k2 = k;
        o[k2] = m[k];
    }

    function __exportStar(m, exports) {
        for (var p in m) if (p !== "default" && !exports.hasOwnProperty(p)) exports[p] = m[p];
    }

    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m) return m.call(o);
        if (o && typeof o.length === "number") return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }

    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    }

    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    };

    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }

    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
    }

    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }

    function __asyncValues(o) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
    }

    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
        return cooked;
    };

    function __importStar(mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
        result.default = mod;
        return result;
    }

    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }

    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }

    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    var AnchorDirective = /** @class */ (function () {
        function AnchorDirective(widget) {
            this.widget = widget;
        }
        AnchorDirective.prototype.onClick = function () {
            var href = this.widget.hyperlink;
            if (href) {
                if (href.indexOf(':') >= 0 && !(_.startsWith(href, 'http://') || _.startsWith(href, 'https://'))) {
                    return;
                }
                else if (_.startsWith(href, '#')) {
                    window.location.href = window.location.origin + window.location.pathname + href;
                    return;
                }
                else if (_.startsWith(href, '//')) {
                    href = 'https:' + href;
                }
                if (window['cordova']) {
                    window.open(href, this.widget.target);
                }
            }
        };
        AnchorDirective.ctorParameters = function () { return [
            { type: undefined, decorators: [{ type: core.Inject, args: [base.WidgetRef,] }] }
        ]; };
        __decorate([
            core.HostListener('click'),
            __metadata("design:type", Function),
            __metadata("design:paramtypes", []),
            __metadata("design:returntype", void 0)
        ], AnchorDirective.prototype, "onClick", null);
        AnchorDirective = __decorate([
            core.Directive({
                selector: '[wmAnchor]'
            }),
            __param(0, core.Inject(base.WidgetRef)),
            __metadata("design:paramtypes", [Object])
        ], AnchorDirective);
        return AnchorDirective;
    }());

    var DEFAULT_CLS = 'app-update-dialog modal fade in hidden';
    var AUTO_UPDATE_FILENAME = 'app-auto-update.apk';
    var AppUpdateComponent = /** @class */ (function () {
        function AppUpdateComponent(deviceService, fileDownloadService, elRef, file, fileOpener, http) {
            var _this = this;
            this.deviceService = deviceService;
            this.fileDownloadService = fileDownloadService;
            this.elRef = elRef;
            this.file = file;
            this.fileOpener = fileOpener;
            this.http = http;
            this.downloadProgress = 0;
            this.downloading = false;
            this.message = 'There is an update available. Would you like to update the app?';
            core$1.addClass(this.elRef.nativeElement, DEFAULT_CLS);
            core$1.setCSS(this.elRef.nativeElement, 'display', 'block');
            if (core$1.hasCordova()) {
                this.getBuildMeta().then(function (buildMeta) {
                    if (buildMeta && buildMeta.buildMode === 'DEVELOPMENT_MODE') {
                        _this.file.removeFile(cordova.file.externalApplicationStorageDirectory, AUTO_UPDATE_FILENAME).catch(core$1.noop);
                        _this.checkForUpdate()
                            .then(_this.getUserConfirmation.bind(_this), core$1.noop);
                    }
                });
            }
        }
        AppUpdateComponent.prototype.cancel = function () {
            core$1.addClass(this.elRef.nativeElement, 'hidden');
        };
        AppUpdateComponent.prototype.installLatestVersion = function () {
            var _this = this;
            var apkFile = cordova.file.externalApplicationStorageDirectory + AUTO_UPDATE_FILENAME, downloadLink = this._buildMeta.host + "/appBuild/rest/mobileBuilds/android/download?token=" + this._buildMeta.token + "&buildNumber=" + this._buildMeta.latestBuildNumber + "&fileName=" + AUTO_UPDATE_FILENAME + "&releaseVersion=" + this._buildMeta.platformVersion, progressObserver = { next: function (e) { _this.downloadProgress = (e.loaded / e.total) * 100; }, error: null, complete: null };
            this.fileDownloadService.download(downloadLink, false, cordova.file.externalApplicationStorageDirectory, AUTO_UPDATE_FILENAME, progressObserver).then(function () {
                _this.fileOpener.open(apkFile, 'application/vnd.android.package-archive');
            }, function () {
                this.message = 'Failed to download latest version.';
            });
            this.message = "Downloading the latest version [" + this._buildMeta.latestVersion + "].";
            this.downloading = true;
        };
        AppUpdateComponent.prototype.checkForUpdate = function () {
            var _this = this;
            return new Promise(function (resolve, reject) {
                _this.http.get(_this._buildMeta.host + "/appBuild/rest/mobileBuilds/latest_build?token=" + _this._buildMeta.token + "&releaseVersion=" + _this._buildMeta.platformVersion)
                    .toPromise()
                    .then(function (response) {
                    var latestBuildNumber = response.success.body.buildNumber, latestVersion = response.success.body.version;
                    if (_this._buildMeta.buildNumber < latestBuildNumber) {
                        _this._buildMeta.latestBuildNumber = latestBuildNumber;
                        _this._buildMeta.latestVersion = latestVersion;
                        resolve(latestBuildNumber);
                    }
                    else {
                        reject();
                    }
                }, reject);
            });
        };
        AppUpdateComponent.prototype.getBuildMeta = function () {
            var _this = this;
            if (!this._buildMeta) {
                return this.file.readAsText(cordova.file.applicationDirectory + 'www/', 'build_meta.json')
                    .then(function (data) {
                    _this._buildMeta = JSON.parse(data);
                    return _this._buildMeta;
                }, core$1.noop);
            }
            return Promise.resolve(this._buildMeta);
        };
        AppUpdateComponent.prototype.getUserConfirmation = function () {
            this.downloadProgress = 0;
            this.downloading = false;
            this.message = 'There is an update available. Would you like to update the app?';
            core$1.removeClass(this.elRef.nativeElement, 'hidden');
        };
        AppUpdateComponent.ctorParameters = function () { return [
            { type: core$2.DeviceService },
            { type: core$2.DeviceFileDownloadService },
            { type: core.ElementRef },
            { type: file.File },
            { type: fileOpener.FileOpener },
            { type: http.HttpClient }
        ]; };
        AppUpdateComponent = __decorate([
            core.Component({
                selector: '[wmAppUpdate]',
                template: "<div class=\"modal-dialog\">\n    <div class=\"modal-content\"> \n        <div class=\"modal-body\"> \n            <span [textContent]=\"message\"></span>\n            <div class=\"progress\" [hidden]=\"!downloading\">\n                <div class=\"progress-bar\" [style.width.%]=\"downloadProgress\"></div>\n            </div>\n        </div>\n        <div class=\"modal-footer\"> \n            <button type=\"button\" class=\"btn btn-default\" data-dismiss=\"modal\" (click)=\"cancel()\">Skip update</button>\n            <button type=\"button\" class=\"btn btn-primary\" [hidden]=\"downloading\" (click)=\"installLatestVersion()\">Update</button>\n        </div>\n    </div>\n</div>"
            }),
            __metadata("design:paramtypes", [core$2.DeviceService,
                core$2.DeviceFileDownloadService,
                core.ElementRef,
                file.File,
                fileOpener.FileOpener,
                http.HttpClient])
        ], AppUpdateComponent);
        return AppUpdateComponent;
    }());

    var FileBrowserComponent = /** @class */ (function () {
        function FileBrowserComponent(deviceService) {
            this.deviceService = deviceService;
            this.selectedFiles = [];
            this.submitEmitter = new core.EventEmitter();
        }
        FileBrowserComponent.prototype.getFileExtension = function (fileName) {
            var extIndex = fileName ? fileName.lastIndexOf('.') : -1;
            if (extIndex > 0) {
                return fileName.substring(extIndex + 1);
            }
            return '';
        };
        FileBrowserComponent.prototype.ngOnDestroy = function () {
            if (this.backButtonListenerDeregister) {
                this.backButtonListenerDeregister();
            }
        };
        FileBrowserComponent.prototype.onFileClick = function (file) {
            if (file.isFile) {
                if (file.isSelected) {
                    this.deselectFile(file);
                }
                else {
                    this.selectFile(file);
                }
            }
            else {
                this.goToFolder(file);
            }
        };
        Object.defineProperty(FileBrowserComponent.prototype, "show", {
            set: function (flag) {
                var _this = this;
                var rootDir = cordova.file.externalRootDirectory;
                this.isVisible = flag;
                if (flag) {
                    if (!this.currentFolder) {
                        if (core$1.isIos()) {
                            rootDir = cordova.file.documentsDirectory;
                        }
                        resolveLocalFileSystemURL(rootDir, function (root) { return _this.goToFolder(root); });
                    }
                    this.backButtonListenerDeregister = this.deviceService.onBackButtonTap(function () {
                        if (_this.isVisible) {
                            if (_this.currentFolder.parent) {
                                _this.onFileClick(_this.currentFolder.parent);
                            }
                            else {
                                _this.isVisible = false;
                            }
                            core$1.$appDigest();
                            return false;
                        }
                    });
                }
                else if (this.backButtonListenerDeregister) {
                    this.backButtonListenerDeregister();
                }
            },
            enumerable: true,
            configurable: true
        });
        FileBrowserComponent.prototype.submit = function () {
            var _this = this;
            var files = [];
            this.loadFileSize(this.selectedFiles).then(function () {
                _.forEach(_this.selectedFiles, function (f) {
                    f.isSelected = false;
                    files.push({ path: f.nativeURL,
                        name: f.name,
                        size: f.size });
                });
                _this.selectedFiles = [];
                _this.isVisible = false;
                _this.submitEmitter.next({ files: files });
            });
        };
        FileBrowserComponent.prototype.deselectFile = function (file) {
            _.remove(this.selectedFiles, file);
            file.isSelected = false;
        };
        FileBrowserComponent.prototype.goToFolder = function (folder) {
            var _this = this;
            if (!folder.files) {
                this.loadFolder(folder, this.fileTypeToSelect)
                    .then(function (files) {
                    folder.files = files;
                    folder.parent = _this.currentFolder;
                    _this.currentFolder = folder;
                });
            }
            else {
                this.currentFolder = folder;
            }
        };
        FileBrowserComponent.prototype.loadFileSize = function (files) {
            return Promise.all(files.map(function (f) {
                return new Promise(function (resolve, reject) {
                    f.file(function (o) {
                        f.size = o.size;
                        resolve();
                    }, reject);
                });
            }));
        };
        FileBrowserComponent.prototype.loadFolder = function (folder, fileTypeToSelect) {
            return new Promise(function (resolve, reject) {
                var fileTypeToShow;
                folder.createReader().readEntries(function (entries) {
                    if (!_.isEmpty(fileTypeToSelect)) {
                        fileTypeToShow = _.split(fileTypeToSelect, ',');
                        entries = _.filter(entries, function (e) {
                            return !e.isFile || _.findIndex(fileTypeToShow, function (ext) { return _.endsWith(e.name, '.' + ext); }) >= 0;
                        });
                    }
                    resolve(_.sortBy(entries, function (e) { return (e.isFile ? '1_' : '0_') + e.name.toLowerCase(); }));
                }, reject);
            });
        };
        FileBrowserComponent.prototype.refreshFolder = function () {
            var _this = this;
            return this.loadFolder(this.currentFolder, this.fileTypeToSelect)
                .then(function (files) { return _this.currentFolder.files = files; });
        };
        FileBrowserComponent.prototype.selectFile = function (file) {
            if (!this.multiple && this.selectedFiles.length > 0) {
                this.selectedFiles[0].isSelected = false;
                this.selectedFiles = [];
            }
            this.selectedFiles.push(file);
            file.isSelected = true;
        };
        FileBrowserComponent.ctorParameters = function () { return [
            { type: core$2.DeviceService }
        ]; };
        __decorate([
            core.Input(),
            __metadata("design:type", String)
        ], FileBrowserComponent.prototype, "fileTypeToSelect", void 0);
        __decorate([
            core.Input(),
            __metadata("design:type", Boolean)
        ], FileBrowserComponent.prototype, "multiple", void 0);
        __decorate([
            core.Output('submit'),
            __metadata("design:type", Object)
        ], FileBrowserComponent.prototype, "submitEmitter", void 0);
        FileBrowserComponent = __decorate([
            core.Component({
                selector: '[wmMobileFileBrowser]',
                template: "<div class=\"app-file-browser\" *ngIf=\"isVisible && currentFolder\">\n    <div class=\"modal-backdrop fade\" [class.in]=\"isVisible\"></div>\n    <div class=\"modal fade\" style=\"display: block;\" [class.in]=\"isVisible\" >\n        <div class=\"modal-dialog\">\n            <div class=\"modal-content\">\n                <div class=\"modal-header clearfix\">\n                    <h4 class=\"modal-title pull-left\">\n                        <span (click)=\"onFileClick(currentFolder.parent)\" [hidden]=\"!!!currentFolder.parent\">\n                            <i class=\"wi wi-long-arrow-left\"></i>\n                        </span>\n                     {{currentFolder.name}}\n                    </h4>\n                    <div class=\"selected-file-button pull-right\" (click)=\"refreshFolder()\">\n                        <i class=\"wi wi-refresh\"></i>\n                    </div>\n                </div>\n                <div class=\"modal-body\">\n                    <div class=\"file-info-box\" *ngFor=\"let file of currentFolder.files\">\n                        <div class=\"file-info\"  [class.bg-primary]=\"file.isSelected\" (click)=\"onFileClick(file)\">\n                            <i class=\"file-icon wi wi-folder\" *ngIf=\"!file.isFile\"></i>\n                            <i class=\"file-icon wi wi-file {{getFileExtension(file.name)}}\" *ngIf=\"file.isFile\"></i>\n                            <span class=\"file-name\">{{file.name}}</span>\n                        </div>\n                    </div>\n                </div>\n                <div class=\"modal-footer\">\n                    <button type=\"button\" class=\"btn btn-primary\" *ngIf=\"selectedFiles && selectedFiles.length > 0\" (click)=\"submit()\">\n                        Done <span class=\"badge badge-light\">{{selectedFiles.length}}</span>\n                    </button>\n                    <button type=\"button\" class=\"btn btn-default\" (click)=\"show = false;\">Close</button>\n                </div>\n            </div>\n        </div>\n    </div>\n</div>"
            }),
            __metadata("design:paramtypes", [core$2.DeviceService])
        ], FileBrowserComponent);
        return FileBrowserComponent;
    }());

    var FileSelectorService = /** @class */ (function () {
        function FileSelectorService(spinnerService) {
            this.spinnerService = spinnerService;
        }
        FileSelectorService.prototype.selectAudio = function (multiple) {
            var _this = this;
            if (multiple === void 0) { multiple = false; }
            var spinnerId = this.spinnerService.show("");
            return new Promise(function (resolve, reject) {
                cordova.wavemaker.filePicker.selectAudio(multiple, resolve, reject);
            }).then(function (files) { return _this.getFiles(files); })
                .then(function (paths) {
                _this.spinnerService.hide(spinnerId);
                return paths;
            });
        };
        FileSelectorService.prototype.setFileBrowser = function (f) {
            this.fileBrowserComponent = f;
        };
        FileSelectorService.prototype.selectFiles = function (multiple, fileTypeToSelect) {
            var _this = this;
            if (multiple === void 0) { multiple = false; }
            var spinnerId = this.spinnerService.show("");
            return new Promise(function (resolve, reject) {
                cordova.wavemaker.filePicker.selectFiles(multiple, resolve, reject);
            }).then(function (files) { return _this.getFiles(files); })
                .then(function (paths) {
                _this.spinnerService.hide(spinnerId);
                return paths;
            });
        };
        FileSelectorService.prototype.selectImages = function (multiple) {
            var _this = this;
            if (multiple === void 0) { multiple = false; }
            var spinnerId = this.spinnerService.show("");
            return new Promise(function (resolve, reject) {
                cordova.wavemaker.filePicker.selectImage(multiple, resolve, reject);
            }).then(function (files) { return _this.getFiles(files); })
                .then(function (paths) {
                _this.spinnerService.hide(spinnerId);
                return paths;
            });
        };
        FileSelectorService.prototype.selectVideos = function (multiple) {
            var _this = this;
            if (multiple === void 0) { multiple = false; }
            var spinnerId = this.spinnerService.show("");
            return new Promise(function (resolve, reject) {
                cordova.wavemaker.filePicker.selectVideo(multiple, resolve, reject);
            }).then(function (files) { return _this.getFiles(files); })
                .then(function (paths) {
                _this.spinnerService.hide(spinnerId);
                return paths;
            });
        };
        /**
         * Converts the file to blob using filepath
         * @param filePaths, array of file paths
         * @returns fileObj having name, path, content
         */
        FileSelectorService.prototype.getFiles = function (filePaths) {
            return Promise.all(_.map(filePaths, function (filePath) {
                if (filePath.indexOf('://') < 0) {
                    filePath = 'file://' + filePath;
                }
                return core$1.convertToBlob(filePath);
            })).then(function (filesList) {
                return _.map(filesList, function (fileObj) {
                    var path = fileObj.filepath;
                    return {
                        name: path.split('/').pop(),
                        path: path,
                        content: fileObj.blob,
                        size: fileObj.blob.size
                    };
                });
            });
        };
        FileSelectorService.SERVICE_NAME = 'FileSelectorService';
        FileSelectorService.ctorParameters = function () { return [
            { type: core$1.AbstractSpinnerService }
        ]; };
        FileSelectorService.ɵprov = core["ɵɵdefineInjectable"]({ factory: function FileSelectorService_Factory() { return new FileSelectorService(core["ɵɵinject"](core$1.AbstractSpinnerService)); }, token: FileSelectorService, providedIn: "root" });
        FileSelectorService = __decorate([
            core.Injectable({ providedIn: 'root' }),
            __metadata("design:paramtypes", [core$1.AbstractSpinnerService])
        ], FileSelectorService);
        return FileSelectorService;
    }());

    var DEFAULT_IMAGE = 'resources/images/imagelists/default-image.png';
    var ImageCacheDirective = /** @class */ (function () {
        function ImageCacheDirective(componentInstance, deviceFileCacheService, file) {
            this.componentInstance = componentInstance;
            this.deviceFileCacheService = deviceFileCacheService;
            this.file = file;
            this._isEnabled = false;
            this._lastUrl = '';
        }
        ImageCacheDirective.prototype.ngDoCheck = function () {
            var _this = this;
            if (!core$1.isSpotcues && this.componentInstance.imgSource
                && this.componentInstance.imgSource.startsWith('http')) {
                if (this._lastUrl !== this.componentInstance.imgSource) {
                    this._lastUrl = this.componentInstance.imgSource;
                    this.componentInstance.imgSource = DEFAULT_IMAGE;
                    this.getLocalPath(this._lastUrl).then(function (localPath) {
                        _this._cacheUrl = core$1.transformFileURI(localPath);
                        _this.componentInstance.imgSource = _this._cacheUrl;
                    });
                }
                else if (this._cacheUrl) {
                    this.componentInstance.imgSource = this._cacheUrl;
                }
            }
        };
        Object.defineProperty(ImageCacheDirective.prototype, "wmImageCache", {
            set: function (val) {
                this._isEnabled = (core$1.hasCordova() && val === 'true');
            },
            enumerable: true,
            configurable: true
        });
        ImageCacheDirective.prototype.getLocalPath = function (val) {
            if (core$1.hasCordova() && val && val.indexOf('{{') < 0 && val.startsWith('http')) {
                return this.deviceFileCacheService.getLocalPath(val, true, true, !this._isEnabled)
                    .catch(core$1.noop);
            }
            return Promise.resolve(val);
        };
        ImageCacheDirective.ctorParameters = function () { return [
            { type: undefined, decorators: [{ type: core.Self }, { type: core.Inject, args: [base.WidgetRef,] }] },
            { type: core$2.DeviceFileCacheService },
            { type: file.File }
        ]; };
        __decorate([
            core.Input(),
            __metadata("design:type", String),
            __metadata("design:paramtypes", [String])
        ], ImageCacheDirective.prototype, "wmImageCache", null);
        ImageCacheDirective = __decorate([
            core.Directive({
                selector: '[wmImageCache]'
            }),
            __param(0, core.Self()), __param(0, core.Inject(base.WidgetRef)),
            __metadata("design:paramtypes", [Object, core$2.DeviceFileCacheService,
                file.File])
        ], ImageCacheDirective);
        return ImageCacheDirective;
    }());

    var registerProps = function () {
        base.register('wm-network-info-toaster', new Map([]));
    };

    var DEFAULT_CLS$1 = 'network-info-toaster';
    var WIDGET_CONFIG = { widgetType: 'wm-network-info-toaster', hostClass: DEFAULT_CLS$1 };

    (function (NetworkState) {
        NetworkState[NetworkState["CONNECTED"] = 1] = "CONNECTED";
        NetworkState[NetworkState["CONNECTING"] = 0] = "CONNECTING";
        NetworkState[NetworkState["SERVICE_AVAILABLE_BUT_NOT_CONNECTED"] = -1] = "SERVICE_AVAILABLE_BUT_NOT_CONNECTED";
        NetworkState[NetworkState["NETWORK_AVAIABLE_BUT_SERVICE_NOT_AVAILABLE"] = -2] = "NETWORK_AVAIABLE_BUT_SERVICE_NOT_AVAILABLE";
        NetworkState[NetworkState["NETWORK_NOT_AVAIABLE"] = -3] = "NETWORK_NOT_AVAIABLE";
    })(exports.NetworkState || (exports.NetworkState = {}));
    var NetworkInfoToasterComponent = /** @class */ (function (_super) {
        __extends(NetworkInfoToasterComponent, _super);
        function NetworkInfoToasterComponent(networkService, app, inj) {
            var _this = _super.call(this, inj, WIDGET_CONFIG) || this;
            _this.networkService = networkService;
            _this.showMessage = false;
            _this.isServiceConnected = false;
            _this.isServiceAvailable = false;
            base.styler(_this.$element, _this);
            _this.isServiceAvailable = _this.networkService.isAvailable();
            _this.isServiceConnected = _this.networkService.isConnected();
            _this._listenerDestroyer = app.subscribe('onNetworkStateChange', function (data) {
                _this.renderMessage(data);
            });
            _this.renderMessage();
            return _this;
        }
        NetworkInfoToasterComponent_1 = NetworkInfoToasterComponent;
        NetworkInfoToasterComponent.prototype.renderMessage = function (data) {
            var _this = this;
            data = data || this.networkService.getState();
            var oldState = this.networkState;
            var autoHide = false;
            if (data.isConnected) {
                this.networkState = exports.NetworkState.CONNECTED;
                autoHide = true;
            }
            else if (data.isConnecting) {
                this.networkState = exports.NetworkState.CONNECTING;
            }
            else if (data.isServiceAvailable) {
                this.networkState = exports.NetworkState.SERVICE_AVAILABLE_BUT_NOT_CONNECTED;
            }
            else if (data.isNetworkAvailable && !data.isServiceAvailable) {
                this.networkState = exports.NetworkState.NETWORK_AVAIABLE_BUT_SERVICE_NOT_AVAILABLE;
            }
            else {
                this.networkState = exports.NetworkState.NETWORK_NOT_AVAIABLE;
            }
            this.showMessage = (!(oldState === undefined && data.isConnected) && oldState !== this.networkState);
            if (autoHide && this.showMessage) {
                setTimeout(function () {
                    _this.showMessage = false;
                    core$1.$appDigest();
                }, 5000);
            }
        };
        NetworkInfoToasterComponent.prototype.connect = function () {
            this.networkService.connect();
        };
        NetworkInfoToasterComponent.prototype.hideMessage = function () {
            this.showMessage = false;
        };
        NetworkInfoToasterComponent.prototype.ngOnDestroy = function () {
            this._listenerDestroyer();
            _super.prototype.ngOnDestroy.call(this);
        };
        var NetworkInfoToasterComponent_1;
        NetworkInfoToasterComponent.initializeProps = registerProps();
        NetworkInfoToasterComponent.ctorParameters = function () { return [
            { type: core$2.NetworkService },
            { type: core$1.App },
            { type: core.Injector }
        ]; };
        NetworkInfoToasterComponent = NetworkInfoToasterComponent_1 = __decorate([
            core.Component({
                selector: '[wmNetworkInfoToaster]',
                template: "<div class=\"network-info-toaster-content\" [ngSwitch]=\"networkState\" *ngIf=\"showMessage\">\n    <div class=\"info\" *ngSwitchCase=\"-3\">\n       <label class=\"message\" [textContent]=\"appLocale.MESSAGE_NETWORK_NOT_AVAILABLE\"></label>\n       <button class=\"btn btn-default hide-btn\" (click)=\"hideMessage()\" [textContent]=\"appLocale.LABEL_HIDE_NETWORK_INFO\"></button>\n    </div>\n    <div class=\"info\" *ngSwitchCase=\"-2\">\n       <label class=\"message\" [textContent]=\"appLocale.MESSAGE_SERVICE_NOT_AVAILABLE\"></label>\n       <button class=\"btn btn-default hide-btn\" (click)=\"hideMessage()\" [textContent]=\"appLocale.LABEL_HIDE_NETWORK_INFO\"></button>\n    </div>\n    <div class=\"info\" *ngSwitchCase=\"-1\">\n       <label class=\"message\" [textContent]=\"appLocale.MESSAGE_SERVICE_AVAILABLE\"></label>\n       <button class=\"btn btn-default hide-btn\" (click)=\"hideMessage()\" [textContent]=\"appLocale.LABEL_HIDE_NETWORK_INFO\"></button>\n       <button class=\"btn btn-primary connect-btn\" (click)=\"connect()\" [textContent]=\"appLocale.LABEL_CONNECT_TO_SERVICE\"></button>\n    </div>\n    <div class=\"info\" *ngSwitchCase=\"0\">\n       <label class=\"message\" [textContent]=\"appLocale.MESSAGE_SERVICE_CONNECTING\"></label>\n    </div>\n    <div class=\"info\" *ngSwitchCase=\"1\">\n       <label class=\"message\" [textContent]=\"appLocale.MESSAGE_SERVICE_CONNECTED\"></label>\n    </div>\n</div>",
                providers: [
                    base.provideAsWidgetRef(NetworkInfoToasterComponent_1)
                ]
            }),
            __metadata("design:paramtypes", [core$2.NetworkService, core$1.App, core.Injector])
        ], NetworkInfoToasterComponent);
        return NetworkInfoToasterComponent;
    }(base.StylableComponent));

    var MAX_PROCESS = 3;
    var ProcessManagerComponent = /** @class */ (function () {
        function ProcessManagerComponent(el) {
            this.el = el;
            this.isVisible = true;
            this.instances = [];
            this.queue = [];
            core$1.addClass(this.el.nativeElement, 'app-global-progress-bar modal default');
        }
        ProcessManagerComponent_1 = ProcessManagerComponent;
        ProcessManagerComponent.prototype.createInstance = function (name, min, max) {
            var _this = this;
            if (min === void 0) { min = 0; }
            if (max === void 0) { max = 100; }
            var instance = {
                max: max,
                min: min,
                name: name,
                onStop: null,
                progressLabel: '',
                show: min !== max,
                stopButtonLabel: 'Cancel',
                value: 0
            };
            var api = {
                get: function (propertyName) { return instance[propertyName]; },
                set: function (propertyName, propertyValue) { return _this.setInstaceProperty(instance, propertyName, propertyValue); },
                destroy: function () { return _this.removeInstance(instance); }
            };
            return this.addToQueue(instance).then(function () { return api; });
        };
        ProcessManagerComponent.prototype.getVisibleInstances = function () {
            return this.instances.filter(function (i) { return i.show; });
        };
        ProcessManagerComponent.prototype.ngDoCheck = function () {
            var hasInstancesToShow = !!this.instances.find(function (i) { return i.show; });
            if (this.isVisible && !hasInstancesToShow) {
                core$1.setAttr(this.el.nativeElement, 'hidden', 'true');
                this.isVisible = false;
            }
            else if (!this.isVisible && hasInstancesToShow) {
                core$1.removeAttr(this.el.nativeElement, 'hidden');
                this.isVisible = true;
            }
        };
        ProcessManagerComponent.prototype.addToQueue = function (instance) {
            var _this = this;
            return new Promise(function (resolve) {
                _this.queue.push(function () {
                    if (_this.instances.length < MAX_PROCESS) {
                        _this.instances.push(instance);
                        resolve(instance);
                    }
                    else {
                        return false;
                    }
                });
                _this.flushQueue();
            });
        };
        ProcessManagerComponent.prototype.flushQueue = function () {
            if (this.queue.length > 0 && this.queue[0]() !== false) {
                this.queue.shift();
                this.flushQueue();
            }
        };
        ProcessManagerComponent.prototype.removeInstance = function (instance) {
            var _this = this;
            return new Promise(function (resolve) {
                setTimeout(function () {
                    _.remove(_this.instances, instance);
                    _this.flushQueue();
                    resolve();
                }, 1000);
            });
        };
        ProcessManagerComponent.prototype.setInstaceProperty = function (instance, propertyName, propertyValue) {
            var _this = this;
            if (propertyName === 'value') {
                if (instance.value >= instance.max) {
                    propertyValue = instance.max;
                }
                instance.value = propertyValue;
                instance.progressLabel = instance.value + '/' + instance.max;
            }
            else if (propertyName === 'onStop' && _.isFunction(propertyValue)) {
                instance.onStop = function () {
                    propertyValue();
                    return _this.removeInstance(instance);
                };
            }
            else {
                instance[propertyName] = propertyValue;
            }
            instance.show = instance.min !== instance.max;
        };
        var ProcessManagerComponent_1;
        ProcessManagerComponent.ctorParameters = function () { return [
            { type: core.ElementRef }
        ]; };
        ProcessManagerComponent = ProcessManagerComponent_1 = __decorate([
            core.Component({
                selector: '[wmProcessManager]',
                template: "<ng-container *ngIf=\"instances.length > 0\">\n   <div class=\"modal-dialog app-dialog\">\n       <div class=\"modal-content\">\n           <ul class=\"instance-list list-unstyled\">\n               <li *ngFor=\"let instance of getVisibleInstances(instances); index as i\" class=\"instance-list-item\">\n                   <div class=\"row\">\n                       <div class=\"col-xs-8\">\n                           <label class=\"app-global-progress-bar-name h6\">{{instance.name}}</label>\n                       </div>\n                       <div class=\"col-xs-4 app-global-progress-bar-progress-label-col\">\n                           <label class=\"app-global-progress-bar-progress-label h6\">\n                                   {{instance.progressLabel}}</label>\n                       </div>\n                   </div>\n                   <ng-template [ngTemplateOutlet]=\"progressTemplate\" [ngTemplateOutletContext]=\"{instance: instance}\"></ng-template>\n                   <button class=\"btn btn-secondary pull-right stop-btn\" *ngIf=\"instance.onStop\" (click)=\"instance.onStop();\">\n                       {{instance.stopButtonLabel}}\n                   </button>\n                   <div style=\"clear: both;\"></div>\n               </li>\n               <li class=\"instance-list-item\" *ngIf=\"queue.length > 0\">\n                   <label class=\"global-progress-bar-ui-primary-label h6\">\n                       ({{queue.length}}) queued\n                   </label>\n               </li>\n           </ul>\n       </div>\n   </div>\n</ng-container>\n<ng-template #progressTemplate let-instance=\"instance\">\n    <div wmProgressBar minvalue.bind=\"instance.min\" maxvalue.bind=\"instance.max\" datavalue.bind=\"instance.value\"></div>\n</ng-template>",
                providers: [
                    base.provideAsWidgetRef(ProcessManagerComponent_1)
                ]
            }),
            __metadata("design:paramtypes", [core.ElementRef])
        ], ProcessManagerComponent);
        return ProcessManagerComponent;
    }());

    var ProcessManagementService = /** @class */ (function () {
        function ProcessManagementService() {
        }
        ProcessManagementService.prototype.setUIComponent = function (processManagerComponent) {
            this.processManagerComponent = processManagerComponent;
        };
        /**
         * Returns a promise that will be resolved when an instance is available. At max, 3 instances can only run
         * in parallel and rest has to wait till a process is completed.
         *
         * A progress instance has the following properties.
         *
         *   1) min {number} minimum value, default value is 0 </br>
         *   2) max {number} maximum value, default value is 100 </br>
         *   3) value {number} progress value </br>
         *   4) progressLabel {string} process name </br>
         *   5) stopButtonLabel {string} label for stop button, default value is 'Cancel' </br>
         *   6) onStop {function} function to invoke when stop button is clicked. </br>
         *
         * A progress instance has 3 methods </br>
         *   1) set(property, value) -- sets value to the corresponding property </br>
         *   2) get(property) -- returns property value </br>
         *   3) destroy() -- closes the instance. </br>
         *
         * A progress instance will get auto closed when value and max are equal or when destroy method is called.
         *
         * @param {string} name name of the process whose progress is going to be shown
         * @param {number} min minimum value
         * @param {number} max maximum value
         *
         * @returns {object} a promise
         */
        ProcessManagementService.prototype.createInstance = function (name, min, max) {
            if (!this.processManagerComponent) {
                return Promise.reject('ProcessManagerComponent is missing');
            }
            return this.processManagerComponent.createInstance(name, min, max);
        };
        ProcessManagementService.SERVICE_NAME = 'ProcessManagementService';
        ProcessManagementService.ɵprov = core["ɵɵdefineInjectable"]({ factory: function ProcessManagementService_Factory() { return new ProcessManagementService(); }, token: ProcessManagementService, providedIn: "root" });
        ProcessManagementService = __decorate([
            core.Injectable({ providedIn: 'root' })
        ], ProcessManagementService);
        return ProcessManagementService;
    }());

    var components = [
        AnchorDirective,
        AppUpdateComponent,
        FileBrowserComponent,
        ImageCacheDirective,
        NetworkInfoToasterComponent,
        ProcessManagerComponent
    ];
    var BasicModule = /** @class */ (function () {
        function BasicModule() {
        }
        BasicModule = __decorate([
            core.NgModule({
                imports: [
                    common.CommonModule,
                    progress.ProgressModule,
                    base.WmComponentsModule
                ],
                declarations: __spread(components),
                exports: __spread(components),
                entryComponents: []
            })
        ], BasicModule);
        return BasicModule;
    }());

    exports.AnchorDirective = AnchorDirective;
    exports.AppUpdateComponent = AppUpdateComponent;
    exports.BasicModule = BasicModule;
    exports.FileBrowserComponent = FileBrowserComponent;
    exports.FileSelectorService = FileSelectorService;
    exports.ImageCacheDirective = ImageCacheDirective;
    exports.NetworkInfoToasterComponent = NetworkInfoToasterComponent;
    exports.ProcessManagementService = ProcessManagementService;
    exports.ProcessManagerComponent = ProcessManagerComponent;
    exports.ɵa = registerProps;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=index.umd.js.map
