import { ElementRef, OnDestroy } from '@angular/core';
import { PageDirective } from '@wm/components/page';
import { LeftPanelDirective } from '@wm/components/page/left-panel';
import { DeviceService } from '@wm/mobile/core';
export declare class MobileLeftPanelDirective implements OnDestroy {
    private page;
    private leftPanelRef;
    private deviceService;
    private _backBtnListenerDestroyer;
    constructor(page: PageDirective, leftPanelRef: LeftPanelDirective, deviceService: DeviceService, elRef: ElementRef);
    ngOnDestroy(): void;
    private destroyBackBtnListener;
}
