(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@wm/core'), require('@wm/components/base'), require('@wm/components/page'), require('@wm/components/basic/search'), require('@wm/mobile/core'), require('@angular/common')) :
    typeof define === 'function' && define.amd ? define('@wm/mobile/components/page/mobile-navbar', ['exports', '@angular/core', '@wm/core', '@wm/components/base', '@wm/components/page', '@wm/components/basic/search', '@wm/mobile/core', '@angular/common'], factory) :
    (global = global || self, factory((global.wm = global.wm || {}, global.wm.mobile = global.wm.mobile || {}, global.wm.mobile.components = global.wm.mobile.components || {}, global.wm.mobile.components.page = global.wm.mobile.components.page || {}, global.wm.mobile.components.page.mobilenavbar = {}), global.ng.core, global.wm.core, global.wm.components.base, global.wm.components.page, global.wm.components.basic.search, global.wm.mobile.core, global.ng.common));
}(this, (function (exports, core, core$1, base, page, search, core$2, common) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __rest(s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); }
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    function __createBinding(o, m, k, k2) {
        if (k2 === undefined) k2 = k;
        o[k2] = m[k];
    }

    function __exportStar(m, exports) {
        for (var p in m) if (p !== "default" && !exports.hasOwnProperty(p)) exports[p] = m[p];
    }

    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m) return m.call(o);
        if (o && typeof o.length === "number") return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }

    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    }

    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    };

    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }

    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
    }

    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }

    function __asyncValues(o) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
    }

    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
        return cooked;
    };

    function __importStar(mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
        result.default = mod;
        return result;
    }

    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }

    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }

    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    var navbarProps = new Map([
        ['backbutton', __assign({ value: true }, base.PROP_BOOLEAN)],
        ['backbuttoniconclass', __assign({ value: 'wi wi-back' }, base.PROP_STRING)],
        ['backbuttonlabel', __assign({ value: '' }, base.PROP_STRING)],
        ['backgroundattachment', base.PROP_STRING],
        ['backgroundcolor', base.PROP_STRING],
        ['backgroundgradient', base.PROP_STRING],
        ['backgroundimage', base.PROP_STRING],
        ['backgroundposition', base.PROP_STRING],
        ['backgroundrepeat', base.PROP_STRING],
        ['backgroundsize', base.PROP_STRING],
        ['class', base.PROP_STRING],
        ['datafield', __assign({ value: 'All Fields' }, base.PROP_STRING)],
        ['dataset', base.PROP_ANY],
        ['datasource', base.PROP_STRING],
        ['datavalue', base.PROP_STRING],
        ['debouncetime', __assign({ value: 250 }, base.PROP_NUMBER)],
        ['defaultview', base.PROP_STRING],
        ['displayimagesrc', base.PROP_STRING],
        ['displaylabel', base.PROP_STRING],
        ['imgsrc', base.PROP_STRING],
        ['query', __assign({ value: '' }, base.PROP_STRING)],
        ['leftnavpaneliconclass', __assign({ value: 'wi wi-menu' }, base.PROP_STRING)],
        ['matchmode', base.PROP_STRING],
        ['name', base.PROP_STRING],
        ['readonlySearchBar', base.PROP_BOOLEAN],
        ['searchbutton', __assign({ value: false }, base.PROP_BOOLEAN)],
        ['searchbuttoniconclass', __assign({ value: 'wi wi-search' }, base.PROP_STRING)],
        ['searchbuttonlabel', __assign({ value: '' }, base.PROP_STRING)],
        ['show', __assign({ value: true }, base.PROP_BOOLEAN)],
        ['showLeftnavbtn', __assign({ value: true }, base.PROP_BOOLEAN)],
        ['searchkey', base.PROP_STRING],
        ['searchplaceholder', __assign({ value: 'Search' }, base.PROP_STRING)],
        ['showSearchbar', base.PROP_BOOLEAN],
        ['title', base.PROP_STRING]
    ]);
    var registerProps = function () {
        base.register('wm-mobile-navbar', navbarProps);
    };

    var DEFAULT_CLS = 'app-mobile-header app-mobile-navbar';
    var WIDGET_CONFIG = { widgetType: 'wm-mobile-navbar', hostClass: DEFAULT_CLS };
    var MobileNavbarComponent = /** @class */ (function (_super) {
        __extends(MobileNavbarComponent, _super);
        function MobileNavbarComponent(app, page, deviceService, navigationService, inj, backbtnClickEvt) {
            var _this = _super.call(this, inj, WIDGET_CONFIG) || this;
            _this.page = page;
            _this.deviceService = deviceService;
            _this.navigationService = navigationService;
            _this.backbtnClickEvt = backbtnClickEvt;
            _this._isReady = false;
            page.subscribe('wmLeftPanel:ready', function (leftNavPanel) {
                if (_this.showLeftnavbtn) {
                    _this.leftNavPanel = leftNavPanel;
                }
            });
            _this._backBtnListenerDestroyer = deviceService.onBackButtonTap(function ($event) {
                if (_this._isReady) {
                    if (_this.backbtnClickEvt) {
                        _this.invokeEventCallback('backbtnclick', { $event: $event });
                        return false;
                    }
                }
            });
            _this.binddisplaylabel = _this.nativeElement.getAttribute('displaylabel.bind');
            setTimeout(function () { return _this._isReady = true; }, 1000);
            return _this;
        }
        MobileNavbarComponent_1 = MobileNavbarComponent;
        Object.defineProperty(MobileNavbarComponent.prototype, "datasource", {
            // getter setter is added to pass the datasource to searchcomponent.
            get: function () {
                return this._datasource;
            },
            set: function (nv) {
                this._datasource = nv;
                this.searchComponent.datasource = nv;
            },
            enumerable: true,
            configurable: true
        });
        MobileNavbarComponent.prototype.ngAfterViewInit = function () {
            this.searchComponent.binddisplayimagesrc = this.binddisplayimagesrc;
            this.searchComponent.displayimagesrc = this.binddisplayimagesrc ? this.binddisplayimagesrc : this.displayimagesrc;
            this.searchComponent.displaylabel = this.displaylabel;
            this.searchComponent.binddisplaylabel = this.binddisplaylabel;
            this.searchComponent.datafield = this.datafield;
            this.searchComponent.binddataset = this.binddataset;
            this.searchComponent.dataset = this.dataset;
            this.searchComponent.searchkey = this.searchkey;
            this.searchComponent.datasource = this.datasource;
            this.searchComponent.matchmode = this.matchmode;
        };
        MobileNavbarComponent.prototype.goBack = function ($event) {
            /**
             * TODO: while trying navigating from details page to edit page in wavereads, app is navigating
             * as details -> editPage -> details. For now, keeping this callback to react after 1 second.
             */
            this.deviceService.executeBackTapListeners($event);
        };
        MobileNavbarComponent.prototype.ngOnDestroy = function () {
            this._backBtnListenerDestroyer();
            _super.prototype.ngOnDestroy.call(this);
        };
        MobileNavbarComponent.prototype.onPropertyChange = function (key, nv, ov) {
            if (this.searchComponent) {
                if (key === 'datafield') {
                    this.searchComponent.datafield = this.datafield;
                }
                if (key === 'displaylabel') {
                    this.searchComponent.displaylabel = this.displaylabel;
                }
            }
            if (key === 'imgsrc') {
                this.imagesrc = base.getImageUrl(nv);
            }
            else if (key === 'dataset') {
                // $is._dataset = nv;
            }
            else if (key === 'defaultview') {
                this.showSearchbar = (nv === 'searchview');
            }
            else if (key === 'datavalue') {
                this.query = nv;
            }
            else {
                _super.prototype.onPropertyChange.call(this, key, nv, ov);
            }
        };
        MobileNavbarComponent.prototype.onSubmission = function ($event) {
            this.invokeEventCallback('search', { $event: $event });
        };
        // switches the view based on defaultview
        MobileNavbarComponent.prototype.switchView = function (view) {
            this.showSearchbar = (view !== 'actionview');
        };
        // goto previous view or page
        MobileNavbarComponent.prototype.goBacktoPreviousView = function ($event) {
            if (this.defaultview === 'actionview') {
                // switches the view from search to action or action to search.
                this.switchView('actionview');
            }
            else {
                // goes back to the previous visited page.
                this.goBack($event);
            }
        };
        MobileNavbarComponent.prototype.onSelect = function ($event, widget, selectedValue) {
            this.datavalue = selectedValue;
            this.query = widget.query;
            this.invokeEventCallback('change', {
                $event: $event,
                newVal: selectedValue,
                oldVal: widget.prevDatavalue
            });
        };
        MobileNavbarComponent.prototype.onClear = function () {
            this.datavalue = '';
            this.query = '';
        };
        var MobileNavbarComponent_1;
        MobileNavbarComponent.initializeProps = registerProps();
        MobileNavbarComponent.ctorParameters = function () { return [
            { type: core$1.App },
            { type: page.PageDirective },
            { type: core$2.DeviceService },
            { type: core$1.AbstractNavigationService },
            { type: core.Injector },
            { type: undefined, decorators: [{ type: core.Attribute, args: ['backbtnclick.event',] }] }
        ]; };
        __decorate([
            core.ViewChild(search.SearchComponent, { static: true }),
            __metadata("design:type", search.SearchComponent)
        ], MobileNavbarComponent.prototype, "searchComponent", void 0);
        MobileNavbarComponent = MobileNavbarComponent_1 = __decorate([
            core.Component({
                selector: 'header[wmMobileNavbar]',
                template: "<nav class=\"navbar\" *ngIf=\"!showSearchbar\">\n    <div class=\"mobile-navbar-left\">\n        <ul class=\"nav navbar-nav navbar-left\">\n            <li *ngIf=\"leftNavPanel\" >\n                <a (click)=\"leftNavPanel.toggle();\"  href=\"javascript: void(0);\">\n                    <i [ngClass]=\"leftnavpaneliconclass\"></i>\n                    </a>\n                </li>\n            <li *ngIf=\"backbutton\">\n                <a class=\"btn-back\" type=\"button\" (click)=\"goBack($event)\"  href=\"javascript: void(0);\">\n                    <i [ngClass]=\"backbuttoniconclass\"></i><span [innerText]=\"backbuttonlabel\"></span>\n                </a>\n            </li>\n        </ul>\n    </div>\n    <div class=\"mobile-navbar-center\">\n        <div class=\"navbar-header\">\n            <h1 class=\"navbar-brand\">\n                <img data-identifier=\"img\" class=\"brand-image\" [alt]=\"title\" width=\"32\" height=\"32\" *ngIf=\"imgsrc\" [src]=\"imgsrc\"/>\n                <span class=\"title\" [innerText]=\"title || ''\"></span>\n                </h1>\n            </div>\n        </div>\n    <div class=\"mobile-navbar-right\">\n        <ul class=\"nav navbar-nav navbar-right\">\n            <li>\n                <ng-content></ng-content>\n            </li>\n            <li *ngIf=\"searchbutton\">\n                <a class=\"btn-search btn-transparent\" type=\"button\" (click)=\"showSearchbar = true\"  href=\"javascript: void(0);\">\n                    <i [ngClass]=\"searchbuttoniconclass\"></i><span [innerText]=\"searchbuttonlabel\"></span>\n                </a>\n            </li>\n        </ul>\n    </div>\n</nav>\n<nav class=\"navbar searchbar\" [hidden]=\"!showSearchbar\">\n    <div class=\"mobile-navbar-left\">\n        <ul class=\"nav navbar-nav navbar-left\">\n            <li>\n                <a class=\"btn-back\" type=\"button\" (click)=\"goBacktoPreviousView($event)\" href=\"javascript:void(0);\">\n                    <i [ngClass]=\"backbuttoniconclass\"></i>\n                </a>\n            </li>\n        </ul>\n    </div>\n    <div class=\"mobile-navbar-center search-container\">\n        <div wmSearch query.bind=\"query\"\n             clearsearch.event=\"onClear();\"\n             select.event=\"onSelect($event, widget, selectedValue)\"\n             searchkey.bind=\"searchkey\"\n             dataset.bind=\"dataset\"\n             displayimagesrc.bind=\"displayimagesrc\"\n             datavalue.bind=\"datavalue\"\n             submit.event=\"onSubmission($event, widget, value)\"\n             placeholder.bind=\"searchplaceholder\"\n             navsearchbar=\"true\"\n             readonly.bind=\"readonlySearchBar\">\n        </div>\n    </div>\n    <div class=\"mobile-navbar-right\">\n        <ul class=\"nav navbar-nav navbar-right\">\n            <li>\n                <a class=\"btn-cancel btn-transparent\" type=\"button\" (click)=\"showSearchbar = false;\"  href=\"javascript: void(0);\"> Cancel </a>\n            </li>\n        </ul>\n    </div>\n</nav>",
                providers: [
                    base.provideAsWidgetRef(MobileNavbarComponent_1)
                ]
            }),
            __param(5, core.Attribute('backbtnclick.event')),
            __metadata("design:paramtypes", [core$1.App,
                page.PageDirective,
                core$2.DeviceService,
                core$1.AbstractNavigationService,
                core.Injector, Object])
        ], MobileNavbarComponent);
        return MobileNavbarComponent;
    }(base.BaseComponent));

    var components = [
        MobileNavbarComponent
    ];
    var MobileNavbarModule = /** @class */ (function () {
        function MobileNavbarModule() {
        }
        MobileNavbarModule = __decorate([
            core.NgModule({
                imports: [
                    common.CommonModule,
                    search.SearchModule,
                    base.WmComponentsModule
                ],
                declarations: __spread(components),
                exports: __spread(components),
                entryComponents: []
            })
        ], MobileNavbarModule);
        return MobileNavbarModule;
    }());

    exports.MobileNavbarComponent = MobileNavbarComponent;
    exports.MobileNavbarModule = MobileNavbarModule;
    exports.ɵa = registerProps;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=index.umd.js.map
