import { AfterViewInit, Injector, OnDestroy } from '@angular/core';
import { AbstractNavigationService, App } from '@wm/core';
import { BaseComponent } from '@wm/components/base';
import { PageDirective } from '@wm/components/page';
import { LeftPanelDirective } from '@wm/components/page/left-panel';
import { SearchComponent } from '@wm/components/basic/search';
import { DeviceService } from '@wm/mobile/core';
export declare class MobileNavbarComponent extends BaseComponent implements OnDestroy, AfterViewInit {
    private page;
    private deviceService;
    private navigationService;
    private backbtnClickEvt;
    static initializeProps: void;
    private _isReady;
    datavalue: string;
    imagesrc: string;
    query: string;
    leftNavPanel: LeftPanelDirective;
    showLeftnavbtn: boolean;
    showSearchbar: boolean;
    backbuttoniconclass: any;
    private _backBtnListenerDestroyer;
    searchComponent: SearchComponent;
    private searchkey;
    private dataset;
    private binddataset;
    private datafield;
    private binddisplaylabel;
    private displaylabel;
    private binddisplayimagesrc;
    private displayimagesrc;
    private _datasource;
    private defaultview;
    private matchmode;
    get datasource(): any;
    set datasource(nv: any);
    constructor(app: App, page: PageDirective, deviceService: DeviceService, navigationService: AbstractNavigationService, inj: Injector, backbtnClickEvt: any);
    ngAfterViewInit(): void;
    goBack($event: any): void;
    ngOnDestroy(): void;
    onPropertyChange(key: any, nv: any, ov?: any): void;
    onSubmission($event: any): void;
    private switchView;
    goBacktoPreviousView($event: any): void;
    private onSelect;
    private onClear;
}
