(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/common/http'), require('@angular/core'), require('@ionic-native/app-version'), require('@ionic-native/barcode-scanner'), require('@ionic-native/calendar'), require('@ionic-native/camera'), require('@ionic-native/contacts'), require('@ionic-native/file'), require('@ionic-native/file-opener'), require('@ionic-native/device'), require('@ionic-native/media-capture'), require('@ionic-native/geolocation'), require('@ionic-native/network'), require('@ionic-native/sqlite'), require('@ionic-native/vibration'), require('@wm/core'), require('@wm/components/base'), require('@wm/mobile/core'), require('@wm/mobile/offline'), require('@wm/security'), require('@wm/mobile/variables'), require('@wm/variables'), require('@wm/mobile/components/basic'), require('rxjs'), require('rxjs/operators')) :
    typeof define === 'function' && define.amd ? define('@wm/mobile/runtime', ['exports', '@angular/common/http', '@angular/core', '@ionic-native/app-version', '@ionic-native/barcode-scanner', '@ionic-native/calendar', '@ionic-native/camera', '@ionic-native/contacts', '@ionic-native/file', '@ionic-native/file-opener', '@ionic-native/device', '@ionic-native/media-capture', '@ionic-native/geolocation', '@ionic-native/network', '@ionic-native/sqlite', '@ionic-native/vibration', '@wm/core', '@wm/components/base', '@wm/mobile/core', '@wm/mobile/offline', '@wm/security', '@wm/mobile/variables', '@wm/variables', '@wm/mobile/components/basic', 'rxjs', 'rxjs/operators'], factory) :
    (global = global || self, factory((global.wm = global.wm || {}, global.wm.mobile = global.wm.mobile || {}, global.wm.mobile.runtime = {}), global.ng.common.http, global.ng.core, global.ionicNative.plugins, global.ionicNative.plugins, global.ionicNative.plugins, global.ionicNative.plugins, global.ionicNative.plugins, global.ionicNative.plugins, global.ionicNative.plugins, global.ionicNative.plugins, global.ionicNative.plugins, global.ionicNative.plugins, global.ionicNative.plugins, global.ionicNative.plugins, global.ionicNative.plugins, global.wm.core, global.wm.components.base, global.wm.mobile.core, global.wm.mobile.offline, global.wm.security, global.wm.mobile.variables, global.wm.variables, global.wm.mobile.components.basic, global.rxjs, global.rxjs.operators));
}(this, (function (exports, http, core, appVersion, barcodeScanner, calendar, camera, contacts, file, fileOpener, device, mediaCapture, geolocation, network, sqlite, vibration, core$1, base, core$2, offline, security, variables, variables$1, basic, rxjs, operators) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __rest(s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); }
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    function __createBinding(o, m, k, k2) {
        if (k2 === undefined) k2 = k;
        o[k2] = m[k];
    }

    function __exportStar(m, exports) {
        for (var p in m) if (p !== "default" && !exports.hasOwnProperty(p)) exports[p] = m[p];
    }

    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m) return m.call(o);
        if (o && typeof o.length === "number") return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }

    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    }

    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    };

    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }

    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
    }

    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }

    function __asyncValues(o) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
    }

    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
        return cooked;
    };

    function __importStar(mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
        result.default = mod;
        return result;
    }

    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }

    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }

    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    var AppExtComponent = /** @class */ (function () {
        function AppExtComponent(elRef, fileSelectorService, processManagementService) {
            this.elRef = elRef;
            this.fileSelectorService = fileSelectorService;
            this.processManagementService = processManagementService;
        }
        AppExtComponent.prototype.ngAfterViewInit = function () {
            var mobileElements = $(this.elRef.nativeElement).find('>[wmNetworkInfoToaster], >[wmAppUpdate], >[wmMobileFileBrowser]');
            var $body = $('body');
            if (core$1.hasCordova()) {
                mobileElements.appendTo($body);
                this.fileSelectorService.setFileBrowser(this.fileBrowserComponent);
            }
            else {
                mobileElements.remove();
            }
            $(this.elRef.nativeElement).find('>[wmProgressManager]').appendTo($body);
            this.processManagementService.setUIComponent(this.processManagerComponent);
        };
        AppExtComponent.ctorParameters = function () { return [
            { type: core.ElementRef },
            { type: basic.FileSelectorService },
            { type: basic.ProcessManagementService }
        ]; };
        __decorate([
            core.ViewChild(basic.FileBrowserComponent),
            __metadata("design:type", basic.FileBrowserComponent)
        ], AppExtComponent.prototype, "fileBrowserComponent", void 0);
        __decorate([
            core.ViewChild(basic.ProcessManagerComponent),
            __metadata("design:type", basic.ProcessManagerComponent)
        ], AppExtComponent.prototype, "processManagerComponent", void 0);
        AppExtComponent = __decorate([
            core.Component({
                selector: '[wmAppExt]',
                template: "<ng-container> \n        <div wmNetworkInfoToaster></div>\n        <div wmAppUpdate></div>\n        <div wmMobileFileBrowser></div>\n        <div wmProcessManager></div>\n    </ng-container>"
            }),
            __metadata("design:paramtypes", [core.ElementRef,
                basic.FileSelectorService,
                basic.ProcessManagementService])
        ], AppExtComponent);
        return AppExtComponent;
    }());

    var STORAGE_KEY = 'wavemaker.persistedcookies';
    var CookieService = /** @class */ (function () {
        function CookieService() {
            this.cookieInfo = {};
            this.serviceName = 'CookeService';
        }
        CookieService_1 = CookieService;
        CookieService.prototype.persistCookie = function (hostname, cookieName, cookieValue) {
            var _this = this;
            return new Promise(function (resolve) {
                if (cookieValue) {
                    resolve(cookieValue);
                }
                else {
                    _this.getCookie(hostname, cookieName)
                        .then(function (data) { return resolve(data.cookieValue); });
                }
            }).then(function (value) {
                _this.cookieInfo[hostname + '-' + cookieName] = {
                    hostname: hostname.replace(/:[0-9]+/, ''),
                    name: cookieName,
                    value: _this.rotateLTR(value)
                };
                localStorage.setItem(STORAGE_KEY, JSON.stringify(_this.cookieInfo));
            });
        };
        CookieService.prototype.getCookie = function (hostname, cookieName) {
            return new Promise(function (resolve, reject) {
                if (core$1.isIos()) {
                    var cookieString = window['cordova'].plugin.http.getCookieString(hostname);
                    if (cookieString) {
                        var at = cookieString.indexOf(cookieName);
                        if (at >= 0) {
                            var start = at + cookieName.length + 1;
                            var end = cookieString.indexOf(';', start);
                            var cookieValue = cookieString.substring(start, end >= 0 ? end : undefined);
                            resolve({
                                cookieValue: cookieValue
                            });
                            return;
                        }
                    }
                    reject();
                }
                else {
                    window['cookieEmperor'].getCookie(hostname, cookieName, resolve, reject);
                }
            });
        };
        CookieService.prototype.setCookie = function (hostname, cookieName, cookieValue) {
            return new Promise(function (resolve, reject) {
                if (core$1.isIos()) {
                    var cookieString = cookieName + '=' + cookieValue;
                    window['cordova'].plugin.http.setCookie(hostname, cookieString);
                    resolve();
                }
                else {
                    window['cookieEmperor'].setCookie(hostname, cookieName, cookieValue, resolve, reject);
                }
            });
        };
        CookieService.prototype.clearAll = function () {
            return new Promise(function (resolve, reject) { return window['cookieEmperor'].clearAll(resolve, reject); });
        };
        /**
         * Loads persisted cookies from local storage and adds them to the browser.
         * @returns {*}
         */
        CookieService.prototype.start = function () {
            var _this = this;
            var cookieInfoStr = localStorage.getItem(STORAGE_KEY), promises = [];
            if (cookieInfoStr) {
                var cookieInfo = JSON.parse(cookieInfoStr);
                _.forEach(cookieInfo, function (c) {
                    if (c.name && c.value) {
                        var promise = new Promise(function (resolve, reject) {
                            window['cookieEmperor'].setCookie(c.hostname, c.name, _this.rotateRTL(c.value), resolve, reject);
                        });
                        promises.push(promise);
                    }
                });
            }
            return Promise.all(promises);
        };
        CookieService.prototype.getServiceName = function () {
            return CookieService_1.SERVICE_NAME;
        };
        /**
         * Just rotates the given string exactly from 1/3 of string length in left to right direction.
         * @param str
         * @returns {string}
         */
        CookieService.prototype.rotateLTR = function (str) {
            var arr = str.split(''), tArr = [], shift = Math.floor(str.length / 3);
            arr.forEach(function (v, i) {
                tArr[(i + shift) % arr.length] = arr[i];
            });
            return tArr.join('');
        };
        /**
         * Just rotates the given string exactly from 1/3 of string length in  right to left direction..
         * @param str
         * @returns {string}
         */
        CookieService.prototype.rotateRTL = function (str) {
            var arr = str.split(''), tArr = [], shift = Math.floor(str.length / 3);
            arr.forEach(function (v, i) {
                tArr[(arr.length + i - shift) % arr.length] = arr[i];
            });
            return tArr.join('');
        };
        var CookieService_1;
        CookieService.SERVICE_NAME = 'CookieService';
        CookieService.ɵprov = core["ɵɵdefineInjectable"]({ factory: function CookieService_Factory() { return new CookieService(); }, token: CookieService, providedIn: "root" });
        CookieService = CookieService_1 = __decorate([
            core.Injectable({
                providedIn: 'root'
            })
        ], CookieService);
        return CookieService;
    }());

    var MobileHttpInterceptor = /** @class */ (function () {
        function MobileHttpInterceptor(app, file, deviceFileDownloadService, deviceService, networkService, securityService) {
            this.app = app;
            this.deviceService = deviceService;
            this.networkService = networkService;
            this.requestInterceptors = [];
            if (core$1.hasCordova() && !variables$1.CONSTANTS.isWaveLens && !core$1.isSpotcues) {
                this.requestInterceptors.push(new SecurityInterceptor(app, file, securityService));
                this.requestInterceptors.push(new RemoteSyncInterceptor(app, deviceFileDownloadService, deviceService, file, networkService));
                this.requestInterceptors.push(new ServiceCallInterceptor(app));
            }
        }
        MobileHttpInterceptor.prototype.intercept = function (request, next) {
            var _this = this;
            var subject = new rxjs.Subject();
            var token = localStorage.getItem(variables$1.CONSTANTS.XSRF_COOKIE_NAME);
            if (token) {
                // Clone the request to add the new header
                request = request.clone({ headers: request.headers.set(core$1.getWmProjectProperties().xsrf_header_name, token) });
            }
            var data = { request: request };
            // invoke the request only when device is ready.
            var obs = rxjs.from(this.deviceService.whenReady()
                .then(function () { return core$1.executePromiseChain(_this.getInterceptors(), [data]); }));
            return obs.pipe(operators.mergeMap(function () {
                return next.handle(data.request);
            }));
        };
        MobileHttpInterceptor.prototype.getInterceptors = function () {
            return this.requestInterceptors.map(function (i) {
                return function (data) { return i.intercept(data.request).then(function (req) { return data.request = req; }); };
            });
        };
        MobileHttpInterceptor.prototype.onHttpError = function (response) {
            if (core$1.hasCordova
                && (!response || !response.status || response.status < 0 || response.status === 404)
                && (this.networkService.isConnected())) {
                this.networkService.isAvailable(true);
            }
        };
        MobileHttpInterceptor.ctorParameters = function () { return [
            { type: core$1.App },
            { type: file.File },
            { type: core$2.DeviceFileDownloadService },
            { type: core$2.DeviceService },
            { type: core$2.NetworkService },
            { type: security.SecurityService }
        ]; };
        MobileHttpInterceptor = __decorate([
            core.Injectable(),
            __metadata("design:paramtypes", [core$1.App,
                file.File,
                core$2.DeviceFileDownloadService,
                core$2.DeviceService,
                core$2.NetworkService,
                security.SecurityService])
        ], MobileHttpInterceptor);
        return MobileHttpInterceptor;
    }());
    var ServiceCallInterceptor = /** @class */ (function () {
        function ServiceCallInterceptor(app) {
            this.app = app;
        }
        ServiceCallInterceptor.prototype.intercept = function (request) {
            var modifiedRequest = request;
            var url = request.url;
            // if necessary, prepend deployed url
            if (url.indexOf('://') < 0
                && ServiceCallInterceptor.REMOTE_SERVICE_URL_PATTERNS.find(function (r) { return r.test(url); })) {
                url = this.app.deployedUrl + url;
            }
            url = core$1.removeExtraSlashes(url);
            if (url !== request.url) {
                modifiedRequest = request.clone({
                    url: url
                });
            }
            return Promise.resolve(modifiedRequest);
        };
        ServiceCallInterceptor.REMOTE_SERVICE_URL_PATTERNS = [
            new RegExp('^((./)|/)?services/'),
            new RegExp('j_spring_security_check'),
            new RegExp('j_spring_security_logout')
        ];
        return ServiceCallInterceptor;
    }());
    var RemoteSyncInterceptor = /** @class */ (function () {
        function RemoteSyncInterceptor(app, deviceFileDownloadService, deviceService, file, networkService) {
            var _this = this;
            this.app = app;
            this.deviceFileDownloadService = deviceFileDownloadService;
            this.deviceService = deviceService;
            this.file = file;
            this.networkService = networkService;
            this.checkRemoteDirectory = true;
            this.hasRemoteChanges = false;
            this.file.checkDir(cordova.file.dataDirectory, 'remote').then(function () { return _this.hasRemoteChanges = true; }, core$1.noop);
        }
        RemoteSyncInterceptor.prototype.intercept = function (request) {
            var _this = this;
            var isRemoteSyncEnabled = localStorage.getItem('remoteSync') === 'true';
            if (this.hasRemoteChanges || isRemoteSyncEnabled) {
                return Promise.resolve(request.url).then(function (url) {
                    if (url.indexOf('://') < 0
                        && RemoteSyncInterceptor.URL_TO_SYNC.find(function (r) { return r.test(url); })) {
                        var fileNameFromUrl = _.last(_.split(url, '/'));
                        return _this.download(url, fileNameFromUrl, isRemoteSyncEnabled);
                    }
                    return url;
                }).then(function (url) {
                    if (url !== request.url) {
                        _this.hasRemoteChanges = true;
                        return request.clone({
                            url: core$1.transformFileURI(url)
                        });
                    }
                    return request;
                });
            }
            else {
                return Promise.resolve(request);
            }
        };
        RemoteSyncInterceptor.prototype.createFolderStructure = function (parentFolder, folderNamesList) {
            var _this = this;
            var folderName = folderNamesList[0];
            if (!_.isEmpty(folderName)) {
                return this.file.createDir(parentFolder, folderName, false)
                    .catch(core$1.noop)
                    .then(function () {
                    parentFolder = parentFolder + folderName + '/';
                    folderNamesList.shift();
                    return _this.createFolderStructure(parentFolder, folderNamesList);
                });
            }
            return Promise.resolve(parentFolder);
        };
        RemoteSyncInterceptor.prototype.init = function (pageUrl, isRemoteSyncEnabled) {
            var _this = this;
            var fileName = _.last(_.split(pageUrl, '/')), path = _.replace(pageUrl, fileName, ''), folderPath = 'remote' + _.replace(path, this.app.deployedUrl, ''), downloadsParent = cordova.file.dataDirectory;
            return new Promise(function (resolve, reject) {
                if (_this.checkRemoteDirectory) {
                    return _this.deviceService.getAppBuildTime().then(function (buildTime) {
                        var remoteSyncInfo = _this.deviceService.getEntry('remote-sync') || {};
                        if (!remoteSyncInfo.lastBuildTime || remoteSyncInfo.lastBuildTime !== buildTime) {
                            return _this.file.removeDir(cordova.file.dataDirectory, 'remote')
                                .catch(core$1.noop).then(function () {
                                remoteSyncInfo.lastBuildTime = buildTime;
                                _this.hasRemoteChanges = false;
                                return _this.deviceService.storeEntry('remote-sync', remoteSyncInfo);
                            });
                        }
                    }).then(function () { return _this.checkRemoteDirectory = false; })
                        .then(resolve, reject);
                }
                resolve();
            })
                .then(function () { return _this.file.checkDir(downloadsParent, folderPath); })
                .then(function () { return downloadsParent + folderPath; }, function () {
                if (isRemoteSyncEnabled) {
                    return _this.createFolderStructure(downloadsParent, _.split(folderPath, '/'));
                }
                return Promise.reject('Could not find equivalent remote path');
            });
        };
        RemoteSyncInterceptor.prototype.download = function (url, fileName, isRemoteSyncEnabled) {
            var _this = this;
            var pageUrl = this.app.deployedUrl + '/' + url;
            var folderPath;
            return this.init(pageUrl, isRemoteSyncEnabled)
                .then(function (pathToRemote) {
                folderPath = pathToRemote;
                return _this.file.checkFile(folderPath + fileName, '');
            }).then(function () {
                if (isRemoteSyncEnabled && _this.networkService.isConnected()) {
                    return _this.file.removeFile(folderPath, fileName)
                        .then(function () { return folderPath + fileName; });
                }
                return folderPath + fileName;
            }, function () { return url; })
                .then(function (path) {
                if (isRemoteSyncEnabled && _this.networkService.isConnected()) {
                    return _this.deviceFileDownloadService.download(pageUrl, false, folderPath, fileName);
                }
                return path;
            });
        };
        RemoteSyncInterceptor.URL_TO_SYNC = [
            new RegExp('page.min.json$'),
            new RegExp('app.js$'),
            new RegExp('app.variables.json$')
        ];
        return RemoteSyncInterceptor;
    }());
    var SecurityInterceptor = /** @class */ (function () {
        function SecurityInterceptor(app, file, securityService) {
            this.app = app;
            this.file = file;
            this.securityService = securityService;
            this.initialized = false;
        }
        SecurityInterceptor.prototype.intercept = function (request) {
            var _this = this;
            return new Promise(function (resolve, reject) {
                if (SecurityInterceptor.PAGE_URL_PATTERN.test(request.url)) {
                    return Promise.resolve().then(function () {
                        if (!_this.initialized) {
                            return _this.init();
                        }
                    }).then(function () {
                        var urlSplits = _.split(request.url, '/');
                        var pageName = urlSplits[urlSplits.length - 2];
                        if (!_this.publicPages || _this.publicPages[pageName]) {
                            return Promise.resolve(request);
                        }
                        else {
                            _this.securityService.getConfig(function (config) {
                                if (!config.securityEnabled || config.authenticated) {
                                    resolve(request);
                                }
                                else {
                                    reject("Page '" + pageName + "' is not accessible to the user.");
                                    _this.app.notify('http401', { page: pageName });
                                }
                            }, function () { return reject("Security call failed."); });
                        }
                        return Promise.resolve(request);
                    }).then(resolve, reject);
                }
                return resolve(request);
            });
        };
        /**
         * loads public pages from 'metadata/app/public-pages.info' and overrides canAccess method SecurityService
         */
        SecurityInterceptor.prototype.init = function () {
            var _this = this;
            var folderPath = cordova.file.applicationDirectory + 'www/metadata/app', fileName = 'public-pages.json';
            return this.file.readAsText(folderPath, fileName).then(function (text) {
                if (!_this.initialized) {
                    _this.publicPages = {};
                    _this.initialized = true;
                    _.forEach(JSON.parse(text), function (pageName) { return _this.publicPages[pageName] = true; });
                }
            }).catch(function () {
                _this.initialized = true;
            });
        };
        SecurityInterceptor.PAGE_URL_PATTERN = new RegExp('page.min.json$');
        return SecurityInterceptor;
    }());

    var WebProcessService = /** @class */ (function () {
        function WebProcessService(app, cookieService, httpService, extAppMessageService) {
            this.app = app;
            this.cookieService = cookieService;
            this.httpService = httpService;
            this.extAppMessageService = extAppMessageService;
        }
        WebProcessService.prototype.execute = function (process, hookUrl, useSystemBrowser) {
            var _this = this;
            if (useSystemBrowser === void 0) { useSystemBrowser = false; }
            return this.httpService.get("/services/webprocess/prepare?processName=" + process + "&hookUrl=" + hookUrl + "&requestSourceType=MOBILE")
                .then(function (processInfo) {
                if (useSystemBrowser) {
                    return _this.executeWithSystemBrowser(processInfo);
                }
                else {
                    return _this.executeWithInAppBrowser(processInfo, process);
                }
            }).then(function (output) {
                return _this.httpService.get('/services/webprocess/decode?encodedProcessdata=' + output);
            });
        };
        WebProcessService.prototype.executeWithSystemBrowser = function (processInfo) {
            var _this = this;
            return new Promise(function (resolve) {
                var oauthAdress = '^services/webprocess/LOGIN';
                var deregister = _this.extAppMessageService.subscribe(oauthAdress, function (message) {
                    resolve(message.data['process_output']);
                    deregister();
                });
                window.open(_this.app.deployedUrl + 'services/webprocess/start?process=' + encodeURIComponent(processInfo), '_system');
            });
        };
        WebProcessService.prototype.executeWithInAppBrowser = function (processInfo, process) {
            var _this = this;
            return new Promise(function (resolve, reject) {
                var ref = cordova.InAppBrowser.open(_this.app.deployedUrl + 'services/webprocess/start?process=' + encodeURIComponent(processInfo), '_blank', 'location=yes,clearcache=yes');
                var isSuccess = false;
                ref.addEventListener('loadstop', function () {
                    ref.executeScript({ code: _this.getScriptToInject(process) }, function (output) {
                        if (output && output[0]) {
                            isSuccess = true;
                            ref.close();
                            resolve(output[0]);
                        }
                    });
                });
                ref.addEventListener('exit', function () {
                    if (!isSuccess) {
                        reject('Login process is stopped');
                    }
                });
            }).then(function (output) {
                var url = _this.app.deployedUrl;
                if (url.endsWith('/')) {
                    url = url.substr(0, url.length - 1);
                }
                return _this.cookieService.setCookie(url, 'WM_WEB_PROCESS', processInfo)
                    .then(function () { return output; });
            });
        };
        WebProcessService.prototype.getScriptToInject = function (process) {
            return "\n            (function() {\n                var elements = document.querySelectorAll('body.flex>a.link');\n                for (var i = 0; i < elements.length; i++) {\n                    var href = elements[i].href;\n                    if (href && href.indexOf('://services/webprocess/" + process + "?process_output=')) {\n                        return href.split('process_output=')[1];\n                    }\n                }\n                window.isWebLoginProcess = true;\n            })();\n        ";
        };
        WebProcessService.ctorParameters = function () { return [
            { type: core$1.App },
            { type: CookieService },
            { type: core$1.AbstractHttpService },
            { type: core$2.ExtAppMessageService }
        ]; };
        WebProcessService = __decorate([
            core.Injectable(),
            __metadata("design:paramtypes", [core$1.App,
                CookieService,
                core$1.AbstractHttpService,
                core$2.ExtAppMessageService])
        ], WebProcessService);
        return WebProcessService;
    }());

    var MAX_WAIT_TIME_4_OAUTH_MESSAGE = 60000;
    var MINIMUM_TAB_WIDTH = 768;
    var KEYBOARD_CLASS = 'keyboard';
    var ionicServices = [
        appVersion.AppVersion,
        barcodeScanner.BarcodeScanner,
        calendar.Calendar,
        camera.Camera,
        contacts.Contacts,
        file.File,
        fileOpener.FileOpener,
        device.Device,
        geolocation.Geolocation,
        mediaCapture.MediaCapture,
        network.Network,
        sqlite.SQLite,
        vibration.Vibration
    ];
    var MobileRuntimeModule = /** @class */ (function () {
        function MobileRuntimeModule(app, cookieService, deviceFileOpenerService, deviceService, securityService, httpService, extAppMessageService, networkService, webProcessService) {
            var _this = this;
            this.app = app;
            this.cookieService = cookieService;
            this.deviceFileOpenerService = deviceFileOpenerService;
            this.deviceService = deviceService;
            this.securityService = securityService;
            this.httpService = httpService;
            this.extAppMessageService = extAppMessageService;
            this.networkService = networkService;
            this.webProcessService = webProcessService;
            this._$appEl = $('.wm-app').first();
            if (this._$appEl.width() >= MINIMUM_TAB_WIDTH) {
                app.isTabletApplicationType = true;
                this._$appEl.addClass('wm-tablet-app');
            }
            else {
                this._$appEl.addClass('wm-mobile-app');
            }
            // applying os theme on getting os details
            app.subscribe('on-viewport-details', function (os) {
                _this.applyOSTheme(os);
            });
            MobileRuntimeModule_1.initializeRuntime(this, this.app, this.cookieService, this.deviceFileOpenerService, this.deviceService);
        }
        MobileRuntimeModule_1 = MobileRuntimeModule;
        MobileRuntimeModule.forRoot = function () {
            /* add all providers that are required for mobile here. This is to simplify placeholder.*/
            return {
                ngModule: MobileRuntimeModule_1,
                providers: __spread([
                    WebProcessService,
                    {
                        provide: http.HTTP_INTERCEPTORS,
                        useClass: MobileHttpInterceptor,
                        multi: true
                    }
                ], ionicServices, [
                    base.FileExtensionFromMimePipe,
                    { provide: offline.PushService, useClass: offline.PushServiceImpl }
                ])
            };
        };
        // Startup services have to be added only once in the app life-cycle.
        MobileRuntimeModule.initializeRuntime = function (runtimeModule, app, cookieService, deviceFileOpenerService, deviceService) {
            if (this.initialized) {
                return;
            }
            this.initialized = true;
            app.deployedUrl = runtimeModule.getDeployedUrl();
            if (core$1.hasCordova()) {
                var unsubscribe_1 = app.subscribe('pageReady', function (page) {
                    if (!core$1.isSpotcues) {
                        navigator.splashscreen.hide();
                    }
                    unsubscribe_1();
                });
                runtimeModule.handleKeyBoardClass();
                deviceService.addStartUpService(cookieService);
                if (!core$1.isSpotcues) {
                    app.subscribe('userLoggedIn', function () {
                        var url = variables$1.$rootScope.project.deployedUrl;
                        if (url.endsWith('/')) {
                            url = url.substr(0, url.length - 1);
                        }
                        cookieService.persistCookie(url, 'JSESSIONID').catch(core$1.noop);
                        cookieService.persistCookie(url, 'SPRING_SECURITY_REMEMBER_ME_COOKIE').catch(core$1.noop);
                    });
                }
                app.subscribe('device-file-download', function (data) {
                    deviceFileOpenerService.openRemoteFile(data.url, data.extension, data.name, data.headers).then(data.successCb, data.errorCb);
                });
                var __zone_symbol__FileReader = window['__zone_symbol__FileReader'];
                if (__zone_symbol__FileReader && __zone_symbol__FileReader.READ_CHUNK_SIZE) {
                    // cordova File Reader is required. Otherwise, file operations are failing.
                    window['FileReader'] = __zone_symbol__FileReader;
                }
                if (!variables$1.CONSTANTS.isWaveLens) {
                    window.remoteSync = function (flag) {
                        if (flag === void 0) { flag = true; }
                        localStorage.setItem('remoteSync', flag ? 'true' : 'false');
                    };
                }
                window.open = window['cordova'].InAppBrowser.open;
                runtimeModule.addAuthInBrowser();
            }
            deviceService.start();
            deviceService.whenReady().then(function () {
                // To make wavelens work with spotcues environment
                if (core$1.isSpotcues) {
                    var params = location.search.substring(1)
                        .split('&')
                        .map(function (s) { return s.split('='); })
                        .reduce(function (a, c, i, s) {
                        a[s[i][0]] = s[i][1];
                        return a;
                    }, {});
                    if (params && params['wavelens']) {
                        var $body = $('body');
                        $body.append("<script src=\"" + params['wavelens'] + "/runtime/script.js\"></script>");
                        $body.append("<link rel=\"stylesheet\" href=\"" + params['wavelens'] + "/runtime/styles.css\">");
                    }
                }
                if (core$1.hasCordova()) {
                    runtimeModule._$appEl.addClass('cordova');
                    runtimeModule.exposeOAuthService();
                    // Fix for issue: ios device is not considering the background style, eventhough value is set in config.xml.
                    if (window['StatusBar']) {
                        window['StatusBar'].overlaysWebView(false);
                    }
                }
            });
        };
        MobileRuntimeModule.prototype.exposeOAuthService = function () {
            var _this = this;
            window['OAuthInMobile'] = function (providerId) {
                return new Promise(function (resolve, reject) {
                    var oauthAdress = '^services/oauth/' + providerId + '$';
                    var deregister = _this.extAppMessageService.subscribe(oauthAdress, function (message) {
                        resolve(message.data['access_token']);
                        deregister();
                        clearTimeout(timerId);
                    });
                    var timerId = setTimeout(function () {
                        deregister();
                        reject("Time out for oauth message after " + MAX_WAIT_TIME_4_OAUTH_MESSAGE % 1000 + " seconds");
                    }, MAX_WAIT_TIME_4_OAUTH_MESSAGE);
                });
            };
            var handleOpenURL = window['handleOpenURL'];
            handleOpenURL.isReady = true;
            handleOpenURL(handleOpenURL.lastURL);
        };
        MobileRuntimeModule.prototype.applyOSTheme = function (os) {
            var oldStyleSheet = $('link[theme="wmtheme"]').first();
            var themeUrl = oldStyleSheet.attr('href').replace(new RegExp('/[a-z]*/style.css$'), "/" + os.toLowerCase() + "/style.css"), newStyleSheet = core$1.loadStyleSheet(themeUrl, { name: 'theme', value: 'wmtheme' });
            oldStyleSheet = oldStyleSheet.length > 0 && oldStyleSheet[0];
            if (newStyleSheet && oldStyleSheet) {
                core$1.insertAfter(newStyleSheet, oldStyleSheet);
                core$1.removeNode(oldStyleSheet);
            }
        };
        MobileRuntimeModule.prototype.handleKeyBoardClass = function () {
            var _this = this;
            var initialScreenSize = window.innerHeight;
            // keyboard class is added when keyboard is open.
            window.addEventListener('resize', function () {
                if (window.innerHeight < initialScreenSize) {
                    _this._$appEl.addClass(KEYBOARD_CLASS);
                }
                else {
                    _this._$appEl.removeClass(KEYBOARD_CLASS);
                }
            });
        };
        MobileRuntimeModule.prototype.getDeployedUrl = function () {
            var _this = this;
            var waveLensAppUrl = window['WaveLens'] && window['WaveLens']['appUrl'];
            var deployedUrl = variables$1.$rootScope.project.deployedUrl;
            if (core$1.hasCordova() && !core$1.isSpotcues) {
                if (waveLensAppUrl) {
                    // TODO: Temporary Fix for WMS-13072, baseUrl is {{DEVELOPMENT_URL}} in wavelens
                    deployedUrl = waveLensAppUrl;
                }
                else {
                    core$1.fetchContent('json', './config.json', true, (function (response) {
                        if (!response.error && response.baseUrl) {
                            deployedUrl = response.baseUrl;
                            _this.app.customUrlScheme = response.customUrlScheme;
                        }
                    }));
                }
            }
            if (!deployedUrl.endsWith('/')) {
                deployedUrl = deployedUrl + '/';
            }
            variables$1.$rootScope.project.deployedUrl = deployedUrl;
            return deployedUrl;
        };
        MobileRuntimeModule.prototype.addAuthInBrowser = function () {
            var _this = this;
            this.securityService.authInBrowser = function () {
                if (!_this.networkService.isConnected()) {
                    return Promise.reject('In offline, app cannot contact the server.');
                }
                return _this.webProcessService.execute('LOGIN', '/')
                    .then(function (output) {
                    var url = _this.app.deployedUrl;
                    if (url.endsWith('/')) {
                        url = url.substr(0, url.length - 1);
                    }
                    output = JSON.parse(output);
                    if (output[variables$1.CONSTANTS.XSRF_COOKIE_NAME]) {
                        localStorage.setItem(variables$1.CONSTANTS.XSRF_COOKIE_NAME, output[variables$1.CONSTANTS.XSRF_COOKIE_NAME]);
                    }
                    return _this.cookieService.clearAll()
                        .then(function () {
                        var promises = _.keys(output).map(function (k) {
                            return _this.cookieService.setCookie(url, k, output[k]);
                        });
                        return Promise.all(promises);
                    });
                })
                    .then(function () { return _this.app.notify('userLoggedIn', {}); });
            };
        };
        var MobileRuntimeModule_1;
        MobileRuntimeModule.initialized = false;
        MobileRuntimeModule.ctorParameters = function () { return [
            { type: core$1.App },
            { type: CookieService },
            { type: core$2.DeviceFileOpenerService },
            { type: core$2.DeviceService },
            { type: security.SecurityService },
            { type: core$1.AbstractHttpService },
            { type: core$2.ExtAppMessageService },
            { type: core$2.NetworkService },
            { type: WebProcessService }
        ]; };
        MobileRuntimeModule = MobileRuntimeModule_1 = __decorate([
            core.NgModule({
                declarations: [
                    AppExtComponent
                ],
                exports: [
                    AppExtComponent
                ],
                imports: [
                    core$2.MobileCoreModule,
                    variables.VariablesModule,
                    basic.BasicModule
                ],
                bootstrap: []
            }),
            __metadata("design:paramtypes", [core$1.App,
                CookieService,
                core$2.DeviceFileOpenerService,
                core$2.DeviceService,
                security.SecurityService,
                core$1.AbstractHttpService,
                core$2.ExtAppMessageService,
                core$2.NetworkService,
                WebProcessService])
        ], MobileRuntimeModule);
        return MobileRuntimeModule;
    }());

    exports.MAX_WAIT_TIME_4_OAUTH_MESSAGE = MAX_WAIT_TIME_4_OAUTH_MESSAGE;
    exports.MobileRuntimeModule = MobileRuntimeModule;
    exports.ɵa = AppExtComponent;
    exports.ɵb = CookieService;
    exports.ɵc = WebProcessService;
    exports.ɵd = MobileHttpInterceptor;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=index.umd.js.map
