import { Injector, ModuleWithProviders } from '@angular/core';
import { RouterModule } from '@angular/router';
import { HttpClientXsrfModule } from '@angular/common/http';
import { App } from '@wm/core';
import { ComponentRefProvider } from '@wm/runtime/base';
export declare const routerModule: ModuleWithProviders<RouterModule>;
export declare const toastrModule: import("@angular/compiler/src/core").ModuleWithProviders;
export declare const httpClientXsrfModule: ModuleWithProviders<HttpClientXsrfModule>;
export declare const modalModule: ModuleWithProviders;
export declare const bsDatePickerModule: ModuleWithProviders;
export declare const datepickerModule: ModuleWithProviders;
export declare const timepickerModule: ModuleWithProviders;
export declare const bsDropdownModule: ModuleWithProviders;
export declare const paginationModule: ModuleWithProviders;
export declare const typeaheadModule: ModuleWithProviders;
export declare const progressbarModule: ModuleWithProviders;
export declare const carouselModule: ModuleWithProviders;
export declare const popoverModule: ModuleWithProviders;
export declare const ngCircleProgressModule: ModuleWithProviders;
export declare const tooltipModule: ModuleWithProviders;
export declare class AppModule {
    private app;
    private inj;
    private componentRefProvider;
    constructor(app: App, inj: Injector, componentRefProvider: ComponentRefProvider);
}
